/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ddgp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|gp) integrals */

void d12hrr_order_ddgp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][5][10] = int_stack + 315;
 Libderiv->deriv_classes[4][5][9] = int_stack + 630;
 Libderiv->deriv_classes[4][5][8] = int_stack + 945;
 Libderiv->deriv_classes[4][5][7] = int_stack + 1260;
 Libderiv->dvrr_classes[4][4] = int_stack + 1575;
 Libderiv->deriv_classes[4][5][6] = int_stack + 1800;
 Libderiv->deriv_classes[4][5][2] = int_stack + 2115;
 Libderiv->deriv_classes[4][5][1] = int_stack + 2430;
 Libderiv->dvrr_classes[3][5] = int_stack + 2745;
 Libderiv->deriv_classes[4][5][0] = int_stack + 2955;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 3270;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 3360;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 3486;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 3636;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 3846;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 4071;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 4386;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 4476;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 4602;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 4752;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 4962;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 5187;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 5502;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 5592;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 5718;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 5868;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 6078;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 6303;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 6618;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 6708;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 6834;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 6984;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 7194;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 7419;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 7734;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 7824;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 7950;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 8100;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 8310;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 8535;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 8850;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 8940;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 9066;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 9216;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 9426;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 9651;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 9966;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 10056;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 10182;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 10332;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 10542;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 10767;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 11082;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 11172;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 11298;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 11448;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 11658;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 11883;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 12198;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 12288;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 12414;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 12564;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 12774;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 12999;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 13314;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 13404;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 13530;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 13680;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 13890;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 14115;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 14430;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 14520;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 14646;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 14796;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 15006;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 15231;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 15546;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 15636;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 15762;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 15912;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 16122;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 16347;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 16662;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 16752;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 16878;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 17028;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 17238;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 17463;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 17778;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 17868;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 17994;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 18144;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 18354;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 18579;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 18894;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 18984;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 19110;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 19260;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 19470;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 19695;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 20010;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 20100;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 20226;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 20376;
 Libderiv->deriv_classes[4][4][11] = int_stack + 20586;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 20811;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 21036;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 21351;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 21441;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 21567;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 21717;
 Libderiv->deriv_classes[4][4][10] = int_stack + 21927;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 22152;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 22377;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 22692;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 22782;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 22908;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 23058;
 Libderiv->deriv_classes[4][4][9] = int_stack + 23268;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 23493;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 23718;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 24033;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 24123;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 24249;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 24399;
 Libderiv->deriv_classes[4][4][8] = int_stack + 24609;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 24834;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 25059;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 25374;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 25464;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 25590;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 25740;
 Libderiv->deriv_classes[4][4][7] = int_stack + 25950;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 26175;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 26400;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 26715;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 26805;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 26931;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 27081;
 Libderiv->deriv_classes[4][4][6] = int_stack + 27291;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 27516;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 27741;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 28056;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 28146;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 28272;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 28422;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 28632;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 28857;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 29172;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 29262;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 29388;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 29538;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 29748;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 29973;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 30288;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 30378;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 30504;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 30654;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 30864;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 31089;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 31404;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 31494;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 31620;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 31770;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 31980;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 32205;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 32520;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 32610;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 32736;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 32886;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 33096;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 33321;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 33636;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 33726;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 33852;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 34002;
 Libderiv->deriv_classes[4][4][2] = int_stack + 34212;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 34437;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 34662;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 34977;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 35067;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 35193;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 35343;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 35553;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 35778;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 36093;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 36183;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 36309;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 36459;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 36669;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 36894;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 37209;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 37299;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 37425;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 37575;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 37785;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 38010;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 38325;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 38415;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 38541;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 38691;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 38901;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 39126;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 39441;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 39531;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 39657;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 39807;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 40017;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 40242;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 40557;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 40647;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 40773;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 40923;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 41133;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 41358;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 41673;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 41763;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 41889;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 42039;
 Libderiv->deriv_classes[4][4][1] = int_stack + 42249;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 42474;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 42699;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 43014;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 43104;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 43230;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 43380;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 43590;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 43815;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 44130;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 44220;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 44346;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 44496;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 44706;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 44931;
 Libderiv->deriv_classes[2][4][11] = int_stack + 45246;
 Libderiv->deriv_classes[2][5][11] = int_stack + 45336;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 45462;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 45552;
 Libderiv->deriv_classes[3][4][11] = int_stack + 45678;
 Libderiv->deriv_classes[3][5][11] = int_stack + 45828;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 46038;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 46188;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 46398;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 46623;
 Libderiv->deriv_classes[2][4][10] = int_stack + 46938;
 Libderiv->deriv_classes[2][5][10] = int_stack + 47028;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 47154;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 47244;
 Libderiv->deriv_classes[3][4][10] = int_stack + 47370;
 Libderiv->deriv_classes[3][5][10] = int_stack + 47520;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 47730;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 47880;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 48090;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 48315;
 Libderiv->deriv_classes[2][4][9] = int_stack + 48630;
 Libderiv->deriv_classes[2][5][9] = int_stack + 48720;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 48846;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 48936;
 Libderiv->deriv_classes[3][4][9] = int_stack + 49062;
 Libderiv->deriv_classes[3][5][9] = int_stack + 49212;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 49422;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 49572;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 49782;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 50007;
 Libderiv->deriv_classes[2][4][8] = int_stack + 50322;
 Libderiv->deriv_classes[2][5][8] = int_stack + 50412;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 50538;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 50628;
 Libderiv->deriv_classes[3][4][8] = int_stack + 50754;
 Libderiv->deriv_classes[3][5][8] = int_stack + 50904;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 51114;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 51264;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 51474;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 51699;
 Libderiv->deriv_classes[2][4][7] = int_stack + 52014;
 Libderiv->deriv_classes[2][5][7] = int_stack + 52104;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 52230;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 52320;
 Libderiv->deriv_classes[3][4][7] = int_stack + 52446;
 Libderiv->deriv_classes[3][5][7] = int_stack + 52596;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 52806;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 52956;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 53166;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 53391;
 Libderiv->deriv_classes[2][4][6] = int_stack + 53706;
 Libderiv->deriv_classes[2][5][6] = int_stack + 53796;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 53922;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 54012;
 Libderiv->dvrr_classes[3][4] = int_stack + 54138;
 Libderiv->deriv_classes[3][4][6] = int_stack + 54288;
 Libderiv->deriv_classes[3][5][6] = int_stack + 54438;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 54648;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 54798;
 Libderiv->deriv_classes[4][4][0] = int_stack + 55008;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 55233;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 55458;
 Libderiv->deriv_classes[2][4][2] = int_stack + 55773;
 Libderiv->deriv_classes[2][5][2] = int_stack + 55863;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 55989;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 56079;
 Libderiv->deriv_classes[3][4][2] = int_stack + 56205;
 Libderiv->deriv_classes[3][5][2] = int_stack + 56355;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 56565;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 56715;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 56925;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 57150;
 Libderiv->deriv_classes[2][4][1] = int_stack + 57465;
 Libderiv->deriv_classes[2][5][1] = int_stack + 57555;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 57681;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 57771;
 Libderiv->deriv_classes[3][4][1] = int_stack + 57897;
 Libderiv->deriv_classes[3][5][1] = int_stack + 58047;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 58257;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 58407;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 58617;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 58842;
 Libderiv->dvrr_classes[2][4] = int_stack + 59157;
 Libderiv->dvrr_classes[2][5] = int_stack + 59247;
 Libderiv->deriv_classes[2][4][0] = int_stack + 59373;
 Libderiv->deriv_classes[2][5][0] = int_stack + 59463;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 59589;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 59679;
 Libderiv->deriv_classes[3][4][0] = int_stack + 59805;
 Libderiv->deriv_classes[3][5][0] = int_stack + 59955;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 60165;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 60315;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 60525;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 60750;
 memset(int_stack,0,488520);

 Libderiv->dvrr_stack = int_stack + 129150;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ddgp(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+61065,int_stack+45336,int_stack+45246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59157,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+61335,int_stack+45828,int_stack+45678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54138,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+61785,int_stack+61335,int_stack+61065,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+62595,int_stack+0,int_stack+20586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+63270,int_stack+62595,int_stack+61335,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+62595,int_stack+47028,int_stack+46938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59157, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+64620,int_stack+47520,int_stack+47370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54138, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+65070,int_stack+64620,int_stack+62595,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+65880,int_stack+315,int_stack+21927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+66555,int_stack+65880,int_stack+64620,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+65880,int_stack+48720,int_stack+48630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59157, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+49212,int_stack+49062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54138, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+67905,int_stack+0,int_stack+65880,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+68715,int_stack+630,int_stack+23268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+69390,int_stack+68715,int_stack+0,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+68715,int_stack+50412,int_stack+50322, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+450,int_stack+50904,int_stack+50754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+70740,int_stack+450,int_stack+68715,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+71550,int_stack+945,int_stack+24609, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+72225,int_stack+71550,int_stack+450,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+71550,int_stack+52104,int_stack+52014, 0.0, zero_stack, 1.0, int_stack+59157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+73575,int_stack+52596,int_stack+52446, 0.0, zero_stack, 1.0, int_stack+54138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+74025,int_stack+73575,int_stack+71550,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+74835,int_stack+1260,int_stack+25950, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+75510,int_stack+74835,int_stack+73575,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+74835,int_stack+53796,int_stack+53706, 1.0, int_stack+59157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+900,int_stack+54438,int_stack+54288, 1.0, int_stack+54138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+76860,int_stack+900,int_stack+74835,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+1800,int_stack+27291, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+78345,int_stack+77670,int_stack+900,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+59247,int_stack+59157,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+2745,int_stack+54138,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+79695,int_stack+1350,int_stack+77670,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77940,int_stack+55863,int_stack+55773,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+80505,int_stack+56355,int_stack+56205,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+80955,int_stack+80505,int_stack+77940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+81765,int_stack+2115,int_stack+34212,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+82440,int_stack+81765,int_stack+80505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+81765,int_stack+57555,int_stack+57465,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1800,int_stack+58047,int_stack+57897,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+83790,int_stack+1800,int_stack+81765, 0.0, zero_stack, 1.0, int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+84600,int_stack+2430,int_stack+42249,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+85275,int_stack+84600,int_stack+1800, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+84600,int_stack+59463,int_stack+59373,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2250,int_stack+59955,int_stack+59805,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+86625,int_stack+2250,int_stack+84600, 1.0, int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+2955,int_stack+55008,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+88110,int_stack+87435,int_stack+2250, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+3360,int_stack+3270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+45246,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+3636,int_stack+3486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+45678,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2700,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+4071,int_stack+3846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20586,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+89460,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+4476,int_stack+4386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45246, 1.0, int_stack+46938,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+4752,int_stack+4602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45678, 1.0, int_stack+47370,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3510,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+5187,int_stack+4962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20586, 1.0, int_stack+21927,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+90810,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+5592,int_stack+5502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+46938, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+5868,int_stack+5718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+47370, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+4320,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+6303,int_stack+6078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+21927, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5130,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+6708,int_stack+6618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45246, 0.0, zero_stack, 1.0, int_stack+48630,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+6984,int_stack+6834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45678, 0.0, zero_stack, 1.0, int_stack+49062,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+92160,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+7419,int_stack+7194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20586, 0.0, zero_stack, 1.0, int_stack+23268,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+92970,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+7824,int_stack+7734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46938, 1.0, int_stack+48630, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+8100,int_stack+7950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47370, 1.0, int_stack+49062, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+6480,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+8535,int_stack+8310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21927, 1.0, int_stack+23268, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+7290,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+8940,int_stack+8850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+48630, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+9216,int_stack+9066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+49062, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+94320,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+9651,int_stack+9426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+23268, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+95130,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+10056,int_stack+9966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45246, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50322,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+10332,int_stack+10182, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45678, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50754,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+8640,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+10767,int_stack+10542, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20586, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24609,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+9450,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+11172,int_stack+11082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46938, 0.0, zero_stack, 1.0, int_stack+50322, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+11448,int_stack+11298, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47370, 0.0, zero_stack, 1.0, int_stack+50754, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+10800,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+11883,int_stack+11658, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21927, 0.0, zero_stack, 1.0, int_stack+24609, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+96480,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+12288,int_stack+12198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48630, 1.0, int_stack+50322, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+12564,int_stack+12414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49062, 1.0, int_stack+50754, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+11610,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+12999,int_stack+12774, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23268, 1.0, int_stack+24609, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+97830,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+13404,int_stack+13314, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+50322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+13680,int_stack+13530, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+50754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+12420,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+14115,int_stack+13890, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+24609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+99180,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+14520,int_stack+14430, 0.0, zero_stack, 1.0, int_stack+45246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52014,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+14796,int_stack+14646, 0.0, zero_stack, 1.0, int_stack+45678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52446,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+13230,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+15231,int_stack+15006, 0.0, zero_stack, 1.0, int_stack+20586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25950,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+14040,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+15636,int_stack+15546, 0.0, zero_stack, 1.0, int_stack+46938, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52014, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+15912,int_stack+15762, 0.0, zero_stack, 1.0, int_stack+47370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52446, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+100530,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+16347,int_stack+16122, 0.0, zero_stack, 1.0, int_stack+21927, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25950, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+101340,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+16752,int_stack+16662, 0.0, zero_stack, 1.0, int_stack+48630, 0.0, zero_stack, 1.0, int_stack+52014, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+17028,int_stack+16878, 0.0, zero_stack, 1.0, int_stack+49062, 0.0, zero_stack, 1.0, int_stack+52446, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+15390,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+17463,int_stack+17238, 0.0, zero_stack, 1.0, int_stack+23268, 0.0, zero_stack, 1.0, int_stack+25950, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+16200,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+17868,int_stack+17778, 0.0, zero_stack, 1.0, int_stack+50322, 1.0, int_stack+52014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+18144,int_stack+17994, 0.0, zero_stack, 1.0, int_stack+50754, 1.0, int_stack+52446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+102690,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+18579,int_stack+18354, 0.0, zero_stack, 1.0, int_stack+24609, 1.0, int_stack+25950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+103500,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+18984,int_stack+18894, 0.0, zero_stack, 2.0, int_stack+52014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+19260,int_stack+19110, 0.0, zero_stack, 2.0, int_stack+52446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+17550,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+19695,int_stack+19470, 0.0, zero_stack, 2.0, int_stack+25950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+18360,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+20100,int_stack+20010, 1.0, int_stack+45246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53706,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+20376,int_stack+20226, 1.0, int_stack+45678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54288,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+19710,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+21036,int_stack+20811, 1.0, int_stack+20586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27291,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+104850,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+21441,int_stack+21351, 1.0, int_stack+46938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53706, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+21717,int_stack+21567, 1.0, int_stack+47370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54288, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+20520,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+22377,int_stack+22152, 1.0, int_stack+21927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27291, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+21330,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+22782,int_stack+22692, 1.0, int_stack+48630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53706, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+23058,int_stack+22908, 1.0, int_stack+49062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54288, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+106200,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+23718,int_stack+23493, 1.0, int_stack+23268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27291, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+22680,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+24123,int_stack+24033, 1.0, int_stack+50322, 0.0, zero_stack, 1.0, int_stack+53706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+24399,int_stack+24249, 1.0, int_stack+50754, 0.0, zero_stack, 1.0, int_stack+54288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+107010,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+25059,int_stack+24834, 1.0, int_stack+24609, 0.0, zero_stack, 1.0, int_stack+27291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+107820,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+25464,int_stack+25374, 1.0, int_stack+52014, 1.0, int_stack+53706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+25740,int_stack+25590, 1.0, int_stack+52446, 1.0, int_stack+54288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+24030,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+26400,int_stack+26175, 1.0, int_stack+25950, 1.0, int_stack+27291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+24840,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+26805,int_stack+26715, 2.0, int_stack+53706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+27081,int_stack+26931, 2.0, int_stack+54288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+26190,int_stack+1350,int_stack+77670,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+27741,int_stack+27516, 2.0, int_stack+27291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+109170,int_stack+87435,int_stack+1350,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+28146,int_stack+28056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55773,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+28422,int_stack+28272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56205,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+27000,int_stack+1350,int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+28857,int_stack+28632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34212,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+27810,int_stack+87435,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+29262,int_stack+29172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55773, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+29538,int_stack+29388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56205, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+110520,int_stack+1350,int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+29973,int_stack+29748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34212, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+111330,int_stack+87435,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+30378,int_stack+30288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55773, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+30654,int_stack+30504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56205, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+29160,int_stack+1350,int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+31089,int_stack+30864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34212, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+29970,int_stack+87435,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+31494,int_stack+31404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+31770,int_stack+31620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+112680,int_stack+1350,int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+32205,int_stack+31980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+113490,int_stack+87435,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+32610,int_stack+32520, 0.0, zero_stack, 1.0, int_stack+55773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+32886,int_stack+32736, 0.0, zero_stack, 1.0, int_stack+56205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+31320,int_stack+1350,int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+33321,int_stack+33096, 0.0, zero_stack, 1.0, int_stack+34212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+32130,int_stack+87435,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+33726,int_stack+33636, 1.0, int_stack+55773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+34002,int_stack+33852, 1.0, int_stack+56205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+114840,int_stack+1350,int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+34662,int_stack+34437, 1.0, int_stack+34212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+33480,int_stack+87435,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+35067,int_stack+34977,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+35343,int_stack+35193,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+115650,int_stack+1350,int_stack+77670, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+77940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+35778,int_stack+35553,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+116460,int_stack+87435,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+36183,int_stack+36093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57465,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+36459,int_stack+36309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57897,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+34830,int_stack+1350,int_stack+77670, 0.0, zero_stack, 1.0, int_stack+61065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+36894,int_stack+36669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42249,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+35640,int_stack+87435,int_stack+1350, 0.0, zero_stack, 1.0, int_stack+61335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+37299,int_stack+37209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57465, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+37575,int_stack+37425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57897, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+117810,int_stack+1350,int_stack+77670, 0.0, zero_stack, 1.0, int_stack+62595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+38010,int_stack+37785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42249, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+118620,int_stack+87435,int_stack+1350, 0.0, zero_stack, 1.0, int_stack+64620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+38415,int_stack+38325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57465, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+38691,int_stack+38541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57897, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+36990,int_stack+1350,int_stack+77670, 0.0, zero_stack, 1.0, int_stack+65880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+39126,int_stack+38901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42249, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+37800,int_stack+87435,int_stack+1350, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+39531,int_stack+39441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+39807,int_stack+39657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+39150,int_stack+1350,int_stack+77670, 0.0, zero_stack, 1.0, int_stack+68715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+40242,int_stack+40017, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+119970,int_stack+87435,int_stack+1350, 0.0, zero_stack, 1.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+40647,int_stack+40557, 0.0, zero_stack, 1.0, int_stack+57465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+40923,int_stack+40773, 0.0, zero_stack, 1.0, int_stack+57897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+39960,int_stack+1350,int_stack+77670, 0.0, zero_stack, 1.0, int_stack+71550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+41358,int_stack+41133, 0.0, zero_stack, 1.0, int_stack+42249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+121320,int_stack+87435,int_stack+1350, 0.0, zero_stack, 1.0, int_stack+73575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+41763,int_stack+41673, 1.0, int_stack+57465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+42039,int_stack+41889, 1.0, int_stack+57897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+40770,int_stack+1350,int_stack+77670, 0.0, zero_stack, 1.0, int_stack+74835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+42699,int_stack+42474, 1.0, int_stack+42249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+41580,int_stack+87435,int_stack+1350, 0.0, zero_stack, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+43104,int_stack+43014,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+43380,int_stack+43230,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+122670,int_stack+1350,int_stack+77670, 0.0, zero_stack, 1.0, int_stack+77940, 1.0, int_stack+81765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+43815,int_stack+43590,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+123480,int_stack+87435,int_stack+1350, 0.0, zero_stack, 1.0, int_stack+80505, 1.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+44220,int_stack+44130,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+44496,int_stack+44346,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+42930,int_stack+1350,int_stack+77670, 0.0, zero_stack, 2.0, int_stack+81765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+44931,int_stack+44706,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+43740,int_stack+87435,int_stack+1350, 0.0, zero_stack, 2.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+45552,int_stack+45462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59373,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+46188,int_stack+46038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59805,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+45090,int_stack+1350,int_stack+77670, 1.0, int_stack+61065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+87435,int_stack+46623,int_stack+46398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55008,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+124830,int_stack+87435,int_stack+1350, 1.0, int_stack+61335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+47244,int_stack+47154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59373, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+47880,int_stack+47730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59805, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+45900,int_stack+1350,int_stack+77670, 1.0, int_stack+62595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+62595,int_stack+48315,int_stack+48090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55008, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+46710,int_stack+62595,int_stack+1350, 1.0, int_stack+64620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+48936,int_stack+48846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59373, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+64620,int_stack+49572,int_stack+49422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59805, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+48060,int_stack+64620,int_stack+77670, 1.0, int_stack+65880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+65880,int_stack+50007,int_stack+49782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55008, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+48870,int_stack+65880,int_stack+64620, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+50628,int_stack+50538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+51264,int_stack+51114, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+50220,int_stack+0,int_stack+77670, 1.0, int_stack+68715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+68715,int_stack+51699,int_stack+51474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+126180,int_stack+68715,int_stack+0, 1.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+52320,int_stack+52230, 0.0, zero_stack, 1.0, int_stack+59373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+64620,int_stack+52956,int_stack+52806, 0.0, zero_stack, 1.0, int_stack+59805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+64620,int_stack+77670, 1.0, int_stack+71550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+71550,int_stack+53391,int_stack+53166, 0.0, zero_stack, 1.0, int_stack+55008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+51030,int_stack+71550,int_stack+64620, 1.0, int_stack+73575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+54012,int_stack+53922, 1.0, int_stack+59373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+73575,int_stack+54798,int_stack+54648, 1.0, int_stack+59805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+52380,int_stack+73575,int_stack+77670, 1.0, int_stack+74835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+74835,int_stack+55458,int_stack+55233, 1.0, int_stack+55008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+53190,int_stack+74835,int_stack+73575, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+56079,int_stack+55989,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+73575,int_stack+56715,int_stack+56565,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+810,int_stack+73575,int_stack+77670, 1.0, int_stack+77940, 0.0, zero_stack, 1.0, int_stack+84600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77670,int_stack+57150,int_stack+56925,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+54540,int_stack+77670,int_stack+73575, 1.0, int_stack+80505, 0.0, zero_stack, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+80505,int_stack+57771,int_stack+57681,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+73575,int_stack+58407,int_stack+58257,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+55890,int_stack+73575,int_stack+80505, 1.0, int_stack+81765, 1.0, int_stack+84600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+81765,int_stack+58842,int_stack+58617,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+56700,int_stack+81765,int_stack+73575, 1.0, int_stack+1800, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+73575,int_stack+59679,int_stack+59589,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+80505,int_stack+60315,int_stack+60165,10);
 /*--- compute (dp|gp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+58050,int_stack+80505,int_stack+73575, 2.0, int_stack+84600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+84600,int_stack+60750,int_stack+60525,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+58860,int_stack+84600,int_stack+80505, 2.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+127530,int_stack+63270,int_stack+61785,45);
     Libderiv->ABCD[11] = int_stack + 127530;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+62595,int_stack+66555,int_stack+65070,45);
     Libderiv->ABCD[10] = int_stack + 62595;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+65880,int_stack+69390,int_stack+67905,45);
     Libderiv->ABCD[9] = int_stack + 65880;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+68715,int_stack+72225,int_stack+70740,45);
     Libderiv->ABCD[8] = int_stack + 68715;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+71550,int_stack+75510,int_stack+74025,45);
     Libderiv->ABCD[7] = int_stack + 71550;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+74835,int_stack+78345,int_stack+76860,45);
     Libderiv->ABCD[6] = int_stack + 74835;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+77670,int_stack+82440,int_stack+80955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[2] = int_stack + 77670;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+81765,int_stack+85275,int_stack+83790, 0.0, zero_stack, 1.0, int_stack+79695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[1] = int_stack + 81765;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+84600,int_stack+88110,int_stack+86625, 1.0, int_stack+79695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[0] = int_stack + 84600;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+79290,int_stack+89460,int_stack+2700,45);
     Libderiv->ABCD[155] = int_stack + 79290;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+1620,int_stack+90810,int_stack+3510,45);
     Libderiv->ABCD[143] = int_stack + 1620;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+87435,int_stack+5130,int_stack+4320,45);
     Libderiv->ABCD[142] = int_stack + 87435;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+3240,int_stack+92970,int_stack+92160,45);
     Libderiv->ABCD[131] = int_stack + 3240;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+4860,int_stack+7290,int_stack+6480,45);
     Libderiv->ABCD[130] = int_stack + 4860;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+6480,int_stack+95130,int_stack+94320,45);
     Libderiv->ABCD[129] = int_stack + 6480;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+89055,int_stack+9450,int_stack+8640,45);
     Libderiv->ABCD[119] = int_stack + 89055;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+8100,int_stack+96480,int_stack+10800,45);
     Libderiv->ABCD[118] = int_stack + 8100;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+9720,int_stack+97830,int_stack+11610,45);
     Libderiv->ABCD[117] = int_stack + 9720;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+90675,int_stack+99180,int_stack+12420,45);
     Libderiv->ABCD[116] = int_stack + 90675;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+11340,int_stack+14040,int_stack+13230,45);
     Libderiv->ABCD[107] = int_stack + 11340;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+12960,int_stack+101340,int_stack+100530,45);
     Libderiv->ABCD[106] = int_stack + 12960;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+92295,int_stack+16200,int_stack+15390,45);
     Libderiv->ABCD[105] = int_stack + 92295;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+14580,int_stack+103500,int_stack+102690,45);
     Libderiv->ABCD[104] = int_stack + 14580;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+93915,int_stack+18360,int_stack+17550,45);
     Libderiv->ABCD[103] = int_stack + 93915;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+16200,int_stack+104850,int_stack+19710,45);
     Libderiv->ABCD[95] = int_stack + 16200;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+17820,int_stack+21330,int_stack+20520,45);
     Libderiv->ABCD[94] = int_stack + 17820;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+19440,int_stack+22680,int_stack+106200,45);
     Libderiv->ABCD[93] = int_stack + 19440;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+21060,int_stack+107820,int_stack+107010,45);
     Libderiv->ABCD[92] = int_stack + 21060;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+95535,int_stack+24840,int_stack+24030,45);
     Libderiv->ABCD[91] = int_stack + 95535;
 /*--- compute (dd|gp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+22680,int_stack+109170,int_stack+26190,45);
     Libderiv->ABCD[90] = int_stack + 22680;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+24300,int_stack+27810,int_stack+27000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[47] = int_stack + 24300;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+25920,int_stack+111330,int_stack+110520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[46] = int_stack + 25920;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+27540,int_stack+29970,int_stack+29160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[45] = int_stack + 27540;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+29160,int_stack+113490,int_stack+112680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[44] = int_stack + 29160;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+97155,int_stack+32130,int_stack+31320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[43] = int_stack + 97155;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+30780,int_stack+33480,int_stack+114840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[42] = int_stack + 30780;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+32400,int_stack+116460,int_stack+115650, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[38] = int_stack + 32400;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+98775,int_stack+35640,int_stack+34830, 0.0, zero_stack, 1.0, int_stack+61785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[35] = int_stack + 98775;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+34020,int_stack+118620,int_stack+117810, 0.0, zero_stack, 1.0, int_stack+65070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[34] = int_stack + 34020;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+100395,int_stack+37800,int_stack+36990, 0.0, zero_stack, 1.0, int_stack+67905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[33] = int_stack + 100395;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+35640,int_stack+119970,int_stack+39150, 0.0, zero_stack, 1.0, int_stack+70740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[32] = int_stack + 35640;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+37260,int_stack+121320,int_stack+39960, 0.0, zero_stack, 1.0, int_stack+74025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[31] = int_stack + 37260;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+38880,int_stack+41580,int_stack+40770, 0.0, zero_stack, 1.0, int_stack+76860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[30] = int_stack + 38880;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+40500,int_stack+123480,int_stack+122670, 0.0, zero_stack, 1.0, int_stack+80955, 1.0, int_stack+83790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[26] = int_stack + 40500;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+102015,int_stack+43740,int_stack+42930, 0.0, zero_stack, 2.0, int_stack+83790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[25] = int_stack + 102015;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+42120,int_stack+124830,int_stack+45090, 1.0, int_stack+61785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[23] = int_stack + 42120;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+43740,int_stack+46710,int_stack+45900, 1.0, int_stack+65070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[22] = int_stack + 43740;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+45360,int_stack+48870,int_stack+48060, 1.0, int_stack+67905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[21] = int_stack + 45360;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+46980,int_stack+126180,int_stack+50220, 1.0, int_stack+70740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[20] = int_stack + 46980;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+48600,int_stack+51030,int_stack+0, 1.0, int_stack+74025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[19] = int_stack + 48600;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+50220,int_stack+53190,int_stack+52380, 1.0, int_stack+76860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[18] = int_stack + 50220;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+51840,int_stack+54540,int_stack+810, 1.0, int_stack+80955, 0.0, zero_stack, 1.0, int_stack+86625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[14] = int_stack + 51840;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+0,int_stack+56700,int_stack+55890, 1.0, int_stack+83790, 1.0, int_stack+86625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[13] = int_stack + 0;
 /*--- compute (dd|gp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+53460,int_stack+58860,int_stack+58050, 2.0, int_stack+86625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[12] = int_stack + 53460;

}
