/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_p0gf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|gf) integrals */

void d12hrr_order_p0gf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][7][11] = int_stack + 0;
 Libderiv->deriv_classes[1][7][10] = int_stack + 108;
 Libderiv->deriv_classes[1][7][9] = int_stack + 216;
 Libderiv->deriv_classes[1][7][8] = int_stack + 324;
 Libderiv->deriv_classes[1][7][7] = int_stack + 432;
 Libderiv->dvrr_classes[1][6] = int_stack + 540;
 Libderiv->deriv_classes[1][7][6] = int_stack + 624;
 Libderiv->deriv_classes[1][7][2] = int_stack + 732;
 Libderiv->deriv_classes[1][7][1] = int_stack + 840;
 Libderiv->deriv_classes[1][7][0] = int_stack + 948;
 Libderiv->deriv2_classes[1][4][143] = int_stack + 1056;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 1101;
 Libderiv->deriv2_classes[1][6][143] = int_stack + 1164;
 Libderiv->deriv2_classes[1][7][143] = int_stack + 1248;
 Libderiv->deriv2_classes[1][4][131] = int_stack + 1356;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 1401;
 Libderiv->deriv2_classes[1][6][131] = int_stack + 1464;
 Libderiv->deriv2_classes[1][7][131] = int_stack + 1548;
 Libderiv->deriv2_classes[1][4][130] = int_stack + 1656;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 1701;
 Libderiv->deriv2_classes[1][6][130] = int_stack + 1764;
 Libderiv->deriv2_classes[1][7][130] = int_stack + 1848;
 Libderiv->deriv2_classes[1][4][119] = int_stack + 1956;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 2001;
 Libderiv->deriv2_classes[1][6][119] = int_stack + 2064;
 Libderiv->deriv2_classes[1][7][119] = int_stack + 2148;
 Libderiv->deriv2_classes[1][4][118] = int_stack + 2256;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 2301;
 Libderiv->deriv2_classes[1][6][118] = int_stack + 2364;
 Libderiv->deriv2_classes[1][7][118] = int_stack + 2448;
 Libderiv->deriv2_classes[1][4][117] = int_stack + 2556;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 2601;
 Libderiv->deriv2_classes[1][6][117] = int_stack + 2664;
 Libderiv->deriv2_classes[1][7][117] = int_stack + 2748;
 Libderiv->deriv2_classes[1][4][107] = int_stack + 2856;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 2901;
 Libderiv->deriv2_classes[1][6][107] = int_stack + 2964;
 Libderiv->deriv2_classes[1][7][107] = int_stack + 3048;
 Libderiv->deriv2_classes[1][4][106] = int_stack + 3156;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 3201;
 Libderiv->deriv2_classes[1][6][106] = int_stack + 3264;
 Libderiv->deriv2_classes[1][7][106] = int_stack + 3348;
 Libderiv->deriv2_classes[1][4][105] = int_stack + 3456;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 3501;
 Libderiv->deriv2_classes[1][6][105] = int_stack + 3564;
 Libderiv->deriv2_classes[1][7][105] = int_stack + 3648;
 Libderiv->deriv2_classes[1][4][104] = int_stack + 3756;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 3801;
 Libderiv->deriv2_classes[1][6][104] = int_stack + 3864;
 Libderiv->deriv2_classes[1][7][104] = int_stack + 3948;
 Libderiv->deriv2_classes[1][4][95] = int_stack + 4056;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 4101;
 Libderiv->deriv2_classes[1][6][95] = int_stack + 4164;
 Libderiv->deriv2_classes[1][7][95] = int_stack + 4248;
 Libderiv->deriv2_classes[1][4][94] = int_stack + 4356;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 4401;
 Libderiv->deriv2_classes[1][6][94] = int_stack + 4464;
 Libderiv->deriv2_classes[1][7][94] = int_stack + 4548;
 Libderiv->deriv2_classes[1][4][93] = int_stack + 4656;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 4701;
 Libderiv->deriv2_classes[1][6][93] = int_stack + 4764;
 Libderiv->deriv2_classes[1][7][93] = int_stack + 4848;
 Libderiv->deriv2_classes[1][4][92] = int_stack + 4956;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 5001;
 Libderiv->deriv2_classes[1][6][92] = int_stack + 5064;
 Libderiv->deriv2_classes[1][7][92] = int_stack + 5148;
 Libderiv->deriv2_classes[1][4][91] = int_stack + 5256;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 5301;
 Libderiv->deriv2_classes[1][6][91] = int_stack + 5364;
 Libderiv->deriv2_classes[1][7][91] = int_stack + 5448;
 Libderiv->deriv_classes[1][4][11] = int_stack + 5556;
 Libderiv->deriv2_classes[1][4][83] = int_stack + 5601;
 Libderiv->deriv_classes[1][5][11] = int_stack + 5646;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 5709;
 Libderiv->deriv_classes[1][6][11] = int_stack + 5772;
 Libderiv->deriv2_classes[1][6][83] = int_stack + 5856;
 Libderiv->deriv2_classes[1][7][83] = int_stack + 5940;
 Libderiv->deriv_classes[1][4][10] = int_stack + 6048;
 Libderiv->deriv2_classes[1][4][82] = int_stack + 6093;
 Libderiv->deriv_classes[1][5][10] = int_stack + 6138;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 6201;
 Libderiv->deriv_classes[1][6][10] = int_stack + 6264;
 Libderiv->deriv2_classes[1][6][82] = int_stack + 6348;
 Libderiv->deriv2_classes[1][7][82] = int_stack + 6432;
 Libderiv->deriv_classes[1][4][9] = int_stack + 6540;
 Libderiv->deriv2_classes[1][4][81] = int_stack + 6585;
 Libderiv->deriv_classes[1][5][9] = int_stack + 6630;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 6693;
 Libderiv->deriv_classes[1][6][9] = int_stack + 6756;
 Libderiv->deriv2_classes[1][6][81] = int_stack + 6840;
 Libderiv->deriv2_classes[1][7][81] = int_stack + 6924;
 Libderiv->deriv_classes[1][4][8] = int_stack + 7032;
 Libderiv->deriv2_classes[1][4][80] = int_stack + 7077;
 Libderiv->deriv_classes[1][5][8] = int_stack + 7122;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 7185;
 Libderiv->deriv_classes[1][6][8] = int_stack + 7248;
 Libderiv->deriv2_classes[1][6][80] = int_stack + 7332;
 Libderiv->deriv2_classes[1][7][80] = int_stack + 7416;
 Libderiv->deriv_classes[1][4][7] = int_stack + 7524;
 Libderiv->deriv2_classes[1][4][79] = int_stack + 7569;
 Libderiv->deriv_classes[1][5][7] = int_stack + 7614;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 7677;
 Libderiv->deriv_classes[1][6][7] = int_stack + 7740;
 Libderiv->deriv2_classes[1][6][79] = int_stack + 7824;
 Libderiv->deriv2_classes[1][7][79] = int_stack + 7908;
 Libderiv->dvrr_classes[1][4] = int_stack + 8016;
 Libderiv->deriv_classes[1][4][6] = int_stack + 8061;
 Libderiv->deriv2_classes[1][4][78] = int_stack + 8106;
 Libderiv->dvrr_classes[1][5] = int_stack + 8151;
 Libderiv->deriv_classes[1][5][6] = int_stack + 8214;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 8277;
 Libderiv->deriv_classes[1][6][6] = int_stack + 8340;
 Libderiv->deriv2_classes[1][6][78] = int_stack + 8424;
 Libderiv->deriv2_classes[1][7][78] = int_stack + 8508;
 Libderiv->deriv2_classes[1][4][35] = int_stack + 8616;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 8661;
 Libderiv->deriv2_classes[1][6][35] = int_stack + 8724;
 Libderiv->deriv2_classes[1][7][35] = int_stack + 8808;
 Libderiv->deriv2_classes[1][4][34] = int_stack + 8916;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 8961;
 Libderiv->deriv2_classes[1][6][34] = int_stack + 9024;
 Libderiv->deriv2_classes[1][7][34] = int_stack + 9108;
 Libderiv->deriv2_classes[1][4][33] = int_stack + 9216;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 9261;
 Libderiv->deriv2_classes[1][6][33] = int_stack + 9324;
 Libderiv->deriv2_classes[1][7][33] = int_stack + 9408;
 Libderiv->deriv2_classes[1][4][32] = int_stack + 9516;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 9561;
 Libderiv->deriv2_classes[1][6][32] = int_stack + 9624;
 Libderiv->deriv2_classes[1][7][32] = int_stack + 9708;
 Libderiv->deriv2_classes[1][4][31] = int_stack + 9816;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 9861;
 Libderiv->deriv2_classes[1][6][31] = int_stack + 9924;
 Libderiv->deriv2_classes[1][7][31] = int_stack + 10008;
 Libderiv->deriv_classes[1][4][2] = int_stack + 10116;
 Libderiv->deriv2_classes[1][4][30] = int_stack + 10161;
 Libderiv->deriv_classes[1][5][2] = int_stack + 10206;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 10269;
 Libderiv->deriv_classes[1][6][2] = int_stack + 10332;
 Libderiv->deriv2_classes[1][6][30] = int_stack + 10416;
 Libderiv->deriv2_classes[1][7][30] = int_stack + 10500;
 Libderiv->deriv2_classes[1][4][26] = int_stack + 10608;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 10653;
 Libderiv->deriv2_classes[1][6][26] = int_stack + 10716;
 Libderiv->deriv2_classes[1][7][26] = int_stack + 10800;
 Libderiv->deriv2_classes[1][4][23] = int_stack + 10908;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 10953;
 Libderiv->deriv2_classes[1][6][23] = int_stack + 11016;
 Libderiv->deriv2_classes[1][7][23] = int_stack + 11100;
 Libderiv->deriv2_classes[1][4][22] = int_stack + 11208;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 11253;
 Libderiv->deriv2_classes[1][6][22] = int_stack + 11316;
 Libderiv->deriv2_classes[1][7][22] = int_stack + 11400;
 Libderiv->deriv2_classes[1][4][21] = int_stack + 11508;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 11553;
 Libderiv->deriv2_classes[1][6][21] = int_stack + 11616;
 Libderiv->deriv2_classes[1][7][21] = int_stack + 11700;
 Libderiv->deriv2_classes[1][4][20] = int_stack + 11808;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 11853;
 Libderiv->deriv2_classes[1][6][20] = int_stack + 11916;
 Libderiv->deriv2_classes[1][7][20] = int_stack + 12000;
 Libderiv->deriv2_classes[1][4][19] = int_stack + 12108;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 12153;
 Libderiv->deriv2_classes[1][6][19] = int_stack + 12216;
 Libderiv->deriv2_classes[1][7][19] = int_stack + 12300;
 Libderiv->deriv_classes[1][4][1] = int_stack + 12408;
 Libderiv->deriv2_classes[1][4][18] = int_stack + 12453;
 Libderiv->deriv_classes[1][5][1] = int_stack + 12498;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 12561;
 Libderiv->deriv_classes[1][6][1] = int_stack + 12624;
 Libderiv->deriv2_classes[1][6][18] = int_stack + 12708;
 Libderiv->deriv2_classes[1][7][18] = int_stack + 12792;
 Libderiv->deriv2_classes[1][4][14] = int_stack + 12900;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 12945;
 Libderiv->deriv2_classes[1][6][14] = int_stack + 13008;
 Libderiv->deriv2_classes[1][7][14] = int_stack + 13092;
 Libderiv->deriv2_classes[1][4][13] = int_stack + 13200;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 13245;
 Libderiv->deriv2_classes[1][6][13] = int_stack + 13308;
 Libderiv->deriv2_classes[1][7][13] = int_stack + 13392;
 Libderiv->deriv2_classes[1][4][11] = int_stack + 13500;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 13545;
 Libderiv->deriv2_classes[1][6][11] = int_stack + 13608;
 Libderiv->deriv2_classes[1][7][11] = int_stack + 13692;
 Libderiv->deriv2_classes[1][4][10] = int_stack + 13800;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 13845;
 Libderiv->deriv2_classes[1][6][10] = int_stack + 13908;
 Libderiv->deriv2_classes[1][7][10] = int_stack + 13992;
 Libderiv->deriv2_classes[1][4][9] = int_stack + 14100;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 14145;
 Libderiv->deriv2_classes[1][6][9] = int_stack + 14208;
 Libderiv->deriv2_classes[1][7][9] = int_stack + 14292;
 Libderiv->deriv2_classes[1][4][8] = int_stack + 14400;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 14445;
 Libderiv->deriv2_classes[1][6][8] = int_stack + 14508;
 Libderiv->deriv2_classes[1][7][8] = int_stack + 14592;
 Libderiv->deriv2_classes[1][4][7] = int_stack + 14700;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 14745;
 Libderiv->deriv2_classes[1][6][7] = int_stack + 14808;
 Libderiv->deriv2_classes[1][7][7] = int_stack + 14892;
 Libderiv->deriv_classes[1][4][0] = int_stack + 15000;
 Libderiv->deriv2_classes[1][4][6] = int_stack + 15045;
 Libderiv->deriv_classes[1][5][0] = int_stack + 15090;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 15153;
 Libderiv->deriv_classes[1][6][0] = int_stack + 15216;
 Libderiv->deriv2_classes[1][6][6] = int_stack + 15300;
 Libderiv->deriv2_classes[1][7][6] = int_stack + 15384;
 Libderiv->deriv2_classes[1][4][2] = int_stack + 15492;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 15537;
 Libderiv->deriv2_classes[1][6][2] = int_stack + 15600;
 Libderiv->deriv2_classes[1][7][2] = int_stack + 15684;
 Libderiv->deriv2_classes[1][4][1] = int_stack + 15792;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 15837;
 Libderiv->deriv2_classes[1][6][1] = int_stack + 15900;
 Libderiv->deriv2_classes[1][7][1] = int_stack + 15984;
 Libderiv->deriv2_classes[1][4][0] = int_stack + 16092;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 16137;
 Libderiv->deriv2_classes[1][6][0] = int_stack + 16200;
 Libderiv->deriv2_classes[1][7][0] = int_stack + 16284;
 memset(int_stack,0,131136);

 Libderiv->dvrr_stack = int_stack + 39639;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_p0gf(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16392,int_stack+8151,int_stack+8016,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16527,int_stack+540,int_stack+8151,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+16716,int_stack+16527,int_stack+16392,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16986,int_stack+5646,int_stack+5556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8016,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+17121,int_stack+5772,int_stack+5646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8151,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17310,int_stack+17121,int_stack+16986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17580,int_stack+0,int_stack+5772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+17832,int_stack+17580,int_stack+17121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16527,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17580,int_stack+6138,int_stack+6048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8016, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18210,int_stack+6264,int_stack+6138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8151, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18399,int_stack+18210,int_stack+17580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18669,int_stack+108,int_stack+6264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18921,int_stack+18669,int_stack+18210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16527, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18669,int_stack+6630,int_stack+6540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8016, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+6756,int_stack+6630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8151, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+19299,int_stack+0,int_stack+18669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19569,int_stack+216,int_stack+6756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19821,int_stack+19569,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16527, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189,int_stack+7122,int_stack+7032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19569,int_stack+7248,int_stack+7122, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+20199,int_stack+19569,int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20469,int_stack+324,int_stack+7248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20721,int_stack+20469,int_stack+19569, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20469,int_stack+7614,int_stack+7524, 0.0, zero_stack, 1.0, int_stack+8016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+7740,int_stack+7614, 0.0, zero_stack, 1.0, int_stack+8151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+21288,int_stack+21099,int_stack+20469, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21558,int_stack+432,int_stack+7740, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21810,int_stack+21558,int_stack+21099, 0.0, zero_stack, 1.0, int_stack+16527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21558,int_stack+8214,int_stack+8061, 1.0, int_stack+8016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324,int_stack+8340,int_stack+8214, 1.0, int_stack+8151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22188,int_stack+324,int_stack+21558, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+624,int_stack+8340, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22710,int_stack+22458,int_stack+324, 1.0, int_stack+16527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+22458,int_stack+10206,int_stack+10116,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16392,int_stack+10332,int_stack+10206,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+23088,int_stack+16392,int_stack+22458,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+732,int_stack+10332,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+23610,int_stack+23358,int_stack+16392,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16581,int_stack+12498,int_stack+12408,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+23358,int_stack+12624,int_stack+12498,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+513,int_stack+23358,int_stack+16581,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23988,int_stack+840,int_stack+12624,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+24240,int_stack+23988,int_stack+23358,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+23988,int_stack+15090,int_stack+15000,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+24618,int_stack+15216,int_stack+15090,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+24807,int_stack+24618,int_stack+23988,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+948,int_stack+15216,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+25329,int_stack+25077,int_stack+24618,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+1101,int_stack+1056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5556,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+1164,int_stack+1101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5646,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+25707,int_stack+783,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16986,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+1248,int_stack+1164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5772,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+972,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17121,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+1401,int_stack+1356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5556, 1.0, int_stack+6048,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+1464,int_stack+1401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5646, 1.0, int_stack+6138,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+25977,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16986, 1.0, int_stack+17580,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+1548,int_stack+1464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5772, 1.0, int_stack+6264,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26499,int_stack+26247,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17121, 1.0, int_stack+18210,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+1701,int_stack+1656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6048, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+1764,int_stack+1701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6138, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1350,int_stack+783,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17580, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+1848,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6264, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26877,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18210, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+2001,int_stack+1956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5556, 0.0, zero_stack, 1.0, int_stack+6540,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+2064,int_stack+2001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5646, 0.0, zero_stack, 1.0, int_stack+6630,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1620,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16986, 0.0, zero_stack, 1.0, int_stack+18669,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+2148,int_stack+2064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5772, 0.0, zero_stack, 1.0, int_stack+6756,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+27255,int_stack+26247,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17121, 0.0, zero_stack, 1.0, int_stack+0,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+2301,int_stack+2256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6048, 1.0, int_stack+6540, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+2364,int_stack+2301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6138, 1.0, int_stack+6630, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1890,int_stack+783,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17580, 1.0, int_stack+18669, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+2448,int_stack+2364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6264, 1.0, int_stack+6756, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2160,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18210, 1.0, int_stack+0, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+2601,int_stack+2556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6540, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+2664,int_stack+2601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6630, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27633,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18669, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+2748,int_stack+2664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6756, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+27903,int_stack+26247,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+2901,int_stack+2856, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7032,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+2964,int_stack+2901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7122,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2538,int_stack+783,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+3048,int_stack+2964, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7248,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28281,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17121, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19569,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+3201,int_stack+3156, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6048, 0.0, zero_stack, 1.0, int_stack+7032, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+3264,int_stack+3201, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6138, 0.0, zero_stack, 1.0, int_stack+7122, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2808,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17580, 0.0, zero_stack, 1.0, int_stack+189, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+3348,int_stack+3264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6264, 0.0, zero_stack, 1.0, int_stack+7248, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3078,int_stack+26247,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18210, 0.0, zero_stack, 1.0, int_stack+19569, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+3501,int_stack+3456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6540, 1.0, int_stack+7032, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+3564,int_stack+3501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6630, 1.0, int_stack+7122, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+28659,int_stack+783,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18669, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+3648,int_stack+3564, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6756, 1.0, int_stack+7248, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28929,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+19569, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+3801,int_stack+3756, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+3864,int_stack+3801, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3456,int_stack+25077,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+3948,int_stack+3864, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+29307,int_stack+26247,int_stack+25077, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+4101,int_stack+4056, 0.0, zero_stack, 1.0, int_stack+5556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7524,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+4164,int_stack+4101, 0.0, zero_stack, 1.0, int_stack+5646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7614,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3726,int_stack+783,int_stack+25077, 0.0, zero_stack, 1.0, int_stack+16986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20469,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+4248,int_stack+4164, 0.0, zero_stack, 1.0, int_stack+5772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7740,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+29685,int_stack+25077,int_stack+783, 0.0, zero_stack, 1.0, int_stack+17121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21099,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+4401,int_stack+4356, 0.0, zero_stack, 1.0, int_stack+6048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7524, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+4464,int_stack+4401, 0.0, zero_stack, 1.0, int_stack+6138, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7614, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3996,int_stack+25077,int_stack+783, 0.0, zero_stack, 1.0, int_stack+17580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20469, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+4548,int_stack+4464, 0.0, zero_stack, 1.0, int_stack+6264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7740, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4266,int_stack+26247,int_stack+25077, 0.0, zero_stack, 1.0, int_stack+18210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21099, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+4701,int_stack+4656, 0.0, zero_stack, 1.0, int_stack+6540, 0.0, zero_stack, 1.0, int_stack+7524, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+4764,int_stack+4701, 0.0, zero_stack, 1.0, int_stack+6630, 0.0, zero_stack, 1.0, int_stack+7614, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+30063,int_stack+783,int_stack+25077, 0.0, zero_stack, 1.0, int_stack+18669, 0.0, zero_stack, 1.0, int_stack+20469, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+4848,int_stack+4764, 0.0, zero_stack, 1.0, int_stack+6756, 0.0, zero_stack, 1.0, int_stack+7740, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+30333,int_stack+25077,int_stack+783, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+21099, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+5001,int_stack+4956, 0.0, zero_stack, 1.0, int_stack+7032, 1.0, int_stack+7524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+5064,int_stack+5001, 0.0, zero_stack, 1.0, int_stack+7122, 1.0, int_stack+7614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4644,int_stack+25077,int_stack+783, 0.0, zero_stack, 1.0, int_stack+189, 1.0, int_stack+20469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+5148,int_stack+5064, 0.0, zero_stack, 1.0, int_stack+7248, 1.0, int_stack+7740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+30711,int_stack+26247,int_stack+25077, 0.0, zero_stack, 1.0, int_stack+19569, 1.0, int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+5301,int_stack+5256, 0.0, zero_stack, 2.0, int_stack+7524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+5364,int_stack+5301, 0.0, zero_stack, 2.0, int_stack+7614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4914,int_stack+783,int_stack+25077, 0.0, zero_stack, 2.0, int_stack+20469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25077,int_stack+5448,int_stack+5364, 0.0, zero_stack, 2.0, int_stack+7740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+31089,int_stack+25077,int_stack+783, 0.0, zero_stack, 2.0, int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+5709,int_stack+5601, 1.0, int_stack+5556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8061,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25077,int_stack+5856,int_stack+5709, 1.0, int_stack+5646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8214,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5184,int_stack+25077,int_stack+783, 1.0, int_stack+16986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21558,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26247,int_stack+5940,int_stack+5856, 1.0, int_stack+5772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8340,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5454,int_stack+26247,int_stack+25077, 1.0, int_stack+17121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25077,int_stack+6201,int_stack+6093, 1.0, int_stack+6048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8061, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+6348,int_stack+6201, 1.0, int_stack+6138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8214, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+16986,int_stack+783,int_stack+25077, 1.0, int_stack+17580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21558, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17580,int_stack+6432,int_stack+6348, 1.0, int_stack+6264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8340, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5832,int_stack+17580,int_stack+783, 1.0, int_stack+18210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18210,int_stack+6693,int_stack+6585, 1.0, int_stack+6540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8061, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+6840,int_stack+6693, 1.0, int_stack+6630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8214, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6210,int_stack+783,int_stack+18210, 1.0, int_stack+18669, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21558, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18669,int_stack+6924,int_stack+6840, 1.0, int_stack+6756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8340, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6480,int_stack+18669,int_stack+783, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+7185,int_stack+7077, 1.0, int_stack+7032, 0.0, zero_stack, 1.0, int_stack+8061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+7332,int_stack+7185, 1.0, int_stack+7122, 0.0, zero_stack, 1.0, int_stack+8214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6858,int_stack+783,int_stack+0, 1.0, int_stack+189, 0.0, zero_stack, 1.0, int_stack+21558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18669,int_stack+7416,int_stack+7332, 1.0, int_stack+7248, 0.0, zero_stack, 1.0, int_stack+8340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7128,int_stack+18669,int_stack+783, 1.0, int_stack+19569, 0.0, zero_stack, 1.0, int_stack+324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+19569,int_stack+7677,int_stack+7569, 1.0, int_stack+7524, 1.0, int_stack+8061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+7824,int_stack+7677, 1.0, int_stack+7614, 1.0, int_stack+8214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+783,int_stack+19569, 1.0, int_stack+20469, 1.0, int_stack+21558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20469,int_stack+7908,int_stack+7824, 1.0, int_stack+7740, 1.0, int_stack+8340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7506,int_stack+20469,int_stack+783, 1.0, int_stack+21099, 1.0, int_stack+324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+8277,int_stack+8106, 2.0, int_stack+8061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+8424,int_stack+8277, 2.0, int_stack+8214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7884,int_stack+783,int_stack+21099, 2.0, int_stack+21558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21558,int_stack+8508,int_stack+8424, 2.0, int_stack+8340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8154,int_stack+21558,int_stack+783, 2.0, int_stack+324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+8661,int_stack+8616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10116,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+8724,int_stack+8661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10206,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+31467,int_stack+21099,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22458,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21558,int_stack+8808,int_stack+8724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10332,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8532,int_stack+21558,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+8961,int_stack+8916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10116, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+9024,int_stack+8961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10206, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+31737,int_stack+783,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22458, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21558,int_stack+9108,int_stack+9024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10332, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32007,int_stack+21558,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+9261,int_stack+9216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10116, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+9324,int_stack+9261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10206, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8910,int_stack+21099,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22458, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21558,int_stack+9408,int_stack+9324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10332, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32385,int_stack+21558,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+9561,int_stack+9516, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+9624,int_stack+9561, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9180,int_stack+783,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21558,int_stack+9708,int_stack+9624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32763,int_stack+21558,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+9861,int_stack+9816, 0.0, zero_stack, 1.0, int_stack+10116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+9924,int_stack+9861, 0.0, zero_stack, 1.0, int_stack+10206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9450,int_stack+21099,int_stack+783, 0.0, zero_stack, 1.0, int_stack+22458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21558,int_stack+10008,int_stack+9924, 0.0, zero_stack, 1.0, int_stack+10332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9720,int_stack+21558,int_stack+21099, 0.0, zero_stack, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+10269,int_stack+10161, 1.0, int_stack+10116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+10416,int_stack+10269, 1.0, int_stack+10206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33141,int_stack+783,int_stack+21099, 1.0, int_stack+22458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+10500,int_stack+10416, 1.0, int_stack+10332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10098,int_stack+22458,int_stack+783, 1.0, int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16392,int_stack+10653,int_stack+10608,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+10716,int_stack+10653,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+33411,int_stack+783,int_stack+16392,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+10800,int_stack+10716,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+10476,int_stack+22458,int_stack+783,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+10953,int_stack+10908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16392,int_stack+11016,int_stack+10953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12498,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33681,int_stack+16392,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16581,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+11100,int_stack+11016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12624,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33951,int_stack+22458,int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23358,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16392,int_stack+11253,int_stack+11208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+11316,int_stack+11253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12498, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10854,int_stack+783,int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16581, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+11400,int_stack+11316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12624, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11124,int_stack+22458,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23358, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+11553,int_stack+11508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16392,int_stack+11616,int_stack+11553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12498, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+34329,int_stack+16392,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16581, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+11700,int_stack+11616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12624, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34599,int_stack+22458,int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23358, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16392,int_stack+11853,int_stack+11808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+11916,int_stack+11853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11502,int_stack+783,int_stack+16392, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+12000,int_stack+11916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34977,int_stack+22458,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+12153,int_stack+12108, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16392,int_stack+12216,int_stack+12153, 0.0, zero_stack, 1.0, int_stack+12498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11772,int_stack+16392,int_stack+783, 0.0, zero_stack, 1.0, int_stack+16581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+12300,int_stack+12216, 0.0, zero_stack, 1.0, int_stack+12624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35355,int_stack+22458,int_stack+16392, 0.0, zero_stack, 1.0, int_stack+23358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16392,int_stack+12561,int_stack+12453, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+12708,int_stack+12561, 1.0, int_stack+12498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12042,int_stack+783,int_stack+16392, 1.0, int_stack+16581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22458,int_stack+12792,int_stack+12708, 1.0, int_stack+12624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12312,int_stack+22458,int_stack+783, 1.0, int_stack+23358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+23358,int_stack+12945,int_stack+12900,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+13008,int_stack+12945,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+16392,int_stack+783,int_stack+23358,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+13092,int_stack+13008,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+12690,int_stack+23358,int_stack+783,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+13245,int_stack+13200,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+13308,int_stack+13245,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+35733,int_stack+21099,int_stack+783,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+13392,int_stack+13308,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+13068,int_stack+23358,int_stack+21099,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+13545,int_stack+13500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15000,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+13608,int_stack+13545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15090,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36003,int_stack+783,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23988,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+13692,int_stack+13608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15216,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+36273,int_stack+23358,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24618,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+13845,int_stack+13800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15000, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+13908,int_stack+13845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15090, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13446,int_stack+21099,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23988, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+13992,int_stack+13908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15216, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13716,int_stack+23358,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24618, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+14145,int_stack+14100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15000, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+14208,int_stack+14145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15090, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36651,int_stack+783,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23988, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+14292,int_stack+14208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15216, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+36921,int_stack+23358,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24618, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+14445,int_stack+14400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+14508,int_stack+14445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14094,int_stack+21099,int_stack+783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+14592,int_stack+14508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37299,int_stack+23358,int_stack+21099, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+14745,int_stack+14700, 0.0, zero_stack, 1.0, int_stack+15000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+783,int_stack+14808,int_stack+14745, 0.0, zero_stack, 1.0, int_stack+15090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14364,int_stack+783,int_stack+21099, 0.0, zero_stack, 1.0, int_stack+23988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23358,int_stack+14892,int_stack+14808, 0.0, zero_stack, 1.0, int_stack+15216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37677,int_stack+23358,int_stack+783, 0.0, zero_stack, 1.0, int_stack+24618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+783,int_stack+15153,int_stack+15045, 1.0, int_stack+15000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+15300,int_stack+15153, 1.0, int_stack+15090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14634,int_stack+21099,int_stack+783, 1.0, int_stack+23988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23988,int_stack+15384,int_stack+15300, 1.0, int_stack+15216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14904,int_stack+23988,int_stack+21099, 1.0, int_stack+24618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+24618,int_stack+15537,int_stack+15492,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+15600,int_stack+15537,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+15282,int_stack+21099,int_stack+24618,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23988,int_stack+15684,int_stack+15600,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38055,int_stack+23988,int_stack+21099,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+21099,int_stack+15837,int_stack+15792,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+24618,int_stack+15900,int_stack+15837,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+15552,int_stack+24618,int_stack+21099,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23988,int_stack+15984,int_stack+15900,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38433,int_stack+23988,int_stack+24618,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+24618,int_stack+16137,int_stack+16092,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21099,int_stack+16200,int_stack+16137,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+15822,int_stack+21099,int_stack+24618,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23988,int_stack+16284,int_stack+16200,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38811,int_stack+23988,int_stack+21099,3);
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+39189,int_stack+17832,int_stack+17310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16716,3);
     Libderiv->ABCD[11] = int_stack + 39189;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+17580,int_stack+18921,int_stack+18399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16716, 0.0, zero_stack,3);
     Libderiv->ABCD[10] = int_stack + 17580;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+18669,int_stack+19821,int_stack+19299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16716, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[9] = int_stack + 18669;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19569,int_stack+20721,int_stack+20199, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[8] = int_stack + 19569;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+20469,int_stack+21810,int_stack+21288, 0.0, zero_stack, 1.0, int_stack+16716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[7] = int_stack + 20469;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+21558,int_stack+22710,int_stack+22188, 1.0, int_stack+16716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[6] = int_stack + 21558;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+22458,int_stack+23610,int_stack+23088,3);
     Libderiv->ABCD[2] = int_stack + 22458;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+23358,int_stack+24240,int_stack+513,3);
     Libderiv->ABCD[1] = int_stack + 23358;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+23808,int_stack+25329,int_stack+24807,3);
     Libderiv->ABCD[0] = int_stack + 23808;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+24258,int_stack+972,int_stack+25707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17310,3);
     Libderiv->ABCD[155] = int_stack + 24258;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+783,int_stack+26499,int_stack+25977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17310, 1.0, int_stack+18399,3);
     Libderiv->ABCD[143] = int_stack + 783;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+25077,int_stack+26877,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18399, 0.0, zero_stack,3);
     Libderiv->ABCD[142] = int_stack + 25077;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+25527,int_stack+27255,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17310, 0.0, zero_stack, 1.0, int_stack+19299,3);
     Libderiv->ABCD[131] = int_stack + 25527;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1233,int_stack+2160,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18399, 1.0, int_stack+19299, 0.0, zero_stack,3);
     Libderiv->ABCD[130] = int_stack + 1233;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1683,int_stack+27903,int_stack+27633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19299, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[129] = int_stack + 1683;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+25977,int_stack+28281,int_stack+2538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20199,3);
     Libderiv->ABCD[119] = int_stack + 25977;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2133,int_stack+3078,int_stack+2808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18399, 0.0, zero_stack, 1.0, int_stack+20199, 0.0, zero_stack,3);
     Libderiv->ABCD[118] = int_stack + 2133;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2583,int_stack+28929,int_stack+28659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19299, 1.0, int_stack+20199, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[117] = int_stack + 2583;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+26427,int_stack+29307,int_stack+3456, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[116] = int_stack + 26427;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3033,int_stack+29685,int_stack+3726, 0.0, zero_stack, 1.0, int_stack+17310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21288,3);
     Libderiv->ABCD[107] = int_stack + 3033;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3483,int_stack+4266,int_stack+3996, 0.0, zero_stack, 1.0, int_stack+18399, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21288, 0.0, zero_stack,3);
     Libderiv->ABCD[106] = int_stack + 3483;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3933,int_stack+30333,int_stack+30063, 0.0, zero_stack, 1.0, int_stack+19299, 0.0, zero_stack, 1.0, int_stack+21288, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[105] = int_stack + 3933;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+26877,int_stack+30711,int_stack+4644, 0.0, zero_stack, 1.0, int_stack+20199, 1.0, int_stack+21288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[104] = int_stack + 26877;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4383,int_stack+31089,int_stack+4914, 0.0, zero_stack, 2.0, int_stack+21288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[103] = int_stack + 4383;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+27327,int_stack+5454,int_stack+5184, 1.0, int_stack+17310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22188,3);
     Libderiv->ABCD[95] = int_stack + 27327;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4833,int_stack+5832,int_stack+16986, 1.0, int_stack+18399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22188, 0.0, zero_stack,3);
     Libderiv->ABCD[94] = int_stack + 4833;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5283,int_stack+6480,int_stack+6210, 1.0, int_stack+19299, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22188, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[93] = int_stack + 5283;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19119,int_stack+7128,int_stack+6858, 1.0, int_stack+20199, 0.0, zero_stack, 1.0, int_stack+22188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[92] = int_stack + 19119;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+20019,int_stack+7506,int_stack+0, 1.0, int_stack+21288, 1.0, int_stack+22188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[91] = int_stack + 20019;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+8154,int_stack+7884, 2.0, int_stack+22188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[90] = int_stack + 0;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+22008,int_stack+8532,int_stack+31467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23088,3);
     Libderiv->ABCD[47] = int_stack + 22008;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5733,int_stack+32007,int_stack+31737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23088, 0.0, zero_stack,3);
     Libderiv->ABCD[46] = int_stack + 5733;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6183,int_stack+32385,int_stack+8910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23088, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[45] = int_stack + 6183;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6633,int_stack+32763,int_stack+9180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[44] = int_stack + 6633;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+7083,int_stack+9720,int_stack+9450, 0.0, zero_stack, 1.0, int_stack+23088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[43] = int_stack + 7083;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+7533,int_stack+10098,int_stack+33141, 1.0, int_stack+23088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[42] = int_stack + 7533;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+22908,int_stack+10476,int_stack+33411,3);
     Libderiv->ABCD[38] = int_stack + 22908;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+7983,int_stack+33951,int_stack+33681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513,3);
     Libderiv->ABCD[35] = int_stack + 7983;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8433,int_stack+11124,int_stack+10854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513, 0.0, zero_stack,3);
     Libderiv->ABCD[34] = int_stack + 8433;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8883,int_stack+34599,int_stack+34329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[33] = int_stack + 8883;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9333,int_stack+34977,int_stack+11502, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[32] = int_stack + 9333;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9783,int_stack+35355,int_stack+11772, 0.0, zero_stack, 1.0, int_stack+513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[31] = int_stack + 9783;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+10233,int_stack+12312,int_stack+12042, 1.0, int_stack+513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[30] = int_stack + 10233;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+10683,int_stack+12690,int_stack+16392,3);
     Libderiv->ABCD[26] = int_stack + 10683;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+11133,int_stack+13068,int_stack+35733,3);
     Libderiv->ABCD[25] = int_stack + 11133;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+11583,int_stack+36273,int_stack+36003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24807,3);
     Libderiv->ABCD[23] = int_stack + 11583;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12033,int_stack+13716,int_stack+13446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24807, 0.0, zero_stack,3);
     Libderiv->ABCD[22] = int_stack + 12033;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12483,int_stack+36921,int_stack+36651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24807, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[21] = int_stack + 12483;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12933,int_stack+37299,int_stack+14094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[20] = int_stack + 12933;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13383,int_stack+37677,int_stack+14364, 0.0, zero_stack, 1.0, int_stack+24807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[19] = int_stack + 13383;
 /*--- compute (p0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13833,int_stack+14904,int_stack+14634, 1.0, int_stack+24807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[18] = int_stack + 13833;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+14283,int_stack+38055,int_stack+15282,3);
     Libderiv->ABCD[14] = int_stack + 14283;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+14733,int_stack+38433,int_stack+15552,3);
     Libderiv->ABCD[13] = int_stack + 14733;
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+15183,int_stack+38811,int_stack+15822,3);
     Libderiv->ABCD[12] = int_stack + 15183;

}
