/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_gdhd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gd|hd) integrals */

void d1hrr_order_gdhd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 315;
 Libderiv->deriv_classes[4][7][11] = int_stack + 735;
 Libderiv->deriv_classes[5][5][11] = int_stack + 1275;
 Libderiv->deriv_classes[5][6][11] = int_stack + 1716;
 Libderiv->deriv_classes[5][7][11] = int_stack + 2304;
 Libderiv->deriv_classes[6][5][11] = int_stack + 3060;
 Libderiv->deriv_classes[6][6][11] = int_stack + 3648;
 Libderiv->deriv_classes[6][7][11] = int_stack + 4432;
 Libderiv->deriv_classes[4][5][10] = int_stack + 5440;
 Libderiv->deriv_classes[4][6][10] = int_stack + 5755;
 Libderiv->deriv_classes[4][7][10] = int_stack + 6175;
 Libderiv->deriv_classes[5][5][10] = int_stack + 6715;
 Libderiv->deriv_classes[5][6][10] = int_stack + 7156;
 Libderiv->deriv_classes[5][7][10] = int_stack + 7744;
 Libderiv->deriv_classes[6][5][10] = int_stack + 8500;
 Libderiv->deriv_classes[6][6][10] = int_stack + 9088;
 Libderiv->deriv_classes[6][7][10] = int_stack + 9872;
 Libderiv->deriv_classes[4][5][9] = int_stack + 10880;
 Libderiv->deriv_classes[4][6][9] = int_stack + 11195;
 Libderiv->deriv_classes[4][7][9] = int_stack + 11615;
 Libderiv->deriv_classes[5][5][9] = int_stack + 12155;
 Libderiv->deriv_classes[5][6][9] = int_stack + 12596;
 Libderiv->deriv_classes[5][7][9] = int_stack + 13184;
 Libderiv->deriv_classes[6][5][9] = int_stack + 13940;
 Libderiv->deriv_classes[6][6][9] = int_stack + 14528;
 Libderiv->deriv_classes[6][7][9] = int_stack + 15312;
 Libderiv->deriv_classes[4][5][8] = int_stack + 16320;
 Libderiv->deriv_classes[4][6][8] = int_stack + 16635;
 Libderiv->deriv_classes[4][7][8] = int_stack + 17055;
 Libderiv->deriv_classes[5][5][8] = int_stack + 17595;
 Libderiv->deriv_classes[5][6][8] = int_stack + 18036;
 Libderiv->deriv_classes[5][7][8] = int_stack + 18624;
 Libderiv->deriv_classes[6][5][8] = int_stack + 19380;
 Libderiv->deriv_classes[6][6][8] = int_stack + 19968;
 Libderiv->deriv_classes[6][7][8] = int_stack + 20752;
 Libderiv->deriv_classes[4][5][7] = int_stack + 21760;
 Libderiv->deriv_classes[4][6][7] = int_stack + 22075;
 Libderiv->deriv_classes[4][7][7] = int_stack + 22495;
 Libderiv->deriv_classes[5][5][7] = int_stack + 23035;
 Libderiv->deriv_classes[5][6][7] = int_stack + 23476;
 Libderiv->deriv_classes[5][7][7] = int_stack + 24064;
 Libderiv->deriv_classes[6][5][7] = int_stack + 24820;
 Libderiv->deriv_classes[6][6][7] = int_stack + 25408;
 Libderiv->deriv_classes[6][7][7] = int_stack + 26192;
 Libderiv->deriv_classes[4][5][6] = int_stack + 27200;
 Libderiv->deriv_classes[4][6][6] = int_stack + 27515;
 Libderiv->deriv_classes[4][7][6] = int_stack + 27935;
 Libderiv->deriv_classes[5][5][6] = int_stack + 28475;
 Libderiv->deriv_classes[5][6][6] = int_stack + 28916;
 Libderiv->deriv_classes[5][7][6] = int_stack + 29504;
 Libderiv->dvrr_classes[6][5] = int_stack + 30260;
 Libderiv->deriv_classes[6][5][6] = int_stack + 30848;
 Libderiv->dvrr_classes[6][6] = int_stack + 31436;
 Libderiv->deriv_classes[6][6][6] = int_stack + 32220;
 Libderiv->deriv_classes[6][7][6] = int_stack + 33004;
 Libderiv->deriv_classes[4][5][2] = int_stack + 34012;
 Libderiv->deriv_classes[4][6][2] = int_stack + 34327;
 Libderiv->deriv_classes[4][7][2] = int_stack + 34747;
 Libderiv->deriv_classes[5][5][2] = int_stack + 35287;
 Libderiv->deriv_classes[5][6][2] = int_stack + 35728;
 Libderiv->deriv_classes[5][7][2] = int_stack + 36316;
 Libderiv->deriv_classes[6][5][2] = int_stack + 37072;
 Libderiv->deriv_classes[6][6][2] = int_stack + 37660;
 Libderiv->deriv_classes[6][7][2] = int_stack + 38444;
 Libderiv->deriv_classes[4][5][1] = int_stack + 39452;
 Libderiv->deriv_classes[4][6][1] = int_stack + 39767;
 Libderiv->deriv_classes[4][7][1] = int_stack + 40187;
 Libderiv->deriv_classes[5][5][1] = int_stack + 40727;
 Libderiv->deriv_classes[5][6][1] = int_stack + 41168;
 Libderiv->deriv_classes[5][7][1] = int_stack + 41756;
 Libderiv->deriv_classes[6][5][1] = int_stack + 42512;
 Libderiv->deriv_classes[6][6][1] = int_stack + 43100;
 Libderiv->deriv_classes[6][7][1] = int_stack + 43884;
 Libderiv->dvrr_classes[4][5] = int_stack + 44892;
 Libderiv->dvrr_classes[4][6] = int_stack + 45207;
 Libderiv->dvrr_classes[4][7] = int_stack + 45627;
 Libderiv->deriv_classes[4][5][0] = int_stack + 46167;
 Libderiv->deriv_classes[4][6][0] = int_stack + 46482;
 Libderiv->deriv_classes[4][7][0] = int_stack + 46902;
 Libderiv->dvrr_classes[5][5] = int_stack + 47442;
 Libderiv->dvrr_classes[5][6] = int_stack + 47883;
 Libderiv->dvrr_classes[5][7] = int_stack + 48471;
 Libderiv->deriv_classes[5][5][0] = int_stack + 49227;
 Libderiv->deriv_classes[5][6][0] = int_stack + 49668;
 Libderiv->deriv_classes[5][7][0] = int_stack + 50256;
 Libderiv->deriv_classes[6][5][0] = int_stack + 51012;
 Libderiv->deriv_classes[6][6][0] = int_stack + 51600;
 Libderiv->deriv_classes[6][7][0] = int_stack + 52384;
 memset(int_stack,0,427136);

 Libderiv->dvrr_stack = int_stack + 170530;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_gdhd(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+53392,int_stack+45207,int_stack+44892,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54337,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44892,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+55282,int_stack+735,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45207,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+56542,int_stack+55282,int_stack+54337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53392,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+54337,int_stack+47883,int_stack+47442,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58432,int_stack+1716,int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47442,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59755,int_stack+2304,int_stack+1716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47883,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+59755,int_stack+58432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54337,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+58432,int_stack+0,int_stack+56542,126);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55660,int_stack+31436,int_stack+30260,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+64102,int_stack+3648,int_stack+3060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30260,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+65866,int_stack+4432,int_stack+3648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31436,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+68218,int_stack+65866,int_stack+64102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55660,28);
 /*--- compute (hp|hd) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+71746,int_stack+68218,int_stack+0,126);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+5755,int_stack+5440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44892, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+945,int_stack+6175,int_stack+5755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45207, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2205,int_stack+945,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53392, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+7156,int_stack+6715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47442, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4095,int_stack+7744,int_stack+7156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47883, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+64102,int_stack+4095,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54337, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+79684,int_stack+64102,int_stack+2205,126);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+9088,int_stack+8500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30260, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+9872,int_stack+9088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31436, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4116,int_stack+1764,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55660, 0.0, zero_stack,28);
 /*--- compute (hp|hd) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+85354,int_stack+4116,int_stack+64102,126);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+64102,int_stack+11195,int_stack+10880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44892, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+65047,int_stack+11615,int_stack+11195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45207, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+66307,int_stack+65047,int_stack+64102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53392, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+64102,int_stack+12596,int_stack+12155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47442, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+68197,int_stack+13184,int_stack+12596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47883, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+68197,int_stack+64102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54337, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2646,int_stack+0,int_stack+66307,126);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+64102,int_stack+14528,int_stack+13940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30260, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+65866,int_stack+15312,int_stack+14528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31436, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+68218,int_stack+65866,int_stack+64102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55660, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hd) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+8316,int_stack+68218,int_stack+0,126);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+16635,int_stack+16320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+945,int_stack+17055,int_stack+16635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+64102,int_stack+945,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+18036,int_stack+17595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+65992,int_stack+18624,int_stack+18036, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+67756,int_stack+65992,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+93292,int_stack+67756,int_stack+64102,126);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+64102,int_stack+19968,int_stack+19380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+20752,int_stack+19968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+16254,int_stack+0,int_stack+64102, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hd) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+98962,int_stack+16254,int_stack+67756,126);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16254,int_stack+22075,int_stack+21760, 0.0, zero_stack, 1.0, int_stack+44892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17199,int_stack+22495,int_stack+22075, 0.0, zero_stack, 1.0, int_stack+45207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18459,int_stack+17199,int_stack+16254, 0.0, zero_stack, 1.0, int_stack+53392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16254,int_stack+23476,int_stack+23035, 0.0, zero_stack, 1.0, int_stack+47442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20349,int_stack+24064,int_stack+23476, 0.0, zero_stack, 1.0, int_stack+47883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+20349,int_stack+16254, 0.0, zero_stack, 1.0, int_stack+54337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+64102,int_stack+0,int_stack+18459,126);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16254,int_stack+25408,int_stack+24820, 0.0, zero_stack, 1.0, int_stack+30260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18018,int_stack+26192,int_stack+25408, 0.0, zero_stack, 1.0, int_stack+31436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20370,int_stack+18018,int_stack+16254, 0.0, zero_stack, 1.0, int_stack+55660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hd) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+106900,int_stack+20370,int_stack+0,126);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+27515,int_stack+27200, 1.0, int_stack+44892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+945,int_stack+27935,int_stack+27515, 1.0, int_stack+45207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+16254,int_stack+945,int_stack+0, 1.0, int_stack+53392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+28916,int_stack+28475, 1.0, int_stack+47442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18144,int_stack+29504,int_stack+28916, 1.0, int_stack+47883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19908,int_stack+18144,int_stack+0, 1.0, int_stack+54337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+22554,int_stack+19908,int_stack+16254,126);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16254,int_stack+32220,int_stack+30848, 1.0, int_stack+30260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+33004,int_stack+32220, 1.0, int_stack+31436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28224,int_stack+0,int_stack+16254, 1.0, int_stack+55660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hd) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+114838,int_stack+28224,int_stack+19908,126);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28224,int_stack+45627,int_stack+45207,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+29484,int_stack+28224,int_stack+53392,15);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+31374,int_stack+48471,int_stack+47883,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+31374,int_stack+54337,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+16254,int_stack+0,int_stack+29484,126);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31374,int_stack+34327,int_stack+34012,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28224,int_stack+34747,int_stack+34327,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+32319,int_stack+28224,int_stack+31374,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+53392,int_stack+35728,int_stack+35287,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+54715,int_stack+36316,int_stack+35728,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+34209,int_stack+54715,int_stack+53392,21);
 /*--- compute (gp|hd) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+122776,int_stack+34209,int_stack+32319, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+53392,int_stack+37660,int_stack+37072,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+55156,int_stack+38444,int_stack+37660,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+128446,int_stack+55156,int_stack+53392,28);
 /*--- compute (hp|hd) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+131974,int_stack+128446,int_stack+34209, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+128446,int_stack+39767,int_stack+39452,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28224,int_stack+40187,int_stack+39767,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+129391,int_stack+28224,int_stack+128446,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+53392,int_stack+41168,int_stack+40727,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+54715,int_stack+41756,int_stack+41168,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+31374,int_stack+54715,int_stack+53392,21);
 /*--- compute (gp|hd) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+34020,int_stack+31374,int_stack+129391, 0.0, zero_stack, 1.0, int_stack+29484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+53392,int_stack+43100,int_stack+42512,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+55156,int_stack+43884,int_stack+43100,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+128446,int_stack+55156,int_stack+53392,28);
 /*--- compute (hp|hd) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+139912,int_stack+128446,int_stack+31374, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31374,int_stack+46482,int_stack+46167,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28224,int_stack+46902,int_stack+46482,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+128446,int_stack+28224,int_stack+31374,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31374,int_stack+49668,int_stack+49227,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+53392,int_stack+50256,int_stack+49668,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+55156,int_stack+53392,int_stack+31374,21);
 /*--- compute (gp|hd) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+39690,int_stack+55156,int_stack+128446, 1.0, int_stack+29484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+53392,int_stack+51600,int_stack+51012,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+128446,int_stack+52384,int_stack+51600,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+28224,int_stack+128446,int_stack+53392,28);
 /*--- compute (hp|hd) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+45360,int_stack+28224,int_stack+55156, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (gd|hd) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+147850,int_stack+71746,int_stack+58432,126);
     Libderiv->ABCD[11] = int_stack + 147850;
 /*--- compute (gd|hd) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+159190,int_stack+85354,int_stack+79684,126);
     Libderiv->ABCD[10] = int_stack + 159190;
 /*--- compute (gd|hd) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+69772,int_stack+8316,int_stack+2646,126);
     Libderiv->ABCD[9] = int_stack + 69772;
 /*--- compute (gd|hd) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+0,int_stack+98962,int_stack+93292,126);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (gd|hd) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+81112,int_stack+106900,int_stack+64102,126);
     Libderiv->ABCD[7] = int_stack + 81112;
 /*--- compute (gd|hd) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+53298,int_stack+114838,int_stack+22554,126);
     Libderiv->ABCD[6] = int_stack + 53298;
 /*--- compute (gd|hd) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+21924,int_stack+131974,int_stack+122776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[2] = int_stack + 21924;
 /*--- compute (gd|hd) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+92452,int_stack+139912,int_stack+34020, 0.0, zero_stack, 1.0, int_stack+16254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[1] = int_stack + 92452;
 /*--- compute (gd|hd) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+103792,int_stack+45360,int_stack+39690, 1.0, int_stack+16254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[0] = int_stack + 103792;

}
