/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hpii(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hp|ii) integrals */

void d1hrr_order_hpii(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3444;
 Libderiv->deriv_classes[5][11][11] = int_stack + 4830;
 Libderiv->deriv_classes[5][12][11] = int_stack + 6468;
 Libderiv->deriv_classes[6][6][11] = int_stack + 8379;
 Libderiv->deriv_classes[6][7][11] = int_stack + 9163;
 Libderiv->deriv_classes[6][8][11] = int_stack + 10171;
 Libderiv->deriv_classes[6][9][11] = int_stack + 11431;
 Libderiv->deriv_classes[6][10][11] = int_stack + 12971;
 Libderiv->deriv_classes[6][11][11] = int_stack + 14819;
 Libderiv->deriv_classes[6][12][11] = int_stack + 17003;
 Libderiv->deriv_classes[5][6][10] = int_stack + 19551;
 Libderiv->deriv_classes[5][7][10] = int_stack + 20139;
 Libderiv->deriv_classes[5][8][10] = int_stack + 20895;
 Libderiv->deriv_classes[5][9][10] = int_stack + 21840;
 Libderiv->deriv_classes[5][10][10] = int_stack + 22995;
 Libderiv->deriv_classes[5][11][10] = int_stack + 24381;
 Libderiv->deriv_classes[5][12][10] = int_stack + 26019;
 Libderiv->deriv_classes[6][6][10] = int_stack + 27930;
 Libderiv->deriv_classes[6][7][10] = int_stack + 28714;
 Libderiv->deriv_classes[6][8][10] = int_stack + 29722;
 Libderiv->deriv_classes[6][9][10] = int_stack + 30982;
 Libderiv->deriv_classes[6][10][10] = int_stack + 32522;
 Libderiv->deriv_classes[6][11][10] = int_stack + 34370;
 Libderiv->deriv_classes[6][12][10] = int_stack + 36554;
 Libderiv->deriv_classes[5][6][9] = int_stack + 39102;
 Libderiv->deriv_classes[5][7][9] = int_stack + 39690;
 Libderiv->deriv_classes[5][8][9] = int_stack + 40446;
 Libderiv->deriv_classes[5][9][9] = int_stack + 41391;
 Libderiv->deriv_classes[5][10][9] = int_stack + 42546;
 Libderiv->deriv_classes[5][11][9] = int_stack + 43932;
 Libderiv->deriv_classes[5][12][9] = int_stack + 45570;
 Libderiv->deriv_classes[6][6][9] = int_stack + 47481;
 Libderiv->deriv_classes[6][7][9] = int_stack + 48265;
 Libderiv->deriv_classes[6][8][9] = int_stack + 49273;
 Libderiv->deriv_classes[6][9][9] = int_stack + 50533;
 Libderiv->deriv_classes[6][10][9] = int_stack + 52073;
 Libderiv->deriv_classes[6][11][9] = int_stack + 53921;
 Libderiv->deriv_classes[6][12][9] = int_stack + 56105;
 Libderiv->deriv_classes[5][6][8] = int_stack + 58653;
 Libderiv->deriv_classes[5][7][8] = int_stack + 59241;
 Libderiv->deriv_classes[5][8][8] = int_stack + 59997;
 Libderiv->deriv_classes[5][9][8] = int_stack + 60942;
 Libderiv->deriv_classes[5][10][8] = int_stack + 62097;
 Libderiv->deriv_classes[5][11][8] = int_stack + 63483;
 Libderiv->deriv_classes[5][12][8] = int_stack + 65121;
 Libderiv->deriv_classes[6][6][8] = int_stack + 67032;
 Libderiv->deriv_classes[6][7][8] = int_stack + 67816;
 Libderiv->deriv_classes[6][8][8] = int_stack + 68824;
 Libderiv->deriv_classes[6][9][8] = int_stack + 70084;
 Libderiv->deriv_classes[6][10][8] = int_stack + 71624;
 Libderiv->deriv_classes[6][11][8] = int_stack + 73472;
 Libderiv->deriv_classes[6][12][8] = int_stack + 75656;
 Libderiv->deriv_classes[5][6][7] = int_stack + 78204;
 Libderiv->deriv_classes[5][7][7] = int_stack + 78792;
 Libderiv->deriv_classes[5][8][7] = int_stack + 79548;
 Libderiv->deriv_classes[5][9][7] = int_stack + 80493;
 Libderiv->deriv_classes[5][10][7] = int_stack + 81648;
 Libderiv->deriv_classes[5][11][7] = int_stack + 83034;
 Libderiv->deriv_classes[5][12][7] = int_stack + 84672;
 Libderiv->deriv_classes[6][6][7] = int_stack + 86583;
 Libderiv->deriv_classes[6][7][7] = int_stack + 87367;
 Libderiv->deriv_classes[6][8][7] = int_stack + 88375;
 Libderiv->deriv_classes[6][9][7] = int_stack + 89635;
 Libderiv->deriv_classes[6][10][7] = int_stack + 91175;
 Libderiv->deriv_classes[6][11][7] = int_stack + 93023;
 Libderiv->deriv_classes[6][12][7] = int_stack + 95207;
 Libderiv->deriv_classes[5][6][6] = int_stack + 97755;
 Libderiv->deriv_classes[5][7][6] = int_stack + 98343;
 Libderiv->deriv_classes[5][8][6] = int_stack + 99099;
 Libderiv->deriv_classes[5][9][6] = int_stack + 100044;
 Libderiv->deriv_classes[5][10][6] = int_stack + 101199;
 Libderiv->deriv_classes[5][11][6] = int_stack + 102585;
 Libderiv->deriv_classes[5][12][6] = int_stack + 104223;
 Libderiv->dvrr_classes[6][6] = int_stack + 106134;
 Libderiv->deriv_classes[6][6][6] = int_stack + 106918;
 Libderiv->dvrr_classes[6][7] = int_stack + 107702;
 Libderiv->deriv_classes[6][7][6] = int_stack + 108710;
 Libderiv->dvrr_classes[6][8] = int_stack + 109718;
 Libderiv->deriv_classes[6][8][6] = int_stack + 110978;
 Libderiv->dvrr_classes[6][9] = int_stack + 112238;
 Libderiv->deriv_classes[6][9][6] = int_stack + 113778;
 Libderiv->dvrr_classes[6][10] = int_stack + 115318;
 Libderiv->deriv_classes[6][10][6] = int_stack + 117166;
 Libderiv->dvrr_classes[6][11] = int_stack + 119014;
 Libderiv->deriv_classes[6][11][6] = int_stack + 121198;
 Libderiv->deriv_classes[6][12][6] = int_stack + 123382;
 Libderiv->deriv_classes[5][6][2] = int_stack + 125930;
 Libderiv->deriv_classes[5][7][2] = int_stack + 126518;
 Libderiv->deriv_classes[5][8][2] = int_stack + 127274;
 Libderiv->deriv_classes[5][9][2] = int_stack + 128219;
 Libderiv->deriv_classes[5][10][2] = int_stack + 129374;
 Libderiv->deriv_classes[5][11][2] = int_stack + 130760;
 Libderiv->deriv_classes[5][12][2] = int_stack + 132398;
 Libderiv->deriv_classes[6][6][2] = int_stack + 134309;
 Libderiv->deriv_classes[6][7][2] = int_stack + 135093;
 Libderiv->deriv_classes[6][8][2] = int_stack + 136101;
 Libderiv->deriv_classes[6][9][2] = int_stack + 137361;
 Libderiv->deriv_classes[6][10][2] = int_stack + 138901;
 Libderiv->deriv_classes[6][11][2] = int_stack + 140749;
 Libderiv->deriv_classes[6][12][2] = int_stack + 142933;
 Libderiv->deriv_classes[5][6][1] = int_stack + 145481;
 Libderiv->deriv_classes[5][7][1] = int_stack + 146069;
 Libderiv->deriv_classes[5][8][1] = int_stack + 146825;
 Libderiv->deriv_classes[5][9][1] = int_stack + 147770;
 Libderiv->deriv_classes[5][10][1] = int_stack + 148925;
 Libderiv->deriv_classes[5][11][1] = int_stack + 150311;
 Libderiv->deriv_classes[5][12][1] = int_stack + 151949;
 Libderiv->deriv_classes[6][6][1] = int_stack + 153860;
 Libderiv->deriv_classes[6][7][1] = int_stack + 154644;
 Libderiv->deriv_classes[6][8][1] = int_stack + 155652;
 Libderiv->deriv_classes[6][9][1] = int_stack + 156912;
 Libderiv->deriv_classes[6][10][1] = int_stack + 158452;
 Libderiv->deriv_classes[6][11][1] = int_stack + 160300;
 Libderiv->deriv_classes[6][12][1] = int_stack + 162484;
 Libderiv->dvrr_classes[5][6] = int_stack + 165032;
 Libderiv->dvrr_classes[5][7] = int_stack + 165620;
 Libderiv->dvrr_classes[5][8] = int_stack + 166376;
 Libderiv->dvrr_classes[5][9] = int_stack + 167321;
 Libderiv->dvrr_classes[5][10] = int_stack + 168476;
 Libderiv->dvrr_classes[5][11] = int_stack + 169862;
 Libderiv->dvrr_classes[5][12] = int_stack + 171500;
 Libderiv->deriv_classes[5][6][0] = int_stack + 173411;
 Libderiv->deriv_classes[5][7][0] = int_stack + 173999;
 Libderiv->deriv_classes[5][8][0] = int_stack + 174755;
 Libderiv->deriv_classes[5][9][0] = int_stack + 175700;
 Libderiv->deriv_classes[5][10][0] = int_stack + 176855;
 Libderiv->deriv_classes[5][11][0] = int_stack + 178241;
 Libderiv->deriv_classes[5][12][0] = int_stack + 179879;
 Libderiv->deriv_classes[6][6][0] = int_stack + 181790;
 Libderiv->deriv_classes[6][7][0] = int_stack + 182574;
 Libderiv->deriv_classes[6][8][0] = int_stack + 183582;
 Libderiv->deriv_classes[6][9][0] = int_stack + 184842;
 Libderiv->deriv_classes[6][10][0] = int_stack + 186382;
 Libderiv->deriv_classes[6][11][0] = int_stack + 188230;
 Libderiv->deriv_classes[6][12][0] = int_stack + 190414;
 memset(int_stack,0,1543696);

 Libderiv->dvrr_stack = int_stack + 625723;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hpii(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+192962,int_stack+165620,int_stack+165032,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+194726,int_stack+166376,int_stack+165620,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+196994,int_stack+194726,int_stack+192962,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+200522,int_stack+167321,int_stack+166376,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+203357,int_stack+200522,int_stack+194726,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+207893,int_stack+203357,int_stack+196994,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+213773,int_stack+168476,int_stack+167321,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+217238,int_stack+213773,int_stack+200522,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+222908,int_stack+217238,int_stack+203357,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+230468,int_stack+222908,int_stack+207893,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+239288,int_stack+169862,int_stack+168476,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+243446,int_stack+239288,int_stack+213773,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+250376,int_stack+243446,int_stack+217238,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+259826,int_stack+250376,int_stack+222908,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+271166,int_stack+259826,int_stack+230468,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+283514,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165032,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+285278,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165620,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+287546,int_stack+285278,int_stack+283514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192962,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+291074,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166376,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+293909,int_stack+291074,int_stack+285278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194726,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+298445,int_stack+293909,int_stack+287546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196994,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+283514,int_stack+3444,int_stack+2289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167321,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+304325,int_stack+283514,int_stack+291074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200522,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+309995,int_stack+304325,int_stack+293909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203357,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+286979,int_stack+309995,int_stack+298445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207893,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+295799,int_stack+4830,int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168476,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+317555,int_stack+295799,int_stack+283514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213773,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+324485,int_stack+317555,int_stack+304325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217238,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+333935,int_stack+324485,int_stack+309995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222908,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+299957,int_stack+333935,int_stack+286979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230468,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+283514,int_stack+6468,int_stack+4830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169862,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+283514,int_stack+295799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239288,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+283514,int_stack+0,int_stack+317555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243446,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+345275,int_stack+283514,int_stack+324485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250376,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+283514,int_stack+345275,int_stack+333935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259826,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+312305,int_stack+283514,int_stack+299957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271166,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+283514,int_stack+107702,int_stack+106134,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+285866,int_stack+109718,int_stack+107702,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+288890,int_stack+285866,int_stack+283514,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+293594,int_stack+112238,int_stack+109718,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+297374,int_stack+293594,int_stack+285866,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+303422,int_stack+297374,int_stack+288890,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+115318,int_stack+112238,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+328769,int_stack+0,int_stack+293594,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+336329,int_stack+328769,int_stack+297374,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+346409,int_stack+336329,int_stack+303422,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+358169,int_stack+119014,int_stack+115318,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+363713,int_stack+358169,int_stack+0,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+372953,int_stack+363713,int_stack+328769,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+385553,int_stack+372953,int_stack+336329,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+400673,int_stack+385553,int_stack+346409,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+9163,int_stack+8379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106134,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417137,int_stack+10171,int_stack+9163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107702,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+420161,int_stack+417137,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283514,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4620,int_stack+11431,int_stack+10171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109718,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+424865,int_stack+4620,int_stack+417137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285866,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+430913,int_stack+424865,int_stack+420161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288890,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+417137,int_stack+12971,int_stack+11431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112238,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+438753,int_stack+417137,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293594,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+446313,int_stack+438753,int_stack+424865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297374,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+456393,int_stack+446313,int_stack+430913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303422,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4620,int_stack+14819,int_stack+12971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115318,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+421757,int_stack+4620,int_stack+417137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+468153,int_stack+421757,int_stack+438753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328769,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+430997,int_stack+468153,int_stack+446313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336329,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+480753,int_stack+430997,int_stack+456393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346409,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+446117,int_stack+17003,int_stack+14819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119014,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+452669,int_stack+446117,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358169,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+497217,int_stack+452669,int_stack+421757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363713,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+446117,int_stack+497217,int_stack+468153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372953,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+497217,int_stack+446117,int_stack+430997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385553,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+417137,int_stack+497217,int_stack+480753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400673,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+20139,int_stack+19551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165032, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6384,int_stack+20895,int_stack+20139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165620, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8652,int_stack+6384,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192962, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12180,int_stack+21840,int_stack+20895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166376, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15015,int_stack+12180,int_stack+6384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194726, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+439089,int_stack+15015,int_stack+8652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196994, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+22995,int_stack+21840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167321, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+444969,int_stack+4620,int_stack+12180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200522, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+450639,int_stack+444969,int_stack+15015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203357, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8085,int_stack+450639,int_stack+439089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207893, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+439089,int_stack+24381,int_stack+22995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168476, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+16905,int_stack+439089,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213773, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+458199,int_stack+16905,int_stack+444969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217238, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+467649,int_stack+458199,int_stack+450639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222908, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+443247,int_stack+467649,int_stack+8085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230468, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4620,int_stack+26019,int_stack+24381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169862, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+478989,int_stack+4620,int_stack+439089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239288, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4620,int_stack+478989,int_stack+16905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243446, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+478989,int_stack+4620,int_stack+458199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250376, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+478989,int_stack+467649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259826, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+455595,int_stack+4620,int_stack+443247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271166, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+28714,int_stack+27930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106134, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6972,int_stack+29722,int_stack+28714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107702, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9996,int_stack+6972,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283514, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14700,int_stack+30982,int_stack+29722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109718, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+18480,int_stack+14700,int_stack+6972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285866, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+439089,int_stack+18480,int_stack+9996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288890, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+32522,int_stack+30982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112238, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+24528,int_stack+4620,int_stack+14700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293594, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+472059,int_stack+24528,int_stack+18480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297374, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+9240,int_stack+472059,int_stack+439089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303422, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+439089,int_stack+34370,int_stack+32522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115318, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+444633,int_stack+439089,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+482139,int_stack+444633,int_stack+24528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328769, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+494739,int_stack+482139,int_stack+472059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336329, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+509859,int_stack+494739,int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346409, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+472059,int_stack+36554,int_stack+34370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119014, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+4620,int_stack+472059,int_stack+439089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358169, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+15708,int_stack+4620,int_stack+444633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363713, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+526323,int_stack+15708,int_stack+482139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372953, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+526323,int_stack+494739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385553, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+472059,int_stack+4620,int_stack+509859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400673, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+39690,int_stack+39102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165032, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6384,int_stack+40446,int_stack+39690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165620, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8652,int_stack+6384,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192962, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12180,int_stack+41391,int_stack+40446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166376, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15015,int_stack+12180,int_stack+6384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194726, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+19551,int_stack+15015,int_stack+8652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196994, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+42546,int_stack+41391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167321, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25431,int_stack+4620,int_stack+12180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200522, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+31101,int_stack+25431,int_stack+15015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203357, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8085,int_stack+31101,int_stack+19551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207893, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+16905,int_stack+43932,int_stack+42546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168476, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+439089,int_stack+16905,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213773, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+446019,int_stack+439089,int_stack+25431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217238, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+494011,int_stack+446019,int_stack+31101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222908, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+21063,int_stack+494011,int_stack+8085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230468, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4620,int_stack+45570,int_stack+43932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169862, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+33411,int_stack+4620,int_stack+16905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239288, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4620,int_stack+33411,int_stack+439089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243446, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+505351,int_stack+4620,int_stack+446019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250376, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+505351,int_stack+494011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259826, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+494011,int_stack+4620,int_stack+21063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271166, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+48265,int_stack+47481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106134, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6972,int_stack+49273,int_stack+48265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107702, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9996,int_stack+6972,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283514, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14700,int_stack+50533,int_stack+49273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109718, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+18480,int_stack+14700,int_stack+6972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285866, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+24528,int_stack+18480,int_stack+9996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288890, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+52073,int_stack+50533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112238, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+32368,int_stack+4620,int_stack+14700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293594, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+39928,int_stack+32368,int_stack+18480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297374, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+9240,int_stack+39928,int_stack+24528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303422, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+21000,int_stack+53921,int_stack+52073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115318, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+510475,int_stack+21000,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+519715,int_stack+510475,int_stack+32368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328769, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+439089,int_stack+519715,int_stack+39928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336329, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+26544,int_stack+439089,int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346409, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4620,int_stack+56105,int_stack+53921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119014, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+43008,int_stack+4620,int_stack+21000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358169, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4620,int_stack+43008,int_stack+510475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363713, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+532315,int_stack+4620,int_stack+519715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372953, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+532315,int_stack+439089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385553, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+510475,int_stack+4620,int_stack+26544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400673, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+59241,int_stack+58653, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6384,int_stack+59997,int_stack+59241, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8652,int_stack+6384,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12180,int_stack+60942,int_stack+59997, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15015,int_stack+12180,int_stack+6384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+19551,int_stack+15015,int_stack+8652, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+62097,int_stack+60942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25431,int_stack+4620,int_stack+12180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+31101,int_stack+25431,int_stack+15015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8085,int_stack+31101,int_stack+19551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+16905,int_stack+63483,int_stack+62097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+38661,int_stack+16905,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+45591,int_stack+38661,int_stack+25431, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+439089,int_stack+45591,int_stack+31101, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+21063,int_stack+439089,int_stack+8085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4620,int_stack+65121,int_stack+63483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+55041,int_stack+4620,int_stack+16905, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4620,int_stack+55041,int_stack+38661, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+532427,int_stack+4620,int_stack+45591, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+532427,int_stack+439089, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+439089,int_stack+4620,int_stack+21063, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+67816,int_stack+67032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6972,int_stack+68824,int_stack+67816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9996,int_stack+6972,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14700,int_stack+70084,int_stack+68824, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+18480,int_stack+14700,int_stack+6972, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+24528,int_stack+18480,int_stack+9996, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+71624,int_stack+70084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+32368,int_stack+4620,int_stack+14700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+39928,int_stack+32368,int_stack+18480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+9240,int_stack+39928,int_stack+24528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+21000,int_stack+73472,int_stack+71624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+50008,int_stack+21000,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+59248,int_stack+50008,int_stack+32368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+532427,int_stack+59248,int_stack+39928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+26544,int_stack+532427,int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4620,int_stack+75656,int_stack+73472, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+547547,int_stack+4620,int_stack+21000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4620,int_stack+547547,int_stack+50008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+547547,int_stack+4620,int_stack+59248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+547547,int_stack+532427, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+532427,int_stack+4620,int_stack+26544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+78792,int_stack+78204, 0.0, zero_stack, 1.0, int_stack+165032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6384,int_stack+79548,int_stack+78792, 0.0, zero_stack, 1.0, int_stack+165620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8652,int_stack+6384,int_stack+4620, 0.0, zero_stack, 1.0, int_stack+192962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12180,int_stack+80493,int_stack+79548, 0.0, zero_stack, 1.0, int_stack+166376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15015,int_stack+12180,int_stack+6384, 0.0, zero_stack, 1.0, int_stack+194726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+19551,int_stack+15015,int_stack+8652, 0.0, zero_stack, 1.0, int_stack+196994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+81648,int_stack+80493, 0.0, zero_stack, 1.0, int_stack+167321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25431,int_stack+4620,int_stack+12180, 0.0, zero_stack, 1.0, int_stack+200522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+31101,int_stack+25431,int_stack+15015, 0.0, zero_stack, 1.0, int_stack+203357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8085,int_stack+31101,int_stack+19551, 0.0, zero_stack, 1.0, int_stack+207893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+16905,int_stack+83034,int_stack+81648, 0.0, zero_stack, 1.0, int_stack+168476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+38661,int_stack+16905,int_stack+4620, 0.0, zero_stack, 1.0, int_stack+213773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+45591,int_stack+38661,int_stack+25431, 0.0, zero_stack, 1.0, int_stack+217238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+55041,int_stack+45591,int_stack+31101, 0.0, zero_stack, 1.0, int_stack+222908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+21063,int_stack+55041,int_stack+8085, 0.0, zero_stack, 1.0, int_stack+230468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4620,int_stack+84672,int_stack+83034, 0.0, zero_stack, 1.0, int_stack+169862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+66381,int_stack+4620,int_stack+16905, 0.0, zero_stack, 1.0, int_stack+239288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4620,int_stack+66381,int_stack+38661, 0.0, zero_stack, 1.0, int_stack+243446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+66381,int_stack+4620,int_stack+45591, 0.0, zero_stack, 1.0, int_stack+250376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+66381,int_stack+55041, 0.0, zero_stack, 1.0, int_stack+259826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+33411,int_stack+4620,int_stack+21063, 0.0, zero_stack, 1.0, int_stack+271166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+87367,int_stack+86583, 0.0, zero_stack, 1.0, int_stack+106134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6972,int_stack+88375,int_stack+87367, 0.0, zero_stack, 1.0, int_stack+107702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9996,int_stack+6972,int_stack+4620, 0.0, zero_stack, 1.0, int_stack+283514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14700,int_stack+89635,int_stack+88375, 0.0, zero_stack, 1.0, int_stack+109718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+18480,int_stack+14700,int_stack+6972, 0.0, zero_stack, 1.0, int_stack+285866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+24528,int_stack+18480,int_stack+9996, 0.0, zero_stack, 1.0, int_stack+288890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4620,int_stack+91175,int_stack+89635, 0.0, zero_stack, 1.0, int_stack+112238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+49875,int_stack+4620,int_stack+14700, 0.0, zero_stack, 1.0, int_stack+293594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+57435,int_stack+49875,int_stack+18480, 0.0, zero_stack, 1.0, int_stack+297374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+9240,int_stack+57435,int_stack+24528, 0.0, zero_stack, 1.0, int_stack+303422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+21000,int_stack+93023,int_stack+91175, 0.0, zero_stack, 1.0, int_stack+115318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+67515,int_stack+21000,int_stack+4620, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+76755,int_stack+67515,int_stack+49875, 0.0, zero_stack, 1.0, int_stack+328769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+554379,int_stack+76755,int_stack+57435, 0.0, zero_stack, 1.0, int_stack+336329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+49875,int_stack+554379,int_stack+9240, 0.0, zero_stack, 1.0, int_stack+346409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4620,int_stack+95207,int_stack+93023, 0.0, zero_stack, 1.0, int_stack+119014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+569499,int_stack+4620,int_stack+21000, 0.0, zero_stack, 1.0, int_stack+358169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4620,int_stack+569499,int_stack+67515, 0.0, zero_stack, 1.0, int_stack+363713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+569499,int_stack+4620,int_stack+76755, 0.0, zero_stack, 1.0, int_stack+372953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+4620,int_stack+569499,int_stack+554379, 0.0, zero_stack, 1.0, int_stack+385553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+554379,int_stack+4620,int_stack+49875, 0.0, zero_stack, 1.0, int_stack+400673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49875,int_stack+98343,int_stack+97755, 1.0, int_stack+165032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+51639,int_stack+99099,int_stack+98343, 1.0, int_stack+165620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+53907,int_stack+51639,int_stack+49875, 1.0, int_stack+192962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+57435,int_stack+100044,int_stack+99099, 1.0, int_stack+166376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+60270,int_stack+57435,int_stack+51639, 1.0, int_stack+194726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+64806,int_stack+60270,int_stack+53907, 1.0, int_stack+196994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+192962,int_stack+101199,int_stack+100044, 1.0, int_stack+167321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+49875,int_stack+192962,int_stack+57435, 1.0, int_stack+200522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+70686,int_stack+49875,int_stack+60270, 1.0, int_stack+203357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+196427,int_stack+70686,int_stack+64806, 1.0, int_stack+207893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+205247,int_stack+102585,int_stack+101199, 1.0, int_stack+168476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+55545,int_stack+205247,int_stack+192962, 1.0, int_stack+213773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+78246,int_stack+55545,int_stack+49875, 1.0, int_stack+217238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+209405,int_stack+78246,int_stack+70686, 1.0, int_stack+222908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+62475,int_stack+209405,int_stack+196427, 1.0, int_stack+230468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+49875,int_stack+104223,int_stack+102585, 1.0, int_stack+169862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+192962,int_stack+49875,int_stack+205247, 1.0, int_stack+239288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+220745,int_stack+192962,int_stack+55545, 1.0, int_stack+243446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+192962,int_stack+220745,int_stack+78246, 1.0, int_stack+250376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+220745,int_stack+192962,int_stack+209405, 1.0, int_stack+259826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+192962,int_stack+220745,int_stack+62475, 1.0, int_stack+271166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+209426,int_stack+108710,int_stack+106918, 1.0, int_stack+106134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+211778,int_stack+110978,int_stack+108710, 1.0, int_stack+107702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+214802,int_stack+211778,int_stack+209426, 1.0, int_stack+283514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+219506,int_stack+113778,int_stack+110978, 1.0, int_stack+109718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+223286,int_stack+219506,int_stack+211778, 1.0, int_stack+285866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+229334,int_stack+223286,int_stack+214802, 1.0, int_stack+288890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+283514,int_stack+117166,int_stack+113778, 1.0, int_stack+112238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+209426,int_stack+283514,int_stack+219506, 1.0, int_stack+293594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+49875,int_stack+209426,int_stack+223286, 1.0, int_stack+297374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+288134,int_stack+49875,int_stack+229334, 1.0, int_stack+303422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+299894,int_stack+121198,int_stack+117166, 1.0, int_stack+115318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+216986,int_stack+299894,int_stack+283514, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+0,int_stack+216986,int_stack+209426, 1.0, int_stack+328769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+12600,int_stack+0,int_stack+49875, 1.0, int_stack+336329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+49875,int_stack+12600,int_stack+288134, 1.0, int_stack+346409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+66339,int_stack+123382,int_stack+121198, 1.0, int_stack+119014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+72891,int_stack+66339,int_stack+299894, 1.0, int_stack+358169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+83979,int_stack+72891,int_stack+216986, 1.0, int_stack+363713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+99379,int_stack+83979,int_stack+0, 1.0, int_stack+372953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+66339,int_stack+99379,int_stack+12600, 1.0, int_stack+385553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+0,int_stack+66339,int_stack+49875, 1.0, int_stack+400673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+49875,int_stack+171500,int_stack+169862,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+54789,int_stack+49875,int_stack+239288,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+63105,int_stack+54789,int_stack+243446,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+74655,int_stack+63105,int_stack+250376,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+49875,int_stack+74655,int_stack+259826,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+65751,int_stack+49875,int_stack+271166,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+49875,int_stack+126518,int_stack+125930,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+51639,int_stack+127274,int_stack+126518,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+53907,int_stack+51639,int_stack+49875,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+57435,int_stack+128219,int_stack+127274,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+60270,int_stack+57435,int_stack+51639,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+82215,int_stack+60270,int_stack+53907,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+49875,int_stack+129374,int_stack+128219,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+88095,int_stack+49875,int_stack+57435,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+93765,int_stack+88095,int_stack+60270,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+53340,int_stack+93765,int_stack+82215,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+82215,int_stack+130760,int_stack+129374,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+101325,int_stack+82215,int_stack+49875,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+108255,int_stack+101325,int_stack+88095,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+117705,int_stack+108255,int_stack+93765,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+86373,int_stack+117705,int_stack+53340,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+49875,int_stack+132398,int_stack+130760,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+54789,int_stack+49875,int_stack+82215,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+328769,int_stack+54789,int_stack+101325,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+49875,int_stack+328769,int_stack+108255,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+328769,int_stack+49875,int_stack+117705,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+344645,int_stack+328769,int_stack+86373,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+328769,int_stack+135093,int_stack+134309,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+331121,int_stack+136101,int_stack+135093,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+334145,int_stack+331121,int_stack+328769,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+338849,int_stack+137361,int_stack+136101,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+49875,int_stack+338849,int_stack+331121,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+55923,int_stack+49875,int_stack+334145,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+328769,int_stack+138901,int_stack+137361,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+361109,int_stack+328769,int_stack+338849,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+333389,int_stack+361109,int_stack+49875,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+368669,int_stack+333389,int_stack+55923,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+49875,int_stack+140749,int_stack+138901,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+55419,int_stack+49875,int_stack+328769,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+380429,int_stack+55419,int_stack+361109,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+393029,int_stack+380429,int_stack+333389,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+82215,int_stack+393029,int_stack+368669,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+361109,int_stack+142933,int_stack+140749,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+367661,int_stack+361109,int_stack+49875,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+328769,int_stack+367661,int_stack+55419,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+361109,int_stack+328769,int_stack+380429,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+98679,int_stack+361109,int_stack+393029,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+361109,int_stack+98679,int_stack+82215,28);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+82215,int_stack+146069,int_stack+145481,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+83979,int_stack+146825,int_stack+146069,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+86247,int_stack+83979,int_stack+82215,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+89775,int_stack+147770,int_stack+146825,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+92610,int_stack+89775,int_stack+83979,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+97146,int_stack+92610,int_stack+86247,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+82215,int_stack+148925,int_stack+147770,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+103026,int_stack+82215,int_stack+89775,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+108696,int_stack+103026,int_stack+92610,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+85680,int_stack+108696,int_stack+97146,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+94500,int_stack+150311,int_stack+148925,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+116256,int_stack+94500,int_stack+82215,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+123186,int_stack+116256,int_stack+103026,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+132636,int_stack+123186,int_stack+108696,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+98658,int_stack+132636,int_stack+85680,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+82215,int_stack+151949,int_stack+150311,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+143976,int_stack+82215,int_stack+94500,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+82215,int_stack+143976,int_stack+116256,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+383061,int_stack+82215,int_stack+123186,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+328769,int_stack+383061,int_stack+132636,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+383061,int_stack+328769,int_stack+98658,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+328769,int_stack+154644,int_stack+153860,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+331121,int_stack+155652,int_stack+154644,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+334145,int_stack+331121,int_stack+328769,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+338849,int_stack+156912,int_stack+155652,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+399525,int_stack+338849,int_stack+331121,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+405573,int_stack+399525,int_stack+334145,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+328769,int_stack+158452,int_stack+156912,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+82215,int_stack+328769,int_stack+338849,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+333389,int_stack+82215,int_stack+399525,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+89775,int_stack+333389,int_stack+405573,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+399525,int_stack+160300,int_stack+158452,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+405069,int_stack+399525,int_stack+328769,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+101535,int_stack+405069,int_stack+82215,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+114135,int_stack+101535,int_stack+333389,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+129255,int_stack+114135,int_stack+89775,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+82215,int_stack+162484,int_stack+160300,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+88767,int_stack+82215,int_stack+399525,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+328769,int_stack+88767,int_stack+405069,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+82215,int_stack+328769,int_stack+101535,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+145719,int_stack+82215,int_stack+114135,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+82215,int_stack+145719,int_stack+129255,28);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+104167,int_stack+173999,int_stack+173411,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+105931,int_stack+174755,int_stack+173999,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+108199,int_stack+105931,int_stack+104167,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+111727,int_stack+175700,int_stack+174755,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+114562,int_stack+111727,int_stack+105931,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+119098,int_stack+114562,int_stack+108199,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+104167,int_stack+176855,int_stack+175700,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+124978,int_stack+104167,int_stack+111727,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+130648,int_stack+124978,int_stack+114562,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+107632,int_stack+130648,int_stack+119098,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+116452,int_stack+178241,int_stack+176855,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+138208,int_stack+116452,int_stack+104167,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+145138,int_stack+138208,int_stack+124978,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+154588,int_stack+145138,int_stack+130648,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+120610,int_stack+154588,int_stack+107632,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+104167,int_stack+179879,int_stack+178241,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+165928,int_stack+104167,int_stack+116452,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+104167,int_stack+165928,int_stack+138208,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+165928,int_stack+104167,int_stack+145138,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+328769,int_stack+165928,int_stack+154588,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+132958,int_stack+328769,int_stack+120610,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+328769,int_stack+182574,int_stack+181790,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+331121,int_stack+183582,int_stack+182574,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+334145,int_stack+331121,int_stack+328769,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+338849,int_stack+184842,int_stack+183582,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+104167,int_stack+338849,int_stack+331121,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+110215,int_stack+104167,int_stack+334145,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+328769,int_stack+186382,int_stack+184842,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+118055,int_stack+328769,int_stack+338849,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+333389,int_stack+118055,int_stack+104167,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+149422,int_stack+333389,int_stack+110215,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+104167,int_stack+188230,int_stack+186382,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+161182,int_stack+104167,int_stack+328769,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+170422,int_stack+161182,int_stack+118055,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+109711,int_stack+170422,int_stack+333389,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+399525,int_stack+109711,int_stack+149422,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+149422,int_stack+190414,int_stack+188230,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+328769,int_stack+149422,int_stack+104167,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+49875,int_stack+328769,int_stack+161182,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+149422,int_stack+49875,int_stack+170422,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+168322,int_stack+149422,int_stack+109711,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+104167,int_stack+168322,int_stack+399525,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+209426,int_stack+417137,int_stack+312305,784);
     Libderiv->ABCD[11] = int_stack + 209426;
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+258818,int_stack+472059,int_stack+455595,784);
     Libderiv->ABCD[10] = int_stack + 258818;
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+576331,int_stack+510475,int_stack+494011,784);
     Libderiv->ABCD[9] = int_stack + 576331;
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+455553,int_stack+532427,int_stack+439089,784);
     Libderiv->ABCD[8] = int_stack + 455553;
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+399525,int_stack+554379,int_stack+33411,784);
     Libderiv->ABCD[7] = int_stack + 399525;
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+504945,int_stack+0,int_stack+192962,784);
     Libderiv->ABCD[6] = int_stack + 504945;
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+0,int_stack+361109,int_stack+344645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[2] = int_stack + 0;
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+149422,int_stack+82215,int_stack+383061, 0.0, zero_stack, 1.0, int_stack+65751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[1] = int_stack + 149422;
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+308210,int_stack+104167,int_stack+132958, 1.0, int_stack+65751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[0] = int_stack + 308210;

}
