/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ipgg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ip|gg) integrals */

void d1hrr_order_ipgg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][4][11] = int_stack + 0;
 Libderiv->deriv_classes[6][5][11] = int_stack + 420;
 Libderiv->deriv_classes[6][6][11] = int_stack + 1008;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1792;
 Libderiv->deriv_classes[6][8][11] = int_stack + 2800;
 Libderiv->deriv_classes[7][4][11] = int_stack + 4060;
 Libderiv->deriv_classes[7][5][11] = int_stack + 4600;
 Libderiv->deriv_classes[7][6][11] = int_stack + 5356;
 Libderiv->deriv_classes[7][7][11] = int_stack + 6364;
 Libderiv->deriv_classes[7][8][11] = int_stack + 7660;
 Libderiv->deriv_classes[6][4][10] = int_stack + 9280;
 Libderiv->deriv_classes[6][5][10] = int_stack + 9700;
 Libderiv->deriv_classes[6][6][10] = int_stack + 10288;
 Libderiv->deriv_classes[6][7][10] = int_stack + 11072;
 Libderiv->deriv_classes[6][8][10] = int_stack + 12080;
 Libderiv->deriv_classes[7][4][10] = int_stack + 13340;
 Libderiv->deriv_classes[7][5][10] = int_stack + 13880;
 Libderiv->deriv_classes[7][6][10] = int_stack + 14636;
 Libderiv->deriv_classes[7][7][10] = int_stack + 15644;
 Libderiv->deriv_classes[7][8][10] = int_stack + 16940;
 Libderiv->deriv_classes[6][4][9] = int_stack + 18560;
 Libderiv->deriv_classes[6][5][9] = int_stack + 18980;
 Libderiv->deriv_classes[6][6][9] = int_stack + 19568;
 Libderiv->deriv_classes[6][7][9] = int_stack + 20352;
 Libderiv->deriv_classes[6][8][9] = int_stack + 21360;
 Libderiv->deriv_classes[7][4][9] = int_stack + 22620;
 Libderiv->deriv_classes[7][5][9] = int_stack + 23160;
 Libderiv->deriv_classes[7][6][9] = int_stack + 23916;
 Libderiv->deriv_classes[7][7][9] = int_stack + 24924;
 Libderiv->deriv_classes[7][8][9] = int_stack + 26220;
 Libderiv->deriv_classes[6][4][8] = int_stack + 27840;
 Libderiv->deriv_classes[6][5][8] = int_stack + 28260;
 Libderiv->deriv_classes[6][6][8] = int_stack + 28848;
 Libderiv->deriv_classes[6][7][8] = int_stack + 29632;
 Libderiv->deriv_classes[6][8][8] = int_stack + 30640;
 Libderiv->deriv_classes[7][4][8] = int_stack + 31900;
 Libderiv->deriv_classes[7][5][8] = int_stack + 32440;
 Libderiv->deriv_classes[7][6][8] = int_stack + 33196;
 Libderiv->deriv_classes[7][7][8] = int_stack + 34204;
 Libderiv->deriv_classes[7][8][8] = int_stack + 35500;
 Libderiv->deriv_classes[6][4][7] = int_stack + 37120;
 Libderiv->deriv_classes[6][5][7] = int_stack + 37540;
 Libderiv->deriv_classes[6][6][7] = int_stack + 38128;
 Libderiv->deriv_classes[6][7][7] = int_stack + 38912;
 Libderiv->deriv_classes[6][8][7] = int_stack + 39920;
 Libderiv->deriv_classes[7][4][7] = int_stack + 41180;
 Libderiv->deriv_classes[7][5][7] = int_stack + 41720;
 Libderiv->deriv_classes[7][6][7] = int_stack + 42476;
 Libderiv->deriv_classes[7][7][7] = int_stack + 43484;
 Libderiv->deriv_classes[7][8][7] = int_stack + 44780;
 Libderiv->deriv_classes[6][4][6] = int_stack + 46400;
 Libderiv->deriv_classes[6][5][6] = int_stack + 46820;
 Libderiv->deriv_classes[6][6][6] = int_stack + 47408;
 Libderiv->deriv_classes[6][7][6] = int_stack + 48192;
 Libderiv->deriv_classes[6][8][6] = int_stack + 49200;
 Libderiv->dvrr_classes[7][4] = int_stack + 50460;
 Libderiv->deriv_classes[7][4][6] = int_stack + 51000;
 Libderiv->dvrr_classes[7][5] = int_stack + 51540;
 Libderiv->deriv_classes[7][5][6] = int_stack + 52296;
 Libderiv->dvrr_classes[7][6] = int_stack + 53052;
 Libderiv->deriv_classes[7][6][6] = int_stack + 54060;
 Libderiv->dvrr_classes[7][7] = int_stack + 55068;
 Libderiv->deriv_classes[7][7][6] = int_stack + 56364;
 Libderiv->deriv_classes[7][8][6] = int_stack + 57660;
 Libderiv->deriv_classes[6][4][2] = int_stack + 59280;
 Libderiv->deriv_classes[6][5][2] = int_stack + 59700;
 Libderiv->deriv_classes[6][6][2] = int_stack + 60288;
 Libderiv->deriv_classes[6][7][2] = int_stack + 61072;
 Libderiv->deriv_classes[6][8][2] = int_stack + 62080;
 Libderiv->deriv_classes[7][4][2] = int_stack + 63340;
 Libderiv->deriv_classes[7][5][2] = int_stack + 63880;
 Libderiv->deriv_classes[7][6][2] = int_stack + 64636;
 Libderiv->deriv_classes[7][7][2] = int_stack + 65644;
 Libderiv->deriv_classes[7][8][2] = int_stack + 66940;
 Libderiv->deriv_classes[6][4][1] = int_stack + 68560;
 Libderiv->deriv_classes[6][5][1] = int_stack + 68980;
 Libderiv->deriv_classes[6][6][1] = int_stack + 69568;
 Libderiv->deriv_classes[6][7][1] = int_stack + 70352;
 Libderiv->deriv_classes[6][8][1] = int_stack + 71360;
 Libderiv->deriv_classes[7][4][1] = int_stack + 72620;
 Libderiv->deriv_classes[7][5][1] = int_stack + 73160;
 Libderiv->deriv_classes[7][6][1] = int_stack + 73916;
 Libderiv->deriv_classes[7][7][1] = int_stack + 74924;
 Libderiv->deriv_classes[7][8][1] = int_stack + 76220;
 Libderiv->dvrr_classes[6][4] = int_stack + 77840;
 Libderiv->dvrr_classes[6][5] = int_stack + 78260;
 Libderiv->dvrr_classes[6][6] = int_stack + 78848;
 Libderiv->dvrr_classes[6][7] = int_stack + 79632;
 Libderiv->dvrr_classes[6][8] = int_stack + 80640;
 Libderiv->deriv_classes[6][4][0] = int_stack + 81900;
 Libderiv->deriv_classes[6][5][0] = int_stack + 82320;
 Libderiv->deriv_classes[6][6][0] = int_stack + 82908;
 Libderiv->deriv_classes[6][7][0] = int_stack + 83692;
 Libderiv->deriv_classes[6][8][0] = int_stack + 84700;
 Libderiv->deriv_classes[7][4][0] = int_stack + 85960;
 Libderiv->deriv_classes[7][5][0] = int_stack + 86500;
 Libderiv->deriv_classes[7][6][0] = int_stack + 87256;
 Libderiv->deriv_classes[7][7][0] = int_stack + 88264;
 Libderiv->deriv_classes[7][8][0] = int_stack + 89560;
 memset(int_stack,0,729440);

 Libderiv->dvrr_stack = int_stack + 223408;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ipgg(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+91180,int_stack+78260,int_stack+77840,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+92440,int_stack+78848,int_stack+78260,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+94204,int_stack+92440,int_stack+91180,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+96724,int_stack+79632,int_stack+78848,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+99076,int_stack+96724,int_stack+92440,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+102604,int_stack+99076,int_stack+94204,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+106804,int_stack+420,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77840,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+108064,int_stack+1008,int_stack+420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78260,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+109828,int_stack+108064,int_stack+106804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91180,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+112348,int_stack+1792,int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78848,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+114700,int_stack+112348,int_stack+108064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92440,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+118228,int_stack+114700,int_stack+109828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94204,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+106804,int_stack+2800,int_stack+1792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79632,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122428,int_stack+106804,int_stack+112348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96724,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+106804,int_stack+122428,int_stack+114700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99076,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+122428,int_stack+106804,int_stack+118228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102604,28);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+106804,int_stack+51540,int_stack+50460,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+108424,int_stack+53052,int_stack+51540,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+110692,int_stack+108424,int_stack+106804,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+113932,int_stack+55068,int_stack+53052,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+116956,int_stack+113932,int_stack+108424,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+128728,int_stack+116956,int_stack+110692,36);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+4600,int_stack+4060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50460,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+5356,int_stack+4600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51540,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+134128,int_stack+1620,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106804,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+137368,int_stack+6364,int_stack+5356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53052,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+140392,int_stack+137368,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108424,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+140392,int_stack+134128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110692,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+144928,int_stack+7660,int_stack+6364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55068,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+148816,int_stack+144928,int_stack+137368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113932,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+154864,int_stack+148816,int_stack+140392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116956,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+134128,int_stack+154864,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128728,36);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+9700,int_stack+9280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77840, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+10288,int_stack+9700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78260, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3024,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91180, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5544,int_stack+11072,int_stack+10288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78848, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+142228,int_stack+5544,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92440, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+145756,int_stack+142228,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94204, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+12080,int_stack+11072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79632, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7896,int_stack+0,int_stack+5544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96724, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+7896,int_stack+142228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99076, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+5880,int_stack+0,int_stack+145756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102604, 0.0, zero_stack,28);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+13880,int_stack+13340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50460, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+14636,int_stack+13880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51540, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+142228,int_stack+1620,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106804, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+145468,int_stack+15644,int_stack+14636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53052, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+148492,int_stack+145468,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108424, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+148492,int_stack+142228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110692, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153028,int_stack+16940,int_stack+15644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55068, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156916,int_stack+153028,int_stack+145468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113932, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+162964,int_stack+156916,int_stack+148492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116956, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+142228,int_stack+162964,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128728, 0.0, zero_stack,36);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+18980,int_stack+18560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77840, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+19568,int_stack+18980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78260, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3024,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91180, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+150328,int_stack+20352,int_stack+19568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78848, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+152680,int_stack+150328,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92440, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+156208,int_stack+152680,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94204, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+21360,int_stack+20352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79632, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+160408,int_stack+0,int_stack+150328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96724, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+160408,int_stack+152680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99076, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+160408,int_stack+0,int_stack+156208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102604, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+23160,int_stack+22620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50460, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+23916,int_stack+23160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51540, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+166708,int_stack+1620,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106804, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+150328,int_stack+24924,int_stack+23916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53052, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+153352,int_stack+150328,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108424, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+153352,int_stack+166708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110692, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+166708,int_stack+26220,int_stack+24924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55068, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12180,int_stack+166708,int_stack+150328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113932, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18228,int_stack+12180,int_stack+153352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116956, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+150328,int_stack+18228,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128728, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+28260,int_stack+27840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+28848,int_stack+28260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3024,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12180,int_stack+29632,int_stack+28848, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14532,int_stack+12180,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+18060,int_stack+14532,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+30640,int_stack+29632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22260,int_stack+0,int_stack+12180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+22260,int_stack+14532, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+22260,int_stack+0,int_stack+18060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+32440,int_stack+31900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+33196,int_stack+32440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+28560,int_stack+1620,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12180,int_stack+34204,int_stack+33196, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15204,int_stack+12180,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+15204,int_stack+28560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+28560,int_stack+35500,int_stack+34204, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166708,int_stack+28560,int_stack+12180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+28560,int_stack+166708,int_stack+15204, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12180,int_stack+28560,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+37540,int_stack+37120, 0.0, zero_stack, 1.0, int_stack+77840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+38128,int_stack+37540, 0.0, zero_stack, 1.0, int_stack+78260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3024,int_stack+1260,int_stack+0, 0.0, zero_stack, 1.0, int_stack+91180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+38912,int_stack+38128, 0.0, zero_stack, 1.0, int_stack+78848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+30912,int_stack+28560,int_stack+1260, 0.0, zero_stack, 1.0, int_stack+92440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+34440,int_stack+30912,int_stack+3024, 0.0, zero_stack, 1.0, int_stack+94204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+39920,int_stack+38912, 0.0, zero_stack, 1.0, int_stack+79632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166708,int_stack+0,int_stack+28560, 0.0, zero_stack, 1.0, int_stack+96724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+166708,int_stack+30912, 0.0, zero_stack, 1.0, int_stack+99076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+166708,int_stack+0,int_stack+34440, 0.0, zero_stack, 1.0, int_stack+102604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+41720,int_stack+41180, 0.0, zero_stack, 1.0, int_stack+50460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+42476,int_stack+41720, 0.0, zero_stack, 1.0, int_stack+51540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+28560,int_stack+1620,int_stack+0, 0.0, zero_stack, 1.0, int_stack+106804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+31800,int_stack+43484,int_stack+42476, 0.0, zero_stack, 1.0, int_stack+53052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34824,int_stack+31800,int_stack+1620, 0.0, zero_stack, 1.0, int_stack+108424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+34824,int_stack+28560, 0.0, zero_stack, 1.0, int_stack+110692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+39360,int_stack+44780,int_stack+43484, 0.0, zero_stack, 1.0, int_stack+55068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+173008,int_stack+39360,int_stack+31800, 0.0, zero_stack, 1.0, int_stack+113932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+179056,int_stack+173008,int_stack+34824, 0.0, zero_stack, 1.0, int_stack+116956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+28560,int_stack+179056,int_stack+0, 0.0, zero_stack, 1.0, int_stack+128728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+46820,int_stack+46400, 1.0, int_stack+77840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+47408,int_stack+46820, 1.0, int_stack+78260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3024,int_stack+1260,int_stack+0, 1.0, int_stack+91180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+173008,int_stack+48192,int_stack+47408, 1.0, int_stack+78848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+175360,int_stack+173008,int_stack+1260, 1.0, int_stack+92440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+178888,int_stack+175360,int_stack+3024, 1.0, int_stack+94204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+91180,int_stack+49200,int_stack+48192, 1.0, int_stack+79632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+91180,int_stack+173008, 1.0, int_stack+96724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36660,int_stack+0,int_stack+175360, 1.0, int_stack+99076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+42540,int_stack+36660,int_stack+178888, 1.0, int_stack+102604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+48840,int_stack+52296,int_stack+51000, 1.0, int_stack+50460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36660,int_stack+54060,int_stack+52296, 1.0, int_stack+51540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38928,int_stack+36660,int_stack+48840, 1.0, int_stack+106804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+48840,int_stack+56364,int_stack+54060, 1.0, int_stack+53052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+48840,int_stack+36660, 1.0, int_stack+108424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+173008,int_stack+0,int_stack+38928, 1.0, int_stack+110692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36660,int_stack+57660,int_stack+56364, 1.0, int_stack+55068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+106804,int_stack+36660,int_stack+48840, 1.0, int_stack+113932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+48840,int_stack+106804,int_stack+0, 1.0, int_stack+116956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+106804,int_stack+48840,int_stack+173008, 1.0, int_stack+128728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+128728,int_stack+80640,int_stack+79632,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+173008,int_stack+128728,int_stack+96724,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+173008,int_stack+99076,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+173008,int_stack+0,int_stack+102604,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+59700,int_stack+59280,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+60288,int_stack+59700,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3024,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+179308,int_stack+61072,int_stack+60288,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+181660,int_stack+179308,int_stack+1260,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+128728,int_stack+181660,int_stack+3024,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+62080,int_stack+61072,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+48840,int_stack+0,int_stack+179308,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+48840,int_stack+181660,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+48840,int_stack+0,int_stack+128728,28);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+128728,int_stack+63880,int_stack+63340,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+130348,int_stack+64636,int_stack+63880,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+130348,int_stack+128728,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+55140,int_stack+65644,int_stack+64636,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+58164,int_stack+55140,int_stack+130348,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+128728,int_stack+58164,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+66940,int_stack+65644,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+179308,int_stack+0,int_stack+55140,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+91180,int_stack+179308,int_stack+58164,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+55140,int_stack+91180,int_stack+128728,36);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+128728,int_stack+68980,int_stack+68560,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+129988,int_stack+69568,int_stack+68980,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+91180,int_stack+129988,int_stack+128728,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+131752,int_stack+70352,int_stack+69568,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+93700,int_stack+131752,int_stack+129988,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+97228,int_stack+93700,int_stack+91180,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+128728,int_stack+71360,int_stack+70352,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+101428,int_stack+128728,int_stack+131752,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+101428,int_stack+93700,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+179308,int_stack+0,int_stack+97228,28);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+73160,int_stack+72620,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+73916,int_stack+73160,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+128728,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+91180,int_stack+74924,int_stack+73916,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+94204,int_stack+91180,int_stack+1620,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+94204,int_stack+128728,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+128728,int_stack+76220,int_stack+74924,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+98740,int_stack+128728,int_stack+91180,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+63240,int_stack+98740,int_stack+94204,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+91180,int_stack+63240,int_stack+0,36);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+82320,int_stack+81900,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+82908,int_stack+82320,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3024,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+63240,int_stack+83692,int_stack+82908,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+65592,int_stack+63240,int_stack+1260,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+69120,int_stack+65592,int_stack+3024,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+84700,int_stack+83692,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+73320,int_stack+0,int_stack+63240,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+73320,int_stack+65592,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+73320,int_stack+0,int_stack+69120,28);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+86500,int_stack+85960,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+87256,int_stack+86500,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+79620,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+82860,int_stack+88264,int_stack+87256,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+63240,int_stack+82860,int_stack+1620,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+128728,int_stack+63240,int_stack+79620,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+89560,int_stack+88264,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+99280,int_stack+0,int_stack+82860,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+79620,int_stack+99280,int_stack+63240,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+63240,int_stack+79620,int_stack+128728,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+185608,int_stack+134128,int_stack+122428,225);
     Libderiv->ABCD[11] = int_stack + 185608;
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+114904,int_stack+142228,int_stack+5880,225);
     Libderiv->ABCD[10] = int_stack + 114904;
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+204508,int_stack+150328,int_stack+160408,225);
     Libderiv->ABCD[9] = int_stack + 204508;
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+133804,int_stack+12180,int_stack+22260,225);
     Libderiv->ABCD[8] = int_stack + 133804;
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+0,int_stack+28560,int_stack+166708,225);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+18900,int_stack+106804,int_stack+42540,225);
     Libderiv->ABCD[6] = int_stack + 18900;
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+152704,int_stack+55140,int_stack+48840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[2] = int_stack + 152704;
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+37800,int_stack+91180,int_stack+179308, 0.0, zero_stack, 1.0, int_stack+173008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[1] = int_stack + 37800;
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+79620,int_stack+63240,int_stack+73320, 1.0, int_stack+173008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[0] = int_stack + 79620;

}
