/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0kk(Libint_t*, prim_data*);

  /* Computes quartets of (d0|kk) integrals */

REALTYPE *hrr_order_d0kk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][7] = int_stack + 0;
 Libint->vrr_classes[2][8] = int_stack + 216;
 Libint->vrr_classes[2][9] = int_stack + 486;
 Libint->vrr_classes[2][10] = int_stack + 816;
 Libint->vrr_classes[2][11] = int_stack + 1212;
 Libint->vrr_classes[2][12] = int_stack + 1680;
 Libint->vrr_classes[2][13] = int_stack + 2226;
 Libint->vrr_classes[2][14] = int_stack + 2856;
 memset(int_stack,0,3576*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3576;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0kk(Libint, Data);
   Data++;
 }
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3576,int_stack+216,int_stack+0,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4224,int_stack+486,int_stack+216,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+5034,int_stack+4224,int_stack+3576,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6330,int_stack+816,int_stack+486,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+7320,int_stack+6330,int_stack+4224,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+8940,int_stack+7320,int_stack+5034,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3576,int_stack+1212,int_stack+816,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+11100,int_stack+3576,int_stack+6330,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+13080,int_stack+11100,int_stack+7320,6);
 /*--- compute (d0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+4764,int_stack+13080,int_stack+8940,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8004,int_stack+1680,int_stack+1212,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15780,int_stack+8004,int_stack+3576,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+18156,int_stack+15780,int_stack+11100,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+21456,int_stack+18156,int_stack+13080,6);
 /*--- compute (d0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+9408,int_stack+21456,int_stack+4764,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3576,int_stack+2226,int_stack+1680,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+25506,int_stack+3576,int_stack+8004,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5214,int_stack+25506,int_stack+15780,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28314,int_stack+5214,int_stack+18156,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+13944,int_stack+28314,int_stack+21456,6);
 /*--- compute (d0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+33264,int_stack+13944,int_stack+9408,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+9174,int_stack+2856,int_stack+2226,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+19614,int_stack+9174,int_stack+3576,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+9174,int_stack+19614,int_stack+25506,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+19614,int_stack+9174,int_stack+5214,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+19614,int_stack+28314,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+19614,int_stack+0,int_stack+13944,6);
 /*--- compute (d0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+19614,int_stack+33264,6);
 return int_stack+0;}
