/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpif(Libint_t*, prim_data*);

  /* Computes quartets of (dp|if) integrals */

REALTYPE *hrr_order_dpif(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][6] = int_stack + 0;
 Libint->vrr_classes[2][7] = int_stack + 168;
 Libint->vrr_classes[2][8] = int_stack + 384;
 Libint->vrr_classes[2][9] = int_stack + 654;
 Libint->vrr_classes[3][6] = int_stack + 984;
 Libint->vrr_classes[3][7] = int_stack + 1264;
 Libint->vrr_classes[3][8] = int_stack + 1624;
 Libint->vrr_classes[3][9] = int_stack + 2074;
 memset(int_stack,0,2624*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2624;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpif(Libint, Data);
   Data++;
 }
 /*--- compute (d0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+2624,int_stack+168,int_stack+0,6);
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3128,int_stack+384,int_stack+168,6);
 /*--- compute (d0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+3776,int_stack+3128,int_stack+2624,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4784,int_stack+654,int_stack+384,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+5594,int_stack+4784,int_stack+3128,6);
 /*--- compute (d0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+6890,int_stack+5594,int_stack+3776,6);
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+2624,int_stack+1264,int_stack+984,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3464,int_stack+1624,int_stack+1264,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+4544,int_stack+3464,int_stack+2624,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+2074,int_stack+1624,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+8570,int_stack+0,int_stack+3464,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+8570,int_stack+4544,10);
 /*--- compute (dp|if) ---*/
 hrr1_build_dp(Libint->AB,int_stack+8570,int_stack+0,int_stack+6890,280);
 return int_stack+8570;}
