/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpkk(Libint_t*, prim_data*);

  /* Computes quartets of (dp|kk) integrals */

REALTYPE *hrr_order_dpkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][7] = int_stack + 0;
 Libint->vrr_classes[2][8] = int_stack + 216;
 Libint->vrr_classes[2][9] = int_stack + 486;
 Libint->vrr_classes[2][10] = int_stack + 816;
 Libint->vrr_classes[2][11] = int_stack + 1212;
 Libint->vrr_classes[2][12] = int_stack + 1680;
 Libint->vrr_classes[2][13] = int_stack + 2226;
 Libint->vrr_classes[2][14] = int_stack + 2856;
 Libint->vrr_classes[3][7] = int_stack + 3576;
 Libint->vrr_classes[3][8] = int_stack + 3936;
 Libint->vrr_classes[3][9] = int_stack + 4386;
 Libint->vrr_classes[3][10] = int_stack + 4936;
 Libint->vrr_classes[3][11] = int_stack + 5596;
 Libint->vrr_classes[3][12] = int_stack + 6376;
 Libint->vrr_classes[3][13] = int_stack + 7286;
 Libint->vrr_classes[3][14] = int_stack + 8336;
 memset(int_stack,0,9536*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9536;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpkk(Libint, Data);
   Data++;
 }
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+9536,int_stack+216,int_stack+0,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+10184,int_stack+486,int_stack+216,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10994,int_stack+10184,int_stack+9536,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12290,int_stack+816,int_stack+486,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13280,int_stack+12290,int_stack+10184,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+14900,int_stack+13280,int_stack+10994,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9536,int_stack+1212,int_stack+816,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+17060,int_stack+9536,int_stack+12290,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+19040,int_stack+17060,int_stack+13280,6);
 /*--- compute (d0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10724,int_stack+19040,int_stack+14900,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13964,int_stack+1680,int_stack+1212,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+21740,int_stack+13964,int_stack+9536,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+24116,int_stack+21740,int_stack+17060,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+27416,int_stack+24116,int_stack+19040,6);
 /*--- compute (d0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+15368,int_stack+27416,int_stack+10724,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+9536,int_stack+2226,int_stack+1680,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+31466,int_stack+9536,int_stack+13964,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+11174,int_stack+31466,int_stack+21740,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+34274,int_stack+11174,int_stack+24116,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+19904,int_stack+34274,int_stack+27416,6);
 /*--- compute (d0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+39224,int_stack+19904,int_stack+15368,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+15134,int_stack+2856,int_stack+2226,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+25574,int_stack+15134,int_stack+9536,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+15134,int_stack+25574,int_stack+31466,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+25574,int_stack+15134,int_stack+11174,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+9536,int_stack+25574,int_stack+34274,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+25574,int_stack+9536,int_stack+19904,6);
 /*--- compute (d0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+9536,int_stack+25574,int_stack+39224,6);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17312,int_stack+3936,int_stack+3576,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18392,int_stack+4386,int_stack+3936,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+19742,int_stack+18392,int_stack+17312,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21902,int_stack+4936,int_stack+4386,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23552,int_stack+21902,int_stack+18392,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+26252,int_stack+23552,int_stack+19742,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17312,int_stack+5596,int_stack+4936,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+29852,int_stack+17312,int_stack+21902,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+33152,int_stack+29852,int_stack+23552,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+19292,int_stack+33152,int_stack+26252,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24692,int_stack+6376,int_stack+5596,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+37652,int_stack+24692,int_stack+17312,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+37652,int_stack+29852,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+41612,int_stack+0,int_stack+33152,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+27032,int_stack+41612,int_stack+19292,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+17312,int_stack+7286,int_stack+6376,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+48362,int_stack+17312,int_stack+24692,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+20042,int_stack+48362,int_stack+37652,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+53042,int_stack+20042,int_stack+0,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+61292,int_stack+53042,int_stack+41612,10);
 /*--- compute (f0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+34592,int_stack+61292,int_stack+27032,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+8336,int_stack+7286,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3150,int_stack+0,int_stack+17312,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+26642,int_stack+3150,int_stack+48362,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+70742,int_stack+26642,int_stack+20042,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+17312,int_stack+70742,int_stack+53042,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+44672,int_stack+17312,int_stack+61292,10);
 /*--- compute (f0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+17312,int_stack+44672,int_stack+34592,10);
 /*--- compute (dp|kk) ---*/
 hrr1_build_dp(Libint->AB,int_stack+30272,int_stack+17312,int_stack+9536,1296);
 return int_stack+30272;}
