/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dplh(Libint_t*, prim_data*);

  /* Computes quartets of (dp|lh) integrals */

REALTYPE *hrr_order_dplh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[2][11] = int_stack + 996;
 Libint->vrr_classes[2][12] = int_stack + 1464;
 Libint->vrr_classes[2][13] = int_stack + 2010;
 Libint->vrr_classes[3][8] = int_stack + 2640;
 Libint->vrr_classes[3][9] = int_stack + 3090;
 Libint->vrr_classes[3][10] = int_stack + 3640;
 Libint->vrr_classes[3][11] = int_stack + 4300;
 Libint->vrr_classes[3][12] = int_stack + 5080;
 Libint->vrr_classes[3][13] = int_stack + 5990;
 memset(int_stack,0,7040*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7040;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dplh(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7040,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7850,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+8840,int_stack+7850,int_stack+7040,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10460,int_stack+996,int_stack+600,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+11648,int_stack+10460,int_stack+7850,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+13628,int_stack+11648,int_stack+8840,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7040,int_stack+1464,int_stack+996,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+16328,int_stack+7040,int_stack+10460,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+18704,int_stack+16328,int_stack+11648,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+8444,int_stack+18704,int_stack+13628,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12494,int_stack+2010,int_stack+1464,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+22004,int_stack+12494,int_stack+7040,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24812,int_stack+22004,int_stack+16328,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12494,int_stack+24812,int_stack+18704,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+17444,int_stack+12494,int_stack+8444,6);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7040,int_stack+3090,int_stack+2640,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8390,int_stack+3640,int_stack+3090,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10040,int_stack+8390,int_stack+7040,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12740,int_stack+4300,int_stack+3640,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23114,int_stack+12740,int_stack+8390,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+26414,int_stack+23114,int_stack+10040,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7040,int_stack+5080,int_stack+4300,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+7040,int_stack+12740,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+9380,int_stack+0,int_stack+23114,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+30914,int_stack+9380,int_stack+26414,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23114,int_stack+5990,int_stack+5080,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+25844,int_stack+23114,int_stack+7040,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+37664,int_stack+25844,int_stack+0,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+37664,int_stack+9380,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+37664,int_stack+0,int_stack+30914,10);
 /*--- compute (dp|lh) ---*/
 hrr1_build_dp(Libint->AB,int_stack+0,int_stack+37664,int_stack+17444,945);
 return int_stack+0;}
