/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpli(Libint_t*, prim_data*);

  /* Computes quartets of (dp|li) integrals */

REALTYPE *hrr_order_dpli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[2][11] = int_stack + 996;
 Libint->vrr_classes[2][12] = int_stack + 1464;
 Libint->vrr_classes[2][13] = int_stack + 2010;
 Libint->vrr_classes[2][14] = int_stack + 2640;
 Libint->vrr_classes[3][8] = int_stack + 3360;
 Libint->vrr_classes[3][9] = int_stack + 3810;
 Libint->vrr_classes[3][10] = int_stack + 4360;
 Libint->vrr_classes[3][11] = int_stack + 5020;
 Libint->vrr_classes[3][12] = int_stack + 5800;
 Libint->vrr_classes[3][13] = int_stack + 6710;
 Libint->vrr_classes[3][14] = int_stack + 7760;
 memset(int_stack,0,8960*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8960;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpli(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8960,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9770,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10760,int_stack+9770,int_stack+8960,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12380,int_stack+996,int_stack+600,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13568,int_stack+12380,int_stack+9770,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+15548,int_stack+13568,int_stack+10760,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8960,int_stack+1464,int_stack+996,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+18248,int_stack+8960,int_stack+12380,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+20624,int_stack+18248,int_stack+13568,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+10364,int_stack+20624,int_stack+15548,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+14414,int_stack+2010,int_stack+1464,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+23924,int_stack+14414,int_stack+8960,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+26732,int_stack+23924,int_stack+18248,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+30692,int_stack+26732,int_stack+20624,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+16052,int_stack+30692,int_stack+10364,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+8960,int_stack+2640,int_stack+2010,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+10850,int_stack+8960,int_stack+14414,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+35642,int_stack+10850,int_stack+23924,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+8960,int_stack+35642,int_stack+26732,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+21722,int_stack+8960,int_stack+30692,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+28652,int_stack+21722,int_stack+16052,6);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8960,int_stack+3810,int_stack+3360,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10310,int_stack+4360,int_stack+3810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+11960,int_stack+10310,int_stack+8960,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14660,int_stack+5020,int_stack+4360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16640,int_stack+14660,int_stack+10310,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+19940,int_stack+16640,int_stack+11960,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8960,int_stack+5800,int_stack+5020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24440,int_stack+8960,int_stack+14660,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+24440,int_stack+16640,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+11300,int_stack+0,int_stack+19940,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+18050,int_stack+6710,int_stack+5800,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+36212,int_stack+18050,int_stack+8960,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+40892,int_stack+36212,int_stack+24440,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+47492,int_stack+40892,int_stack+0,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+55742,int_stack+47492,int_stack+11300,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+7760,int_stack+6710,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3150,int_stack+0,int_stack+18050,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+8610,int_stack+3150,int_stack+36212,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+16410,int_stack+8610,int_stack+40892,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+16410,int_stack+47492,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+36212,int_stack+0,int_stack+55742,10);
 /*--- compute (dp|li) ---*/
 hrr1_build_dp(Libint->AB,int_stack+0,int_stack+36212,int_stack+28652,1260);
 return int_stack+0;}
