/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpmk(Libint_t*, prim_data*);

  /* Computes quartets of (dp|mk) integrals */

REALTYPE *hrr_order_dpmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[2][14] = int_stack + 2370;
 Libint->vrr_classes[2][15] = int_stack + 3090;
 Libint->vrr_classes[2][16] = int_stack + 3906;
 Libint->vrr_classes[3][9] = int_stack + 4824;
 Libint->vrr_classes[3][10] = int_stack + 5374;
 Libint->vrr_classes[3][11] = int_stack + 6034;
 Libint->vrr_classes[3][12] = int_stack + 6814;
 Libint->vrr_classes[3][13] = int_stack + 7724;
 Libint->vrr_classes[3][14] = int_stack + 8774;
 Libint->vrr_classes[3][15] = int_stack + 9974;
 Libint->vrr_classes[3][16] = int_stack + 11334;
 memset(int_stack,0,12864*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12864;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpmk(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12864,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13854,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+15042,int_stack+13854,int_stack+12864,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+17022,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+18426,int_stack+17022,int_stack+13854,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+20802,int_stack+18426,int_stack+15042,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12864,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+24102,int_stack+12864,int_stack+17022,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+26910,int_stack+24102,int_stack+18426,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+14502,int_stack+26910,int_stack+20802,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+19452,int_stack+2370,int_stack+1740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+30870,int_stack+19452,int_stack+12864,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+34146,int_stack+30870,int_stack+24102,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+38826,int_stack+34146,int_stack+26910,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+21342,int_stack+38826,int_stack+14502,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+12864,int_stack+3090,int_stack+2370,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+15024,int_stack+12864,int_stack+19452,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+44766,int_stack+15024,int_stack+30870,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+50226,int_stack+44766,int_stack+34146,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+28272,int_stack+50226,int_stack+38826,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+57246,int_stack+28272,int_stack+21342,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+18804,int_stack+3906,int_stack+3090,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+21252,int_stack+18804,int_stack+12864,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+36588,int_stack+21252,int_stack+15024,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+12864,int_stack+36588,int_stack+44766,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+36588,int_stack+12864,int_stack+50226,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+12864,int_stack+36588,int_stack+28272,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+23952,int_stack+12864,int_stack+57246,6);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12864,int_stack+5374,int_stack+4824,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14514,int_stack+6034,int_stack+5374,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16494,int_stack+14514,int_stack+12864,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19794,int_stack+6814,int_stack+6034,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35832,int_stack+19794,int_stack+14514,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+39792,int_stack+35832,int_stack+16494,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12864,int_stack+7724,int_stack+6814,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+45292,int_stack+12864,int_stack+19794,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+15594,int_stack+45292,int_stack+35832,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+49972,int_stack+15594,int_stack+39792,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35832,int_stack+8774,int_stack+7724,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+38982,int_stack+35832,int_stack+12864,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+58222,int_stack+38982,int_stack+45292,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+66022,int_stack+58222,int_stack+15594,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+75922,int_stack+66022,int_stack+49972,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+12864,int_stack+9974,int_stack+8774,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+16464,int_stack+12864,int_stack+35832,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+44442,int_stack+16464,int_stack+38982,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+87472,int_stack+44442,int_stack+58222,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+99172,int_stack+87472,int_stack+66022,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+53542,int_stack+99172,int_stack+75922,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+35832,int_stack+11334,int_stack+9974,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+68942,int_stack+35832,int_stack+12864,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+76142,int_stack+68942,int_stack+16464,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+76142,int_stack+44442,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+68942,int_stack+0,int_stack+87472,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+68942,int_stack+99172,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+68942,int_stack+0,int_stack+53542,10);
 /*--- compute (dp|mk) ---*/
 hrr1_build_dp(Libint->AB,int_stack+88742,int_stack+68942,int_stack+23952,1980);
 return int_stack+88742;}
