/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdnh(Libint_t*, prim_data*);

  /* Computes quartets of (fd|nh) integrals */

REALTYPE *hrr_order_fdnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[4][10] = int_stack + 5960;
 Libint->vrr_classes[4][11] = int_stack + 6950;
 Libint->vrr_classes[4][12] = int_stack + 8120;
 Libint->vrr_classes[4][13] = int_stack + 9485;
 Libint->vrr_classes[4][14] = int_stack + 11060;
 Libint->vrr_classes[4][15] = int_stack + 12860;
 Libint->vrr_classes[5][10] = int_stack + 14900;
 Libint->vrr_classes[5][11] = int_stack + 16286;
 Libint->vrr_classes[5][12] = int_stack + 17924;
 Libint->vrr_classes[5][13] = int_stack + 19835;
 Libint->vrr_classes[5][14] = int_stack + 22040;
 Libint->vrr_classes[5][15] = int_stack + 24560;
 memset(int_stack,0,27416*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27416;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdnh(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27416,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29396,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+31736,int_stack+29396,int_stack+27416,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+35696,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+38426,int_stack+35696,int_stack+29396,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+43106,int_stack+38426,int_stack+31736,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27416,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+49706,int_stack+27416,int_stack+35696,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+30566,int_stack+49706,int_stack+38426,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+55166,int_stack+30566,int_stack+43106,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+38366,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+41966,int_stack+38366,int_stack+27416,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65066,int_stack+41966,int_stack+49706,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+38366,int_stack+65066,int_stack+30566,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+65066,int_stack+38366,int_stack+55166,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27416,int_stack+6950,int_stack+5960,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30386,int_stack+8120,int_stack+6950,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33896,int_stack+30386,int_stack+27416,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+39836,int_stack+9485,int_stack+8120,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+43931,int_stack+39836,int_stack+30386,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+50951,int_stack+43931,int_stack+33896,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27416,int_stack+11060,int_stack+9485,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+27416,int_stack+39836,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+32141,int_stack+0,int_stack+43931,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+78926,int_stack+32141,int_stack+50951,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+43841,int_stack+12860,int_stack+11060,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49241,int_stack+43841,int_stack+27416,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+93776,int_stack+49241,int_stack+0,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+43841,int_stack+93776,int_stack+32141,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+93776,int_stack+43841,int_stack+78926,15);
 /*--- compute (fp|nh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+114566,int_stack+93776,int_stack+65066,1386);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+16286,int_stack+14900,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4158,int_stack+17924,int_stack+16286,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+9072,int_stack+4158,int_stack+0,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+27416,int_stack+19835,int_stack+17924,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+33149,int_stack+27416,int_stack+4158,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42977,int_stack+33149,int_stack+9072,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+22040,int_stack+19835,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6615,int_stack+0,int_stack+27416,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+56837,int_stack+6615,int_stack+33149,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+156146,int_stack+56837,int_stack+42977,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+27416,int_stack+24560,int_stack+22040,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+34976,int_stack+27416,int_stack+0,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+73217,int_stack+34976,int_stack+6615,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+73217,int_stack+56837,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+24570,int_stack+0,int_stack+156146,21);
 /*--- compute (gp|nh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+156146,int_stack+24570,int_stack+93776,1386);
 /*--- compute (fd|nh) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+156146,int_stack+114566,1386);
 return int_stack+0;}
