/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpii(Libint_t*, prim_data*);

  /* Computes quartets of (fp|ii) integrals */

REALTYPE *hrr_order_fpii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[3][7] = int_stack + 280;
 Libint->vrr_classes[3][8] = int_stack + 640;
 Libint->vrr_classes[3][9] = int_stack + 1090;
 Libint->vrr_classes[3][10] = int_stack + 1640;
 Libint->vrr_classes[3][11] = int_stack + 2300;
 Libint->vrr_classes[3][12] = int_stack + 3080;
 Libint->vrr_classes[4][6] = int_stack + 3990;
 Libint->vrr_classes[4][7] = int_stack + 4410;
 Libint->vrr_classes[4][8] = int_stack + 4950;
 Libint->vrr_classes[4][9] = int_stack + 5625;
 Libint->vrr_classes[4][10] = int_stack + 6450;
 Libint->vrr_classes[4][11] = int_stack + 7440;
 Libint->vrr_classes[4][12] = int_stack + 8610;
 memset(int_stack,0,9975*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9975;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpii(Libint, Data);
   Data++;
 }
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9975,int_stack+280,int_stack+0,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10815,int_stack+640,int_stack+280,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+11895,int_stack+10815,int_stack+9975,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13575,int_stack+1090,int_stack+640,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+14925,int_stack+13575,int_stack+10815,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+17085,int_stack+14925,int_stack+11895,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9975,int_stack+1640,int_stack+1090,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19885,int_stack+9975,int_stack+13575,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+22585,int_stack+19885,int_stack+14925,10);
 /*--- compute (f0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+11625,int_stack+22585,int_stack+17085,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15825,int_stack+2300,int_stack+1640,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+26185,int_stack+15825,int_stack+9975,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+29485,int_stack+26185,int_stack+19885,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+33985,int_stack+29485,int_stack+22585,10);
 /*--- compute (f0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+17805,int_stack+33985,int_stack+11625,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+9975,int_stack+3080,int_stack+2300,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+9975,int_stack+15825,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+9975,int_stack+0,int_stack+26185,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+39385,int_stack+9975,int_stack+29485,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+9975,int_stack+39385,int_stack+33985,10);
 /*--- compute (f0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+23685,int_stack+9975,int_stack+17805,10);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9975,int_stack+4410,int_stack+3990,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11235,int_stack+4950,int_stack+4410,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+12855,int_stack+11235,int_stack+9975,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15375,int_stack+5625,int_stack+4950,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+17400,int_stack+15375,int_stack+11235,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+17400,int_stack+12855,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9975,int_stack+6450,int_stack+5625,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31525,int_stack+9975,int_stack+15375,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+35575,int_stack+31525,int_stack+17400,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+12450,int_stack+35575,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+7440,int_stack+6450,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+40975,int_stack+0,int_stack+9975,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+45925,int_stack+40975,int_stack+31525,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+52675,int_stack+45925,int_stack+35575,15);
 /*--- compute (g0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+31525,int_stack+52675,int_stack+12450,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+9975,int_stack+8610,int_stack+7440,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+13485,int_stack+9975,int_stack+0,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+13485,int_stack+40975,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+8250,int_stack+0,int_stack+45925,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+40345,int_stack+8250,int_stack+52675,15);
 /*--- compute (g0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+0,int_stack+40345,int_stack+31525,15);
 /*--- compute (fp|ii) ---*/
 hrr1_build_fp(Libint->AB,int_stack+31525,int_stack+0,int_stack+23685,784);
 return int_stack+31525;}
