/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpmh(Libint_t*, prim_data*);

  /* Computes quartets of (fp|mh) integrals */

REALTYPE *hrr_order_fpmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[4][9] = int_stack + 5150;
 Libint->vrr_classes[4][10] = int_stack + 5975;
 Libint->vrr_classes[4][11] = int_stack + 6965;
 Libint->vrr_classes[4][12] = int_stack + 8135;
 Libint->vrr_classes[4][13] = int_stack + 9500;
 Libint->vrr_classes[4][14] = int_stack + 11075;
 memset(int_stack,0,12875*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12875;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpmh(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12875,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14525,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16505,int_stack+14525,int_stack+12875,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19805,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+22145,int_stack+19805,int_stack+14525,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26105,int_stack+22145,int_stack+16505,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12875,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+31605,int_stack+12875,int_stack+19805,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+36285,int_stack+31605,int_stack+22145,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+15605,int_stack+36285,int_stack+26105,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+23855,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+42885,int_stack+23855,int_stack+12875,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48345,int_stack+42885,int_stack+31605,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+23855,int_stack+48345,int_stack+36285,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+33755,int_stack+23855,int_stack+15605,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12875,int_stack+5975,int_stack+5150,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15350,int_stack+6965,int_stack+5975,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+18320,int_stack+15350,int_stack+12875,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23270,int_stack+8135,int_stack+6965,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+26780,int_stack+23270,int_stack+15350,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+45305,int_stack+26780,int_stack+18320,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12875,int_stack+9500,int_stack+8135,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+12875,int_stack+23270,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+53555,int_stack+0,int_stack+26780,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+16970,int_stack+53555,int_stack+45305,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+45305,int_stack+11075,int_stack+9500,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+63455,int_stack+45305,int_stack+12875,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+71645,int_stack+63455,int_stack+0,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+71645,int_stack+53555,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+45305,int_stack+0,int_stack+16970,15);
 /*--- compute (fp|mh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+62630,int_stack+45305,int_stack+33755,1155);
 return int_stack+62630;}
