/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdll(Libint_t*, prim_data*);

  /* Computes quartets of (gd|ll) integrals */

REALTYPE *hrr_order_gdll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[4][15] = int_stack + 8400;
 Libint->vrr_classes[4][16] = int_stack + 10440;
 Libint->vrr_classes[5][8] = int_stack + 12735;
 Libint->vrr_classes[5][9] = int_stack + 13680;
 Libint->vrr_classes[5][10] = int_stack + 14835;
 Libint->vrr_classes[5][11] = int_stack + 16221;
 Libint->vrr_classes[5][12] = int_stack + 17859;
 Libint->vrr_classes[5][13] = int_stack + 19770;
 Libint->vrr_classes[5][14] = int_stack + 21975;
 Libint->vrr_classes[5][15] = int_stack + 24495;
 Libint->vrr_classes[5][16] = int_stack + 27351;
 Libint->vrr_classes[6][8] = int_stack + 30564;
 Libint->vrr_classes[6][9] = int_stack + 31824;
 Libint->vrr_classes[6][10] = int_stack + 33364;
 Libint->vrr_classes[6][11] = int_stack + 35212;
 Libint->vrr_classes[6][12] = int_stack + 37396;
 Libint->vrr_classes[6][13] = int_stack + 39944;
 Libint->vrr_classes[6][14] = int_stack + 42884;
 Libint->vrr_classes[6][15] = int_stack + 46244;
 Libint->vrr_classes[6][16] = int_stack + 50052;
 memset(int_stack,0,54336*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 54336;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdll(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54336,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+56361,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+58836,int_stack+56361,int_stack+54336,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62886,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+65856,int_stack+62886,int_stack+56361,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+70806,int_stack+65856,int_stack+58836,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54336,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+77556,int_stack+54336,int_stack+62886,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+83496,int_stack+77556,int_stack+65856,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+57846,int_stack+83496,int_stack+70806,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+67971,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+91746,int_stack+67971,int_stack+54336,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+98766,int_stack+91746,int_stack+77556,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+108666,int_stack+98766,int_stack+83496,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+72066,int_stack+108666,int_stack+57846,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+54336,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+59061,int_stack+54336,int_stack+67971,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+121041,int_stack+59061,int_stack+91746,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+132741,int_stack+121041,int_stack+98766,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+86241,int_stack+132741,int_stack+108666,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+147591,int_stack+86241,int_stack+72066,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+67251,int_stack+8400,int_stack+6600,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+72651,int_stack+67251,int_stack+54336,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+103566,int_stack+72651,int_stack+59061,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+166491,int_stack+103566,int_stack+121041,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+184041,int_stack+166491,int_stack+132741,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+117216,int_stack+184041,int_stack+86241,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+204831,int_stack+117216,int_stack+147591,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+54336,int_stack+10440,int_stack+8400,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+82101,int_stack+54336,int_stack+67251,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+54336,int_stack+82101,int_stack+72651,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+70086,int_stack+54336,int_stack+103566,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+90561,int_stack+70086,int_stack+166491,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+54336,int_stack+90561,int_stack+184041,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+82056,int_stack+54336,int_stack+117216,15);
 /*--- compute (g0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+111756,int_stack+82056,int_stack+204831,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54336,int_stack+13680,int_stack+12735,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57171,int_stack+14835,int_stack+13680,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60636,int_stack+57171,int_stack+54336,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+66306,int_stack+16221,int_stack+14835,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+70464,int_stack+66306,int_stack+57171,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+77394,int_stack+70464,int_stack+60636,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54336,int_stack+17859,int_stack+16221,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+86844,int_stack+54336,int_stack+66306,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+95160,int_stack+86844,int_stack+70464,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+59250,int_stack+95160,int_stack+77394,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73425,int_stack+19770,int_stack+17859,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+142131,int_stack+73425,int_stack+54336,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+151959,int_stack+142131,int_stack+86844,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+165819,int_stack+151959,int_stack+95160,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+79158,int_stack+165819,int_stack+59250,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+54336,int_stack+21975,int_stack+19770,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+60951,int_stack+54336,int_stack+73425,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+183144,int_stack+60951,int_stack+142131,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+199524,int_stack+183144,int_stack+151959,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+220314,int_stack+199524,int_stack+165819,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+142131,int_stack+220314,int_stack+79158,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+168591,int_stack+24495,int_stack+21975,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+72417,int_stack+168591,int_stack+54336,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+85647,int_stack+72417,int_stack+60951,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+244569,int_stack+85647,int_stack+183144,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+269139,int_stack+244569,int_stack+199524,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+176151,int_stack+269139,int_stack+220314,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+208491,int_stack+176151,int_stack+142131,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+142131,int_stack+27351,int_stack+24495,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+150699,int_stack+142131,int_stack+168591,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+150699,int_stack+72417,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+142131,int_stack+0,int_stack+85647,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+54336,int_stack+142131,int_stack+244569,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+298245,int_stack+54336,int_stack+269139,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+54336,int_stack+298245,int_stack+176151,21);
 /*--- compute (h0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+142131,int_stack+54336,int_stack+208491,21);
 /*--- compute (gp|ll) ---*/
 hrr1_build_gp(Libint->AB,int_stack+184656,int_stack+142131,int_stack+111756,2025);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54336,int_stack+31824,int_stack+30564,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58116,int_stack+33364,int_stack+31824,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+62736,int_stack+58116,int_stack+54336,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+70296,int_stack+35212,int_stack+33364,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75840,int_stack+70296,int_stack+58116,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85080,int_stack+75840,int_stack+62736,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54336,int_stack+37396,int_stack+35212,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97680,int_stack+54336,int_stack+70296,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+108768,int_stack+97680,int_stack+75840,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+60888,int_stack+108768,int_stack+85080,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+79788,int_stack+39944,int_stack+37396,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+124168,int_stack+79788,int_stack+54336,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+275781,int_stack+124168,int_stack+97680,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+294261,int_stack+275781,int_stack+108768,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+87432,int_stack+294261,int_stack+60888,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+54336,int_stack+42884,int_stack+39944,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+63156,int_stack+54336,int_stack+79788,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+63156,int_stack+124168,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+113892,int_stack+0,int_stack+275781,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+317361,int_stack+113892,int_stack+294261,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+275781,int_stack+317361,int_stack+87432,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+78444,int_stack+46244,int_stack+42884,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+88524,int_stack+78444,int_stack+54336,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+349701,int_stack+88524,int_stack+63156,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+375181,int_stack+349701,int_stack+0,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+375181,int_stack+113892,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+407941,int_stack+0,int_stack+317361,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+451061,int_stack+407941,int_stack+275781,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+275781,int_stack+50052,int_stack+46244,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+287205,int_stack+275781,int_stack+78444,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+307365,int_stack+287205,int_stack+88524,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+38808,int_stack+307365,int_stack+349701,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+275781,int_stack+38808,int_stack+375181,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+38808,int_stack+275781,int_stack+0,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+275781,int_stack+38808,int_stack+407941,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+275781,int_stack+451061,28);
 /*--- compute (hp|ll) ---*/
 hrr1_build_hp(Libint->AB,int_stack+275781,int_stack+0,int_stack+142131,2025);
 /*--- compute (gd|ll) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+275781,int_stack+184656,2025);
 return int_stack+0;}
