/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdmi(Libint_t*, prim_data*);

  /* Computes quartets of (gd|mi) integrals */

REALTYPE *hrr_order_gdmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[4][15] = int_stack + 7725;
 Libint->vrr_classes[5][9] = int_stack + 9765;
 Libint->vrr_classes[5][10] = int_stack + 10920;
 Libint->vrr_classes[5][11] = int_stack + 12306;
 Libint->vrr_classes[5][12] = int_stack + 13944;
 Libint->vrr_classes[5][13] = int_stack + 15855;
 Libint->vrr_classes[5][14] = int_stack + 18060;
 Libint->vrr_classes[5][15] = int_stack + 20580;
 Libint->vrr_classes[6][9] = int_stack + 23436;
 Libint->vrr_classes[6][10] = int_stack + 24976;
 Libint->vrr_classes[6][11] = int_stack + 26824;
 Libint->vrr_classes[6][12] = int_stack + 29008;
 Libint->vrr_classes[6][13] = int_stack + 31556;
 Libint->vrr_classes[6][14] = int_stack + 34496;
 Libint->vrr_classes[6][15] = int_stack + 37856;
 memset(int_stack,0,41664*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 41664;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdmi(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41664,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44139,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+47109,int_stack+44139,int_stack+41664,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+52059,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+55569,int_stack+52059,int_stack+44139,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61509,int_stack+55569,int_stack+47109,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+41664,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+69759,int_stack+41664,int_stack+52059,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+76779,int_stack+69759,int_stack+55569,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+45759,int_stack+76779,int_stack+61509,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+58134,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+86679,int_stack+58134,int_stack+41664,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+94869,int_stack+86679,int_stack+69759,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+106569,int_stack+94869,int_stack+76779,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+62859,int_stack+106569,int_stack+45759,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+41664,int_stack+7725,int_stack+5925,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+47064,int_stack+41664,int_stack+58134,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+121419,int_stack+47064,int_stack+86679,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+41664,int_stack+121419,int_stack+94869,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+80184,int_stack+41664,int_stack+106569,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+100974,int_stack+80184,int_stack+62859,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41664,int_stack+10920,int_stack+9765,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45129,int_stack+12306,int_stack+10920,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49287,int_stack+45129,int_stack+41664,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56217,int_stack+13944,int_stack+12306,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+61131,int_stack+56217,int_stack+45129,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+69447,int_stack+61131,int_stack+49287,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+41664,int_stack+15855,int_stack+13944,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+80997,int_stack+41664,int_stack+56217,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+80997,int_stack+61131,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+47397,int_stack+0,int_stack+69447,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+64722,int_stack+18060,int_stack+15855,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+124074,int_stack+64722,int_stack+41664,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+135540,int_stack+124074,int_stack+80997,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+71337,int_stack+135540,int_stack+0,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+151920,int_stack+71337,int_stack+47397,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+20580,int_stack+18060,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+7560,int_stack+0,int_stack+64722,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+41664,int_stack+7560,int_stack+124074,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+176175,int_stack+41664,int_stack+135540,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+41664,int_stack+176175,int_stack+71337,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+176175,int_stack+41664,int_stack+151920,21);
 /*--- compute (gp|mi) ---*/
 hrr1_build_gp(Libint->AB,int_stack+208515,int_stack+176175,int_stack+100974,1540);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41664,int_stack+24976,int_stack+23436,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46284,int_stack+26824,int_stack+24976,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+51828,int_stack+46284,int_stack+41664,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61068,int_stack+29008,int_stack+26824,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+67620,int_stack+61068,int_stack+46284,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+78708,int_stack+67620,int_stack+51828,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+41664,int_stack+31556,int_stack+29008,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+94108,int_stack+41664,int_stack+61068,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+107212,int_stack+94108,int_stack+67620,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+49308,int_stack+107212,int_stack+78708,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+72408,int_stack+34496,int_stack+31556,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+125692,int_stack+72408,int_stack+41664,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+140980,int_stack+125692,int_stack+94108,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+140980,int_stack+107212,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+81228,int_stack+0,int_stack+49308,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+41664,int_stack+37856,int_stack+34496,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+51744,int_stack+41664,int_stack+72408,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+277815,int_stack+51744,int_stack+125692,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+27720,int_stack+277815,int_stack+140980,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+113568,int_stack+27720,int_stack+0,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+113568,int_stack+81228,28);
 /*--- compute (hp|mi) ---*/
 hrr1_build_hp(Libint->AB,int_stack+43120,int_stack+0,int_stack+176175,1540);
 /*--- compute (gd|mi) ---*/
 hrr1_build_gd(Libint->AB,int_stack+277815,int_stack+43120,int_stack+208515,1540);
 return int_stack+277815;}
