/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggli(Libint_t*, prim_data*);

  /* Computes quartets of (gg|li) integrals */

REALTYPE *hrr_order_ggli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[5][8] = int_stack + 8400;
 Libint->vrr_classes[5][9] = int_stack + 9345;
 Libint->vrr_classes[5][10] = int_stack + 10500;
 Libint->vrr_classes[5][11] = int_stack + 11886;
 Libint->vrr_classes[5][12] = int_stack + 13524;
 Libint->vrr_classes[5][13] = int_stack + 15435;
 Libint->vrr_classes[5][14] = int_stack + 17640;
 Libint->vrr_classes[6][8] = int_stack + 20160;
 Libint->vrr_classes[6][9] = int_stack + 21420;
 Libint->vrr_classes[6][10] = int_stack + 22960;
 Libint->vrr_classes[6][11] = int_stack + 24808;
 Libint->vrr_classes[6][12] = int_stack + 26992;
 Libint->vrr_classes[6][13] = int_stack + 29540;
 Libint->vrr_classes[6][14] = int_stack + 32480;
 Libint->vrr_classes[7][8] = int_stack + 35840;
 Libint->vrr_classes[7][9] = int_stack + 37460;
 Libint->vrr_classes[7][10] = int_stack + 39440;
 Libint->vrr_classes[7][11] = int_stack + 41816;
 Libint->vrr_classes[7][12] = int_stack + 44624;
 Libint->vrr_classes[7][13] = int_stack + 47900;
 Libint->vrr_classes[7][14] = int_stack + 51680;
 Libint->vrr_classes[8][8] = int_stack + 56000;
 Libint->vrr_classes[8][9] = int_stack + 58025;
 Libint->vrr_classes[8][10] = int_stack + 60500;
 Libint->vrr_classes[8][11] = int_stack + 63470;
 Libint->vrr_classes[8][12] = int_stack + 66980;
 Libint->vrr_classes[8][13] = int_stack + 71075;
 Libint->vrr_classes[8][14] = int_stack + 75800;
 memset(int_stack,0,81200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 81200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggli(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81200,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+83225,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+85700,int_stack+83225,int_stack+81200,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+89750,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92720,int_stack+89750,int_stack+83225,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+97670,int_stack+92720,int_stack+85700,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81200,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+104420,int_stack+81200,int_stack+89750,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+110360,int_stack+104420,int_stack+92720,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+84710,int_stack+110360,int_stack+97670,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+94835,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+118610,int_stack+94835,int_stack+81200,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+125630,int_stack+118610,int_stack+104420,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+135530,int_stack+125630,int_stack+110360,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+98930,int_stack+135530,int_stack+84710,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+81200,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+85925,int_stack+81200,int_stack+94835,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+147905,int_stack+85925,int_stack+118610,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+81200,int_stack+147905,int_stack+125630,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+113105,int_stack+81200,int_stack+135530,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+130430,int_stack+113105,int_stack+98930,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81200,int_stack+9345,int_stack+8400,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+84035,int_stack+10500,int_stack+9345,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+87500,int_stack+84035,int_stack+81200,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+93170,int_stack+11886,int_stack+10500,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+97328,int_stack+93170,int_stack+84035,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+104258,int_stack+97328,int_stack+87500,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81200,int_stack+13524,int_stack+11886,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113708,int_stack+81200,int_stack+93170,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+113708,int_stack+97328,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+86114,int_stack+0,int_stack+104258,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+100289,int_stack+15435,int_stack+13524,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149330,int_stack+100289,int_stack+81200,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+159158,int_stack+149330,int_stack+113708,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+106022,int_stack+159158,int_stack+0,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+173018,int_stack+106022,int_stack+86114,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+17640,int_stack+15435,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6615,int_stack+0,int_stack+100289,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+81200,int_stack+6615,int_stack+149330,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+192863,int_stack+81200,int_stack+159158,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+81200,int_stack+192863,int_stack+106022,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+192863,int_stack+81200,int_stack+173018,21);
 /*--- compute (gp|li) ---*/
 hrr1_build_gp(Libint->AB,int_stack+219323,int_stack+192863,int_stack+130430,1260);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81200,int_stack+21420,int_stack+20160,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+84980,int_stack+22960,int_stack+21420,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+89600,int_stack+84980,int_stack+81200,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+97160,int_stack+24808,int_stack+22960,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+102704,int_stack+97160,int_stack+84980,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+111944,int_stack+102704,int_stack+89600,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81200,int_stack+26992,int_stack+24808,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+124544,int_stack+81200,int_stack+97160,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+135632,int_stack+124544,int_stack+102704,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+87752,int_stack+135632,int_stack+111944,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+106652,int_stack+29540,int_stack+26992,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+151032,int_stack+106652,int_stack+81200,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164136,int_stack+151032,int_stack+124544,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+164136,int_stack+135632,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+114296,int_stack+0,int_stack+87752,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+81200,int_stack+32480,int_stack+29540,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+90020,int_stack+81200,int_stack+106652,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+276023,int_stack+90020,int_stack+151032,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+81200,int_stack+276023,int_stack+164136,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+140756,int_stack+81200,int_stack+0,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+140756,int_stack+114296,28);
 /*--- compute (hp|li) ---*/
 hrr1_build_hp(Libint->AB,int_stack+81200,int_stack+0,int_stack+192863,1260);
 /*--- compute (gd|li) ---*/
 hrr1_build_gd(Libint->AB,int_stack+276023,int_stack+81200,int_stack+219323,1260);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+160580,int_stack+37460,int_stack+35840,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+165440,int_stack+39440,int_stack+37460,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+171380,int_stack+165440,int_stack+160580,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181100,int_stack+41816,int_stack+39440,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+188228,int_stack+181100,int_stack+165440,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+200108,int_stack+188228,int_stack+171380,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+160580,int_stack+44624,int_stack+41816,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+216308,int_stack+160580,int_stack+181100,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+230564,int_stack+216308,int_stack+188228,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+169004,int_stack+230564,int_stack+200108,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+193304,int_stack+47900,int_stack+44624,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+250364,int_stack+193304,int_stack+160580,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+389423,int_stack+250364,int_stack+216308,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+413183,int_stack+389423,int_stack+230564,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+203132,int_stack+413183,int_stack+169004,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+160580,int_stack+51680,int_stack+47900,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+171920,int_stack+160580,int_stack+193304,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+442883,int_stack+171920,int_stack+250364,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+160580,int_stack+442883,int_stack+389423,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+442883,int_stack+160580,int_stack+413183,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+389423,int_stack+442883,int_stack+203132,36);
 /*--- compute (ip|li) ---*/
 hrr1_build_ip(Libint->AB,int_stack+160580,int_stack+389423,int_stack+0,1260);
 /*--- compute (hd|li) ---*/
 hrr1_build_hd(Libint->AB,int_stack+434783,int_stack+160580,int_stack+81200,1260);
 /*--- compute (gf|li) ---*/
 hrr1_build_gf(Libint->AB,int_stack+593543,int_stack+434783,int_stack+276023,1260);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81200,int_stack+58025,int_stack+56000,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+87275,int_stack+60500,int_stack+58025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+94700,int_stack+87275,int_stack+81200,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+106850,int_stack+63470,int_stack+60500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+115760,int_stack+106850,int_stack+87275,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+130610,int_stack+115760,int_stack+94700,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81200,int_stack+66980,int_stack+63470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+81200,int_stack+106850,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+17820,int_stack+0,int_stack+115760,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+91730,int_stack+17820,int_stack+130610,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+122105,int_stack+71075,int_stack+66980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+134390,int_stack+122105,int_stack+81200,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+266420,int_stack+134390,int_stack+0,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+296120,int_stack+266420,int_stack+17820,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+296120,int_stack+91730,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+42525,int_stack+75800,int_stack+71075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+56700,int_stack+42525,int_stack+122105,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+81270,int_stack+56700,int_stack+134390,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333245,int_stack+81270,int_stack+266420,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+42525,int_stack+333245,int_stack+296120,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+266420,int_stack+42525,int_stack+0,45);
 /*--- compute (kp|li) ---*/
 hrr1_build_kp(Libint->AB,int_stack+0,int_stack+266420,int_stack+389423,1260);
 /*--- compute (id|li) ---*/
 hrr1_build_id(Libint->AB,int_stack+782543,int_stack+0,int_stack+160580,1260);
 /*--- compute (hf|li) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+782543,int_stack+434783,1260);
 /*--- compute (gg|li) ---*/
 hrr1_build_gg(Libint->AB,int_stack+264600,int_stack+0,int_stack+593543,1260);
 return int_stack+264600;}
