/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggnn(Libint_t*, prim_data*);

  /* Computes quartets of (gg|nn) integrals */

REALTYPE *hrr_order_ggnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[4][18] = int_stack + 13800;
 Libint->vrr_classes[4][19] = int_stack + 16650;
 Libint->vrr_classes[4][20] = int_stack + 19800;
 Libint->vrr_classes[5][10] = int_stack + 23265;
 Libint->vrr_classes[5][11] = int_stack + 24651;
 Libint->vrr_classes[5][12] = int_stack + 26289;
 Libint->vrr_classes[5][13] = int_stack + 28200;
 Libint->vrr_classes[5][14] = int_stack + 30405;
 Libint->vrr_classes[5][15] = int_stack + 32925;
 Libint->vrr_classes[5][16] = int_stack + 35781;
 Libint->vrr_classes[5][17] = int_stack + 38994;
 Libint->vrr_classes[5][18] = int_stack + 42585;
 Libint->vrr_classes[5][19] = int_stack + 46575;
 Libint->vrr_classes[5][20] = int_stack + 50985;
 Libint->vrr_classes[6][10] = int_stack + 55836;
 Libint->vrr_classes[6][11] = int_stack + 57684;
 Libint->vrr_classes[6][12] = int_stack + 59868;
 Libint->vrr_classes[6][13] = int_stack + 62416;
 Libint->vrr_classes[6][14] = int_stack + 65356;
 Libint->vrr_classes[6][15] = int_stack + 68716;
 Libint->vrr_classes[6][16] = int_stack + 72524;
 Libint->vrr_classes[6][17] = int_stack + 76808;
 Libint->vrr_classes[6][18] = int_stack + 81596;
 Libint->vrr_classes[6][19] = int_stack + 86916;
 Libint->vrr_classes[6][20] = int_stack + 92796;
 Libint->vrr_classes[7][10] = int_stack + 99264;
 Libint->vrr_classes[7][11] = int_stack + 101640;
 Libint->vrr_classes[7][12] = int_stack + 104448;
 Libint->vrr_classes[7][13] = int_stack + 107724;
 Libint->vrr_classes[7][14] = int_stack + 111504;
 Libint->vrr_classes[7][15] = int_stack + 115824;
 Libint->vrr_classes[7][16] = int_stack + 120720;
 Libint->vrr_classes[7][17] = int_stack + 126228;
 Libint->vrr_classes[7][18] = int_stack + 132384;
 Libint->vrr_classes[7][19] = int_stack + 139224;
 Libint->vrr_classes[7][20] = int_stack + 146784;
 Libint->vrr_classes[8][10] = int_stack + 155100;
 Libint->vrr_classes[8][11] = int_stack + 158070;
 Libint->vrr_classes[8][12] = int_stack + 161580;
 Libint->vrr_classes[8][13] = int_stack + 165675;
 Libint->vrr_classes[8][14] = int_stack + 170400;
 Libint->vrr_classes[8][15] = int_stack + 175800;
 Libint->vrr_classes[8][16] = int_stack + 181920;
 Libint->vrr_classes[8][17] = int_stack + 188805;
 Libint->vrr_classes[8][18] = int_stack + 196500;
 Libint->vrr_classes[8][19] = int_stack + 205050;
 Libint->vrr_classes[8][20] = int_stack + 214500;
 memset(int_stack,0,224895*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 224895;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggnn(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+224895,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+227865,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+231375,int_stack+227865,int_stack+224895,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+237315,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+241410,int_stack+237315,int_stack+227865,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+248430,int_stack+241410,int_stack+231375,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+224895,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+258330,int_stack+224895,int_stack+237315,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+229620,int_stack+258330,int_stack+241410,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+266520,int_stack+229620,int_stack+248430,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+241320,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+246720,int_stack+241320,int_stack+224895,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+281370,int_stack+246720,int_stack+258330,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+295020,int_stack+281370,int_stack+229620,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+312570,int_stack+295020,int_stack+266520,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+224895,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+256170,int_stack+224895,int_stack+241320,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+333360,int_stack+256170,int_stack+246720,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+231015,int_stack+333360,int_stack+281370,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+266970,int_stack+231015,int_stack+295020,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+349110,int_stack+266970,int_stack+312570,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+291540,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+298425,int_stack+291540,int_stack+224895,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+310665,int_stack+298425,int_stack+256170,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+376830,int_stack+310665,int_stack+333360,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+400455,int_stack+376830,int_stack+231015,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+224895,int_stack+400455,int_stack+266970,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+429120,int_stack+224895,int_stack+349110,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+257655,int_stack+13800,int_stack+11235,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+265350,int_stack+257655,int_stack+291540,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+328665,int_stack+265350,int_stack+298425,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+279120,int_stack+328665,int_stack+310665,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+464760,int_stack+279120,int_stack+376830,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+349065,int_stack+464760,int_stack+400455,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+497835,int_stack+349065,int_stack+224895,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+539955,int_stack+497835,int_stack+429120,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+224895,int_stack+16650,int_stack+13800,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+233445,int_stack+224895,int_stack+257655,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+387285,int_stack+233445,int_stack+265350,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+410235,int_stack+387285,int_stack+328665,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+306120,int_stack+410235,int_stack+279120,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+248835,int_stack+306120,int_stack+464760,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+440835,int_stack+248835,int_stack+349065,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+584505,int_stack+440835,int_stack+497835,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+637155,int_stack+584505,int_stack+539955,15);
 /*--- compute (g0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+292935,int_stack+19800,int_stack+16650,15);
 /*--- compute (g0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+343920,int_stack+292935,int_stack+224895,15);
 /*--- compute (g0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+361020,int_stack+343920,int_stack+233445,15);
 /*--- compute (g0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+489975,int_stack+361020,int_stack+387285,15);
 /*--- compute (g0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+343920,int_stack+489975,int_stack+410235,15);
 /*--- compute (g0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+489975,int_stack+343920,int_stack+306120,15);
 /*--- compute (g0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+292935,int_stack+489975,int_stack+248835,15);
 /*--- compute (g0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+489975,int_stack+292935,int_stack+440835,15);
 /*--- compute (g0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+224895,int_stack+489975,int_stack+584505,15);
 /*--- compute (g0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+289245,int_stack+224895,int_stack+637155,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+224895,int_stack+24651,int_stack+23265,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+229053,int_stack+26289,int_stack+24651,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+233967,int_stack+229053,int_stack+224895,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+242283,int_stack+28200,int_stack+26289,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+248016,int_stack+242283,int_stack+229053,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+257844,int_stack+248016,int_stack+233967,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+224895,int_stack+30405,int_stack+28200,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+271704,int_stack+224895,int_stack+242283,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+231510,int_stack+271704,int_stack+248016,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+354585,int_stack+231510,int_stack+257844,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+247890,int_stack+32925,int_stack+30405,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+255450,int_stack+247890,int_stack+224895,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+375375,int_stack+255450,int_stack+271704,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+394485,int_stack+375375,int_stack+231510,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+419055,int_stack+394485,int_stack+354585,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+354585,int_stack+35781,int_stack+32925,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+224895,int_stack+354585,int_stack+247890,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+448161,int_stack+224895,int_stack+255450,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+240015,int_stack+448161,int_stack+375375,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+470211,int_stack+240015,int_stack+394485,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+363153,int_stack+470211,int_stack+419055,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+401961,int_stack+38994,int_stack+35781,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+411600,int_stack+401961,int_stack+354585,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+504609,int_stack+411600,int_stack+224895,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+529809,int_stack+504609,int_stack+448161,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+428736,int_stack+529809,int_stack+240015,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+224895,int_stack+428736,int_stack+470211,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+562884,int_stack+224895,int_stack+363153,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+270759,int_stack+42585,int_stack+38994,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+354585,int_stack+270759,int_stack+401961,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+373863,int_stack+354585,int_stack+411600,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+612780,int_stack+373863,int_stack+504609,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+468867,int_stack+612780,int_stack+529809,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+650580,int_stack+468867,int_stack+428736,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+402423,int_stack+650580,int_stack+224895,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+704088,int_stack+402423,int_stack+562884,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+224895,int_stack+46575,int_stack+42585,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+236865,int_stack+224895,int_stack+270759,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+515172,int_stack+236865,int_stack+354585,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+547302,int_stack+515172,int_stack+373863,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+766458,int_stack+547302,int_stack+612780,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+819378,int_stack+766458,int_stack+468867,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+881118,int_stack+819378,int_stack+650580,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+590142,int_stack+881118,int_stack+402423,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+354585,int_stack+590142,int_stack+704088,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+430815,int_stack+50985,int_stack+46575,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+444045,int_stack+430815,int_stack+224895,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+467985,int_stack+444045,int_stack+236865,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+224895,int_stack+467985,int_stack+515172,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+430815,int_stack+224895,int_stack+547302,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+490791,int_stack+430815,int_stack+766458,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+663852,int_stack+490791,int_stack+819378,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+430815,int_stack+663852,int_stack+881118,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+663852,int_stack+430815,int_stack+590142,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+430815,int_stack+663852,int_stack+354585,21);
 /*--- compute (gp|nn) ---*/
 hrr1_build_gp(Libint->AB,int_stack+522291,int_stack+430815,int_stack+289245,4356);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+718311,int_stack+57684,int_stack+55836,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+723855,int_stack+59868,int_stack+57684,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+730407,int_stack+723855,int_stack+718311,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+741495,int_stack+62416,int_stack+59868,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+749139,int_stack+741495,int_stack+723855,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+762243,int_stack+749139,int_stack+730407,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+718311,int_stack+65356,int_stack+62416,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+780723,int_stack+718311,int_stack+741495,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+727131,int_stack+780723,int_stack+749139,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+796011,int_stack+727131,int_stack+762243,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+748971,int_stack+68716,int_stack+65356,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+759051,int_stack+748971,int_stack+718311,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+823731,int_stack+759051,int_stack+780723,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+849211,int_stack+823731,int_stack+727131,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+881971,int_stack+849211,int_stack+796011,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+718311,int_stack+72524,int_stack+68716,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+776691,int_stack+718311,int_stack+748971,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+224895,int_stack+776691,int_stack+759051,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+729735,int_stack+224895,int_stack+823731,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+796851,int_stack+729735,int_stack+849211,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254295,int_stack+796851,int_stack+881971,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+842715,int_stack+76808,int_stack+72524,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+855567,int_stack+842715,int_stack+718311,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+878415,int_stack+855567,int_stack+776691,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+306039,int_stack+878415,int_stack+224895,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+350139,int_stack+306039,int_stack+729735,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+718311,int_stack+350139,int_stack+796851,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+718311,int_stack+254295,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+224895,int_stack+81596,int_stack+76808,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+239259,int_stack+224895,int_stack+842715,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+264963,int_stack+239259,int_stack+855567,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+779463,int_stack+264963,int_stack+878415,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+829863,int_stack+779463,int_stack+306039,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+891603,int_stack+829863,int_stack+350139,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+303043,int_stack+891603,int_stack+718311,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+962947,int_stack+303043,int_stack+0,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+86916,int_stack+81596,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+15960,int_stack+0,int_stack+224895,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+718311,int_stack+15960,int_stack+239259,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1046107,int_stack+718311,int_stack+264963,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+224895,int_stack+1046107,int_stack+779463,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1103227,int_stack+224895,int_stack+829863,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+761151,int_stack+1103227,int_stack+891603,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+852879,int_stack+761151,int_stack+303043,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+295455,int_stack+852879,int_stack+962947,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+397095,int_stack+92796,int_stack+86916,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+44688,int_stack+397095,int_stack+0,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+951159,int_stack+44688,int_stack+15960,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+0,int_stack+951159,int_stack+718311,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+951159,int_stack+0,int_stack+1046107,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+951159,int_stack+224895,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+951159,int_stack+0,int_stack+1103227,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1056999,int_stack+951159,int_stack+761151,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+718311,int_stack+1056999,int_stack+852879,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+838431,int_stack+718311,int_stack+295455,28);
 /*--- compute (hp|nn) ---*/
 hrr1_build_hp(Libint->AB,int_stack+960399,int_stack+838431,int_stack+430815,4356);
 /*--- compute (gd|nn) ---*/
 hrr1_build_gd(Libint->AB,int_stack+1234827,int_stack+960399,int_stack+522291,4356);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+101640,int_stack+99264,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+104448,int_stack+101640,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15552,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29808,int_stack+107724,int_stack+104448,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+39636,int_stack+29808,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56484,int_stack+39636,int_stack+15552,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+111504,int_stack+107724,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+80244,int_stack+0,int_stack+29808,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+11340,int_stack+80244,int_stack+39636,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+224895,int_stack+11340,int_stack+56484,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+39420,int_stack+115824,int_stack+111504,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+52380,int_stack+39420,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+260535,int_stack+52380,int_stack+80244,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+293295,int_stack+260535,int_stack+11340,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+335415,int_stack+293295,int_stack+224895,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+224895,int_stack+120720,int_stack+115824,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+224895,int_stack+39420,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+75060,int_stack+0,int_stack+52380,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+25920,int_stack+75060,int_stack+260535,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+385311,int_stack+25920,int_stack+293295,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+239583,int_stack+385311,int_stack+335415,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+306111,int_stack+126228,int_stack+120720,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+322635,int_stack+306111,int_stack+224895,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+444279,int_stack+322635,int_stack+0,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+487479,int_stack+444279,int_stack+75060,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+544179,int_stack+487479,int_stack+25920,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+544179,int_stack+385311,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+352011,int_stack+0,int_stack+239583,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+78624,int_stack+132384,int_stack+126228,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+97092,int_stack+78624,int_stack+306111,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+224895,int_stack+97092,int_stack+322635,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+273855,int_stack+224895,int_stack+444279,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+612975,int_stack+273855,int_stack+487479,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+437547,int_stack+612975,int_stack+544179,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+692355,int_stack+437547,int_stack+0,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1626867,int_stack+692355,int_stack+352011,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+139224,int_stack+132384,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+20520,int_stack+0,int_stack+78624,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+338655,int_stack+20520,int_stack+97092,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+57456,int_stack+338655,int_stack+224895,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1733787,int_stack+57456,int_stack+273855,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+224895,int_stack+1733787,int_stack+612975,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+529275,int_stack+224895,int_stack+437547,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+393735,int_stack+529275,int_stack+692355,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+647211,int_stack+393735,int_stack+1626867,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1626867,int_stack+146784,int_stack+139224,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1649547,int_stack+1626867,int_stack+0,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1824507,int_stack+1649547,int_stack+20520,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1626867,int_stack+1824507,int_stack+338655,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1824507,int_stack+1626867,int_stack+57456,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+1824507,int_stack+1733787,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1626867,int_stack+0,int_stack+224895,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+224895,int_stack+1626867,int_stack+529275,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1626867,int_stack+224895,int_stack+393735,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+224895,int_stack+1626867,int_stack+647211,36);
 /*--- compute (ip|nn) ---*/
 hrr1_build_ip(Libint->AB,int_stack+381711,int_stack+224895,int_stack+838431,4356);
 /*--- compute (hd|nn) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1626867,int_stack+381711,int_stack+960399,4356);
 /*--- compute (gf|nn) ---*/
 hrr1_build_gf(Libint->AB,int_stack+2175723,int_stack+1626867,int_stack+1234827,4356);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+747615,int_stack+158070,int_stack+155100,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+756525,int_stack+161580,int_stack+158070,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+767055,int_stack+756525,int_stack+747615,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+784875,int_stack+165675,int_stack+161580,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+797160,int_stack+784875,int_stack+756525,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+818220,int_stack+797160,int_stack+767055,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+747615,int_stack+170400,int_stack+165675,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+847920,int_stack+747615,int_stack+784875,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+761790,int_stack+847920,int_stack+797160,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+872490,int_stack+761790,int_stack+818220,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+796890,int_stack+175800,int_stack+170400,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+813090,int_stack+796890,int_stack+747615,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+917040,int_stack+813090,int_stack+847920,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+957990,int_stack+917040,int_stack+761790,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1010640,int_stack+957990,int_stack+872490,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+747615,int_stack+181920,int_stack+175800,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+841440,int_stack+747615,int_stack+796890,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1073010,int_stack+841440,int_stack+813090,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+765975,int_stack+1073010,int_stack+917040,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+873840,int_stack+765975,int_stack+957990,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1120260,int_stack+873840,int_stack+1010640,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+947550,int_stack+188805,int_stack+181920,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+968205,int_stack+947550,int_stack+747615,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1004925,int_stack+968205,int_stack+841440,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1203420,int_stack+1004925,int_stack+1073010,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1274295,int_stack+1203420,int_stack+765975,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+747615,int_stack+1274295,int_stack+873840,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1360290,int_stack+747615,int_stack+1120260,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+845895,int_stack+196500,int_stack+188805,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+868980,int_stack+845895,int_stack+947550,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1058925,int_stack+868980,int_stack+968205,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+910290,int_stack+1058925,int_stack+1004925,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1467210,int_stack+910290,int_stack+1203420,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1120125,int_stack+1467210,int_stack+1274295,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1120125,int_stack+747615,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2829123,int_stack+0,int_stack+1360290,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+747615,int_stack+205050,int_stack+196500,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+773265,int_stack+747615,int_stack+845895,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1234785,int_stack+773265,int_stack+868980,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1303635,int_stack+1234785,int_stack+1058925,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+991290,int_stack+1303635,int_stack+910290,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+819435,int_stack+991290,int_stack+1467210,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1395435,int_stack+819435,int_stack+1120125,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2962773,int_stack+1395435,int_stack+0,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+2962773,int_stack+2829123,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2829123,int_stack+214500,int_stack+205050,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2857473,int_stack+2829123,int_stack+747615,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1104690,int_stack+2857473,int_stack+773265,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2829123,int_stack+1104690,int_stack+1234785,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1104690,int_stack+2829123,int_stack+1303635,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1233210,int_stack+1104690,int_stack+991290,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+951735,int_stack+1233210,int_stack+819435,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+747615,int_stack+951735,int_stack+1395435,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+931890,int_stack+747615,int_stack+2962773,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2829123,int_stack+931890,int_stack+0,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+747615,int_stack+2829123,int_stack+224895,4356);
 /*--- compute (id|nn) ---*/
 hrr1_build_id(Libint->AB,int_stack+2829123,int_stack+747615,int_stack+381711,4356);
 /*--- compute (hf|nn) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+2829123,int_stack+1626867,4356);
 /*--- compute (gg|nn) ---*/
 hrr1_build_gg(Libint->AB,int_stack+914760,int_stack+0,int_stack+2175723,4356);
 return int_stack+914760;}
