/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggnp(Libint_t*, prim_data*);

  /* Computes quartets of (gg|np) integrals */

REALTYPE *hrr_order_ggnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[5][10] = int_stack + 2160;
 Libint->vrr_classes[5][11] = int_stack + 3546;
 Libint->vrr_classes[6][10] = int_stack + 5184;
 Libint->vrr_classes[6][11] = int_stack + 7032;
 Libint->vrr_classes[7][10] = int_stack + 9216;
 Libint->vrr_classes[7][11] = int_stack + 11592;
 Libint->vrr_classes[8][10] = int_stack + 14400;
 Libint->vrr_classes[8][11] = int_stack + 17370;
 memset(int_stack,0,20880*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20880;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggnp(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20880,int_stack+990,int_stack+0,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23850,int_stack+3546,int_stack+2160,21);
 /*--- compute (gp|np) ---*/
 hrr1_build_gp(Libint->AB,int_stack+28008,int_stack+23850,int_stack+20880,198);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+36918,int_stack+7032,int_stack+5184,28);
 /*--- compute (hp|np) ---*/
 hrr1_build_hp(Libint->AB,int_stack+42462,int_stack+36918,int_stack+23850,198);
 /*--- compute (gd|np) ---*/
 hrr1_build_gd(Libint->AB,int_stack+54936,int_stack+42462,int_stack+28008,198);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20880,int_stack+11592,int_stack+9216,36);
 /*--- compute (ip|np) ---*/
 hrr1_build_ip(Libint->AB,int_stack+72756,int_stack+20880,int_stack+36918,198);
 /*--- compute (hd|np) ---*/
 hrr1_build_hd(Libint->AB,int_stack+89388,int_stack+72756,int_stack+42462,198);
 /*--- compute (gf|np) ---*/
 hrr1_build_gf(Libint->AB,int_stack+114336,int_stack+89388,int_stack+54936,198);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28008,int_stack+17370,int_stack+14400,45);
 /*--- compute (kp|np) ---*/
 hrr1_build_kp(Libint->AB,int_stack+36918,int_stack+28008,int_stack+20880,198);
 /*--- compute (id|np) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+36918,int_stack+72756,198);
 /*--- compute (hf|np) ---*/
 hrr1_build_hf(Libint->AB,int_stack+33264,int_stack+0,int_stack+89388,198);
 /*--- compute (gg|np) ---*/
 hrr1_build_gg(Libint->AB,int_stack+144036,int_stack+33264,int_stack+114336,198);
 return int_stack+144036;}
