/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpli(Libint_t*, prim_data*);

  /* Computes quartets of (gp|li) integrals */

REALTYPE *hrr_order_gpli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[5][8] = int_stack + 8400;
 Libint->vrr_classes[5][9] = int_stack + 9345;
 Libint->vrr_classes[5][10] = int_stack + 10500;
 Libint->vrr_classes[5][11] = int_stack + 11886;
 Libint->vrr_classes[5][12] = int_stack + 13524;
 Libint->vrr_classes[5][13] = int_stack + 15435;
 Libint->vrr_classes[5][14] = int_stack + 17640;
 memset(int_stack,0,20160*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20160;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpli(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20160,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+22185,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+24660,int_stack+22185,int_stack+20160,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28710,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31680,int_stack+28710,int_stack+22185,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+36630,int_stack+31680,int_stack+24660,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20160,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43380,int_stack+20160,int_stack+28710,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+49320,int_stack+43380,int_stack+31680,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+23670,int_stack+49320,int_stack+36630,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+33795,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57570,int_stack+33795,int_stack+20160,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+64590,int_stack+57570,int_stack+43380,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+74490,int_stack+64590,int_stack+49320,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+37890,int_stack+74490,int_stack+23670,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+20160,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+24885,int_stack+20160,int_stack+33795,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+86865,int_stack+24885,int_stack+57570,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+20160,int_stack+86865,int_stack+64590,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+52065,int_stack+20160,int_stack+74490,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+69390,int_stack+52065,int_stack+37890,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20160,int_stack+9345,int_stack+8400,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+22995,int_stack+10500,int_stack+9345,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+26460,int_stack+22995,int_stack+20160,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32130,int_stack+11886,int_stack+10500,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+36288,int_stack+32130,int_stack+22995,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+43218,int_stack+36288,int_stack+26460,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20160,int_stack+13524,int_stack+11886,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+52668,int_stack+20160,int_stack+32130,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+52668,int_stack+36288,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+25074,int_stack+0,int_stack+43218,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+39249,int_stack+15435,int_stack+13524,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+88290,int_stack+39249,int_stack+20160,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+98118,int_stack+88290,int_stack+52668,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+44982,int_stack+98118,int_stack+0,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+111978,int_stack+44982,int_stack+25074,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+17640,int_stack+15435,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6615,int_stack+0,int_stack+39249,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+18081,int_stack+6615,int_stack+88290,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+131823,int_stack+18081,int_stack+98118,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+131823,int_stack+44982,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+24255,int_stack+0,int_stack+111978,21);
 /*--- compute (gp|li) ---*/
 hrr1_build_gp(Libint->AB,int_stack+88290,int_stack+24255,int_stack+69390,1260);
 return int_stack+88290;}
