/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpmd(Libint_t*, prim_data*);

  /* Computes quartets of (gp|md) integrals */

REALTYPE *hrr_order_gpmd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[5][9] = int_stack + 2985;
 Libint->vrr_classes[5][10] = int_stack + 4140;
 Libint->vrr_classes[5][11] = int_stack + 5526;
 memset(int_stack,0,7164*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7164;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpmd(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7164,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9639,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+12609,int_stack+9639,int_stack+7164,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7164,int_stack+4140,int_stack+2985,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17559,int_stack+5526,int_stack+4140,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+17559,int_stack+7164,21);
 /*--- compute (gp|md) ---*/
 hrr1_build_gp(Libint->AB,int_stack+17559,int_stack+0,int_stack+12609,330);
 return int_stack+17559;}
