/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpmi(Libint_t*, prim_data*);

  /* Computes quartets of (gp|mi) integrals */

REALTYPE *hrr_order_gpmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[4][15] = int_stack + 7725;
 Libint->vrr_classes[5][9] = int_stack + 9765;
 Libint->vrr_classes[5][10] = int_stack + 10920;
 Libint->vrr_classes[5][11] = int_stack + 12306;
 Libint->vrr_classes[5][12] = int_stack + 13944;
 Libint->vrr_classes[5][13] = int_stack + 15855;
 Libint->vrr_classes[5][14] = int_stack + 18060;
 Libint->vrr_classes[5][15] = int_stack + 20580;
 memset(int_stack,0,23436*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 23436;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpmi(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+23436,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25911,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28881,int_stack+25911,int_stack+23436,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33831,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+37341,int_stack+33831,int_stack+25911,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+43281,int_stack+37341,int_stack+28881,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23436,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+51531,int_stack+23436,int_stack+33831,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+58551,int_stack+51531,int_stack+37341,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+27531,int_stack+58551,int_stack+43281,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39906,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+68451,int_stack+39906,int_stack+23436,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+76641,int_stack+68451,int_stack+51531,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+88341,int_stack+76641,int_stack+58551,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+44631,int_stack+88341,int_stack+27531,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+23436,int_stack+7725,int_stack+5925,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28836,int_stack+23436,int_stack+39906,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+103191,int_stack+28836,int_stack+68451,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+23436,int_stack+103191,int_stack+76641,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+61956,int_stack+23436,int_stack+88341,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+82746,int_stack+61956,int_stack+44631,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+23436,int_stack+10920,int_stack+9765,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26901,int_stack+12306,int_stack+10920,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31059,int_stack+26901,int_stack+23436,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37989,int_stack+13944,int_stack+12306,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+42903,int_stack+37989,int_stack+26901,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51219,int_stack+42903,int_stack+31059,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23436,int_stack+15855,int_stack+13944,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+62769,int_stack+23436,int_stack+37989,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+62769,int_stack+42903,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+29169,int_stack+0,int_stack+51219,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+46494,int_stack+18060,int_stack+15855,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+105846,int_stack+46494,int_stack+23436,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+117312,int_stack+105846,int_stack+62769,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+53109,int_stack+117312,int_stack+0,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+133692,int_stack+53109,int_stack+29169,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+20580,int_stack+18060,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+7560,int_stack+0,int_stack+46494,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+20790,int_stack+7560,int_stack+105846,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+157947,int_stack+20790,int_stack+117312,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+157947,int_stack+53109,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+29106,int_stack+0,int_stack+133692,21);
 /*--- compute (gp|mi) ---*/
 hrr1_build_gp(Libint->AB,int_stack+105846,int_stack+29106,int_stack+82746,1540);
 return int_stack+105846;}
