/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpnh(Libint_t*, prim_data*);

  /* Computes quartets of (gp|nh) integrals */

REALTYPE *hrr_order_gpnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[5][10] = int_stack + 8940;
 Libint->vrr_classes[5][11] = int_stack + 10326;
 Libint->vrr_classes[5][12] = int_stack + 11964;
 Libint->vrr_classes[5][13] = int_stack + 13875;
 Libint->vrr_classes[5][14] = int_stack + 16080;
 Libint->vrr_classes[5][15] = int_stack + 18600;
 memset(int_stack,0,21456*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21456;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpnh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21456,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24426,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+27936,int_stack+24426,int_stack+21456,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+33876,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+37971,int_stack+33876,int_stack+24426,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+44991,int_stack+37971,int_stack+27936,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+21456,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+54891,int_stack+21456,int_stack+33876,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+26181,int_stack+54891,int_stack+37971,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+63081,int_stack+26181,int_stack+44991,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+37881,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43281,int_stack+37881,int_stack+21456,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+77931,int_stack+43281,int_stack+54891,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+37881,int_stack+77931,int_stack+26181,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+77931,int_stack+37881,int_stack+63081,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21456,int_stack+10326,int_stack+8940,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25614,int_stack+11964,int_stack+10326,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30528,int_stack+25614,int_stack+21456,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+38844,int_stack+13875,int_stack+11964,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+44577,int_stack+38844,int_stack+25614,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+54405,int_stack+44577,int_stack+30528,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+21456,int_stack+16080,int_stack+13875,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+21456,int_stack+38844,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28071,int_stack+0,int_stack+44577,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+98721,int_stack+28071,int_stack+54405,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+44451,int_stack+18600,int_stack+16080,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+52011,int_stack+44451,int_stack+21456,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+119511,int_stack+52011,int_stack+0,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+119511,int_stack+28071,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+24570,int_stack+0,int_stack+98721,21);
 /*--- compute (gp|nh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+98721,int_stack+24570,int_stack+77931,1386);
 return int_stack+98721;}
