/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpnm(Libint_t*, prim_data*);

  /* Computes quartets of (gp|nm) integrals */

REALTYPE *hrr_order_gpnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[4][18] = int_stack + 13800;
 Libint->vrr_classes[4][19] = int_stack + 16650;
 Libint->vrr_classes[5][10] = int_stack + 19800;
 Libint->vrr_classes[5][11] = int_stack + 21186;
 Libint->vrr_classes[5][12] = int_stack + 22824;
 Libint->vrr_classes[5][13] = int_stack + 24735;
 Libint->vrr_classes[5][14] = int_stack + 26940;
 Libint->vrr_classes[5][15] = int_stack + 29460;
 Libint->vrr_classes[5][16] = int_stack + 32316;
 Libint->vrr_classes[5][17] = int_stack + 35529;
 Libint->vrr_classes[5][18] = int_stack + 39120;
 Libint->vrr_classes[5][19] = int_stack + 43110;
 memset(int_stack,0,47520*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47520;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpnm(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47520,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+50490,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54000,int_stack+50490,int_stack+47520,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+59940,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+64035,int_stack+59940,int_stack+50490,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+71055,int_stack+64035,int_stack+54000,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47520,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+80955,int_stack+47520,int_stack+59940,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+52245,int_stack+80955,int_stack+64035,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+89145,int_stack+52245,int_stack+71055,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+63945,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+69345,int_stack+63945,int_stack+47520,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+103995,int_stack+69345,int_stack+80955,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+117645,int_stack+103995,int_stack+52245,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+135195,int_stack+117645,int_stack+89145,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+47520,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+78795,int_stack+47520,int_stack+63945,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+155985,int_stack+78795,int_stack+69345,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+53640,int_stack+155985,int_stack+103995,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+89595,int_stack+53640,int_stack+117645,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+171735,int_stack+89595,int_stack+135195,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+114165,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+121050,int_stack+114165,int_stack+47520,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+133290,int_stack+121050,int_stack+78795,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+199455,int_stack+133290,int_stack+155985,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+223080,int_stack+199455,int_stack+53640,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+47520,int_stack+223080,int_stack+89595,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+251745,int_stack+47520,int_stack+171735,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+80280,int_stack+13800,int_stack+11235,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+87975,int_stack+80280,int_stack+114165,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+151290,int_stack+87975,int_stack+121050,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+101745,int_stack+151290,int_stack+133290,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+287385,int_stack+101745,int_stack+199455,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+171690,int_stack+287385,int_stack+223080,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+320460,int_stack+171690,int_stack+47520,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+362580,int_stack+320460,int_stack+251745,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+47520,int_stack+16650,int_stack+13800,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+56070,int_stack+47520,int_stack+80280,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+209910,int_stack+56070,int_stack+87975,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+47520,int_stack+209910,int_stack+151290,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+209910,int_stack+47520,int_stack+101745,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+47520,int_stack+209910,int_stack+287385,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+209910,int_stack+47520,int_stack+171690,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+47520,int_stack+209910,int_stack+320460,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+100170,int_stack+47520,int_stack+362580,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47520,int_stack+21186,int_stack+19800,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51678,int_stack+22824,int_stack+21186,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+56592,int_stack+51678,int_stack+47520,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64908,int_stack+24735,int_stack+22824,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+70641,int_stack+64908,int_stack+51678,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+80469,int_stack+70641,int_stack+56592,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47520,int_stack+26940,int_stack+24735,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+154620,int_stack+47520,int_stack+64908,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+54135,int_stack+154620,int_stack+70641,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+166086,int_stack+54135,int_stack+80469,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+70515,int_stack+29460,int_stack+26940,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+78075,int_stack+70515,int_stack+47520,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+186876,int_stack+78075,int_stack+154620,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+205986,int_stack+186876,int_stack+54135,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+230556,int_stack+205986,int_stack+166086,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+154620,int_stack+32316,int_stack+29460,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+163188,int_stack+154620,int_stack+70515,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+47520,int_stack+163188,int_stack+78075,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+69570,int_stack+47520,int_stack+186876,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+259662,int_stack+69570,int_stack+205986,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+178308,int_stack+259662,int_stack+230556,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+217116,int_stack+35529,int_stack+32316,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+226755,int_stack+217116,int_stack+154620,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+294060,int_stack+226755,int_stack+163188,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+319260,int_stack+294060,int_stack+47520,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+352335,int_stack+319260,int_stack+69570,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+47520,int_stack+352335,int_stack+259662,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+243891,int_stack+47520,int_stack+178308,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+154620,int_stack+39120,int_stack+35529,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+165393,int_stack+154620,int_stack+217116,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+184671,int_stack+165393,int_stack+226755,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+184671,int_stack+294060,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+392466,int_stack+0,int_stack+319260,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+293787,int_stack+392466,int_stack+352335,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+438771,int_stack+293787,int_stack+47520,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+497739,int_stack+438771,int_stack+243891,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+47520,int_stack+43110,int_stack+39120,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+59490,int_stack+47520,int_stack+154620,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+213231,int_stack+59490,int_stack+165393,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+245361,int_stack+213231,int_stack+184671,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+154620,int_stack+245361,int_stack+0,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+154620,int_stack+392466,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+154620,int_stack+0,int_stack+293787,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+154620,int_stack+438771,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+154620,int_stack+0,int_stack+497739,21);
 /*--- compute (gp|nm) ---*/
 hrr1_build_gp(Libint->AB,int_stack+230850,int_stack+154620,int_stack+100170,3630);
 return int_stack+230850;}
