/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdkf(Libint_t*, prim_data*);

  /* Computes quartets of (hd|kf) integrals */

REALTYPE *hrr_order_hdkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[6][7] = int_stack + 4242;
 Libint->vrr_classes[6][8] = int_stack + 5250;
 Libint->vrr_classes[6][9] = int_stack + 6510;
 Libint->vrr_classes[6][10] = int_stack + 8050;
 Libint->vrr_classes[7][7] = int_stack + 9898;
 Libint->vrr_classes[7][8] = int_stack + 11194;
 Libint->vrr_classes[7][9] = int_stack + 12814;
 Libint->vrr_classes[7][10] = int_stack + 14794;
 memset(int_stack,0,17170*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 17170;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdkf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17170,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19438,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22273,int_stack+19438,int_stack+17170,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+26809,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+30274,int_stack+26809,int_stack+19438,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+35944,int_stack+30274,int_stack+22273,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17170,int_stack+5250,int_stack+4242,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20194,int_stack+6510,int_stack+5250,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+23974,int_stack+20194,int_stack+17170,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30022,int_stack+8050,int_stack+6510,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+30022,int_stack+20194,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+43504,int_stack+0,int_stack+23974,28);
 /*--- compute (hp|kf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+53584,int_stack+43504,int_stack+35944,360);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+11194,int_stack+9898,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3888,int_stack+12814,int_stack+11194,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+17170,int_stack+3888,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24946,int_stack+14794,int_stack+12814,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+30886,int_stack+24946,int_stack+3888,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+30886,int_stack+17170,36);
 /*--- compute (ip|kf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+12960,int_stack+0,int_stack+43504,360);
 /*--- compute (hd|kf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+76264,int_stack+12960,int_stack+53584,360);
 return int_stack+76264;}
