/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdlf(Libint_t*, prim_data*);

  /* Computes quartets of (hd|lf) integrals */

REALTYPE *hrr_order_hdlf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[6][8] = int_stack + 5124;
 Libint->vrr_classes[6][9] = int_stack + 6384;
 Libint->vrr_classes[6][10] = int_stack + 7924;
 Libint->vrr_classes[6][11] = int_stack + 9772;
 Libint->vrr_classes[7][8] = int_stack + 11956;
 Libint->vrr_classes[7][9] = int_stack + 13576;
 Libint->vrr_classes[7][10] = int_stack + 15556;
 Libint->vrr_classes[7][11] = int_stack + 17932;
 memset(int_stack,0,20740*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20740;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdlf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20740,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+23575,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27040,int_stack+23575,int_stack+20740,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32710,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+36868,int_stack+32710,int_stack+23575,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+43798,int_stack+36868,int_stack+27040,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20740,int_stack+6384,int_stack+5124,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24520,int_stack+7924,int_stack+6384,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+29140,int_stack+24520,int_stack+20740,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+36700,int_stack+9772,int_stack+7924,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+36700,int_stack+24520,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+53248,int_stack+0,int_stack+29140,28);
 /*--- compute (hp|lf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+65848,int_stack+53248,int_stack+43798,450);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+13576,int_stack+11956,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+15556,int_stack+13576,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+20740,int_stack+4860,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30460,int_stack+17932,int_stack+15556,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+37588,int_stack+30460,int_stack+4860,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+37588,int_stack+20740,36);
 /*--- compute (ip|lf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+94198,int_stack+0,int_stack+53248,450);
 /*--- compute (hd|lf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+94198,int_stack+65848,450);
 return int_stack+0;}
