/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgkg(Libint_t*, prim_data*);

  /* Computes quartets of (hg|kg) integrals */

REALTYPE *hrr_order_hgkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[6][7] = int_stack + 5880;
 Libint->vrr_classes[6][8] = int_stack + 6888;
 Libint->vrr_classes[6][9] = int_stack + 8148;
 Libint->vrr_classes[6][10] = int_stack + 9688;
 Libint->vrr_classes[6][11] = int_stack + 11536;
 Libint->vrr_classes[7][7] = int_stack + 13720;
 Libint->vrr_classes[7][8] = int_stack + 15016;
 Libint->vrr_classes[7][9] = int_stack + 16636;
 Libint->vrr_classes[7][10] = int_stack + 18616;
 Libint->vrr_classes[7][11] = int_stack + 20992;
 Libint->vrr_classes[8][7] = int_stack + 23800;
 Libint->vrr_classes[8][8] = int_stack + 25420;
 Libint->vrr_classes[8][9] = int_stack + 27445;
 Libint->vrr_classes[8][10] = int_stack + 29920;
 Libint->vrr_classes[8][11] = int_stack + 32890;
 Libint->vrr_classes[9][7] = int_stack + 36400;
 Libint->vrr_classes[9][8] = int_stack + 38380;
 Libint->vrr_classes[9][9] = int_stack + 40855;
 Libint->vrr_classes[9][10] = int_stack + 43880;
 Libint->vrr_classes[9][11] = int_stack + 47510;
 memset(int_stack,0,51800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 51800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgkg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+51800,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54068,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+56903,int_stack+54068,int_stack+51800,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+61439,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+64904,int_stack+61439,int_stack+54068,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+70574,int_stack+64904,int_stack+56903,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51800,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+78134,int_stack+51800,int_stack+61439,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51800,int_stack+78134,int_stack+64904,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+78134,int_stack+51800,int_stack+70574,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+51800,int_stack+6888,int_stack+5880,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54824,int_stack+8148,int_stack+6888,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+58604,int_stack+54824,int_stack+51800,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+64652,int_stack+9688,int_stack+8148,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+69272,int_stack+64652,int_stack+54824,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+89474,int_stack+69272,int_stack+58604,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51800,int_stack+11536,int_stack+9688,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+51800,int_stack+64652,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51800,int_stack+0,int_stack+69272,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+99554,int_stack+51800,int_stack+89474,28);
 /*--- compute (hp|kg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+114674,int_stack+99554,int_stack+78134,540);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+51800,int_stack+15016,int_stack+13720,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+55688,int_stack+16636,int_stack+15016,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+60548,int_stack+55688,int_stack+51800,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+68324,int_stack+18616,int_stack+16636,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+74264,int_stack+68324,int_stack+55688,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+83984,int_stack+74264,int_stack+60548,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51800,int_stack+20992,int_stack+18616,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+51800,int_stack+68324,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51800,int_stack+0,int_stack+74264,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+51800,int_stack+83984,36);
 /*--- compute (ip|kg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+51800,int_stack+0,int_stack+99554,540);
 /*--- compute (hd|kg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+148694,int_stack+51800,int_stack+114674,540);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+97160,int_stack+25420,int_stack+23800,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+102020,int_stack+27445,int_stack+25420,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+108095,int_stack+102020,int_stack+97160,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+117815,int_stack+29920,int_stack+27445,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+125240,int_stack+117815,int_stack+102020,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+216734,int_stack+125240,int_stack+108095,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+97160,int_stack+32890,int_stack+29920,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19440,int_stack+97160,int_stack+117815,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+97160,int_stack+19440,int_stack+125240,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+117410,int_stack+97160,int_stack+216734,45);
 /*--- compute (kp|kg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+216734,int_stack+117410,int_stack+0,540);
 /*--- compute (id|kg) ---*/
 hrr1_build_id(Libint->AB,int_stack+275054,int_stack+216734,int_stack+51800,540);
 /*--- compute (hf|kg) ---*/
 hrr1_build_hf(Libint->AB,int_stack+365774,int_stack+275054,int_stack+148694,540);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+51800,int_stack+38380,int_stack+36400,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57740,int_stack+40855,int_stack+38380,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+65165,int_stack+57740,int_stack+51800,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77045,int_stack+43880,int_stack+40855,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+86120,int_stack+77045,int_stack+57740,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+86120,int_stack+65165,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51800,int_stack+47510,int_stack+43880,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19800,int_stack+51800,int_stack+77045,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+37950,int_stack+19800,int_stack+86120,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+62700,int_stack+37950,int_stack+0,55);
 /*--- compute (lp|kg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+141710,int_stack+62700,int_stack+117410,540);
 /*--- compute (kd|kg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+141710,int_stack+216734,540);
 /*--- compute (if|kg) ---*/
 hrr1_build_if(Libint->AB,int_stack+116640,int_stack+0,int_stack+275054,540);
 /*--- compute (hg|kg) ---*/
 hrr1_build_hg(Libint->AB,int_stack+479174,int_stack+116640,int_stack+365774,540);
 return int_stack+479174;}
