/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgmg(Libint_t*, prim_data*);

  /* Computes quartets of (hg|mg) integrals */

REALTYPE *hrr_order_hgmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[6][9] = int_stack + 8295;
 Libint->vrr_classes[6][10] = int_stack + 9835;
 Libint->vrr_classes[6][11] = int_stack + 11683;
 Libint->vrr_classes[6][12] = int_stack + 13867;
 Libint->vrr_classes[6][13] = int_stack + 16415;
 Libint->vrr_classes[7][9] = int_stack + 19355;
 Libint->vrr_classes[7][10] = int_stack + 21335;
 Libint->vrr_classes[7][11] = int_stack + 23711;
 Libint->vrr_classes[7][12] = int_stack + 26519;
 Libint->vrr_classes[7][13] = int_stack + 29795;
 Libint->vrr_classes[8][9] = int_stack + 33575;
 Libint->vrr_classes[8][10] = int_stack + 36050;
 Libint->vrr_classes[8][11] = int_stack + 39020;
 Libint->vrr_classes[8][12] = int_stack + 42530;
 Libint->vrr_classes[8][13] = int_stack + 46625;
 Libint->vrr_classes[9][9] = int_stack + 51350;
 Libint->vrr_classes[9][10] = int_stack + 54375;
 Libint->vrr_classes[9][11] = int_stack + 58005;
 Libint->vrr_classes[9][12] = int_stack + 62295;
 Libint->vrr_classes[9][13] = int_stack + 67300;
 memset(int_stack,0,73075*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 73075;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgmg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+73075,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+76540,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80698,int_stack+76540,int_stack+73075,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+87628,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+92542,int_stack+87628,int_stack+76540,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+100858,int_stack+92542,int_stack+80698,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73075,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+112408,int_stack+73075,int_stack+87628,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+73075,int_stack+112408,int_stack+92542,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+112408,int_stack+73075,int_stack+100858,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+73075,int_stack+9835,int_stack+8295,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77695,int_stack+11683,int_stack+9835,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+83239,int_stack+77695,int_stack+73075,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92479,int_stack+13867,int_stack+11683,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+99031,int_stack+92479,int_stack+77695,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+129733,int_stack+99031,int_stack+83239,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73075,int_stack+16415,int_stack+13867,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+73075,int_stack+92479,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+73075,int_stack+0,int_stack+99031,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+145133,int_stack+73075,int_stack+129733,28);
 /*--- compute (hp|mg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+168233,int_stack+145133,int_stack+112408,825);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+73075,int_stack+21335,int_stack+19355,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+79015,int_stack+23711,int_stack+21335,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+86143,int_stack+79015,int_stack+73075,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+98023,int_stack+26519,int_stack+23711,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+106447,int_stack+98023,int_stack+79015,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120703,int_stack+106447,int_stack+86143,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73075,int_stack+29795,int_stack+26519,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+73075,int_stack+98023,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+73075,int_stack+0,int_stack+106447,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+73075,int_stack+120703,36);
 /*--- compute (ip|mg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+73075,int_stack+0,int_stack+145133,825);
 /*--- compute (hd|mg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+220208,int_stack+73075,int_stack+168233,825);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+142375,int_stack+36050,int_stack+33575,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149800,int_stack+39020,int_stack+36050,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+158710,int_stack+149800,int_stack+142375,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+173560,int_stack+42530,int_stack+39020,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+184090,int_stack+173560,int_stack+149800,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+324158,int_stack+184090,int_stack+158710,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+142375,int_stack+46625,int_stack+42530,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+29700,int_stack+142375,int_stack+173560,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142375,int_stack+29700,int_stack+184090,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+172075,int_stack+142375,int_stack+324158,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+324158,int_stack+172075,int_stack+0,825);
 /*--- compute (id|mg) ---*/
 hrr1_build_id(Libint->AB,int_stack+413258,int_stack+324158,int_stack+73075,825);
 /*--- compute (hf|mg) ---*/
 hrr1_build_hf(Libint->AB,int_stack+551858,int_stack+413258,int_stack+220208,825);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+73075,int_stack+54375,int_stack+51350,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+82150,int_stack+58005,int_stack+54375,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+93040,int_stack+82150,int_stack+73075,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+111190,int_stack+62295,int_stack+58005,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+124060,int_stack+111190,int_stack+82150,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+124060,int_stack+93040,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73075,int_stack+67300,int_stack+62295,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+145840,int_stack+73075,int_stack+111190,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30250,int_stack+145840,int_stack+124060,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+66550,int_stack+30250,int_stack+0,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+209200,int_stack+66550,int_stack+172075,825);
 /*--- compute (kd|mg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+209200,int_stack+324158,825);
 /*--- compute (if|mg) ---*/
 hrr1_build_if(Libint->AB,int_stack+178200,int_stack+0,int_stack+413258,825);
 /*--- compute (hg|mg) ---*/
 hrr1_build_hg(Libint->AB,int_stack+725108,int_stack+178200,int_stack+551858,825);
 return int_stack+725108;}
