/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgng(Libint_t*, prim_data*);

  /* Computes quartets of (hg|ng) integrals */

REALTYPE *hrr_order_hgng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[6][10] = int_stack + 9660;
 Libint->vrr_classes[6][11] = int_stack + 11508;
 Libint->vrr_classes[6][12] = int_stack + 13692;
 Libint->vrr_classes[6][13] = int_stack + 16240;
 Libint->vrr_classes[6][14] = int_stack + 19180;
 Libint->vrr_classes[7][10] = int_stack + 22540;
 Libint->vrr_classes[7][11] = int_stack + 24916;
 Libint->vrr_classes[7][12] = int_stack + 27724;
 Libint->vrr_classes[7][13] = int_stack + 31000;
 Libint->vrr_classes[7][14] = int_stack + 34780;
 Libint->vrr_classes[8][10] = int_stack + 39100;
 Libint->vrr_classes[8][11] = int_stack + 42070;
 Libint->vrr_classes[8][12] = int_stack + 45580;
 Libint->vrr_classes[8][13] = int_stack + 49675;
 Libint->vrr_classes[8][14] = int_stack + 54400;
 Libint->vrr_classes[9][10] = int_stack + 59800;
 Libint->vrr_classes[9][11] = int_stack + 63430;
 Libint->vrr_classes[9][12] = int_stack + 67720;
 Libint->vrr_classes[9][13] = int_stack + 72725;
 Libint->vrr_classes[9][14] = int_stack + 78500;
 memset(int_stack,0,85100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 85100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgng(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85100,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+89258,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+94172,int_stack+89258,int_stack+85100,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+102488,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+108221,int_stack+102488,int_stack+89258,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+118049,int_stack+108221,int_stack+94172,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85100,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+131909,int_stack+85100,int_stack+102488,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+85100,int_stack+131909,int_stack+108221,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+131909,int_stack+85100,int_stack+118049,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85100,int_stack+11508,int_stack+9660,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90644,int_stack+13692,int_stack+11508,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97196,int_stack+90644,int_stack+85100,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+108284,int_stack+16240,int_stack+13692,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115928,int_stack+108284,int_stack+90644,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+152699,int_stack+115928,int_stack+97196,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85100,int_stack+19180,int_stack+16240,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+85100,int_stack+108284,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+85100,int_stack+0,int_stack+115928,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+171179,int_stack+85100,int_stack+152699,28);
 /*--- compute (hp|ng) ---*/
 hrr1_build_hp(Libint->AB,int_stack+198899,int_stack+171179,int_stack+131909,990);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85100,int_stack+24916,int_stack+22540,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92228,int_stack+27724,int_stack+24916,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+100652,int_stack+92228,int_stack+85100,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+114908,int_stack+31000,int_stack+27724,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+124736,int_stack+114908,int_stack+92228,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+141584,int_stack+124736,int_stack+100652,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85100,int_stack+34780,int_stack+31000,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+85100,int_stack+114908,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+85100,int_stack+0,int_stack+124736,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+85100,int_stack+141584,36);
 /*--- compute (ip|ng) ---*/
 hrr1_build_ip(Libint->AB,int_stack+85100,int_stack+0,int_stack+171179,990);
 /*--- compute (hd|ng) ---*/
 hrr1_build_hd(Libint->AB,int_stack+261269,int_stack+85100,int_stack+198899,990);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+168260,int_stack+42070,int_stack+39100,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+177170,int_stack+45580,int_stack+42070,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+187700,int_stack+177170,int_stack+168260,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+205520,int_stack+49675,int_stack+45580,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+217805,int_stack+205520,int_stack+177170,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+386009,int_stack+217805,int_stack+187700,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+168260,int_stack+54400,int_stack+49675,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+415709,int_stack+168260,int_stack+205520,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+168260,int_stack+415709,int_stack+217805,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+203360,int_stack+168260,int_stack+386009,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+386009,int_stack+203360,int_stack+0,990);
 /*--- compute (id|ng) ---*/
 hrr1_build_id(Libint->AB,int_stack+492929,int_stack+386009,int_stack+85100,990);
 /*--- compute (hf|ng) ---*/
 hrr1_build_hf(Libint->AB,int_stack+659249,int_stack+492929,int_stack+261269,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85100,int_stack+63430,int_stack+59800,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+95990,int_stack+67720,int_stack+63430,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108860,int_stack+95990,int_stack+85100,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+130640,int_stack+72725,int_stack+67720,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+145655,int_stack+130640,int_stack+95990,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+145655,int_stack+108860,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85100,int_stack+78500,int_stack+72725,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+171395,int_stack+85100,int_stack+130640,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+36300,int_stack+171395,int_stack+145655,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+79200,int_stack+36300,int_stack+0,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+247910,int_stack+79200,int_stack+203360,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+247910,int_stack+386009,990);
 /*--- compute (if|ng) ---*/
 hrr1_build_if(Libint->AB,int_stack+213840,int_stack+0,int_stack+492929,990);
 /*--- compute (hg|ng) ---*/
 hrr1_build_hg(Libint->AB,int_stack+867149,int_stack+213840,int_stack+659249,990);
 return int_stack+867149;}
