/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhih(Libint_t*, prim_data*);

  /* Computes quartets of (hh|ih) integrals */

REALTYPE *hrr_order_hhih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[5][9] = int_stack + 2289;
 Libint->vrr_classes[5][10] = int_stack + 3444;
 Libint->vrr_classes[5][11] = int_stack + 4830;
 Libint->vrr_classes[6][6] = int_stack + 6468;
 Libint->vrr_classes[6][7] = int_stack + 7252;
 Libint->vrr_classes[6][8] = int_stack + 8260;
 Libint->vrr_classes[6][9] = int_stack + 9520;
 Libint->vrr_classes[6][10] = int_stack + 11060;
 Libint->vrr_classes[6][11] = int_stack + 12908;
 Libint->vrr_classes[7][6] = int_stack + 15092;
 Libint->vrr_classes[7][7] = int_stack + 16100;
 Libint->vrr_classes[7][8] = int_stack + 17396;
 Libint->vrr_classes[7][9] = int_stack + 19016;
 Libint->vrr_classes[7][10] = int_stack + 20996;
 Libint->vrr_classes[7][11] = int_stack + 23372;
 Libint->vrr_classes[8][6] = int_stack + 26180;
 Libint->vrr_classes[8][7] = int_stack + 27440;
 Libint->vrr_classes[8][8] = int_stack + 29060;
 Libint->vrr_classes[8][9] = int_stack + 31085;
 Libint->vrr_classes[8][10] = int_stack + 33560;
 Libint->vrr_classes[8][11] = int_stack + 36530;
 Libint->vrr_classes[9][6] = int_stack + 40040;
 Libint->vrr_classes[9][7] = int_stack + 41580;
 Libint->vrr_classes[9][8] = int_stack + 43560;
 Libint->vrr_classes[9][9] = int_stack + 46035;
 Libint->vrr_classes[9][10] = int_stack + 49060;
 Libint->vrr_classes[9][11] = int_stack + 52690;
 Libint->vrr_classes[10][6] = int_stack + 56980;
 Libint->vrr_classes[10][7] = int_stack + 58828;
 Libint->vrr_classes[10][8] = int_stack + 61204;
 Libint->vrr_classes[10][9] = int_stack + 64174;
 Libint->vrr_classes[10][10] = int_stack + 67804;
 Libint->vrr_classes[10][11] = int_stack + 72160;
 memset(int_stack,0,77308*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 77308;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhih(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+77308,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+79072,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+81340,int_stack+79072,int_stack+77308,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84868,int_stack+2289,int_stack+1344,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+87703,int_stack+84868,int_stack+79072,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+92239,int_stack+87703,int_stack+81340,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77308,int_stack+3444,int_stack+2289,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+98119,int_stack+77308,int_stack+84868,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+103789,int_stack+98119,int_stack+87703,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+80773,int_stack+103789,int_stack+92239,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+89593,int_stack+4830,int_stack+3444,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+111349,int_stack+89593,int_stack+77308,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+118279,int_stack+111349,int_stack+98119,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+89593,int_stack+118279,int_stack+103789,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+100933,int_stack+89593,int_stack+80773,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+77308,int_stack+7252,int_stack+6468,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+79660,int_stack+8260,int_stack+7252,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+82684,int_stack+79660,int_stack+77308,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+87388,int_stack+9520,int_stack+8260,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+91168,int_stack+87388,int_stack+79660,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+113281,int_stack+91168,int_stack+82684,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77308,int_stack+11060,int_stack+9520,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+77308,int_stack+87388,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+121121,int_stack+0,int_stack+91168,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+81928,int_stack+121121,int_stack+113281,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113281,int_stack+12908,int_stack+11060,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131201,int_stack+113281,int_stack+77308,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+140441,int_stack+131201,int_stack+0,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+153041,int_stack+140441,int_stack+121121,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+113281,int_stack+153041,int_stack+81928,28);
 /*--- compute (hp|ih) ---*/
 hrr1_build_hp(Libint->AB,int_stack+129745,int_stack+113281,int_stack+100933,588);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+16100,int_stack+15092,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3024,int_stack+17396,int_stack+16100,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+6912,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+77308,int_stack+19016,int_stack+17396,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+82168,int_stack+77308,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+89944,int_stack+82168,int_stack+6912,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+20996,int_stack+19016,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+5940,int_stack+0,int_stack+77308,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+100024,int_stack+5940,int_stack+82168,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+166789,int_stack+100024,int_stack+89944,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77308,int_stack+23372,int_stack+20996,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+84436,int_stack+77308,int_stack+0,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+181909,int_stack+84436,int_stack+5940,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+181909,int_stack+100024,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+77308,int_stack+0,int_stack+166789,36);
 /*--- compute (ip|ih) ---*/
 hrr1_build_ip(Libint->AB,int_stack+166789,int_stack+77308,int_stack+113281,588);
 /*--- compute (hd|ih) ---*/
 hrr1_build_hd(Libint->AB,int_stack+216181,int_stack+166789,int_stack+129745,588);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+27440,int_stack+26180,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3780,int_stack+29060,int_stack+27440,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8640,int_stack+3780,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16200,int_stack+31085,int_stack+29060,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+98476,int_stack+16200,int_stack+3780,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+108196,int_stack+98476,int_stack+8640,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+33560,int_stack+31085,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+120796,int_stack+0,int_stack+16200,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+7425,int_stack+120796,int_stack+98476,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+132946,int_stack+7425,int_stack+108196,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+98476,int_stack+36530,int_stack+33560,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23625,int_stack+98476,int_stack+0,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+98476,int_stack+23625,int_stack+120796,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+290269,int_stack+98476,int_stack+7425,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+98476,int_stack+290269,int_stack+132946,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+290269,int_stack+98476,int_stack+77308,588);
 /*--- compute (id|ih) ---*/
 hrr1_build_id(Libint->AB,int_stack+353773,int_stack+290269,int_stack+166789,588);
 /*--- compute (hf|ih) ---*/
 hrr1_build_hf(Libint->AB,int_stack+452557,int_stack+353773,int_stack+216181,588);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+77308,int_stack+41580,int_stack+40040,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+81928,int_stack+43560,int_stack+41580,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+87868,int_stack+81928,int_stack+77308,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124936,int_stack+46035,int_stack+43560,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+132361,int_stack+124936,int_stack+81928,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+144241,int_stack+132361,int_stack+87868,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77308,int_stack+49060,int_stack+46035,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+159641,int_stack+77308,int_stack+124936,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+174491,int_stack+159641,int_stack+132361,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+194291,int_stack+174491,int_stack+144241,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+124936,int_stack+52690,int_stack+49060,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+135826,int_stack+124936,int_stack+77308,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+217391,int_stack+135826,int_stack+159641,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+124936,int_stack+217391,int_stack+174491,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+217391,int_stack+124936,int_stack+194291,55);
 /*--- compute (lp|ih) ---*/
 hrr1_build_lp(Libint->AB,int_stack+124936,int_stack+217391,int_stack+98476,588);
 /*--- compute (kd|ih) ---*/
 hrr1_build_kd(Libint->AB,int_stack+576037,int_stack+124936,int_stack+290269,588);
 /*--- compute (if|ih) ---*/
 hrr1_build_if(Libint->AB,int_stack+703045,int_stack+576037,int_stack+353773,588);
 /*--- compute (hg|ih) ---*/
 hrr1_build_hg(Libint->AB,int_stack+249731,int_stack+703045,int_stack+452557,588);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+204316,int_stack+58828,int_stack+56980,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+209860,int_stack+61204,int_stack+58828,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+434951,int_stack+209860,int_stack+204316,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+446039,int_stack+64174,int_stack+61204,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+454949,int_stack+446039,int_stack+209860,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+469205,int_stack+454949,int_stack+434951,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+434951,int_stack+67804,int_stack+64174,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+487685,int_stack+434951,int_stack+446039,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+505505,int_stack+487685,int_stack+454949,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+529265,int_stack+505505,int_stack+469205,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+445841,int_stack+72160,int_stack+67804,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+458909,int_stack+445841,int_stack+434951,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+458909,int_stack+487685,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+434951,int_stack+0,int_stack+505505,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+434951,int_stack+529265,66);
 /*--- compute (mp|ih) ---*/
 hrr1_build_mp(Libint->AB,int_stack+434951,int_stack+0,int_stack+217391,588);
 /*--- compute (ld|ih) ---*/
 hrr1_build_ld(Libint->AB,int_stack+867685,int_stack+434951,int_stack+124936,588);
 /*--- compute (kf|ih) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+867685,int_stack+576037,588);
 /*--- compute (ig|ih) ---*/
 hrr1_build_ig(Libint->AB,int_stack+434951,int_stack+0,int_stack+703045,588);
 /*--- compute (hh|ih) ---*/
 hrr1_build_hh(Libint->AB,int_stack+681911,int_stack+434951,int_stack+249731,588);
 return int_stack+681911;}
