/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhkk(Libint_t*, prim_data*);

  /* Computes quartets of (hh|kk) integrals */

REALTYPE *hrr_order_hhkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[5][14] = int_stack + 9996;
 Libint->vrr_classes[6][7] = int_stack + 12516;
 Libint->vrr_classes[6][8] = int_stack + 13524;
 Libint->vrr_classes[6][9] = int_stack + 14784;
 Libint->vrr_classes[6][10] = int_stack + 16324;
 Libint->vrr_classes[6][11] = int_stack + 18172;
 Libint->vrr_classes[6][12] = int_stack + 20356;
 Libint->vrr_classes[6][13] = int_stack + 22904;
 Libint->vrr_classes[6][14] = int_stack + 25844;
 Libint->vrr_classes[7][7] = int_stack + 29204;
 Libint->vrr_classes[7][8] = int_stack + 30500;
 Libint->vrr_classes[7][9] = int_stack + 32120;
 Libint->vrr_classes[7][10] = int_stack + 34100;
 Libint->vrr_classes[7][11] = int_stack + 36476;
 Libint->vrr_classes[7][12] = int_stack + 39284;
 Libint->vrr_classes[7][13] = int_stack + 42560;
 Libint->vrr_classes[7][14] = int_stack + 46340;
 Libint->vrr_classes[8][7] = int_stack + 50660;
 Libint->vrr_classes[8][8] = int_stack + 52280;
 Libint->vrr_classes[8][9] = int_stack + 54305;
 Libint->vrr_classes[8][10] = int_stack + 56780;
 Libint->vrr_classes[8][11] = int_stack + 59750;
 Libint->vrr_classes[8][12] = int_stack + 63260;
 Libint->vrr_classes[8][13] = int_stack + 67355;
 Libint->vrr_classes[8][14] = int_stack + 72080;
 Libint->vrr_classes[9][7] = int_stack + 77480;
 Libint->vrr_classes[9][8] = int_stack + 79460;
 Libint->vrr_classes[9][9] = int_stack + 81935;
 Libint->vrr_classes[9][10] = int_stack + 84960;
 Libint->vrr_classes[9][11] = int_stack + 88590;
 Libint->vrr_classes[9][12] = int_stack + 92880;
 Libint->vrr_classes[9][13] = int_stack + 97885;
 Libint->vrr_classes[9][14] = int_stack + 103660;
 Libint->vrr_classes[10][7] = int_stack + 110260;
 Libint->vrr_classes[10][8] = int_stack + 112636;
 Libint->vrr_classes[10][9] = int_stack + 115606;
 Libint->vrr_classes[10][10] = int_stack + 119236;
 Libint->vrr_classes[10][11] = int_stack + 123592;
 Libint->vrr_classes[10][12] = int_stack + 128740;
 Libint->vrr_classes[10][13] = int_stack + 134746;
 Libint->vrr_classes[10][14] = int_stack + 141676;
 memset(int_stack,0,149596*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 149596;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhkk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+149596,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+151864,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+154699,int_stack+151864,int_stack+149596,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+159235,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+162700,int_stack+159235,int_stack+151864,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+168370,int_stack+162700,int_stack+154699,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149596,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175930,int_stack+149596,int_stack+159235,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+182860,int_stack+175930,int_stack+162700,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+153754,int_stack+182860,int_stack+168370,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+165094,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+192310,int_stack+165094,int_stack+149596,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+200626,int_stack+192310,int_stack+175930,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+212176,int_stack+200626,int_stack+182860,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+170008,int_stack+212176,int_stack+153754,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149596,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+226351,int_stack+149596,int_stack+165094,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+155329,int_stack+226351,int_stack+192310,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+236179,int_stack+155329,int_stack+200626,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+185884,int_stack+236179,int_stack+212176,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+253504,int_stack+185884,int_stack+170008,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+169189,int_stack+9996,int_stack+7791,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+205729,int_stack+169189,int_stack+149596,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+169189,int_stack+205729,int_stack+226351,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+205729,int_stack+169189,int_stack+155329,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+149596,int_stack+205729,int_stack+236179,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+205729,int_stack+149596,int_stack+185884,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+149596,int_stack+205729,int_stack+253504,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+176812,int_stack+13524,int_stack+12516,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+179836,int_stack+14784,int_stack+13524,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+183616,int_stack+179836,int_stack+176812,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+189664,int_stack+16324,int_stack+14784,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+194284,int_stack+189664,int_stack+179836,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+201844,int_stack+194284,int_stack+183616,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+176812,int_stack+18172,int_stack+16324,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+211924,int_stack+176812,int_stack+189664,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+221164,int_stack+211924,int_stack+194284,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+182356,int_stack+221164,int_stack+201844,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+197476,int_stack+20356,int_stack+18172,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+233764,int_stack+197476,int_stack+176812,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+244852,int_stack+233764,int_stack+211924,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+244852,int_stack+221164,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+204028,int_stack+0,int_stack+182356,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+176812,int_stack+22904,int_stack+20356,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+260252,int_stack+176812,int_stack+197476,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+184456,int_stack+260252,int_stack+233764,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+273356,int_stack+184456,int_stack+244852,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+225196,int_stack+273356,int_stack+0,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+296456,int_stack+225196,int_stack+204028,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+25844,int_stack+22904,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+176812,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+202936,int_stack+8820,int_stack+260252,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+202936,int_stack+184456,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+176812,int_stack+0,int_stack+273356,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+251656,int_stack+176812,int_stack+225196,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+176812,int_stack+251656,int_stack+296456,28);
 /*--- compute (hp|kk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+213100,int_stack+176812,int_stack+149596,1296);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+149596,int_stack+30500,int_stack+29204,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+153484,int_stack+32120,int_stack+30500,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+158344,int_stack+153484,int_stack+149596,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+166120,int_stack+34100,int_stack+32120,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+294748,int_stack+166120,int_stack+153484,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+304468,int_stack+294748,int_stack+158344,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149596,int_stack+36476,int_stack+34100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+149596,int_stack+166120,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+156724,int_stack+0,int_stack+294748,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+11880,int_stack+156724,int_stack+304468,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+294748,int_stack+39284,int_stack+36476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+303172,int_stack+294748,int_stack+149596,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+317428,int_stack+303172,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+337228,int_stack+317428,int_stack+156724,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+149596,int_stack+337228,int_stack+11880,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+42560,int_stack+39284,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+294748,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+361528,int_stack+9828,int_stack+303172,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+385288,int_stack+361528,int_stack+317428,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+294748,int_stack+385288,int_stack+337228,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+414988,int_stack+294748,int_stack+149596,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149596,int_stack+46340,int_stack+42560,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+328768,int_stack+149596,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+451276,int_stack+328768,int_stack+9828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+451276,int_stack+361528,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+328768,int_stack+0,int_stack+385288,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+328768,int_stack+294748,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+294748,int_stack+0,int_stack+414988,36);
 /*--- compute (ip|kk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+341404,int_stack+294748,int_stack+176812,1296);
 /*--- compute (hd|kk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+450268,int_stack+341404,int_stack+213100,1296);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+52280,int_stack+50660,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+54305,int_stack+52280,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10935,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20655,int_stack+56780,int_stack+54305,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+28080,int_stack+20655,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+40230,int_stack+28080,int_stack+10935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+59750,int_stack+56780,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+149596,int_stack+0,int_stack+20655,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+164446,int_stack+149596,int_stack+28080,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+8910,int_stack+164446,int_stack+40230,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33210,int_stack+63260,int_stack+59750,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43740,int_stack+33210,int_stack+0,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+184696,int_stack+43740,int_stack+149596,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+209446,int_stack+184696,int_stack+164446,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+149596,int_stack+209446,int_stack+8910,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+67355,int_stack+63260,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+239821,int_stack+0,int_stack+33210,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12285,int_stack+239821,int_stack+43740,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+613564,int_stack+12285,int_stack+184696,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+650689,int_stack+613564,int_stack+209446,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+183616,int_stack+650689,int_stack+149596,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149596,int_stack+72080,int_stack+67355,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+41985,int_stack+149596,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+693214,int_stack+41985,int_stack+239821,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+228976,int_stack+693214,int_stack+12285,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+228976,int_stack+613564,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+228976,int_stack+0,int_stack+650689,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+228976,int_stack+183616,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+149596,int_stack+0,int_stack+294748,1296);
 /*--- compute (id|kk) ---*/
 hrr1_build_id(Libint->AB,int_stack+613564,int_stack+149596,int_stack+341404,1296);
 /*--- compute (hf|kk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+831292,int_stack+613564,int_stack+450268,1296);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+58320,int_stack+79460,int_stack+77480,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+64260,int_stack+81935,int_stack+79460,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+289564,int_stack+64260,int_stack+58320,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+71685,int_stack+84960,int_stack+81935,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+301444,int_stack+71685,int_stack+64260,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+316294,int_stack+301444,int_stack+289564,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+289564,int_stack+88590,int_stack+84960,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+336094,int_stack+289564,int_stack+71685,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+58320,int_stack+336094,int_stack+301444,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+354244,int_stack+58320,int_stack+316294,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+300454,int_stack+92880,int_stack+88590,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+313324,int_stack+300454,int_stack+289564,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+383944,int_stack+313324,int_stack+336094,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+414194,int_stack+383944,int_stack+58320,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+451319,int_stack+414194,int_stack+354244,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+58320,int_stack+97885,int_stack+92880,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+335104,int_stack+58320,int_stack+300454,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+492899,int_stack+335104,int_stack+313324,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+289564,int_stack+492899,int_stack+383944,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+360844,int_stack+289564,int_stack+414194,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+529199,int_stack+360844,int_stack+451319,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+73335,int_stack+103660,int_stack+97885,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+412819,int_stack+73335,int_stack+58320,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+58320,int_stack+412819,int_stack+335104,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+412819,int_stack+58320,int_stack+492899,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1103452,int_stack+412819,int_stack+289564,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+289564,int_stack+1103452,int_stack+360844,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+358864,int_stack+289564,int_stack+529199,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+430144,int_stack+358864,int_stack+0,1296);
 /*--- compute (kd|kk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1103452,int_stack+430144,int_stack+149596,1296);
 /*--- compute (if|kk) ---*/
 hrr1_build_if(Libint->AB,int_stack+1383388,int_stack+1103452,int_stack+613564,1296);
 /*--- compute (hg|kk) ---*/
 hrr1_build_hg(Libint->AB,int_stack+1746268,int_stack+1383388,int_stack+831292,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+149596,int_stack+112636,int_stack+110260,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+156724,int_stack+115606,int_stack+112636,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+165634,int_stack+156724,int_stack+149596,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+179890,int_stack+119236,int_stack+115606,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+190780,int_stack+179890,int_stack+156724,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+208600,int_stack+190780,int_stack+165634,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149596,int_stack+123592,int_stack+119236,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+232360,int_stack+149596,int_stack+179890,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+254140,int_stack+232360,int_stack+190780,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+162664,int_stack+254140,int_stack+208600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+198304,int_stack+128740,int_stack+123592,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+283840,int_stack+198304,int_stack+149596,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+309976,int_stack+283840,int_stack+232360,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+309976,int_stack+254140,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+213748,int_stack+0,int_stack+162664,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149596,int_stack+134746,int_stack+128740,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+44550,int_stack+149596,int_stack+198304,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+167614,int_stack+44550,int_stack+283840,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+75438,int_stack+167614,int_stack+309976,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+263644,int_stack+75438,int_stack+0,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+605104,int_stack+263644,int_stack+213748,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+141676,int_stack+134746,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+211174,int_stack+0,int_stack+149596,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+671632,int_stack+211174,int_stack+44550,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+671632,int_stack+167614,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+671632,int_stack+0,int_stack+75438,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+671632,int_stack+263644,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+671632,int_stack+0,int_stack+605104,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+671632,int_stack+358864,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+605104,int_stack+0,int_stack+430144,1296);
 /*--- compute (kf|kk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+605104,int_stack+1103452,1296);
 /*--- compute (ig|kk) ---*/
 hrr1_build_ig(Libint->AB,int_stack+466560,int_stack+0,int_stack+1383388,1296);
 /*--- compute (hh|kk) ---*/
 hrr1_build_hh(Libint->AB,int_stack+1010880,int_stack+466560,int_stack+1746268,1296);
 return int_stack+1010880;}
