/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhld(Libint_t*, prim_data*);

  /* Computes quartets of (hh|ld) integrals */

REALTYPE *hrr_order_hhld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[6][8] = int_stack + 3486;
 Libint->vrr_classes[6][9] = int_stack + 4746;
 Libint->vrr_classes[6][10] = int_stack + 6286;
 Libint->vrr_classes[7][8] = int_stack + 8134;
 Libint->vrr_classes[7][9] = int_stack + 9754;
 Libint->vrr_classes[7][10] = int_stack + 11734;
 Libint->vrr_classes[8][8] = int_stack + 14110;
 Libint->vrr_classes[8][9] = int_stack + 16135;
 Libint->vrr_classes[8][10] = int_stack + 18610;
 Libint->vrr_classes[9][8] = int_stack + 21580;
 Libint->vrr_classes[9][9] = int_stack + 24055;
 Libint->vrr_classes[9][10] = int_stack + 27080;
 Libint->vrr_classes[10][8] = int_stack + 30710;
 Libint->vrr_classes[10][9] = int_stack + 33680;
 Libint->vrr_classes[10][10] = int_stack + 37310;
 memset(int_stack,0,41666*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 41666;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhld(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41666,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44501,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47966,int_stack+44501,int_stack+41666,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41666,int_stack+4746,int_stack+3486,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+6286,int_stack+4746,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+53636,int_stack+0,int_stack+41666,28);
 /*--- compute (hp|ld) ---*/
 hrr1_build_hp(Libint->AB,int_stack+61196,int_stack+53636,int_stack+47966,270);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41666,int_stack+9754,int_stack+8134,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46526,int_stack+11734,int_stack+9754,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+46526,int_stack+41666,36);
 /*--- compute (ip|ld) ---*/
 hrr1_build_ip(Libint->AB,int_stack+78206,int_stack+0,int_stack+53636,270);
 /*--- compute (hd|ld) ---*/
 hrr1_build_hd(Libint->AB,int_stack+100886,int_stack+78206,int_stack+61196,270);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41666,int_stack+16135,int_stack+14110,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47741,int_stack+18610,int_stack+16135,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+55166,int_stack+47741,int_stack+41666,45);
 /*--- compute (kp|ld) ---*/
 hrr1_build_kp(Libint->AB,int_stack+134906,int_stack+55166,int_stack+0,270);
 /*--- compute (id|ld) ---*/
 hrr1_build_id(Libint->AB,int_stack+164066,int_stack+134906,int_stack+78206,270);
 /*--- compute (hf|ld) ---*/
 hrr1_build_hf(Libint->AB,int_stack+209426,int_stack+164066,int_stack+100886,270);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+24055,int_stack+21580,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+27080,int_stack+24055,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+67316,int_stack+7425,int_stack+0,55);
 /*--- compute (lp|ld) ---*/
 hrr1_build_lp(Libint->AB,int_stack+82166,int_stack+67316,int_stack+55166,270);
 /*--- compute (kd|ld) ---*/
 hrr1_build_kd(Libint->AB,int_stack+266126,int_stack+82166,int_stack+134906,270);
 /*--- compute (if|ld) ---*/
 hrr1_build_if(Libint->AB,int_stack+324446,int_stack+266126,int_stack+164066,270);
 /*--- compute (hg|ld) ---*/
 hrr1_build_hg(Libint->AB,int_stack+118616,int_stack+324446,int_stack+209426,270);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+33680,int_stack+30710,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+37310,int_stack+33680,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (mp|ld) ---*/
 hrr1_build_mp(Libint->AB,int_stack+203666,int_stack+19800,int_stack+67316,270);
 /*--- compute (ld|ld) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+203666,int_stack+82166,270);
 /*--- compute (kf|ld) ---*/
 hrr1_build_kf(Libint->AB,int_stack+400046,int_stack+0,int_stack+266126,270);
 /*--- compute (ig|ld) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+400046,int_stack+324446,270);
 /*--- compute (hh|ld) ---*/
 hrr1_build_hh(Libint->AB,int_stack+203666,int_stack+0,int_stack+118616,270);
 return int_stack+203666;}
