/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhnd(Libint_t*, prim_data*);

  /* Computes quartets of (hh|nd) integrals */

REALTYPE *hrr_order_hhnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[6][10] = int_stack + 4935;
 Libint->vrr_classes[6][11] = int_stack + 6783;
 Libint->vrr_classes[6][12] = int_stack + 8967;
 Libint->vrr_classes[7][10] = int_stack + 11515;
 Libint->vrr_classes[7][11] = int_stack + 13891;
 Libint->vrr_classes[7][12] = int_stack + 16699;
 Libint->vrr_classes[8][10] = int_stack + 19975;
 Libint->vrr_classes[8][11] = int_stack + 22945;
 Libint->vrr_classes[8][12] = int_stack + 26455;
 Libint->vrr_classes[9][10] = int_stack + 30550;
 Libint->vrr_classes[9][11] = int_stack + 34180;
 Libint->vrr_classes[9][12] = int_stack + 38470;
 Libint->vrr_classes[10][10] = int_stack + 43475;
 Libint->vrr_classes[10][11] = int_stack + 47831;
 Libint->vrr_classes[10][12] = int_stack + 52979;
 memset(int_stack,0,58985*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 58985;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhnd(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58985,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63143,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+68057,int_stack+63143,int_stack+58985,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58985,int_stack+6783,int_stack+4935,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+8967,int_stack+6783,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+76373,int_stack+0,int_stack+58985,28);
 /*--- compute (hp|nd) ---*/
 hrr1_build_hp(Libint->AB,int_stack+87461,int_stack+76373,int_stack+68057,396);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58985,int_stack+13891,int_stack+11515,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66113,int_stack+16699,int_stack+13891,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+66113,int_stack+58985,36);
 /*--- compute (ip|nd) ---*/
 hrr1_build_ip(Libint->AB,int_stack+112409,int_stack+0,int_stack+76373,396);
 /*--- compute (hd|nd) ---*/
 hrr1_build_hd(Libint->AB,int_stack+145673,int_stack+112409,int_stack+87461,396);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58985,int_stack+22945,int_stack+19975,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67895,int_stack+26455,int_stack+22945,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+78425,int_stack+67895,int_stack+58985,45);
 /*--- compute (kp|nd) ---*/
 hrr1_build_kp(Libint->AB,int_stack+195569,int_stack+78425,int_stack+0,396);
 /*--- compute (id|nd) ---*/
 hrr1_build_id(Libint->AB,int_stack+238337,int_stack+195569,int_stack+112409,396);
 /*--- compute (hf|nd) ---*/
 hrr1_build_hf(Libint->AB,int_stack+304865,int_stack+238337,int_stack+145673,396);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+34180,int_stack+30550,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+38470,int_stack+34180,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+96245,int_stack+10890,int_stack+0,55);
 /*--- compute (lp|nd) ---*/
 hrr1_build_lp(Libint->AB,int_stack+118025,int_stack+96245,int_stack+78425,396);
 /*--- compute (kd|nd) ---*/
 hrr1_build_kd(Libint->AB,int_stack+388025,int_stack+118025,int_stack+195569,396);
 /*--- compute (if|nd) ---*/
 hrr1_build_if(Libint->AB,int_stack+473561,int_stack+388025,int_stack+238337,396);
 /*--- compute (hg|nd) ---*/
 hrr1_build_hg(Libint->AB,int_stack+171485,int_stack+473561,int_stack+304865,396);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+47831,int_stack+43475,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+52979,int_stack+47831,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (mp|nd) ---*/
 hrr1_build_mp(Libint->AB,int_stack+296225,int_stack+28512,int_stack+96245,396);
 /*--- compute (ld|nd) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+296225,int_stack+118025,396);
 /*--- compute (kf|nd) ---*/
 hrr1_build_kf(Libint->AB,int_stack+584441,int_stack+0,int_stack+388025,396);
 /*--- compute (ig|nd) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+584441,int_stack+473561,396);
 /*--- compute (hh|nd) ---*/
 hrr1_build_hh(Libint->AB,int_stack+296225,int_stack+0,int_stack+171485,396);
 return int_stack+296225;}
