/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhnh(Libint_t*, prim_data*);

  /* Computes quartets of (hh|nh) integrals */

REALTYPE *hrr_order_hhnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[6][10] = int_stack + 12516;
 Libint->vrr_classes[6][11] = int_stack + 14364;
 Libint->vrr_classes[6][12] = int_stack + 16548;
 Libint->vrr_classes[6][13] = int_stack + 19096;
 Libint->vrr_classes[6][14] = int_stack + 22036;
 Libint->vrr_classes[6][15] = int_stack + 25396;
 Libint->vrr_classes[7][10] = int_stack + 29204;
 Libint->vrr_classes[7][11] = int_stack + 31580;
 Libint->vrr_classes[7][12] = int_stack + 34388;
 Libint->vrr_classes[7][13] = int_stack + 37664;
 Libint->vrr_classes[7][14] = int_stack + 41444;
 Libint->vrr_classes[7][15] = int_stack + 45764;
 Libint->vrr_classes[8][10] = int_stack + 50660;
 Libint->vrr_classes[8][11] = int_stack + 53630;
 Libint->vrr_classes[8][12] = int_stack + 57140;
 Libint->vrr_classes[8][13] = int_stack + 61235;
 Libint->vrr_classes[8][14] = int_stack + 65960;
 Libint->vrr_classes[8][15] = int_stack + 71360;
 Libint->vrr_classes[9][10] = int_stack + 77480;
 Libint->vrr_classes[9][11] = int_stack + 81110;
 Libint->vrr_classes[9][12] = int_stack + 85400;
 Libint->vrr_classes[9][13] = int_stack + 90405;
 Libint->vrr_classes[9][14] = int_stack + 96180;
 Libint->vrr_classes[9][15] = int_stack + 102780;
 Libint->vrr_classes[10][10] = int_stack + 110260;
 Libint->vrr_classes[10][11] = int_stack + 114616;
 Libint->vrr_classes[10][12] = int_stack + 119764;
 Libint->vrr_classes[10][13] = int_stack + 125770;
 Libint->vrr_classes[10][14] = int_stack + 132700;
 Libint->vrr_classes[10][15] = int_stack + 140620;
 memset(int_stack,0,149596*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 149596;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhnh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149596,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+153754,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+158668,int_stack+153754,int_stack+149596,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+166984,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+172717,int_stack+166984,int_stack+153754,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+182545,int_stack+172717,int_stack+158668,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149596,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+196405,int_stack+149596,int_stack+166984,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+156211,int_stack+196405,int_stack+172717,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+207871,int_stack+156211,int_stack+182545,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+172591,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+180151,int_stack+172591,int_stack+149596,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+228661,int_stack+180151,int_stack+196405,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+172591,int_stack+228661,int_stack+156211,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+228661,int_stack+172591,int_stack+207871,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149596,int_stack+14364,int_stack+12516,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+155140,int_stack+16548,int_stack+14364,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+161692,int_stack+155140,int_stack+149596,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+172780,int_stack+19096,int_stack+16548,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+180424,int_stack+172780,int_stack+155140,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+193528,int_stack+180424,int_stack+161692,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149596,int_stack+22036,int_stack+19096,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+212008,int_stack+149596,int_stack+172780,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+158416,int_stack+212008,int_stack+180424,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+257767,int_stack+158416,int_stack+193528,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+180256,int_stack+25396,int_stack+22036,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+190336,int_stack+180256,int_stack+149596,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+190336,int_stack+212008,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+180256,int_stack+0,int_stack+158416,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+285487,int_stack+180256,int_stack+257767,28);
 /*--- compute (hp|nh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+324295,int_stack+285487,int_stack+228661,1386);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+31580,int_stack+29204,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+34388,int_stack+31580,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15552,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149596,int_stack+37664,int_stack+34388,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+159424,int_stack+149596,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+176272,int_stack+159424,int_stack+15552,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+41444,int_stack+37664,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11340,int_stack+0,int_stack+149596,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+200032,int_stack+11340,int_stack+159424,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+228112,int_stack+200032,int_stack+176272,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+149596,int_stack+45764,int_stack+41444,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+162556,int_stack+149596,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+411613,int_stack+162556,int_stack+11340,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+411613,int_stack+200032,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+149596,int_stack+0,int_stack+228112,36);
 /*--- compute (ip|nh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+411613,int_stack+149596,int_stack+285487,1386);
 /*--- compute (hd|nh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+528037,int_stack+411613,int_stack+324295,1386);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+53630,int_stack+50660,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+57140,int_stack+53630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37260,int_stack+61235,int_stack+57140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+199492,int_stack+37260,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+220552,int_stack+199492,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+65960,int_stack+61235,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+250252,int_stack+0,int_stack+37260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+14175,int_stack+250252,int_stack+199492,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+274822,int_stack+14175,int_stack+220552,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+199492,int_stack+71360,int_stack+65960,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+215692,int_stack+199492,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+319372,int_stack+215692,int_stack+250252,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+199492,int_stack+319372,int_stack+14175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+319372,int_stack+199492,int_stack+274822,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+702673,int_stack+319372,int_stack+149596,1386);
 /*--- compute (id|nh) ---*/
 hrr1_build_id(Libint->AB,int_stack+852361,int_stack+702673,int_stack+411613,1386);
 /*--- compute (hf|nh) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1085209,int_stack+852361,int_stack+528037,1386);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149596,int_stack+81110,int_stack+77480,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+160486,int_stack+85400,int_stack+81110,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+173356,int_stack+160486,int_stack+149596,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+195136,int_stack+90405,int_stack+85400,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+210151,int_stack+195136,int_stack+160486,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+235891,int_stack+210151,int_stack+173356,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149596,int_stack+96180,int_stack+90405,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+272191,int_stack+149596,int_stack+195136,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+166921,int_stack+272191,int_stack+210151,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+381742,int_stack+166921,int_stack+235891,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+209821,int_stack+102780,int_stack+96180,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+229621,int_stack+209821,int_stack+149596,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+436192,int_stack+229621,int_stack+272191,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+209821,int_stack+436192,int_stack+166921,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+436192,int_stack+209821,int_stack+381742,55);
 /*--- compute (lp|nh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+512422,int_stack+436192,int_stack+319372,1386);
 /*--- compute (kd|nh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1376269,int_stack+512422,int_stack+702673,1386);
 /*--- compute (if|nh) ---*/
 hrr1_build_if(Libint->AB,int_stack+1675645,int_stack+1376269,int_stack+852361,1386);
 /*--- compute (hg|nh) ---*/
 hrr1_build_hg(Libint->AB,int_stack+2063725,int_stack+1675645,int_stack+1085209,1386);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+699532,int_stack+114616,int_stack+110260,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+712600,int_stack+119764,int_stack+114616,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+728044,int_stack+712600,int_stack+699532,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+754180,int_stack+125770,int_stack+119764,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+772198,int_stack+754180,int_stack+712600,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+803086,int_stack+772198,int_stack+728044,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+699532,int_stack+132700,int_stack+125770,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+846646,int_stack+699532,int_stack+754180,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+720322,int_stack+846646,int_stack+772198,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+882682,int_stack+720322,int_stack+803086,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+771802,int_stack+140620,int_stack+132700,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+795562,int_stack+771802,int_stack+699532,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+948022,int_stack+795562,int_stack+846646,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+771802,int_stack+948022,int_stack+720322,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+948022,int_stack+771802,int_stack+882682,66);
 /*--- compute (mp|nh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1039498,int_stack+948022,int_stack+436192,1386);
 /*--- compute (ld|nh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+1039498,int_stack+512422,1386);
 /*--- compute (kf|nh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+374220,int_stack+0,int_stack+1376269,1386);
 /*--- compute (ig|nh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+873180,int_stack+374220,int_stack+1675645,1386);
 /*--- compute (hh|nh) ---*/
 hrr1_build_hh(Libint->AB,int_stack+0,int_stack+873180,int_stack+2063725,1386);
 return int_stack+0;}
