/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpll(Libint_t*, prim_data*);

  /* Computes quartets of (hp|ll) integrals */

REALTYPE *hrr_order_hpll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 Libint->vrr_classes[5][15] = int_stack + 11760;
 Libint->vrr_classes[5][16] = int_stack + 14616;
 Libint->vrr_classes[6][8] = int_stack + 17829;
 Libint->vrr_classes[6][9] = int_stack + 19089;
 Libint->vrr_classes[6][10] = int_stack + 20629;
 Libint->vrr_classes[6][11] = int_stack + 22477;
 Libint->vrr_classes[6][12] = int_stack + 24661;
 Libint->vrr_classes[6][13] = int_stack + 27209;
 Libint->vrr_classes[6][14] = int_stack + 30149;
 Libint->vrr_classes[6][15] = int_stack + 33509;
 Libint->vrr_classes[6][16] = int_stack + 37317;
 memset(int_stack,0,41601*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 41601;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpll(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41601,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44436,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47901,int_stack+44436,int_stack+41601,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53571,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+57729,int_stack+53571,int_stack+44436,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+64659,int_stack+57729,int_stack+47901,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41601,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+74109,int_stack+41601,int_stack+53571,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+82425,int_stack+74109,int_stack+57729,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+46515,int_stack+82425,int_stack+64659,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+60690,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+93975,int_stack+60690,int_stack+41601,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+103803,int_stack+93975,int_stack+74109,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+117663,int_stack+103803,int_stack+82425,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+66423,int_stack+117663,int_stack+46515,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+41601,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+48216,int_stack+41601,int_stack+60690,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+134988,int_stack+48216,int_stack+93975,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+151368,int_stack+134988,int_stack+103803,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+86268,int_stack+151368,int_stack+117663,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+172158,int_stack+86268,int_stack+66423,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+59682,int_stack+11760,int_stack+9240,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+67242,int_stack+59682,int_stack+41601,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+110523,int_stack+67242,int_stack+48216,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+198618,int_stack+110523,int_stack+134988,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+223188,int_stack+198618,int_stack+151368,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+129633,int_stack+223188,int_stack+86268,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+252294,int_stack+129633,int_stack+172158,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+41601,int_stack+14616,int_stack+11760,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+80472,int_stack+41601,int_stack+59682,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+41601,int_stack+80472,int_stack+67242,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+63651,int_stack+41601,int_stack+110523,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+92316,int_stack+63651,int_stack+198618,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+41601,int_stack+92316,int_stack+223188,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+80409,int_stack+41601,int_stack+129633,21);
 /*--- compute (h0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+121989,int_stack+80409,int_stack+252294,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41601,int_stack+19089,int_stack+17829,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+45381,int_stack+20629,int_stack+19089,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+50001,int_stack+45381,int_stack+41601,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+57561,int_stack+22477,int_stack+20629,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+63105,int_stack+57561,int_stack+45381,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72345,int_stack+63105,int_stack+50001,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41601,int_stack+24661,int_stack+22477,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84945,int_stack+41601,int_stack+57561,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+96033,int_stack+84945,int_stack+63105,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+48153,int_stack+96033,int_stack+72345,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+67053,int_stack+27209,int_stack+24661,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+164514,int_stack+67053,int_stack+41601,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+177618,int_stack+164514,int_stack+84945,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+196098,int_stack+177618,int_stack+96033,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+74697,int_stack+196098,int_stack+48153,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+41601,int_stack+30149,int_stack+27209,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+50421,int_stack+41601,int_stack+67053,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+219198,int_stack+50421,int_stack+164514,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+241038,int_stack+219198,int_stack+177618,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+268758,int_stack+241038,int_stack+196098,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+164514,int_stack+268758,int_stack+74697,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+199794,int_stack+33509,int_stack+30149,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+65709,int_stack+199794,int_stack+41601,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+83349,int_stack+65709,int_stack+50421,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+83349,int_stack+219198,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+301098,int_stack+0,int_stack+241038,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+209874,int_stack+301098,int_stack+268758,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+252994,int_stack+209874,int_stack+164514,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+164514,int_stack+37317,int_stack+33509,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+175938,int_stack+164514,int_stack+199794,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+32760,int_stack+175938,int_stack+65709,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+164514,int_stack+32760,int_stack+83349,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+32760,int_stack+164514,int_stack+0,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+339906,int_stack+32760,int_stack+301098,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+339906,int_stack+209874,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+55440,int_stack+0,int_stack+252994,28);
 /*--- compute (hp|ll) ---*/
 hrr1_build_hp(Libint->AB,int_stack+164514,int_stack+55440,int_stack+121989,2025);
 return int_stack+164514;}
