/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpnh(Libint_t*, prim_data*);

  /* Computes quartets of (hp|nh) integrals */

REALTYPE *hrr_order_hpnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[6][10] = int_stack + 12516;
 Libint->vrr_classes[6][11] = int_stack + 14364;
 Libint->vrr_classes[6][12] = int_stack + 16548;
 Libint->vrr_classes[6][13] = int_stack + 19096;
 Libint->vrr_classes[6][14] = int_stack + 22036;
 Libint->vrr_classes[6][15] = int_stack + 25396;
 memset(int_stack,0,29204*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29204;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpnh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29204,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33362,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+38276,int_stack+33362,int_stack+29204,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+46592,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+52325,int_stack+46592,int_stack+33362,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+62153,int_stack+52325,int_stack+38276,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+29204,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+76013,int_stack+29204,int_stack+46592,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+35819,int_stack+76013,int_stack+52325,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+87479,int_stack+35819,int_stack+62153,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+52199,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+59759,int_stack+52199,int_stack+29204,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+108269,int_stack+59759,int_stack+76013,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+52199,int_stack+108269,int_stack+35819,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+108269,int_stack+52199,int_stack+87479,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29204,int_stack+14364,int_stack+12516,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+34748,int_stack+16548,int_stack+14364,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41300,int_stack+34748,int_stack+29204,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+52388,int_stack+19096,int_stack+16548,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60032,int_stack+52388,int_stack+34748,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+73136,int_stack+60032,int_stack+41300,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+29204,int_stack+22036,int_stack+19096,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+91616,int_stack+29204,int_stack+52388,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+38024,int_stack+91616,int_stack+60032,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+137375,int_stack+38024,int_stack+73136,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+59864,int_stack+25396,int_stack+22036,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+69944,int_stack+59864,int_stack+29204,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+69944,int_stack+91616,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+59864,int_stack+0,int_stack+38024,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+59864,int_stack+137375,28);
 /*--- compute (hp|nh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+137375,int_stack+0,int_stack+108269,1386);
 return int_stack+137375;}
