/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idnh(Libint_t*, prim_data*);

  /* Computes quartets of (id|nh) integrals */

REALTYPE *hrr_order_idnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[7][10] = int_stack + 16688;
 Libint->vrr_classes[7][11] = int_stack + 19064;
 Libint->vrr_classes[7][12] = int_stack + 21872;
 Libint->vrr_classes[7][13] = int_stack + 25148;
 Libint->vrr_classes[7][14] = int_stack + 28928;
 Libint->vrr_classes[7][15] = int_stack + 33248;
 Libint->vrr_classes[8][10] = int_stack + 38144;
 Libint->vrr_classes[8][11] = int_stack + 41114;
 Libint->vrr_classes[8][12] = int_stack + 44624;
 Libint->vrr_classes[8][13] = int_stack + 48719;
 Libint->vrr_classes[8][14] = int_stack + 53444;
 Libint->vrr_classes[8][15] = int_stack + 58844;
 memset(int_stack,0,64964*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 64964;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idnh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64964,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+70508,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+77060,int_stack+70508,int_stack+64964,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+88148,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+95792,int_stack+88148,int_stack+70508,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+108896,int_stack+95792,int_stack+77060,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+64964,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+127376,int_stack+64964,int_stack+88148,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+73784,int_stack+127376,int_stack+95792,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+142664,int_stack+73784,int_stack+108896,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+95624,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+105704,int_stack+95624,int_stack+64964,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+170384,int_stack+105704,int_stack+127376,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+95624,int_stack+170384,int_stack+73784,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+170384,int_stack+95624,int_stack+142664,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64964,int_stack+19064,int_stack+16688,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72092,int_stack+21872,int_stack+19064,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+80516,int_stack+72092,int_stack+64964,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+94772,int_stack+25148,int_stack+21872,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+104600,int_stack+94772,int_stack+72092,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+121448,int_stack+104600,int_stack+80516,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+64964,int_stack+28928,int_stack+25148,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+145208,int_stack+64964,int_stack+94772,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+76304,int_stack+145208,int_stack+104600,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+209192,int_stack+76304,int_stack+121448,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+104384,int_stack+33248,int_stack+28928,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+117344,int_stack+104384,int_stack+64964,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+117344,int_stack+145208,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+104384,int_stack+0,int_stack+76304,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+244832,int_stack+104384,int_stack+209192,36);
 /*--- compute (ip|nh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+294728,int_stack+244832,int_stack+170384,1386);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+41114,int_stack+38144,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+44624,int_stack+41114,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64964,int_stack+48719,int_stack+44624,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+77249,int_stack+64964,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+98309,int_stack+77249,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+53444,int_stack+48719,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+14175,int_stack+0,int_stack+64964,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+128009,int_stack+14175,int_stack+77249,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+163109,int_stack+128009,int_stack+98309,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+64964,int_stack+58844,int_stack+53444,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+81164,int_stack+64964,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+38745,int_stack+81164,int_stack+14175,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+411152,int_stack+38745,int_stack+128009,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+411152,int_stack+163109,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+62370,int_stack+0,int_stack+244832,1386);
 /*--- compute (id|nh) ---*/
 hrr1_build_id(Libint->AB,int_stack+411152,int_stack+62370,int_stack+294728,1386);
 return int_stack+411152;}
