/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifll(Libint_t*, prim_data*);

  /* Computes quartets of (if|ll) integrals */

REALTYPE *hrr_order_ifll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 Libint->vrr_classes[6][16] = int_stack + 19488;
 Libint->vrr_classes[7][8] = int_stack + 23772;
 Libint->vrr_classes[7][9] = int_stack + 25392;
 Libint->vrr_classes[7][10] = int_stack + 27372;
 Libint->vrr_classes[7][11] = int_stack + 29748;
 Libint->vrr_classes[7][12] = int_stack + 32556;
 Libint->vrr_classes[7][13] = int_stack + 35832;
 Libint->vrr_classes[7][14] = int_stack + 39612;
 Libint->vrr_classes[7][15] = int_stack + 43932;
 Libint->vrr_classes[7][16] = int_stack + 48828;
 Libint->vrr_classes[8][8] = int_stack + 54336;
 Libint->vrr_classes[8][9] = int_stack + 56361;
 Libint->vrr_classes[8][10] = int_stack + 58836;
 Libint->vrr_classes[8][11] = int_stack + 61806;
 Libint->vrr_classes[8][12] = int_stack + 65316;
 Libint->vrr_classes[8][13] = int_stack + 69411;
 Libint->vrr_classes[8][14] = int_stack + 74136;
 Libint->vrr_classes[8][15] = int_stack + 79536;
 Libint->vrr_classes[8][16] = int_stack + 85656;
 Libint->vrr_classes[9][8] = int_stack + 92541;
 Libint->vrr_classes[9][9] = int_stack + 95016;
 Libint->vrr_classes[9][10] = int_stack + 98041;
 Libint->vrr_classes[9][11] = int_stack + 101671;
 Libint->vrr_classes[9][12] = int_stack + 105961;
 Libint->vrr_classes[9][13] = int_stack + 110966;
 Libint->vrr_classes[9][14] = int_stack + 116741;
 Libint->vrr_classes[9][15] = int_stack + 123341;
 Libint->vrr_classes[9][16] = int_stack + 130821;
 memset(int_stack,0,139236*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 139236;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifll(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+139236,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+143016,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+147636,int_stack+143016,int_stack+139236,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+155196,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+160740,int_stack+155196,int_stack+143016,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+169980,int_stack+160740,int_stack+147636,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+139236,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+182580,int_stack+139236,int_stack+155196,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+193668,int_stack+182580,int_stack+160740,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+145788,int_stack+193668,int_stack+169980,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+164688,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+209068,int_stack+164688,int_stack+139236,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+222172,int_stack+209068,int_stack+182580,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+240652,int_stack+222172,int_stack+193668,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+172332,int_stack+240652,int_stack+145788,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+139236,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+148056,int_stack+139236,int_stack+164688,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+263752,int_stack+148056,int_stack+209068,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+285592,int_stack+263752,int_stack+222172,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+198792,int_stack+285592,int_stack+240652,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+313312,int_stack+198792,int_stack+172332,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+163344,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+173424,int_stack+163344,int_stack+139236,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+231132,int_stack+173424,int_stack+148056,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+348592,int_stack+231132,int_stack+263752,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+381352,int_stack+348592,int_stack+285592,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+256612,int_stack+381352,int_stack+198792,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+420160,int_stack+256612,int_stack+313312,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+139236,int_stack+19488,int_stack+15680,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+191064,int_stack+139236,int_stack+163344,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+139236,int_stack+191064,int_stack+173424,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+168636,int_stack+139236,int_stack+231132,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+206856,int_stack+168636,int_stack+348592,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+139236,int_stack+206856,int_stack+381352,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+190980,int_stack+139236,int_stack+256612,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+246420,int_stack+190980,int_stack+420160,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+139236,int_stack+25392,int_stack+23772,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+144096,int_stack+27372,int_stack+25392,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+150036,int_stack+144096,int_stack+139236,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+159756,int_stack+29748,int_stack+27372,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+166884,int_stack+159756,int_stack+144096,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+178764,int_stack+166884,int_stack+150036,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+139236,int_stack+32556,int_stack+29748,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+194964,int_stack+139236,int_stack+159756,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+209220,int_stack+194964,int_stack+166884,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+147660,int_stack+209220,int_stack+178764,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+171960,int_stack+35832,int_stack+32556,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+229020,int_stack+171960,int_stack+139236,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+303120,int_stack+229020,int_stack+194964,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+326880,int_stack+303120,int_stack+209220,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+181788,int_stack+326880,int_stack+147660,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+139236,int_stack+39612,int_stack+35832,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+150576,int_stack+139236,int_stack+171960,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+356580,int_stack+150576,int_stack+229020,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+384660,int_stack+356580,int_stack+303120,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+420300,int_stack+384660,int_stack+326880,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+303120,int_stack+420300,int_stack+181788,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+170232,int_stack+43932,int_stack+39612,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+183192,int_stack+170232,int_stack+139236,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+205872,int_stack+183192,int_stack+150576,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+205872,int_stack+356580,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+461880,int_stack+0,int_stack+384660,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+348480,int_stack+461880,int_stack+420300,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+511776,int_stack+348480,int_stack+303120,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+303120,int_stack+48828,int_stack+43932,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+317808,int_stack+303120,int_stack+170232,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+139236,int_stack+317808,int_stack+183192,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+403920,int_stack+139236,int_stack+205872,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+139236,int_stack+403920,int_stack+0,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+570096,int_stack+139236,int_stack+461880,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+139236,int_stack+570096,int_stack+348480,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+303120,int_stack+139236,int_stack+511776,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+376020,int_stack+303120,int_stack+246420,2025);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+139236,int_stack+56361,int_stack+54336,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+145311,int_stack+58836,int_stack+56361,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+152736,int_stack+145311,int_stack+139236,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+164886,int_stack+61806,int_stack+58836,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+173796,int_stack+164886,int_stack+145311,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+188646,int_stack+173796,int_stack+152736,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+139236,int_stack+65316,int_stack+61806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+208896,int_stack+139236,int_stack+164886,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+226716,int_stack+208896,int_stack+173796,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+149766,int_stack+226716,int_stack+188646,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+180141,int_stack+69411,int_stack+65316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+251466,int_stack+180141,int_stack+139236,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+272526,int_stack+251466,int_stack+208896,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+272526,int_stack+226716,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+192426,int_stack+0,int_stack+149766,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+139236,int_stack+74136,int_stack+69411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+153411,int_stack+139236,int_stack+180141,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37125,int_stack+153411,int_stack+251466,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+546120,int_stack+37125,int_stack+272526,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+234951,int_stack+546120,int_stack+0,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+590670,int_stack+234951,int_stack+192426,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+79536,int_stack+74136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+177981,int_stack+0,int_stack+139236,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+647370,int_stack+177981,int_stack+153411,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+688320,int_stack+647370,int_stack+37125,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16200,int_stack+688320,int_stack+546120,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+740970,int_stack+16200,int_stack+234951,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+206331,int_stack+740970,int_stack+590670,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+546120,int_stack+85656,int_stack+79536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+564480,int_stack+546120,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+596880,int_stack+564480,int_stack+177981,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+139236,int_stack+596880,int_stack+647370,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+546120,int_stack+139236,int_stack+688320,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+619830,int_stack+546120,int_stack+16200,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+619830,int_stack+740970,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+546120,int_stack+0,int_stack+206331,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+637245,int_stack+546120,int_stack+303120,2025);
 /*--- compute (id|ll) ---*/
 hrr1_build_id(Libint->AB,int_stack+855945,int_stack+637245,int_stack+376020,2025);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+95016,int_stack+92541,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+98041,int_stack+95016,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31350,int_stack+101671,int_stack+98041,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42240,int_stack+31350,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+60390,int_stack+42240,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+105961,int_stack+101671,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139236,int_stack+0,int_stack+31350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+161016,int_stack+139236,int_stack+42240,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+12870,int_stack+161016,int_stack+60390,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49995,int_stack+110966,int_stack+105961,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+65010,int_stack+49995,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+191266,int_stack+65010,int_stack+139236,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+227566,int_stack+191266,int_stack+161016,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+139236,int_stack+227566,int_stack+12870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+116741,int_stack+110966,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+49995,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+272941,int_stack+17325,int_stack+65010,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+47355,int_stack+272941,int_stack+191266,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+315841,int_stack+47355,int_stack+227566,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+191211,int_stack+315841,int_stack+139236,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+139236,int_stack+123341,int_stack+116741,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+379366,int_stack+139236,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+414016,int_stack+379366,int_stack+17325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+464066,int_stack+414016,int_stack+272941,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1196145,int_stack+464066,int_stack+47355,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1196145,int_stack+315841,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+260511,int_stack+0,int_stack+191211,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+84700,int_stack+130821,int_stack+123341,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+159036,int_stack+84700,int_stack+139236,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+84700,int_stack+159036,int_stack+379366,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+142450,int_stack+84700,int_stack+414016,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+349611,int_stack+142450,int_stack+464066,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+84700,int_stack+349611,int_stack+1196145,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+349611,int_stack+84700,int_stack+0,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+349611,int_stack+260511,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+111375,int_stack+0,int_stack+546120,2025);
 /*--- compute (kd|ll) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1196145,int_stack+111375,int_stack+637245,2025);
 /*--- compute (if|ll) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+1196145,int_stack+855945,2025);
 return int_stack+0;}
