/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifnh(Libint_t*, prim_data*);

  /* Computes quartets of (if|nh) integrals */

REALTYPE *hrr_order_ifnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[7][10] = int_stack + 16688;
 Libint->vrr_classes[7][11] = int_stack + 19064;
 Libint->vrr_classes[7][12] = int_stack + 21872;
 Libint->vrr_classes[7][13] = int_stack + 25148;
 Libint->vrr_classes[7][14] = int_stack + 28928;
 Libint->vrr_classes[7][15] = int_stack + 33248;
 Libint->vrr_classes[8][10] = int_stack + 38144;
 Libint->vrr_classes[8][11] = int_stack + 41114;
 Libint->vrr_classes[8][12] = int_stack + 44624;
 Libint->vrr_classes[8][13] = int_stack + 48719;
 Libint->vrr_classes[8][14] = int_stack + 53444;
 Libint->vrr_classes[8][15] = int_stack + 58844;
 Libint->vrr_classes[9][10] = int_stack + 64964;
 Libint->vrr_classes[9][11] = int_stack + 68594;
 Libint->vrr_classes[9][12] = int_stack + 72884;
 Libint->vrr_classes[9][13] = int_stack + 77889;
 Libint->vrr_classes[9][14] = int_stack + 83664;
 Libint->vrr_classes[9][15] = int_stack + 90264;
 memset(int_stack,0,97744*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 97744;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifnh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+97744,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103288,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+109840,int_stack+103288,int_stack+97744,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+120928,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+128572,int_stack+120928,int_stack+103288,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+141676,int_stack+128572,int_stack+109840,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+97744,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+160156,int_stack+97744,int_stack+120928,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+106564,int_stack+160156,int_stack+128572,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175444,int_stack+106564,int_stack+141676,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+128404,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+138484,int_stack+128404,int_stack+97744,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+203164,int_stack+138484,int_stack+160156,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+128404,int_stack+203164,int_stack+106564,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+203164,int_stack+128404,int_stack+175444,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+97744,int_stack+19064,int_stack+16688,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+104872,int_stack+21872,int_stack+19064,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113296,int_stack+104872,int_stack+97744,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+127552,int_stack+25148,int_stack+21872,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+137380,int_stack+127552,int_stack+104872,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+154228,int_stack+137380,int_stack+113296,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+97744,int_stack+28928,int_stack+25148,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+177988,int_stack+97744,int_stack+127552,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+109084,int_stack+177988,int_stack+137380,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+241972,int_stack+109084,int_stack+154228,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+137164,int_stack+33248,int_stack+28928,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+150124,int_stack+137164,int_stack+97744,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+150124,int_stack+177988,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+137164,int_stack+0,int_stack+109084,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+277612,int_stack+137164,int_stack+241972,36);
 /*--- compute (ip|nh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+327508,int_stack+277612,int_stack+203164,1386);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+41114,int_stack+38144,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+44624,int_stack+41114,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+97744,int_stack+48719,int_stack+44624,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+110029,int_stack+97744,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+131089,int_stack+110029,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+53444,int_stack+48719,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+14175,int_stack+0,int_stack+97744,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+160789,int_stack+14175,int_stack+110029,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+195889,int_stack+160789,int_stack+131089,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+97744,int_stack+58844,int_stack+53444,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113944,int_stack+97744,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+443932,int_stack+113944,int_stack+14175,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+443932,int_stack+160789,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+97744,int_stack+0,int_stack+195889,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+443932,int_stack+97744,int_stack+277612,1386);
 /*--- compute (id|nh) ---*/
 hrr1_build_id(Libint->AB,int_stack+593620,int_stack+443932,int_stack+327508,1386);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+68594,int_stack+64964,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+72884,int_stack+68594,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+77889,int_stack+72884,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+160114,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+185854,int_stack+160114,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+83664,int_stack+77889,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+222154,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+222154,int_stack+160114,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+252184,int_stack+17325,int_stack+185854,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+160114,int_stack+90264,int_stack+83664,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+179914,int_stack+160114,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+306634,int_stack+179914,int_stack+222154,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+160114,int_stack+306634,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+306634,int_stack+160114,int_stack+252184,55);
 /*--- compute (lp|nh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+826468,int_stack+306634,int_stack+97744,1386);
 /*--- compute (kd|nh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+826468,int_stack+443932,1386);
 /*--- compute (if|nh) ---*/
 hrr1_build_if(Libint->AB,int_stack+826468,int_stack+0,int_stack+593620,1386);
 return int_stack+826468;}
