/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifnl(Libint_t*, prim_data*);

  /* Computes quartets of (if|nl) integrals */

REALTYPE *hrr_order_ifnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[7][10] = int_stack + 31080;
 Libint->vrr_classes[7][11] = int_stack + 33456;
 Libint->vrr_classes[7][12] = int_stack + 36264;
 Libint->vrr_classes[7][13] = int_stack + 39540;
 Libint->vrr_classes[7][14] = int_stack + 43320;
 Libint->vrr_classes[7][15] = int_stack + 47640;
 Libint->vrr_classes[7][16] = int_stack + 52536;
 Libint->vrr_classes[7][17] = int_stack + 58044;
 Libint->vrr_classes[7][18] = int_stack + 64200;
 Libint->vrr_classes[8][10] = int_stack + 71040;
 Libint->vrr_classes[8][11] = int_stack + 74010;
 Libint->vrr_classes[8][12] = int_stack + 77520;
 Libint->vrr_classes[8][13] = int_stack + 81615;
 Libint->vrr_classes[8][14] = int_stack + 86340;
 Libint->vrr_classes[8][15] = int_stack + 91740;
 Libint->vrr_classes[8][16] = int_stack + 97860;
 Libint->vrr_classes[8][17] = int_stack + 104745;
 Libint->vrr_classes[8][18] = int_stack + 112440;
 Libint->vrr_classes[9][10] = int_stack + 120990;
 Libint->vrr_classes[9][11] = int_stack + 124620;
 Libint->vrr_classes[9][12] = int_stack + 128910;
 Libint->vrr_classes[9][13] = int_stack + 133915;
 Libint->vrr_classes[9][14] = int_stack + 139690;
 Libint->vrr_classes[9][15] = int_stack + 146290;
 Libint->vrr_classes[9][16] = int_stack + 153770;
 Libint->vrr_classes[9][17] = int_stack + 162185;
 Libint->vrr_classes[9][18] = int_stack + 171590;
 memset(int_stack,0,182040*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 182040;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifnl(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+182040,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+187584,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+194136,int_stack+187584,int_stack+182040,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+205224,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+212868,int_stack+205224,int_stack+187584,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+225972,int_stack+212868,int_stack+194136,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+182040,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+244452,int_stack+182040,int_stack+205224,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+190860,int_stack+244452,int_stack+212868,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+259740,int_stack+190860,int_stack+225972,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+212700,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222780,int_stack+212700,int_stack+182040,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+287460,int_stack+222780,int_stack+244452,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+312940,int_stack+287460,int_stack+190860,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+345700,int_stack+312940,int_stack+259740,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+182040,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+240420,int_stack+182040,int_stack+212700,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+384508,int_stack+240420,int_stack+222780,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+193464,int_stack+384508,int_stack+287460,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+260580,int_stack+193464,int_stack+312940,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+413908,int_stack+260580,int_stack+345700,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+306444,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+319296,int_stack+306444,int_stack+182040,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+342144,int_stack+319296,int_stack+240420,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+465652,int_stack+342144,int_stack+384508,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+509752,int_stack+465652,int_stack+193464,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+182040,int_stack+509752,int_stack+260580,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+563260,int_stack+182040,int_stack+413908,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+243192,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+257556,int_stack+243192,int_stack+306444,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+375744,int_stack+257556,int_stack+319296,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+243192,int_stack+375744,int_stack+342144,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+293592,int_stack+243192,int_stack+465652,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+355332,int_stack+293592,int_stack+509752,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+243192,int_stack+355332,int_stack+182040,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+321816,int_stack+243192,int_stack+563260,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+182040,int_stack+33456,int_stack+31080,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+189168,int_stack+36264,int_stack+33456,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+197592,int_stack+189168,int_stack+182040,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+211848,int_stack+39540,int_stack+36264,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+221676,int_stack+211848,int_stack+189168,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238524,int_stack+221676,int_stack+197592,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+182040,int_stack+43320,int_stack+39540,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+262284,int_stack+182040,int_stack+211848,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+193380,int_stack+262284,int_stack+221676,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+281940,int_stack+193380,int_stack+238524,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+221460,int_stack+47640,int_stack+43320,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+234420,int_stack+221460,int_stack+182040,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+404976,int_stack+234420,int_stack+262284,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+437736,int_stack+404976,int_stack+193380,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+479856,int_stack+437736,int_stack+281940,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+182040,int_stack+52536,int_stack+47640,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+257100,int_stack+182040,int_stack+221460,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+283020,int_stack+257100,int_stack+234420,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+196728,int_stack+283020,int_stack+404976,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+529752,int_stack+196728,int_stack+437736,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+404976,int_stack+529752,int_stack+479856,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+471504,int_stack+58044,int_stack+52536,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+488028,int_stack+471504,int_stack+182040,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+488028,int_stack+257100,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+588720,int_stack+0,int_stack+283020,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+245868,int_stack+588720,int_stack+196728,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+645420,int_stack+245868,int_stack+529752,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+724044,int_stack+645420,int_stack+404976,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+404976,int_stack+64200,int_stack+58044,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+423444,int_stack+404976,int_stack+471504,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+182040,int_stack+423444,int_stack+488028,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+404976,int_stack+182040,int_stack+0,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+469776,int_stack+404976,int_stack+588720,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+549156,int_stack+469776,int_stack+245868,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+404976,int_stack+549156,int_stack+645420,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+506064,int_stack+404976,int_stack+724044,36);
 /*--- compute (ip|nl) ---*/
 hrr1_build_ip(Libint->AB,int_stack+612984,int_stack+506064,int_stack+321816,2970);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+74010,int_stack+71040,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+77520,int_stack+74010,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37260,int_stack+81615,int_stack+77520,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49545,int_stack+37260,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+182040,int_stack+49545,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+86340,int_stack+81615,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+211740,int_stack+0,int_stack+37260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+14175,int_stack+211740,int_stack+49545,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+236310,int_stack+14175,int_stack+182040,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+182040,int_stack+91740,int_stack+86340,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49275,int_stack+182040,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+280860,int_stack+49275,int_stack+211740,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+321810,int_stack+280860,int_stack+14175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+374460,int_stack+321810,int_stack+236310,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+97860,int_stack+91740,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+198240,int_stack+0,int_stack+182040,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+230640,int_stack+198240,int_stack+49275,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+18360,int_stack+230640,int_stack+280860,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+862464,int_stack+18360,int_stack+321810,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+277890,int_stack+862464,int_stack+374460,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+361050,int_stack+104745,int_stack+97860,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+381705,int_stack+361050,int_stack+0,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+418425,int_stack+381705,int_stack+198240,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+936174,int_stack+418425,int_stack+230640,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+182040,int_stack+936174,int_stack+18360,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+182040,int_stack+862464,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1007049,int_stack+0,int_stack+277890,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+862464,int_stack+112440,int_stack+104745,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+885549,int_stack+862464,int_stack+361050,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+268035,int_stack+885549,int_stack+381705,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+329235,int_stack+268035,int_stack+418425,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1113969,int_stack+329235,int_stack+936174,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+268035,int_stack+1113969,int_stack+182040,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+862464,int_stack+268035,int_stack+0,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+182040,int_stack+862464,int_stack+1007049,45);
 /*--- compute (kp|nl) ---*/
 hrr1_build_kp(Libint->AB,int_stack+862464,int_stack+182040,int_stack+506064,2970);
 /*--- compute (id|nl) ---*/
 hrr1_build_id(Libint->AB,int_stack+1183224,int_stack+862464,int_stack+612984,2970);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+124620,int_stack+120990,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+128910,int_stack+124620,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+133915,int_stack+128910,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86295,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+139690,int_stack+133915,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+315690,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+315690,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+345720,int_stack+17325,int_stack+86295,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+60225,int_stack+146290,int_stack+139690,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+80025,int_stack+60225,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+400170,int_stack+80025,int_stack+315690,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+450220,int_stack+400170,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+514570,int_stack+450220,int_stack+345720,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+315690,int_stack+153770,int_stack+146290,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+338130,int_stack+315690,int_stack+60225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+338130,int_stack+80025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+57750,int_stack+0,int_stack+400170,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+590800,int_stack+57750,int_stack+450220,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+377730,int_stack+590800,int_stack+514570,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+479370,int_stack+162185,int_stack+153770,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+504615,int_stack+479370,int_stack+315690,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+680890,int_stack+504615,int_stack+338130,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+746890,int_stack+680890,int_stack+0,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1682184,int_stack+746890,int_stack+57750,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1682184,int_stack+590800,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+549495,int_stack+0,int_stack+377730,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+120120,int_stack+171590,int_stack+162185,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+315690,int_stack+120120,int_stack+479370,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+366180,int_stack+315690,int_stack+504615,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+440980,int_stack+366180,int_stack+680890,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+315690,int_stack+440980,int_stack+746890,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+680175,int_stack+315690,int_stack+1682184,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+315690,int_stack+680175,int_stack+0,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+315690,int_stack+549495,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+315690,int_stack+0,int_stack+182040,2970);
 /*--- compute (kd|nl) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1682184,int_stack+315690,int_stack+862464,2970);
 /*--- compute (if|nl) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+1682184,int_stack+1183224,2970);
 return int_stack+0;}
