/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igkf(Libint_t*, prim_data*);

  /* Computes quartets of (ig|kf) integrals */

REALTYPE *hrr_order_igkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[7][7] = int_stack + 5656;
 Libint->vrr_classes[7][8] = int_stack + 6952;
 Libint->vrr_classes[7][9] = int_stack + 8572;
 Libint->vrr_classes[7][10] = int_stack + 10552;
 Libint->vrr_classes[8][7] = int_stack + 12928;
 Libint->vrr_classes[8][8] = int_stack + 14548;
 Libint->vrr_classes[8][9] = int_stack + 16573;
 Libint->vrr_classes[8][10] = int_stack + 19048;
 Libint->vrr_classes[9][7] = int_stack + 22018;
 Libint->vrr_classes[9][8] = int_stack + 23998;
 Libint->vrr_classes[9][9] = int_stack + 26473;
 Libint->vrr_classes[9][10] = int_stack + 29498;
 Libint->vrr_classes[10][7] = int_stack + 33128;
 Libint->vrr_classes[10][8] = int_stack + 35504;
 Libint->vrr_classes[10][9] = int_stack + 38474;
 Libint->vrr_classes[10][10] = int_stack + 42104;
 memset(int_stack,0,46460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 46460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igkf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+46460,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+49484,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+53264,int_stack+49484,int_stack+46460,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+59312,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+63932,int_stack+59312,int_stack+49484,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+71492,int_stack+63932,int_stack+53264,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+46460,int_stack+6952,int_stack+5656,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+50348,int_stack+8572,int_stack+6952,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+55208,int_stack+50348,int_stack+46460,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62984,int_stack+10552,int_stack+8572,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+62984,int_stack+50348,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81572,int_stack+0,int_stack+55208,36);
 /*--- compute (ip|kf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+94532,int_stack+81572,int_stack+71492,360);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+14548,int_stack+12928,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+16573,int_stack+14548,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+46460,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+56180,int_stack+19048,int_stack+16573,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+63605,int_stack+56180,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+63605,int_stack+46460,45);
 /*--- compute (kp|kf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+124772,int_stack+0,int_stack+81572,360);
 /*--- compute (id|kf) ---*/
 hrr1_build_id(Libint->AB,int_stack+163652,int_stack+124772,int_stack+94532,360);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+46460,int_stack+23998,int_stack+22018,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+52400,int_stack+26473,int_stack+23998,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+59825,int_stack+52400,int_stack+46460,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+71705,int_stack+29498,int_stack+26473,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+80780,int_stack+71705,int_stack+52400,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+95630,int_stack+80780,int_stack+59825,55);
 /*--- compute (lp|kf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+46460,int_stack+95630,int_stack+0,360);
 /*--- compute (kd|kf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+224132,int_stack+46460,int_stack+124772,360);
 /*--- compute (if|kf) ---*/
 hrr1_build_if(Libint->AB,int_stack+301892,int_stack+224132,int_stack+163652,360);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+35504,int_stack+33128,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+38474,int_stack+35504,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16038,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115430,int_stack+42104,int_stack+38474,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+126320,int_stack+115430,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+144140,int_stack+126320,int_stack+16038,66);
 /*--- compute (mp|kf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+402692,int_stack+144140,int_stack+95630,360);
 /*--- compute (ld|kf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+95060,int_stack+402692,int_stack+46460,360);
 /*--- compute (kf|kf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+402692,int_stack+95060,int_stack+224132,360);
 /*--- compute (ig|kf) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+402692,int_stack+301892,360);
 return int_stack+0;}
