/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igki(Libint_t*, prim_data*);

  /* Computes quartets of (ig|ki) integrals */

REALTYPE *hrr_order_igki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[6][13] = int_stack + 10388;
 Libint->vrr_classes[7][7] = int_stack + 13328;
 Libint->vrr_classes[7][8] = int_stack + 14624;
 Libint->vrr_classes[7][9] = int_stack + 16244;
 Libint->vrr_classes[7][10] = int_stack + 18224;
 Libint->vrr_classes[7][11] = int_stack + 20600;
 Libint->vrr_classes[7][12] = int_stack + 23408;
 Libint->vrr_classes[7][13] = int_stack + 26684;
 Libint->vrr_classes[8][7] = int_stack + 30464;
 Libint->vrr_classes[8][8] = int_stack + 32084;
 Libint->vrr_classes[8][9] = int_stack + 34109;
 Libint->vrr_classes[8][10] = int_stack + 36584;
 Libint->vrr_classes[8][11] = int_stack + 39554;
 Libint->vrr_classes[8][12] = int_stack + 43064;
 Libint->vrr_classes[8][13] = int_stack + 47159;
 Libint->vrr_classes[9][7] = int_stack + 51884;
 Libint->vrr_classes[9][8] = int_stack + 53864;
 Libint->vrr_classes[9][9] = int_stack + 56339;
 Libint->vrr_classes[9][10] = int_stack + 59364;
 Libint->vrr_classes[9][11] = int_stack + 62994;
 Libint->vrr_classes[9][12] = int_stack + 67284;
 Libint->vrr_classes[9][13] = int_stack + 72289;
 Libint->vrr_classes[10][7] = int_stack + 78064;
 Libint->vrr_classes[10][8] = int_stack + 80440;
 Libint->vrr_classes[10][9] = int_stack + 83410;
 Libint->vrr_classes[10][10] = int_stack + 87040;
 Libint->vrr_classes[10][11] = int_stack + 91396;
 Libint->vrr_classes[10][12] = int_stack + 96544;
 Libint->vrr_classes[10][13] = int_stack + 102550;
 memset(int_stack,0,109480*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 109480;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igki(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+109480,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+112504,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+116284,int_stack+112504,int_stack+109480,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+122332,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+126952,int_stack+122332,int_stack+112504,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+134512,int_stack+126952,int_stack+116284,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+109480,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144592,int_stack+109480,int_stack+122332,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+153832,int_stack+144592,int_stack+126952,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+115024,int_stack+153832,int_stack+134512,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+130144,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+166432,int_stack+130144,int_stack+109480,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+177520,int_stack+166432,int_stack+144592,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+192920,int_stack+177520,int_stack+153832,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+136696,int_stack+192920,int_stack+115024,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109480,int_stack+10388,int_stack+7840,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+109480,int_stack+130144,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+109480,int_stack+0,int_stack+166432,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+211820,int_stack+109480,int_stack+177520,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+109480,int_stack+211820,int_stack+192920,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+157864,int_stack+109480,int_stack+136696,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+109480,int_stack+14624,int_stack+13328,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+113368,int_stack+16244,int_stack+14624,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+118228,int_stack+113368,int_stack+109480,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+126004,int_stack+18224,int_stack+16244,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+131944,int_stack+126004,int_stack+113368,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+141664,int_stack+131944,int_stack+118228,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+109480,int_stack+20600,int_stack+18224,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+109480,int_stack+126004,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+186088,int_stack+0,int_stack+131944,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+116608,int_stack+186088,int_stack+141664,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+136048,int_stack+23408,int_stack+20600,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+202288,int_stack+136048,int_stack+109480,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+216544,int_stack+202288,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+236344,int_stack+216544,int_stack+186088,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+260644,int_stack+236344,int_stack+116608,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+186088,int_stack+26684,int_stack+23408,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+186088,int_stack+136048,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+109480,int_stack+0,int_stack+202288,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+109480,int_stack+216544,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+109480,int_stack+0,int_stack+236344,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+186088,int_stack+109480,int_stack+260644,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+222376,int_stack+186088,int_stack+157864,1008);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+109480,int_stack+32084,int_stack+30464,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+114340,int_stack+34109,int_stack+32084,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+120415,int_stack+114340,int_stack+109480,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+130135,int_stack+36584,int_stack+34109,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+137560,int_stack+130135,int_stack+114340,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+149710,int_stack+137560,int_stack+120415,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+109480,int_stack+39554,int_stack+36584,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+165910,int_stack+109480,int_stack+130135,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+165910,int_stack+137560,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+118390,int_stack+0,int_stack+149710,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+142690,int_stack+43064,int_stack+39554,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20250,int_stack+142690,int_stack+109480,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+307048,int_stack+20250,int_stack+165910,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+153220,int_stack+307048,int_stack+0,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+331798,int_stack+153220,int_stack+118390,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+47159,int_stack+43064,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+109480,int_stack+0,int_stack+142690,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+365818,int_stack+109480,int_stack+20250,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+109480,int_stack+365818,int_stack+307048,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+109480,int_stack+153220,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+109480,int_stack+0,int_stack+331798,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+307048,int_stack+109480,int_stack+186088,1008);
 /*--- compute (id|ki) ---*/
 hrr1_build_id(Libint->AB,int_stack+415912,int_stack+307048,int_stack+222376,1008);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+53864,int_stack+51884,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+56339,int_stack+53864,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+59364,int_stack+56339,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34320,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+154840,int_stack+34320,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+62994,int_stack+59364,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+174640,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+192790,int_stack+174640,int_stack+34320,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10890,int_stack+192790,int_stack+154840,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+154840,int_stack+67284,int_stack+62994,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40590,int_stack+154840,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+217540,int_stack+40590,int_stack+174640,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+247790,int_stack+217540,int_stack+192790,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+167710,int_stack+247790,int_stack+10890,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72289,int_stack+67284,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+585256,int_stack+0,int_stack+154840,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+585256,int_stack+40590,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+585256,int_stack+0,int_stack+217540,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+585256,int_stack+247790,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+209290,int_stack+0,int_stack+167710,55);
 /*--- compute (lp|ki) ---*/
 hrr1_build_lp(Libint->AB,int_stack+585256,int_stack+209290,int_stack+109480,1008);
 /*--- compute (kd|ki) ---*/
 hrr1_build_kd(Libint->AB,int_stack+721336,int_stack+585256,int_stack+307048,1008);
 /*--- compute (if|ki) ---*/
 hrr1_build_if(Libint->AB,int_stack+939064,int_stack+721336,int_stack+415912,1008);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+109480,int_stack+80440,int_stack+78064,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+116608,int_stack+83410,int_stack+80440,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+125518,int_stack+116608,int_stack+109480,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+139774,int_stack+87040,int_stack+83410,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+150664,int_stack+139774,int_stack+116608,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+168484,int_stack+150664,int_stack+125518,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+109480,int_stack+91396,int_stack+87040,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+109480,int_stack+139774,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+21780,int_stack+0,int_stack+150664,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+122548,int_stack+21780,int_stack+168484,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+158188,int_stack+96544,int_stack+91396,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+173632,int_stack+158188,int_stack+109480,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51480,int_stack+173632,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+264730,int_stack+51480,int_stack+21780,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+264730,int_stack+122548,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109480,int_stack+102550,int_stack+96544,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+309280,int_stack+109480,int_stack+158188,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+87780,int_stack+309280,int_stack+173632,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+309280,int_stack+87780,int_stack+51480,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+363730,int_stack+309280,int_stack+264730,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+264730,int_stack+363730,int_stack+0,66);
 /*--- compute (mp|ki) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+264730,int_stack+209290,1008);
 /*--- compute (ld|ki) ---*/
 hrr1_build_ld(Libint->AB,int_stack+166320,int_stack+0,int_stack+585256,1008);
 /*--- compute (kf|ki) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1221304,int_stack+166320,int_stack+721336,1008);
 /*--- compute (ig|ki) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+1221304,int_stack+939064,1008);
 return int_stack+0;}
