/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igml(Libint_t*, prim_data*);

  /* Computes quartets of (ig|ml) integrals */

REALTYPE *hrr_order_igml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[6][15] = int_stack + 14420;
 Libint->vrr_classes[6][16] = int_stack + 18228;
 Libint->vrr_classes[6][17] = int_stack + 22512;
 Libint->vrr_classes[7][9] = int_stack + 27300;
 Libint->vrr_classes[7][10] = int_stack + 29280;
 Libint->vrr_classes[7][11] = int_stack + 31656;
 Libint->vrr_classes[7][12] = int_stack + 34464;
 Libint->vrr_classes[7][13] = int_stack + 37740;
 Libint->vrr_classes[7][14] = int_stack + 41520;
 Libint->vrr_classes[7][15] = int_stack + 45840;
 Libint->vrr_classes[7][16] = int_stack + 50736;
 Libint->vrr_classes[7][17] = int_stack + 56244;
 Libint->vrr_classes[8][9] = int_stack + 62400;
 Libint->vrr_classes[8][10] = int_stack + 64875;
 Libint->vrr_classes[8][11] = int_stack + 67845;
 Libint->vrr_classes[8][12] = int_stack + 71355;
 Libint->vrr_classes[8][13] = int_stack + 75450;
 Libint->vrr_classes[8][14] = int_stack + 80175;
 Libint->vrr_classes[8][15] = int_stack + 85575;
 Libint->vrr_classes[8][16] = int_stack + 91695;
 Libint->vrr_classes[8][17] = int_stack + 98580;
 Libint->vrr_classes[9][9] = int_stack + 106275;
 Libint->vrr_classes[9][10] = int_stack + 109300;
 Libint->vrr_classes[9][11] = int_stack + 112930;
 Libint->vrr_classes[9][12] = int_stack + 117220;
 Libint->vrr_classes[9][13] = int_stack + 122225;
 Libint->vrr_classes[9][14] = int_stack + 128000;
 Libint->vrr_classes[9][15] = int_stack + 134600;
 Libint->vrr_classes[9][16] = int_stack + 142080;
 Libint->vrr_classes[9][17] = int_stack + 150495;
 Libint->vrr_classes[10][9] = int_stack + 159900;
 Libint->vrr_classes[10][10] = int_stack + 163530;
 Libint->vrr_classes[10][11] = int_stack + 167886;
 Libint->vrr_classes[10][12] = int_stack + 173034;
 Libint->vrr_classes[10][13] = int_stack + 179040;
 Libint->vrr_classes[10][14] = int_stack + 185970;
 Libint->vrr_classes[10][15] = int_stack + 193890;
 Libint->vrr_classes[10][16] = int_stack + 202866;
 Libint->vrr_classes[10][17] = int_stack + 212964;
 memset(int_stack,0,224250*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 224250;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igml(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+224250,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+228870,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+234414,int_stack+228870,int_stack+224250,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+243654,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+250206,int_stack+243654,int_stack+228870,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+261294,int_stack+250206,int_stack+234414,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+224250,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+276694,int_stack+224250,int_stack+243654,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+289798,int_stack+276694,int_stack+250206,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+231894,int_stack+289798,int_stack+261294,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254994,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+308278,int_stack+254994,int_stack+224250,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+323566,int_stack+308278,int_stack+276694,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+345406,int_stack+323566,int_stack+289798,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+263814,int_stack+345406,int_stack+231894,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+224250,int_stack+14420,int_stack+11060,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+234330,int_stack+224250,int_stack+254994,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+373126,int_stack+234330,int_stack+308278,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+398606,int_stack+373126,int_stack+323566,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+296154,int_stack+398606,int_stack+345406,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+431366,int_stack+296154,int_stack+263814,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+251970,int_stack+18228,int_stack+14420,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+263394,int_stack+251970,int_stack+224250,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+334962,int_stack+263394,int_stack+234330,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+474486,int_stack+334962,int_stack+373126,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+512706,int_stack+474486,int_stack+398606,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+364362,int_stack+512706,int_stack+296154,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+558570,int_stack+364362,int_stack+431366,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+224250,int_stack+22512,int_stack+18228,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+283554,int_stack+224250,int_stack+251970,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+224250,int_stack+283554,int_stack+263394,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+257850,int_stack+224250,int_stack+334962,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+301950,int_stack+257850,int_stack+474486,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+224250,int_stack+301950,int_stack+512706,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+285402,int_stack+224250,int_stack+364362,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+351930,int_stack+285402,int_stack+558570,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+224250,int_stack+29280,int_stack+27300,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+230190,int_stack+31656,int_stack+29280,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+237318,int_stack+230190,int_stack+224250,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+249198,int_stack+34464,int_stack+31656,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+257622,int_stack+249198,int_stack+230190,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+271878,int_stack+257622,int_stack+237318,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+224250,int_stack+37740,int_stack+34464,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+291678,int_stack+224250,int_stack+249198,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+308526,int_stack+291678,int_stack+257622,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+234078,int_stack+308526,int_stack+271878,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+263778,int_stack+41520,int_stack+37740,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+421230,int_stack+263778,int_stack+224250,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+440886,int_stack+421230,int_stack+291678,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+468966,int_stack+440886,int_stack+308526,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+275118,int_stack+468966,int_stack+234078,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+224250,int_stack+45840,int_stack+41520,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+237210,int_stack+224250,int_stack+263778,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+316698,int_stack+237210,int_stack+421230,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+504606,int_stack+316698,int_stack+440886,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+546726,int_stack+504606,int_stack+468966,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+421230,int_stack+546726,int_stack+275118,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+476670,int_stack+50736,int_stack+45840,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+259890,int_stack+476670,int_stack+224250,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+259890,int_stack+237210,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+596622,int_stack+0,int_stack+316698,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+285810,int_stack+596622,int_stack+504606,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+645762,int_stack+285810,int_stack+546726,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+491358,int_stack+645762,int_stack+421230,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+421230,int_stack+56244,int_stack+50736,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+437754,int_stack+421230,int_stack+476670,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+712290,int_stack+437754,int_stack+259890,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+421230,int_stack+712290,int_stack+0,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+712290,int_stack+421230,int_stack+596622,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+562638,int_stack+712290,int_stack+285810,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+224250,int_stack+562638,int_stack+645762,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+562638,int_stack+224250,int_stack+491358,36);
 /*--- compute (ip|ml) ---*/
 hrr1_build_ip(Libint->AB,int_stack+651738,int_stack+562638,int_stack+351930,2475);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+224250,int_stack+64875,int_stack+62400,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+231675,int_stack+67845,int_stack+64875,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+240585,int_stack+231675,int_stack+224250,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+255435,int_stack+71355,int_stack+67845,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+265965,int_stack+255435,int_stack+231675,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+283785,int_stack+265965,int_stack+240585,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+224250,int_stack+75450,int_stack+71355,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+308535,int_stack+224250,int_stack+255435,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+329595,int_stack+308535,int_stack+265965,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+236535,int_stack+329595,int_stack+283785,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+273660,int_stack+80175,int_stack+75450,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+359295,int_stack+273660,int_stack+224250,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+383865,int_stack+359295,int_stack+308535,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+418965,int_stack+383865,int_stack+329595,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+287835,int_stack+418965,int_stack+236535,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+224250,int_stack+85575,int_stack+80175,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+240450,int_stack+224250,int_stack+273660,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+463515,int_stack+240450,int_stack+359295,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+504465,int_stack+463515,int_stack+383865,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+339810,int_stack+504465,int_stack+418965,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+339810,int_stack+287835,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+268800,int_stack+91695,int_stack+85575,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+287160,int_stack+268800,int_stack+224250,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+402180,int_stack+287160,int_stack+240450,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+859638,int_stack+402180,int_stack+463515,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+921063,int_stack+859638,int_stack+504465,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+449430,int_stack+921063,int_stack+339810,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+994773,int_stack+449430,int_stack+0,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+98580,int_stack+91695,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+20655,int_stack+0,int_stack+268800,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+224250,int_stack+20655,int_stack+287160,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+224250,int_stack+402180,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+224250,int_stack+0,int_stack+859638,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+224250,int_stack+921063,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+224250,int_stack+0,int_stack+449430,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+331170,int_stack+224250,int_stack+994773,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+859638,int_stack+331170,int_stack+562638,2475);
 /*--- compute (id|ml) ---*/
 hrr1_build_id(Libint->AB,int_stack+1126938,int_stack+859638,int_stack+651738,2475);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+224250,int_stack+109300,int_stack+106275,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+233325,int_stack+112930,int_stack+109300,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+244215,int_stack+233325,int_stack+224250,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+262365,int_stack+117220,int_stack+112930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+275235,int_stack+262365,int_stack+233325,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+297015,int_stack+275235,int_stack+244215,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+224250,int_stack+122225,int_stack+117220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+224250,int_stack+262365,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25740,int_stack+0,int_stack+275235,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+239265,int_stack+25740,int_stack+297015,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+284640,int_stack+128000,int_stack+122225,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+62040,int_stack+284640,int_stack+224250,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+442545,int_stack+62040,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+485445,int_stack+442545,int_stack+25740,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+539895,int_stack+485445,int_stack+239265,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+134600,int_stack+128000,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+284640,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+224250,int_stack+19800,int_stack+62040,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+54450,int_stack+224250,int_stack+442545,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+603420,int_stack+54450,int_stack+485445,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+442545,int_stack+603420,int_stack+539895,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+527245,int_stack+142080,int_stack+134600,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+549685,int_stack+527245,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+679650,int_stack+549685,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+737400,int_stack+679650,int_stack+224250,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+224250,int_stack+737400,int_stack+54450,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+224250,int_stack+603420,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1542738,int_stack+0,int_stack+442545,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+442545,int_stack+150495,int_stack+142080,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+467790,int_stack+442545,int_stack+527245,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+589285,int_stack+467790,int_stack+549685,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+442545,int_stack+589285,int_stack+679650,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+529170,int_stack+442545,int_stack+737400,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+634275,int_stack+529170,int_stack+224250,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+442545,int_stack+634275,int_stack+0,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+442545,int_stack+1542738,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+442545,int_stack+0,int_stack+331170,2475);
 /*--- compute (kd|ml) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1542738,int_stack+442545,int_stack+859638,2475);
 /*--- compute (if|ml) ---*/
 hrr1_build_if(Libint->AB,int_stack+2077338,int_stack+1542738,int_stack+1126938,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+776670,int_stack+163530,int_stack+159900,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+787560,int_stack+167886,int_stack+163530,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+800628,int_stack+787560,int_stack+776670,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+822408,int_stack+173034,int_stack+167886,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+837852,int_stack+822408,int_stack+787560,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+863988,int_stack+837852,int_stack+800628,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+776670,int_stack+179040,int_stack+173034,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+900288,int_stack+776670,int_stack+822408,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+931176,int_stack+900288,int_stack+837852,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+794688,int_stack+931176,int_stack+863988,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+849138,int_stack+185970,int_stack+179040,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+974736,int_stack+849138,int_stack+776670,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1010772,int_stack+974736,int_stack+900288,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1062252,int_stack+1010772,int_stack+931176,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+869928,int_stack+1062252,int_stack+794688,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+776670,int_stack+193890,int_stack+185970,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+800430,int_stack+776670,int_stack+849138,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1127592,int_stack+800430,int_stack+974736,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1187652,int_stack+1127592,int_stack+1010772,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+946158,int_stack+1187652,int_stack+1062252,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1264872,int_stack+946158,int_stack+869928,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+842010,int_stack+202866,int_stack+193890,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+868938,int_stack+842010,int_stack+776670,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1037634,int_stack+868938,int_stack+800430,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1366512,int_stack+1037634,int_stack+1127592,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+224250,int_stack+1366512,int_stack+1187652,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1106934,int_stack+224250,int_stack+946158,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2770338,int_stack+1106934,int_stack+1264872,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+776670,int_stack+212964,int_stack+202866,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+916458,int_stack+776670,int_stack+842010,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+776670,int_stack+916458,int_stack+868938,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+855870,int_stack+776670,int_stack+1037634,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+959820,int_stack+855870,int_stack+1366512,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+776670,int_stack+959820,int_stack+224250,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+920814,int_stack+776670,int_stack+1106934,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1077630,int_stack+920814,int_stack+2770338,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2770338,int_stack+1077630,int_stack+0,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+776670,int_stack+2770338,int_stack+442545,2475);
 /*--- compute (kf|ml) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2770338,int_stack+776670,int_stack+1542738,2475);
 /*--- compute (ig|ml) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+2770338,int_stack+2077338,2475);
 return int_stack+0;}
