/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iill(Libint_t*, prim_data*);

  /* Computes quartets of (ii|ll) integrals */

REALTYPE *hrr_order_iill(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 Libint->vrr_classes[6][16] = int_stack + 19488;
 Libint->vrr_classes[7][8] = int_stack + 23772;
 Libint->vrr_classes[7][9] = int_stack + 25392;
 Libint->vrr_classes[7][10] = int_stack + 27372;
 Libint->vrr_classes[7][11] = int_stack + 29748;
 Libint->vrr_classes[7][12] = int_stack + 32556;
 Libint->vrr_classes[7][13] = int_stack + 35832;
 Libint->vrr_classes[7][14] = int_stack + 39612;
 Libint->vrr_classes[7][15] = int_stack + 43932;
 Libint->vrr_classes[7][16] = int_stack + 48828;
 Libint->vrr_classes[8][8] = int_stack + 54336;
 Libint->vrr_classes[8][9] = int_stack + 56361;
 Libint->vrr_classes[8][10] = int_stack + 58836;
 Libint->vrr_classes[8][11] = int_stack + 61806;
 Libint->vrr_classes[8][12] = int_stack + 65316;
 Libint->vrr_classes[8][13] = int_stack + 69411;
 Libint->vrr_classes[8][14] = int_stack + 74136;
 Libint->vrr_classes[8][15] = int_stack + 79536;
 Libint->vrr_classes[8][16] = int_stack + 85656;
 Libint->vrr_classes[9][8] = int_stack + 92541;
 Libint->vrr_classes[9][9] = int_stack + 95016;
 Libint->vrr_classes[9][10] = int_stack + 98041;
 Libint->vrr_classes[9][11] = int_stack + 101671;
 Libint->vrr_classes[9][12] = int_stack + 105961;
 Libint->vrr_classes[9][13] = int_stack + 110966;
 Libint->vrr_classes[9][14] = int_stack + 116741;
 Libint->vrr_classes[9][15] = int_stack + 123341;
 Libint->vrr_classes[9][16] = int_stack + 130821;
 Libint->vrr_classes[10][8] = int_stack + 139236;
 Libint->vrr_classes[10][9] = int_stack + 142206;
 Libint->vrr_classes[10][10] = int_stack + 145836;
 Libint->vrr_classes[10][11] = int_stack + 150192;
 Libint->vrr_classes[10][12] = int_stack + 155340;
 Libint->vrr_classes[10][13] = int_stack + 161346;
 Libint->vrr_classes[10][14] = int_stack + 168276;
 Libint->vrr_classes[10][15] = int_stack + 176196;
 Libint->vrr_classes[10][16] = int_stack + 185172;
 Libint->vrr_classes[11][8] = int_stack + 195270;
 Libint->vrr_classes[11][9] = int_stack + 198780;
 Libint->vrr_classes[11][10] = int_stack + 203070;
 Libint->vrr_classes[11][11] = int_stack + 208218;
 Libint->vrr_classes[11][12] = int_stack + 214302;
 Libint->vrr_classes[11][13] = int_stack + 221400;
 Libint->vrr_classes[11][14] = int_stack + 229590;
 Libint->vrr_classes[11][15] = int_stack + 238950;
 Libint->vrr_classes[11][16] = int_stack + 249558;
 Libint->vrr_classes[12][8] = int_stack + 261492;
 Libint->vrr_classes[12][9] = int_stack + 265587;
 Libint->vrr_classes[12][10] = int_stack + 270592;
 Libint->vrr_classes[12][11] = int_stack + 276598;
 Libint->vrr_classes[12][12] = int_stack + 283696;
 Libint->vrr_classes[12][13] = int_stack + 291977;
 Libint->vrr_classes[12][14] = int_stack + 301532;
 Libint->vrr_classes[12][15] = int_stack + 312452;
 Libint->vrr_classes[12][16] = int_stack + 324828;
 memset(int_stack,0,338751*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 338751;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iill(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+338751,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+342531,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+347151,int_stack+342531,int_stack+338751,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+354711,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+360255,int_stack+354711,int_stack+342531,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+369495,int_stack+360255,int_stack+347151,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338751,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+382095,int_stack+338751,int_stack+354711,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+393183,int_stack+382095,int_stack+360255,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+345303,int_stack+393183,int_stack+369495,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+364203,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+408583,int_stack+364203,int_stack+338751,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+421687,int_stack+408583,int_stack+382095,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+440167,int_stack+421687,int_stack+393183,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+371847,int_stack+440167,int_stack+345303,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+338751,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+347571,int_stack+338751,int_stack+364203,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+463267,int_stack+347571,int_stack+408583,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+485107,int_stack+463267,int_stack+421687,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+398307,int_stack+485107,int_stack+440167,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+512827,int_stack+398307,int_stack+371847,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+362859,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+372939,int_stack+362859,int_stack+338751,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+430647,int_stack+372939,int_stack+347571,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+548107,int_stack+430647,int_stack+463267,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+580867,int_stack+548107,int_stack+485107,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+456127,int_stack+580867,int_stack+398307,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+619675,int_stack+456127,int_stack+512827,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+338751,int_stack+19488,int_stack+15680,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+390579,int_stack+338751,int_stack+362859,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+338751,int_stack+390579,int_stack+372939,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+368151,int_stack+338751,int_stack+430647,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+406371,int_stack+368151,int_stack+548107,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+338751,int_stack+406371,int_stack+580867,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+390495,int_stack+338751,int_stack+456127,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+445935,int_stack+390495,int_stack+619675,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+338751,int_stack+25392,int_stack+23772,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+343611,int_stack+27372,int_stack+25392,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+349551,int_stack+343611,int_stack+338751,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+359271,int_stack+29748,int_stack+27372,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+366399,int_stack+359271,int_stack+343611,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+378279,int_stack+366399,int_stack+349551,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338751,int_stack+32556,int_stack+29748,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+394479,int_stack+338751,int_stack+359271,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+408735,int_stack+394479,int_stack+366399,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+347175,int_stack+408735,int_stack+378279,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+371475,int_stack+35832,int_stack+32556,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+428535,int_stack+371475,int_stack+338751,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+502635,int_stack+428535,int_stack+394479,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+526395,int_stack+502635,int_stack+408735,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+381303,int_stack+526395,int_stack+347175,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+338751,int_stack+39612,int_stack+35832,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+350091,int_stack+338751,int_stack+371475,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+556095,int_stack+350091,int_stack+428535,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+584175,int_stack+556095,int_stack+502635,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+619815,int_stack+584175,int_stack+526395,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+502635,int_stack+619815,int_stack+381303,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+369747,int_stack+43932,int_stack+39612,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+382707,int_stack+369747,int_stack+338751,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+405387,int_stack+382707,int_stack+350091,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+405387,int_stack+556095,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+661395,int_stack+0,int_stack+584175,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+547995,int_stack+661395,int_stack+619815,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+711291,int_stack+547995,int_stack+502635,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+502635,int_stack+48828,int_stack+43932,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+517323,int_stack+502635,int_stack+369747,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+338751,int_stack+517323,int_stack+382707,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+603435,int_stack+338751,int_stack+405387,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+338751,int_stack+603435,int_stack+0,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+769611,int_stack+338751,int_stack+661395,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+338751,int_stack+769611,int_stack+547995,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+502635,int_stack+338751,int_stack+711291,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+575535,int_stack+502635,int_stack+445935,2025);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+338751,int_stack+56361,int_stack+54336,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+344826,int_stack+58836,int_stack+56361,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+352251,int_stack+344826,int_stack+338751,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+364401,int_stack+61806,int_stack+58836,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+373311,int_stack+364401,int_stack+344826,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+388161,int_stack+373311,int_stack+352251,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338751,int_stack+65316,int_stack+61806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+408411,int_stack+338751,int_stack+364401,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+426231,int_stack+408411,int_stack+373311,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+349281,int_stack+426231,int_stack+388161,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+379656,int_stack+69411,int_stack+65316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+450981,int_stack+379656,int_stack+338751,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+472041,int_stack+450981,int_stack+408411,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+472041,int_stack+426231,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+391941,int_stack+0,int_stack+349281,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+338751,int_stack+74136,int_stack+69411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+352926,int_stack+338751,int_stack+379656,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37125,int_stack+352926,int_stack+450981,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+745635,int_stack+37125,int_stack+472041,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+434466,int_stack+745635,int_stack+0,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+790185,int_stack+434466,int_stack+391941,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+79536,int_stack+74136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+377496,int_stack+0,int_stack+338751,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+846885,int_stack+377496,int_stack+352926,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+887835,int_stack+846885,int_stack+37125,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16200,int_stack+887835,int_stack+745635,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+940485,int_stack+16200,int_stack+434466,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+405846,int_stack+940485,int_stack+790185,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+745635,int_stack+85656,int_stack+79536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+763995,int_stack+745635,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+796395,int_stack+763995,int_stack+377496,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+338751,int_stack+796395,int_stack+846885,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+745635,int_stack+338751,int_stack+887835,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+819345,int_stack+745635,int_stack+16200,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+819345,int_stack+940485,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+745635,int_stack+0,int_stack+405846,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+836760,int_stack+745635,int_stack+502635,2025);
 /*--- compute (id|ll) ---*/
 hrr1_build_id(Libint->AB,int_stack+1055460,int_stack+836760,int_stack+575535,2025);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+95016,int_stack+92541,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+98041,int_stack+95016,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31350,int_stack+101671,int_stack+98041,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42240,int_stack+31350,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+60390,int_stack+42240,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+105961,int_stack+101671,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+338751,int_stack+0,int_stack+31350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+360531,int_stack+338751,int_stack+42240,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+12870,int_stack+360531,int_stack+60390,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49995,int_stack+110966,int_stack+105961,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+65010,int_stack+49995,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+390781,int_stack+65010,int_stack+338751,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+427081,int_stack+390781,int_stack+360531,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+338751,int_stack+427081,int_stack+12870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+116741,int_stack+110966,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+49995,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+472456,int_stack+17325,int_stack+65010,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+47355,int_stack+472456,int_stack+390781,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+515356,int_stack+47355,int_stack+427081,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+390726,int_stack+515356,int_stack+338751,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+338751,int_stack+123341,int_stack+116741,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+578881,int_stack+338751,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+613531,int_stack+578881,int_stack+17325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+663581,int_stack+613531,int_stack+472456,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1395660,int_stack+663581,int_stack+47355,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1395660,int_stack+515356,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+460026,int_stack+0,int_stack+390726,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+84700,int_stack+130821,int_stack+123341,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+358551,int_stack+84700,int_stack+338751,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+398151,int_stack+358551,int_stack+578881,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1471890,int_stack+398151,int_stack+613531,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+338751,int_stack+1471890,int_stack+663581,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+549126,int_stack+338751,int_stack+1395660,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1395660,int_stack+549126,int_stack+0,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1395660,int_stack+460026,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+338751,int_stack+0,int_stack+745635,2025);
 /*--- compute (kd|ll) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1395660,int_stack+338751,int_stack+836760,2025);
 /*--- compute (if|ll) ---*/
 hrr1_build_if(Libint->AB,int_stack+1833060,int_stack+1395660,int_stack+1055460,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+111375,int_stack+142206,int_stack+139236,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+120285,int_stack+145836,int_stack+142206,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+612126,int_stack+120285,int_stack+111375,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131175,int_stack+150192,int_stack+145836,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+629946,int_stack+131175,int_stack+120285,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+651726,int_stack+629946,int_stack+612126,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+612126,int_stack+155340,int_stack+150192,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+681426,int_stack+612126,int_stack+131175,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+111375,int_stack+681426,int_stack+629946,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+707562,int_stack+111375,int_stack+651726,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+627570,int_stack+161346,int_stack+155340,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+645588,int_stack+627570,int_stack+612126,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+752112,int_stack+645588,int_stack+681426,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+795672,int_stack+752112,int_stack+111375,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+850122,int_stack+795672,int_stack+707562,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111375,int_stack+168276,int_stack+161346,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+132165,int_stack+111375,int_stack+627570,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+676476,int_stack+132165,int_stack+645588,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+912492,int_stack+676476,int_stack+752112,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+977832,int_stack+912492,int_stack+795672,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+727956,int_stack+977832,int_stack+850122,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+612126,int_stack+176196,int_stack+168276,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+811116,int_stack+612126,int_stack+111375,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1054062,int_stack+811116,int_stack+132165,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1114122,int_stack+1054062,int_stack+676476,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+635886,int_stack+1114122,int_stack+912492,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+852696,int_stack+635886,int_stack+977832,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1191342,int_stack+852696,int_stack+727956,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+111375,int_stack+185172,int_stack+176196,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+138303,int_stack+111375,int_stack+612126,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+727362,int_stack+138303,int_stack+811116,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+954336,int_stack+727362,int_stack+1054062,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+727362,int_stack+954336,int_stack+1114122,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+954336,int_stack+727362,int_stack+635886,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+612126,int_stack+954336,int_stack+852696,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+742806,int_stack+612126,int_stack+1191342,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+876456,int_stack+742806,int_stack+0,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2400060,int_stack+876456,int_stack+338751,2025);
 /*--- compute (kf|ll) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2946810,int_stack+2400060,int_stack+1395660,2025);
 /*--- compute (ig|ll) ---*/
 hrr1_build_ig(Libint->AB,int_stack+3675810,int_stack+2946810,int_stack+1833060,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+338751,int_stack+198780,int_stack+195270,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+349281,int_stack+203070,int_stack+198780,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+362151,int_stack+349281,int_stack+338751,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+383211,int_stack+208218,int_stack+203070,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+398655,int_stack+383211,int_stack+349281,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+424395,int_stack+398655,int_stack+362151,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338751,int_stack+214302,int_stack+208218,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+459495,int_stack+338751,int_stack+383211,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+490383,int_stack+459495,int_stack+398655,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+357003,int_stack+490383,int_stack+424395,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+409653,int_stack+221400,int_stack+214302,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+533283,int_stack+409653,int_stack+338751,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+569787,int_stack+533283,int_stack+459495,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+621267,int_stack+569787,int_stack+490383,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+430947,int_stack+621267,int_stack+357003,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+338751,int_stack+229590,int_stack+221400,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+363321,int_stack+338751,int_stack+409653,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+363321,int_stack+533283,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+60840,int_stack+0,int_stack+569787,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+504657,int_stack+60840,int_stack+621267,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+594747,int_stack+504657,int_stack+430947,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+405909,int_stack+238950,int_stack+229590,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+433989,int_stack+405909,int_stack+338751,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+138060,int_stack+433989,int_stack+363321,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1210581,int_stack+138060,int_stack+0,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1301841,int_stack+1210581,int_stack+60840,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1301841,int_stack+504657,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1409949,int_stack+0,int_stack+594747,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+338751,int_stack+249558,int_stack+238950,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+483129,int_stack+338751,int_stack+405909,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+338751,int_stack+483129,int_stack+433989,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+420651,int_stack+338751,int_stack+138060,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+527121,int_stack+420651,int_stack+1210581,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+338751,int_stack+527121,int_stack+1301841,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1210581,int_stack+338751,int_stack+0,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1210581,int_stack+1409949,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+1210581,int_stack+0,int_stack+742806,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+1611531,int_stack+1210581,int_stack+876456,2025);
 /*--- compute (lf|ll) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4526310,int_stack+1611531,int_stack+2400060,2025);
 /*--- compute (kg|ll) ---*/
 hrr1_build_kg(Libint->AB,int_stack+5437560,int_stack+4526310,int_stack+2946810,2025);
 /*--- compute (ih|ll) ---*/
 hrr1_build_ih(Libint->AB,int_stack+2279781,int_stack+5437560,int_stack+3675810,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3470481,int_stack+265587,int_stack+261492,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3482766,int_stack+270592,int_stack+265587,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+3497781,int_stack+3482766,int_stack+3470481,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3522351,int_stack+276598,int_stack+270592,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3540369,int_stack+3522351,int_stack+3482766,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+3570399,int_stack+3540369,int_stack+3497781,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3470481,int_stack+283696,int_stack+276598,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3611349,int_stack+3470481,int_stack+3522351,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+3647385,int_stack+3611349,int_stack+3540369,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+3491775,int_stack+3647385,int_stack+3570399,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3553200,int_stack+291977,int_stack+283696,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3697435,int_stack+3553200,int_stack+3470481,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3740023,int_stack+3697435,int_stack+3611349,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+3800083,int_stack+3740023,int_stack+3647385,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+3578043,int_stack+3800083,int_stack+3491775,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3470481,int_stack+301532,int_stack+291977,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3499146,int_stack+3470481,int_stack+3553200,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3875158,int_stack+3499146,int_stack+3697435,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3946138,int_stack+3875158,int_stack+3740023,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+3664038,int_stack+3946138,int_stack+3800083,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+4036228,int_stack+3664038,int_stack+3578043,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3548832,int_stack+312452,int_stack+301532,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3581592,int_stack+3548832,int_stack+3470481,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3769143,int_stack+3581592,int_stack+3499146,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4150888,int_stack+3769143,int_stack+3875158,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4257358,int_stack+4150888,int_stack+3946138,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+3851953,int_stack+4257358,int_stack+3664038,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+157950,int_stack+3851953,int_stack+4036228,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3470481,int_stack+324828,int_stack+312452,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3638922,int_stack+3470481,int_stack+3548832,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3470481,int_stack+3638922,int_stack+3581592,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3566031,int_stack+3470481,int_stack+3769143,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3690246,int_stack+3566031,int_stack+4150888,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3470481,int_stack+3690246,int_stack+4257358,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3638649,int_stack+3470481,int_stack+3851953,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+3818829,int_stack+3638649,int_stack+157950,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+157950,int_stack+3818829,int_stack+0,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3470481,int_stack+157950,int_stack+1210581,2025);
 /*--- compute (mf|ll) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+3470481,int_stack+1611531,2025);
 /*--- compute (lg|ll) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6531060,int_stack+0,int_stack+4526310,2025);
 /*--- compute (kh|ll) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+6531060,int_stack+5437560,2025);
 /*--- compute (ii|ll) ---*/
 hrr1_build_ii(Libint->AB,int_stack+3470481,int_stack+0,int_stack+2279781,2025);
 return int_stack+3470481;}
