/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdmg(Libint_t*, prim_data*);

  /* Computes quartets of (kd|mg) integrals */

REALTYPE *hrr_order_kdmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[8][9] = int_stack + 14220;
 Libint->vrr_classes[8][10] = int_stack + 16695;
 Libint->vrr_classes[8][11] = int_stack + 19665;
 Libint->vrr_classes[8][12] = int_stack + 23175;
 Libint->vrr_classes[8][13] = int_stack + 27270;
 Libint->vrr_classes[9][9] = int_stack + 31995;
 Libint->vrr_classes[9][10] = int_stack + 35020;
 Libint->vrr_classes[9][11] = int_stack + 38650;
 Libint->vrr_classes[9][12] = int_stack + 42940;
 Libint->vrr_classes[9][13] = int_stack + 47945;
 memset(int_stack,0,53720*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 53720;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdmg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53720,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59660,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66788,int_stack+59660,int_stack+53720,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+78668,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+87092,int_stack+78668,int_stack+59660,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+101348,int_stack+87092,int_stack+66788,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+53720,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+121148,int_stack+53720,int_stack+78668,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+53720,int_stack+121148,int_stack+87092,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+121148,int_stack+53720,int_stack+101348,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53720,int_stack+16695,int_stack+14220,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61145,int_stack+19665,int_stack+16695,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+70055,int_stack+61145,int_stack+53720,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84905,int_stack+23175,int_stack+19665,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95435,int_stack+84905,int_stack+61145,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+150848,int_stack+95435,int_stack+70055,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+53720,int_stack+27270,int_stack+23175,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+53720,int_stack+84905,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+53720,int_stack+0,int_stack+95435,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+83420,int_stack+53720,int_stack+150848,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+150848,int_stack+83420,int_stack+121148,825);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53720,int_stack+35020,int_stack+31995,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62795,int_stack+38650,int_stack+35020,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+62795,int_stack+53720,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18150,int_stack+42940,int_stack+38650,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120545,int_stack+18150,int_stack+62795,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+239948,int_stack+120545,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+47945,int_stack+42940,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+31020,int_stack+0,int_stack+18150,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+270198,int_stack+31020,int_stack+120545,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+270198,int_stack+239948,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+239948,int_stack+0,int_stack+83420,825);
 /*--- compute (kd|mg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+351323,int_stack+239948,int_stack+150848,825);
 return int_stack+351323;}
