/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgmm(Libint_t*, prim_data*);

  /* Computes quartets of (kg|mm) integrals */

REALTYPE *hrr_order_kgmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[7][17] = int_stack + 28944;
 Libint->vrr_classes[7][18] = int_stack + 35100;
 Libint->vrr_classes[8][9] = int_stack + 41940;
 Libint->vrr_classes[8][10] = int_stack + 44415;
 Libint->vrr_classes[8][11] = int_stack + 47385;
 Libint->vrr_classes[8][12] = int_stack + 50895;
 Libint->vrr_classes[8][13] = int_stack + 54990;
 Libint->vrr_classes[8][14] = int_stack + 59715;
 Libint->vrr_classes[8][15] = int_stack + 65115;
 Libint->vrr_classes[8][16] = int_stack + 71235;
 Libint->vrr_classes[8][17] = int_stack + 78120;
 Libint->vrr_classes[8][18] = int_stack + 85815;
 Libint->vrr_classes[9][9] = int_stack + 94365;
 Libint->vrr_classes[9][10] = int_stack + 97390;
 Libint->vrr_classes[9][11] = int_stack + 101020;
 Libint->vrr_classes[9][12] = int_stack + 105310;
 Libint->vrr_classes[9][13] = int_stack + 110315;
 Libint->vrr_classes[9][14] = int_stack + 116090;
 Libint->vrr_classes[9][15] = int_stack + 122690;
 Libint->vrr_classes[9][16] = int_stack + 130170;
 Libint->vrr_classes[9][17] = int_stack + 138585;
 Libint->vrr_classes[9][18] = int_stack + 147990;
 Libint->vrr_classes[10][9] = int_stack + 158440;
 Libint->vrr_classes[10][10] = int_stack + 162070;
 Libint->vrr_classes[10][11] = int_stack + 166426;
 Libint->vrr_classes[10][12] = int_stack + 171574;
 Libint->vrr_classes[10][13] = int_stack + 177580;
 Libint->vrr_classes[10][14] = int_stack + 184510;
 Libint->vrr_classes[10][15] = int_stack + 192430;
 Libint->vrr_classes[10][16] = int_stack + 201406;
 Libint->vrr_classes[10][17] = int_stack + 211504;
 Libint->vrr_classes[10][18] = int_stack + 222790;
 Libint->vrr_classes[11][9] = int_stack + 235330;
 Libint->vrr_classes[11][10] = int_stack + 239620;
 Libint->vrr_classes[11][11] = int_stack + 244768;
 Libint->vrr_classes[11][12] = int_stack + 250852;
 Libint->vrr_classes[11][13] = int_stack + 257950;
 Libint->vrr_classes[11][14] = int_stack + 266140;
 Libint->vrr_classes[11][15] = int_stack + 275500;
 Libint->vrr_classes[11][16] = int_stack + 286108;
 Libint->vrr_classes[11][17] = int_stack + 298042;
 Libint->vrr_classes[11][18] = int_stack + 311380;
 memset(int_stack,0,326200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 326200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgmm(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+326200,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+332140,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+339268,int_stack+332140,int_stack+326200,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+351148,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+359572,int_stack+351148,int_stack+332140,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+373828,int_stack+359572,int_stack+339268,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326200,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+393628,int_stack+326200,int_stack+351148,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+410476,int_stack+393628,int_stack+359572,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+336028,int_stack+410476,int_stack+373828,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+365728,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+434236,int_stack+365728,int_stack+326200,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+453892,int_stack+434236,int_stack+393628,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+481972,int_stack+453892,int_stack+410476,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+377068,int_stack+481972,int_stack+336028,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+326200,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+339160,int_stack+326200,int_stack+365728,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+517612,int_stack+339160,int_stack+434236,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+550372,int_stack+517612,int_stack+453892,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+418648,int_stack+550372,int_stack+481972,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+592492,int_stack+418648,int_stack+377068,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+361840,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+376528,int_stack+361840,int_stack+326200,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+468544,int_stack+376528,int_stack+339160,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+647932,int_stack+468544,int_stack+517612,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+697072,int_stack+647932,int_stack+550372,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+506344,int_stack+697072,int_stack+418648,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+756040,int_stack+506344,int_stack+592492,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+326200,int_stack+28944,int_stack+23436,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+402448,int_stack+326200,int_stack+361840,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+572872,int_stack+402448,int_stack+376528,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+342724,int_stack+572872,int_stack+468544,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+431824,int_stack+342724,int_stack+647932,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+616072,int_stack+431824,int_stack+697072,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+827320,int_stack+616072,int_stack+506344,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+912856,int_stack+827320,int_stack+756040,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+500620,int_stack+35100,int_stack+28944,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+519088,int_stack+500620,int_stack+326200,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+694696,int_stack+519088,int_stack+402448,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+500620,int_stack+694696,int_stack+572872,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+694696,int_stack+500620,int_stack+342724,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+500620,int_stack+694696,int_stack+431824,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+694696,int_stack+500620,int_stack+616072,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+326200,int_stack+694696,int_stack+827320,36);
 /*--- compute (k0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+433120,int_stack+326200,int_stack+912856,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+326200,int_stack+44415,int_stack+41940,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+333625,int_stack+47385,int_stack+44415,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+342535,int_stack+333625,int_stack+326200,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+357385,int_stack+50895,int_stack+47385,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+367915,int_stack+357385,int_stack+333625,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+385735,int_stack+367915,int_stack+342535,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326200,int_stack+54990,int_stack+50895,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+410485,int_stack+326200,int_stack+357385,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+542020,int_stack+410485,int_stack+367915,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+338485,int_stack+542020,int_stack+385735,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+375610,int_stack+59715,int_stack+54990,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+571720,int_stack+375610,int_stack+326200,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+596290,int_stack+571720,int_stack+410485,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+631390,int_stack+596290,int_stack+542020,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+675940,int_stack+631390,int_stack+338485,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+542020,int_stack+65115,int_stack+59715,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+326200,int_stack+542020,int_stack+375610,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+354550,int_stack+326200,int_stack+571720,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+727915,int_stack+354550,int_stack+596290,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+558220,int_stack+727915,int_stack+631390,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+780565,int_stack+558220,int_stack+675940,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+620590,int_stack+71235,int_stack+65115,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+638950,int_stack+620590,int_stack+542020,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+671350,int_stack+638950,int_stack+326200,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+849865,int_stack+671350,int_stack+354550,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+326200,int_stack+849865,int_stack+727915,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+911290,int_stack+326200,int_stack+558220,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+994450,int_stack+911290,int_stack+780565,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+399910,int_stack+78120,int_stack+71235,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+542020,int_stack+399910,int_stack+620590,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+578740,int_stack+542020,int_stack+638950,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+718600,int_stack+578740,int_stack+671350,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1083550,int_stack+718600,int_stack+849865,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+789475,int_stack+1083550,int_stack+326200,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1169545,int_stack+789475,int_stack+911290,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1276465,int_stack+1169545,int_stack+994450,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+326200,int_stack+85815,int_stack+78120,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+349285,int_stack+326200,int_stack+399910,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+632740,int_stack+349285,int_stack+542020,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+326200,int_stack+632740,int_stack+578740,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+542020,int_stack+326200,int_stack+718600,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+641245,int_stack+542020,int_stack+1083550,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+887755,int_stack+641245,int_stack+789475,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+542020,int_stack+887755,int_stack+1169545,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+675670,int_stack+542020,int_stack+1276465,45);
 /*--- compute (kp|mm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+811795,int_stack+675670,int_stack+433120,3025);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1138495,int_stack+97390,int_stack+94365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1147570,int_stack+101020,int_stack+97390,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1158460,int_stack+1147570,int_stack+1138495,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1176610,int_stack+105310,int_stack+101020,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1189480,int_stack+1176610,int_stack+1147570,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1211260,int_stack+1189480,int_stack+1158460,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1138495,int_stack+110315,int_stack+105310,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1241510,int_stack+1138495,int_stack+1176610,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1267250,int_stack+1241510,int_stack+1189480,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1153510,int_stack+1267250,int_stack+1211260,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1198885,int_stack+116090,int_stack+110315,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1303550,int_stack+1198885,int_stack+1138495,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1333580,int_stack+1303550,int_stack+1241510,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+326200,int_stack+1333580,int_stack+1267250,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1216210,int_stack+326200,int_stack+1153510,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1138495,int_stack+122690,int_stack+116090,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1158295,int_stack+1138495,int_stack+1198885,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+380650,int_stack+1158295,int_stack+1303550,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+430700,int_stack+380650,int_stack+1333580,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1279735,int_stack+430700,int_stack+326200,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+495050,int_stack+1279735,int_stack+1216210,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+326200,int_stack+130170,int_stack+122690,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1192945,int_stack+326200,int_stack+1138495,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+579750,int_stack+1192945,int_stack+1158295,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+579750,int_stack+380650,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1355965,int_stack+0,int_stack+430700,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+348640,int_stack+1355965,int_stack+1279735,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1232545,int_stack+348640,int_stack+495050,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1138495,int_stack+138585,int_stack+130170,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+450280,int_stack+1138495,int_stack+326200,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+495160,int_stack+450280,int_stack+1192945,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1446055,int_stack+495160,int_stack+579750,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+561160,int_stack+1446055,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+561160,int_stack+1355965,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1532680,int_stack+0,int_stack+348640,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1663360,int_stack+1532680,int_stack+1232545,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+326200,int_stack+147990,int_stack+138585,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+354415,int_stack+326200,int_stack+1138495,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1138495,int_stack+354415,int_stack+450280,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1213295,int_stack+1138495,int_stack+495160,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1312295,int_stack+1213295,int_stack+1446055,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1138495,int_stack+1312295,int_stack+561160,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1278635,int_stack+1138495,int_stack+0,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+326200,int_stack+1278635,int_stack+1532680,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1138495,int_stack+326200,int_stack+1663360,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1304870,int_stack+1138495,int_stack+675670,3025);
 /*--- compute (kd|mm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1713245,int_stack+1304870,int_stack+811795,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+326200,int_stack+162070,int_stack+158440,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+337090,int_stack+166426,int_stack+162070,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+350158,int_stack+337090,int_stack+326200,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+371938,int_stack+171574,int_stack+166426,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+387382,int_stack+371938,int_stack+337090,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+413518,int_stack+387382,int_stack+350158,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326200,int_stack+177580,int_stack+171574,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+449818,int_stack+326200,int_stack+371938,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+480706,int_stack+449818,int_stack+387382,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+344218,int_stack+480706,int_stack+413518,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+398668,int_stack+184510,int_stack+177580,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+524266,int_stack+398668,int_stack+326200,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+560302,int_stack+524266,int_stack+449818,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+611782,int_stack+560302,int_stack+480706,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+419458,int_stack+611782,int_stack+344218,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+326200,int_stack+192430,int_stack+184510,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+349960,int_stack+326200,int_stack+398668,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+677122,int_stack+349960,int_stack+524266,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+737182,int_stack+677122,int_stack+560302,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+495688,int_stack+737182,int_stack+611782,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+814402,int_stack+495688,int_stack+419458,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+391540,int_stack+201406,int_stack+192430,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+418468,int_stack+391540,int_stack+326200,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+587164,int_stack+418468,int_stack+349960,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+916042,int_stack+587164,int_stack+677122,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1006132,int_stack+916042,int_stack+737182,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+656464,int_stack+1006132,int_stack+495688,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+656464,int_stack+814402,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+326200,int_stack+211504,int_stack+201406,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+465988,int_stack+326200,int_stack+391540,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+778432,int_stack+465988,int_stack+418468,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+356494,int_stack+778432,int_stack+587164,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+519844,int_stack+356494,int_stack+916042,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+857632,int_stack+519844,int_stack+1006132,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2366645,int_stack+857632,int_stack+656464,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2523461,int_stack+2366645,int_stack+0,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+222790,int_stack+211504,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+33858,int_stack+0,int_stack+326200,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+94446,int_stack+33858,int_stack+465988,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+645970,int_stack+94446,int_stack+778432,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+645970,int_stack+356494,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+645970,int_stack+0,int_stack+519844,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+645970,int_stack+857632,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+326200,int_stack+0,int_stack+2366645,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+326200,int_stack+2523461,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+326200,int_stack+0,int_stack+1138495,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2366645,int_stack+326200,int_stack+1304870,3025);
 /*--- compute (kf|mm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+3183395,int_stack+2366645,int_stack+1713245,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+825325,int_stack+239620,int_stack+235330,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+838195,int_stack+244768,int_stack+239620,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+853639,int_stack+838195,int_stack+825325,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+879379,int_stack+250852,int_stack+244768,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+897631,int_stack+879379,int_stack+838195,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+928519,int_stack+897631,int_stack+853639,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+825325,int_stack+257950,int_stack+250852,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+971419,int_stack+825325,int_stack+879379,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1007923,int_stack+971419,int_stack+897631,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+846619,int_stack+1007923,int_stack+928519,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+910969,int_stack+266140,int_stack+257950,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1059403,int_stack+910969,int_stack+825325,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1101991,int_stack+1059403,int_stack+971419,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1162831,int_stack+1101991,int_stack+1007923,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+935539,int_stack+1162831,int_stack+846619,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+825325,int_stack+275500,int_stack+266140,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+853405,int_stack+825325,int_stack+910969,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1240051,int_stack+853405,int_stack+1059403,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1311031,int_stack+1240051,int_stack+1101991,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1025629,int_stack+1311031,int_stack+1162831,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1402291,int_stack+1025629,int_stack+935539,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+902545,int_stack+286108,int_stack+275500,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+934369,int_stack+902545,int_stack+825325,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1133737,int_stack+934369,int_stack+853405,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1522411,int_stack+1133737,int_stack+1240051,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1628881,int_stack+1522411,int_stack+1311031,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1215637,int_stack+1628881,int_stack+1025629,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1756645,int_stack+1215637,int_stack+1402291,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+825325,int_stack+298042,int_stack+286108,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+990529,int_stack+825325,int_stack+902545,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1359781,int_stack+990529,int_stack+934369,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+861127,int_stack+1359781,int_stack+1133737,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1054177,int_stack+861127,int_stack+1522411,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1453381,int_stack+1054177,int_stack+1628881,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1911085,int_stack+1453381,int_stack+1215637,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2096413,int_stack+1911085,int_stack+1756645,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1203235,int_stack+311380,int_stack+298042,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1243249,int_stack+1203235,int_stack+825325,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1623733,int_stack+1243249,int_stack+990529,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1203235,int_stack+1623733,int_stack+1359781,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1623733,int_stack+1203235,int_stack+861127,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1203235,int_stack+1623733,int_stack+1054177,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1623733,int_stack+1203235,int_stack+1453381,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+825325,int_stack+1623733,int_stack+1911085,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1056985,int_stack+825325,int_stack+2096413,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1292935,int_stack+1056985,int_stack+0,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+4272395,int_stack+1292935,int_stack+326200,3025);
 /*--- compute (lf|mm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+4272395,int_stack+2366645,3025);
 /*--- compute (kg|mm) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1361250,int_stack+0,int_stack+3183395,3025);
 return int_stack+1361250;}
