/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khkk(Libint_t*, prim_data*);

  /* Computes quartets of (kh|kk) integrals */

REALTYPE *hrr_order_khkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[7][13] = int_stack + 13356;
 Libint->vrr_classes[7][14] = int_stack + 17136;
 Libint->vrr_classes[8][7] = int_stack + 21456;
 Libint->vrr_classes[8][8] = int_stack + 23076;
 Libint->vrr_classes[8][9] = int_stack + 25101;
 Libint->vrr_classes[8][10] = int_stack + 27576;
 Libint->vrr_classes[8][11] = int_stack + 30546;
 Libint->vrr_classes[8][12] = int_stack + 34056;
 Libint->vrr_classes[8][13] = int_stack + 38151;
 Libint->vrr_classes[8][14] = int_stack + 42876;
 Libint->vrr_classes[9][7] = int_stack + 48276;
 Libint->vrr_classes[9][8] = int_stack + 50256;
 Libint->vrr_classes[9][9] = int_stack + 52731;
 Libint->vrr_classes[9][10] = int_stack + 55756;
 Libint->vrr_classes[9][11] = int_stack + 59386;
 Libint->vrr_classes[9][12] = int_stack + 63676;
 Libint->vrr_classes[9][13] = int_stack + 68681;
 Libint->vrr_classes[9][14] = int_stack + 74456;
 Libint->vrr_classes[10][7] = int_stack + 81056;
 Libint->vrr_classes[10][8] = int_stack + 83432;
 Libint->vrr_classes[10][9] = int_stack + 86402;
 Libint->vrr_classes[10][10] = int_stack + 90032;
 Libint->vrr_classes[10][11] = int_stack + 94388;
 Libint->vrr_classes[10][12] = int_stack + 99536;
 Libint->vrr_classes[10][13] = int_stack + 105542;
 Libint->vrr_classes[10][14] = int_stack + 112472;
 Libint->vrr_classes[11][7] = int_stack + 120392;
 Libint->vrr_classes[11][8] = int_stack + 123200;
 Libint->vrr_classes[11][9] = int_stack + 126710;
 Libint->vrr_classes[11][10] = int_stack + 131000;
 Libint->vrr_classes[11][11] = int_stack + 136148;
 Libint->vrr_classes[11][12] = int_stack + 142232;
 Libint->vrr_classes[11][13] = int_stack + 149330;
 Libint->vrr_classes[11][14] = int_stack + 157520;
 Libint->vrr_classes[12][7] = int_stack + 166880;
 Libint->vrr_classes[12][8] = int_stack + 170156;
 Libint->vrr_classes[12][9] = int_stack + 174251;
 Libint->vrr_classes[12][10] = int_stack + 179256;
 Libint->vrr_classes[12][11] = int_stack + 185262;
 Libint->vrr_classes[12][12] = int_stack + 192360;
 Libint->vrr_classes[12][13] = int_stack + 200641;
 Libint->vrr_classes[12][14] = int_stack + 210196;
 memset(int_stack,0,221116*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 221116;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khkk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+221116,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+225004,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+229864,int_stack+225004,int_stack+221116,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+237640,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+243580,int_stack+237640,int_stack+225004,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+253300,int_stack+243580,int_stack+229864,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+221116,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+266260,int_stack+221116,int_stack+237640,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+278140,int_stack+266260,int_stack+243580,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+228244,int_stack+278140,int_stack+253300,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+247684,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+294340,int_stack+247684,int_stack+221116,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+308596,int_stack+294340,int_stack+266260,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+328396,int_stack+308596,int_stack+278140,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+256108,int_stack+328396,int_stack+228244,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+221116,int_stack+13356,int_stack+10080,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+352696,int_stack+221116,int_stack+247684,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+230944,int_stack+352696,int_stack+294340,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+369544,int_stack+230944,int_stack+308596,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+283324,int_stack+369544,int_stack+328396,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+399244,int_stack+283324,int_stack+256108,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254704,int_stack+17136,int_stack+13356,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+317344,int_stack+254704,int_stack+221116,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+254704,int_stack+317344,int_stack+352696,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+317344,int_stack+254704,int_stack+230944,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+221116,int_stack+317344,int_stack+369544,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+317344,int_stack+221116,int_stack+283324,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+221116,int_stack+317344,int_stack+399244,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+267772,int_stack+23076,int_stack+21456,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+272632,int_stack+25101,int_stack+23076,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+278707,int_stack+272632,int_stack+267772,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+288427,int_stack+27576,int_stack+25101,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+295852,int_stack+288427,int_stack+272632,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+308002,int_stack+295852,int_stack+278707,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+267772,int_stack+30546,int_stack+27576,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+324202,int_stack+267772,int_stack+288427,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+339052,int_stack+324202,int_stack+295852,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+276682,int_stack+339052,int_stack+308002,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+300982,int_stack+34056,int_stack+30546,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+359302,int_stack+300982,int_stack+267772,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+377122,int_stack+359302,int_stack+324202,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+401872,int_stack+377122,int_stack+339052,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+311512,int_stack+401872,int_stack+276682,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+267772,int_stack+38151,int_stack+34056,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+267772,int_stack+300982,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280057,int_stack+0,int_stack+359302,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+432247,int_stack+280057,int_stack+377122,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+345532,int_stack+432247,int_stack+401872,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+469372,int_stack+345532,int_stack+311512,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+309757,int_stack+42876,int_stack+38151,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+388057,int_stack+309757,int_stack+267772,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+309757,int_stack+388057,int_stack+0,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+309757,int_stack+280057,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+267772,int_stack+0,int_stack+432247,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+388057,int_stack+267772,int_stack+345532,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+267772,int_stack+388057,int_stack+469372,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+326092,int_stack+267772,int_stack+221116,1296);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+221116,int_stack+50256,int_stack+48276,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+227056,int_stack+52731,int_stack+50256,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+234481,int_stack+227056,int_stack+221116,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+246361,int_stack+55756,int_stack+52731,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+466060,int_stack+246361,int_stack+227056,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+480910,int_stack+466060,int_stack+234481,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+221116,int_stack+59386,int_stack+55756,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+221116,int_stack+246361,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+232006,int_stack+0,int_stack+466060,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18150,int_stack+232006,int_stack+480910,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+466060,int_stack+63676,int_stack+59386,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+478930,int_stack+466060,int_stack+221116,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+500710,int_stack+478930,int_stack+0,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+530960,int_stack+500710,int_stack+232006,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+221116,int_stack+530960,int_stack+18150,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+68681,int_stack+63676,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15015,int_stack+0,int_stack+466060,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+568085,int_stack+15015,int_stack+478930,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+604385,int_stack+568085,int_stack+500710,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+466060,int_stack+604385,int_stack+530960,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+649760,int_stack+466060,int_stack+221116,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221116,int_stack+74456,int_stack+68681,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+518035,int_stack+221116,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+221116,int_stack+518035,int_stack+15015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+221116,int_stack+568085,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+518035,int_stack+0,int_stack+604385,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+518035,int_stack+466060,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+466060,int_stack+0,int_stack+649760,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+537340,int_stack+466060,int_stack+267772,1296);
 /*--- compute (kd|kk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+712300,int_stack+537340,int_stack+326092,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+83432,int_stack+81056,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+86402,int_stack+83432,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16038,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30294,int_stack+90032,int_stack+86402,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41184,int_stack+30294,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+59004,int_stack+41184,int_stack+16038,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+94388,int_stack+90032,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+221116,int_stack+0,int_stack+30294,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+242896,int_stack+221116,int_stack+41184,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+13068,int_stack+242896,int_stack+59004,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48708,int_stack+99536,int_stack+94388,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64152,int_stack+48708,int_stack+0,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+272596,int_stack+64152,int_stack+221116,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+308896,int_stack+272596,int_stack+242896,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+221116,int_stack+308896,int_stack+13068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+105542,int_stack+99536,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+353446,int_stack+0,int_stack+48708,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+18018,int_stack+353446,int_stack+64152,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+384334,int_stack+18018,int_stack+272596,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+992236,int_stack+384334,int_stack+308896,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+271012,int_stack+992236,int_stack+221116,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221116,int_stack+112472,int_stack+105542,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+61578,int_stack+221116,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1054606,int_stack+61578,int_stack+353446,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1106086,int_stack+1054606,int_stack+18018,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1106086,int_stack+384334,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1054606,int_stack+0,int_stack+992236,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+1054606,int_stack+271012,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+221116,int_stack+0,int_stack+466060,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+992236,int_stack+221116,int_stack+537340,1296);
 /*--- compute (kf|kk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1342156,int_stack+992236,int_stack+712300,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+85536,int_stack+123200,int_stack+120392,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+93960,int_stack+126710,int_stack+123200,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+104490,int_stack+93960,int_stack+85536,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+434956,int_stack+131000,int_stack+126710,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+447826,int_stack+434956,int_stack+93960,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+468886,int_stack+447826,int_stack+104490,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85536,int_stack+136148,int_stack+131000,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+100980,int_stack+85536,int_stack+434956,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+496966,int_stack+100980,int_stack+447826,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+532066,int_stack+496966,int_stack+468886,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+434956,int_stack+142232,int_stack+136148,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+453208,int_stack+434956,int_stack+85536,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+574186,int_stack+453208,int_stack+100980,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+85536,int_stack+574186,int_stack+496966,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+617086,int_stack+85536,int_stack+532066,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+484096,int_stack+149330,int_stack+142232,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+505390,int_stack+484096,int_stack+434956,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+676054,int_stack+505390,int_stack+453208,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+727534,int_stack+676054,int_stack+574186,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+541894,int_stack+727534,int_stack+85536,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+791884,int_stack+541894,int_stack+617086,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85536,int_stack+157520,int_stack+149330,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+110106,int_stack+85536,int_stack+484096,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+434956,int_stack+110106,int_stack+505390,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+85536,int_stack+434956,int_stack+676054,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+434956,int_stack+85536,int_stack+727534,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+615604,int_stack+434956,int_stack+541894,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+434956,int_stack+615604,int_stack+791884,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+536044,int_stack+434956,int_stack+0,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1808716,int_stack+536044,int_stack+221116,1296);
 /*--- compute (lf|kk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2236396,int_stack+1808716,int_stack+992236,1296);
 /*--- compute (kg|kk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2819596,int_stack+2236396,int_stack+1342156,1296);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+221116,int_stack+170156,int_stack+166880,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+230944,int_stack+174251,int_stack+170156,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+243229,int_stack+230944,int_stack+221116,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+262885,int_stack+179256,int_stack+174251,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+277900,int_stack+262885,int_stack+230944,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+302470,int_stack+277900,int_stack+243229,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+221116,int_stack+185262,int_stack+179256,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+335230,int_stack+221116,int_stack+262885,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+365260,int_stack+335230,int_stack+277900,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+239134,int_stack+365260,int_stack+302470,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+288274,int_stack+192360,int_stack+185262,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+288274,int_stack+221116,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36036,int_stack+0,int_stack+335230,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+86086,int_stack+36036,int_stack+365260,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+309568,int_stack+86086,int_stack+239134,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+221116,int_stack+200641,int_stack+192360,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+378364,int_stack+221116,int_stack+288274,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+245959,int_stack+378364,int_stack+0,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+792652,int_stack+245959,int_stack+36036,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+792652,int_stack+86086,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+85995,int_stack+0,int_stack+309568,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+306019,int_stack+210196,int_stack+200641,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+867727,int_stack+306019,int_stack+221116,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+306019,int_stack+867727,int_stack+378364,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+867727,int_stack+306019,int_stack+245959,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+957817,int_stack+867727,int_stack+792652,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+792652,int_stack+957817,int_stack+0,91);
 /*--- compute (q0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+907312,int_stack+792652,int_stack+85995,91);
 /*--- compute (op|kk) ---*/
 hrr1_build_op(Libint->AB,int_stack+0,int_stack+907312,int_stack+434956,1296);
 /*--- compute (nd|kk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+792652,int_stack+0,int_stack+536044,1296);
 /*--- compute (mf|kk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+792652,int_stack+1808716,1296);
 /*--- compute (lg|kk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+712800,int_stack+0,int_stack+2236396,1296);
 /*--- compute (kh|kk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1587600,int_stack+712800,int_stack+2819596,1296);
 return int_stack+1587600;}
