/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khnd(Libint_t*, prim_data*);

  /* Computes quartets of (kh|nd) integrals */

REALTYPE *hrr_order_khnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[8][10] = int_stack + 8460;
 Libint->vrr_classes[8][11] = int_stack + 11430;
 Libint->vrr_classes[8][12] = int_stack + 14940;
 Libint->vrr_classes[9][10] = int_stack + 19035;
 Libint->vrr_classes[9][11] = int_stack + 22665;
 Libint->vrr_classes[9][12] = int_stack + 26955;
 Libint->vrr_classes[10][10] = int_stack + 31960;
 Libint->vrr_classes[10][11] = int_stack + 36316;
 Libint->vrr_classes[10][12] = int_stack + 41464;
 Libint->vrr_classes[11][10] = int_stack + 47470;
 Libint->vrr_classes[11][11] = int_stack + 52618;
 Libint->vrr_classes[11][12] = int_stack + 58702;
 Libint->vrr_classes[12][10] = int_stack + 65800;
 Libint->vrr_classes[12][11] = int_stack + 71806;
 Libint->vrr_classes[12][12] = int_stack + 78904;
 memset(int_stack,0,87185*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 87185;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khnd(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87185,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94313,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+102737,int_stack+94313,int_stack+87185,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87185,int_stack+11430,int_stack+8460,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+14940,int_stack+11430,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+116993,int_stack+0,int_stack+87185,45);
 /*--- compute (kp|nd) ---*/
 hrr1_build_kp(Libint->AB,int_stack+134813,int_stack+116993,int_stack+102737,396);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87185,int_stack+22665,int_stack+19035,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+98075,int_stack+26955,int_stack+22665,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+98075,int_stack+87185,55);
 /*--- compute (lp|nd) ---*/
 hrr1_build_lp(Libint->AB,int_stack+177581,int_stack+0,int_stack+116993,396);
 /*--- compute (kd|nd) ---*/
 hrr1_build_kd(Libint->AB,int_stack+231041,int_stack+177581,int_stack+134813,396);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87185,int_stack+36316,int_stack+31960,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100253,int_stack+41464,int_stack+36316,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+115697,int_stack+100253,int_stack+87185,66);
 /*--- compute (mp|nd) ---*/
 hrr1_build_mp(Libint->AB,int_stack+316577,int_stack+115697,int_stack+0,396);
 /*--- compute (ld|nd) ---*/
 hrr1_build_ld(Libint->AB,int_stack+381917,int_stack+316577,int_stack+177581,396);
 /*--- compute (kf|nd) ---*/
 hrr1_build_kf(Libint->AB,int_stack+488837,int_stack+381917,int_stack+231041,396);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+52618,int_stack+47470,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+58702,int_stack+52618,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (np|nd) ---*/
 hrr1_build_np(Libint->AB,int_stack+141833,int_stack+33696,int_stack+115697,396);
 /*--- compute (md|nd) ---*/
 hrr1_build_md(Libint->AB,int_stack+631397,int_stack+141833,int_stack+316577,396);
 /*--- compute (lf|nd) ---*/
 hrr1_build_lf(Libint->AB,int_stack+762077,int_stack+631397,int_stack+381917,396);
 /*--- compute (kg|nd) ---*/
 hrr1_build_kg(Libint->AB,int_stack+220241,int_stack+762077,int_stack+488837,396);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+71806,int_stack+65800,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+87185,int_stack+78904,int_stack+71806,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+434081,int_stack+87185,int_stack+0,91);
 /*--- compute (op|nd) ---*/
 hrr1_build_op(Libint->AB,int_stack+470117,int_stack+434081,int_stack+33696,396);
 /*--- compute (nd|nd) ---*/
 hrr1_build_nd(Libint->AB,int_stack+940277,int_stack+470117,int_stack+141833,396);
 /*--- compute (mf|nd) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+940277,int_stack+631397,396);
 /*--- compute (lg|nd) ---*/
 hrr1_build_lg(Libint->AB,int_stack+434081,int_stack+0,int_stack+762077,396);
 /*--- compute (kh|nd) ---*/
 hrr1_build_kh(Libint->AB,int_stack+701381,int_stack+434081,int_stack+220241,396);
 return int_stack+701381;}
