/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kimi(Libint_t*, prim_data*);

  /* Computes quartets of (ki|mi) integrals */

REALTYPE *hrr_order_kimi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[8][9] = int_stack + 23436;
 Libint->vrr_classes[8][10] = int_stack + 25911;
 Libint->vrr_classes[8][11] = int_stack + 28881;
 Libint->vrr_classes[8][12] = int_stack + 32391;
 Libint->vrr_classes[8][13] = int_stack + 36486;
 Libint->vrr_classes[8][14] = int_stack + 41211;
 Libint->vrr_classes[8][15] = int_stack + 46611;
 Libint->vrr_classes[9][9] = int_stack + 52731;
 Libint->vrr_classes[9][10] = int_stack + 55756;
 Libint->vrr_classes[9][11] = int_stack + 59386;
 Libint->vrr_classes[9][12] = int_stack + 63676;
 Libint->vrr_classes[9][13] = int_stack + 68681;
 Libint->vrr_classes[9][14] = int_stack + 74456;
 Libint->vrr_classes[9][15] = int_stack + 81056;
 Libint->vrr_classes[10][9] = int_stack + 88536;
 Libint->vrr_classes[10][10] = int_stack + 92166;
 Libint->vrr_classes[10][11] = int_stack + 96522;
 Libint->vrr_classes[10][12] = int_stack + 101670;
 Libint->vrr_classes[10][13] = int_stack + 107676;
 Libint->vrr_classes[10][14] = int_stack + 114606;
 Libint->vrr_classes[10][15] = int_stack + 122526;
 Libint->vrr_classes[11][9] = int_stack + 131502;
 Libint->vrr_classes[11][10] = int_stack + 135792;
 Libint->vrr_classes[11][11] = int_stack + 140940;
 Libint->vrr_classes[11][12] = int_stack + 147024;
 Libint->vrr_classes[11][13] = int_stack + 154122;
 Libint->vrr_classes[11][14] = int_stack + 162312;
 Libint->vrr_classes[11][15] = int_stack + 171672;
 Libint->vrr_classes[12][9] = int_stack + 182280;
 Libint->vrr_classes[12][10] = int_stack + 187285;
 Libint->vrr_classes[12][11] = int_stack + 193291;
 Libint->vrr_classes[12][12] = int_stack + 200389;
 Libint->vrr_classes[12][13] = int_stack + 208670;
 Libint->vrr_classes[12][14] = int_stack + 218225;
 Libint->vrr_classes[12][15] = int_stack + 229145;
 Libint->vrr_classes[13][9] = int_stack + 241521;
 Libint->vrr_classes[13][10] = int_stack + 247296;
 Libint->vrr_classes[13][11] = int_stack + 254226;
 Libint->vrr_classes[13][12] = int_stack + 262416;
 Libint->vrr_classes[13][13] = int_stack + 271971;
 Libint->vrr_classes[13][14] = int_stack + 282996;
 Libint->vrr_classes[13][15] = int_stack + 295596;
 memset(int_stack,0,309876*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 309876;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kimi(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+309876,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+315816,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+322944,int_stack+315816,int_stack+309876,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+334824,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+343248,int_stack+334824,int_stack+315816,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+357504,int_stack+343248,int_stack+322944,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+309876,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+377304,int_stack+309876,int_stack+334824,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+394152,int_stack+377304,int_stack+343248,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+319704,int_stack+394152,int_stack+357504,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+349404,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+417912,int_stack+349404,int_stack+309876,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+437568,int_stack+417912,int_stack+377304,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+465648,int_stack+437568,int_stack+394152,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+360744,int_stack+465648,int_stack+319704,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+309876,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+322836,int_stack+309876,int_stack+349404,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+501288,int_stack+322836,int_stack+417912,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+309876,int_stack+501288,int_stack+437568,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+402324,int_stack+309876,int_stack+465648,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+452220,int_stack+402324,int_stack+360744,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+309876,int_stack+25911,int_stack+23436,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+317301,int_stack+28881,int_stack+25911,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+326211,int_stack+317301,int_stack+309876,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+341061,int_stack+32391,int_stack+28881,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+351591,int_stack+341061,int_stack+317301,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+369411,int_stack+351591,int_stack+326211,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+309876,int_stack+36486,int_stack+32391,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+394161,int_stack+309876,int_stack+341061,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+415221,int_stack+394161,int_stack+351591,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+322161,int_stack+415221,int_stack+369411,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+359286,int_stack+41211,int_stack+36486,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+507660,int_stack+359286,int_stack+309876,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+507660,int_stack+394161,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+532230,int_stack+0,int_stack+415221,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+373461,int_stack+532230,int_stack+322161,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+309876,int_stack+46611,int_stack+41211,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+326076,int_stack+309876,int_stack+359286,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+576780,int_stack+326076,int_stack+507660,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+309876,int_stack+576780,int_stack+0,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+576780,int_stack+309876,int_stack+532230,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+639150,int_stack+576780,int_stack+373461,45);
 /*--- compute (kp|mi) ---*/
 hrr1_build_kp(Libint->AB,int_stack+708450,int_stack+639150,int_stack+452220,1540);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+309876,int_stack+55756,int_stack+52731,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+318951,int_stack+59386,int_stack+55756,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+329841,int_stack+318951,int_stack+309876,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+347991,int_stack+63676,int_stack+59386,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+360861,int_stack+347991,int_stack+318951,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+382641,int_stack+360861,int_stack+329841,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+309876,int_stack+68681,int_stack+63676,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+412891,int_stack+309876,int_stack+347991,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+438631,int_stack+412891,int_stack+360861,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+324891,int_stack+438631,int_stack+382641,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+370266,int_stack+74456,int_stack+68681,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+474931,int_stack+370266,int_stack+309876,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+504961,int_stack+474931,int_stack+412891,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+547861,int_stack+504961,int_stack+438631,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+387591,int_stack+547861,int_stack+324891,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+309876,int_stack+81056,int_stack+74456,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+329676,int_stack+309876,int_stack+370266,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+329676,int_stack+474931,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+309876,int_stack+0,int_stack+504961,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+309876,int_stack+547861,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+451116,int_stack+0,int_stack+387591,55);
 /*--- compute (lp|mi) ---*/
 hrr1_build_lp(Libint->AB,int_stack+874770,int_stack+451116,int_stack+639150,1540);
 /*--- compute (kd|mi) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1082670,int_stack+874770,int_stack+708450,1540);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+92166,int_stack+88536,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+96522,int_stack+92166,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+101670,int_stack+96522,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+61182,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+309876,int_stack+61182,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+107676,int_stack+101670,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+346176,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+377064,int_stack+346176,int_stack+61182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+18018,int_stack+377064,int_stack+309876,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+309876,int_stack+114606,int_stack+107676,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+72468,int_stack+309876,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+535816,int_stack+72468,int_stack+346176,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+587296,int_stack+535816,int_stack+377064,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+330666,int_stack+587296,int_stack+18018,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+122526,int_stack+114606,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+23760,int_stack+0,int_stack+309876,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+652636,int_stack+23760,int_stack+72468,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+652636,int_stack+535816,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+652636,int_stack+0,int_stack+587296,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+652636,int_stack+330666,66);
 /*--- compute (mp|mi) ---*/
 hrr1_build_mp(Libint->AB,int_stack+535816,int_stack+0,int_stack+451116,1540);
 /*--- compute (ld|mi) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1415310,int_stack+535816,int_stack+874770,1540);
 /*--- compute (kf|mi) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1831110,int_stack+1415310,int_stack+1082670,1540);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+101640,int_stack+135792,int_stack+131502,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+114510,int_stack+140940,int_stack+135792,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+789916,int_stack+114510,int_stack+101640,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+815656,int_stack+147024,int_stack+140940,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+833908,int_stack+815656,int_stack+114510,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+101640,int_stack+833908,int_stack+789916,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+789916,int_stack+154122,int_stack+147024,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+864796,int_stack+789916,int_stack+815656,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+901300,int_stack+864796,int_stack+833908,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+952780,int_stack+901300,int_stack+101640,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+101640,int_stack+162312,int_stack+154122,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+811210,int_stack+101640,int_stack+789916,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1017130,int_stack+811210,int_stack+864796,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1077970,int_stack+1017130,int_stack+901300,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+853798,int_stack+1077970,int_stack+952780,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+126210,int_stack+171672,int_stack+162312,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+943888,int_stack+126210,int_stack+101640,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+101640,int_stack+943888,int_stack+811210,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1155190,int_stack+101640,int_stack+1017130,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+943888,int_stack+1155190,int_stack+1077970,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1051996,int_stack+943888,int_stack+853798,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+2385510,int_stack+1051996,int_stack+0,1540);
 /*--- compute (md|mi) ---*/
 hrr1_build_md(Libint->AB,int_stack+2690430,int_stack+2385510,int_stack+535816,1540);
 /*--- compute (lf|mi) ---*/
 hrr1_build_lf(Libint->AB,int_stack+309876,int_stack+2690430,int_stack+1415310,1540);
 /*--- compute (kg|mi) ---*/
 hrr1_build_kg(Libint->AB,int_stack+3198630,int_stack+309876,int_stack+1831110,1540);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+187285,int_stack+182280,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+193291,int_stack+187285,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+200389,int_stack+193291,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+208670,int_stack+200389,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1172116,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1214704,int_stack+1172116,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+1214704,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+218225,int_stack+208670,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+128583,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1274764,int_stack+128583,int_stack+1172116,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1345744,int_stack+1274764,int_stack+1214704,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1435834,int_stack+1345744,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1172116,int_stack+229145,int_stack+218225,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1204876,int_stack+1172116,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+1204876,int_stack+128583,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+82810,int_stack+0,int_stack+1274764,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1172116,int_stack+82810,int_stack+1345744,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1172116,int_stack+1435834,91);
 /*--- compute (op|mi) ---*/
 hrr1_build_op(Libint->AB,int_stack+1172116,int_stack+0,int_stack+1051996,1540);
 /*--- compute (nd|mi) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1532476,int_stack+1172116,int_stack+2385510,1540);
 /*--- compute (mf|mi) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4030230,int_stack+1532476,int_stack+2690430,1540);
 /*--- compute (lg|mi) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2142316,int_stack+4030230,int_stack+309876,1540);
 /*--- compute (kh|mi) ---*/
 hrr1_build_kh(Libint->AB,int_stack+4877230,int_stack+2142316,int_stack+3198630,1540);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+309876,int_stack+247296,int_stack+241521,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+327201,int_stack+254226,int_stack+247296,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+347991,int_stack+327201,int_stack+309876,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+382641,int_stack+262416,int_stack+254226,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+407211,int_stack+382641,int_stack+327201,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+448791,int_stack+407211,int_stack+347991,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+309876,int_stack+271971,int_stack+262416,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+506541,int_stack+309876,int_stack+382641,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+555681,int_stack+506541,int_stack+407211,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+338541,int_stack+555681,int_stack+448791,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+425166,int_stack+282996,int_stack+271971,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+624981,int_stack+425166,int_stack+309876,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+682311,int_stack+624981,int_stack+506541,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+764211,int_stack+682311,int_stack+555681,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+458241,int_stack+764211,int_stack+338541,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+309876,int_stack+295596,int_stack+282996,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+347676,int_stack+309876,int_stack+425166,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+868161,int_stack+347676,int_stack+624981,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+963711,int_stack+868161,int_stack+682311,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+579516,int_stack+963711,int_stack+764211,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+725046,int_stack+579516,int_stack+458241,105);
 /*--- compute (qp|mi) ---*/
 hrr1_build_qp(Libint->AB,int_stack+3181816,int_stack+725046,int_stack+0,1540);
 /*--- compute (od|mi) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+3181816,int_stack+1172116,1540);
 /*--- compute (nf|mi) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6041470,int_stack+0,int_stack+1532476,1540);
 /*--- compute (mg|mi) ---*/
 hrr1_build_mg(Libint->AB,int_stack+0,int_stack+6041470,int_stack+4030230,1540);
 /*--- compute (lh|mi) ---*/
 hrr1_build_lh(Libint->AB,int_stack+3181816,int_stack+0,int_stack+2142316,1540);
 /*--- compute (ki|mi) ---*/
 hrr1_build_ki(Libint->AB,int_stack+0,int_stack+3181816,int_stack+4877230,1540);
 return int_stack+0;}
