/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kinh(Libint_t*, prim_data*);

  /* Computes quartets of (ki|nh) integrals */

REALTYPE *hrr_order_kinh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[8][10] = int_stack + 21456;
 Libint->vrr_classes[8][11] = int_stack + 24426;
 Libint->vrr_classes[8][12] = int_stack + 27936;
 Libint->vrr_classes[8][13] = int_stack + 32031;
 Libint->vrr_classes[8][14] = int_stack + 36756;
 Libint->vrr_classes[8][15] = int_stack + 42156;
 Libint->vrr_classes[9][10] = int_stack + 48276;
 Libint->vrr_classes[9][11] = int_stack + 51906;
 Libint->vrr_classes[9][12] = int_stack + 56196;
 Libint->vrr_classes[9][13] = int_stack + 61201;
 Libint->vrr_classes[9][14] = int_stack + 66976;
 Libint->vrr_classes[9][15] = int_stack + 73576;
 Libint->vrr_classes[10][10] = int_stack + 81056;
 Libint->vrr_classes[10][11] = int_stack + 85412;
 Libint->vrr_classes[10][12] = int_stack + 90560;
 Libint->vrr_classes[10][13] = int_stack + 96566;
 Libint->vrr_classes[10][14] = int_stack + 103496;
 Libint->vrr_classes[10][15] = int_stack + 111416;
 Libint->vrr_classes[11][10] = int_stack + 120392;
 Libint->vrr_classes[11][11] = int_stack + 125540;
 Libint->vrr_classes[11][12] = int_stack + 131624;
 Libint->vrr_classes[11][13] = int_stack + 138722;
 Libint->vrr_classes[11][14] = int_stack + 146912;
 Libint->vrr_classes[11][15] = int_stack + 156272;
 Libint->vrr_classes[12][10] = int_stack + 166880;
 Libint->vrr_classes[12][11] = int_stack + 172886;
 Libint->vrr_classes[12][12] = int_stack + 179984;
 Libint->vrr_classes[12][13] = int_stack + 188265;
 Libint->vrr_classes[12][14] = int_stack + 197820;
 Libint->vrr_classes[12][15] = int_stack + 208740;
 Libint->vrr_classes[13][10] = int_stack + 221116;
 Libint->vrr_classes[13][11] = int_stack + 228046;
 Libint->vrr_classes[13][12] = int_stack + 236236;
 Libint->vrr_classes[13][13] = int_stack + 245791;
 Libint->vrr_classes[13][14] = int_stack + 256816;
 Libint->vrr_classes[13][15] = int_stack + 269416;
 memset(int_stack,0,283696*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 283696;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kinh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283696,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+290824,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+299248,int_stack+290824,int_stack+283696,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+313504,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+323332,int_stack+313504,int_stack+290824,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+340180,int_stack+323332,int_stack+299248,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+283696,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+363940,int_stack+283696,int_stack+313504,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+295036,int_stack+363940,int_stack+323332,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+383596,int_stack+295036,int_stack+340180,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+323116,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+336076,int_stack+323116,int_stack+283696,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+419236,int_stack+336076,int_stack+363940,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+323116,int_stack+419236,int_stack+295036,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+419236,int_stack+323116,int_stack+383596,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283696,int_stack+24426,int_stack+21456,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+292606,int_stack+27936,int_stack+24426,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+303136,int_stack+292606,int_stack+283696,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+320956,int_stack+32031,int_stack+27936,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+333241,int_stack+320956,int_stack+292606,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+354301,int_stack+333241,int_stack+303136,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+283696,int_stack+36756,int_stack+32031,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+384001,int_stack+283696,int_stack+320956,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+297871,int_stack+384001,int_stack+333241,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+469132,int_stack+297871,int_stack+354301,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+332971,int_stack+42156,int_stack+36756,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+349171,int_stack+332971,int_stack+283696,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+349171,int_stack+384001,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+332971,int_stack+0,int_stack+297871,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+513682,int_stack+332971,int_stack+469132,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+576052,int_stack+513682,int_stack+419236,1386);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+51906,int_stack+48276,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+56196,int_stack+51906,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+283696,int_stack+61201,int_stack+56196,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+298711,int_stack+283696,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+324451,int_stack+298711,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+66976,int_stack+61201,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+283696,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+360751,int_stack+17325,int_stack+298711,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+403651,int_stack+360751,int_stack+324451,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+283696,int_stack+73576,int_stack+66976,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+303496,int_stack+283696,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+458101,int_stack+303496,int_stack+17325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+458101,int_stack+360751,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+283696,int_stack+0,int_stack+403651,55);
 /*--- compute (lp|nh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+725740,int_stack+283696,int_stack+513682,1386);
 /*--- compute (kd|nh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+912850,int_stack+725740,int_stack+576052,1386);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+85412,int_stack+81056,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+90560,int_stack+85412,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+96566,int_stack+90560,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+359926,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+390814,int_stack+359926,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+103496,int_stack+96566,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+434374,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+434374,int_stack+359926,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+470410,int_stack+20790,int_stack+390814,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+359926,int_stack+111416,int_stack+103496,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+383686,int_stack+359926,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+535750,int_stack+383686,int_stack+434374,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+359926,int_stack+535750,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+535750,int_stack+359926,int_stack+470410,66);
 /*--- compute (mp|nh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1212226,int_stack+535750,int_stack+283696,1386);
 /*--- compute (ld|nh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1440916,int_stack+1212226,int_stack+725740,1386);
 /*--- compute (kf|nh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1815136,int_stack+1440916,int_stack+912850,1386);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283696,int_stack+125540,int_stack+120392,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+299140,int_stack+131624,int_stack+125540,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+317392,int_stack+299140,int_stack+283696,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+348280,int_stack+138722,int_stack+131624,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+369574,int_stack+348280,int_stack+299140,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+406078,int_stack+369574,int_stack+317392,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+283696,int_stack+146912,int_stack+138722,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+457558,int_stack+283696,int_stack+348280,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+308266,int_stack+457558,int_stack+369574,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+627226,int_stack+308266,int_stack+406078,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+369106,int_stack+156272,int_stack+146912,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+397186,int_stack+369106,int_stack+283696,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+704446,int_stack+397186,int_stack+457558,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+369106,int_stack+704446,int_stack+308266,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+704446,int_stack+369106,int_stack+627226,78);
 /*--- compute (np|nh) ---*/
 hrr1_build_np(Libint->AB,int_stack+812554,int_stack+704446,int_stack+535750,1386);
 /*--- compute (md|nh) ---*/
 hrr1_build_md(Libint->AB,int_stack+2314096,int_stack+812554,int_stack+1212226,1386);
 /*--- compute (lf|nh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2771476,int_stack+2314096,int_stack+1440916,1386);
 /*--- compute (kg|nh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+3395176,int_stack+2771476,int_stack+1815136,1386);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1086982,int_stack+172886,int_stack+166880,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1105000,int_stack+179984,int_stack+172886,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1126294,int_stack+1105000,int_stack+1086982,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1162330,int_stack+188265,int_stack+179984,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1187173,int_stack+1162330,int_stack+1105000,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1229761,int_stack+1187173,int_stack+1126294,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1086982,int_stack+197820,int_stack+188265,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1289821,int_stack+1086982,int_stack+1162330,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1115647,int_stack+1289821,int_stack+1187173,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1339507,int_stack+1115647,int_stack+1229761,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1186627,int_stack+208740,int_stack+197820,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1219387,int_stack+1186627,int_stack+1086982,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1429597,int_stack+1219387,int_stack+1289821,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1186627,int_stack+1429597,int_stack+1115647,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1429597,int_stack+1186627,int_stack+1339507,91);
 /*--- compute (op|nh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1555723,int_stack+1429597,int_stack+704446,1386);
 /*--- compute (nd|nh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4143616,int_stack+1555723,int_stack+812554,1386);
 /*--- compute (mf|nh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+283696,int_stack+4143616,int_stack+2314096,1386);
 /*--- compute (lg|nh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+4692472,int_stack+283696,int_stack+2771476,1386);
 /*--- compute (kh|nh) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1880047,int_stack+4692472,int_stack+3395176,1386);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2927863,int_stack+228046,int_stack+221116,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2948653,int_stack+236236,int_stack+228046,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2973223,int_stack+2948653,int_stack+2927863,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3014803,int_stack+245791,int_stack+236236,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3043468,int_stack+3014803,int_stack+2948653,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3092608,int_stack+3043468,int_stack+2973223,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2927863,int_stack+256816,int_stack+245791,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3161908,int_stack+2927863,int_stack+3014803,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2960938,int_stack+3161908,int_stack+3043468,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3219238,int_stack+2960938,int_stack+3092608,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3042838,int_stack+269416,int_stack+256816,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3080638,int_stack+3042838,int_stack+2927863,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3323188,int_stack+3080638,int_stack+3161908,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3042838,int_stack+3323188,int_stack+2960938,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3323188,int_stack+3042838,int_stack+3219238,105);
 /*--- compute (qp|nh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+3468718,int_stack+3323188,int_stack+1429597,1386);
 /*--- compute (od|nh) ---*/
 hrr1_build_od(Libint->AB,int_stack+5628022,int_stack+3468718,int_stack+1555723,1386);
 /*--- compute (nf|nh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2927863,int_stack+5628022,int_stack+4143616,1386);
 /*--- compute (mg|nh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+5628022,int_stack+2927863,int_stack+283696,1386);
 /*--- compute (lh|nh) ---*/
 hrr1_build_lh(Libint->AB,int_stack+2927863,int_stack+5628022,int_stack+4692472,1386);
 /*--- compute (ki|nh) ---*/
 hrr1_build_ki(Libint->AB,int_stack+4237633,int_stack+2927863,int_stack+1880047,1386);
 return int_stack+4237633;}
