/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kkni(Libint_t*, prim_data*);

  /* Computes quartets of (kk|ni) integrals */

REALTYPE *hrr_order_kkni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[8][10] = int_stack + 26964;
 Libint->vrr_classes[8][11] = int_stack + 29934;
 Libint->vrr_classes[8][12] = int_stack + 33444;
 Libint->vrr_classes[8][13] = int_stack + 37539;
 Libint->vrr_classes[8][14] = int_stack + 42264;
 Libint->vrr_classes[8][15] = int_stack + 47664;
 Libint->vrr_classes[8][16] = int_stack + 53784;
 Libint->vrr_classes[9][10] = int_stack + 60669;
 Libint->vrr_classes[9][11] = int_stack + 64299;
 Libint->vrr_classes[9][12] = int_stack + 68589;
 Libint->vrr_classes[9][13] = int_stack + 73594;
 Libint->vrr_classes[9][14] = int_stack + 79369;
 Libint->vrr_classes[9][15] = int_stack + 85969;
 Libint->vrr_classes[9][16] = int_stack + 93449;
 Libint->vrr_classes[10][10] = int_stack + 101864;
 Libint->vrr_classes[10][11] = int_stack + 106220;
 Libint->vrr_classes[10][12] = int_stack + 111368;
 Libint->vrr_classes[10][13] = int_stack + 117374;
 Libint->vrr_classes[10][14] = int_stack + 124304;
 Libint->vrr_classes[10][15] = int_stack + 132224;
 Libint->vrr_classes[10][16] = int_stack + 141200;
 Libint->vrr_classes[11][10] = int_stack + 151298;
 Libint->vrr_classes[11][11] = int_stack + 156446;
 Libint->vrr_classes[11][12] = int_stack + 162530;
 Libint->vrr_classes[11][13] = int_stack + 169628;
 Libint->vrr_classes[11][14] = int_stack + 177818;
 Libint->vrr_classes[11][15] = int_stack + 187178;
 Libint->vrr_classes[11][16] = int_stack + 197786;
 Libint->vrr_classes[12][10] = int_stack + 209720;
 Libint->vrr_classes[12][11] = int_stack + 215726;
 Libint->vrr_classes[12][12] = int_stack + 222824;
 Libint->vrr_classes[12][13] = int_stack + 231105;
 Libint->vrr_classes[12][14] = int_stack + 240660;
 Libint->vrr_classes[12][15] = int_stack + 251580;
 Libint->vrr_classes[12][16] = int_stack + 263956;
 Libint->vrr_classes[13][10] = int_stack + 277879;
 Libint->vrr_classes[13][11] = int_stack + 284809;
 Libint->vrr_classes[13][12] = int_stack + 292999;
 Libint->vrr_classes[13][13] = int_stack + 302554;
 Libint->vrr_classes[13][14] = int_stack + 313579;
 Libint->vrr_classes[13][15] = int_stack + 326179;
 Libint->vrr_classes[13][16] = int_stack + 340459;
 Libint->vrr_classes[14][10] = int_stack + 356524;
 Libint->vrr_classes[14][11] = int_stack + 364444;
 Libint->vrr_classes[14][12] = int_stack + 373804;
 Libint->vrr_classes[14][13] = int_stack + 384724;
 Libint->vrr_classes[14][14] = int_stack + 397324;
 Libint->vrr_classes[14][15] = int_stack + 411724;
 Libint->vrr_classes[14][16] = int_stack + 428044;
 memset(int_stack,0,446404*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 446404;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kkni(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+453532,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+461956,int_stack+453532,int_stack+446404,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+476212,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+486040,int_stack+476212,int_stack+453532,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+502888,int_stack+486040,int_stack+461956,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+526648,int_stack+446404,int_stack+476212,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+457744,int_stack+526648,int_stack+486040,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+546304,int_stack+457744,int_stack+502888,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+485824,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+498784,int_stack+485824,int_stack+446404,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+581944,int_stack+498784,int_stack+526648,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+614704,int_stack+581944,int_stack+457744,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+656824,int_stack+614704,int_stack+546304,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+446404,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+521464,int_stack+446404,int_stack+485824,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+446404,int_stack+521464,int_stack+498784,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+484204,int_stack+446404,int_stack+581944,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+533344,int_stack+484204,int_stack+614704,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+446404,int_stack+533344,int_stack+656824,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+512932,int_stack+29934,int_stack+26964,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+521842,int_stack+33444,int_stack+29934,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+532372,int_stack+521842,int_stack+512932,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+550192,int_stack+37539,int_stack+33444,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+562477,int_stack+550192,int_stack+521842,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+583537,int_stack+562477,int_stack+532372,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+512932,int_stack+42264,int_stack+37539,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+613237,int_stack+512932,int_stack+550192,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+527107,int_stack+613237,int_stack+562477,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+637807,int_stack+527107,int_stack+583537,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+562207,int_stack+47664,int_stack+42264,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+578407,int_stack+562207,int_stack+512932,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+578407,int_stack+613237,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+682357,int_stack+0,int_stack+527107,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+735007,int_stack+682357,int_stack+637807,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+512932,int_stack+53784,int_stack+47664,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+606757,int_stack+512932,int_stack+562207,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+512932,int_stack+606757,int_stack+578407,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+560182,int_stack+512932,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+797377,int_stack+560182,int_stack+682357,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+512932,int_stack+797377,int_stack+735007,45);
 /*--- compute (kp|ni) ---*/
 hrr1_build_kp(Libint->AB,int_stack+596092,int_stack+512932,int_stack+446404,1848);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+64299,int_stack+60669,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+457294,int_stack+68589,int_stack+64299,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+470164,int_stack+457294,int_stack+446404,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+491944,int_stack+73594,int_stack+68589,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+491944,int_stack+457294,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25740,int_stack+0,int_stack+470164,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+79369,int_stack+73594,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+795676,int_stack+446404,int_stack+491944,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+463729,int_stack+795676,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+825706,int_stack+463729,int_stack+25740,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+85969,int_stack+79369,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+446404,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+880156,int_stack+19800,int_stack+795676,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+930206,int_stack+880156,int_stack+463729,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+994556,int_stack+930206,int_stack+825706,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+795676,int_stack+93449,int_stack+85969,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+818116,int_stack+795676,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+446404,int_stack+818116,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+446404,int_stack+880156,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+795676,int_stack+0,int_stack+930206,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+795676,int_stack+994556,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+795676,int_stack+0,int_stack+512932,1848);
 /*--- compute (kd|ni) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1045156,int_stack+795676,int_stack+596092,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+106220,int_stack+101864,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+459472,int_stack+111368,int_stack+106220,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+474916,int_stack+459472,int_stack+446404,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+501052,int_stack+117374,int_stack+111368,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+519070,int_stack+501052,int_stack+459472,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+549958,int_stack+519070,int_stack+474916,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+124304,int_stack+117374,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+593518,int_stack+446404,int_stack+501052,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+467194,int_stack+593518,int_stack+519070,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+629554,int_stack+467194,int_stack+549958,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+518674,int_stack+132224,int_stack+124304,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+542434,int_stack+518674,int_stack+446404,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+694894,int_stack+542434,int_stack+593518,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1444324,int_stack+694894,int_stack+467194,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1521544,int_stack+1444324,int_stack+629554,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+446404,int_stack+141200,int_stack+132224,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+584014,int_stack+446404,int_stack+518674,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+446404,int_stack+584014,int_stack+542434,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+515704,int_stack+446404,int_stack+694894,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+605794,int_stack+515704,int_stack+1444324,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+446404,int_stack+605794,int_stack+1521544,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1444324,int_stack+446404,int_stack+0,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1749244,int_stack+1444324,int_stack+795676,1848);
 /*--- compute (kf|ni) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2248204,int_stack+1749244,int_stack+1045156,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+156446,int_stack+151298,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+162530,int_stack+156446,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+169628,int_stack+162530,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+568372,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+177818,int_stack+169628,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+122382,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+122382,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+619852,int_stack+24570,int_stack+568372,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+568372,int_stack+187178,int_stack+177818,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+697072,int_stack+568372,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+746212,int_stack+697072,int_stack+122382,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+85410,int_stack+746212,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+817192,int_stack+85410,int_stack+619852,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+197786,int_stack+187178,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+596452,int_stack+0,int_stack+568372,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+596452,int_stack+697072,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+568372,int_stack+0,int_stack+746212,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+674842,int_stack+568372,int_stack+85410,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+674842,int_stack+817192,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+568372,int_stack+0,int_stack+446404,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+2913484,int_stack+568372,int_stack+1444324,1848);
 /*--- compute (lf|ni) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3523324,int_stack+2913484,int_stack+1749244,1848);
 /*--- compute (kg|ni) ---*/
 hrr1_build_kg(Libint->AB,int_stack+934276,int_stack+3523324,int_stack+2248204,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+215726,int_stack+209720,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+464422,int_stack+222824,int_stack+215726,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+485716,int_stack+464422,int_stack+446404,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+521752,int_stack+231105,int_stack+222824,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1932196,int_stack+521752,int_stack+464422,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1974784,int_stack+1932196,int_stack+485716,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+240660,int_stack+231105,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2034844,int_stack+446404,int_stack+521752,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+475069,int_stack+2034844,int_stack+1932196,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2084530,int_stack+475069,int_stack+1974784,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1932196,int_stack+251580,int_stack+240660,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1964956,int_stack+1932196,int_stack+446404,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2174620,int_stack+1964956,int_stack+2034844,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2257430,int_stack+2174620,int_stack+475069,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2363900,int_stack+2257430,int_stack+2084530,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+446404,int_stack+263956,int_stack+251580,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+483532,int_stack+446404,int_stack+1932196,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2022286,int_stack+483532,int_stack+1964956,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2490026,int_stack+2022286,int_stack+2174620,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1932196,int_stack+2490026,int_stack+2257430,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2490026,int_stack+1932196,int_stack+2363900,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1932196,int_stack+2490026,int_stack+0,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4354924,int_stack+1932196,int_stack+568372,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5086732,int_stack+4354924,int_stack+2913484,1848);
 /*--- compute (lg|ni) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6103132,int_stack+5086732,int_stack+3523324,1848);
 /*--- compute (kh|ni) ---*/
 hrr1_build_kh(Libint->AB,int_stack+2658194,int_stack+6103132,int_stack+934276,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+284809,int_stack+277879,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+292999,int_stack+284809,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+302554,int_stack+292999,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+313579,int_stack+302554,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234045,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+234045,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2364628,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+326179,int_stack+313579,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4055282,int_stack+152775,int_stack+234045,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4150832,int_stack+4055282,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+446404,int_stack+4150832,int_stack+2364628,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2364628,int_stack+340459,int_stack+326179,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2407468,int_stack+2364628,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+2407468,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+110250,int_stack+0,int_stack+4055282,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+591934,int_stack+110250,int_stack+4150832,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4055282,int_stack+591934,int_stack+446404,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+446404,int_stack+4055282,int_stack+2490026,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+950908,int_stack+446404,int_stack+1932196,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+7350532,int_stack+950908,int_stack+4354924,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+8570212,int_stack+7350532,int_stack+5086732,1848);
 /*--- compute (lh|ni) ---*/
 hrr1_build_lh(Libint->AB,int_stack+4249322,int_stack+8570212,int_stack+6103132,1848);
 /*--- compute (ki|ni) ---*/
 hrr1_build_ki(Libint->AB,int_stack+10094812,int_stack+4249322,int_stack+2658194,1848);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1815772,int_stack+364444,int_stack+356524,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1839532,int_stack+373804,int_stack+364444,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1867612,int_stack+1839532,int_stack+1815772,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1915132,int_stack+384724,int_stack+373804,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1947892,int_stack+1915132,int_stack+1839532,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2004052,int_stack+1947892,int_stack+1867612,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1815772,int_stack+397324,int_stack+384724,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2083252,int_stack+1815772,int_stack+1915132,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1853572,int_stack+2083252,int_stack+1947892,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2148772,int_stack+1853572,int_stack+2004052,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1947172,int_stack+411724,int_stack+397324,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1990372,int_stack+1947172,int_stack+1815772,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2267572,int_stack+1990372,int_stack+2083252,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2376772,int_stack+2267572,int_stack+1853572,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2517172,int_stack+2376772,int_stack+2148772,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1815772,int_stack+428044,int_stack+411724,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2065972,int_stack+1815772,int_stack+1947172,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1815772,int_stack+2065972,int_stack+1990372,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1941772,int_stack+1815772,int_stack+2267572,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2105572,int_stack+1941772,int_stack+2376772,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1815772,int_stack+2105572,int_stack+2517172,120);
 /*--- compute (rp|ni) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2037532,int_stack+1815772,int_stack+4055282,1848);
 /*--- compute (qd|ni) ---*/
 hrr1_build_qd(Libint->AB,int_stack+2619652,int_stack+2037532,int_stack+446404,1848);
 /*--- compute (of|ni) ---*/
 hrr1_build_of(Libint->AB,int_stack+11957596,int_stack+2619652,int_stack+950908,1848);
 /*--- compute (ng|ni) ---*/
 hrr1_build_ng(Libint->AB,int_stack+0,int_stack+11957596,int_stack+7350532,1848);
 /*--- compute (mh|ni) ---*/
 hrr1_build_mh(Libint->AB,int_stack+5995682,int_stack+0,int_stack+8570212,1848);
 /*--- compute (li|ni) ---*/
 hrr1_build_li(Libint->AB,int_stack+0,int_stack+5995682,int_stack+4249322,1848);
 /*--- compute (kk|ni) ---*/
 hrr1_build_kk(Libint->AB,int_stack+2328480,int_stack+0,int_stack+10094812,1848);
 return int_stack+2328480;}
