/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpii(Libint_t*, prim_data*);

  /* Computes quartets of (kp|ii) integrals */

REALTYPE *hrr_order_kpii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[7][11] = int_stack + 8280;
 Libint->vrr_classes[7][12] = int_stack + 11088;
 Libint->vrr_classes[8][6] = int_stack + 14364;
 Libint->vrr_classes[8][7] = int_stack + 15624;
 Libint->vrr_classes[8][8] = int_stack + 17244;
 Libint->vrr_classes[8][9] = int_stack + 19269;
 Libint->vrr_classes[8][10] = int_stack + 21744;
 Libint->vrr_classes[8][11] = int_stack + 24714;
 Libint->vrr_classes[8][12] = int_stack + 28224;
 memset(int_stack,0,32319*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 32319;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpii(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+32319,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35343,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+39231,int_stack+35343,int_stack+32319,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45279,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+50139,int_stack+45279,int_stack+35343,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+57915,int_stack+50139,int_stack+39231,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32319,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+67995,int_stack+32319,int_stack+45279,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+77715,int_stack+67995,int_stack+50139,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+38259,int_stack+77715,int_stack+57915,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53379,int_stack+8280,int_stack+5904,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+90675,int_stack+53379,int_stack+32319,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+102555,int_stack+90675,int_stack+67995,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+118755,int_stack+102555,int_stack+77715,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+60507,int_stack+118755,int_stack+38259,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+32319,int_stack+11088,int_stack+8280,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+32319,int_stack+53379,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+32319,int_stack+0,int_stack+90675,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+138195,int_stack+32319,int_stack+102555,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+32319,int_stack+138195,int_stack+118755,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+81675,int_stack+32319,int_stack+60507,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+32319,int_stack+15624,int_stack+14364,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+36099,int_stack+17244,int_stack+15624,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+40959,int_stack+36099,int_stack+32319,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+48519,int_stack+19269,int_stack+17244,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+54594,int_stack+48519,int_stack+36099,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+64314,int_stack+54594,int_stack+40959,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32319,int_stack+21744,int_stack+19269,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+32319,int_stack+48519,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+109899,int_stack+0,int_stack+54594,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+39744,int_stack+109899,int_stack+64314,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58644,int_stack+24714,int_stack+21744,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126099,int_stack+58644,int_stack+32319,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+140949,int_stack+126099,int_stack+0,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+140949,int_stack+109899,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+161199,int_stack+0,int_stack+39744,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+109899,int_stack+28224,int_stack+24714,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24300,int_stack+109899,int_stack+58644,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+42120,int_stack+24300,int_stack+126099,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+109899,int_stack+42120,int_stack+140949,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+24300,int_stack+109899,int_stack+0,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+109899,int_stack+24300,int_stack+161199,45);
 /*--- compute (kp|ii) ---*/
 hrr1_build_kp(Libint->AB,int_stack+145179,int_stack+109899,int_stack+81675,784);
 return int_stack+145179;}
