/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpll(Libint_t*, prim_data*);

  /* Computes quartets of (kp|ll) integrals */

REALTYPE *hrr_order_kpll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[7][16] = int_stack + 25056;
 Libint->vrr_classes[8][8] = int_stack + 30564;
 Libint->vrr_classes[8][9] = int_stack + 32589;
 Libint->vrr_classes[8][10] = int_stack + 35064;
 Libint->vrr_classes[8][11] = int_stack + 38034;
 Libint->vrr_classes[8][12] = int_stack + 41544;
 Libint->vrr_classes[8][13] = int_stack + 45639;
 Libint->vrr_classes[8][14] = int_stack + 50364;
 Libint->vrr_classes[8][15] = int_stack + 55764;
 Libint->vrr_classes[8][16] = int_stack + 61884;
 memset(int_stack,0,68769*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 68769;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpll(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+68769,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+73629,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+79569,int_stack+73629,int_stack+68769,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+89289,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96417,int_stack+89289,int_stack+73629,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+108297,int_stack+96417,int_stack+79569,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+68769,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+124497,int_stack+68769,int_stack+89289,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138753,int_stack+124497,int_stack+96417,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+77193,int_stack+138753,int_stack+108297,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+101493,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+158553,int_stack+101493,int_stack+68769,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+175401,int_stack+158553,int_stack+124497,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+199161,int_stack+175401,int_stack+138753,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+111321,int_stack+199161,int_stack+77193,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+68769,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+80109,int_stack+68769,int_stack+101493,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+228861,int_stack+80109,int_stack+158553,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+256941,int_stack+228861,int_stack+175401,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+145341,int_stack+256941,int_stack+199161,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+292581,int_stack+145341,int_stack+111321,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99765,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+112725,int_stack+99765,int_stack+68769,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+186921,int_stack+112725,int_stack+80109,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+337941,int_stack+186921,int_stack+228861,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+380061,int_stack+337941,int_stack+256941,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+219681,int_stack+380061,int_stack+145341,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+429957,int_stack+219681,int_stack+292581,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+68769,int_stack+25056,int_stack+20160,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+135405,int_stack+68769,int_stack+99765,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+68769,int_stack+135405,int_stack+112725,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+106569,int_stack+68769,int_stack+186921,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+155709,int_stack+106569,int_stack+337941,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+68769,int_stack+155709,int_stack+380061,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+135297,int_stack+68769,int_stack+219681,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+206577,int_stack+135297,int_stack+429957,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+68769,int_stack+32589,int_stack+30564,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+74844,int_stack+35064,int_stack+32589,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82269,int_stack+74844,int_stack+68769,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+94419,int_stack+38034,int_stack+35064,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+103329,int_stack+94419,int_stack+74844,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+118179,int_stack+103329,int_stack+82269,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+68769,int_stack+41544,int_stack+38034,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+138429,int_stack+68769,int_stack+94419,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+156249,int_stack+138429,int_stack+103329,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+79299,int_stack+156249,int_stack+118179,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109674,int_stack+45639,int_stack+41544,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+180999,int_stack+109674,int_stack+68769,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+279477,int_stack+180999,int_stack+138429,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+309177,int_stack+279477,int_stack+156249,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+121959,int_stack+309177,int_stack+79299,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+68769,int_stack+50364,int_stack+45639,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+82944,int_stack+68769,int_stack+109674,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+346302,int_stack+82944,int_stack+180999,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+381402,int_stack+346302,int_stack+279477,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+425952,int_stack+381402,int_stack+309177,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+279477,int_stack+425952,int_stack+121959,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+107514,int_stack+55764,int_stack+50364,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+123714,int_stack+107514,int_stack+68769,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+152064,int_stack+123714,int_stack+82944,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+152064,int_stack+346302,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+477927,int_stack+0,int_stack+381402,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+336177,int_stack+477927,int_stack+425952,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+540297,int_stack+336177,int_stack+279477,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+279477,int_stack+61884,int_stack+55764,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+297837,int_stack+279477,int_stack+107514,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+405477,int_stack+297837,int_stack+123714,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+52650,int_stack+405477,int_stack+152064,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+114075,int_stack+52650,int_stack+0,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+114075,int_stack+477927,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+83160,int_stack+0,int_stack+336177,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+279477,int_stack+83160,int_stack+540297,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+370602,int_stack+279477,int_stack+206577,2025);
 return int_stack+370602;}
