/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpnk(Libint_t*, prim_data*);

  /* Computes quartets of (kp|nk) integrals */

REALTYPE *hrr_order_kpnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[8][10] = int_stack + 33120;
 Libint->vrr_classes[8][11] = int_stack + 36090;
 Libint->vrr_classes[8][12] = int_stack + 39600;
 Libint->vrr_classes[8][13] = int_stack + 43695;
 Libint->vrr_classes[8][14] = int_stack + 48420;
 Libint->vrr_classes[8][15] = int_stack + 53820;
 Libint->vrr_classes[8][16] = int_stack + 59940;
 Libint->vrr_classes[8][17] = int_stack + 66825;
 memset(int_stack,0,74520*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 74520;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpnk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74520,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81648,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+90072,int_stack+81648,int_stack+74520,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+104328,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+114156,int_stack+104328,int_stack+81648,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+131004,int_stack+114156,int_stack+90072,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+74520,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+154764,int_stack+74520,int_stack+104328,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+85860,int_stack+154764,int_stack+114156,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+174420,int_stack+85860,int_stack+131004,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+113940,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+126900,int_stack+113940,int_stack+74520,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+210060,int_stack+126900,int_stack+154764,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+242820,int_stack+210060,int_stack+85860,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+284940,int_stack+242820,int_stack+174420,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+74520,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+149580,int_stack+74520,int_stack+113940,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+334836,int_stack+149580,int_stack+126900,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+89208,int_stack+334836,int_stack+210060,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+175500,int_stack+89208,int_stack+242820,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+372636,int_stack+175500,int_stack+284940,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+234468,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+250992,int_stack+234468,int_stack+74520,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+280368,int_stack+250992,int_stack+149580,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+439164,int_stack+280368,int_stack+334836,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+234468,int_stack+439164,int_stack+89208,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+74520,int_stack+234468,int_stack+175500,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+153144,int_stack+74520,int_stack+372636,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74520,int_stack+36090,int_stack+33120,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83430,int_stack+39600,int_stack+36090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+93960,int_stack+83430,int_stack+74520,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+111780,int_stack+43695,int_stack+39600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+124065,int_stack+111780,int_stack+83430,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238680,int_stack+124065,int_stack+93960,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+74520,int_stack+48420,int_stack+43695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+268380,int_stack+74520,int_stack+111780,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+88695,int_stack+268380,int_stack+124065,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+292950,int_stack+88695,int_stack+238680,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+238680,int_stack+53820,int_stack+48420,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+123795,int_stack+238680,int_stack+74520,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+337500,int_stack+123795,int_stack+268380,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+378450,int_stack+337500,int_stack+88695,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+431100,int_stack+378450,int_stack+292950,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+74520,int_stack+59940,int_stack+53820,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+254880,int_stack+74520,int_stack+238680,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+287280,int_stack+254880,int_stack+123795,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+493470,int_stack+287280,int_stack+337500,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+554895,int_stack+493470,int_stack+378450,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+334530,int_stack+554895,int_stack+431100,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+92880,int_stack+66825,int_stack+59940,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+113535,int_stack+92880,int_stack+74520,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+417690,int_stack+113535,int_stack+254880,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+417690,int_stack+287280,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+238680,int_stack+0,int_stack+493470,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+238680,int_stack+554895,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+417690,int_stack+0,int_stack+334530,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+524610,int_stack+417690,int_stack+153144,2376);
 return int_stack+524610;}
