/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldlf(Libint_t*, prim_data*);

  /* Computes quartets of (ld|lf) integrals */

REALTYPE *hrr_order_ldlf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[9][8] = int_stack + 10980;
 Libint->vrr_classes[9][9] = int_stack + 13455;
 Libint->vrr_classes[9][10] = int_stack + 16480;
 Libint->vrr_classes[9][11] = int_stack + 20110;
 Libint->vrr_classes[10][8] = int_stack + 24400;
 Libint->vrr_classes[10][9] = int_stack + 27370;
 Libint->vrr_classes[10][10] = int_stack + 31000;
 Libint->vrr_classes[10][11] = int_stack + 35356;
 memset(int_stack,0,40504*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40504;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldlf(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40504,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46579,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54004,int_stack+46579,int_stack+40504,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+66154,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75064,int_stack+66154,int_stack+46579,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+89914,int_stack+75064,int_stack+54004,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40504,int_stack+13455,int_stack+10980,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47929,int_stack+16480,int_stack+13455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+57004,int_stack+47929,int_stack+40504,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71854,int_stack+20110,int_stack+16480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+71854,int_stack+47929,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+110164,int_stack+0,int_stack+57004,55);
 /*--- compute (lp|lf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+134914,int_stack+110164,int_stack+89914,450);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+27370,int_stack+24400,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+31000,int_stack+27370,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+40504,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58324,int_stack+35356,int_stack+31000,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+71392,int_stack+58324,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+71392,int_stack+40504,66);
 /*--- compute (mp|lf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+29700,int_stack+0,int_stack+110164,450);
 /*--- compute (ld|lf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+195664,int_stack+29700,int_stack+134914,450);
 return int_stack+195664;}
