/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfll(Libint_t*, prim_data*);

  /* Computes quartets of (lf|ll) integrals */

REALTYPE *hrr_order_lfll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[8][15] = int_stack + 25200;
 Libint->vrr_classes[8][16] = int_stack + 31320;
 Libint->vrr_classes[9][8] = int_stack + 38205;
 Libint->vrr_classes[9][9] = int_stack + 40680;
 Libint->vrr_classes[9][10] = int_stack + 43705;
 Libint->vrr_classes[9][11] = int_stack + 47335;
 Libint->vrr_classes[9][12] = int_stack + 51625;
 Libint->vrr_classes[9][13] = int_stack + 56630;
 Libint->vrr_classes[9][14] = int_stack + 62405;
 Libint->vrr_classes[9][15] = int_stack + 69005;
 Libint->vrr_classes[9][16] = int_stack + 76485;
 Libint->vrr_classes[10][8] = int_stack + 84900;
 Libint->vrr_classes[10][9] = int_stack + 87870;
 Libint->vrr_classes[10][10] = int_stack + 91500;
 Libint->vrr_classes[10][11] = int_stack + 95856;
 Libint->vrr_classes[10][12] = int_stack + 101004;
 Libint->vrr_classes[10][13] = int_stack + 107010;
 Libint->vrr_classes[10][14] = int_stack + 113940;
 Libint->vrr_classes[10][15] = int_stack + 121860;
 Libint->vrr_classes[10][16] = int_stack + 130836;
 Libint->vrr_classes[11][8] = int_stack + 140934;
 Libint->vrr_classes[11][9] = int_stack + 144444;
 Libint->vrr_classes[11][10] = int_stack + 148734;
 Libint->vrr_classes[11][11] = int_stack + 153882;
 Libint->vrr_classes[11][12] = int_stack + 159966;
 Libint->vrr_classes[11][13] = int_stack + 167064;
 Libint->vrr_classes[11][14] = int_stack + 175254;
 Libint->vrr_classes[11][15] = int_stack + 184614;
 Libint->vrr_classes[11][16] = int_stack + 195222;
 memset(int_stack,0,207156*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 207156;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfll(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+207156,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+213231,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+220656,int_stack+213231,int_stack+207156,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+232806,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+241716,int_stack+232806,int_stack+213231,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+256566,int_stack+241716,int_stack+220656,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207156,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+276816,int_stack+207156,int_stack+232806,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+294636,int_stack+276816,int_stack+241716,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+217686,int_stack+294636,int_stack+256566,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+248061,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+319386,int_stack+248061,int_stack+207156,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+340446,int_stack+319386,int_stack+276816,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+370146,int_stack+340446,int_stack+294636,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+260346,int_stack+370146,int_stack+217686,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207156,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+221331,int_stack+207156,int_stack+248061,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+407271,int_stack+221331,int_stack+319386,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+442371,int_stack+407271,int_stack+340446,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+302871,int_stack+442371,int_stack+370146,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+486921,int_stack+302871,int_stack+260346,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+245901,int_stack+25200,int_stack+19800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+262101,int_stack+245901,int_stack+207156,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+354846,int_stack+262101,int_stack+221331,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+543621,int_stack+354846,int_stack+407271,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+596271,int_stack+543621,int_stack+442371,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+395796,int_stack+596271,int_stack+302871,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+658641,int_stack+395796,int_stack+486921,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+207156,int_stack+31320,int_stack+25200,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+290451,int_stack+207156,int_stack+245901,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+207156,int_stack+290451,int_stack+262101,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+254406,int_stack+207156,int_stack+354846,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+315831,int_stack+254406,int_stack+543621,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+207156,int_stack+315831,int_stack+596271,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+290316,int_stack+207156,int_stack+395796,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+379416,int_stack+290316,int_stack+658641,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+207156,int_stack+40680,int_stack+38205,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+214581,int_stack+43705,int_stack+40680,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+223656,int_stack+214581,int_stack+207156,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+238506,int_stack+47335,int_stack+43705,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+249396,int_stack+238506,int_stack+214581,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+267546,int_stack+249396,int_stack+223656,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207156,int_stack+51625,int_stack+47335,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+292296,int_stack+207156,int_stack+238506,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+314076,int_stack+292296,int_stack+249396,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+220026,int_stack+314076,int_stack+267546,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+257151,int_stack+56630,int_stack+51625,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+344326,int_stack+257151,int_stack+207156,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+470541,int_stack+344326,int_stack+292296,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+506841,int_stack+470541,int_stack+314076,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+272166,int_stack+506841,int_stack+220026,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207156,int_stack+62405,int_stack+56630,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+224481,int_stack+207156,int_stack+257151,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+552216,int_stack+224481,int_stack+344326,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+324141,int_stack+552216,int_stack+470541,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+595116,int_stack+324141,int_stack+506841,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+470541,int_stack+595116,int_stack+272166,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+254511,int_stack+69005,int_stack+62405,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+274311,int_stack+254511,int_stack+207156,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+658641,int_stack+274311,int_stack+224481,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+658641,int_stack+552216,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+708691,int_stack+0,int_stack+324141,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+784921,int_stack+708691,int_stack+595116,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+539841,int_stack+784921,int_stack+470541,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+470541,int_stack+76485,int_stack+69005,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+492981,int_stack+470541,int_stack+254511,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+207156,int_stack+492981,int_stack+274311,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+264906,int_stack+207156,int_stack+658641,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+869621,int_stack+264906,int_stack+0,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+207156,int_stack+869621,int_stack+708691,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+628941,int_stack+207156,int_stack+784921,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+207156,int_stack+628941,int_stack+539841,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+470541,int_stack+207156,int_stack+379416,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+318531,int_stack+87870,int_stack+84900,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+327441,int_stack+91500,int_stack+87870,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+338331,int_stack+327441,int_stack+318531,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356151,int_stack+95856,int_stack+91500,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+369219,int_stack+356151,int_stack+327441,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+390999,int_stack+369219,int_stack+338331,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+318531,int_stack+101004,int_stack+95856,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+420699,int_stack+318531,int_stack+356151,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+420699,int_stack+369219,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+333975,int_stack+0,int_stack+390999,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+378525,int_stack+107010,int_stack+101004,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+36300,int_stack+378525,int_stack+318531,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+743916,int_stack+36300,int_stack+420699,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+396543,int_stack+743916,int_stack+0,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+787476,int_stack+396543,int_stack+333975,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+113940,int_stack+107010,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+318531,int_stack+0,int_stack+378525,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+849846,int_stack+318531,int_stack+36300,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+20790,int_stack+849846,int_stack+743916,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+901326,int_stack+20790,int_stack+396543,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+354567,int_stack+901326,int_stack+787476,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+743916,int_stack+121860,int_stack+113940,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+767676,int_stack+743916,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+977556,int_stack+767676,int_stack+318531,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1037616,int_stack+977556,int_stack+849846,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+809256,int_stack+1037616,int_stack+20790,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+809256,int_stack+901326,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1114836,int_stack+0,int_stack+354567,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+318531,int_stack+130836,int_stack+121860,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+345459,int_stack+318531,int_stack+743916,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+392979,int_stack+345459,int_stack+767676,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1221756,int_stack+392979,int_stack+977556,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+318531,int_stack+1221756,int_stack+1037616,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+900732,int_stack+318531,int_stack+809256,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+318531,int_stack+900732,int_stack+0,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+318531,int_stack+1114836,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+743916,int_stack+0,int_stack+207156,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1078041,int_stack+743916,int_stack+470541,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+207156,int_stack+144444,int_stack+140934,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+217686,int_stack+148734,int_stack+144444,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+230556,int_stack+217686,int_stack+207156,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+251616,int_stack+153882,int_stack+148734,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+267060,int_stack+251616,int_stack+217686,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+292800,int_stack+267060,int_stack+230556,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207156,int_stack+159966,int_stack+153882,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+327900,int_stack+207156,int_stack+251616,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+358788,int_stack+327900,int_stack+267060,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+225408,int_stack+358788,int_stack+292800,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+278058,int_stack+167064,int_stack+159966,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+401688,int_stack+278058,int_stack+207156,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+438192,int_stack+401688,int_stack+327900,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+489672,int_stack+438192,int_stack+358788,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+299352,int_stack+489672,int_stack+225408,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207156,int_stack+175254,int_stack+167064,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+231726,int_stack+207156,int_stack+278058,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+554022,int_stack+231726,int_stack+401688,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+614862,int_stack+554022,int_stack+438192,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+373062,int_stack+614862,int_stack+489672,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1624791,int_stack+373062,int_stack+299352,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+274314,int_stack+184614,int_stack+175254,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+302394,int_stack+274314,int_stack+207156,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+463152,int_stack+302394,int_stack+231726,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1723071,int_stack+463152,int_stack+554022,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1814331,int_stack+1723071,int_stack+614862,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+534132,int_stack+1814331,int_stack+373062,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1922439,int_stack+534132,int_stack+1624791,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1624791,int_stack+195222,int_stack+184614,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1656615,int_stack+1624791,int_stack+274314,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+351534,int_stack+1656615,int_stack+302394,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+133650,int_stack+351534,int_stack+463152,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+240120,int_stack+133650,int_stack+1723071,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1624791,int_stack+240120,int_stack+1814331,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+133650,int_stack+1624791,int_stack+534132,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+1624791,int_stack+133650,int_stack+1922439,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+133650,int_stack+1624791,int_stack+0,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+1624791,int_stack+133650,int_stack+743916,2025);
 /*--- compute (lf|ll) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1624791,int_stack+1078041,2025);
 return int_stack+0;}
