/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfnk(Libint_t*, prim_data*);

  /* Computes quartets of (lf|nk) integrals */

REALTYPE *hrr_order_lfnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[9][10] = int_stack + 41400;
 Libint->vrr_classes[9][11] = int_stack + 45030;
 Libint->vrr_classes[9][12] = int_stack + 49320;
 Libint->vrr_classes[9][13] = int_stack + 54325;
 Libint->vrr_classes[9][14] = int_stack + 60100;
 Libint->vrr_classes[9][15] = int_stack + 66700;
 Libint->vrr_classes[9][16] = int_stack + 74180;
 Libint->vrr_classes[9][17] = int_stack + 82595;
 Libint->vrr_classes[10][10] = int_stack + 92000;
 Libint->vrr_classes[10][11] = int_stack + 96356;
 Libint->vrr_classes[10][12] = int_stack + 101504;
 Libint->vrr_classes[10][13] = int_stack + 107510;
 Libint->vrr_classes[10][14] = int_stack + 114440;
 Libint->vrr_classes[10][15] = int_stack + 122360;
 Libint->vrr_classes[10][16] = int_stack + 131336;
 Libint->vrr_classes[10][17] = int_stack + 141434;
 Libint->vrr_classes[11][10] = int_stack + 152720;
 Libint->vrr_classes[11][11] = int_stack + 157868;
 Libint->vrr_classes[11][12] = int_stack + 163952;
 Libint->vrr_classes[11][13] = int_stack + 171050;
 Libint->vrr_classes[11][14] = int_stack + 179240;
 Libint->vrr_classes[11][15] = int_stack + 188600;
 Libint->vrr_classes[11][16] = int_stack + 199208;
 Libint->vrr_classes[11][17] = int_stack + 211142;
 memset(int_stack,0,224480*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 224480;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfnk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+224480,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+233390,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+243920,int_stack+233390,int_stack+224480,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+261740,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+274025,int_stack+261740,int_stack+233390,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+295085,int_stack+274025,int_stack+243920,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+224480,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+324785,int_stack+224480,int_stack+261740,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+238655,int_stack+324785,int_stack+274025,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+349355,int_stack+238655,int_stack+295085,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+273755,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+289955,int_stack+273755,int_stack+224480,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+393905,int_stack+289955,int_stack+324785,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+434855,int_stack+393905,int_stack+238655,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+487505,int_stack+434855,int_stack+349355,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+224480,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+318305,int_stack+224480,int_stack+273755,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+549875,int_stack+318305,int_stack+289955,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+242840,int_stack+549875,int_stack+393905,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+350705,int_stack+242840,int_stack+434855,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+597125,int_stack+350705,int_stack+487505,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+424415,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+445070,int_stack+424415,int_stack+224480,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+481790,int_stack+445070,int_stack+318305,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+680285,int_stack+481790,int_stack+549875,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+424415,int_stack+680285,int_stack+242840,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+224480,int_stack+424415,int_stack+350705,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+322760,int_stack+224480,int_stack+597125,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+224480,int_stack+45030,int_stack+41400,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+235370,int_stack+49320,int_stack+45030,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+248240,int_stack+235370,int_stack+224480,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+270020,int_stack+54325,int_stack+49320,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+285035,int_stack+270020,int_stack+235370,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+429680,int_stack+285035,int_stack+248240,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+224480,int_stack+60100,int_stack+54325,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+465980,int_stack+224480,int_stack+270020,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+241805,int_stack+465980,int_stack+285035,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+496010,int_stack+241805,int_stack+429680,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+429680,int_stack+66700,int_stack+60100,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+284705,int_stack+429680,int_stack+224480,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+550460,int_stack+284705,int_stack+465980,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+600510,int_stack+550460,int_stack+241805,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+664860,int_stack+600510,int_stack+496010,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+224480,int_stack+74180,int_stack+66700,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+449480,int_stack+224480,int_stack+429680,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+489080,int_stack+449480,int_stack+284705,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+246920,int_stack+489080,int_stack+550460,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+741090,int_stack+246920,int_stack+600510,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+546830,int_stack+741090,int_stack+664860,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+648470,int_stack+82595,int_stack+74180,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+673715,int_stack+648470,int_stack+224480,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+673715,int_stack+449480,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+648470,int_stack+0,int_stack+489080,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+429680,int_stack+648470,int_stack+246920,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+831180,int_stack+429680,int_stack+741090,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+648470,int_stack+831180,int_stack+546830,55);
 /*--- compute (lp|nk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+779150,int_stack+648470,int_stack+322760,2376);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+96356,int_stack+92000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+101504,int_stack+96356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+107510,int_stack+101504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+224480,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+114440,int_stack+107510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+268040,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+268040,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+304076,int_stack+20790,int_stack+224480,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+224480,int_stack+122360,int_stack+114440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+72270,int_stack+224480,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+369416,int_stack+72270,int_stack+268040,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+429476,int_stack+369416,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+506696,int_stack+429476,int_stack+304076,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+131336,int_stack+122360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+248240,int_stack+0,int_stack+224480,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+295760,int_stack+248240,int_stack+72270,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+26928,int_stack+295760,int_stack+369416,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1099910,int_stack+26928,int_stack+429476,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+365060,int_stack+1099910,int_stack+506696,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+487028,int_stack+141434,int_stack+131336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+517322,int_stack+487028,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1208018,int_stack+517322,int_stack+248240,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+487028,int_stack+1208018,int_stack+295760,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+224480,int_stack+487028,int_stack+26928,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+487028,int_stack+224480,int_stack+1099910,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1099910,int_stack+487028,int_stack+365060,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+224480,int_stack+1099910,int_stack+648470,2376);
 /*--- compute (ld|nk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1256726,int_stack+224480,int_stack+779150,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+616520,int_stack+157868,int_stack+152720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+631964,int_stack+163952,int_stack+157868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+650216,int_stack+631964,int_stack+616520,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+681104,int_stack+171050,int_stack+163952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+702398,int_stack+681104,int_stack+631964,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+738902,int_stack+702398,int_stack+650216,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+616520,int_stack+179240,int_stack+171050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+790382,int_stack+616520,int_stack+681104,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+641090,int_stack+790382,int_stack+702398,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+832970,int_stack+641090,int_stack+738902,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+701930,int_stack+188600,int_stack+179240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+730010,int_stack+701930,int_stack+616520,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+910190,int_stack+730010,int_stack+790382,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+981170,int_stack+910190,int_stack+641090,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+981170,int_stack+832970,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+616520,int_stack+199208,int_stack+188600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+779150,int_stack+616520,int_stack+701930,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+108108,int_stack+779150,int_stack+730010,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+648344,int_stack+108108,int_stack+910190,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+835310,int_stack+648344,int_stack+981170,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1898246,int_stack+835310,int_stack+0,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+211142,int_stack+199208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+35802,int_stack+0,int_stack+616520,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+963074,int_stack+35802,int_stack+779150,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2042390,int_stack+963074,int_stack+108108,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+2042390,int_stack+648344,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+616520,int_stack+0,int_stack+835310,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+616520,int_stack+1898246,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+616520,int_stack+0,int_stack+1099910,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1898246,int_stack+616520,int_stack+224480,2376);
 /*--- compute (lf|nk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1898246,int_stack+1256726,2376);
 return int_stack+0;}
