/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhmh(Libint_t*, prim_data*);

  /* Computes quartets of (lh|mh) integrals */

REALTYPE *hrr_order_lhmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[9][9] = int_stack + 23175;
 Libint->vrr_classes[9][10] = int_stack + 26200;
 Libint->vrr_classes[9][11] = int_stack + 29830;
 Libint->vrr_classes[9][12] = int_stack + 34120;
 Libint->vrr_classes[9][13] = int_stack + 39125;
 Libint->vrr_classes[9][14] = int_stack + 44900;
 Libint->vrr_classes[10][9] = int_stack + 51500;
 Libint->vrr_classes[10][10] = int_stack + 55130;
 Libint->vrr_classes[10][11] = int_stack + 59486;
 Libint->vrr_classes[10][12] = int_stack + 64634;
 Libint->vrr_classes[10][13] = int_stack + 70640;
 Libint->vrr_classes[10][14] = int_stack + 77570;
 Libint->vrr_classes[11][9] = int_stack + 85490;
 Libint->vrr_classes[11][10] = int_stack + 89780;
 Libint->vrr_classes[11][11] = int_stack + 94928;
 Libint->vrr_classes[11][12] = int_stack + 101012;
 Libint->vrr_classes[11][13] = int_stack + 108110;
 Libint->vrr_classes[11][14] = int_stack + 116300;
 Libint->vrr_classes[12][9] = int_stack + 125660;
 Libint->vrr_classes[12][10] = int_stack + 130665;
 Libint->vrr_classes[12][11] = int_stack + 136671;
 Libint->vrr_classes[12][12] = int_stack + 143769;
 Libint->vrr_classes[12][13] = int_stack + 152050;
 Libint->vrr_classes[12][14] = int_stack + 161605;
 Libint->vrr_classes[13][9] = int_stack + 172525;
 Libint->vrr_classes[13][10] = int_stack + 178300;
 Libint->vrr_classes[13][11] = int_stack + 185230;
 Libint->vrr_classes[13][12] = int_stack + 193420;
 Libint->vrr_classes[13][13] = int_stack + 202975;
 Libint->vrr_classes[13][14] = int_stack + 214000;
 memset(int_stack,0,226600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 226600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhmh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+226600,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+234025,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+242935,int_stack+234025,int_stack+226600,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+257785,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+268315,int_stack+257785,int_stack+234025,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+286135,int_stack+268315,int_stack+242935,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+226600,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+310885,int_stack+226600,int_stack+257785,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+331945,int_stack+310885,int_stack+268315,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+238885,int_stack+331945,int_stack+286135,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+276010,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+361645,int_stack+276010,int_stack+226600,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+386215,int_stack+361645,int_stack+310885,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+276010,int_stack+386215,int_stack+331945,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+320560,int_stack+276010,int_stack+238885,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+226600,int_stack+26200,int_stack+23175,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+235675,int_stack+29830,int_stack+26200,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+246565,int_stack+235675,int_stack+226600,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+264715,int_stack+34120,int_stack+29830,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+277585,int_stack+264715,int_stack+235675,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+372535,int_stack+277585,int_stack+246565,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+226600,int_stack+39125,int_stack+34120,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+226600,int_stack+264715,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+402785,int_stack+0,int_stack+277585,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+241615,int_stack+402785,int_stack+372535,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+372535,int_stack+44900,int_stack+39125,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+286990,int_stack+372535,int_stack+226600,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+439085,int_stack+286990,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+481985,int_stack+439085,int_stack+402785,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+372535,int_stack+481985,int_stack+241615,55);
 /*--- compute (lp|mh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+436060,int_stack+372535,int_stack+320560,1155);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+55130,int_stack+51500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+59486,int_stack+55130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+226600,int_stack+64634,int_stack+59486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+242044,int_stack+226600,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+268180,int_stack+242044,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+70640,int_stack+64634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+18018,int_stack+0,int_stack+226600,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+304480,int_stack+18018,int_stack+242044,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+591985,int_stack+304480,int_stack+268180,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+226600,int_stack+77570,int_stack+70640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+247390,int_stack+226600,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+646435,int_stack+247390,int_stack+18018,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+646435,int_stack+304480,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+226600,int_stack+0,int_stack+591985,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+591985,int_stack+226600,int_stack+372535,1155);
 /*--- compute (ld|mh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+782560,int_stack+591985,int_stack+436060,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+89780,int_stack+85490,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+94928,int_stack+89780,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+101012,int_stack+94928,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+302830,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+333718,int_stack+302830,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+108110,int_stack+101012,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+376618,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21294,int_stack+376618,int_stack+302830,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+413122,int_stack+21294,int_stack+333718,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+302830,int_stack+116300,int_stack+108110,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+327400,int_stack+302830,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+477472,int_stack+327400,int_stack+376618,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+302830,int_stack+477472,int_stack+21294,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+477472,int_stack+302830,int_stack+413122,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+1094410,int_stack+477472,int_stack+226600,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1323100,int_stack+1094410,int_stack+591985,1155);
 /*--- compute (lf|mh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1704250,int_stack+1323100,int_stack+782560,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+226600,int_stack+130665,int_stack+125660,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+241615,int_stack+136671,int_stack+130665,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+259633,int_stack+241615,int_stack+226600,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+289663,int_stack+143769,int_stack+136671,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+310957,int_stack+289663,int_stack+241615,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+346993,int_stack+310957,int_stack+259633,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+226600,int_stack+152050,int_stack+143769,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+397043,int_stack+226600,int_stack+289663,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+567562,int_stack+397043,int_stack+310957,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+251443,int_stack+567562,int_stack+346993,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+326518,int_stack+161605,int_stack+152050,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+627622,int_stack+326518,int_stack+226600,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+677308,int_stack+627622,int_stack+397043,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+326518,int_stack+677308,int_stack+567562,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+567562,int_stack+326518,int_stack+251443,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+672667,int_stack+567562,int_stack+477472,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2224000,int_stack+672667,int_stack+1094410,1155);
 /*--- compute (mf|mh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2681380,int_stack+2224000,int_stack+1323100,1155);
 /*--- compute (lg|mh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3316630,int_stack+2681380,int_stack+1704250,1155);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+942937,int_stack+178300,int_stack+172525,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+960262,int_stack+185230,int_stack+178300,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+981052,int_stack+960262,int_stack+942937,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1015702,int_stack+193420,int_stack+185230,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1040272,int_stack+1015702,int_stack+960262,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1081852,int_stack+1040272,int_stack+981052,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+942937,int_stack+202975,int_stack+193420,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1139602,int_stack+942937,int_stack+1015702,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1188742,int_stack+1139602,int_stack+1040272,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+971602,int_stack+1188742,int_stack+1081852,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1058227,int_stack+214000,int_stack+202975,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1258042,int_stack+1058227,int_stack+942937,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1315372,int_stack+1258042,int_stack+1139602,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1058227,int_stack+1315372,int_stack+1188742,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1162177,int_stack+1058227,int_stack+971602,105);
 /*--- compute (qp|mh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1283452,int_stack+1162177,int_stack+567562,1155);
 /*--- compute (od|mh) ---*/
 hrr1_build_od(Libint->AB,int_stack+1598767,int_stack+1283452,int_stack+672667,1155);
 /*--- compute (nf|mh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+1598767,int_stack+2224000,1155);
 /*--- compute (mg|mh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+762300,int_stack+0,int_stack+2681380,1155);
 /*--- compute (lh|mh) ---*/
 hrr1_build_lh(Libint->AB,int_stack+1715175,int_stack+762300,int_stack+3316630,1155);
 return int_stack+1715175;}
