/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lknn(Libint_t*, prim_data*);

  /* Computes quartets of (lk|nn) integrals */

REALTYPE *hrr_order_lknn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[8][19] = int_stack + 49950;
 Libint->vrr_classes[8][20] = int_stack + 59400;
 Libint->vrr_classes[9][10] = int_stack + 69795;
 Libint->vrr_classes[9][11] = int_stack + 73425;
 Libint->vrr_classes[9][12] = int_stack + 77715;
 Libint->vrr_classes[9][13] = int_stack + 82720;
 Libint->vrr_classes[9][14] = int_stack + 88495;
 Libint->vrr_classes[9][15] = int_stack + 95095;
 Libint->vrr_classes[9][16] = int_stack + 102575;
 Libint->vrr_classes[9][17] = int_stack + 110990;
 Libint->vrr_classes[9][18] = int_stack + 120395;
 Libint->vrr_classes[9][19] = int_stack + 130845;
 Libint->vrr_classes[9][20] = int_stack + 142395;
 Libint->vrr_classes[10][10] = int_stack + 155100;
 Libint->vrr_classes[10][11] = int_stack + 159456;
 Libint->vrr_classes[10][12] = int_stack + 164604;
 Libint->vrr_classes[10][13] = int_stack + 170610;
 Libint->vrr_classes[10][14] = int_stack + 177540;
 Libint->vrr_classes[10][15] = int_stack + 185460;
 Libint->vrr_classes[10][16] = int_stack + 194436;
 Libint->vrr_classes[10][17] = int_stack + 204534;
 Libint->vrr_classes[10][18] = int_stack + 215820;
 Libint->vrr_classes[10][19] = int_stack + 228360;
 Libint->vrr_classes[10][20] = int_stack + 242220;
 Libint->vrr_classes[11][10] = int_stack + 257466;
 Libint->vrr_classes[11][11] = int_stack + 262614;
 Libint->vrr_classes[11][12] = int_stack + 268698;
 Libint->vrr_classes[11][13] = int_stack + 275796;
 Libint->vrr_classes[11][14] = int_stack + 283986;
 Libint->vrr_classes[11][15] = int_stack + 293346;
 Libint->vrr_classes[11][16] = int_stack + 303954;
 Libint->vrr_classes[11][17] = int_stack + 315888;
 Libint->vrr_classes[11][18] = int_stack + 329226;
 Libint->vrr_classes[11][19] = int_stack + 344046;
 Libint->vrr_classes[11][20] = int_stack + 360426;
 Libint->vrr_classes[12][10] = int_stack + 378444;
 Libint->vrr_classes[12][11] = int_stack + 384450;
 Libint->vrr_classes[12][12] = int_stack + 391548;
 Libint->vrr_classes[12][13] = int_stack + 399829;
 Libint->vrr_classes[12][14] = int_stack + 409384;
 Libint->vrr_classes[12][15] = int_stack + 420304;
 Libint->vrr_classes[12][16] = int_stack + 432680;
 Libint->vrr_classes[12][17] = int_stack + 446603;
 Libint->vrr_classes[12][18] = int_stack + 462164;
 Libint->vrr_classes[12][19] = int_stack + 479454;
 Libint->vrr_classes[12][20] = int_stack + 498564;
 Libint->vrr_classes[13][10] = int_stack + 519585;
 Libint->vrr_classes[13][11] = int_stack + 526515;
 Libint->vrr_classes[13][12] = int_stack + 534705;
 Libint->vrr_classes[13][13] = int_stack + 544260;
 Libint->vrr_classes[13][14] = int_stack + 555285;
 Libint->vrr_classes[13][15] = int_stack + 567885;
 Libint->vrr_classes[13][16] = int_stack + 582165;
 Libint->vrr_classes[13][17] = int_stack + 598230;
 Libint->vrr_classes[13][18] = int_stack + 616185;
 Libint->vrr_classes[13][19] = int_stack + 636135;
 Libint->vrr_classes[13][20] = int_stack + 658185;
 Libint->vrr_classes[14][10] = int_stack + 682440;
 Libint->vrr_classes[14][11] = int_stack + 690360;
 Libint->vrr_classes[14][12] = int_stack + 699720;
 Libint->vrr_classes[14][13] = int_stack + 710640;
 Libint->vrr_classes[14][14] = int_stack + 723240;
 Libint->vrr_classes[14][15] = int_stack + 737640;
 Libint->vrr_classes[14][16] = int_stack + 753960;
 Libint->vrr_classes[14][17] = int_stack + 772320;
 Libint->vrr_classes[14][18] = int_stack + 792840;
 Libint->vrr_classes[14][19] = int_stack + 815640;
 Libint->vrr_classes[14][20] = int_stack + 840840;
 Libint->vrr_classes[15][10] = int_stack + 868560;
 Libint->vrr_classes[15][11] = int_stack + 877536;
 Libint->vrr_classes[15][12] = int_stack + 888144;
 Libint->vrr_classes[15][13] = int_stack + 900520;
 Libint->vrr_classes[15][14] = int_stack + 914800;
 Libint->vrr_classes[15][15] = int_stack + 931120;
 Libint->vrr_classes[15][16] = int_stack + 949616;
 Libint->vrr_classes[15][17] = int_stack + 970424;
 Libint->vrr_classes[15][18] = int_stack + 993680;
 Libint->vrr_classes[15][19] = int_stack + 1019520;
 Libint->vrr_classes[15][20] = int_stack + 1048080;
 memset(int_stack,0,1079496*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1079496;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lknn(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1079496,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1088406,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1098936,int_stack+1088406,int_stack+1079496,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1116756,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1129041,int_stack+1116756,int_stack+1088406,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1150101,int_stack+1129041,int_stack+1098936,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1079496,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1179801,int_stack+1079496,int_stack+1116756,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1093671,int_stack+1179801,int_stack+1129041,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1204371,int_stack+1093671,int_stack+1150101,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1128771,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1144971,int_stack+1128771,int_stack+1079496,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1248921,int_stack+1144971,int_stack+1179801,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1289871,int_stack+1248921,int_stack+1093671,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1342521,int_stack+1289871,int_stack+1204371,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1079496,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1173321,int_stack+1079496,int_stack+1128771,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1404891,int_stack+1173321,int_stack+1144971,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1097856,int_stack+1404891,int_stack+1248921,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1205721,int_stack+1097856,int_stack+1289871,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1452141,int_stack+1205721,int_stack+1342521,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1279431,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1300086,int_stack+1279431,int_stack+1079496,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1336806,int_stack+1300086,int_stack+1173321,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1535301,int_stack+1336806,int_stack+1404891,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1606176,int_stack+1535301,int_stack+1097856,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1079496,int_stack+1606176,int_stack+1205721,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1692171,int_stack+1079496,int_stack+1452141,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1177776,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1200861,int_stack+1177776,int_stack+1279431,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1390806,int_stack+1200861,int_stack+1300086,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1242171,int_stack+1390806,int_stack+1336806,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1799091,int_stack+1242171,int_stack+1535301,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1452006,int_stack+1799091,int_stack+1606176,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1898316,int_stack+1452006,int_stack+1079496,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2024676,int_stack+1898316,int_stack+1692171,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1079496,int_stack+49950,int_stack+41400,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1105146,int_stack+1079496,int_stack+1177776,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1566666,int_stack+1105146,int_stack+1200861,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1635516,int_stack+1566666,int_stack+1390806,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1323171,int_stack+1635516,int_stack+1242171,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1151316,int_stack+1323171,int_stack+1799091,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1727316,int_stack+1151316,int_stack+1452006,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2158326,int_stack+1727316,int_stack+1898316,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2316276,int_stack+2158326,int_stack+2024676,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1283616,int_stack+59400,int_stack+49950,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1436571,int_stack+1283616,int_stack+1079496,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1487871,int_stack+1436571,int_stack+1105146,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1874736,int_stack+1487871,int_stack+1566666,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1436571,int_stack+1874736,int_stack+1635516,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1874736,int_stack+1436571,int_stack+1323171,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1283616,int_stack+1874736,int_stack+1151316,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1874736,int_stack+1283616,int_stack+1727316,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1079496,int_stack+1874736,int_stack+2158326,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1272546,int_stack+1079496,int_stack+2316276,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1079496,int_stack+73425,int_stack+69795,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1090386,int_stack+77715,int_stack+73425,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1103256,int_stack+1090386,int_stack+1079496,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1125036,int_stack+82720,int_stack+77715,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1140051,int_stack+1125036,int_stack+1090386,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1165791,int_stack+1140051,int_stack+1103256,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1079496,int_stack+88495,int_stack+82720,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1202091,int_stack+1079496,int_stack+1125036,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1096821,int_stack+1202091,int_stack+1140051,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1468566,int_stack+1096821,int_stack+1165791,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1139721,int_stack+95095,int_stack+88495,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1159521,int_stack+1139721,int_stack+1079496,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1523016,int_stack+1159521,int_stack+1202091,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1194171,int_stack+1523016,int_stack+1096821,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1573066,int_stack+1194171,int_stack+1468566,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1468566,int_stack+102575,int_stack+95095,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1079496,int_stack+1468566,int_stack+1139721,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1649296,int_stack+1079496,int_stack+1159521,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1119096,int_stack+1649296,int_stack+1523016,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1707046,int_stack+1119096,int_stack+1194171,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1797136,int_stack+1707046,int_stack+1573066,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1194171,int_stack+110990,int_stack+102575,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1219416,int_stack+1194171,int_stack+1468566,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1468566,int_stack+1219416,int_stack+1079496,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1534566,int_stack+1468566,int_stack+1649296,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1898776,int_stack+1534566,int_stack+1119096,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2003881,int_stack+1898776,int_stack+1707046,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1621191,int_stack+2003881,int_stack+1797136,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1079496,int_stack+120395,int_stack+110990,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1107711,int_stack+1079496,int_stack+1194171,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1751871,int_stack+1107711,int_stack+1219416,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1158201,int_stack+1751871,int_stack+1468566,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2124001,int_stack+1158201,int_stack+1534566,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1468566,int_stack+2124001,int_stack+1898776,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1826671,int_stack+1468566,int_stack+2003881,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2245276,int_stack+1826671,int_stack+1621191,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1608706,int_stack+130845,int_stack+120395,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1640056,int_stack+1608706,int_stack+1079496,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1981111,int_stack+1640056,int_stack+1107711,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1981111,int_stack+1751871,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2408626,int_stack+0,int_stack+1158201,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1079496,int_stack+2408626,int_stack+2124001,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2547226,int_stack+1079496,int_stack+1468566,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2727406,int_stack+2547226,int_stack+1826671,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1696486,int_stack+2727406,int_stack+2245276,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1468566,int_stack+142395,int_stack+130845,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1503216,int_stack+1468566,int_stack+1608706,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2065261,int_stack+1503216,int_stack+1640056,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1468566,int_stack+2065261,int_stack+1981111,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1896136,int_stack+1468566,int_stack+0,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1468566,int_stack+1896136,int_stack+2408626,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1896136,int_stack+1468566,int_stack+1079496,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1468566,int_stack+1896136,int_stack+2547226,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1896136,int_stack+1468566,int_stack+2727406,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2132086,int_stack+1896136,int_stack+1696486,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1468566,int_stack+2132086,int_stack+1272546,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2056626,int_stack+159456,int_stack+155100,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2069694,int_stack+164604,int_stack+159456,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2085138,int_stack+2069694,int_stack+2056626,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2111274,int_stack+170610,int_stack+164604,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2371666,int_stack+2111274,int_stack+2069694,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2402554,int_stack+2371666,int_stack+2085138,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2056626,int_stack+177540,int_stack+170610,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2446114,int_stack+2056626,int_stack+2111274,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2077416,int_stack+2446114,int_stack+2371666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2482150,int_stack+2077416,int_stack+2402554,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2371666,int_stack+185460,int_stack+177540,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2395426,int_stack+2371666,int_stack+2056626,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2547490,int_stack+2395426,int_stack+2446114,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2607550,int_stack+2547490,int_stack+2077416,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2684770,int_stack+2607550,int_stack+2482150,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2056626,int_stack+194436,int_stack+185460,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2083554,int_stack+2056626,int_stack+2371666,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2437006,int_stack+2083554,int_stack+2395426,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2776246,int_stack+2437006,int_stack+2547490,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1079496,int_stack+2776246,int_stack+2607550,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2506306,int_stack+1079496,int_stack+2684770,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2371666,int_stack+204534,int_stack+194436,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2628274,int_stack+2371666,int_stack+2056626,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2682130,int_stack+2628274,int_stack+2083554,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1187604,int_stack+2682130,int_stack+2437006,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1291554,int_stack+1187604,int_stack+2776246,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2761330,int_stack+1291554,int_stack+1079496,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2761330,int_stack+2506306,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1079496,int_stack+215820,int_stack+204534,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1113354,int_stack+1079496,int_stack+2371666,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2371666,int_stack+1113354,int_stack+2628274,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2461426,int_stack+2371666,int_stack+2682130,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2580226,int_stack+2461426,int_stack+1187604,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2905474,int_stack+2580226,int_stack+1291554,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1173942,int_stack+2905474,int_stack+2761330,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3073642,int_stack+1173942,int_stack+0,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+228360,int_stack+215820,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+37620,int_stack+0,int_stack+1079496,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+105336,int_stack+37620,int_stack+1113354,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2725756,int_stack+105336,int_stack+2371666,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3269662,int_stack+2725756,int_stack+2461426,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2371666,int_stack+3269662,int_stack+2580226,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3435982,int_stack+2371666,int_stack+2905474,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3652198,int_stack+3435982,int_stack+1173942,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1079496,int_stack+3652198,int_stack+3073642,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2565706,int_stack+242220,int_stack+228360,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2607286,int_stack+2565706,int_stack+0,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1319076,int_stack+2607286,int_stack+37620,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2565706,int_stack+1319076,int_stack+105336,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+2565706,int_stack+2725756,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2565706,int_stack+0,int_stack+3269662,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+2565706,int_stack+2371666,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2371666,int_stack+0,int_stack+3435982,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2641936,int_stack+2371666,int_stack+3652198,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2925076,int_stack+2641936,int_stack+1079496,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+3212572,int_stack+2925076,int_stack+2132086,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+3931312,int_stack+3212572,int_stack+1468566,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1079496,int_stack+262614,int_stack+257466,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1094940,int_stack+268698,int_stack+262614,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1113192,int_stack+1094940,int_stack+1079496,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1144080,int_stack+275796,int_stack+268698,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1165374,int_stack+1144080,int_stack+1094940,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1201878,int_stack+1165374,int_stack+1113192,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1079496,int_stack+283986,int_stack+275796,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1253358,int_stack+1079496,int_stack+1144080,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1104066,int_stack+1253358,int_stack+1165374,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1295946,int_stack+1104066,int_stack+1201878,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1164906,int_stack+293346,int_stack+283986,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1192986,int_stack+1164906,int_stack+1079496,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1373166,int_stack+1192986,int_stack+1253358,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1444146,int_stack+1373166,int_stack+1104066,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1535406,int_stack+1444146,int_stack+1295946,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1079496,int_stack+303954,int_stack+293346,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1242126,int_stack+1079496,int_stack+1164906,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1643514,int_stack+1242126,int_stack+1192986,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1111320,int_stack+1643514,int_stack+1373166,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1298286,int_stack+1111320,int_stack+1444146,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1725414,int_stack+1298286,int_stack+1535406,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1426050,int_stack+315888,int_stack+303954,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1461852,int_stack+1426050,int_stack+1079496,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1525500,int_stack+1461852,int_stack+1242126,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1869558,int_stack+1525500,int_stack+1643514,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1992408,int_stack+1869558,int_stack+1111320,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1079496,int_stack+1992408,int_stack+1298286,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2141466,int_stack+1079496,int_stack+1725414,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1249848,int_stack+329226,int_stack+315888,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1289862,int_stack+1249848,int_stack+1426050,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1619100,int_stack+1289862,int_stack+1461852,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1361466,int_stack+1619100,int_stack+1525500,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2326794,int_stack+1361466,int_stack+1869558,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1725180,int_stack+2326794,int_stack+1992408,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2498784,int_stack+1725180,int_stack+1079496,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2498784,int_stack+2141466,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1079496,int_stack+344046,int_stack+329226,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1123956,int_stack+1079496,int_stack+1249848,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1923924,int_stack+1123956,int_stack+1289862,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2043264,int_stack+1923924,int_stack+1619100,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1501866,int_stack+2043264,int_stack+1361466,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1203984,int_stack+1501866,int_stack+2326794,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2202384,int_stack+1203984,int_stack+1725180,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+5107432,int_stack+2202384,int_stack+2498784,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2457912,int_stack+5107432,int_stack+0,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+360426,int_stack+344046,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+49140,int_stack+0,int_stack+1079496,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+138060,int_stack+49140,int_stack+1123956,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1698426,int_stack+138060,int_stack+1923924,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1698426,int_stack+2043264,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1698426,int_stack+0,int_stack+1501866,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1698426,int_stack+1203984,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1079496,int_stack+0,int_stack+2202384,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+1079496,int_stack+5107432,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1079496,int_stack+0,int_stack+2457912,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+1419264,int_stack+1079496,int_stack+2925076,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+5107432,int_stack+1419264,int_stack+3212572,4356);
 /*--- compute (lf|nn) ---*/
 hrr1_build_lf(Libint->AB,int_stack+6544912,int_stack+5107432,int_stack+3931312,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+384450,int_stack+378444,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+391548,int_stack+384450,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+399829,int_stack+391548,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+409384,int_stack+399829,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+202839,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+202839,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+252525,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+420304,int_stack+409384,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2281752,int_stack+132405,int_stack+202839,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2364562,int_stack+2281752,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2471032,int_stack+2364562,int_stack+252525,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+432680,int_stack+420304,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+189735,int_stack+0,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+255255,int_stack+189735,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+37128,int_stack+255255,int_stack+2281752,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2597158,int_stack+37128,int_stack+2364562,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2281752,int_stack+2597158,int_stack+2471032,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2449920,int_stack+446603,int_stack+432680,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2491689,int_stack+2449920,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2746216,int_stack+2491689,int_stack+189735,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2855416,int_stack+2746216,int_stack+255255,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+161343,int_stack+2855416,int_stack+37128,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2998741,int_stack+161343,int_stack+2597158,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3197485,int_stack+2998741,int_stack+2281752,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2281752,int_stack+462164,int_stack+446603,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2328435,int_stack+2281752,int_stack+2449920,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+2328435,int_stack+2491689,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2411973,int_stack+0,int_stack+2746216,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2575773,int_stack+2411973,int_stack+2855416,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3413701,int_stack+2575773,int_stack+161343,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+123760,int_stack+3413701,int_stack+2998741,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2776428,int_stack+123760,int_stack+3197485,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3046698,int_stack+479454,int_stack+462164,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3098568,int_stack+3046698,int_stack+2281752,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3191934,int_stack+3098568,int_stack+2328435,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3645569,int_stack+3191934,int_stack+0,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3831209,int_stack+3645569,int_stack+2411973,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2281752,int_stack+3831209,int_stack+2575773,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4060529,int_stack+2281752,int_stack+3413701,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4358645,int_stack+4060529,int_stack+123760,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+4358645,int_stack+2776428,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+330330,int_stack+498564,int_stack+479454,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+387660,int_stack+330330,int_stack+3046698,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2549292,int_stack+387660,int_stack+3098568,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2704902,int_stack+2549292,int_stack+3191934,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2913747,int_stack+2704902,int_stack+3645569,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2549292,int_stack+2913747,int_stack+3831209,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2855052,int_stack+2549292,int_stack+2281752,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2281752,int_stack+2855052,int_stack+4060529,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2654397,int_stack+2281752,int_stack+4358645,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3044787,int_stack+2654397,int_stack+0,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+3441183,int_stack+3044787,int_stack+1079496,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+8505112,int_stack+3441183,int_stack+1419264,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+10230088,int_stack+8505112,int_stack+5107432,4356);
 /*--- compute (lg|nn) ---*/
 hrr1_build_lg(Libint->AB,int_stack+12625888,int_stack+10230088,int_stack+6544912,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1079496,int_stack+526515,int_stack+519585,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1100286,int_stack+534705,int_stack+526515,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1124856,int_stack+1100286,int_stack+1079496,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1166436,int_stack+544260,int_stack+534705,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1195101,int_stack+1166436,int_stack+1100286,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1244241,int_stack+1195101,int_stack+1124856,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1079496,int_stack+555285,int_stack+544260,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1313541,int_stack+1079496,int_stack+1166436,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1112571,int_stack+1313541,int_stack+1195101,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1370871,int_stack+1112571,int_stack+1244241,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1194471,int_stack+567885,int_stack+555285,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1232271,int_stack+1194471,int_stack+1079496,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1474821,int_stack+1232271,int_stack+1313541,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1570371,int_stack+1474821,int_stack+1112571,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1693221,int_stack+1570371,int_stack+1370871,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1079496,int_stack+582165,int_stack+567885,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1298421,int_stack+1079496,int_stack+1194471,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1838751,int_stack+1298421,int_stack+1232271,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1122336,int_stack+1838751,int_stack+1474821,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1374021,int_stack+1122336,int_stack+1570371,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1949001,int_stack+1374021,int_stack+1693221,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1546011,int_stack+598230,int_stack+582165,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1594206,int_stack+1546011,int_stack+1079496,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1679886,int_stack+1594206,int_stack+1298421,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2143041,int_stack+1679886,int_stack+1838751,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2308416,int_stack+2143041,int_stack+1122336,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1079496,int_stack+2308416,int_stack+1374021,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2509071,int_stack+1079496,int_stack+1949001,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1308816,int_stack+616185,int_stack+598230,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1362681,int_stack+1308816,int_stack+1546011,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1805886,int_stack+1362681,int_stack+1594206,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1459071,int_stack+1805886,int_stack+1679886,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2758551,int_stack+1459071,int_stack+2143041,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1948686,int_stack+2758551,int_stack+2308416,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1948686,int_stack+1079496,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+294840,int_stack+0,int_stack+2509071,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1079496,int_stack+636135,int_stack+616185,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1139346,int_stack+1079496,int_stack+1308816,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2216226,int_stack+1139346,int_stack+1362681,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2376876,int_stack+2216226,int_stack+1805886,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1648071,int_stack+2376876,int_stack+1459071,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1247076,int_stack+1648071,int_stack+2758551,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2591076,int_stack+1247076,int_stack+1948686,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4460487,int_stack+2591076,int_stack+0,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4829037,int_stack+4460487,int_stack+294840,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+658185,int_stack+636135,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+66150,int_stack+0,int_stack+1079496,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+185850,int_stack+66150,int_stack+1139346,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+365400,int_stack+185850,int_stack+2216226,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+365400,int_stack+2376876,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+299880,int_stack+0,int_stack+1648071,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1555776,int_stack+299880,int_stack+1247076,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+1555776,int_stack+2591076,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1079496,int_stack+0,int_stack+4460487,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+1079496,int_stack+4829037,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1079496,int_stack+0,int_stack+3044787,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+4460487,int_stack+1079496,int_stack+3441183,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+15566188,int_stack+4460487,int_stack+8505112,4356);
 /*--- compute (mg|nn) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6499095,int_stack+15566188,int_stack+10230088,4356);
 /*--- compute (lh|nn) ---*/
 hrr1_build_lh(Libint->AB,int_stack+18441148,int_stack+6499095,int_stack+12625888,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2268684,int_stack+690360,int_stack+682440,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2292444,int_stack+699720,int_stack+690360,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2320524,int_stack+2292444,int_stack+2268684,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2368044,int_stack+710640,int_stack+699720,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2400804,int_stack+2368044,int_stack+2292444,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2456964,int_stack+2400804,int_stack+2320524,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2268684,int_stack+723240,int_stack+710640,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2536164,int_stack+2268684,int_stack+2368044,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2306484,int_stack+2536164,int_stack+2400804,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2601684,int_stack+2306484,int_stack+2456964,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2400084,int_stack+737640,int_stack+723240,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2443284,int_stack+2400084,int_stack+2268684,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2720484,int_stack+2443284,int_stack+2536164,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2829684,int_stack+2720484,int_stack+2306484,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2970084,int_stack+2829684,int_stack+2601684,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2268684,int_stack+753960,int_stack+737640,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2518884,int_stack+2268684,int_stack+2400084,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3136404,int_stack+2518884,int_stack+2443284,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2317644,int_stack+3136404,int_stack+2720484,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2605284,int_stack+2317644,int_stack+2829684,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3262404,int_stack+2605284,int_stack+2970084,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2801844,int_stack+772320,int_stack+753960,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2856924,int_stack+2801844,int_stack+2268684,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2954844,int_stack+2856924,int_stack+2518884,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3484164,int_stack+2954844,int_stack+3136404,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3673164,int_stack+3484164,int_stack+2317644,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2268684,int_stack+3673164,int_stack+2605284,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3902484,int_stack+2268684,int_stack+3262404,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2530764,int_stack+792840,int_stack+772320,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2592324,int_stack+2530764,int_stack+2801844,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3098844,int_stack+2592324,int_stack+2856924,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2702484,int_stack+3098844,int_stack+2954844,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4187604,int_stack+2702484,int_stack+3484164,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3262044,int_stack+4187604,int_stack+3673164,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+10092795,int_stack+3262044,int_stack+2268684,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10429755,int_stack+10092795,int_stack+3902484,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2268684,int_stack+815640,int_stack+792840,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2337084,int_stack+2268684,int_stack+2530764,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3567804,int_stack+2337084,int_stack+2592324,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3751404,int_stack+3567804,int_stack+3098844,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2918484,int_stack+3751404,int_stack+2702484,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2460204,int_stack+2918484,int_stack+4187604,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3996204,int_stack+2460204,int_stack+3262044,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+10786155,int_stack+3996204,int_stack+10092795,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+11207355,int_stack+10786155,int_stack+10429755,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+10092795,int_stack+840840,int_stack+815640,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+10168395,int_stack+10092795,int_stack+2268684,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+10305195,int_stack+10168395,int_stack+2337084,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+10510395,int_stack+10305195,int_stack+3567804,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+10092795,int_stack+10510395,int_stack+3751404,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3220884,int_stack+10092795,int_stack+2918484,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+10092795,int_stack+3220884,int_stack+2460204,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2268684,int_stack+10092795,int_stack+3996204,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+10092795,int_stack+2268684,int_stack+10786155,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2268684,int_stack+10092795,int_stack+11207355,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+10092795,int_stack+2268684,int_stack+0,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+11464935,int_stack+10092795,int_stack+1079496,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+22557568,int_stack+11464935,int_stack+4460487,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+25955248,int_stack+22557568,int_stack+15566188,4356);
 /*--- compute (mh|nn) ---*/
 hrr1_build_mh(Libint->AB,int_stack+30267688,int_stack+25955248,int_stack+6499095,4356);
 /*--- compute (li|nn) ---*/
 hrr1_build_li(Libint->AB,int_stack+2791404,int_stack+30267688,int_stack+18441148,4356);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1079496,int_stack+877536,int_stack+868560,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1106424,int_stack+888144,int_stack+877536,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1138248,int_stack+1106424,int_stack+1079496,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1192104,int_stack+900520,int_stack+888144,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1229232,int_stack+1192104,int_stack+1106424,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1292880,int_stack+1229232,int_stack+1138248,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1079496,int_stack+914800,int_stack+900520,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1382640,int_stack+1079496,int_stack+1192104,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1122336,int_stack+1382640,int_stack+1229232,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1456896,int_stack+1122336,int_stack+1292880,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1228416,int_stack+931120,int_stack+914800,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1277376,int_stack+1228416,int_stack+1079496,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1591536,int_stack+1277376,int_stack+1382640,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1715296,int_stack+1591536,int_stack+1122336,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1874416,int_stack+1715296,int_stack+1456896,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1079496,int_stack+949616,int_stack+931120,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1363056,int_stack+1079496,int_stack+1228416,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2062912,int_stack+1363056,int_stack+1277376,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1134984,int_stack+2062912,int_stack+1591536,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1460976,int_stack+1134984,int_stack+1715296,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1460976,int_stack+1874416,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1683744,int_stack+970424,int_stack+949616,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1746168,int_stack+1683744,int_stack+1079496,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1857144,int_stack+1746168,int_stack+1363056,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+251328,int_stack+1857144,int_stack+2062912,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+465528,int_stack+251328,int_stack+1134984,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1079496,int_stack+465528,int_stack+1460976,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+13843311,int_stack+1079496,int_stack+0,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+993680,int_stack+970424,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+69768,int_stack+0,int_stack+1683744,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1376520,int_stack+69768,int_stack+1746168,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1561480,int_stack+1376520,int_stack+1857144,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1806280,int_stack+1561480,int_stack+251328,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+14166447,int_stack+1806280,int_stack+465528,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+194616,int_stack+14166447,int_stack+1079496,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+576504,int_stack+194616,int_stack+13843311,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+13843311,int_stack+1019520,int_stack+993680,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+13920831,int_stack+13843311,int_stack+0,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1079496,int_stack+13920831,int_stack+69768,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+14512975,int_stack+1079496,int_stack+1376520,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+14790415,int_stack+14512975,int_stack+1561480,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1287576,int_stack+14790415,int_stack+1806280,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1687416,int_stack+1287576,int_stack+14166447,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+15133135,int_stack+1687416,int_stack+194616,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+15133135,int_stack+576504,136);
 /*--- compute (u0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+493680,int_stack+1048080,int_stack+1019520,136);
 /*--- compute (u0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+579360,int_stack+493680,int_stack+13843311,136);
 /*--- compute (u0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+734400,int_stack+579360,int_stack+13920831,136);
 /*--- compute (u0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+13843311,int_stack+734400,int_stack+1079496,136);
 /*--- compute (u0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+493680,int_stack+13843311,int_stack+14512975,136);
 /*--- compute (u0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+13843311,int_stack+493680,int_stack+14790415,136);
 /*--- compute (u0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+493680,int_stack+13843311,int_stack+1287576,136);
 /*--- compute (u0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+13843311,int_stack+493680,int_stack+1687416,136);
 /*--- compute (u0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+493680,int_stack+13843311,int_stack+15133135,136);
 /*--- compute (u0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+13843311,int_stack+493680,int_stack+0,136);
 /*--- compute (tp|nn) ---*/
 hrr1_build_tp(Libint->AB,int_stack+0,int_stack+13843311,int_stack+2268684,4356);
 /*--- compute (rd|nn) ---*/
 hrr1_build_rd(Libint->AB,int_stack+13843311,int_stack+0,int_stack+10092795,4356);
 /*--- compute (qf|nn) ---*/
 hrr1_build_qf(Libint->AB,int_stack+16587591,int_stack+13843311,int_stack+11464935,4356);
 /*--- compute (og|nn) ---*/
 hrr1_build_og(Libint->AB,int_stack+8279964,int_stack+16587591,int_stack+22557568,4356);
 /*--- compute (nh|nn) ---*/
 hrr1_build_nh(Libint->AB,int_stack+13376484,int_stack+8279964,int_stack+25955248,4356);
 /*--- compute (mi|nn) ---*/
 hrr1_build_mi(Libint->AB,int_stack+19413900,int_stack+13376484,int_stack+30267688,4356);
 /*--- compute (lk|nn) ---*/
 hrr1_build_lk(Libint->AB,int_stack+8279964,int_stack+19413900,int_stack+2791404,4356);
 return int_stack+8279964;}
