/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpkh(Libint_t*, prim_data*);

  /* Computes quartets of (lp|kh) integrals */

REALTYPE *hrr_order_lpkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][7] = int_stack + 0;
 Libint->vrr_classes[8][8] = int_stack + 1620;
 Libint->vrr_classes[8][9] = int_stack + 3645;
 Libint->vrr_classes[8][10] = int_stack + 6120;
 Libint->vrr_classes[8][11] = int_stack + 9090;
 Libint->vrr_classes[8][12] = int_stack + 12600;
 Libint->vrr_classes[9][7] = int_stack + 16695;
 Libint->vrr_classes[9][8] = int_stack + 18675;
 Libint->vrr_classes[9][9] = int_stack + 21150;
 Libint->vrr_classes[9][10] = int_stack + 24175;
 Libint->vrr_classes[9][11] = int_stack + 27805;
 Libint->vrr_classes[9][12] = int_stack + 32095;
 memset(int_stack,0,37100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 37100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpkh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+37100,int_stack+1620,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41960,int_stack+3645,int_stack+1620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+48035,int_stack+41960,int_stack+37100,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57755,int_stack+6120,int_stack+3645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65180,int_stack+57755,int_stack+41960,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+77330,int_stack+65180,int_stack+48035,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37100,int_stack+9090,int_stack+6120,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+93530,int_stack+37100,int_stack+57755,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+108380,int_stack+93530,int_stack+65180,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+46010,int_stack+108380,int_stack+77330,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+70310,int_stack+12600,int_stack+9090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+128630,int_stack+70310,int_stack+37100,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+146450,int_stack+128630,int_stack+93530,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+70310,int_stack+146450,int_stack+108380,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+100685,int_stack+70310,int_stack+46010,45);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+37100,int_stack+18675,int_stack+16695,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43040,int_stack+21150,int_stack+18675,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+50465,int_stack+43040,int_stack+37100,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62345,int_stack+24175,int_stack+21150,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+71420,int_stack+62345,int_stack+43040,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+134705,int_stack+71420,int_stack+50465,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37100,int_stack+27805,int_stack+24175,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+37100,int_stack+62345,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+154505,int_stack+0,int_stack+71420,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+47990,int_stack+154505,int_stack+134705,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+134705,int_stack+32095,int_stack+27805,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+77690,int_stack+134705,int_stack+37100,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+179255,int_stack+77690,int_stack+0,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+179255,int_stack+154505,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+134705,int_stack+0,int_stack+47990,55);
 /*--- compute (lp|kh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+176285,int_stack+134705,int_stack+100685,756);
 return int_stack+176285;}
