/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpmm(Libint_t*, prim_data*);

  /* Computes quartets of (lp|mm) integrals */

REALTYPE *hrr_order_lpmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[8][18] = int_stack + 43875;
 Libint->vrr_classes[9][9] = int_stack + 52425;
 Libint->vrr_classes[9][10] = int_stack + 55450;
 Libint->vrr_classes[9][11] = int_stack + 59080;
 Libint->vrr_classes[9][12] = int_stack + 63370;
 Libint->vrr_classes[9][13] = int_stack + 68375;
 Libint->vrr_classes[9][14] = int_stack + 74150;
 Libint->vrr_classes[9][15] = int_stack + 80750;
 Libint->vrr_classes[9][16] = int_stack + 88230;
 Libint->vrr_classes[9][17] = int_stack + 96645;
 Libint->vrr_classes[9][18] = int_stack + 106050;
 memset(int_stack,0,116500*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 116500;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpmm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+116500,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+123925,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+132835,int_stack+123925,int_stack+116500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+147685,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+158215,int_stack+147685,int_stack+123925,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+176035,int_stack+158215,int_stack+132835,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+116500,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+200785,int_stack+116500,int_stack+147685,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+221845,int_stack+200785,int_stack+158215,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+128785,int_stack+221845,int_stack+176035,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+165910,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+251545,int_stack+165910,int_stack+116500,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+276115,int_stack+251545,int_stack+200785,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+311215,int_stack+276115,int_stack+221845,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+180085,int_stack+311215,int_stack+128785,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+116500,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132700,int_stack+116500,int_stack+165910,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+355765,int_stack+132700,int_stack+251545,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+396715,int_stack+355765,int_stack+276115,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+232060,int_stack+396715,int_stack+311215,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+449365,int_stack+232060,int_stack+180085,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+161050,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+179410,int_stack+161050,int_stack+116500,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+294430,int_stack+179410,int_stack+132700,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+518665,int_stack+294430,int_stack+355765,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+580090,int_stack+518665,int_stack+396715,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+341680,int_stack+580090,int_stack+232060,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+653800,int_stack+341680,int_stack+449365,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+116500,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+211810,int_stack+116500,int_stack+161050,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+424840,int_stack+211810,int_stack+179410,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+137155,int_stack+424840,int_stack+294430,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+248530,int_stack+137155,int_stack+518665,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+478840,int_stack+248530,int_stack+580090,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+742900,int_stack+478840,int_stack+341680,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+849820,int_stack+742900,int_stack+653800,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+334525,int_stack+43875,int_stack+36180,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+357610,int_stack+334525,int_stack+116500,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+577120,int_stack+357610,int_stack+211810,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+334525,int_stack+577120,int_stack+424840,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+577120,int_stack+334525,int_stack+137155,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+334525,int_stack+577120,int_stack+248530,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+577120,int_stack+334525,int_stack+478840,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+116500,int_stack+577120,int_stack+742900,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+250150,int_stack+116500,int_stack+849820,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+116500,int_stack+55450,int_stack+52425,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125575,int_stack+59080,int_stack+55450,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+136465,int_stack+125575,int_stack+116500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+154615,int_stack+63370,int_stack+59080,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+167485,int_stack+154615,int_stack+125575,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+189265,int_stack+167485,int_stack+136465,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+116500,int_stack+68375,int_stack+63370,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+219515,int_stack+116500,int_stack+154615,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+386275,int_stack+219515,int_stack+167485,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+131515,int_stack+386275,int_stack+189265,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+176890,int_stack+74150,int_stack+68375,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+422575,int_stack+176890,int_stack+116500,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+452605,int_stack+422575,int_stack+219515,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+194215,int_stack+452605,int_stack+386275,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+495505,int_stack+194215,int_stack+131515,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+386275,int_stack+80750,int_stack+74150,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+116500,int_stack+386275,int_stack+176890,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+559030,int_stack+116500,int_stack+422575,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+609080,int_stack+559030,int_stack+452605,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+406075,int_stack+609080,int_stack+194215,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+151150,int_stack+406075,int_stack+495505,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+482305,int_stack+88230,int_stack+80750,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+504745,int_stack+482305,int_stack+386275,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+673430,int_stack+504745,int_stack+116500,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+731180,int_stack+673430,int_stack+559030,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+806255,int_stack+731180,int_stack+609080,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+544345,int_stack+806255,int_stack+406075,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+896345,int_stack+544345,int_stack+151150,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+116500,int_stack+96645,int_stack+88230,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+141745,int_stack+116500,int_stack+482305,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+386275,int_stack+141745,int_stack+504745,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+452275,int_stack+386275,int_stack+673430,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1005245,int_stack+452275,int_stack+731180,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+645985,int_stack+1005245,int_stack+806255,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1110350,int_stack+645985,int_stack+544345,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1241030,int_stack+1110350,int_stack+896345,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+186625,int_stack+106050,int_stack+96645,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+538900,int_stack+186625,int_stack+116500,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+766105,int_stack+538900,int_stack+141745,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+538900,int_stack+766105,int_stack+386275,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+766105,int_stack+538900,int_stack+452275,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+386275,int_stack+766105,int_stack+1005245,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+766105,int_stack+386275,int_stack+645985,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+386275,int_stack+766105,int_stack+1110350,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+549625,int_stack+386275,int_stack+1241030,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+716000,int_stack+549625,int_stack+250150,3025);
 return int_stack+716000;}
