/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_m0ii(Libint_t*, prim_data*);

  /* Computes quartets of (m0|ii) integrals */

REALTYPE *hrr_order_m0ii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][6] = int_stack + 0;
 Libint->vrr_classes[9][7] = int_stack + 1540;
 Libint->vrr_classes[9][8] = int_stack + 3520;
 Libint->vrr_classes[9][9] = int_stack + 5995;
 Libint->vrr_classes[9][10] = int_stack + 9020;
 Libint->vrr_classes[9][11] = int_stack + 12650;
 Libint->vrr_classes[9][12] = int_stack + 16940;
 memset(int_stack,0,21945*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21945;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_m0ii(Libint, Data);
   Data++;
 }
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+21945,int_stack+1540,int_stack+0,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+26565,int_stack+3520,int_stack+1540,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+32505,int_stack+26565,int_stack+21945,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41745,int_stack+5995,int_stack+3520,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+49170,int_stack+41745,int_stack+26565,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+61050,int_stack+49170,int_stack+32505,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21945,int_stack+9020,int_stack+5995,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+76450,int_stack+21945,int_stack+41745,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+91300,int_stack+76450,int_stack+49170,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+31020,int_stack+91300,int_stack+61050,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+54120,int_stack+12650,int_stack+9020,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+111100,int_stack+54120,int_stack+21945,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+129250,int_stack+111100,int_stack+76450,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+154000,int_stack+129250,int_stack+91300,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+65010,int_stack+154000,int_stack+31020,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21945,int_stack+16940,int_stack+12650,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+21945,int_stack+54120,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+21780,int_stack+0,int_stack+111100,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+183700,int_stack+21780,int_stack+129250,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+183700,int_stack+154000,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+97350,int_stack+0,int_stack+65010,55);
 return int_stack+97350;}
