/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdnh(Libint_t*, prim_data*);

  /* Computes quartets of (md|nh) integrals */

REALTYPE *hrr_order_mdnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[10][10] = int_stack + 32780;
 Libint->vrr_classes[10][11] = int_stack + 37136;
 Libint->vrr_classes[10][12] = int_stack + 42284;
 Libint->vrr_classes[10][13] = int_stack + 48290;
 Libint->vrr_classes[10][14] = int_stack + 55220;
 Libint->vrr_classes[10][15] = int_stack + 63140;
 Libint->vrr_classes[11][10] = int_stack + 72116;
 Libint->vrr_classes[11][11] = int_stack + 77264;
 Libint->vrr_classes[11][12] = int_stack + 83348;
 Libint->vrr_classes[11][13] = int_stack + 90446;
 Libint->vrr_classes[11][14] = int_stack + 98636;
 Libint->vrr_classes[11][15] = int_stack + 107996;
 memset(int_stack,0,118604*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 118604;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdnh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118604,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+129494,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+142364,int_stack+129494,int_stack+118604,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+164144,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+179159,int_stack+164144,int_stack+129494,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+204899,int_stack+179159,int_stack+142364,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+118604,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+241199,int_stack+118604,int_stack+164144,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+135929,int_stack+241199,int_stack+179159,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+271229,int_stack+135929,int_stack+204899,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+178829,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+198629,int_stack+178829,int_stack+118604,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+325679,int_stack+198629,int_stack+241199,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+178829,int_stack+325679,int_stack+135929,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+325679,int_stack+178829,int_stack+271229,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118604,int_stack+37136,int_stack+32780,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+131672,int_stack+42284,int_stack+37136,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+147116,int_stack+131672,int_stack+118604,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173252,int_stack+48290,int_stack+42284,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+191270,int_stack+173252,int_stack+131672,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+222158,int_stack+191270,int_stack+147116,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+118604,int_stack+55220,int_stack+48290,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+265718,int_stack+118604,int_stack+173252,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+139394,int_stack+265718,int_stack+191270,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+401909,int_stack+139394,int_stack+222158,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+190874,int_stack+63140,int_stack+55220,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+214634,int_stack+190874,int_stack+118604,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+214634,int_stack+265718,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+190874,int_stack+0,int_stack+139394,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+467249,int_stack+190874,int_stack+401909,66);
 /*--- compute (mp|nh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+558725,int_stack+467249,int_stack+325679,1386);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+77264,int_stack+72116,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+83348,int_stack+77264,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+118604,int_stack+90446,int_stack+83348,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+139898,int_stack+118604,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+176402,int_stack+139898,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+98636,int_stack+90446,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+24570,int_stack+0,int_stack+118604,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+227882,int_stack+24570,int_stack+139898,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+288722,int_stack+227882,int_stack+176402,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+118604,int_stack+107996,int_stack+98636,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+146684,int_stack+118604,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+67158,int_stack+146684,int_stack+24570,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+365942,int_stack+67158,int_stack+227882,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+365942,int_stack+288722,78);
 /*--- compute (np|nh) ---*/
 hrr1_build_np(Libint->AB,int_stack+108108,int_stack+0,int_stack+467249,1386);
 /*--- compute (md|nh) ---*/
 hrr1_build_md(Libint->AB,int_stack+787415,int_stack+108108,int_stack+558725,1386);
 return int_stack+787415;}
