/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mflk(Libint_t*, prim_data*);

  /* Computes quartets of (mf|lk) integrals */

REALTYPE *hrr_order_mflk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[10][8] = int_stack + 38280;
 Libint->vrr_classes[10][9] = int_stack + 41250;
 Libint->vrr_classes[10][10] = int_stack + 44880;
 Libint->vrr_classes[10][11] = int_stack + 49236;
 Libint->vrr_classes[10][12] = int_stack + 54384;
 Libint->vrr_classes[10][13] = int_stack + 60390;
 Libint->vrr_classes[10][14] = int_stack + 67320;
 Libint->vrr_classes[10][15] = int_stack + 75240;
 Libint->vrr_classes[11][8] = int_stack + 84216;
 Libint->vrr_classes[11][9] = int_stack + 87726;
 Libint->vrr_classes[11][10] = int_stack + 92016;
 Libint->vrr_classes[11][11] = int_stack + 97164;
 Libint->vrr_classes[11][12] = int_stack + 103248;
 Libint->vrr_classes[11][13] = int_stack + 110346;
 Libint->vrr_classes[11][14] = int_stack + 118536;
 Libint->vrr_classes[11][15] = int_stack + 127896;
 Libint->vrr_classes[12][8] = int_stack + 138504;
 Libint->vrr_classes[12][9] = int_stack + 142599;
 Libint->vrr_classes[12][10] = int_stack + 147604;
 Libint->vrr_classes[12][11] = int_stack + 153610;
 Libint->vrr_classes[12][12] = int_stack + 160708;
 Libint->vrr_classes[12][13] = int_stack + 168989;
 Libint->vrr_classes[12][14] = int_stack + 178544;
 Libint->vrr_classes[12][15] = int_stack + 189464;
 memset(int_stack,0,201840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 201840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mflk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+201840,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+209265,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+218340,int_stack+209265,int_stack+201840,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+233190,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+244080,int_stack+233190,int_stack+209265,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+262230,int_stack+244080,int_stack+218340,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+201840,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+286980,int_stack+201840,int_stack+233190,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+308760,int_stack+286980,int_stack+244080,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+214710,int_stack+308760,int_stack+262230,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+251835,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+339010,int_stack+251835,int_stack+201840,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+364750,int_stack+339010,int_stack+286980,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+401050,int_stack+364750,int_stack+308760,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+266850,int_stack+401050,int_stack+214710,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+201840,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+219165,int_stack+201840,int_stack+251835,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+446425,int_stack+219165,int_stack+339010,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+489325,int_stack+446425,int_stack+364750,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+318825,int_stack+489325,int_stack+401050,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+543775,int_stack+318825,int_stack+266850,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+249195,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+268995,int_stack+249195,int_stack+201840,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+382350,int_stack+268995,int_stack+219165,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+201840,int_stack+382350,int_stack+446425,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+382350,int_stack+201840,int_stack+489325,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+201840,int_stack+382350,int_stack+318825,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+286540,int_stack+201840,int_stack+543775,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+201840,int_stack+41250,int_stack+38280,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+210750,int_stack+44880,int_stack+41250,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+221640,int_stack+210750,int_stack+201840,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+239460,int_stack+49236,int_stack+44880,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+252528,int_stack+239460,int_stack+210750,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+375640,int_stack+252528,int_stack+221640,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+201840,int_stack+54384,int_stack+49236,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+405340,int_stack+201840,int_stack+239460,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+431476,int_stack+405340,int_stack+252528,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+217284,int_stack+431476,int_stack+375640,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+375640,int_stack+60390,int_stack+54384,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+467776,int_stack+375640,int_stack+201840,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+498664,int_stack+467776,int_stack+405340,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+542224,int_stack+498664,int_stack+431476,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+393658,int_stack+542224,int_stack+217284,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+201840,int_stack+67320,int_stack+60390,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+222630,int_stack+201840,int_stack+375640,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+222630,int_stack+467776,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+596674,int_stack+0,int_stack+498664,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+456028,int_stack+596674,int_stack+542224,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+662014,int_stack+456028,int_stack+393658,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+375640,int_stack+75240,int_stack+67320,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+399400,int_stack+375640,int_stack+201840,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+532258,int_stack+399400,int_stack+222630,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+201840,int_stack+532258,int_stack+0,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+745174,int_stack+201840,int_stack+596674,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+532258,int_stack+745174,int_stack+456028,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+375640,int_stack+532258,int_stack+662014,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+482560,int_stack+375640,int_stack+286540,1620);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+201840,int_stack+87726,int_stack+84216,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+212370,int_stack+92016,int_stack+87726,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+225240,int_stack+212370,int_stack+201840,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+246300,int_stack+97164,int_stack+92016,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+261744,int_stack+246300,int_stack+212370,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+287484,int_stack+261744,int_stack+225240,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+201840,int_stack+103248,int_stack+97164,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+322584,int_stack+201840,int_stack+246300,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+322584,int_stack+261744,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+220092,int_stack+0,int_stack+287484,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+272742,int_stack+110346,int_stack+103248,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+42900,int_stack+272742,int_stack+201840,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+749860,int_stack+42900,int_stack+322584,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+294036,int_stack+749860,int_stack+0,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+801340,int_stack+294036,int_stack+220092,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+118536,int_stack+110346,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+201840,int_stack+0,int_stack+272742,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+875050,int_stack+201840,int_stack+42900,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+24570,int_stack+875050,int_stack+749860,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+935890,int_stack+24570,int_stack+294036,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+244428,int_stack+935890,int_stack+801340,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+749860,int_stack+127896,int_stack+118536,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+777940,int_stack+749860,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1025980,int_stack+777940,int_stack+201840,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+749860,int_stack+1025980,int_stack+875050,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1025980,int_stack+749860,int_stack+24570,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+749860,int_stack+1025980,int_stack+935890,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+869980,int_stack+749860,int_stack+244428,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+996340,int_stack+869980,int_stack+375640,1620);
 /*--- compute (md|lk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1317100,int_stack+996340,int_stack+482560,1620);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+201840,int_stack+142599,int_stack+138504,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+214125,int_stack+147604,int_stack+142599,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+229140,int_stack+214125,int_stack+201840,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+253710,int_stack+153610,int_stack+147604,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+271728,int_stack+253710,int_stack+214125,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+301758,int_stack+271728,int_stack+229140,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+201840,int_stack+160708,int_stack+153610,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+342708,int_stack+201840,int_stack+253710,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+378744,int_stack+342708,int_stack+271728,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+223134,int_stack+378744,int_stack+301758,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+284559,int_stack+168989,int_stack+160708,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+428794,int_stack+284559,int_stack+201840,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+471382,int_stack+428794,int_stack+342708,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+531442,int_stack+471382,int_stack+378744,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+309402,int_stack+531442,int_stack+223134,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+201840,int_stack+178544,int_stack+168989,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+230505,int_stack+201840,int_stack+284559,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+606517,int_stack+230505,int_stack+428794,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+677497,int_stack+606517,int_stack+471382,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+395397,int_stack+677497,int_stack+531442,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+395397,int_stack+309402,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+280191,int_stack+189464,int_stack+178544,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+312951,int_stack+280191,int_stack+201840,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+500502,int_stack+312951,int_stack+230505,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+114660,int_stack+500502,int_stack+606517,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+500502,int_stack+114660,int_stack+677497,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+114660,int_stack+500502,int_stack+395397,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+254800,int_stack+114660,int_stack+0,91);
 /*--- compute (op|lk) ---*/
 hrr1_build_op(Libint->AB,int_stack+402220,int_stack+254800,int_stack+869980,1620);
 /*--- compute (nd|lk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1851700,int_stack+402220,int_stack+996340,1620);
 /*--- compute (mf|lk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1851700,int_stack+1317100,1620);
 return int_stack+0;}
