/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgng(Libint_t*, prim_data*);

  /* Computes quartets of (mg|ng) integrals */

REALTYPE *hrr_order_mgng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[10][10] = int_stack + 25300;
 Libint->vrr_classes[10][11] = int_stack + 29656;
 Libint->vrr_classes[10][12] = int_stack + 34804;
 Libint->vrr_classes[10][13] = int_stack + 40810;
 Libint->vrr_classes[10][14] = int_stack + 47740;
 Libint->vrr_classes[11][10] = int_stack + 55660;
 Libint->vrr_classes[11][11] = int_stack + 60808;
 Libint->vrr_classes[11][12] = int_stack + 66892;
 Libint->vrr_classes[11][13] = int_stack + 73990;
 Libint->vrr_classes[11][14] = int_stack + 82180;
 Libint->vrr_classes[12][10] = int_stack + 91540;
 Libint->vrr_classes[12][11] = int_stack + 97546;
 Libint->vrr_classes[12][12] = int_stack + 104644;
 Libint->vrr_classes[12][13] = int_stack + 112925;
 Libint->vrr_classes[12][14] = int_stack + 122480;
 Libint->vrr_classes[13][10] = int_stack + 133400;
 Libint->vrr_classes[13][11] = int_stack + 140330;
 Libint->vrr_classes[13][12] = int_stack + 148520;
 Libint->vrr_classes[13][13] = int_stack + 158075;
 Libint->vrr_classes[13][14] = int_stack + 169100;
 memset(int_stack,0,181700*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 181700;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgng(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181700,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+192590,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+205460,int_stack+192590,int_stack+181700,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+227240,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+242255,int_stack+227240,int_stack+192590,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+267995,int_stack+242255,int_stack+205460,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+181700,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+304295,int_stack+181700,int_stack+227240,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+181700,int_stack+304295,int_stack+242255,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+304295,int_stack+181700,int_stack+267995,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181700,int_stack+29656,int_stack+25300,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+194768,int_stack+34804,int_stack+29656,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210212,int_stack+194768,int_stack+181700,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+236348,int_stack+40810,int_stack+34804,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+254366,int_stack+236348,int_stack+194768,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+358745,int_stack+254366,int_stack+210212,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+181700,int_stack+47740,int_stack+40810,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+181700,int_stack+236348,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+181700,int_stack+0,int_stack+254366,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+233180,int_stack+181700,int_stack+358745,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+358745,int_stack+233180,int_stack+304295,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181700,int_stack+60808,int_stack+55660,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+197144,int_stack+66892,int_stack+60808,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+197144,int_stack+181700,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+30888,int_stack+73990,int_stack+66892,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+298520,int_stack+30888,int_stack+197144,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+181700,int_stack+298520,int_stack+0,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+82180,int_stack+73990,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+522095,int_stack+0,int_stack+30888,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+522095,int_stack+298520,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+522095,int_stack+0,int_stack+181700,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+599315,int_stack+522095,int_stack+233180,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+795335,int_stack+599315,int_stack+358745,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181700,int_stack+97546,int_stack+91540,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+199718,int_stack+104644,int_stack+97546,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+221012,int_stack+199718,int_stack+181700,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+257048,int_stack+112925,int_stack+104644,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+281891,int_stack+257048,int_stack+199718,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+324479,int_stack+281891,int_stack+221012,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+181700,int_stack+122480,int_stack+112925,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+384539,int_stack+181700,int_stack+257048,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+181700,int_stack+384539,int_stack+281891,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+384539,int_stack+181700,int_stack+324479,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+1122035,int_stack+384539,int_stack+522095,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1353695,int_stack+1122035,int_stack+599315,990);
 /*--- compute (mf|ng) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1745735,int_stack+1353695,int_stack+795335,990);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181700,int_stack+140330,int_stack+133400,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+202490,int_stack+148520,int_stack+140330,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+227060,int_stack+202490,int_stack+181700,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+268640,int_stack+158075,int_stack+148520,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+297305,int_stack+268640,int_stack+202490,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+474629,int_stack+297305,int_stack+227060,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+181700,int_stack+169100,int_stack+158075,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+543929,int_stack+181700,int_stack+268640,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+601259,int_stack+543929,int_stack+297305,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+683159,int_stack+601259,int_stack+474629,105);
 /*--- compute (qp|ng) ---*/
 hrr1_build_qp(Libint->AB,int_stack+787109,int_stack+683159,int_stack+384539,990);
 /*--- compute (od|ng) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+787109,int_stack+1122035,990);
 /*--- compute (nf|ng) ---*/
 hrr1_build_nf(Libint->AB,int_stack+463320,int_stack+0,int_stack+1353695,990);
 /*--- compute (mg|ng) ---*/
 hrr1_build_mg(Libint->AB,int_stack+2290235,int_stack+463320,int_stack+1745735,990);
 return int_stack+2290235;}
