/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgnn(Libint_t*, prim_data*);

  /* Computes quartets of (mg|nn) integrals */

REALTYPE *hrr_order_mgnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[9][19] = int_stack + 61050;
 Libint->vrr_classes[9][20] = int_stack + 72600;
 Libint->vrr_classes[10][10] = int_stack + 85305;
 Libint->vrr_classes[10][11] = int_stack + 89661;
 Libint->vrr_classes[10][12] = int_stack + 94809;
 Libint->vrr_classes[10][13] = int_stack + 100815;
 Libint->vrr_classes[10][14] = int_stack + 107745;
 Libint->vrr_classes[10][15] = int_stack + 115665;
 Libint->vrr_classes[10][16] = int_stack + 124641;
 Libint->vrr_classes[10][17] = int_stack + 134739;
 Libint->vrr_classes[10][18] = int_stack + 146025;
 Libint->vrr_classes[10][19] = int_stack + 158565;
 Libint->vrr_classes[10][20] = int_stack + 172425;
 Libint->vrr_classes[11][10] = int_stack + 187671;
 Libint->vrr_classes[11][11] = int_stack + 192819;
 Libint->vrr_classes[11][12] = int_stack + 198903;
 Libint->vrr_classes[11][13] = int_stack + 206001;
 Libint->vrr_classes[11][14] = int_stack + 214191;
 Libint->vrr_classes[11][15] = int_stack + 223551;
 Libint->vrr_classes[11][16] = int_stack + 234159;
 Libint->vrr_classes[11][17] = int_stack + 246093;
 Libint->vrr_classes[11][18] = int_stack + 259431;
 Libint->vrr_classes[11][19] = int_stack + 274251;
 Libint->vrr_classes[11][20] = int_stack + 290631;
 Libint->vrr_classes[12][10] = int_stack + 308649;
 Libint->vrr_classes[12][11] = int_stack + 314655;
 Libint->vrr_classes[12][12] = int_stack + 321753;
 Libint->vrr_classes[12][13] = int_stack + 330034;
 Libint->vrr_classes[12][14] = int_stack + 339589;
 Libint->vrr_classes[12][15] = int_stack + 350509;
 Libint->vrr_classes[12][16] = int_stack + 362885;
 Libint->vrr_classes[12][17] = int_stack + 376808;
 Libint->vrr_classes[12][18] = int_stack + 392369;
 Libint->vrr_classes[12][19] = int_stack + 409659;
 Libint->vrr_classes[12][20] = int_stack + 428769;
 Libint->vrr_classes[13][10] = int_stack + 449790;
 Libint->vrr_classes[13][11] = int_stack + 456720;
 Libint->vrr_classes[13][12] = int_stack + 464910;
 Libint->vrr_classes[13][13] = int_stack + 474465;
 Libint->vrr_classes[13][14] = int_stack + 485490;
 Libint->vrr_classes[13][15] = int_stack + 498090;
 Libint->vrr_classes[13][16] = int_stack + 512370;
 Libint->vrr_classes[13][17] = int_stack + 528435;
 Libint->vrr_classes[13][18] = int_stack + 546390;
 Libint->vrr_classes[13][19] = int_stack + 566340;
 Libint->vrr_classes[13][20] = int_stack + 588390;
 memset(int_stack,0,612645*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 612645;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgnn(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+612645,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+623535,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+636405,int_stack+623535,int_stack+612645,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+658185,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+673200,int_stack+658185,int_stack+623535,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+698940,int_stack+673200,int_stack+636405,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+612645,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+735240,int_stack+612645,int_stack+658185,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+629970,int_stack+735240,int_stack+673200,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+765270,int_stack+629970,int_stack+698940,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+672870,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+692670,int_stack+672870,int_stack+612645,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+819720,int_stack+692670,int_stack+735240,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+869770,int_stack+819720,int_stack+629970,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+934120,int_stack+869770,int_stack+765270,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+612645,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+727320,int_stack+612645,int_stack+672870,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1010350,int_stack+727320,int_stack+692670,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+635085,int_stack+1010350,int_stack+819720,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+766920,int_stack+635085,int_stack+869770,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1068100,int_stack+766920,int_stack+934120,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+857010,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+882255,int_stack+857010,int_stack+612645,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+927135,int_stack+882255,int_stack+727320,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1169740,int_stack+927135,int_stack+1010350,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1256365,int_stack+1169740,int_stack+635085,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+612645,int_stack+1256365,int_stack+766920,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1361470,int_stack+612645,int_stack+1068100,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+732765,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+760980,int_stack+732765,int_stack+857010,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+993135,int_stack+760980,int_stack+882255,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+811470,int_stack+993135,int_stack+927135,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1492150,int_stack+811470,int_stack+1169740,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1067935,int_stack+1492150,int_stack+1256365,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1613425,int_stack+1067935,int_stack+612645,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1767865,int_stack+1613425,int_stack+1361470,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+612645,int_stack+61050,int_stack+50600,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+643995,int_stack+612645,int_stack+732765,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1208075,int_stack+643995,int_stack+760980,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1292225,int_stack+1208075,int_stack+993135,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+910470,int_stack+1292225,int_stack+811470,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+700425,int_stack+910470,int_stack+1492150,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1404425,int_stack+700425,int_stack+1067935,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1931215,int_stack+1404425,int_stack+1613425,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2124265,int_stack+1931215,int_stack+1767865,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+862125,int_stack+72600,int_stack+61050,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1049070,int_stack+862125,int_stack+612645,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1111770,int_stack+1049070,int_stack+643995,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1584605,int_stack+1111770,int_stack+1208075,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1049070,int_stack+1584605,int_stack+1292225,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1584605,int_stack+1049070,int_stack+910470,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+862125,int_stack+1584605,int_stack+700425,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1584605,int_stack+862125,int_stack+1404425,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+612645,int_stack+1584605,int_stack+1931215,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+848595,int_stack+612645,int_stack+2124265,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+612645,int_stack+89661,int_stack+85305,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+625713,int_stack+94809,int_stack+89661,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+641157,int_stack+625713,int_stack+612645,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+667293,int_stack+100815,int_stack+94809,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+685311,int_stack+667293,int_stack+625713,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+716199,int_stack+685311,int_stack+641157,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+612645,int_stack+107745,int_stack+100815,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+759759,int_stack+612645,int_stack+667293,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+633435,int_stack+759759,int_stack+685311,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1088175,int_stack+633435,int_stack+716199,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+684915,int_stack+115665,int_stack+107745,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+708675,int_stack+684915,int_stack+612645,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1153515,int_stack+708675,int_stack+759759,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+750255,int_stack+1153515,int_stack+633435,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1213575,int_stack+750255,int_stack+1088175,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1088175,int_stack+124641,int_stack+115665,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+612645,int_stack+1088175,int_stack+684915,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1305051,int_stack+612645,int_stack+708675,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+660165,int_stack+1305051,int_stack+1153515,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1374351,int_stack+660165,int_stack+750255,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1482459,int_stack+1374351,int_stack+1213575,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+750255,int_stack+134739,int_stack+124641,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+780549,int_stack+750255,int_stack+1088175,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1088175,int_stack+780549,int_stack+612645,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1167375,int_stack+1088175,int_stack+1305051,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1604427,int_stack+1167375,int_stack+660165,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1730553,int_stack+1604427,int_stack+1374351,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1271325,int_stack+1730553,int_stack+1482459,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+612645,int_stack+146025,int_stack+134739,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+646503,int_stack+612645,int_stack+750255,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1428141,int_stack+646503,int_stack+780549,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+707091,int_stack+1428141,int_stack+1088175,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1874697,int_stack+707091,int_stack+1167375,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1088175,int_stack+1874697,int_stack+1604427,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1517901,int_stack+1088175,int_stack+1730553,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2020227,int_stack+1517901,int_stack+1271325,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1256343,int_stack+158565,int_stack+146025,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1293963,int_stack+1256343,int_stack+612645,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1703229,int_stack+1293963,int_stack+646503,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1703229,int_stack+1428141,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2216247,int_stack+0,int_stack+707091,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+612645,int_stack+2216247,int_stack+1874697,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2382567,int_stack+612645,int_stack+1088175,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2598783,int_stack+2382567,int_stack+1517901,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1361679,int_stack+2598783,int_stack+2020227,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1088175,int_stack+172425,int_stack+158565,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1129755,int_stack+1088175,int_stack+1256343,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1804209,int_stack+1129755,int_stack+1293963,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1088175,int_stack+1804209,int_stack+1703229,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1601259,int_stack+1088175,int_stack+0,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1088175,int_stack+1601259,int_stack+2216247,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1601259,int_stack+1088175,int_stack+612645,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1088175,int_stack+1601259,int_stack+2382567,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1601259,int_stack+1088175,int_stack+2598783,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1884399,int_stack+1601259,int_stack+1361679,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1088175,int_stack+1884399,int_stack+848595,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1806915,int_stack+192819,int_stack+187671,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1822359,int_stack+198903,int_stack+192819,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1840611,int_stack+1822359,int_stack+1806915,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2171895,int_stack+206001,int_stack+198903,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2193189,int_stack+2171895,int_stack+1822359,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2229693,int_stack+2193189,int_stack+1840611,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1806915,int_stack+214191,int_stack+206001,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1831485,int_stack+1806915,int_stack+2171895,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2281173,int_stack+1831485,int_stack+2193189,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2342013,int_stack+2281173,int_stack+2229693,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2171895,int_stack+223551,int_stack+214191,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2199975,int_stack+2171895,int_stack+1806915,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2419233,int_stack+2199975,int_stack+1831485,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2490213,int_stack+2419233,int_stack+2281173,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2581473,int_stack+2490213,int_stack+2342013,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1806915,int_stack+234159,int_stack+223551,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2249115,int_stack+1806915,int_stack+2171895,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2305275,int_stack+2249115,int_stack+2199975,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2689581,int_stack+2305275,int_stack+2419233,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+612645,int_stack+2689581,int_stack+2490213,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2387175,int_stack+612645,int_stack+2581473,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2171895,int_stack+246093,int_stack+234159,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2531319,int_stack+2171895,int_stack+1806915,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2594967,int_stack+2531319,int_stack+2249115,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+740409,int_stack+2594967,int_stack+2305275,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2207697,int_stack+740409,int_stack+2689581,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+863259,int_stack+2207697,int_stack+612645,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+863259,int_stack+2387175,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+612645,int_stack+259431,int_stack+246093,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+652659,int_stack+612645,int_stack+2171895,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2356755,int_stack+652659,int_stack+2531319,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2688567,int_stack+2356755,int_stack+2594967,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2462835,int_stack+2688567,int_stack+740409,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2828967,int_stack+2462835,int_stack+2207697,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3027711,int_stack+2828967,int_stack+863259,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+724263,int_stack+3027711,int_stack+0,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+274251,int_stack+259431,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44460,int_stack+0,int_stack+612645,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+124488,int_stack+44460,int_stack+652659,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2171895,int_stack+124488,int_stack+2356755,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3246735,int_stack+2171895,int_stack+2688567,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3443295,int_stack+3246735,int_stack+2462835,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2331015,int_stack+3443295,int_stack+2828967,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2586543,int_stack+2331015,int_stack+3027711,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2860323,int_stack+2586543,int_stack+724263,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+612645,int_stack+290631,int_stack+274251,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+661785,int_stack+612645,int_stack+0,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+750705,int_stack+661785,int_stack+44460,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+884085,int_stack+750705,int_stack+124488,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+884085,int_stack+2171895,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+612645,int_stack+0,int_stack+3246735,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+612645,int_stack+3443295,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+612645,int_stack+0,int_stack+2331015,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2171895,int_stack+612645,int_stack+2586543,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+612645,int_stack+2171895,int_stack+2860323,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+2171895,int_stack+612645,int_stack+1884399,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+3034383,int_stack+2171895,int_stack+1088175,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+952413,int_stack+314655,int_stack+308649,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+970431,int_stack+321753,int_stack+314655,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+991725,int_stack+970431,int_stack+952413,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1027761,int_stack+330034,int_stack+321753,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1052604,int_stack+1027761,int_stack+970431,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1095192,int_stack+1052604,int_stack+991725,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+952413,int_stack+339589,int_stack+330034,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1155252,int_stack+952413,int_stack+1027761,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+981078,int_stack+1155252,int_stack+1052604,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1204938,int_stack+981078,int_stack+1095192,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1052058,int_stack+350509,int_stack+339589,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1084818,int_stack+1052058,int_stack+952413,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1295028,int_stack+1084818,int_stack+1155252,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1377838,int_stack+1295028,int_stack+981078,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1484308,int_stack+1377838,int_stack+1204938,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+952413,int_stack+362885,int_stack+350509,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1142148,int_stack+952413,int_stack+1052058,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1610434,int_stack+1142148,int_stack+1084818,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+989541,int_stack+1610434,int_stack+1295028,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1207668,int_stack+989541,int_stack+1377838,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1705984,int_stack+1207668,int_stack+1484308,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1356726,int_stack+376808,int_stack+362885,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1398495,int_stack+1356726,int_stack+952413,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1472751,int_stack+1398495,int_stack+1142148,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1874152,int_stack+1472751,int_stack+1610434,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+1874152,int_stack+989541,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+952413,int_stack+0,int_stack+1207668,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4471863,int_stack+952413,int_stack+1705984,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1151157,int_stack+392369,int_stack+376808,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1197840,int_stack+1151157,int_stack+1356726,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1581951,int_stack+1197840,int_stack+1398495,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1281378,int_stack+1581951,int_stack+1472751,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+173901,int_stack+1281378,int_stack+1874152,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1705711,int_stack+173901,int_stack+0,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4688079,int_stack+1705711,int_stack+952413,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4943607,int_stack+4688079,int_stack+4471863,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+4471863,int_stack+409659,int_stack+392369,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+4523733,int_stack+4471863,int_stack+1151157,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+952413,int_stack+4523733,int_stack+1197840,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1091643,int_stack+952413,int_stack+1581951,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1445178,int_stack+1091643,int_stack+1281378,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+5213877,int_stack+1445178,int_stack+173901,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+5213877,int_stack+1705711,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1674498,int_stack+0,int_stack+4688079,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+5481417,int_stack+1674498,int_stack+4943607,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+4617099,int_stack+428769,int_stack+409659,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+4674429,int_stack+4617099,int_stack+4471863,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+4778169,int_stack+4674429,int_stack+4523733,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+4471863,int_stack+4778169,int_stack+952413,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+4680708,int_stack+4471863,int_stack+1091643,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+952413,int_stack+4680708,int_stack+1445178,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+4471863,int_stack+952413,int_stack+5213877,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+952413,int_stack+4471863,int_stack+0,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+952413,int_stack+1674498,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+952413,int_stack+0,int_stack+5481417,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+4471863,int_stack+952413,int_stack+612645,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+5491167,int_stack+4471863,int_stack+2171895,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+7216143,int_stack+5491167,int_stack+3034383,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+612645,int_stack+456720,int_stack+449790,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+633435,int_stack+464910,int_stack+456720,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+658005,int_stack+633435,int_stack+612645,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+699585,int_stack+474465,int_stack+464910,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+728250,int_stack+699585,int_stack+633435,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+777390,int_stack+728250,int_stack+658005,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+612645,int_stack+485490,int_stack+474465,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+846690,int_stack+612645,int_stack+699585,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+645720,int_stack+846690,int_stack+728250,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+645720,int_stack+777390,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+727620,int_stack+498090,int_stack+485490,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+765420,int_stack+727620,int_stack+612645,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+103950,int_stack+765420,int_stack+846690,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+199500,int_stack+103950,int_stack+645720,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+322350,int_stack+199500,int_stack+0,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+512370,int_stack+498090,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+612645,int_stack+0,int_stack+727620,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+831570,int_stack+612645,int_stack+765420,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+688245,int_stack+831570,int_stack+103950,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1348809,int_stack+688245,int_stack+199500,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+42840,int_stack+1348809,int_stack+322350,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+236880,int_stack+528435,int_stack+512370,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+285075,int_stack+236880,int_stack+0,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+370755,int_stack+285075,int_stack+612645,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1520799,int_stack+370755,int_stack+831570,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1686174,int_stack+1520799,int_stack+688245,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+612645,int_stack+1686174,int_stack+1348809,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1886829,int_stack+612645,int_stack+42840,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1348809,int_stack+546390,int_stack+528435,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1402674,int_stack+1348809,int_stack+236880,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1402674,int_stack+285075,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+142800,int_stack+0,int_stack+370755,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2136309,int_stack+142800,int_stack+1520799,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2367834,int_stack+2136309,int_stack+1686174,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1499064,int_stack+2367834,int_stack+612645,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+612645,int_stack+1499064,int_stack+1886829,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1793904,int_stack+566340,int_stack+546390,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1853754,int_stack+1793904,int_stack+1348809,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1961484,int_stack+1853754,int_stack+1402674,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+331800,int_stack+1961484,int_stack+0,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2635374,int_stack+331800,int_stack+142800,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+2635374,int_stack+2136309,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2899974,int_stack+0,int_stack+2367834,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2122134,int_stack+2899974,int_stack+1499064,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1348809,int_stack+2122134,int_stack+612645,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+612645,int_stack+588390,int_stack+566340,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+678795,int_stack+612645,int_stack+1793904,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+3243954,int_stack+678795,int_stack+1853754,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+546000,int_stack+3243954,int_stack+1961484,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+3243954,int_stack+546000,int_stack+331800,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3543834,int_stack+3243954,int_stack+2635374,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+3896634,int_stack+3543834,int_stack+0,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+3896634,int_stack+2899974,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+429975,int_stack+0,int_stack+2122134,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1729959,int_stack+429975,int_stack+1348809,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2187339,int_stack+1729959,int_stack+952413,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+2187339,int_stack+4471863,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2038608,int_stack+0,int_stack+5491167,4356);
 /*--- compute (mg|nn) ---*/
 hrr1_build_mg(Libint->AB,int_stack+9611943,int_stack+2038608,int_stack+7216143,4356);
 return int_stack+9611943;}
