/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhll(Libint_t*, prim_data*);

  /* Computes quartets of (mh|ll) integrals */

REALTYPE *hrr_order_mhll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[9][16] = int_stack + 38280;
 Libint->vrr_classes[10][8] = int_stack + 46695;
 Libint->vrr_classes[10][9] = int_stack + 49665;
 Libint->vrr_classes[10][10] = int_stack + 53295;
 Libint->vrr_classes[10][11] = int_stack + 57651;
 Libint->vrr_classes[10][12] = int_stack + 62799;
 Libint->vrr_classes[10][13] = int_stack + 68805;
 Libint->vrr_classes[10][14] = int_stack + 75735;
 Libint->vrr_classes[10][15] = int_stack + 83655;
 Libint->vrr_classes[10][16] = int_stack + 92631;
 Libint->vrr_classes[11][8] = int_stack + 102729;
 Libint->vrr_classes[11][9] = int_stack + 106239;
 Libint->vrr_classes[11][10] = int_stack + 110529;
 Libint->vrr_classes[11][11] = int_stack + 115677;
 Libint->vrr_classes[11][12] = int_stack + 121761;
 Libint->vrr_classes[11][13] = int_stack + 128859;
 Libint->vrr_classes[11][14] = int_stack + 137049;
 Libint->vrr_classes[11][15] = int_stack + 146409;
 Libint->vrr_classes[11][16] = int_stack + 157017;
 Libint->vrr_classes[12][8] = int_stack + 168951;
 Libint->vrr_classes[12][9] = int_stack + 173046;
 Libint->vrr_classes[12][10] = int_stack + 178051;
 Libint->vrr_classes[12][11] = int_stack + 184057;
 Libint->vrr_classes[12][12] = int_stack + 191155;
 Libint->vrr_classes[12][13] = int_stack + 199436;
 Libint->vrr_classes[12][14] = int_stack + 208991;
 Libint->vrr_classes[12][15] = int_stack + 219911;
 Libint->vrr_classes[12][16] = int_stack + 232287;
 Libint->vrr_classes[13][8] = int_stack + 246210;
 Libint->vrr_classes[13][9] = int_stack + 250935;
 Libint->vrr_classes[13][10] = int_stack + 256710;
 Libint->vrr_classes[13][11] = int_stack + 263640;
 Libint->vrr_classes[13][12] = int_stack + 271830;
 Libint->vrr_classes[13][13] = int_stack + 281385;
 Libint->vrr_classes[13][14] = int_stack + 292410;
 Libint->vrr_classes[13][15] = int_stack + 305010;
 Libint->vrr_classes[13][16] = int_stack + 319290;
 Libint->vrr_classes[14][8] = int_stack + 335355;
 Libint->vrr_classes[14][9] = int_stack + 340755;
 Libint->vrr_classes[14][10] = int_stack + 347355;
 Libint->vrr_classes[14][11] = int_stack + 355275;
 Libint->vrr_classes[14][12] = int_stack + 364635;
 Libint->vrr_classes[14][13] = int_stack + 375555;
 Libint->vrr_classes[14][14] = int_stack + 388155;
 Libint->vrr_classes[14][15] = int_stack + 402555;
 Libint->vrr_classes[14][16] = int_stack + 418875;
 memset(int_stack,0,437235*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 437235;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhll(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+437235,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+444660,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+453735,int_stack+444660,int_stack+437235,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+468585,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+479475,int_stack+468585,int_stack+444660,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+497625,int_stack+479475,int_stack+453735,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+437235,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+522375,int_stack+437235,int_stack+468585,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+544155,int_stack+522375,int_stack+479475,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+450105,int_stack+544155,int_stack+497625,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+487230,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+574405,int_stack+487230,int_stack+437235,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+600145,int_stack+574405,int_stack+522375,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+636445,int_stack+600145,int_stack+544155,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+502245,int_stack+636445,int_stack+450105,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+437235,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+454560,int_stack+437235,int_stack+487230,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+681820,int_stack+454560,int_stack+574405,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+724720,int_stack+681820,int_stack+600145,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+554220,int_stack+724720,int_stack+636445,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+779170,int_stack+554220,int_stack+502245,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+484590,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+504390,int_stack+484590,int_stack+437235,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+617745,int_stack+504390,int_stack+454560,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+848470,int_stack+617745,int_stack+681820,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+912820,int_stack+848470,int_stack+724720,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+667795,int_stack+912820,int_stack+554220,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+989050,int_stack+667795,int_stack+779170,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+437235,int_stack+38280,int_stack+30800,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+539040,int_stack+437235,int_stack+484590,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+437235,int_stack+539040,int_stack+504390,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+494985,int_stack+437235,int_stack+617745,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+570060,int_stack+494985,int_stack+848470,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+437235,int_stack+570060,int_stack+912820,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+538875,int_stack+437235,int_stack+667795,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+647775,int_stack+538875,int_stack+989050,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+437235,int_stack+49665,int_stack+46695,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+446145,int_stack+53295,int_stack+49665,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+457035,int_stack+446145,int_stack+437235,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+474855,int_stack+57651,int_stack+53295,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+487923,int_stack+474855,int_stack+446145,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+509703,int_stack+487923,int_stack+457035,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+437235,int_stack+62799,int_stack+57651,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+539403,int_stack+437235,int_stack+474855,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+565539,int_stack+539403,int_stack+487923,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+452679,int_stack+565539,int_stack+509703,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+497229,int_stack+68805,int_stack+62799,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+601839,int_stack+497229,int_stack+437235,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+759150,int_stack+601839,int_stack+539403,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+802710,int_stack+759150,int_stack+565539,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+515247,int_stack+802710,int_stack+452679,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+437235,int_stack+75735,int_stack+68805,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+458025,int_stack+437235,int_stack+497229,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+857160,int_stack+458025,int_stack+601839,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+577617,int_stack+857160,int_stack+759150,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+908640,int_stack+577617,int_stack+802710,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+759150,int_stack+908640,int_stack+515247,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+494061,int_stack+83655,int_stack+75735,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+517821,int_stack+494061,int_stack+437235,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+984870,int_stack+517821,int_stack+458025,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+984870,int_stack+857160,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1044930,int_stack+0,int_stack+577617,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1136406,int_stack+1044930,int_stack+908640,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+842310,int_stack+1136406,int_stack+759150,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+759150,int_stack+92631,int_stack+83655,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+786078,int_stack+759150,int_stack+494061,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+437235,int_stack+786078,int_stack+517821,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+506535,int_stack+437235,int_stack+984870,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1238046,int_stack+506535,int_stack+0,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+437235,int_stack+1238046,int_stack+1044930,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+949230,int_stack+437235,int_stack+1136406,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+437235,int_stack+949230,int_stack+842310,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+759150,int_stack+437235,int_stack+647775,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+570885,int_stack+106239,int_stack+102729,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581415,int_stack+110529,int_stack+106239,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+594285,int_stack+581415,int_stack+570885,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+615345,int_stack+115677,int_stack+110529,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+630789,int_stack+615345,int_stack+581415,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+656529,int_stack+630789,int_stack+594285,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+570885,int_stack+121761,int_stack+115677,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+691629,int_stack+570885,int_stack+615345,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+691629,int_stack+630789,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+589137,int_stack+0,int_stack+656529,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+641787,int_stack+128859,int_stack+121761,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+722517,int_stack+641787,int_stack+570885,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42900,int_stack+722517,int_stack+691629,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1093275,int_stack+42900,int_stack+0,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1157625,int_stack+1093275,int_stack+589137,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137049,int_stack+128859,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+570885,int_stack+0,int_stack+641787,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+613473,int_stack+570885,int_stack+722517,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+674313,int_stack+613473,int_stack+42900,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+24570,int_stack+674313,int_stack+1093275,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1231335,int_stack+24570,int_stack+1157625,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1093275,int_stack+146409,int_stack+137049,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1121355,int_stack+1093275,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1329615,int_stack+1121355,int_stack+570885,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1400595,int_stack+1329615,int_stack+613473,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1491855,int_stack+1400595,int_stack+674313,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+570885,int_stack+1491855,int_stack+24570,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+570885,int_stack+1231335,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+691005,int_stack+157017,int_stack+146409,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1170495,int_stack+691005,int_stack+1093275,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1226655,int_stack+1170495,int_stack+1121355,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1093275,int_stack+1226655,int_stack+1329615,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1199745,int_stack+1093275,int_stack+1400595,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1327509,int_stack+1199745,int_stack+1491855,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1093275,int_stack+1327509,int_stack+570885,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+570885,int_stack+1093275,int_stack+0,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+1093275,int_stack+570885,int_stack+437235,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+1494225,int_stack+1093275,int_stack+759150,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+437235,int_stack+173046,int_stack+168951,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+449520,int_stack+178051,int_stack+173046,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+464535,int_stack+449520,int_stack+437235,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+489105,int_stack+184057,int_stack+178051,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+507123,int_stack+489105,int_stack+449520,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+507123,int_stack+464535,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+437235,int_stack+191155,int_stack+184057,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40950,int_stack+437235,int_stack+489105,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+76986,int_stack+40950,int_stack+507123,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+458529,int_stack+76986,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+199436,int_stack+191155,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+519954,int_stack+0,int_stack+437235,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+127036,int_stack+519954,int_stack+40950,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+728835,int_stack+127036,int_stack+76986,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+24843,int_stack+728835,int_stack+458529,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+437235,int_stack+208991,int_stack+199436,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+465900,int_stack+437235,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+803910,int_stack+465900,int_stack+519954,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+874890,int_stack+803910,int_stack+127036,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+964980,int_stack+874890,int_stack+728835,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+2162475,int_stack+964980,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+728835,int_stack+219911,int_stack+208991,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+728835,int_stack+437235,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+465900,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+437235,int_stack+57330,int_stack+803910,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2277135,int_stack+437235,int_stack+874890,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+761595,int_stack+2277135,int_stack+964980,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+901735,int_stack+761595,int_stack+2162475,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2162475,int_stack+232287,int_stack+219911,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2199603,int_stack+2162475,int_stack+728835,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+140140,int_stack+2199603,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2403261,int_stack+140140,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+2403261,int_stack+437235,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2403261,int_stack+0,int_stack+2277135,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+2403261,int_stack+761595,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+2162475,int_stack+0,int_stack+901735,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+2346750,int_stack+2162475,int_stack+570885,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2820600,int_stack+2346750,int_stack+1093275,2025);
 /*--- compute (mf|ll) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3622500,int_stack+2820600,int_stack+1494225,2025);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+250935,int_stack+246210,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14175,int_stack+256710,int_stack+250935,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31500,int_stack+14175,int_stack+0,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59850,int_stack+263640,int_stack+256710,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80640,int_stack+59850,int_stack+14175,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+115290,int_stack+80640,int_stack+31500,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+271830,int_stack+263640,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162540,int_stack+0,int_stack+59850,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+204120,int_stack+162540,int_stack+80640,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24570,int_stack+204120,int_stack+115290,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+95445,int_stack+281385,int_stack+271830,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+437235,int_stack+95445,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+486375,int_stack+437235,int_stack+162540,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+555675,int_stack+486375,int_stack+204120,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+124110,int_stack+555675,int_stack+24570,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+292410,int_stack+281385,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+33075,int_stack+0,int_stack+95445,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+642300,int_stack+33075,int_stack+437235,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+724200,int_stack+642300,int_stack+486375,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+828150,int_stack+724200,int_stack+555675,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+437235,int_stack+828150,int_stack+124110,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+569535,int_stack+305010,int_stack+292410,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+90405,int_stack+569535,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+156555,int_stack+90405,int_stack+33075,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+949425,int_stack+156555,int_stack+642300,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1072275,int_stack+949425,int_stack+724200,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+607335,int_stack+1072275,int_stack+828150,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+769035,int_stack+607335,int_stack+437235,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+437235,int_stack+319290,int_stack+305010,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+480075,int_stack+437235,int_stack+569535,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1217805,int_stack+480075,int_stack+90405,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+437235,int_stack+1217805,int_stack+156555,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1217805,int_stack+437235,int_stack+949425,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1389795,int_stack+1217805,int_stack+1072275,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1583835,int_stack+1389795,int_stack+607335,105);
 /*--- compute (r0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+437235,int_stack+1583835,int_stack+769035,105);
 /*--- compute (qp|ll) ---*/
 hrr1_build_qp(Libint->AB,int_stack+649860,int_stack+437235,int_stack+2162475,2025);
 /*--- compute (od|ll) ---*/
 hrr1_build_od(Libint->AB,int_stack+1202685,int_stack+649860,int_stack+2346750,2025);
 /*--- compute (nf|ll) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4736250,int_stack+1202685,int_stack+2820600,2025);
 /*--- compute (mg|ll) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6072750,int_stack+4736250,int_stack+3622500,2025);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2150385,int_stack+340755,int_stack+335355,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2166585,int_stack+347355,int_stack+340755,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2186385,int_stack+2166585,int_stack+2150385,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2218785,int_stack+355275,int_stack+347355,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2242545,int_stack+2218785,int_stack+2166585,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+2282145,int_stack+2242545,int_stack+2186385,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2150385,int_stack+364635,int_stack+355275,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2336145,int_stack+2150385,int_stack+2218785,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2383665,int_stack+2336145,int_stack+2242545,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2178465,int_stack+2383665,int_stack+2282145,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2259465,int_stack+375555,int_stack+364635,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2449665,int_stack+2259465,int_stack+2150385,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2505825,int_stack+2449665,int_stack+2336145,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2585025,int_stack+2505825,int_stack+2383665,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+2292225,int_stack+2585025,int_stack+2178465,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2150385,int_stack+388155,int_stack+375555,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2188185,int_stack+2150385,int_stack+2259465,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2684025,int_stack+2188185,int_stack+2449665,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2777625,int_stack+2684025,int_stack+2505825,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2405625,int_stack+2777625,int_stack+2585025,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+2896425,int_stack+2405625,int_stack+2292225,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2253705,int_stack+402555,int_stack+388155,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2296905,int_stack+2253705,int_stack+2150385,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2544225,int_stack+2296905,int_stack+2188185,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3047625,int_stack+2544225,int_stack+2684025,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3188025,int_stack+3047625,int_stack+2777625,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2653425,int_stack+3188025,int_stack+2405625,120);
 /*--- compute (t0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+3354345,int_stack+2653425,int_stack+2896425,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2150385,int_stack+418875,int_stack+402555,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2372505,int_stack+2150385,int_stack+2253705,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2150385,int_stack+2372505,int_stack+2296905,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2276385,int_stack+2150385,int_stack+2544225,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2440185,int_stack+2276385,int_stack+3047625,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2150385,int_stack+2440185,int_stack+3188025,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2372145,int_stack+2150385,int_stack+2653425,120);
 /*--- compute (t0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+2609745,int_stack+2372145,int_stack+3354345,120);
 /*--- compute (rp|ll) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2852745,int_stack+2609745,int_stack+437235,2025);
 /*--- compute (qd|ll) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3490620,int_stack+2852745,int_stack+649860,2025);
 /*--- compute (of|ll) ---*/
 hrr1_build_of(Libint->AB,int_stack+7743375,int_stack+3490620,int_stack+1202685,2025);
 /*--- compute (ng|ll) ---*/
 hrr1_build_ng(Libint->AB,int_stack+0,int_stack+7743375,int_stack+4736250,2025);
 /*--- compute (mh|ll) ---*/
 hrr1_build_mh(Libint->AB,int_stack+2004750,int_stack+0,int_stack+6072750,2025);
 return int_stack+2004750;}
