/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhni(Libint_t*, prim_data*);

  /* Computes quartets of (mh|ni) integrals */

REALTYPE *hrr_order_mhni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[10][10] = int_stack + 41195;
 Libint->vrr_classes[10][11] = int_stack + 45551;
 Libint->vrr_classes[10][12] = int_stack + 50699;
 Libint->vrr_classes[10][13] = int_stack + 56705;
 Libint->vrr_classes[10][14] = int_stack + 63635;
 Libint->vrr_classes[10][15] = int_stack + 71555;
 Libint->vrr_classes[10][16] = int_stack + 80531;
 Libint->vrr_classes[11][10] = int_stack + 90629;
 Libint->vrr_classes[11][11] = int_stack + 95777;
 Libint->vrr_classes[11][12] = int_stack + 101861;
 Libint->vrr_classes[11][13] = int_stack + 108959;
 Libint->vrr_classes[11][14] = int_stack + 117149;
 Libint->vrr_classes[11][15] = int_stack + 126509;
 Libint->vrr_classes[11][16] = int_stack + 137117;
 Libint->vrr_classes[12][10] = int_stack + 149051;
 Libint->vrr_classes[12][11] = int_stack + 155057;
 Libint->vrr_classes[12][12] = int_stack + 162155;
 Libint->vrr_classes[12][13] = int_stack + 170436;
 Libint->vrr_classes[12][14] = int_stack + 179991;
 Libint->vrr_classes[12][15] = int_stack + 190911;
 Libint->vrr_classes[12][16] = int_stack + 203287;
 Libint->vrr_classes[13][10] = int_stack + 217210;
 Libint->vrr_classes[13][11] = int_stack + 224140;
 Libint->vrr_classes[13][12] = int_stack + 232330;
 Libint->vrr_classes[13][13] = int_stack + 241885;
 Libint->vrr_classes[13][14] = int_stack + 252910;
 Libint->vrr_classes[13][15] = int_stack + 265510;
 Libint->vrr_classes[13][16] = int_stack + 279790;
 Libint->vrr_classes[14][10] = int_stack + 295855;
 Libint->vrr_classes[14][11] = int_stack + 303775;
 Libint->vrr_classes[14][12] = int_stack + 313135;
 Libint->vrr_classes[14][13] = int_stack + 324055;
 Libint->vrr_classes[14][14] = int_stack + 336655;
 Libint->vrr_classes[14][15] = int_stack + 351055;
 Libint->vrr_classes[14][16] = int_stack + 367375;
 memset(int_stack,0,385735*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 385735;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhni(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+385735,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+396625,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+409495,int_stack+396625,int_stack+385735,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+431275,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+446290,int_stack+431275,int_stack+396625,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+472030,int_stack+446290,int_stack+409495,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+385735,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+508330,int_stack+385735,int_stack+431275,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+403060,int_stack+508330,int_stack+446290,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+538360,int_stack+403060,int_stack+472030,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+445960,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+465760,int_stack+445960,int_stack+385735,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+592810,int_stack+465760,int_stack+508330,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+642860,int_stack+592810,int_stack+403060,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+707210,int_stack+642860,int_stack+538360,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+385735,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+500410,int_stack+385735,int_stack+445960,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+385735,int_stack+500410,int_stack+465760,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+443485,int_stack+385735,int_stack+592810,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+518560,int_stack+443485,int_stack+642860,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+385735,int_stack+518560,int_stack+707210,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+487375,int_stack+45551,int_stack+41195,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+500443,int_stack+50699,int_stack+45551,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+515887,int_stack+500443,int_stack+487375,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+542023,int_stack+56705,int_stack+50699,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+560041,int_stack+542023,int_stack+500443,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+590929,int_stack+560041,int_stack+515887,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+487375,int_stack+63635,int_stack+56705,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+634489,int_stack+487375,int_stack+542023,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+508165,int_stack+634489,int_stack+560041,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+670525,int_stack+508165,int_stack+590929,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+559645,int_stack+71555,int_stack+63635,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+583405,int_stack+559645,int_stack+487375,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+583405,int_stack+634489,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+735865,int_stack+0,int_stack+508165,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+813085,int_stack+735865,int_stack+670525,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+487375,int_stack+80531,int_stack+71555,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+624985,int_stack+487375,int_stack+559645,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+487375,int_stack+624985,int_stack+583405,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+556675,int_stack+487375,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+904561,int_stack+556675,int_stack+735865,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+487375,int_stack+904561,int_stack+813085,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+609343,int_stack+487375,int_stack+385735,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+385735,int_stack+95777,int_stack+90629,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+401179,int_stack+101861,int_stack+95777,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+419431,int_stack+401179,int_stack+385735,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+450319,int_stack+108959,int_stack+101861,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+450319,int_stack+401179,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+36504,int_stack+0,int_stack+419431,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+385735,int_stack+117149,int_stack+108959,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+914263,int_stack+385735,int_stack+450319,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+410305,int_stack+914263,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+956851,int_stack+410305,int_stack+36504,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+126509,int_stack+117149,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28080,int_stack+0,int_stack+385735,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1034071,int_stack+28080,int_stack+914263,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1105051,int_stack+1034071,int_stack+410305,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1196311,int_stack+1105051,int_stack+956851,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+914263,int_stack+137117,int_stack+126509,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+946087,int_stack+914263,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+385735,int_stack+946087,int_stack+28080,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+385735,int_stack+1034071,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+914263,int_stack+0,int_stack+1105051,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+914263,int_stack+1196311,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+914263,int_stack+0,int_stack+487375,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+1280167,int_stack+914263,int_stack+609343,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+385735,int_stack+155057,int_stack+149051,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+403753,int_stack+162155,int_stack+155057,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+425047,int_stack+403753,int_stack+385735,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+461083,int_stack+170436,int_stack+162155,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+485926,int_stack+461083,int_stack+403753,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+528514,int_stack+485926,int_stack+425047,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+385735,int_stack+179991,int_stack+170436,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+588574,int_stack+385735,int_stack+461083,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+414400,int_stack+588574,int_stack+485926,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+638260,int_stack+414400,int_stack+528514,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+485380,int_stack+190911,int_stack+179991,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+518140,int_stack+485380,int_stack+385735,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+728350,int_stack+518140,int_stack+588574,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1890007,int_stack+728350,int_stack+414400,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1996477,int_stack+1890007,int_stack+638260,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+385735,int_stack+203287,int_stack+190911,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+575470,int_stack+385735,int_stack+485380,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+385735,int_stack+575470,int_stack+518140,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+481285,int_stack+385735,int_stack+728350,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+605500,int_stack+481285,int_stack+1890007,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+385735,int_stack+605500,int_stack+1996477,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1890007,int_stack+385735,int_stack+0,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2322439,int_stack+1890007,int_stack+914263,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3054247,int_stack+2322439,int_stack+1280167,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+224140,int_stack+217210,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+232330,int_stack+224140,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+241885,int_stack+232330,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+252910,int_stack+241885,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+553903,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+553903,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+611233,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+265510,int_stack+252910,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+715183,int_stack+152775,int_stack+553903,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+810733,int_stack+715183,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+933583,int_stack+810733,int_stack+611233,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+553903,int_stack+279790,int_stack+265510,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+596743,int_stack+553903,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+596743,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+553903,int_stack+0,int_stack+715183,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+553903,int_stack+810733,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+553903,int_stack+0,int_stack+933583,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+747943,int_stack+553903,int_stack+385735,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+4070647,int_stack+747943,int_stack+1890007,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4935511,int_stack+4070647,int_stack+2322439,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1252447,int_stack+4935511,int_stack+3054247,1848);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+385735,int_stack+303775,int_stack+295855,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+409495,int_stack+313135,int_stack+303775,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+437575,int_stack+409495,int_stack+385735,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+485095,int_stack+324055,int_stack+313135,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+485095,int_stack+409495,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56160,int_stack+0,int_stack+437575,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+385735,int_stack+336655,int_stack+324055,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+135360,int_stack+385735,int_stack+485095,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+423535,int_stack+135360,int_stack+0,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200880,int_stack+423535,int_stack+56160,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+351055,int_stack+336655,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+385735,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2777047,int_stack+43200,int_stack+135360,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2886247,int_stack+2777047,int_stack+423535,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+385735,int_stack+2886247,int_stack+200880,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118800,int_stack+367375,int_stack+351055,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+167760,int_stack+118800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+254160,int_stack+167760,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+254160,int_stack+2777047,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+163800,int_stack+0,int_stack+2886247,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2777047,int_stack+163800,int_stack+385735,120);
 /*--- compute (rp|ni) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2998807,int_stack+2777047,int_stack+553903,1848);
 /*--- compute (qd|ni) ---*/
 hrr1_build_qd(Libint->AB,int_stack+6155191,int_stack+2998807,int_stack+747943,1848);
 /*--- compute (of|ni) ---*/
 hrr1_build_of(Libint->AB,int_stack+7164199,int_stack+6155191,int_stack+4070647,1848);
 /*--- compute (ng|ni) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2777047,int_stack+7164199,int_stack+4935511,1848);
 /*--- compute (mh|ni) ---*/
 hrr1_build_mh(Libint->AB,int_stack+4606567,int_stack+2777047,int_stack+1252447,1848);
 return int_stack+4606567;}
