/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mmmm(Libint_t*, prim_data*);

  /* Computes quartets of (mm|mm) integrals */

REALTYPE *hrr_order_mmmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[9][18] = int_stack + 53625;
 Libint->vrr_classes[10][9] = int_stack + 64075;
 Libint->vrr_classes[10][10] = int_stack + 67705;
 Libint->vrr_classes[10][11] = int_stack + 72061;
 Libint->vrr_classes[10][12] = int_stack + 77209;
 Libint->vrr_classes[10][13] = int_stack + 83215;
 Libint->vrr_classes[10][14] = int_stack + 90145;
 Libint->vrr_classes[10][15] = int_stack + 98065;
 Libint->vrr_classes[10][16] = int_stack + 107041;
 Libint->vrr_classes[10][17] = int_stack + 117139;
 Libint->vrr_classes[10][18] = int_stack + 128425;
 Libint->vrr_classes[11][9] = int_stack + 140965;
 Libint->vrr_classes[11][10] = int_stack + 145255;
 Libint->vrr_classes[11][11] = int_stack + 150403;
 Libint->vrr_classes[11][12] = int_stack + 156487;
 Libint->vrr_classes[11][13] = int_stack + 163585;
 Libint->vrr_classes[11][14] = int_stack + 171775;
 Libint->vrr_classes[11][15] = int_stack + 181135;
 Libint->vrr_classes[11][16] = int_stack + 191743;
 Libint->vrr_classes[11][17] = int_stack + 203677;
 Libint->vrr_classes[11][18] = int_stack + 217015;
 Libint->vrr_classes[12][9] = int_stack + 231835;
 Libint->vrr_classes[12][10] = int_stack + 236840;
 Libint->vrr_classes[12][11] = int_stack + 242846;
 Libint->vrr_classes[12][12] = int_stack + 249944;
 Libint->vrr_classes[12][13] = int_stack + 258225;
 Libint->vrr_classes[12][14] = int_stack + 267780;
 Libint->vrr_classes[12][15] = int_stack + 278700;
 Libint->vrr_classes[12][16] = int_stack + 291076;
 Libint->vrr_classes[12][17] = int_stack + 304999;
 Libint->vrr_classes[12][18] = int_stack + 320560;
 Libint->vrr_classes[13][9] = int_stack + 337850;
 Libint->vrr_classes[13][10] = int_stack + 343625;
 Libint->vrr_classes[13][11] = int_stack + 350555;
 Libint->vrr_classes[13][12] = int_stack + 358745;
 Libint->vrr_classes[13][13] = int_stack + 368300;
 Libint->vrr_classes[13][14] = int_stack + 379325;
 Libint->vrr_classes[13][15] = int_stack + 391925;
 Libint->vrr_classes[13][16] = int_stack + 406205;
 Libint->vrr_classes[13][17] = int_stack + 422270;
 Libint->vrr_classes[13][18] = int_stack + 440225;
 Libint->vrr_classes[14][9] = int_stack + 460175;
 Libint->vrr_classes[14][10] = int_stack + 466775;
 Libint->vrr_classes[14][11] = int_stack + 474695;
 Libint->vrr_classes[14][12] = int_stack + 484055;
 Libint->vrr_classes[14][13] = int_stack + 494975;
 Libint->vrr_classes[14][14] = int_stack + 507575;
 Libint->vrr_classes[14][15] = int_stack + 521975;
 Libint->vrr_classes[14][16] = int_stack + 538295;
 Libint->vrr_classes[14][17] = int_stack + 556655;
 Libint->vrr_classes[14][18] = int_stack + 577175;
 Libint->vrr_classes[15][9] = int_stack + 599975;
 Libint->vrr_classes[15][10] = int_stack + 607455;
 Libint->vrr_classes[15][11] = int_stack + 616431;
 Libint->vrr_classes[15][12] = int_stack + 627039;
 Libint->vrr_classes[15][13] = int_stack + 639415;
 Libint->vrr_classes[15][14] = int_stack + 653695;
 Libint->vrr_classes[15][15] = int_stack + 670015;
 Libint->vrr_classes[15][16] = int_stack + 688511;
 Libint->vrr_classes[15][17] = int_stack + 709319;
 Libint->vrr_classes[15][18] = int_stack + 732575;
 Libint->vrr_classes[16][9] = int_stack + 758415;
 Libint->vrr_classes[16][10] = int_stack + 766830;
 Libint->vrr_classes[16][11] = int_stack + 776928;
 Libint->vrr_classes[16][12] = int_stack + 788862;
 Libint->vrr_classes[16][13] = int_stack + 802785;
 Libint->vrr_classes[16][14] = int_stack + 818850;
 Libint->vrr_classes[16][15] = int_stack + 837210;
 Libint->vrr_classes[16][16] = int_stack + 858018;
 Libint->vrr_classes[16][17] = int_stack + 881427;
 Libint->vrr_classes[16][18] = int_stack + 907590;
 Libint->vrr_classes[17][9] = int_stack + 936660;
 Libint->vrr_classes[17][10] = int_stack + 946065;
 Libint->vrr_classes[17][11] = int_stack + 957351;
 Libint->vrr_classes[17][12] = int_stack + 970689;
 Libint->vrr_classes[17][13] = int_stack + 986250;
 Libint->vrr_classes[17][14] = int_stack + 1004205;
 Libint->vrr_classes[17][15] = int_stack + 1024725;
 Libint->vrr_classes[17][16] = int_stack + 1047981;
 Libint->vrr_classes[17][17] = int_stack + 1074144;
 Libint->vrr_classes[17][18] = int_stack + 1103385;
 Libint->vrr_classes[18][9] = int_stack + 1135875;
 Libint->vrr_classes[18][10] = int_stack + 1146325;
 Libint->vrr_classes[18][11] = int_stack + 1158865;
 Libint->vrr_classes[18][12] = int_stack + 1173685;
 Libint->vrr_classes[18][13] = int_stack + 1190975;
 Libint->vrr_classes[18][14] = int_stack + 1210925;
 Libint->vrr_classes[18][15] = int_stack + 1233725;
 Libint->vrr_classes[18][16] = int_stack + 1259565;
 Libint->vrr_classes[18][17] = int_stack + 1288635;
 Libint->vrr_classes[18][18] = int_stack + 1321125;
 memset(int_stack,0,1357225*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1357225;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mmmm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1357225,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1366300,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1377190,int_stack+1366300,int_stack+1357225,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1395340,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1408210,int_stack+1395340,int_stack+1366300,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1429990,int_stack+1408210,int_stack+1377190,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1357225,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1460240,int_stack+1357225,int_stack+1395340,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1485980,int_stack+1460240,int_stack+1408210,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1372240,int_stack+1485980,int_stack+1429990,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1417615,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1522280,int_stack+1417615,int_stack+1357225,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1552310,int_stack+1522280,int_stack+1460240,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1595210,int_stack+1552310,int_stack+1485980,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1434940,int_stack+1595210,int_stack+1372240,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1357225,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1377025,int_stack+1357225,int_stack+1417615,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1649660,int_stack+1377025,int_stack+1522280,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1699710,int_stack+1649660,int_stack+1552310,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1498465,int_stack+1699710,int_stack+1595210,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1764060,int_stack+1498465,int_stack+1434940,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1411675,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1434115,int_stack+1411675,int_stack+1357225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1574695,int_stack+1434115,int_stack+1377025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1848760,int_stack+1574695,int_stack+1649660,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1923835,int_stack+1848760,int_stack+1699710,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1632445,int_stack+1923835,int_stack+1498465,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2013925,int_stack+1632445,int_stack+1764060,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1357225,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1473715,int_stack+1357225,int_stack+1411675,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1734085,int_stack+1473715,int_stack+1434115,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1382470,int_stack+1734085,int_stack+1574695,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1518595,int_stack+1382470,int_stack+1848760,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1800085,int_stack+1518595,int_stack+1923835,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2122825,int_stack+1800085,int_stack+1632445,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2253505,int_stack+2122825,int_stack+2013925,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1623700,int_stack+53625,int_stack+44220,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1651915,int_stack+1623700,int_stack+1357225,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1920205,int_stack+1651915,int_stack+1473715,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1623700,int_stack+1920205,int_stack+1734085,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1920205,int_stack+1623700,int_stack+1382470,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1623700,int_stack+1920205,int_stack+1518595,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1920205,int_stack+1623700,int_stack+1800085,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1357225,int_stack+1920205,int_stack+2122825,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1520575,int_stack+1357225,int_stack+2253505,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1357225,int_stack+67705,int_stack+64075,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1368115,int_stack+72061,int_stack+67705,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1381183,int_stack+1368115,int_stack+1357225,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1402963,int_stack+77209,int_stack+72061,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1418407,int_stack+1402963,int_stack+1368115,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1444543,int_stack+1418407,int_stack+1381183,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1357225,int_stack+83215,int_stack+77209,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1480843,int_stack+1357225,int_stack+1402963,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1686950,int_stack+1480843,int_stack+1418407,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1375243,int_stack+1686950,int_stack+1444543,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1429693,int_stack+90145,int_stack+83215,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1730510,int_stack+1429693,int_stack+1357225,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1766546,int_stack+1730510,int_stack+1480843,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1450483,int_stack+1766546,int_stack+1686950,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1818026,int_stack+1450483,int_stack+1375243,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1686950,int_stack+98065,int_stack+90145,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1357225,int_stack+1686950,int_stack+1429693,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1894256,int_stack+1357225,int_stack+1730510,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1954316,int_stack+1894256,int_stack+1766546,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1710710,int_stack+1954316,int_stack+1450483,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1398805,int_stack+1710710,int_stack+1818026,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1802186,int_stack+107041,int_stack+98065,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1829114,int_stack+1802186,int_stack+1686950,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2031536,int_stack+1829114,int_stack+1357225,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2100836,int_stack+2031536,int_stack+1894256,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2190926,int_stack+2100836,int_stack+1954316,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1876634,int_stack+2190926,int_stack+1710710,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2299034,int_stack+1876634,int_stack+1398805,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1357225,int_stack+117139,int_stack+107041,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1387519,int_stack+1357225,int_stack+1802186,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1441375,int_stack+1387519,int_stack+1829114,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1686950,int_stack+1441375,int_stack+2031536,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2429714,int_stack+1686950,int_stack+2100836,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1998602,int_stack+2429714,int_stack+2190926,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2555840,int_stack+1998602,int_stack+1876634,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1790900,int_stack+2555840,int_stack+2299034,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1954250,int_stack+128425,int_stack+117139,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2142746,int_stack+1954250,int_stack+1357225,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2203334,int_stack+2142746,int_stack+1387519,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2293094,int_stack+2203334,int_stack+1441375,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2142746,int_stack+2293094,int_stack+1686950,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2712656,int_stack+2142746,int_stack+2429714,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2142746,int_stack+2712656,int_stack+1998602,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2328074,int_stack+2142746,int_stack+2555840,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2524094,int_stack+2328074,int_stack+1790900,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1686950,int_stack+2524094,int_stack+1520575,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2723744,int_stack+145255,int_stack+140965,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2736614,int_stack+150403,int_stack+145255,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2752058,int_stack+2736614,int_stack+2723744,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2777798,int_stack+156487,int_stack+150403,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2796050,int_stack+2777798,int_stack+2736614,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2826938,int_stack+2796050,int_stack+2752058,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2723744,int_stack+163585,int_stack+156487,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2186075,int_stack+2723744,int_stack+2777798,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2222579,int_stack+2186075,int_stack+2796050,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2745038,int_stack+2222579,int_stack+2826938,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2809388,int_stack+171775,int_stack+163585,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2833958,int_stack+2809388,int_stack+2723744,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2274059,int_stack+2833958,int_stack+2186075,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2334899,int_stack+2274059,int_stack+2222579,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2412119,int_stack+2334899,int_stack+2745038,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2186075,int_stack+181135,int_stack+171775,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2214155,int_stack+2186075,int_stack+2809388,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2723744,int_stack+2214155,int_stack+2833958,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1357225,int_stack+2723744,int_stack+2274059,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1448485,int_stack+1357225,int_stack+2334899,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2263295,int_stack+1448485,int_stack+2412119,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2383415,int_stack+191743,int_stack+181135,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2415239,int_stack+2383415,int_stack+2186075,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2794724,int_stack+2415239,int_stack+2214155,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1556593,int_stack+2794724,int_stack+2723744,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1556593,int_stack+1357225,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2876624,int_stack+0,int_stack+1448485,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1357225,int_stack+2876624,int_stack+2263295,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1511665,int_stack+203677,int_stack+191743,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2723744,int_stack+1511665,int_stack+2383415,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2186075,int_stack+2723744,int_stack+2415239,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2279675,int_stack+2186075,int_stack+2794724,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3020768,int_stack+2279675,int_stack+1556593,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3169826,int_stack+3020768,int_stack+0,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+3169826,int_stack+2876624,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2787392,int_stack+0,int_stack+1357225,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1357225,int_stack+217015,int_stack+203677,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1397239,int_stack+1357225,int_stack+1511665,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1468843,int_stack+1397239,int_stack+2723744,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3340178,int_stack+1468843,int_stack+2186075,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1357225,int_stack+3340178,int_stack+2279675,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2186075,int_stack+1357225,int_stack+3020768,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1357225,int_stack+2186075,int_stack+3169826,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2186075,int_stack+1357225,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1357225,int_stack+2186075,int_stack+2787392,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2723744,int_stack+1357225,int_stack+2524094,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3322694,int_stack+2723744,int_stack+1686950,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+236840,int_stack+231835,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+242846,int_stack+236840,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+249944,int_stack+242846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+258225,int_stack+249944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1593175,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+1593175,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+267780,int_stack+258225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1653235,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1724215,int_stack+1653235,int_stack+1593175,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1814305,int_stack+1724215,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1593175,int_stack+278700,int_stack+267780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+1593175,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+1653235,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1919410,int_stack+140140,int_stack+1724215,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1625935,int_stack+1919410,int_stack+1814305,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1766075,int_stack+291076,int_stack+278700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1803203,int_stack+1766075,int_stack+1593175,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2045536,int_stack+1803203,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2141086,int_stack+2045536,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2265301,int_stack+2141086,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2265301,int_stack+1919410,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2414359,int_stack+0,int_stack+1625935,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+304999,int_stack+291076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+1766075,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1593175,int_stack+209937,int_stack+1803203,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1702375,int_stack+1593175,int_stack+2045536,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1845700,int_stack+1702375,int_stack+2141086,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2019601,int_stack+1845700,int_stack+2265301,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4320944,int_stack+2019601,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4537160,int_stack+4320944,int_stack+2414359,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+320560,int_stack+304999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+46683,int_stack+0,int_stack+168168,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2218345,int_stack+46683,int_stack+209937,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+2218345,int_stack+1593175,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2218345,int_stack+0,int_stack+1702375,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2218345,int_stack+1845700,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2218345,int_stack+0,int_stack+2019601,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2218345,int_stack+4320944,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1593175,int_stack+0,int_stack+4537160,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1868450,int_stack+1593175,int_stack+1357225,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4320944,int_stack+1868450,int_stack+2723744,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5518844,int_stack+4320944,int_stack+3322694,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1357225,int_stack+343625,int_stack+337850,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1374550,int_stack+350555,int_stack+343625,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1395340,int_stack+1374550,int_stack+1357225,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1429990,int_stack+358745,int_stack+350555,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1454560,int_stack+1429990,int_stack+1374550,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1496140,int_stack+1454560,int_stack+1395340,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1357225,int_stack+368300,int_stack+358745,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+1357225,int_stack+1429990,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+1454560,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1385890,int_stack+49140,int_stack+1496140,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1472515,int_stack+379325,int_stack+368300,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1505590,int_stack+1472515,int_stack+1357225,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+118440,int_stack+1505590,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200340,int_stack+118440,int_stack+49140,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2576300,int_stack+200340,int_stack+1385890,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+391925,int_stack+379325,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+1472515,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1357225,int_stack+37800,int_stack+1505590,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1452775,int_stack+1357225,int_stack+118440,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2697575,int_stack+1452775,int_stack+200340,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+103950,int_stack+2697575,int_stack+2576300,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2576300,int_stack+406205,int_stack+391925,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2619140,int_stack+2576300,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+265650,int_stack+2619140,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2843105,int_stack+265650,int_stack+1357225,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2986430,int_stack+2843105,int_stack+1452775,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1357225,int_stack+2986430,int_stack+2697575,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3158420,int_stack+1357225,int_stack+103950,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+422270,int_stack+406205,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48195,int_stack+0,int_stack+2576300,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+133875,int_stack+48195,int_stack+2619140,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2576300,int_stack+133875,int_stack+265650,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3366320,int_stack+2576300,int_stack+2843105,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2741675,int_stack+3366320,int_stack+2986430,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3566975,int_stack+2741675,int_stack+1357225,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3816455,int_stack+3566975,int_stack+3158420,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1357225,int_stack+440225,int_stack+422270,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1411090,int_stack+1357225,int_stack+0,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2970995,int_stack+1411090,int_stack+48195,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1357225,int_stack+2970995,int_stack+133875,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2970995,int_stack+1357225,int_stack+2576300,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2970995,int_stack+3366320,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2970995,int_stack+0,int_stack+2741675,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2970995,int_stack+3566975,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2576300,int_stack+0,int_stack+3816455,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2893925,int_stack+2576300,int_stack+1593175,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+7182594,int_stack+2893925,int_stack+1868450,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8598294,int_stack+7182594,int_stack+4320944,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+10594794,int_stack+8598294,int_stack+5518844,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+466775,int_stack+460175,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+474695,int_stack+466775,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+484055,int_stack+474695,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+494975,int_stack+484055,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280920,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+280920,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+507575,int_stack+494975,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+360120,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3719750,int_stack+360120,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3813350,int_stack+3719750,int_stack+280920,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169560,int_stack+3813350,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+521975,int_stack+507575,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3932150,int_stack+43200,int_stack+360120,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+308160,int_stack+3932150,int_stack+3719750,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4041350,int_stack+308160,int_stack+3813350,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+3719750,int_stack+4041350,int_stack+169560,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118800,int_stack+538295,int_stack+521975,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+167760,int_stack+118800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4207670,int_stack+167760,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4333670,int_stack+4207670,int_stack+3932150,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4497470,int_stack+4333670,int_stack+308160,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254160,int_stack+4497470,int_stack+4041350,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3904550,int_stack+254160,int_stack+3719750,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3719750,int_stack+556655,int_stack+538295,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3774830,int_stack+3719750,int_stack+118800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+3774830,int_stack+167760,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4694030,int_stack+0,int_stack+4207670,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4883030,int_stack+4694030,int_stack+4333670,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4142150,int_stack+4883030,int_stack+4497470,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4404230,int_stack+4142150,int_stack+254160,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+144000,int_stack+4404230,int_stack+3904550,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3872750,int_stack+577175,int_stack+556655,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3934310,int_stack+3872750,int_stack+3719750,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+5112350,int_stack+3934310,int_stack+3774830,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3719750,int_stack+5112350,int_stack+0,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5112350,int_stack+3719750,int_stack+4694030,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3719750,int_stack+5112350,int_stack+4883030,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4689350,int_stack+3719750,int_stack+4142150,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3719750,int_stack+4689350,int_stack+4404230,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+4076150,int_stack+3719750,int_stack+144000,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+4439150,int_stack+4076150,int_stack+2576300,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+5392025,int_stack+4439150,int_stack+2893925,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+1357225,int_stack+5392025,int_stack+7182594,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+13090419,int_stack+1357225,int_stack+8598294,3025);
 /*--- compute (mh|mm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+7043675,int_stack+13090419,int_stack+10594794,3025);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10537550,int_stack+607455,int_stack+599975,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10559990,int_stack+616431,int_stack+607455,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10586918,int_stack+10559990,int_stack+10537550,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10631798,int_stack+627039,int_stack+616431,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10663622,int_stack+10631798,int_stack+10559990,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+10717478,int_stack+10663622,int_stack+10586918,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+10537550,int_stack+639415,int_stack+627039,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+10792278,int_stack+10537550,int_stack+10631798,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10855926,int_stack+10792278,int_stack+10663622,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+10574678,int_stack+10855926,int_stack+10717478,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+10686878,int_stack+653695,int_stack+639415,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+10945686,int_stack+10686878,int_stack+10537550,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+11019942,int_stack+10945686,int_stack+10792278,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+11126022,int_stack+11019942,int_stack+10855926,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+10729718,int_stack+11126022,int_stack+10574678,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+10537550,int_stack+670015,int_stack+653695,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10586510,int_stack+10537550,int_stack+10686878,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+11260662,int_stack+10586510,int_stack+10945686,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+11384422,int_stack+11260662,int_stack+11019942,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+10886798,int_stack+11384422,int_stack+11126022,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+11543542,int_stack+10886798,int_stack+10729718,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+10672190,int_stack+688511,int_stack+670015,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+10727678,int_stack+10672190,int_stack+10537550,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+11075294,int_stack+10727678,int_stack+10586510,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+11752982,int_stack+11075294,int_stack+11260662,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+11938622,int_stack+11752982,int_stack+11384422,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+11218094,int_stack+11938622,int_stack+10886798,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+12161390,int_stack+11218094,int_stack+11543542,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+10537550,int_stack+709319,int_stack+688511,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+10825598,int_stack+10537550,int_stack+10672190,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+11469422,int_stack+10825598,int_stack+10727678,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+10599974,int_stack+11469422,int_stack+11075294,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+10936574,int_stack+10599974,int_stack+11752982,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+11632622,int_stack+10936574,int_stack+11938622,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+12430670,int_stack+11632622,int_stack+11218094,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+12753806,int_stack+12430670,int_stack+12161390,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+11196470,int_stack+732575,int_stack+709319,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+11266238,int_stack+11196470,int_stack+10537550,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+11929646,int_stack+11266238,int_stack+10825598,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+11196470,int_stack+11929646,int_stack+11469422,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+11929646,int_stack+11196470,int_stack+10599974,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+11196470,int_stack+11929646,int_stack+10936574,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+11929646,int_stack+11196470,int_stack+11632622,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10537550,int_stack+11929646,int_stack+12430670,136);
 /*--- compute (u0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+10941470,int_stack+10537550,int_stack+12753806,136);
 /*--- compute (tp|mm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+11352870,int_stack+10941470,int_stack+4076150,3025);
 /*--- compute (rd|mm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+16085169,int_stack+11352870,int_stack+4439150,3025);
 /*--- compute (qf|mm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+17990919,int_stack+16085169,int_stack+5392025,3025);
 /*--- compute (og|mm) ---*/
 hrr1_build_og(Libint->AB,int_stack+20743669,int_stack+17990919,int_stack+1357225,3025);
 /*--- compute (nh|mm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+1357225,int_stack+20743669,int_stack+13090419,3025);
 /*--- compute (mi|mm) ---*/
 hrr1_build_mi(Libint->AB,int_stack+24282919,int_stack+1357225,int_stack+7043675,3025);
 /*--- compute (v0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5549875,int_stack+766830,int_stack+758415,153);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5575120,int_stack+776928,int_stack+766830,153);
 /*--- compute (v0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5605414,int_stack+5575120,int_stack+5549875,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5655904,int_stack+788862,int_stack+776928,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5691706,int_stack+5655904,int_stack+5575120,153);
 /*--- compute (v0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5752294,int_stack+5691706,int_stack+5605414,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5549875,int_stack+802785,int_stack+788862,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5836444,int_stack+5549875,int_stack+5655904,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5908048,int_stack+5836444,int_stack+5691706,153);
 /*--- compute (v0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+5591644,int_stack+5908048,int_stack+5752294,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5717869,int_stack+818850,int_stack+802785,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6009028,int_stack+5717869,int_stack+5549875,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+6092566,int_stack+6009028,int_stack+5836444,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+6211906,int_stack+6092566,int_stack+5908048,153);
 /*--- compute (v0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+5766064,int_stack+6211906,int_stack+5591644,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5549875,int_stack+837210,int_stack+818850,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5604955,int_stack+5549875,int_stack+5717869,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+6363376,int_stack+5604955,int_stack+6009028,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+6502606,int_stack+6363376,int_stack+6092566,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5942779,int_stack+6502606,int_stack+6211906,153);
 /*--- compute (v0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+6681616,int_stack+5942779,int_stack+5766064,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5701345,int_stack+858018,int_stack+837210,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5763769,int_stack+5701345,int_stack+5549875,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+6154837,int_stack+5763769,int_stack+5604955,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+6917236,int_stack+6154837,int_stack+6363376,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+7126081,int_stack+6917236,int_stack+6502606,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+6315487,int_stack+7126081,int_stack+5942779,153);
 /*--- compute (v0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+7376695,int_stack+6315487,int_stack+6681616,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+5549875,int_stack+881427,int_stack+858018,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+5873929,int_stack+5549875,int_stack+5701345,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+6598231,int_stack+5873929,int_stack+5763769,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5620102,int_stack+6598231,int_stack+6154837,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5998777,int_stack+5620102,int_stack+6917236,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+6781831,int_stack+5998777,int_stack+7126081,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+7679635,int_stack+6781831,int_stack+6315487,153);
 /*--- compute (v0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+8043163,int_stack+7679635,int_stack+7376695,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+6291160,int_stack+907590,int_stack+881427,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+6369649,int_stack+6291160,int_stack+5549875,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+7115983,int_stack+6369649,int_stack+5873929,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+6291160,int_stack+7115983,int_stack+6598231,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+7115983,int_stack+6291160,int_stack+5620102,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6291160,int_stack+7115983,int_stack+5998777,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+7115983,int_stack+6291160,int_stack+6781831,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5549875,int_stack+7115983,int_stack+7679635,153);
 /*--- compute (v0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+6004285,int_stack+5549875,int_stack+8043163,153);
 /*--- compute (up|mm) ---*/
 hrr1_build_up(Libint->AB,int_stack+6467110,int_stack+6004285,int_stack+10941470,3025);
 /*--- compute (td|mm) ---*/
 hrr1_build_td(Libint->AB,int_stack+7701310,int_stack+6467110,int_stack+11352870,3025);
 /*--- compute (rf|mm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+9879310,int_stack+7701310,int_stack+16085169,3025);
 /*--- compute (qg|mm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+13055560,int_stack+9879310,int_stack+17990919,3025);
 /*--- compute (oh|mm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+28941419,int_stack+13055560,int_stack+20743669,3025);
 /*--- compute (ni|mm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+17184685,int_stack+28941419,int_stack+1357225,3025);
 /*--- compute (mk|mm) ---*/
 hrr1_build_mk(Libint->AB,int_stack+33896369,int_stack+17184685,int_stack+24282919,3025);
 /*--- compute (w0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1357225,int_stack+946065,int_stack+936660,171);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1385440,int_stack+957351,int_stack+946065,171);
 /*--- compute (w0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1419298,int_stack+1385440,int_stack+1357225,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1475728,int_stack+970689,int_stack+957351,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1515742,int_stack+1475728,int_stack+1385440,171);
 /*--- compute (w0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1583458,int_stack+1515742,int_stack+1419298,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1357225,int_stack+986250,int_stack+970689,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1677508,int_stack+1357225,int_stack+1475728,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1757536,int_stack+1677508,int_stack+1515742,171);
 /*--- compute (w0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1403908,int_stack+1757536,int_stack+1583458,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1544983,int_stack+1004205,int_stack+986250,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1870396,int_stack+1544983,int_stack+1357225,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1963762,int_stack+1870396,int_stack+1677508,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2097142,int_stack+1963762,int_stack+1757536,171);
 /*--- compute (w0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1598848,int_stack+2097142,int_stack+1403908,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1357225,int_stack+1024725,int_stack+1004205,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1418785,int_stack+1357225,int_stack+1544983,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2266432,int_stack+1418785,int_stack+1870396,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2422042,int_stack+2266432,int_stack+1963762,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1796353,int_stack+2422042,int_stack+2097142,171);
 /*--- compute (w0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2622112,int_stack+1796353,int_stack+1598848,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1526515,int_stack+1047981,int_stack+1024725,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1596283,int_stack+1526515,int_stack+1357225,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2033359,int_stack+1596283,int_stack+1418785,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2885452,int_stack+2033359,int_stack+2266432,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3118867,int_stack+2885452,int_stack+2422042,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2212909,int_stack+3118867,int_stack+1796353,171);
 /*--- compute (w0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3398965,int_stack+2212909,int_stack+2622112,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1357225,int_stack+1074144,int_stack+1047981,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1719403,int_stack+1357225,int_stack+1526515,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2528917,int_stack+1719403,int_stack+1596283,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1435714,int_stack+2528917,int_stack+2033359,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1858939,int_stack+1435714,int_stack+2885452,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2734117,int_stack+1858939,int_stack+3118867,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3737545,int_stack+2734117,int_stack+2212909,171);
 /*--- compute (w0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4143841,int_stack+3737545,int_stack+3398965,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2185720,int_stack+1103385,int_stack+1074144,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2273443,int_stack+2185720,int_stack+1357225,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3107581,int_stack+2273443,int_stack+1719403,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2185720,int_stack+3107581,int_stack+2528917,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3107581,int_stack+2185720,int_stack+1435714,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2185720,int_stack+3107581,int_stack+1858939,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3107581,int_stack+2185720,int_stack+2734117,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1357225,int_stack+3107581,int_stack+3737545,171);
 /*--- compute (w0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1865095,int_stack+1357225,int_stack+4143841,171);
 /*--- compute (vp|mm) ---*/
 hrr1_build_vp(Libint->AB,int_stack+2382370,int_stack+1865095,int_stack+6004285,3025);
 /*--- compute (ud|mm) ---*/
 hrr1_build_ud(Libint->AB,int_stack+3770845,int_stack+2382370,int_stack+6467110,3025);
 /*--- compute (tf|mm) ---*/
 hrr1_build_tf(Libint->AB,int_stack+22774885,int_stack+3770845,int_stack+7701310,3025);
 /*--- compute (rg|mm) ---*/
 hrr1_build_rg(Libint->AB,int_stack+39885869,int_stack+22774885,int_stack+9879310,3025);
 /*--- compute (qh|mm) ---*/
 hrr1_build_qh(Libint->AB,int_stack+6239245,int_stack+39885869,int_stack+13055560,3025);
 /*--- compute (oi|mm) ---*/
 hrr1_build_oi(Libint->AB,int_stack+44650244,int_stack+6239245,int_stack+28941419,3025);
 /*--- compute (nk|mm) ---*/
 hrr1_build_nk(Libint->AB,int_stack+26404885,int_stack+44650244,int_stack+17184685,3025);
 /*--- compute (ml|mm) ---*/
 hrr1_build_ml(Libint->AB,int_stack+12020020,int_stack+26404885,int_stack+33896369,3025);
 /*--- compute (x0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1357225,int_stack+1146325,int_stack+1135875,190);
 /*--- compute (x0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1388575,int_stack+1158865,int_stack+1146325,190);
 /*--- compute (x0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1426195,int_stack+1388575,int_stack+1357225,190);
 /*--- compute (x0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1488895,int_stack+1173685,int_stack+1158865,190);
 /*--- compute (x0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1533355,int_stack+1488895,int_stack+1388575,190);
 /*--- compute (x0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1608595,int_stack+1533355,int_stack+1426195,190);
 /*--- compute (x0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1357225,int_stack+1190975,int_stack+1173685,190);
 /*--- compute (x0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1713095,int_stack+1357225,int_stack+1488895,190);
 /*--- compute (x0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+19506895,int_stack+1713095,int_stack+1533355,190);
 /*--- compute (x0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1409095,int_stack+19506895,int_stack+1608595,190);
 /*--- compute (x0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1565845,int_stack+1210925,int_stack+1190975,190);
 /*--- compute (x0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+19632295,int_stack+1565845,int_stack+1357225,190);
 /*--- compute (x0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+19736035,int_stack+19632295,int_stack+1713095,190);
 /*--- compute (x0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1625695,int_stack+19736035,int_stack+19506895,190);
 /*--- compute (x0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+19884235,int_stack+1625695,int_stack+1409095,190);
 /*--- compute (x0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+19506895,int_stack+1233725,int_stack+1210925,190);
 /*--- compute (x0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1357225,int_stack+19506895,int_stack+1565845,190);
 /*--- compute (x0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+20103685,int_stack+1357225,int_stack+19632295,190);
 /*--- compute (x0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+20276585,int_stack+20103685,int_stack+19736035,190);
 /*--- compute (x0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+19575295,int_stack+20276585,int_stack+1625695,190);
 /*--- compute (x0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1476925,int_stack+19575295,int_stack+19884235,190);
 /*--- compute (x0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+19838635,int_stack+1259565,int_stack+1233725,190);
 /*--- compute (x0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+19916155,int_stack+19838635,int_stack+19506895,190);
 /*--- compute (x0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+20498885,int_stack+19916155,int_stack+1357225,190);
 /*--- compute (x0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+20698385,int_stack+20498885,int_stack+20103685,190);
 /*--- compute (x0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+20957735,int_stack+20698385,int_stack+20276585,190);
 /*--- compute (x0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+20052955,int_stack+20957735,int_stack+19575295,190);
 /*--- compute (x0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+21268955,int_stack+20052955,int_stack+1476925,190);
 /*--- compute (x0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1357225,int_stack+1288635,int_stack+1259565,190);
 /*--- compute (x0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1444435,int_stack+1357225,int_stack+19838635,190);
 /*--- compute (x0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1599475,int_stack+1444435,int_stack+19916155,190);
 /*--- compute (x0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+19506895,int_stack+1599475,int_stack+20498885,190);
 /*--- compute (x0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+21645155,int_stack+19506895,int_stack+20698385,190);
 /*--- compute (x0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+20404075,int_stack+21645155,int_stack+20957735,190);
 /*--- compute (x0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+22008245,int_stack+20404075,int_stack+20052955,190);
 /*--- compute (x0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+19806145,int_stack+22008245,int_stack+21268955,190);
 /*--- compute (x0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+20276395,int_stack+1321125,int_stack+1288635,190);
 /*--- compute (x0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+20819035,int_stack+20276395,int_stack+1357225,190);
 /*--- compute (x0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+20993455,int_stack+20819035,int_stack+1444435,190);
 /*--- compute (x0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+21251855,int_stack+20993455,int_stack+1599475,190);
 /*--- compute (x0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+20819035,int_stack+21251855,int_stack+19506895,190);
 /*--- compute (x0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+33592285,int_stack+20819035,int_stack+21645155,190);
 /*--- compute (x0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+20819035,int_stack+33592285,int_stack+20404075,190);
 /*--- compute (x0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+33592285,int_stack+20819035,int_stack+22008245,190);
 /*--- compute (x0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+34156585,int_stack+33592285,int_stack+19806145,190);
 /*--- compute (wp|mm) ---*/
 hrr1_build_wp(Libint->AB,int_stack+34731335,int_stack+34156585,int_stack+1865095,3025);
 /*--- compute (vd|mm) ---*/
 hrr1_build_vd(Libint->AB,int_stack+36283160,int_stack+34731335,int_stack+2382370,3025);
 /*--- compute (uf|mm) ---*/
 hrr1_build_uf(Libint->AB,int_stack+51256844,int_stack+36283160,int_stack+3770845,3025);
 /*--- compute (tg|mm) ---*/
 hrr1_build_tg(Libint->AB,int_stack+33592285,int_stack+51256844,int_stack+22774885,3025);
 /*--- compute (rh|mm) ---*/
 hrr1_build_rh(Libint->AB,int_stack+19506895,int_stack+33592285,int_stack+39885869,3025);
 /*--- compute (qi|mm) ---*/
 hrr1_build_qi(Libint->AB,int_stack+33592285,int_stack+19506895,int_stack+6239245,3025);
 /*--- compute (ok|mm) ---*/
 hrr1_build_ok(Libint->AB,int_stack+0,int_stack+33592285,int_stack+44650244,3025);
 /*--- compute (nl|mm) ---*/
 hrr1_build_nl(Libint->AB,int_stack+33592285,int_stack+0,int_stack+26404885,3025);
 /*--- compute (mm|mm) ---*/
 hrr1_build_mm(Libint->AB,int_stack+0,int_stack+33592285,int_stack+12020020,3025);
 return int_stack+0;}
