/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndmf(Libint_t*, prim_data*);

  /* Computes quartets of (nd|mf) integrals */

REALTYPE *hrr_order_ndmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[11][9] = int_stack + 19140;
 Libint->vrr_classes[11][10] = int_stack + 23430;
 Libint->vrr_classes[11][11] = int_stack + 28578;
 Libint->vrr_classes[11][12] = int_stack + 34662;
 Libint->vrr_classes[12][9] = int_stack + 41760;
 Libint->vrr_classes[12][10] = int_stack + 46765;
 Libint->vrr_classes[12][11] = int_stack + 52771;
 Libint->vrr_classes[12][12] = int_stack + 59869;
 memset(int_stack,0,68150*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 68150;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndmf(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+68150,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+79040,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92108,int_stack+79040,int_stack+68150,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+113888,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+129332,int_stack+113888,int_stack+79040,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+155468,int_stack+129332,int_stack+92108,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+68150,int_stack+23430,int_stack+19140,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+81020,int_stack+28578,int_stack+23430,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96464,int_stack+81020,int_stack+68150,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+122204,int_stack+34662,int_stack+28578,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+122204,int_stack+81020,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+191768,int_stack+0,int_stack+96464,78);
 /*--- compute (np|mf) ---*/
 hrr1_build_np(Libint->AB,int_stack+234668,int_stack+191768,int_stack+155468,550);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+46765,int_stack+41760,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+52771,int_stack+46765,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+68150,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+98180,int_stack+59869,int_stack+52771,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+119474,int_stack+98180,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+119474,int_stack+68150,91);
 /*--- compute (op|mf) ---*/
 hrr1_build_op(Libint->AB,int_stack+50050,int_stack+0,int_stack+191768,550);
 /*--- compute (nd|mf) ---*/
 hrr1_build_nd(Libint->AB,int_stack+343568,int_stack+50050,int_stack+234668,550);
 return int_stack+343568;}
