/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndml(Libint_t*, prim_data*);

  /* Computes quartets of (nd|ml) integrals */

REALTYPE *hrr_order_ndml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[11][9] = int_stack + 64350;
 Libint->vrr_classes[11][10] = int_stack + 68640;
 Libint->vrr_classes[11][11] = int_stack + 73788;
 Libint->vrr_classes[11][12] = int_stack + 79872;
 Libint->vrr_classes[11][13] = int_stack + 86970;
 Libint->vrr_classes[11][14] = int_stack + 95160;
 Libint->vrr_classes[11][15] = int_stack + 104520;
 Libint->vrr_classes[11][16] = int_stack + 115128;
 Libint->vrr_classes[11][17] = int_stack + 127062;
 Libint->vrr_classes[12][9] = int_stack + 140400;
 Libint->vrr_classes[12][10] = int_stack + 145405;
 Libint->vrr_classes[12][11] = int_stack + 151411;
 Libint->vrr_classes[12][12] = int_stack + 158509;
 Libint->vrr_classes[12][13] = int_stack + 166790;
 Libint->vrr_classes[12][14] = int_stack + 176345;
 Libint->vrr_classes[12][15] = int_stack + 187265;
 Libint->vrr_classes[12][16] = int_stack + 199641;
 Libint->vrr_classes[12][17] = int_stack + 213564;
 memset(int_stack,0,229125*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 229125;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndml(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+229125,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+240015,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+253083,int_stack+240015,int_stack+229125,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+274863,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+290307,int_stack+274863,int_stack+240015,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+316443,int_stack+290307,int_stack+253083,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+229125,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+352743,int_stack+229125,int_stack+274863,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+383631,int_stack+352743,int_stack+290307,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+247143,int_stack+383631,int_stack+316443,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+301593,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+427191,int_stack+301593,int_stack+229125,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+463227,int_stack+427191,int_stack+352743,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+514707,int_stack+463227,int_stack+383631,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+322383,int_stack+514707,int_stack+247143,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+229125,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+252885,int_stack+229125,int_stack+301593,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+580047,int_stack+252885,int_stack+427191,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+640107,int_stack+580047,int_stack+463227,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+398613,int_stack+640107,int_stack+514707,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+717327,int_stack+398613,int_stack+322383,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+294465,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+321393,int_stack+294465,int_stack+229125,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+490089,int_stack+321393,int_stack+252885,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+818967,int_stack+490089,int_stack+580047,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+909057,int_stack+818967,int_stack+640107,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+559389,int_stack+909057,int_stack+398613,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1017165,int_stack+559389,int_stack+717327,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+229125,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+368913,int_stack+229125,int_stack+294465,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+229125,int_stack+368913,int_stack+321393,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+308325,int_stack+229125,int_stack+490089,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+412275,int_stack+308325,int_stack+818967,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+229125,int_stack+412275,int_stack+909057,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+373269,int_stack+229125,int_stack+559389,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+530085,int_stack+373269,int_stack+1017165,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+229125,int_stack+68640,int_stack+64350,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+241995,int_stack+73788,int_stack+68640,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+257439,int_stack+241995,int_stack+229125,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+283179,int_stack+79872,int_stack+73788,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+301431,int_stack+283179,int_stack+241995,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+332319,int_stack+301431,int_stack+257439,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+229125,int_stack+86970,int_stack+79872,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+375219,int_stack+229125,int_stack+283179,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+411723,int_stack+375219,int_stack+301431,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+250419,int_stack+411723,int_stack+332319,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+314769,int_stack+95160,int_stack+86970,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+463203,int_stack+314769,int_stack+229125,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+693435,int_stack+463203,int_stack+375219,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+754275,int_stack+693435,int_stack+411723,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+339339,int_stack+754275,int_stack+250419,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+229125,int_stack+104520,int_stack+95160,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+257205,int_stack+229125,int_stack+314769,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+831495,int_stack+257205,int_stack+463203,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+429429,int_stack+831495,int_stack+693435,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+902475,int_stack+429429,int_stack+754275,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+693435,int_stack+902475,int_stack+339339,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+306345,int_stack+115128,int_stack+104520,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+338169,int_stack+306345,int_stack+229125,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1010583,int_stack+338169,int_stack+257205,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1010583,int_stack+831495,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1092483,int_stack+0,int_stack+429429,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1220247,int_stack+1092483,int_stack+902475,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+813555,int_stack+1220247,int_stack+693435,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+693435,int_stack+127062,int_stack+115128,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+729237,int_stack+693435,int_stack+306345,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+229125,int_stack+729237,int_stack+338169,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+322725,int_stack+229125,int_stack+1010583,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1364391,int_stack+322725,int_stack+0,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+229125,int_stack+1364391,int_stack+1092483,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+967995,int_stack+229125,int_stack+1220247,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+229125,int_stack+967995,int_stack+813555,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+693435,int_stack+229125,int_stack+530085,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+422175,int_stack+145405,int_stack+140400,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+437190,int_stack+151411,int_stack+145405,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+455208,int_stack+437190,int_stack+422175,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+485238,int_stack+158509,int_stack+151411,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+506532,int_stack+485238,int_stack+437190,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+542568,int_stack+506532,int_stack+455208,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+422175,int_stack+166790,int_stack+158509,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+592618,int_stack+422175,int_stack+485238,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+592618,int_stack+506532,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+447018,int_stack+0,int_stack+542568,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+522093,int_stack+176345,int_stack+166790,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+635206,int_stack+522093,int_stack+422175,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+60060,int_stack+635206,int_stack+592618,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1183485,int_stack+60060,int_stack+0,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1273575,int_stack+1183485,int_stack+447018,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+187265,int_stack+176345,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+422175,int_stack+0,int_stack+522093,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+479505,int_stack+422175,int_stack+635206,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+562315,int_stack+479505,int_stack+60060,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+32760,int_stack+562315,int_stack+1183485,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1378680,int_stack+32760,int_stack+1273575,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1183485,int_stack+199641,int_stack+187265,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1220613,int_stack+1183485,int_stack+0,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1518820,int_stack+1220613,int_stack+422175,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1614370,int_stack+1518820,int_stack+479505,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1738585,int_stack+1614370,int_stack+562315,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+422175,int_stack+1738585,int_stack+32760,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+422175,int_stack+1378680,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+590343,int_stack+213564,int_stack+199641,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1286133,int_stack+590343,int_stack+1183485,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1360389,int_stack+1286133,int_stack+1220613,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1183485,int_stack+1360389,int_stack+1518820,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1326810,int_stack+1183485,int_stack+1614370,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1500711,int_stack+1326810,int_stack+1738585,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1183485,int_stack+1500711,int_stack+422175,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+422175,int_stack+1183485,int_stack+0,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+1183485,int_stack+422175,int_stack+229125,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1762635,int_stack+1183485,int_stack+693435,2475);
 return int_stack+1762635;}
