/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nfnn(Libint_t*, prim_data*);

  /* Computes quartets of (nf|nn) integrals */

REALTYPE *hrr_order_nfnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[10][20] = int_stack + 87120;
 Libint->vrr_classes[11][10] = int_stack + 102366;
 Libint->vrr_classes[11][11] = int_stack + 107514;
 Libint->vrr_classes[11][12] = int_stack + 113598;
 Libint->vrr_classes[11][13] = int_stack + 120696;
 Libint->vrr_classes[11][14] = int_stack + 128886;
 Libint->vrr_classes[11][15] = int_stack + 138246;
 Libint->vrr_classes[11][16] = int_stack + 148854;
 Libint->vrr_classes[11][17] = int_stack + 160788;
 Libint->vrr_classes[11][18] = int_stack + 174126;
 Libint->vrr_classes[11][19] = int_stack + 188946;
 Libint->vrr_classes[11][20] = int_stack + 205326;
 Libint->vrr_classes[12][10] = int_stack + 223344;
 Libint->vrr_classes[12][11] = int_stack + 229350;
 Libint->vrr_classes[12][12] = int_stack + 236448;
 Libint->vrr_classes[12][13] = int_stack + 244729;
 Libint->vrr_classes[12][14] = int_stack + 254284;
 Libint->vrr_classes[12][15] = int_stack + 265204;
 Libint->vrr_classes[12][16] = int_stack + 277580;
 Libint->vrr_classes[12][17] = int_stack + 291503;
 Libint->vrr_classes[12][18] = int_stack + 307064;
 Libint->vrr_classes[12][19] = int_stack + 324354;
 Libint->vrr_classes[12][20] = int_stack + 343464;
 Libint->vrr_classes[13][10] = int_stack + 364485;
 Libint->vrr_classes[13][11] = int_stack + 371415;
 Libint->vrr_classes[13][12] = int_stack + 379605;
 Libint->vrr_classes[13][13] = int_stack + 389160;
 Libint->vrr_classes[13][14] = int_stack + 400185;
 Libint->vrr_classes[13][15] = int_stack + 412785;
 Libint->vrr_classes[13][16] = int_stack + 427065;
 Libint->vrr_classes[13][17] = int_stack + 443130;
 Libint->vrr_classes[13][18] = int_stack + 461085;
 Libint->vrr_classes[13][19] = int_stack + 481035;
 Libint->vrr_classes[13][20] = int_stack + 503085;
 memset(int_stack,0,527340*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 527340;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nfnn(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+527340,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+540408,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+555852,int_stack+540408,int_stack+527340,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581988,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+600006,int_stack+581988,int_stack+540408,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+630894,int_stack+600006,int_stack+555852,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+527340,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+674454,int_stack+527340,int_stack+581988,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+548130,int_stack+674454,int_stack+600006,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+710490,int_stack+548130,int_stack+630894,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+599610,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+623370,int_stack+599610,int_stack+527340,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+775830,int_stack+623370,int_stack+674454,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+835890,int_stack+775830,int_stack+548130,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+913110,int_stack+835890,int_stack+710490,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+527340,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+664950,int_stack+527340,int_stack+599610,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1004586,int_stack+664950,int_stack+623370,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+554268,int_stack+1004586,int_stack+775830,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+712470,int_stack+554268,int_stack+835890,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1073886,int_stack+712470,int_stack+913110,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+820578,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+850872,int_stack+820578,int_stack+527340,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+904728,int_stack+850872,int_stack+664950,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1195854,int_stack+904728,int_stack+1004586,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1299804,int_stack+1195854,int_stack+554268,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+527340,int_stack+1299804,int_stack+712470,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1425930,int_stack+527340,int_stack+1073886,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+671484,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+705342,int_stack+671484,int_stack+820578,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+983928,int_stack+705342,int_stack+850872,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+765930,int_stack+983928,int_stack+904728,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1582746,int_stack+765930,int_stack+1195854,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1073688,int_stack+1582746,int_stack+1299804,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1728276,int_stack+1073688,int_stack+527340,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1913604,int_stack+1728276,int_stack+1425930,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+527340,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+564960,int_stack+527340,int_stack+671484,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1241856,int_stack+564960,int_stack+705342,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1342836,int_stack+1241856,int_stack+983928,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+884730,int_stack+1342836,int_stack+765930,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+632676,int_stack+884730,int_stack+1582746,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1477476,int_stack+632676,int_stack+1073688,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2109624,int_stack+1477476,int_stack+1728276,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2341284,int_stack+2109624,int_stack+1913604,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+826716,int_stack+87120,int_stack+73260,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1051050,int_stack+826716,int_stack+527340,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1126290,int_stack+1051050,int_stack+564960,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1693692,int_stack+1126290,int_stack+1241856,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1051050,int_stack+1693692,int_stack+1342836,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1693692,int_stack+1051050,int_stack+884730,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+826716,int_stack+1693692,int_stack+632676,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1693692,int_stack+826716,int_stack+1477476,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+527340,int_stack+1693692,int_stack+2109624,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+810480,int_stack+527340,int_stack+2341284,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+527340,int_stack+107514,int_stack+102366,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+542784,int_stack+113598,int_stack+107514,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+561036,int_stack+542784,int_stack+527340,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+591924,int_stack+120696,int_stack+113598,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+613218,int_stack+591924,int_stack+542784,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+649722,int_stack+613218,int_stack+561036,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+527340,int_stack+128886,int_stack+120696,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+701202,int_stack+527340,int_stack+591924,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+551910,int_stack+701202,int_stack+613218,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1097976,int_stack+551910,int_stack+649722,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+612750,int_stack+138246,int_stack+128886,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+640830,int_stack+612750,int_stack+527340,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1175196,int_stack+640830,int_stack+701202,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+689970,int_stack+1175196,int_stack+551910,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1246176,int_stack+689970,int_stack+1097976,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1097976,int_stack+148854,int_stack+138246,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+527340,int_stack+1097976,int_stack+612750,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1354284,int_stack+527340,int_stack+640830,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+583500,int_stack+1354284,int_stack+1175196,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1436184,int_stack+583500,int_stack+689970,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1563948,int_stack+1436184,int_stack+1246176,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+689970,int_stack+160788,int_stack+148854,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+725772,int_stack+689970,int_stack+1097976,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1097976,int_stack+725772,int_stack+527340,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1191576,int_stack+1097976,int_stack+1354284,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1708092,int_stack+1191576,int_stack+583500,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1857150,int_stack+1708092,int_stack+1436184,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1314426,int_stack+1857150,int_stack+1563948,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+527340,int_stack+174126,int_stack+160788,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+567354,int_stack+527340,int_stack+689970,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1499754,int_stack+567354,int_stack+725772,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+638958,int_stack+1499754,int_stack+1097976,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2027502,int_stack+638958,int_stack+1191576,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1097976,int_stack+2027502,int_stack+1708092,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1605834,int_stack+1097976,int_stack+1857150,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2199492,int_stack+1605834,int_stack+1314426,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1296720,int_stack+188946,int_stack+174126,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1341180,int_stack+1296720,int_stack+527340,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1824858,int_stack+1341180,int_stack+567354,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1824858,int_stack+1499754,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2431152,int_stack+0,int_stack+638958,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+527340,int_stack+2431152,int_stack+2027502,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2627712,int_stack+527340,int_stack+1097976,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2883240,int_stack+2627712,int_stack+1605834,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1421208,int_stack+2883240,int_stack+2199492,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1097976,int_stack+205326,int_stack+188946,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1147116,int_stack+1097976,int_stack+1296720,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1944198,int_stack+1147116,int_stack+1341180,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1097976,int_stack+1944198,int_stack+1824858,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1704348,int_stack+1097976,int_stack+0,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1097976,int_stack+1704348,int_stack+2431152,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1704348,int_stack+1097976,int_stack+527340,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1097976,int_stack+1704348,int_stack+2627712,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1704348,int_stack+1097976,int_stack+2883240,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2038968,int_stack+1704348,int_stack+1421208,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+1097976,int_stack+2038968,int_stack+810480,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1960464,int_stack+229350,int_stack+223344,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1978482,int_stack+236448,int_stack+229350,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1999776,int_stack+1978482,int_stack+1960464,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2378736,int_stack+244729,int_stack+236448,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2403579,int_stack+2378736,int_stack+1978482,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2446167,int_stack+2403579,int_stack+1999776,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1960464,int_stack+254284,int_stack+244729,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1989129,int_stack+1960464,int_stack+2378736,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2506227,int_stack+1989129,int_stack+2403579,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2577207,int_stack+2506227,int_stack+2446167,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2378736,int_stack+265204,int_stack+254284,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2411496,int_stack+2378736,int_stack+1960464,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2667297,int_stack+2411496,int_stack+1989129,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2750107,int_stack+2667297,int_stack+2506227,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2856577,int_stack+2750107,int_stack+2577207,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1960464,int_stack+277580,int_stack+265204,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2468826,int_stack+1960464,int_stack+2378736,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2534346,int_stack+2468826,int_stack+2411496,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2982703,int_stack+2534346,int_stack+2667297,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+527340,int_stack+2982703,int_stack+2750107,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2629896,int_stack+527340,int_stack+2856577,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2378736,int_stack+291503,int_stack+277580,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2798064,int_stack+2378736,int_stack+1960464,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2872320,int_stack+2798064,int_stack+2468826,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+676398,int_stack+2872320,int_stack+2534346,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2420505,int_stack+676398,int_stack+2982703,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+819723,int_stack+2420505,int_stack+527340,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+819723,int_stack+2629896,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+527340,int_stack+307064,int_stack+291503,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+574023,int_stack+527340,int_stack+2378736,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2594406,int_stack+574023,int_stack+2798064,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2981520,int_stack+2594406,int_stack+2872320,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2718166,int_stack+2981520,int_stack+676398,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3145320,int_stack+2718166,int_stack+2420505,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3377188,int_stack+3145320,int_stack+819723,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+657561,int_stack+3377188,int_stack+0,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+324354,int_stack+307064,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+51870,int_stack+0,int_stack+527340,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+145236,int_stack+51870,int_stack+574023,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2378736,int_stack+145236,int_stack+2594406,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3632716,int_stack+2378736,int_stack+2981520,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3862036,int_stack+3632716,int_stack+2718166,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2564376,int_stack+3862036,int_stack+3145320,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2862492,int_stack+2564376,int_stack+3377188,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3181902,int_stack+2862492,int_stack+657561,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+527340,int_stack+343464,int_stack+324354,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+584670,int_stack+527340,int_stack+0,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+688410,int_stack+584670,int_stack+51870,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+844020,int_stack+688410,int_stack+145236,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+844020,int_stack+2378736,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+527340,int_stack+0,int_stack+3632716,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+527340,int_stack+3862036,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+527340,int_stack+0,int_stack+2564376,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2378736,int_stack+527340,int_stack+2862492,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+527340,int_stack+2378736,int_stack+3181902,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+2378736,int_stack+527340,int_stack+2038968,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3398040,int_stack+2378736,int_stack+1097976,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+923736,int_stack+371415,int_stack+364485,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+944526,int_stack+379605,int_stack+371415,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+969096,int_stack+944526,int_stack+923736,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1010676,int_stack+389160,int_stack+379605,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1039341,int_stack+1010676,int_stack+944526,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1088481,int_stack+1039341,int_stack+969096,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+923736,int_stack+400185,int_stack+389160,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1157781,int_stack+923736,int_stack+1010676,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+956811,int_stack+1157781,int_stack+1039341,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1215111,int_stack+956811,int_stack+1088481,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1038711,int_stack+412785,int_stack+400185,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1076511,int_stack+1038711,int_stack+923736,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1319061,int_stack+1076511,int_stack+1157781,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1414611,int_stack+1319061,int_stack+956811,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1537461,int_stack+1414611,int_stack+1215111,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+923736,int_stack+427065,int_stack+412785,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1142661,int_stack+923736,int_stack+1038711,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1682991,int_stack+1142661,int_stack+1076511,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+966576,int_stack+1682991,int_stack+1319061,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1218261,int_stack+966576,int_stack+1414611,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1793241,int_stack+1218261,int_stack+1537461,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1390251,int_stack+443130,int_stack+427065,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1438446,int_stack+1390251,int_stack+923736,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1524126,int_stack+1438446,int_stack+1142661,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1987281,int_stack+1524126,int_stack+1682991,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2152656,int_stack+1987281,int_stack+966576,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+923736,int_stack+2152656,int_stack+1218261,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+923736,int_stack+1793241,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1153056,int_stack+461085,int_stack+443130,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1206921,int_stack+1153056,int_stack+1390251,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1650126,int_stack+1206921,int_stack+1438446,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1303311,int_stack+1650126,int_stack+1524126,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5123016,int_stack+1303311,int_stack+1987281,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1792926,int_stack+5123016,int_stack+2152656,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2060466,int_stack+1792926,int_stack+923736,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5354541,int_stack+2060466,int_stack+0,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+481035,int_stack+461085,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+59850,int_stack+0,int_stack+1153056,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+167580,int_stack+59850,int_stack+1206921,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+923736,int_stack+167580,int_stack+1650126,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1492311,int_stack+923736,int_stack+1303311,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1137936,int_stack+1492311,int_stack+5123016,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+5666391,int_stack+1137936,int_stack+1792926,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+6010371,int_stack+5666391,int_stack+2060466,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1756911,int_stack+6010371,int_stack+5354541,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5123016,int_stack+503085,int_stack+481035,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5189166,int_stack+5123016,int_stack+0,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+5308866,int_stack+5189166,int_stack+59850,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+6378921,int_stack+5308866,int_stack+167580,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+6378921,int_stack+923736,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+5123016,int_stack+0,int_stack+1492311,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+5123016,int_stack+1137936,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+5123016,int_stack+0,int_stack+5666391,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+5123016,int_stack+6010371,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+5123016,int_stack+0,int_stack+1756911,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+923736,int_stack+5123016,int_stack+527340,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+5123016,int_stack+923736,int_stack+2378736,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+5123016,int_stack+3398040,4356);
 return int_stack+0;}
