/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngmi(Libint_t*, prim_data*);

  /* Computes quartets of (ng|mi) integrals */

REALTYPE *hrr_order_ngmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[11][9] = int_stack + 42966;
 Libint->vrr_classes[11][10] = int_stack + 47256;
 Libint->vrr_classes[11][11] = int_stack + 52404;
 Libint->vrr_classes[11][12] = int_stack + 58488;
 Libint->vrr_classes[11][13] = int_stack + 65586;
 Libint->vrr_classes[11][14] = int_stack + 73776;
 Libint->vrr_classes[11][15] = int_stack + 83136;
 Libint->vrr_classes[12][9] = int_stack + 93744;
 Libint->vrr_classes[12][10] = int_stack + 98749;
 Libint->vrr_classes[12][11] = int_stack + 104755;
 Libint->vrr_classes[12][12] = int_stack + 111853;
 Libint->vrr_classes[12][13] = int_stack + 120134;
 Libint->vrr_classes[12][14] = int_stack + 129689;
 Libint->vrr_classes[12][15] = int_stack + 140609;
 Libint->vrr_classes[13][9] = int_stack + 152985;
 Libint->vrr_classes[13][10] = int_stack + 158760;
 Libint->vrr_classes[13][11] = int_stack + 165690;
 Libint->vrr_classes[13][12] = int_stack + 173880;
 Libint->vrr_classes[13][13] = int_stack + 183435;
 Libint->vrr_classes[13][14] = int_stack + 194460;
 Libint->vrr_classes[13][15] = int_stack + 207060;
 Libint->vrr_classes[14][9] = int_stack + 221340;
 Libint->vrr_classes[14][10] = int_stack + 227940;
 Libint->vrr_classes[14][11] = int_stack + 235860;
 Libint->vrr_classes[14][12] = int_stack + 245220;
 Libint->vrr_classes[14][13] = int_stack + 256140;
 Libint->vrr_classes[14][14] = int_stack + 268740;
 Libint->vrr_classes[14][15] = int_stack + 283140;
 memset(int_stack,0,299460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 299460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngmi(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+299460,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+310350,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+323418,int_stack+310350,int_stack+299460,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+345198,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+360642,int_stack+345198,int_stack+310350,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+386778,int_stack+360642,int_stack+323418,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+299460,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+423078,int_stack+299460,int_stack+345198,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+453966,int_stack+423078,int_stack+360642,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+317478,int_stack+453966,int_stack+386778,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+371928,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+497526,int_stack+371928,int_stack+299460,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+533562,int_stack+497526,int_stack+423078,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+585042,int_stack+533562,int_stack+453966,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+392718,int_stack+585042,int_stack+317478,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+299460,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+323220,int_stack+299460,int_stack+371928,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+650382,int_stack+323220,int_stack+497526,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+299460,int_stack+650382,int_stack+533562,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+468948,int_stack+299460,int_stack+585042,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+560424,int_stack+468948,int_stack+392718,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+299460,int_stack+47256,int_stack+42966,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+312330,int_stack+52404,int_stack+47256,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+327774,int_stack+312330,int_stack+299460,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+353514,int_stack+58488,int_stack+52404,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+371766,int_stack+353514,int_stack+312330,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+402654,int_stack+371766,int_stack+327774,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+299460,int_stack+65586,int_stack+58488,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+445554,int_stack+299460,int_stack+353514,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+482058,int_stack+445554,int_stack+371766,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+320754,int_stack+482058,int_stack+402654,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+385104,int_stack+73776,int_stack+65586,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+662064,int_stack+385104,int_stack+299460,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+662064,int_stack+445554,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+704652,int_stack+0,int_stack+482058,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+409674,int_stack+704652,int_stack+320754,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+299460,int_stack+83136,int_stack+73776,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+327540,int_stack+299460,int_stack+385104,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+781872,int_stack+327540,int_stack+662064,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+299460,int_stack+781872,int_stack+0,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+781872,int_stack+299460,int_stack+704652,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+889980,int_stack+781872,int_stack+409674,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+1010100,int_stack+889980,int_stack+560424,1540);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+299460,int_stack+98749,int_stack+93744,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+314475,int_stack+104755,int_stack+98749,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+332493,int_stack+314475,int_stack+299460,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+362523,int_stack+111853,int_stack+104755,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+383817,int_stack+362523,int_stack+314475,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+419853,int_stack+383817,int_stack+332493,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+299460,int_stack+120134,int_stack+111853,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+469903,int_stack+299460,int_stack+362523,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+512491,int_stack+469903,int_stack+383817,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+324303,int_stack+512491,int_stack+419853,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+399378,int_stack+129689,int_stack+120134,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+572551,int_stack+399378,int_stack+299460,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+622237,int_stack+572551,int_stack+469903,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+693217,int_stack+622237,int_stack+512491,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+428043,int_stack+693217,int_stack+324303,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+299460,int_stack+140609,int_stack+129689,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+332220,int_stack+299460,int_stack+399378,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+783307,int_stack+332220,int_stack+572551,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+299460,int_stack+783307,int_stack+622237,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+533148,int_stack+299460,int_stack+693217,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+659274,int_stack+533148,int_stack+428043,91);
 /*--- compute (op|mi) ---*/
 hrr1_build_op(Libint->AB,int_stack+1315020,int_stack+659274,int_stack+889980,1540);
 /*--- compute (nd|mi) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1675380,int_stack+1315020,int_stack+1010100,1540);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+299460,int_stack+158760,int_stack+152985,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+316785,int_stack+165690,int_stack+158760,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+337575,int_stack+316785,int_stack+299460,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+372225,int_stack+173880,int_stack+165690,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+396795,int_stack+372225,int_stack+316785,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+438375,int_stack+396795,int_stack+337575,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+299460,int_stack+183435,int_stack+173880,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+496125,int_stack+299460,int_stack+372225,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+545265,int_stack+496125,int_stack+396795,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+328125,int_stack+545265,int_stack+438375,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+414750,int_stack+194460,int_stack+183435,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+799414,int_stack+414750,int_stack+299460,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+856744,int_stack+799414,int_stack+496125,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+938644,int_stack+856744,int_stack+545265,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+447825,int_stack+938644,int_stack+328125,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+299460,int_stack+207060,int_stack+194460,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+337260,int_stack+299460,int_stack+414750,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1042594,int_stack+337260,int_stack+799414,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+299460,int_stack+1042594,int_stack+856744,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1042594,int_stack+299460,int_stack+938644,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+799414,int_stack+1042594,int_stack+447825,105);
 /*--- compute (qp|mi) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2285220,int_stack+799414,int_stack+659274,1540);
 /*--- compute (od|mi) ---*/
 hrr1_build_od(Libint->AB,int_stack+2705640,int_stack+2285220,int_stack+1315020,1540);
 /*--- compute (nf|mi) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3426360,int_stack+2705640,int_stack+1675380,1540);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+299460,int_stack+227940,int_stack+221340,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+319260,int_stack+235860,int_stack+227940,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+343020,int_stack+319260,int_stack+299460,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+382620,int_stack+245220,int_stack+235860,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+410700,int_stack+382620,int_stack+319260,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+458220,int_stack+410700,int_stack+343020,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+299460,int_stack+256140,int_stack+245220,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+524220,int_stack+299460,int_stack+382620,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+580380,int_stack+524220,int_stack+410700,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+332220,int_stack+580380,int_stack+458220,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+431220,int_stack+268740,int_stack+256140,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+659580,int_stack+431220,int_stack+299460,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+961114,int_stack+659580,int_stack+524220,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1054714,int_stack+961114,int_stack+580380,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+469020,int_stack+1054714,int_stack+332220,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+299460,int_stack+283140,int_stack+268740,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+342660,int_stack+299460,int_stack+431220,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1173514,int_stack+342660,int_stack+659580,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+607620,int_stack+1173514,int_stack+961114,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1173514,int_stack+607620,int_stack+1054714,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+607620,int_stack+1173514,int_stack+469020,120);
 /*--- compute (rp|mi) ---*/
 hrr1_build_rp(Libint->AB,int_stack+961114,int_stack+607620,int_stack+799414,1540);
 /*--- compute (qd|mi) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+961114,int_stack+2285220,1540);
 /*--- compute (of|mi) ---*/
 hrr1_build_of(Libint->AB,int_stack+840840,int_stack+0,int_stack+2705640,1540);
 /*--- compute (ng|mi) ---*/
 hrr1_build_ng(Libint->AB,int_stack+4442760,int_stack+840840,int_stack+3426360,1540);
 return int_stack+4442760;}
