/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nini(Libint_t*, prim_data*);

  /* Computes quartets of (ni|ni) integrals */

REALTYPE *hrr_order_nini(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[11][10] = int_stack + 49434;
 Libint->vrr_classes[11][11] = int_stack + 54582;
 Libint->vrr_classes[11][12] = int_stack + 60666;
 Libint->vrr_classes[11][13] = int_stack + 67764;
 Libint->vrr_classes[11][14] = int_stack + 75954;
 Libint->vrr_classes[11][15] = int_stack + 85314;
 Libint->vrr_classes[11][16] = int_stack + 95922;
 Libint->vrr_classes[12][10] = int_stack + 107856;
 Libint->vrr_classes[12][11] = int_stack + 113862;
 Libint->vrr_classes[12][12] = int_stack + 120960;
 Libint->vrr_classes[12][13] = int_stack + 129241;
 Libint->vrr_classes[12][14] = int_stack + 138796;
 Libint->vrr_classes[12][15] = int_stack + 149716;
 Libint->vrr_classes[12][16] = int_stack + 162092;
 Libint->vrr_classes[13][10] = int_stack + 176015;
 Libint->vrr_classes[13][11] = int_stack + 182945;
 Libint->vrr_classes[13][12] = int_stack + 191135;
 Libint->vrr_classes[13][13] = int_stack + 200690;
 Libint->vrr_classes[13][14] = int_stack + 211715;
 Libint->vrr_classes[13][15] = int_stack + 224315;
 Libint->vrr_classes[13][16] = int_stack + 238595;
 Libint->vrr_classes[14][10] = int_stack + 254660;
 Libint->vrr_classes[14][11] = int_stack + 262580;
 Libint->vrr_classes[14][12] = int_stack + 271940;
 Libint->vrr_classes[14][13] = int_stack + 282860;
 Libint->vrr_classes[14][14] = int_stack + 295460;
 Libint->vrr_classes[14][15] = int_stack + 309860;
 Libint->vrr_classes[14][16] = int_stack + 326180;
 Libint->vrr_classes[15][10] = int_stack + 344540;
 Libint->vrr_classes[15][11] = int_stack + 353516;
 Libint->vrr_classes[15][12] = int_stack + 364124;
 Libint->vrr_classes[15][13] = int_stack + 376500;
 Libint->vrr_classes[15][14] = int_stack + 390780;
 Libint->vrr_classes[15][15] = int_stack + 407100;
 Libint->vrr_classes[15][16] = int_stack + 425596;
 Libint->vrr_classes[16][10] = int_stack + 446404;
 Libint->vrr_classes[16][11] = int_stack + 456502;
 Libint->vrr_classes[16][12] = int_stack + 468436;
 Libint->vrr_classes[16][13] = int_stack + 482359;
 Libint->vrr_classes[16][14] = int_stack + 498424;
 Libint->vrr_classes[16][15] = int_stack + 516784;
 Libint->vrr_classes[16][16] = int_stack + 537592;
 memset(int_stack,0,561001*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 561001;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nini(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+561001,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+574069,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+589513,int_stack+574069,int_stack+561001,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+615649,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+633667,int_stack+615649,int_stack+574069,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+664555,int_stack+633667,int_stack+589513,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+561001,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+708115,int_stack+561001,int_stack+615649,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+581791,int_stack+708115,int_stack+633667,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+744151,int_stack+581791,int_stack+664555,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+633271,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+657031,int_stack+633271,int_stack+561001,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+809491,int_stack+657031,int_stack+708115,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+869551,int_stack+809491,int_stack+581791,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+946771,int_stack+869551,int_stack+744151,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+561001,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+698611,int_stack+561001,int_stack+633271,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+561001,int_stack+698611,int_stack+657031,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+630301,int_stack+561001,int_stack+809491,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+720391,int_stack+630301,int_stack+869551,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+561001,int_stack+720391,int_stack+946771,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+682969,int_stack+54582,int_stack+49434,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+698413,int_stack+60666,int_stack+54582,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+716665,int_stack+698413,int_stack+682969,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+747553,int_stack+67764,int_stack+60666,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+768847,int_stack+747553,int_stack+698413,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+805351,int_stack+768847,int_stack+716665,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682969,int_stack+75954,int_stack+67764,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+856831,int_stack+682969,int_stack+747553,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+707539,int_stack+856831,int_stack+768847,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+899419,int_stack+707539,int_stack+805351,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+768379,int_stack+85314,int_stack+75954,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+796459,int_stack+768379,int_stack+682969,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+796459,int_stack+856831,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+976639,int_stack+0,int_stack+707539,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1067899,int_stack+976639,int_stack+899419,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+682969,int_stack+95922,int_stack+85314,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+845599,int_stack+682969,int_stack+768379,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+682969,int_stack+845599,int_stack+796459,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+764869,int_stack+682969,int_stack+0,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1176007,int_stack+764869,int_stack+976639,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+682969,int_stack+1176007,int_stack+1067899,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+827113,int_stack+682969,int_stack+561001,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+561001,int_stack+113862,int_stack+107856,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+579019,int_stack+120960,int_stack+113862,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+600313,int_stack+579019,int_stack+561001,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+636349,int_stack+129241,int_stack+120960,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+636349,int_stack+579019,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42588,int_stack+0,int_stack+600313,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+561001,int_stack+138796,int_stack+129241,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1193017,int_stack+561001,int_stack+636349,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+589666,int_stack+1193017,int_stack+0,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1242703,int_stack+589666,int_stack+42588,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+149716,int_stack+138796,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+32760,int_stack+0,int_stack+561001,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1332793,int_stack+32760,int_stack+1193017,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1415603,int_stack+1332793,int_stack+589666,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1522073,int_stack+1415603,int_stack+1242703,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1193017,int_stack+162092,int_stack+149716,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1230145,int_stack+1193017,int_stack+0,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+561001,int_stack+1230145,int_stack+32760,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+561001,int_stack+1332793,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1193017,int_stack+0,int_stack+1415603,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1193017,int_stack+1522073,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1193017,int_stack+0,int_stack+682969,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1625449,int_stack+1193017,int_stack+827113,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+561001,int_stack+182945,int_stack+176015,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+581791,int_stack+191135,int_stack+182945,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+606361,int_stack+581791,int_stack+561001,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+647941,int_stack+200690,int_stack+191135,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+676606,int_stack+647941,int_stack+581791,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+725746,int_stack+676606,int_stack+606361,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+561001,int_stack+211715,int_stack+200690,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+795046,int_stack+561001,int_stack+647941,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+594076,int_stack+795046,int_stack+676606,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+852376,int_stack+594076,int_stack+725746,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+675976,int_stack+224315,int_stack+211715,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+713776,int_stack+675976,int_stack+561001,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+956326,int_stack+713776,int_stack+795046,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1051876,int_stack+956326,int_stack+594076,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2357257,int_stack+1051876,int_stack+852376,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+561001,int_stack+238595,int_stack+224315,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+779926,int_stack+561001,int_stack+675976,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+561001,int_stack+779926,int_stack+713776,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+671251,int_stack+561001,int_stack+956326,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+814576,int_stack+671251,int_stack+1051876,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+561001,int_stack+814576,int_stack+2357257,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2357257,int_stack+561001,int_stack+0,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+2861761,int_stack+2357257,int_stack+1193017,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3726625,int_stack+2861761,int_stack+1625449,1848);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+262580,int_stack+254660,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+271940,int_stack+262580,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+282860,int_stack+271940,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+295460,int_stack+282860,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+755041,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+755041,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+820561,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+309860,int_stack+295460,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+939361,int_stack+174600,int_stack+755041,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1048561,int_stack+939361,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1188961,int_stack+1048561,int_stack+820561,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+755041,int_stack+326180,int_stack+309860,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+804001,int_stack+755041,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+804001,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+755041,int_stack+0,int_stack+939361,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+755041,int_stack+1048561,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+755041,int_stack+0,int_stack+1188961,120);
 /*--- compute (rp|ni) ---*/
 hrr1_build_rp(Libint->AB,int_stack+976801,int_stack+755041,int_stack+561001,1848);
 /*--- compute (qd|ni) ---*/
 hrr1_build_qd(Libint->AB,int_stack+4946305,int_stack+976801,int_stack+2357257,1848);
 /*--- compute (of|ni) ---*/
 hrr1_build_of(Libint->AB,int_stack+5955313,int_stack+4946305,int_stack+2861761,1848);
 /*--- compute (ng|ni) ---*/
 hrr1_build_ng(Libint->AB,int_stack+1558921,int_stack+5955313,int_stack+3726625,1848);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+561001,int_stack+353516,int_stack+344540,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+587929,int_stack+364124,int_stack+353516,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+619753,int_stack+587929,int_stack+561001,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+673609,int_stack+376500,int_stack+364124,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+673609,int_stack+587929,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+63648,int_stack+0,int_stack+619753,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+561001,int_stack+390780,int_stack+376500,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+153408,int_stack+561001,int_stack+673609,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+603841,int_stack+153408,int_stack+0,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+227664,int_stack+603841,int_stack+63648,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+407100,int_stack+390780,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48960,int_stack+0,int_stack+561001,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3388441,int_stack+48960,int_stack+153408,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3512201,int_stack+3388441,int_stack+603841,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+561001,int_stack+3512201,int_stack+227664,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+134640,int_stack+425596,int_stack+407100,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+190128,int_stack+134640,int_stack+0,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+288048,int_stack+190128,int_stack+48960,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+288048,int_stack+3388441,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+185640,int_stack+0,int_stack+3512201,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3388441,int_stack+185640,int_stack+561001,136);
 /*--- compute (tp|ni) ---*/
 hrr1_build_tp(Libint->AB,int_stack+3639769,int_stack+3388441,int_stack+755041,1848);
 /*--- compute (rd|ni) ---*/
 hrr1_build_rd(Libint->AB,int_stack+7396753,int_stack+3639769,int_stack+976801,1848);
 /*--- compute (qf|ni) ---*/
 hrr1_build_qf(Libint->AB,int_stack+8560993,int_stack+7396753,int_stack+4946305,1848);
 /*--- compute (og|ni) ---*/
 hrr1_build_og(Libint->AB,int_stack+10242673,int_stack+8560993,int_stack+5955313,1848);
 /*--- compute (nh|ni) ---*/
 hrr1_build_nh(Libint->AB,int_stack+4305049,int_stack+10242673,int_stack+1558921,1848);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+561001,int_stack+456502,int_stack+446404,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+591295,int_stack+468436,int_stack+456502,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+627097,int_stack+591295,int_stack+561001,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+687685,int_stack+482359,int_stack+468436,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+729454,int_stack+687685,int_stack+591295,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+801058,int_stack+729454,int_stack+627097,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+561001,int_stack+498424,int_stack+482359,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+902038,int_stack+561001,int_stack+687685,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+609196,int_stack+902038,int_stack+729454,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+985576,int_stack+609196,int_stack+801058,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+728536,int_stack+516784,int_stack+498424,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+783616,int_stack+728536,int_stack+561001,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1137046,int_stack+783616,int_stack+902038,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1276276,int_stack+1137046,int_stack+609196,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1455286,int_stack+1276276,int_stack+985576,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+561001,int_stack+537592,int_stack+516784,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+880006,int_stack+561001,int_stack+728536,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1667344,int_stack+880006,int_stack+783616,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1827994,int_stack+1667344,int_stack+1137046,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2036839,int_stack+1827994,int_stack+1276276,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1667344,int_stack+2036839,int_stack+1455286,153);
 /*--- compute (up|ni) ---*/
 hrr1_build_up(Libint->AB,int_stack+1950088,int_stack+1667344,int_stack+3388441,1848);
 /*--- compute (td|ni) ---*/
 hrr1_build_td(Libint->AB,int_stack+0,int_stack+1950088,int_stack+3639769,1848);
 /*--- compute (rf|ni) ---*/
 hrr1_build_rf(Libint->AB,int_stack+1330560,int_stack+0,int_stack+7396753,1848);
 /*--- compute (qg|ni) ---*/
 hrr1_build_qg(Libint->AB,int_stack+12404833,int_stack+1330560,int_stack+8560993,1848);
 /*--- compute (oh|ni) ---*/
 hrr1_build_oh(Libint->AB,int_stack+0,int_stack+12404833,int_stack+10242673,1848);
 /*--- compute (ni|ni) ---*/
 hrr1_build_ni(Libint->AB,int_stack+6866377,int_stack+0,int_stack+4305049,1848);
 return int_stack+6866377;}
