/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npml(Libint_t*, prim_data*);

  /* Computes quartets of (np|ml) integrals */

REALTYPE *hrr_order_npml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[11][9] = int_stack + 64350;
 Libint->vrr_classes[11][10] = int_stack + 68640;
 Libint->vrr_classes[11][11] = int_stack + 73788;
 Libint->vrr_classes[11][12] = int_stack + 79872;
 Libint->vrr_classes[11][13] = int_stack + 86970;
 Libint->vrr_classes[11][14] = int_stack + 95160;
 Libint->vrr_classes[11][15] = int_stack + 104520;
 Libint->vrr_classes[11][16] = int_stack + 115128;
 Libint->vrr_classes[11][17] = int_stack + 127062;
 memset(int_stack,0,140400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 140400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npml(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+140400,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+151290,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+164358,int_stack+151290,int_stack+140400,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+186138,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+201582,int_stack+186138,int_stack+151290,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+227718,int_stack+201582,int_stack+164358,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+140400,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+264018,int_stack+140400,int_stack+186138,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+294906,int_stack+264018,int_stack+201582,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+158418,int_stack+294906,int_stack+227718,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+212868,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+338466,int_stack+212868,int_stack+140400,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+374502,int_stack+338466,int_stack+264018,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+425982,int_stack+374502,int_stack+294906,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+233658,int_stack+425982,int_stack+158418,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+140400,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+164160,int_stack+140400,int_stack+212868,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+491322,int_stack+164160,int_stack+338466,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+551382,int_stack+491322,int_stack+374502,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+309888,int_stack+551382,int_stack+425982,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+628602,int_stack+309888,int_stack+233658,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+205740,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+232668,int_stack+205740,int_stack+140400,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+401364,int_stack+232668,int_stack+164160,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+730242,int_stack+401364,int_stack+491322,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+820332,int_stack+730242,int_stack+551382,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+470664,int_stack+820332,int_stack+309888,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+928440,int_stack+470664,int_stack+628602,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+140400,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+280188,int_stack+140400,int_stack+205740,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+140400,int_stack+280188,int_stack+232668,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+219600,int_stack+140400,int_stack+401364,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+323550,int_stack+219600,int_stack+730242,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+140400,int_stack+323550,int_stack+820332,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+284544,int_stack+140400,int_stack+470664,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+441360,int_stack+284544,int_stack+928440,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+140400,int_stack+68640,int_stack+64350,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+153270,int_stack+73788,int_stack+68640,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+168714,int_stack+153270,int_stack+140400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+194454,int_stack+79872,int_stack+73788,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+212706,int_stack+194454,int_stack+153270,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+243594,int_stack+212706,int_stack+168714,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+140400,int_stack+86970,int_stack+79872,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+286494,int_stack+140400,int_stack+194454,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+322998,int_stack+286494,int_stack+212706,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+161694,int_stack+322998,int_stack+243594,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+226044,int_stack+95160,int_stack+86970,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+374478,int_stack+226044,int_stack+140400,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+604710,int_stack+374478,int_stack+286494,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+665550,int_stack+604710,int_stack+322998,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+250614,int_stack+665550,int_stack+161694,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+140400,int_stack+104520,int_stack+95160,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+168480,int_stack+140400,int_stack+226044,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+742770,int_stack+168480,int_stack+374478,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+340704,int_stack+742770,int_stack+604710,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+813750,int_stack+340704,int_stack+665550,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+604710,int_stack+813750,int_stack+250614,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+217620,int_stack+115128,int_stack+104520,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+249444,int_stack+217620,int_stack+140400,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+921858,int_stack+249444,int_stack+168480,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+921858,int_stack+742770,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1003758,int_stack+0,int_stack+340704,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1131522,int_stack+1003758,int_stack+813750,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+724830,int_stack+1131522,int_stack+604710,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+604710,int_stack+127062,int_stack+115128,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+640512,int_stack+604710,int_stack+217620,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+305604,int_stack+640512,int_stack+249444,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+106470,int_stack+305604,int_stack+921858,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+229320,int_stack+106470,int_stack+0,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+229320,int_stack+1003758,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+170352,int_stack+0,int_stack+1131522,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+879270,int_stack+170352,int_stack+724830,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+1072320,int_stack+879270,int_stack+441360,2475);
 return int_stack+1072320;}
