/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npnh(Libint_t*, prim_data*);

  /* Computes quartets of (np|nh) integrals */

REALTYPE *hrr_order_npnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[11][10] = int_stack + 39336;
 Libint->vrr_classes[11][11] = int_stack + 44484;
 Libint->vrr_classes[11][12] = int_stack + 50568;
 Libint->vrr_classes[11][13] = int_stack + 57666;
 Libint->vrr_classes[11][14] = int_stack + 65856;
 Libint->vrr_classes[11][15] = int_stack + 75216;
 memset(int_stack,0,85824*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 85824;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npnh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85824,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+98892,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+114336,int_stack+98892,int_stack+85824,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+140472,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+158490,int_stack+140472,int_stack+98892,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+189378,int_stack+158490,int_stack+114336,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85824,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+232938,int_stack+85824,int_stack+140472,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+106614,int_stack+232938,int_stack+158490,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+268974,int_stack+106614,int_stack+189378,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+158094,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+181854,int_stack+158094,int_stack+85824,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+334314,int_stack+181854,int_stack+232938,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+158094,int_stack+334314,int_stack+106614,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+334314,int_stack+158094,int_stack+268974,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85824,int_stack+44484,int_stack+39336,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+101268,int_stack+50568,int_stack+44484,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+119520,int_stack+101268,int_stack+85824,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+150408,int_stack+57666,int_stack+50568,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+171702,int_stack+150408,int_stack+101268,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+208206,int_stack+171702,int_stack+119520,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85824,int_stack+65856,int_stack+57666,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+259686,int_stack+85824,int_stack+150408,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+110394,int_stack+259686,int_stack+171702,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+425790,int_stack+110394,int_stack+208206,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+171234,int_stack+75216,int_stack+65856,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+199314,int_stack+171234,int_stack+85824,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+199314,int_stack+259686,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+171234,int_stack+0,int_stack+110394,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+171234,int_stack+425790,78);
 /*--- compute (np|nh) ---*/
 hrr1_build_np(Libint->AB,int_stack+425790,int_stack+0,int_stack+334314,1386);
 return int_stack+425790;}
