/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npni(Libint_t*, prim_data*);

  /* Computes quartets of (np|ni) integrals */

REALTYPE *hrr_order_npni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[11][10] = int_stack + 49434;
 Libint->vrr_classes[11][11] = int_stack + 54582;
 Libint->vrr_classes[11][12] = int_stack + 60666;
 Libint->vrr_classes[11][13] = int_stack + 67764;
 Libint->vrr_classes[11][14] = int_stack + 75954;
 Libint->vrr_classes[11][15] = int_stack + 85314;
 Libint->vrr_classes[11][16] = int_stack + 95922;
 memset(int_stack,0,107856*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 107856;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npni(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107856,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+120924,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+136368,int_stack+120924,int_stack+107856,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+162504,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+180522,int_stack+162504,int_stack+120924,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+211410,int_stack+180522,int_stack+136368,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+107856,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+254970,int_stack+107856,int_stack+162504,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+128646,int_stack+254970,int_stack+180522,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+291006,int_stack+128646,int_stack+211410,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+180126,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+203886,int_stack+180126,int_stack+107856,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+356346,int_stack+203886,int_stack+254970,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+416406,int_stack+356346,int_stack+128646,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+493626,int_stack+416406,int_stack+291006,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+107856,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+245466,int_stack+107856,int_stack+180126,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+107856,int_stack+245466,int_stack+203886,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+177156,int_stack+107856,int_stack+356346,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+267246,int_stack+177156,int_stack+416406,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+107856,int_stack+267246,int_stack+493626,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+229824,int_stack+54582,int_stack+49434,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+245268,int_stack+60666,int_stack+54582,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+263520,int_stack+245268,int_stack+229824,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+294408,int_stack+67764,int_stack+60666,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+315702,int_stack+294408,int_stack+245268,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+352206,int_stack+315702,int_stack+263520,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+229824,int_stack+75954,int_stack+67764,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+403686,int_stack+229824,int_stack+294408,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+254394,int_stack+403686,int_stack+315702,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+446274,int_stack+254394,int_stack+352206,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+315234,int_stack+85314,int_stack+75954,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+343314,int_stack+315234,int_stack+229824,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+343314,int_stack+403686,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+523494,int_stack+0,int_stack+254394,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+614754,int_stack+523494,int_stack+446274,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+229824,int_stack+95922,int_stack+85314,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+392454,int_stack+229824,int_stack+315234,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+229824,int_stack+392454,int_stack+343314,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+311724,int_stack+229824,int_stack+0,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+722862,int_stack+311724,int_stack+523494,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+229824,int_stack+722862,int_stack+614754,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+373968,int_stack+229824,int_stack+107856,1848);
 return int_stack+373968;}
