/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_pplg(Libint_t*, prim_data*);

  /* Computes quartets of (pp|lg) integrals */

REALTYPE *hrr_order_pplg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][8] = int_stack + 0;
 Libint->vrr_classes[1][9] = int_stack + 135;
 Libint->vrr_classes[1][10] = int_stack + 300;
 Libint->vrr_classes[1][11] = int_stack + 498;
 Libint->vrr_classes[1][12] = int_stack + 732;
 Libint->vrr_classes[2][8] = int_stack + 1005;
 Libint->vrr_classes[2][9] = int_stack + 1275;
 Libint->vrr_classes[2][10] = int_stack + 1605;
 Libint->vrr_classes[2][11] = int_stack + 2001;
 Libint->vrr_classes[2][12] = int_stack + 2469;
 memset(int_stack,0,3015*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3015;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_pplg(Libint, Data);
   Data++;
 }
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3015,int_stack+135,int_stack+0,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3420,int_stack+300,int_stack+135,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+3915,int_stack+3420,int_stack+3015,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4725,int_stack+498,int_stack+300,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5319,int_stack+4725,int_stack+3420,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+6309,int_stack+5319,int_stack+3915,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3015,int_stack+732,int_stack+498,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+7659,int_stack+3015,int_stack+4725,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+3015,int_stack+7659,int_stack+5319,3);
 /*--- compute (p0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+7659,int_stack+3015,int_stack+6309,3);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3015,int_stack+1275,int_stack+1005,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3825,int_stack+1605,int_stack+1275,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+4815,int_stack+3825,int_stack+3015,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6435,int_stack+2001,int_stack+1605,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+6435,int_stack+3825,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+9684,int_stack+0,int_stack+4815,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3015,int_stack+2469,int_stack+2001,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12384,int_stack+3015,int_stack+6435,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1980,int_stack+12384,int_stack+0,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+12384,int_stack+1980,int_stack+9684,6);
 /*--- compute (pp|lg) ---*/
 hrr1_build_pp(Libint->AB,int_stack+0,int_stack+12384,int_stack+7659,675);
 return int_stack+0;}
