/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_pplh(Libint_t*, prim_data*);

  /* Computes quartets of (pp|lh) integrals */

REALTYPE *hrr_order_pplh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][8] = int_stack + 0;
 Libint->vrr_classes[1][9] = int_stack + 135;
 Libint->vrr_classes[1][10] = int_stack + 300;
 Libint->vrr_classes[1][11] = int_stack + 498;
 Libint->vrr_classes[1][12] = int_stack + 732;
 Libint->vrr_classes[1][13] = int_stack + 1005;
 Libint->vrr_classes[2][8] = int_stack + 1320;
 Libint->vrr_classes[2][9] = int_stack + 1590;
 Libint->vrr_classes[2][10] = int_stack + 1920;
 Libint->vrr_classes[2][11] = int_stack + 2316;
 Libint->vrr_classes[2][12] = int_stack + 2784;
 Libint->vrr_classes[2][13] = int_stack + 3330;
 memset(int_stack,0,3960*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3960;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_pplh(Libint, Data);
   Data++;
 }
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3960,int_stack+135,int_stack+0,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4365,int_stack+300,int_stack+135,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+4860,int_stack+4365,int_stack+3960,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5670,int_stack+498,int_stack+300,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+6264,int_stack+5670,int_stack+4365,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+7254,int_stack+6264,int_stack+4860,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3960,int_stack+732,int_stack+498,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+8604,int_stack+3960,int_stack+5670,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+9792,int_stack+8604,int_stack+6264,3);
 /*--- compute (p0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+4662,int_stack+9792,int_stack+7254,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+6687,int_stack+1005,int_stack+732,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+11442,int_stack+6687,int_stack+3960,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12846,int_stack+11442,int_stack+8604,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+6687,int_stack+12846,int_stack+9792,3);
 /*--- compute (p0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+9162,int_stack+6687,int_stack+4662,3);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3960,int_stack+1590,int_stack+1320,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4770,int_stack+1920,int_stack+1590,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+5760,int_stack+4770,int_stack+3960,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7380,int_stack+2316,int_stack+1920,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+11997,int_stack+7380,int_stack+4770,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+13977,int_stack+11997,int_stack+5760,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3960,int_stack+2784,int_stack+2316,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+3960,int_stack+7380,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5364,int_stack+0,int_stack+11997,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+16677,int_stack+5364,int_stack+13977,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+11997,int_stack+3330,int_stack+2784,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+13635,int_stack+11997,int_stack+3960,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+20727,int_stack+13635,int_stack+0,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+20727,int_stack+5364,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+20727,int_stack+0,int_stack+16677,6);
 /*--- compute (pp|lh) ---*/
 hrr1_build_pp(Libint->AB,int_stack+0,int_stack+20727,int_stack+9162,945);
 return int_stack+0;}
