/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppmg(Libint_t*, prim_data*);

  /* Computes quartets of (pp|mg) integrals */

REALTYPE *hrr_order_ppmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[1][12] = int_stack + 597;
 Libint->vrr_classes[1][13] = int_stack + 870;
 Libint->vrr_classes[2][9] = int_stack + 1185;
 Libint->vrr_classes[2][10] = int_stack + 1515;
 Libint->vrr_classes[2][11] = int_stack + 1911;
 Libint->vrr_classes[2][12] = int_stack + 2379;
 Libint->vrr_classes[2][13] = int_stack + 2925;
 memset(int_stack,0,3555*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3555;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppmg(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3555,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4050,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+4644,int_stack+4050,int_stack+3555,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5634,int_stack+597,int_stack+363,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6336,int_stack+5634,int_stack+4050,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+7524,int_stack+6336,int_stack+4644,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3555,int_stack+870,int_stack+597,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9174,int_stack+3555,int_stack+5634,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3555,int_stack+9174,int_stack+6336,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+9174,int_stack+3555,int_stack+7524,3);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3555,int_stack+1515,int_stack+1185,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4545,int_stack+1911,int_stack+1515,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5733,int_stack+4545,int_stack+3555,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7713,int_stack+2379,int_stack+1911,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+7713,int_stack+4545,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+11649,int_stack+0,int_stack+5733,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3555,int_stack+2925,int_stack+2379,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+14949,int_stack+3555,int_stack+7713,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2376,int_stack+14949,int_stack+0,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+14949,int_stack+2376,int_stack+11649,6);
 /*--- compute (pp|mg) ---*/
 hrr1_build_pp(Libint->AB,int_stack+0,int_stack+14949,int_stack+9174,825);
 return int_stack+0;}
