/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (hh|mf) integrals */

void vrr_order_hhmf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+12, vrr_stack+3, vrr_stack+9, NULL, NULL, Data->F+10);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+3, NULL, NULL, Data->F+9);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+21, vrr_stack+12, vrr_stack+6, vrr_stack+3, vrr_stack+0);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+3, vrr_stack+9, Data->F+9, Data->F+10, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+6, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+6, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+6);
 _BUILD_00p0(Data,vrr_stack+102, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+105, vrr_stack+9, vrr_stack+102, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+111, vrr_stack+48, vrr_stack+105, NULL, NULL, vrr_stack+9);
 _BUILD_d0d0(Data,vrr_stack+129, vrr_stack+60, vrr_stack+111, vrr_stack+54, vrr_stack+48, vrr_stack+12);
 _BUILD_d0d0(Data,vrr_stack+165, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+201, vrr_stack+165, vrr_stack+129, vrr_stack+84, vrr_stack+60, vrr_stack+30);
 _BUILD_00f0(Data,vrr_stack+12, vrr_stack+54, vrr_stack+48, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00f0(Data,vrr_stack+22, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00f0(Data,vrr_stack+32, vrr_stack+48, vrr_stack+105, vrr_stack+3, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+261, vrr_stack+12, vrr_stack+32, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+291, vrr_stack+22, vrr_stack+12, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+321, vrr_stack+291, vrr_stack+261, vrr_stack+22, vrr_stack+12, vrr_stack+60);
 _BUILD_00p0(Data,vrr_stack+60, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+60, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+63, vrr_stack+3, vrr_stack+78, vrr_stack+60, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+381, vrr_stack+63, vrr_stack+22, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+411, vrr_stack+381, vrr_stack+291, vrr_stack+63, vrr_stack+22, vrr_stack+84);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+42, vrr_stack+102, vrr_stack+0, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+105, vrr_stack+42, vrr_stack+9, vrr_stack+102, NULL);
 _BUILD_p0f0(Data,vrr_stack+471, vrr_stack+32, vrr_stack+84, NULL, NULL, vrr_stack+105);
 _BUILD_d0f0(Data,vrr_stack+501, vrr_stack+261, vrr_stack+471, vrr_stack+12, vrr_stack+32, vrr_stack+111);
 _BUILD_f0f0(Data,vrr_stack+561, vrr_stack+321, vrr_stack+501, vrr_stack+291, vrr_stack+261, vrr_stack+129);
 _BUILD_f0f0(Data,vrr_stack+661, vrr_stack+411, vrr_stack+321, vrr_stack+381, vrr_stack+291, vrr_stack+165);
 _BUILD_g0f0(Data,vrr_stack+761, vrr_stack+661, vrr_stack+561, vrr_stack+411, vrr_stack+321, vrr_stack+201);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+12, vrr_stack+32, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+126, vrr_stack+22, vrr_stack+12, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+141, vrr_stack+126, vrr_stack+111, NULL, NULL, vrr_stack+12);
 _BUILD_00g0(Data,vrr_stack+186, vrr_stack+63, vrr_stack+22, vrr_stack+3, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+201, vrr_stack+186, vrr_stack+126, NULL, NULL, vrr_stack+22);
 _BUILD_00g0(Data,vrr_stack+246, vrr_stack+32, vrr_stack+84, vrr_stack+48, vrr_stack+105, NULL);
 _BUILD_p0g0(Data,vrr_stack+911, vrr_stack+111, vrr_stack+246, NULL, NULL, vrr_stack+32);
 _BUILD_d0g0(Data,vrr_stack+956, vrr_stack+141, vrr_stack+911, vrr_stack+126, vrr_stack+111, vrr_stack+261);
 _BUILD_d0g0(Data,vrr_stack+1046, vrr_stack+201, vrr_stack+141, vrr_stack+186, vrr_stack+126, vrr_stack+291);
 _BUILD_f0g0(Data,vrr_stack+1136, vrr_stack+1046, vrr_stack+956, vrr_stack+201, vrr_stack+141, vrr_stack+321);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+261, vrr_stack+9, vrr_stack+60, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+267, vrr_stack+261, vrr_stack+3, vrr_stack+9, vrr_stack+60, NULL);
 _BUILD_00g0(Data,vrr_stack+48, vrr_stack+267, vrr_stack+63, vrr_stack+261, vrr_stack+3, NULL);
 _BUILD_p0g0(Data,vrr_stack+277, vrr_stack+48, vrr_stack+186, NULL, NULL, vrr_stack+63);
 _BUILD_d0g0(Data,vrr_stack+1286, vrr_stack+277, vrr_stack+201, vrr_stack+48, vrr_stack+186, vrr_stack+381);
 _BUILD_f0g0(Data,vrr_stack+1376, vrr_stack+1286, vrr_stack+1046, vrr_stack+277, vrr_stack+201, vrr_stack+411);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+322, vrr_stack+0, vrr_stack+3, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+328, vrr_stack+42, vrr_stack+322, vrr_stack+102, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+338, vrr_stack+84, vrr_stack+328, vrr_stack+105, vrr_stack+42, NULL);
 _BUILD_p0g0(Data,vrr_stack+353, vrr_stack+246, vrr_stack+338, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+1526, vrr_stack+911, vrr_stack+353, vrr_stack+111, vrr_stack+246, vrr_stack+471);
 _BUILD_f0g0(Data,vrr_stack+1616, vrr_stack+956, vrr_stack+1526, vrr_stack+141, vrr_stack+911, vrr_stack+501);
 _BUILD_g0g0(Data,vrr_stack+1766, vrr_stack+1136, vrr_stack+1616, vrr_stack+1046, vrr_stack+956, vrr_stack+561);
 _BUILD_g0g0(Data,vrr_stack+398, vrr_stack+1376, vrr_stack+1136, vrr_stack+1286, vrr_stack+1046, vrr_stack+661);
 _BUILD_h0g0(Data,vrr_stack+1991, vrr_stack+398, vrr_stack+1766, vrr_stack+1376, vrr_stack+1136, vrr_stack+761);
 _BUILD_00h0(Data,vrr_stack+623, vrr_stack+126, vrr_stack+111, vrr_stack+22, vrr_stack+12, NULL);
 _BUILD_00h0(Data,vrr_stack+644, vrr_stack+186, vrr_stack+126, vrr_stack+63, vrr_stack+22, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+111, vrr_stack+246, vrr_stack+12, vrr_stack+32, NULL);
 _BUILD_p0h0(Data,vrr_stack+686, vrr_stack+623, vrr_stack+665, NULL, NULL, vrr_stack+111);
 _BUILD_p0h0(Data,vrr_stack+749, vrr_stack+644, vrr_stack+623, NULL, NULL, vrr_stack+126);
 _BUILD_d0h0(Data,vrr_stack+2306, vrr_stack+749, vrr_stack+686, vrr_stack+644, vrr_stack+623, vrr_stack+141);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+48, vrr_stack+186, vrr_stack+267, vrr_stack+63, NULL);
 _BUILD_p0h0(Data,vrr_stack+812, vrr_stack+141, vrr_stack+644, NULL, NULL, vrr_stack+186);
 _BUILD_d0h0(Data,vrr_stack+2432, vrr_stack+812, vrr_stack+749, vrr_stack+141, vrr_stack+644, vrr_stack+201);
 _BUILD_00h0(Data,vrr_stack+63, vrr_stack+246, vrr_stack+338, vrr_stack+32, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+2558, vrr_stack+665, vrr_stack+63, NULL, NULL, vrr_stack+246);
 _BUILD_d0h0(Data,vrr_stack+2621, vrr_stack+686, vrr_stack+2558, vrr_stack+623, vrr_stack+665, vrr_stack+911);
 _BUILD_f0h0(Data,vrr_stack+2747, vrr_stack+2306, vrr_stack+2621, vrr_stack+749, vrr_stack+686, vrr_stack+956);
 _BUILD_f0h0(Data,vrr_stack+2957, vrr_stack+2432, vrr_stack+2306, vrr_stack+812, vrr_stack+749, vrr_stack+1046);
 _BUILD_g0h0(Data,vrr_stack+3167, vrr_stack+2957, vrr_stack+2747, vrr_stack+2432, vrr_stack+2306, vrr_stack+1136);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+6, vrr_stack+9, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+201, vrr_stack+261, vrr_stack+6, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+9, vrr_stack+207, vrr_stack+267, vrr_stack+201, vrr_stack+261, NULL);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+9, vrr_stack+48, vrr_stack+207, vrr_stack+267, NULL);
 _BUILD_p0h0(Data,vrr_stack+875, vrr_stack+217, vrr_stack+141, NULL, NULL, vrr_stack+48);
 _BUILD_d0h0(Data,vrr_stack+938, vrr_stack+875, vrr_stack+812, vrr_stack+217, vrr_stack+141, vrr_stack+277);
 _BUILD_f0h0(Data,vrr_stack+1064, vrr_stack+938, vrr_stack+2432, vrr_stack+875, vrr_stack+812, vrr_stack+1286);
 _BUILD_g0h0(Data,vrr_stack+3482, vrr_stack+1064, vrr_stack+2957, vrr_stack+938, vrr_stack+2432, vrr_stack+1376);
 _BUILD_00p0(Data,vrr_stack+261, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+264, vrr_stack+3, vrr_stack+261, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+270, vrr_stack+322, vrr_stack+264, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+280, vrr_stack+328, vrr_stack+270, vrr_stack+42, vrr_stack+322, NULL);
 _BUILD_00h0(Data,vrr_stack+295, vrr_stack+338, vrr_stack+280, vrr_stack+84, vrr_stack+328, NULL);
 _BUILD_p0h0(Data,vrr_stack+1274, vrr_stack+63, vrr_stack+295, NULL, NULL, vrr_stack+338);
 _BUILD_d0h0(Data,vrr_stack+1337, vrr_stack+2558, vrr_stack+1274, vrr_stack+665, vrr_stack+63, vrr_stack+353);
 _BUILD_f0h0(Data,vrr_stack+3797, vrr_stack+2621, vrr_stack+1337, vrr_stack+686, vrr_stack+2558, vrr_stack+1526);
 _BUILD_g0h0(Data,vrr_stack+4007, vrr_stack+2747, vrr_stack+3797, vrr_stack+2306, vrr_stack+2621, vrr_stack+1616);
 _BUILD_h0h0(Data,vrr_stack+4322, vrr_stack+3167, vrr_stack+4007, vrr_stack+2957, vrr_stack+2747, vrr_stack+1766);
 _BUILD_h0h0(Data,vrr_stack+1463, vrr_stack+3482, vrr_stack+3167, vrr_stack+1064, vrr_stack+2957, vrr_stack+398);
 _BUILD_i0h0(Data,vrr_stack+4763, vrr_stack+1463, vrr_stack+4322, vrr_stack+3482, vrr_stack+3167, vrr_stack+1991);
 _BUILD_00i0(Data,vrr_stack+353, vrr_stack+623, vrr_stack+665, vrr_stack+126, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+381, vrr_stack+644, vrr_stack+623, vrr_stack+186, vrr_stack+126, NULL);
 _BUILD_p0i0(Data,vrr_stack+409, vrr_stack+381, vrr_stack+353, NULL, NULL, vrr_stack+623);
 _BUILD_00i0(Data,vrr_stack+493, vrr_stack+141, vrr_stack+644, vrr_stack+48, vrr_stack+186, NULL);
 _BUILD_p0i0(Data,vrr_stack+521, vrr_stack+493, vrr_stack+381, NULL, NULL, vrr_stack+644);
 _BUILD_00i0(Data,vrr_stack+162, vrr_stack+665, vrr_stack+63, vrr_stack+111, vrr_stack+246, NULL);
 _BUILD_p0i0(Data,vrr_stack+1904, vrr_stack+353, vrr_stack+162, NULL, NULL, vrr_stack+665);
 _BUILD_d0i0(Data,vrr_stack+1988, vrr_stack+409, vrr_stack+1904, vrr_stack+381, vrr_stack+353, vrr_stack+686);
 _BUILD_d0i0(Data,vrr_stack+5351, vrr_stack+521, vrr_stack+409, vrr_stack+493, vrr_stack+381, vrr_stack+749);
 _BUILD_f0i0(Data,vrr_stack+5519, vrr_stack+5351, vrr_stack+1988, vrr_stack+521, vrr_stack+409, vrr_stack+2306);
 _BUILD_00i0(Data,vrr_stack+686, vrr_stack+217, vrr_stack+141, vrr_stack+9, vrr_stack+48, NULL);
 _BUILD_p0i0(Data,vrr_stack+714, vrr_stack+686, vrr_stack+493, NULL, NULL, vrr_stack+141);
 _BUILD_d0i0(Data,vrr_stack+2156, vrr_stack+714, vrr_stack+521, vrr_stack+686, vrr_stack+493, vrr_stack+812);
 _BUILD_f0i0(Data,vrr_stack+5799, vrr_stack+2156, vrr_stack+5351, vrr_stack+714, vrr_stack+521, vrr_stack+2432);
 _BUILD_00i0(Data,vrr_stack+798, vrr_stack+63, vrr_stack+295, vrr_stack+246, vrr_stack+338, NULL);
 _BUILD_p0i0(Data,vrr_stack+2324, vrr_stack+162, vrr_stack+798, NULL, NULL, vrr_stack+63);
 _BUILD_d0i0(Data,vrr_stack+6079, vrr_stack+1904, vrr_stack+2324, vrr_stack+353, vrr_stack+162, vrr_stack+2558);
 _BUILD_f0i0(Data,vrr_stack+6247, vrr_stack+1988, vrr_stack+6079, vrr_stack+409, vrr_stack+1904, vrr_stack+2621);
 _BUILD_g0i0(Data,vrr_stack+6527, vrr_stack+5519, vrr_stack+6247, vrr_stack+5351, vrr_stack+1988, vrr_stack+2747);
 _BUILD_g0i0(Data,vrr_stack+2408, vrr_stack+5799, vrr_stack+5519, vrr_stack+2156, vrr_stack+5351, vrr_stack+2957);
 _BUILD_h0i0(Data,vrr_stack+6947, vrr_stack+2408, vrr_stack+6527, vrr_stack+5799, vrr_stack+5519, vrr_stack+3167);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+316, vrr_stack+0, vrr_stack+6, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+826, vrr_stack+316, vrr_stack+201, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+836, vrr_stack+826, vrr_stack+207, vrr_stack+316, vrr_stack+201, NULL);
 _BUILD_00h0(Data,vrr_stack+851, vrr_stack+836, vrr_stack+9, vrr_stack+826, vrr_stack+207, NULL);
 _BUILD_00i0(Data,vrr_stack+84, vrr_stack+851, vrr_stack+217, vrr_stack+836, vrr_stack+9, NULL);
 _BUILD_p0i0(Data,vrr_stack+2828, vrr_stack+84, vrr_stack+686, NULL, NULL, vrr_stack+217);
 _BUILD_d0i0(Data,vrr_stack+2912, vrr_stack+2828, vrr_stack+714, vrr_stack+84, vrr_stack+686, vrr_stack+875);
 _BUILD_f0i0(Data,vrr_stack+3080, vrr_stack+2912, vrr_stack+2156, vrr_stack+2828, vrr_stack+714, vrr_stack+938);
 _BUILD_g0i0(Data,vrr_stack+7535, vrr_stack+3080, vrr_stack+5799, vrr_stack+2912, vrr_stack+2156, vrr_stack+1064);
 _BUILD_h0i0(Data,vrr_stack+7955, vrr_stack+7535, vrr_stack+2408, vrr_stack+3080, vrr_stack+5799, vrr_stack+3482);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+261, vrr_stack+6, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+15, vrr_stack+264, vrr_stack+9, vrr_stack+3, vrr_stack+261, NULL);
 _BUILD_00g0(Data,vrr_stack+25, vrr_stack+270, vrr_stack+15, vrr_stack+322, vrr_stack+264, NULL);
 _BUILD_00h0(Data,vrr_stack+40, vrr_stack+280, vrr_stack+25, vrr_stack+328, vrr_stack+270, NULL);
 _BUILD_00i0(Data,vrr_stack+872, vrr_stack+295, vrr_stack+40, vrr_stack+338, vrr_stack+280, NULL);
 _BUILD_p0i0(Data,vrr_stack+900, vrr_stack+798, vrr_stack+872, NULL, NULL, vrr_stack+295);
 _BUILD_d0i0(Data,vrr_stack+984, vrr_stack+2324, vrr_stack+900, vrr_stack+162, vrr_stack+798, vrr_stack+1274);
 _BUILD_f0i0(Data,vrr_stack+3360, vrr_stack+6079, vrr_stack+984, vrr_stack+1904, vrr_stack+2324, vrr_stack+1337);
 _BUILD_g0i0(Data,vrr_stack+8543, vrr_stack+6247, vrr_stack+3360, vrr_stack+1988, vrr_stack+6079, vrr_stack+3797);
 _BUILD_h0i0(Data,vrr_stack+8963, vrr_stack+6527, vrr_stack+8543, vrr_stack+5519, vrr_stack+6247, vrr_stack+4007);
 _BUILD_i0i0(Data,vrr_stack+9551, vrr_stack+6947, vrr_stack+8963, vrr_stack+2408, vrr_stack+6527, vrr_stack+4322);
 _BUILD_i0i0(Data,vrr_stack+3640, vrr_stack+7955, vrr_stack+6947, vrr_stack+7535, vrr_stack+2408, vrr_stack+1463);
 _BUILD_k0i0(Data,vrr_stack+10335, vrr_stack+3640, vrr_stack+9551, vrr_stack+7955, vrr_stack+6947, vrr_stack+4763);
 _BUILD_00k0(Data,vrr_stack+1152, vrr_stack+381, vrr_stack+353, vrr_stack+644, vrr_stack+623, NULL);
 _BUILD_00k0(Data,vrr_stack+1188, vrr_stack+493, vrr_stack+381, vrr_stack+141, vrr_stack+644, NULL);
 _BUILD_00k0(Data,vrr_stack+1224, vrr_stack+353, vrr_stack+162, vrr_stack+623, vrr_stack+665, NULL);
 _BUILD_p0k0(Data,vrr_stack+1260, vrr_stack+1152, vrr_stack+1224, NULL, NULL, vrr_stack+353);
 _BUILD_p0k0(Data,vrr_stack+1368, vrr_stack+1188, vrr_stack+1152, NULL, NULL, vrr_stack+381);
 _BUILD_d0k0(Data,vrr_stack+1476, vrr_stack+1368, vrr_stack+1260, vrr_stack+1188, vrr_stack+1152, vrr_stack+409);
 _BUILD_00k0(Data,vrr_stack+409, vrr_stack+686, vrr_stack+493, vrr_stack+217, vrr_stack+141, NULL);
 _BUILD_p0k0(Data,vrr_stack+1692, vrr_stack+409, vrr_stack+1188, NULL, NULL, vrr_stack+493);
 _BUILD_d0k0(Data,vrr_stack+4424, vrr_stack+1692, vrr_stack+1368, vrr_stack+409, vrr_stack+1188, vrr_stack+521);
 _BUILD_00k0(Data,vrr_stack+521, vrr_stack+162, vrr_stack+798, vrr_stack+665, vrr_stack+63, NULL);
 _BUILD_p0k0(Data,vrr_stack+557, vrr_stack+1224, vrr_stack+521, NULL, NULL, vrr_stack+162);
 _BUILD_d0k0(Data,vrr_stack+4640, vrr_stack+1260, vrr_stack+557, vrr_stack+1152, vrr_stack+1224, vrr_stack+1904);
 _BUILD_f0k0(Data,vrr_stack+4856, vrr_stack+1476, vrr_stack+4640, vrr_stack+1368, vrr_stack+1260, vrr_stack+1988);
 _BUILD_f0k0(Data,vrr_stack+11343, vrr_stack+4424, vrr_stack+1476, vrr_stack+1692, vrr_stack+1368, vrr_stack+5351);
 _BUILD_g0k0(Data,vrr_stack+11703, vrr_stack+11343, vrr_stack+4856, vrr_stack+4424, vrr_stack+1476, vrr_stack+5519);
 _BUILD_00k0(Data,vrr_stack+445, vrr_stack+84, vrr_stack+686, vrr_stack+851, vrr_stack+217, NULL);
 _BUILD_p0k0(Data,vrr_stack+1800, vrr_stack+445, vrr_stack+409, NULL, NULL, vrr_stack+686);
 _BUILD_d0k0(Data,vrr_stack+1908, vrr_stack+1800, vrr_stack+1692, vrr_stack+445, vrr_stack+409, vrr_stack+714);
 _BUILD_f0k0(Data,vrr_stack+5216, vrr_stack+1908, vrr_stack+4424, vrr_stack+1800, vrr_stack+1692, vrr_stack+2156);
 _BUILD_g0k0(Data,vrr_stack+12243, vrr_stack+5216, vrr_stack+11343, vrr_stack+1908, vrr_stack+4424, vrr_stack+5799);
 _BUILD_00k0(Data,vrr_stack+714, vrr_stack+798, vrr_stack+872, vrr_stack+63, vrr_stack+295, NULL);
 _BUILD_p0k0(Data,vrr_stack+2124, vrr_stack+521, vrr_stack+714, NULL, NULL, vrr_stack+798);
 _BUILD_d0k0(Data,vrr_stack+5576, vrr_stack+557, vrr_stack+2124, vrr_stack+1224, vrr_stack+521, vrr_stack+2324);
 _BUILD_f0k0(Data,vrr_stack+12783, vrr_stack+4640, vrr_stack+5576, vrr_stack+1260, vrr_stack+557, vrr_stack+6079);
 _BUILD_g0k0(Data,vrr_stack+13143, vrr_stack+4856, vrr_stack+12783, vrr_stack+1476, vrr_stack+4640, vrr_stack+6247);
 _BUILD_h0k0(Data,vrr_stack+13683, vrr_stack+11703, vrr_stack+13143, vrr_stack+11343, vrr_stack+4856, vrr_stack+6527);
 _BUILD_h0k0(Data,vrr_stack+5792, vrr_stack+12243, vrr_stack+11703, vrr_stack+5216, vrr_stack+11343, vrr_stack+2408);
 _BUILD_i0k0(Data,vrr_stack+14439, vrr_stack+5792, vrr_stack+13683, vrr_stack+12243, vrr_stack+11703, vrr_stack+6947);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+750, vrr_stack+3, vrr_stack+0, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+756, vrr_stack+750, vrr_stack+316, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+766, vrr_stack+756, vrr_stack+826, vrr_stack+750, vrr_stack+316, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+766, vrr_stack+836, vrr_stack+756, vrr_stack+826, NULL);
 _BUILD_00i0(Data,vrr_stack+316, vrr_stack+665, vrr_stack+851, vrr_stack+766, vrr_stack+836, NULL);
 _BUILD_00k0(Data,vrr_stack+2232, vrr_stack+316, vrr_stack+84, vrr_stack+665, vrr_stack+851, NULL);
 _BUILD_p0k0(Data,vrr_stack+2268, vrr_stack+2232, vrr_stack+445, NULL, NULL, vrr_stack+84);
 _BUILD_d0k0(Data,vrr_stack+2376, vrr_stack+2268, vrr_stack+1800, vrr_stack+2232, vrr_stack+445, vrr_stack+2828);
 _BUILD_f0k0(Data,vrr_stack+6548, vrr_stack+2376, vrr_stack+1908, vrr_stack+2268, vrr_stack+1800, vrr_stack+2912);
 _BUILD_g0k0(Data,vrr_stack+6908, vrr_stack+6548, vrr_stack+5216, vrr_stack+2376, vrr_stack+1908, vrr_stack+3080);
 _BUILD_h0k0(Data,vrr_stack+2592, vrr_stack+6908, vrr_stack+12243, vrr_stack+6548, vrr_stack+5216, vrr_stack+7535);
 _BUILD_i0k0(Data,vrr_stack+15447, vrr_stack+2592, vrr_stack+5792, vrr_stack+6908, vrr_stack+12243, vrr_stack+7955);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+826, vrr_stack+6, vrr_stack+0, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+832, vrr_stack+9, vrr_stack+826, vrr_stack+261, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+842, vrr_stack+15, vrr_stack+832, vrr_stack+264, vrr_stack+9, NULL);
 _BUILD_00h0(Data,vrr_stack+61, vrr_stack+25, vrr_stack+842, vrr_stack+270, vrr_stack+15, NULL);
 _BUILD_00i0(Data,vrr_stack+112, vrr_stack+40, vrr_stack+61, vrr_stack+280, vrr_stack+25, NULL);
 _BUILD_00k0(Data,vrr_stack+190, vrr_stack+872, vrr_stack+112, vrr_stack+295, vrr_stack+40, NULL);
 _BUILD_p0k0(Data,vrr_stack+7448, vrr_stack+714, vrr_stack+190, NULL, NULL, vrr_stack+872);
 _BUILD_d0k0(Data,vrr_stack+7556, vrr_stack+2124, vrr_stack+7448, vrr_stack+521, vrr_stack+714, vrr_stack+900);
 _BUILD_f0k0(Data,vrr_stack+7772, vrr_stack+5576, vrr_stack+7556, vrr_stack+557, vrr_stack+2124, vrr_stack+984);
 _BUILD_g0k0(Data,vrr_stack+16455, vrr_stack+12783, vrr_stack+7772, vrr_stack+4640, vrr_stack+5576, vrr_stack+3360);
 _BUILD_h0k0(Data,vrr_stack+16995, vrr_stack+13143, vrr_stack+16455, vrr_stack+4856, vrr_stack+12783, vrr_stack+8543);
 _BUILD_i0k0(Data,vrr_stack+17751, vrr_stack+13683, vrr_stack+16995, vrr_stack+11703, vrr_stack+13143, vrr_stack+8963);
 _BUILD_k0k0(Data,vrr_stack+8132, vrr_stack+14439, vrr_stack+17751, vrr_stack+5792, vrr_stack+13683, vrr_stack+9551);
 _BUILD_k0k0(Data,vrr_stack+18759, vrr_stack+15447, vrr_stack+14439, vrr_stack+2592, vrr_stack+5792, vrr_stack+3640);
 _BUILD_l0k0(Data,vrr_stack+20055, vrr_stack+18759, vrr_stack+8132, vrr_stack+15447, vrr_stack+14439, vrr_stack+10335);
 _BUILD_00l0(Data,vrr_stack+900, vrr_stack+1152, vrr_stack+1224, vrr_stack+381, vrr_stack+353, NULL);
 _BUILD_00l0(Data,vrr_stack+945, vrr_stack+1188, vrr_stack+1152, vrr_stack+493, vrr_stack+381, NULL);
 _BUILD_p0l0(Data,vrr_stack+990, vrr_stack+945, vrr_stack+900, NULL, NULL, vrr_stack+1152);
 _BUILD_00l0(Data,vrr_stack+3348, vrr_stack+409, vrr_stack+1188, vrr_stack+686, vrr_stack+493, NULL);
 _BUILD_p0l0(Data,vrr_stack+3393, vrr_stack+3348, vrr_stack+945, NULL, NULL, vrr_stack+1188);
 _BUILD_00l0(Data,vrr_stack+3528, vrr_stack+1224, vrr_stack+521, vrr_stack+353, vrr_stack+162, NULL);
 _BUILD_p0l0(Data,vrr_stack+3573, vrr_stack+900, vrr_stack+3528, NULL, NULL, vrr_stack+1224);
 _BUILD_d0l0(Data,vrr_stack+3708, vrr_stack+990, vrr_stack+3573, vrr_stack+945, vrr_stack+900, vrr_stack+1260);
 _BUILD_d0l0(Data,vrr_stack+3978, vrr_stack+3393, vrr_stack+990, vrr_stack+3348, vrr_stack+945, vrr_stack+1368);
 _BUILD_f0l0(Data,vrr_stack+9428, vrr_stack+3978, vrr_stack+3708, vrr_stack+3393, vrr_stack+990, vrr_stack+1476);
 _BUILD_00l0(Data,vrr_stack+1260, vrr_stack+445, vrr_stack+409, vrr_stack+84, vrr_stack+686, NULL);
 _BUILD_p0l0(Data,vrr_stack+1305, vrr_stack+1260, vrr_stack+3348, NULL, NULL, vrr_stack+409);
 _BUILD_d0l0(Data,vrr_stack+9878, vrr_stack+1305, vrr_stack+3393, vrr_stack+1260, vrr_stack+3348, vrr_stack+1692);
 _BUILD_f0l0(Data,vrr_stack+10148, vrr_stack+9878, vrr_stack+3978, vrr_stack+1305, vrr_stack+3393, vrr_stack+4424);
 _BUILD_00l0(Data,vrr_stack+1440, vrr_stack+521, vrr_stack+714, vrr_stack+162, vrr_stack+798, NULL);
 _BUILD_p0l0(Data,vrr_stack+1485, vrr_stack+3528, vrr_stack+1440, NULL, NULL, vrr_stack+521);
 _BUILD_d0l0(Data,vrr_stack+4248, vrr_stack+3573, vrr_stack+1485, vrr_stack+900, vrr_stack+3528, vrr_stack+557);
 _BUILD_f0l0(Data,vrr_stack+10598, vrr_stack+3708, vrr_stack+4248, vrr_stack+990, vrr_stack+3573, vrr_stack+4640);
 _BUILD_g0l0(Data,vrr_stack+21675, vrr_stack+9428, vrr_stack+10598, vrr_stack+3978, vrr_stack+3708, vrr_stack+4856);
 _BUILD_g0l0(Data,vrr_stack+4518, vrr_stack+10148, vrr_stack+9428, vrr_stack+9878, vrr_stack+3978, vrr_stack+11343);
 _BUILD_h0l0(Data,vrr_stack+22350, vrr_stack+4518, vrr_stack+21675, vrr_stack+10148, vrr_stack+9428, vrr_stack+11703);
 _BUILD_00l0(Data,vrr_stack+557, vrr_stack+2232, vrr_stack+445, vrr_stack+316, vrr_stack+84, NULL);
 _BUILD_p0l0(Data,vrr_stack+1620, vrr_stack+557, vrr_stack+1260, NULL, NULL, vrr_stack+445);
 _BUILD_d0l0(Data,vrr_stack+11048, vrr_stack+1620, vrr_stack+1305, vrr_stack+557, vrr_stack+1260, vrr_stack+1800);
 _BUILD_f0l0(Data,vrr_stack+11318, vrr_stack+11048, vrr_stack+9878, vrr_stack+1620, vrr_stack+1305, vrr_stack+1908);
 _BUILD_g0l0(Data,vrr_stack+23295, vrr_stack+11318, vrr_stack+10148, vrr_stack+11048, vrr_stack+9878, vrr_stack+5216);
 _BUILD_h0l0(Data,vrr_stack+23970, vrr_stack+23295, vrr_stack+4518, vrr_stack+11318, vrr_stack+10148, vrr_stack+12243);
 _BUILD_00l0(Data,vrr_stack+602, vrr_stack+714, vrr_stack+190, vrr_stack+798, vrr_stack+872, NULL);
 _BUILD_p0l0(Data,vrr_stack+1755, vrr_stack+1440, vrr_stack+602, NULL, NULL, vrr_stack+714);
 _BUILD_d0l0(Data,vrr_stack+5193, vrr_stack+1485, vrr_stack+1755, vrr_stack+3528, vrr_stack+1440, vrr_stack+2124);
 _BUILD_f0l0(Data,vrr_stack+11768, vrr_stack+4248, vrr_stack+5193, vrr_stack+3573, vrr_stack+1485, vrr_stack+5576);
 _BUILD_g0l0(Data,vrr_stack+24915, vrr_stack+10598, vrr_stack+11768, vrr_stack+3708, vrr_stack+4248, vrr_stack+12783);
 _BUILD_h0l0(Data,vrr_stack+25590, vrr_stack+21675, vrr_stack+24915, vrr_stack+9428, vrr_stack+10598, vrr_stack+13143);
 _BUILD_i0l0(Data,vrr_stack+12218, vrr_stack+22350, vrr_stack+25590, vrr_stack+4518, vrr_stack+21675, vrr_stack+13683);
 _BUILD_i0l0(Data,vrr_stack+26535, vrr_stack+23970, vrr_stack+22350, vrr_stack+23295, vrr_stack+4518, vrr_stack+5792);
 _BUILD_k0l0(Data,vrr_stack+27795, vrr_stack+26535, vrr_stack+12218, vrr_stack+23970, vrr_stack+22350, vrr_stack+14439);
 _BUILD_00p0(Data,vrr_stack+647, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+650, vrr_stack+647, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+686, vrr_stack+650, vrr_stack+750, vrr_stack+647, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+857, vrr_stack+686, vrr_stack+756, vrr_stack+650, vrr_stack+750, NULL);
 _BUILD_00h0(Data,vrr_stack+1890, vrr_stack+857, vrr_stack+766, vrr_stack+686, vrr_stack+756, NULL);
 _BUILD_00i0(Data,vrr_stack+1911, vrr_stack+1890, vrr_stack+665, vrr_stack+857, vrr_stack+766, NULL);
 _BUILD_00k0(Data,vrr_stack+750, vrr_stack+1911, vrr_stack+316, vrr_stack+1890, vrr_stack+665, NULL);
 _BUILD_00l0(Data,vrr_stack+1939, vrr_stack+750, vrr_stack+2232, vrr_stack+1911, vrr_stack+316, NULL);
 _BUILD_p0l0(Data,vrr_stack+1984, vrr_stack+1939, vrr_stack+557, NULL, NULL, vrr_stack+2232);
 _BUILD_d0l0(Data,vrr_stack+5463, vrr_stack+1984, vrr_stack+1620, vrr_stack+1939, vrr_stack+557, vrr_stack+2268);
 _BUILD_f0l0(Data,vrr_stack+5733, vrr_stack+5463, vrr_stack+11048, vrr_stack+1984, vrr_stack+1620, vrr_stack+2376);
 _BUILD_g0l0(Data,vrr_stack+13478, vrr_stack+5733, vrr_stack+11318, vrr_stack+5463, vrr_stack+11048, vrr_stack+6548);
 _BUILD_h0l0(Data,vrr_stack+14153, vrr_stack+13478, vrr_stack+23295, vrr_stack+5733, vrr_stack+11318, vrr_stack+6908);
 _BUILD_i0l0(Data,vrr_stack+6183, vrr_stack+14153, vrr_stack+23970, vrr_stack+13478, vrr_stack+23295, vrr_stack+2592);
 _BUILD_k0l0(Data,vrr_stack+29415, vrr_stack+6183, vrr_stack+26535, vrr_stack+14153, vrr_stack+23970, vrr_stack+15447);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2268, vrr_stack+0, vrr_stack+3, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+2274, vrr_stack+826, vrr_stack+2268, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+2284, vrr_stack+832, vrr_stack+2274, vrr_stack+9, vrr_stack+826, NULL);
 _BUILD_00h0(Data,vrr_stack+2299, vrr_stack+842, vrr_stack+2284, vrr_stack+15, vrr_stack+832, NULL);
 _BUILD_00i0(Data,vrr_stack+2320, vrr_stack+61, vrr_stack+2299, vrr_stack+25, vrr_stack+842, NULL);
 _BUILD_00k0(Data,vrr_stack+2348, vrr_stack+112, vrr_stack+2320, vrr_stack+40, vrr_stack+61, NULL);
 _BUILD_00l0(Data,vrr_stack+6, vrr_stack+190, vrr_stack+2348, vrr_stack+872, vrr_stack+112, NULL);
 _BUILD_p0l0(Data,vrr_stack+2384, vrr_stack+602, vrr_stack+6, NULL, NULL, vrr_stack+190);
 _BUILD_d0l0(Data,vrr_stack+2519, vrr_stack+1755, vrr_stack+2384, vrr_stack+1440, vrr_stack+602, vrr_stack+7448);
 _BUILD_f0l0(Data,vrr_stack+2789, vrr_stack+5193, vrr_stack+2519, vrr_stack+1485, vrr_stack+1755, vrr_stack+7556);
 _BUILD_g0l0(Data,vrr_stack+15098, vrr_stack+11768, vrr_stack+2789, vrr_stack+4248, vrr_stack+5193, vrr_stack+7772);
 _BUILD_h0l0(Data,vrr_stack+31035, vrr_stack+24915, vrr_stack+15098, vrr_stack+10598, vrr_stack+11768, vrr_stack+16455);
 _BUILD_i0l0(Data,vrr_stack+31980, vrr_stack+25590, vrr_stack+31035, vrr_stack+21675, vrr_stack+24915, vrr_stack+16995);
 _BUILD_k0l0(Data,vrr_stack+15773, vrr_stack+12218, vrr_stack+31980, vrr_stack+22350, vrr_stack+25590, vrr_stack+17751);
 _BUILD_l0l0(Data,vrr_stack+33240, vrr_stack+27795, vrr_stack+15773, vrr_stack+26535, vrr_stack+12218, vrr_stack+8132);
 _BUILD_l0l0(Data,vrr_stack+35265, vrr_stack+29415, vrr_stack+27795, vrr_stack+6183, vrr_stack+26535, vrr_stack+18759);
 _BUILD_m0l0(Data,vrr_stack+17393, vrr_stack+35265, vrr_stack+33240, vrr_stack+29415, vrr_stack+27795, vrr_stack+20055);
 _BUILD_00m0(Data,vrr_stack+3239, vrr_stack+945, vrr_stack+900, vrr_stack+1188, vrr_stack+1152, NULL);
 _BUILD_00m0(Data,vrr_stack+2119, vrr_stack+3348, vrr_stack+945, vrr_stack+409, vrr_stack+1188, NULL);
 _BUILD_00m0(Data,vrr_stack+2174, vrr_stack+900, vrr_stack+3528, vrr_stack+1152, vrr_stack+1224, NULL);
 _BUILD_p0m0(Data,vrr_stack+7443, vrr_stack+3239, vrr_stack+2174, NULL, NULL, vrr_stack+900);
 _BUILD_p0m0(Data,vrr_stack+7608, vrr_stack+2119, vrr_stack+3239, NULL, NULL, vrr_stack+945);
 _BUILD_d0m0(Data,vrr_stack+7773, vrr_stack+7608, vrr_stack+7443, vrr_stack+2119, vrr_stack+3239, vrr_stack+990);
 _BUILD_00m0(Data,vrr_stack+990, vrr_stack+1260, vrr_stack+3348, vrr_stack+445, vrr_stack+409, NULL);
 _BUILD_p0m0(Data,vrr_stack+1045, vrr_stack+990, vrr_stack+2119, NULL, NULL, vrr_stack+3348);
 _BUILD_d0m0(Data,vrr_stack+8103, vrr_stack+1045, vrr_stack+7608, vrr_stack+990, vrr_stack+2119, vrr_stack+3393);
 _BUILD_00m0(Data,vrr_stack+3393, vrr_stack+3528, vrr_stack+1440, vrr_stack+1224, vrr_stack+521, NULL);
 _BUILD_p0m0(Data,vrr_stack+8433, vrr_stack+2174, vrr_stack+3393, NULL, NULL, vrr_stack+3528);
 _BUILD_d0m0(Data,vrr_stack+8598, vrr_stack+7443, vrr_stack+8433, vrr_stack+3239, vrr_stack+2174, vrr_stack+3573);
 _BUILD_f0m0(Data,vrr_stack+19868, vrr_stack+7773, vrr_stack+8598, vrr_stack+7608, vrr_stack+7443, vrr_stack+3708);
 _BUILD_f0m0(Data,vrr_stack+20418, vrr_stack+8103, vrr_stack+7773, vrr_stack+1045, vrr_stack+7608, vrr_stack+3978);
 _BUILD_g0m0(Data,vrr_stack+37290, vrr_stack+20418, vrr_stack+19868, vrr_stack+8103, vrr_stack+7773, vrr_stack+9428);
 _BUILD_00m0(Data,vrr_stack+3573, vrr_stack+557, vrr_stack+1260, vrr_stack+2232, vrr_stack+445, NULL);
 _BUILD_p0m0(Data,vrr_stack+3628, vrr_stack+3573, vrr_stack+990, NULL, NULL, vrr_stack+1260);
 _BUILD_d0m0(Data,vrr_stack+3793, vrr_stack+3628, vrr_stack+1045, vrr_stack+3573, vrr_stack+990, vrr_stack+1305);
 _BUILD_f0m0(Data,vrr_stack+8928, vrr_stack+3793, vrr_stack+8103, vrr_stack+3628, vrr_stack+1045, vrr_stack+9878);
 _BUILD_g0m0(Data,vrr_stack+38115, vrr_stack+8928, vrr_stack+20418, vrr_stack+3793, vrr_stack+8103, vrr_stack+10148);
 _BUILD_00m0(Data,vrr_stack+1305, vrr_stack+1440, vrr_stack+602, vrr_stack+521, vrr_stack+714, NULL);
 _BUILD_p0m0(Data,vrr_stack+9478, vrr_stack+3393, vrr_stack+1305, NULL, NULL, vrr_stack+1440);
 _BUILD_d0m0(Data,vrr_stack+9643, vrr_stack+8433, vrr_stack+9478, vrr_stack+2174, vrr_stack+3393, vrr_stack+1485);
 _BUILD_f0m0(Data,vrr_stack+9973, vrr_stack+8598, vrr_stack+9643, vrr_stack+7443, vrr_stack+8433, vrr_stack+4248);
 _BUILD_g0m0(Data,vrr_stack+38940, vrr_stack+19868, vrr_stack+9973, vrr_stack+7773, vrr_stack+8598, vrr_stack+10598);
 _BUILD_h0m0(Data,vrr_stack+39765, vrr_stack+37290, vrr_stack+38940, vrr_stack+20418, vrr_stack+19868, vrr_stack+21675);
 _BUILD_h0m0(Data,vrr_stack+20968, vrr_stack+38115, vrr_stack+37290, vrr_stack+8928, vrr_stack+20418, vrr_stack+4518);
 _BUILD_i0m0(Data,vrr_stack+40920, vrr_stack+20968, vrr_stack+39765, vrr_stack+38115, vrr_stack+37290, vrr_stack+22350);
 _BUILD_00m0(Data,vrr_stack+1485, vrr_stack+1939, vrr_stack+557, vrr_stack+750, vrr_stack+2232, NULL);
 _BUILD_p0m0(Data,vrr_stack+4123, vrr_stack+1485, vrr_stack+3573, NULL, NULL, vrr_stack+557);
 _BUILD_d0m0(Data,vrr_stack+4288, vrr_stack+4123, vrr_stack+3628, vrr_stack+1485, vrr_stack+3573, vrr_stack+1620);
 _BUILD_f0m0(Data,vrr_stack+4618, vrr_stack+4288, vrr_stack+3793, vrr_stack+4123, vrr_stack+3628, vrr_stack+11048);
 _BUILD_g0m0(Data,vrr_stack+22123, vrr_stack+4618, vrr_stack+8928, vrr_stack+4288, vrr_stack+3793, vrr_stack+11318);
 _BUILD_h0m0(Data,vrr_stack+10523, vrr_stack+22123, vrr_stack+38115, vrr_stack+4618, vrr_stack+8928, vrr_stack+23295);
 _BUILD_i0m0(Data,vrr_stack+42460, vrr_stack+10523, vrr_stack+20968, vrr_stack+22123, vrr_stack+38115, vrr_stack+23970);
 _BUILD_00m0(Data,vrr_stack+1540, vrr_stack+602, vrr_stack+6, vrr_stack+714, vrr_stack+190, NULL);
 _BUILD_p0m0(Data,vrr_stack+226, vrr_stack+1305, vrr_stack+1540, NULL, NULL, vrr_stack+602);
 _BUILD_d0m0(Data,vrr_stack+22948, vrr_stack+9478, vrr_stack+226, vrr_stack+3393, vrr_stack+1305, vrr_stack+1755);
 _BUILD_f0m0(Data,vrr_stack+23278, vrr_stack+9643, vrr_stack+22948, vrr_stack+8433, vrr_stack+9478, vrr_stack+5193);
 _BUILD_g0m0(Data,vrr_stack+23828, vrr_stack+9973, vrr_stack+23278, vrr_stack+8598, vrr_stack+9643, vrr_stack+11768);
 _BUILD_h0m0(Data,vrr_stack+44000, vrr_stack+38940, vrr_stack+23828, vrr_stack+19868, vrr_stack+9973, vrr_stack+24915);
 _BUILD_i0m0(Data,vrr_stack+45155, vrr_stack+39765, vrr_stack+44000, vrr_stack+37290, vrr_stack+38940, vrr_stack+25590);
 _BUILD_k0m0(Data,vrr_stack+46695, vrr_stack+40920, vrr_stack+45155, vrr_stack+20968, vrr_stack+39765, vrr_stack+12218);
 _BUILD_k0m0(Data,vrr_stack+48675, vrr_stack+42460, vrr_stack+40920, vrr_stack+10523, vrr_stack+20968, vrr_stack+26535);
 _BUILD_l0m0(Data,vrr_stack+24653, vrr_stack+48675, vrr_stack+46695, vrr_stack+42460, vrr_stack+40920, vrr_stack+27795);
 _BUILD_00p0(Data,vrr_stack+1595, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1598, vrr_stack+1595, vrr_stack+647, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+51, vrr_stack+1598, vrr_stack+650, vrr_stack+1595, vrr_stack+647, NULL);
 _BUILD_00g0(Data,vrr_stack+1604, vrr_stack+51, vrr_stack+686, vrr_stack+1598, vrr_stack+650, NULL);
 _BUILD_00h0(Data,vrr_stack+647, vrr_stack+1604, vrr_stack+857, vrr_stack+51, vrr_stack+686, NULL);
 _BUILD_00i0(Data,vrr_stack+872, vrr_stack+647, vrr_stack+1890, vrr_stack+1604, vrr_stack+857, NULL);
 _BUILD_00k0(Data,vrr_stack+668, vrr_stack+872, vrr_stack+1911, vrr_stack+647, vrr_stack+1890, NULL);
 _BUILD_00l0(Data,vrr_stack+704, vrr_stack+668, vrr_stack+750, vrr_stack+872, vrr_stack+1911, NULL);
 _BUILD_00m0(Data,vrr_stack+1595, vrr_stack+704, vrr_stack+1939, vrr_stack+668, vrr_stack+750, NULL);
 _BUILD_p0m0(Data,vrr_stack+1650, vrr_stack+1595, vrr_stack+1485, NULL, NULL, vrr_stack+1939);
 _BUILD_d0m0(Data,vrr_stack+11678, vrr_stack+1650, vrr_stack+4123, vrr_stack+1595, vrr_stack+1485, vrr_stack+1984);
 _BUILD_f0m0(Data,vrr_stack+12008, vrr_stack+11678, vrr_stack+4288, vrr_stack+1650, vrr_stack+4123, vrr_stack+5463);
 _BUILD_g0m0(Data,vrr_stack+12558, vrr_stack+12008, vrr_stack+4618, vrr_stack+11678, vrr_stack+4288, vrr_stack+5733);
 _BUILD_h0m0(Data,vrr_stack+27128, vrr_stack+12558, vrr_stack+22123, vrr_stack+12008, vrr_stack+4618, vrr_stack+13478);
   tmp = vrr_stack + 27128;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0m0(Data,vrr_stack+50655, vrr_stack+27128, vrr_stack+10523, vrr_stack+12558, vrr_stack+22123, vrr_stack+14153);
   tmp = vrr_stack + 50655;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0m0(Data,vrr_stack+11678, vrr_stack+50655, vrr_stack+42460, vrr_stack+27128, vrr_stack+10523, vrr_stack+6183);
   tmp = vrr_stack + 11678;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0m0(Data,vrr_stack+52195, vrr_stack+11678, vrr_stack+48675, vrr_stack+50655, vrr_stack+42460, vrr_stack+29415);
   tmp = vrr_stack + 52195;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+50655, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50658, vrr_stack+3, vrr_stack+50655, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+51, vrr_stack+2268, vrr_stack+50658, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50664, vrr_stack+2274, vrr_stack+51, vrr_stack+826, vrr_stack+2268, NULL);
 _BUILD_00h0(Data,vrr_stack+50679, vrr_stack+2284, vrr_stack+50664, vrr_stack+832, vrr_stack+2274, NULL);
 _BUILD_00i0(Data,vrr_stack+50700, vrr_stack+2299, vrr_stack+50679, vrr_stack+842, vrr_stack+2284, NULL);
 _BUILD_00k0(Data,vrr_stack+50728, vrr_stack+2320, vrr_stack+50700, vrr_stack+61, vrr_stack+2299, NULL);
 _BUILD_00l0(Data,vrr_stack+61, vrr_stack+2348, vrr_stack+50728, vrr_stack+112, vrr_stack+2320, NULL);
 _BUILD_00m0(Data,vrr_stack+106, vrr_stack+6, vrr_stack+61, vrr_stack+190, vrr_stack+2348, NULL);
 _BUILD_p0m0(Data,vrr_stack+50764, vrr_stack+1540, vrr_stack+106, NULL, NULL, vrr_stack+6);
 _BUILD_d0m0(Data,vrr_stack+50929, vrr_stack+226, vrr_stack+50764, vrr_stack+1305, vrr_stack+1540, vrr_stack+2384);
 _BUILD_f0m0(Data,vrr_stack+51259, vrr_stack+22948, vrr_stack+50929, vrr_stack+9478, vrr_stack+226, vrr_stack+2519);
 _BUILD_g0m0(Data,vrr_stack+27128, vrr_stack+23278, vrr_stack+51259, vrr_stack+9643, vrr_stack+22948, vrr_stack+2789);
 _BUILD_h0m0(Data,vrr_stack+27953, vrr_stack+23828, vrr_stack+27128, vrr_stack+9973, vrr_stack+23278, vrr_stack+15098);
 _BUILD_i0m0(Data,vrr_stack+29108, vrr_stack+44000, vrr_stack+27953, vrr_stack+38940, vrr_stack+23828, vrr_stack+31035);
 _BUILD_k0m0(Data,vrr_stack+13658, vrr_stack+45155, vrr_stack+29108, vrr_stack+39765, vrr_stack+44000, vrr_stack+31980);
 _BUILD_l0m0(Data,vrr_stack+30648, vrr_stack+46695, vrr_stack+13658, vrr_stack+40920, vrr_stack+45155, vrr_stack+15773);
 _BUILD_m0m0(Data,vrr_stack+54670, vrr_stack+24653, vrr_stack+30648, vrr_stack+48675, vrr_stack+46695, vrr_stack+33240);
 _BUILD_m0m0(Data,vrr_stack+57695, vrr_stack+52195, vrr_stack+24653, vrr_stack+11678, vrr_stack+48675, vrr_stack+35265);
   tmp = vrr_stack + 57695;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+11678, vrr_stack+3239, vrr_stack+2174, vrr_stack+945, vrr_stack+900, NULL);
 _BUILD_00n0(Data,vrr_stack+11744, vrr_stack+2119, vrr_stack+3239, vrr_stack+3348, vrr_stack+945, NULL);
 _BUILD_00n0(Data,vrr_stack+11810, vrr_stack+2174, vrr_stack+3393, vrr_stack+900, vrr_stack+3528, NULL);
 _BUILD_p0n0(Data,vrr_stack+11876, vrr_stack+11678, vrr_stack+11810, NULL, NULL, vrr_stack+2174);
 _BUILD_p0n0(Data,vrr_stack+12074, vrr_stack+11744, vrr_stack+11678, NULL, NULL, vrr_stack+3239);
 _BUILD_d0n0(Data,vrr_stack+12272, vrr_stack+12074, vrr_stack+11876, vrr_stack+11744, vrr_stack+11678, vrr_stack+7443);
 _BUILD_00n0(Data,vrr_stack+12668, vrr_stack+990, vrr_stack+2119, vrr_stack+1260, vrr_stack+3348, NULL);
 _BUILD_p0n0(Data,vrr_stack+12734, vrr_stack+12668, vrr_stack+11744, NULL, NULL, vrr_stack+2119);
 _BUILD_d0n0(Data,vrr_stack+12932, vrr_stack+12734, vrr_stack+12074, vrr_stack+12668, vrr_stack+11744, vrr_stack+7608);
 _BUILD_00n0(Data,vrr_stack+13328, vrr_stack+3393, vrr_stack+1305, vrr_stack+3528, vrr_stack+1440, NULL);
 _BUILD_p0n0(Data,vrr_stack+13394, vrr_stack+11810, vrr_stack+13328, NULL, NULL, vrr_stack+3393);
 _BUILD_d0n0(Data,vrr_stack+2384, vrr_stack+11876, vrr_stack+13394, vrr_stack+11678, vrr_stack+11810, vrr_stack+8433);
 _BUILD_f0n0(Data,vrr_stack+33123, vrr_stack+12272, vrr_stack+2384, vrr_stack+12074, vrr_stack+11876, vrr_stack+8598);
 _BUILD_f0n0(Data,vrr_stack+33783, vrr_stack+12932, vrr_stack+12272, vrr_stack+12734, vrr_stack+12074, vrr_stack+7773);
 _BUILD_g0n0(Data,vrr_stack+34443, vrr_stack+33783, vrr_stack+33123, vrr_stack+12932, vrr_stack+12272, vrr_stack+19868);
 _BUILD_00n0(Data,vrr_stack+13592, vrr_stack+3573, vrr_stack+990, vrr_stack+557, vrr_stack+1260, NULL);
 _BUILD_p0n0(Data,vrr_stack+19868, vrr_stack+13592, vrr_stack+12668, NULL, NULL, vrr_stack+990);
 _BUILD_d0n0(Data,vrr_stack+8433, vrr_stack+19868, vrr_stack+12734, vrr_stack+13592, vrr_stack+12668, vrr_stack+1045);
 _BUILD_f0n0(Data,vrr_stack+35433, vrr_stack+8433, vrr_stack+12932, vrr_stack+19868, vrr_stack+12734, vrr_stack+8103);
 _BUILD_g0n0(Data,vrr_stack+36093, vrr_stack+35433, vrr_stack+33783, vrr_stack+8433, vrr_stack+12932, vrr_stack+20418);
 _BUILD_00n0(Data,vrr_stack+1045, vrr_stack+1305, vrr_stack+1540, vrr_stack+1440, vrr_stack+602, NULL);
 _BUILD_p0n0(Data,vrr_stack+20066, vrr_stack+13328, vrr_stack+1045, NULL, NULL, vrr_stack+1305);
 _BUILD_d0n0(Data,vrr_stack+20264, vrr_stack+13394, vrr_stack+20066, vrr_stack+11810, vrr_stack+13328, vrr_stack+9478);
 _BUILD_f0n0(Data,vrr_stack+15638, vrr_stack+2384, vrr_stack+20264, vrr_stack+11876, vrr_stack+13394, vrr_stack+9643);
 _BUILD_g0n0(Data,vrr_stack+16298, vrr_stack+33123, vrr_stack+15638, vrr_stack+12272, vrr_stack+2384, vrr_stack+9973);
 _BUILD_h0n0(Data,vrr_stack+5168, vrr_stack+34443, vrr_stack+16298, vrr_stack+33783, vrr_stack+33123, vrr_stack+38940);
 _BUILD_h0n0(Data,vrr_stack+6554, vrr_stack+36093, vrr_stack+34443, vrr_stack+35433, vrr_stack+33783, vrr_stack+37290);
 _BUILD_i0n0(Data,vrr_stack+60720, vrr_stack+6554, vrr_stack+5168, vrr_stack+36093, vrr_stack+34443, vrr_stack+39765);
 _BUILD_00n0(Data,vrr_stack+38940, vrr_stack+1485, vrr_stack+3573, vrr_stack+1939, vrr_stack+557, NULL);
 _BUILD_p0n0(Data,vrr_stack+39006, vrr_stack+38940, vrr_stack+13592, NULL, NULL, vrr_stack+3573);
 _BUILD_d0n0(Data,vrr_stack+39204, vrr_stack+39006, vrr_stack+19868, vrr_stack+38940, vrr_stack+13592, vrr_stack+3628);
 _BUILD_f0n0(Data,vrr_stack+39600, vrr_stack+39204, vrr_stack+8433, vrr_stack+39006, vrr_stack+19868, vrr_stack+3793);
 _BUILD_g0n0(Data,vrr_stack+9478, vrr_stack+39600, vrr_stack+35433, vrr_stack+39204, vrr_stack+8433, vrr_stack+8928);
 _BUILD_h0n0(Data,vrr_stack+62568, vrr_stack+9478, vrr_stack+36093, vrr_stack+39600, vrr_stack+35433, vrr_stack+38115);
 _BUILD_i0n0(Data,vrr_stack+37083, vrr_stack+62568, vrr_stack+6554, vrr_stack+9478, vrr_stack+36093, vrr_stack+20968);
 _BUILD_00n0(Data,vrr_stack+3628, vrr_stack+1540, vrr_stack+106, vrr_stack+602, vrr_stack+6, NULL);
 _BUILD_p0n0(Data,vrr_stack+3694, vrr_stack+1045, vrr_stack+3628, NULL, NULL, vrr_stack+1540);
 _BUILD_d0n0(Data,vrr_stack+40260, vrr_stack+20066, vrr_stack+3694, vrr_stack+13328, vrr_stack+1045, vrr_stack+226);
 _BUILD_f0n0(Data,vrr_stack+20660, vrr_stack+20264, vrr_stack+40260, vrr_stack+13394, vrr_stack+20066, vrr_stack+22948);
 _BUILD_g0n0(Data,vrr_stack+63954, vrr_stack+15638, vrr_stack+20660, vrr_stack+2384, vrr_stack+20264, vrr_stack+23278);
 _BUILD_h0n0(Data,vrr_stack+64944, vrr_stack+16298, vrr_stack+63954, vrr_stack+33123, vrr_stack+15638, vrr_stack+23828);
 _BUILD_i0n0(Data,vrr_stack+66330, vrr_stack+5168, vrr_stack+64944, vrr_stack+34443, vrr_stack+16298, vrr_stack+44000);
 _BUILD_k0n0(Data,vrr_stack+68178, vrr_stack+60720, vrr_stack+66330, vrr_stack+6554, vrr_stack+5168, vrr_stack+45155);
 _BUILD_k0n0(Data,vrr_stack+44000, vrr_stack+37083, vrr_stack+60720, vrr_stack+62568, vrr_stack+6554, vrr_stack+40920);
 _BUILD_l0n0(Data,vrr_stack+70554, vrr_stack+44000, vrr_stack+68178, vrr_stack+37083, vrr_stack+60720, vrr_stack+46695);
 _BUILD_00n0(Data,vrr_stack+46376, vrr_stack+1595, vrr_stack+1485, vrr_stack+704, vrr_stack+1939, NULL);
 _BUILD_p0n0(Data,vrr_stack+46442, vrr_stack+46376, vrr_stack+38940, NULL, NULL, vrr_stack+1485);
 _BUILD_d0n0(Data,vrr_stack+46640, vrr_stack+46442, vrr_stack+39006, vrr_stack+46376, vrr_stack+38940, vrr_stack+4123);
 _BUILD_f0n0(Data,vrr_stack+47036, vrr_stack+46640, vrr_stack+39204, vrr_stack+46442, vrr_stack+39006, vrr_stack+4288);
 _BUILD_g0n0(Data,vrr_stack+22948, vrr_stack+47036, vrr_stack+39600, vrr_stack+46640, vrr_stack+39204, vrr_stack+4618);
 _BUILD_h0n0(Data,vrr_stack+40656, vrr_stack+22948, vrr_stack+9478, vrr_stack+47036, vrr_stack+39600, vrr_stack+22123);
   tmp = vrr_stack + 40656;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0n0(Data,vrr_stack+46442, vrr_stack+40656, vrr_stack+62568, vrr_stack+22948, vrr_stack+9478, vrr_stack+10523);
   tmp = vrr_stack + 46442;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0n0(Data,vrr_stack+21320, vrr_stack+46442, vrr_stack+37083, vrr_stack+40656, vrr_stack+62568, vrr_stack+42460);
   tmp = vrr_stack + 21320;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+40656, vrr_stack+21320, vrr_stack+44000, vrr_stack+46442, vrr_stack+37083, vrr_stack+48675);
   tmp = vrr_stack + 40656;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+46442, vrr_stack+50655, vrr_stack+0, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+46448, vrr_stack+50658, vrr_stack+46442, vrr_stack+3, vrr_stack+50655, NULL);
 _BUILD_00g0(Data,vrr_stack+46458, vrr_stack+51, vrr_stack+46448, vrr_stack+2268, vrr_stack+50658, NULL);
 _BUILD_00h0(Data,vrr_stack+46473, vrr_stack+50664, vrr_stack+46458, vrr_stack+2274, vrr_stack+51, NULL);
 _BUILD_00i0(Data,vrr_stack+46494, vrr_stack+50679, vrr_stack+46473, vrr_stack+2284, vrr_stack+50664, NULL);
 _BUILD_00k0(Data,vrr_stack+46522, vrr_stack+50700, vrr_stack+46494, vrr_stack+2299, vrr_stack+50679, NULL);
 _BUILD_00l0(Data,vrr_stack+46558, vrr_stack+50728, vrr_stack+46522, vrr_stack+2320, vrr_stack+50700, NULL);
 _BUILD_00m0(Data,vrr_stack+46603, vrr_stack+61, vrr_stack+46558, vrr_stack+2348, vrr_stack+50728, NULL);
 _BUILD_00n0(Data,vrr_stack+46658, vrr_stack+106, vrr_stack+46603, vrr_stack+6, vrr_stack+61, NULL);
 _BUILD_p0n0(Data,vrr_stack+46724, vrr_stack+3628, vrr_stack+46658, NULL, NULL, vrr_stack+106);
 _BUILD_d0n0(Data,vrr_stack+46922, vrr_stack+3694, vrr_stack+46724, vrr_stack+1045, vrr_stack+3628, vrr_stack+50764);
 _BUILD_f0n0(Data,vrr_stack+47318, vrr_stack+40260, vrr_stack+46922, vrr_stack+20066, vrr_stack+3694, vrr_stack+50929);
 _BUILD_g0n0(Data,vrr_stack+47978, vrr_stack+20660, vrr_stack+47318, vrr_stack+20264, vrr_stack+40260, vrr_stack+51259);
 _BUILD_h0n0(Data,vrr_stack+50764, vrr_stack+63954, vrr_stack+47978, vrr_stack+15638, vrr_stack+20660, vrr_stack+27128);
 _BUILD_i0n0(Data,vrr_stack+73524, vrr_stack+64944, vrr_stack+50764, vrr_stack+16298, vrr_stack+63954, vrr_stack+27953);
 _BUILD_k0n0(Data,vrr_stack+75372, vrr_stack+66330, vrr_stack+73524, vrr_stack+5168, vrr_stack+64944, vrr_stack+29108);
 _BUILD_l0n0(Data,vrr_stack+27128, vrr_stack+68178, vrr_stack+75372, vrr_stack+60720, vrr_stack+66330, vrr_stack+13658);
 _BUILD_m0n0(Data,vrr_stack+77748, vrr_stack+70554, vrr_stack+27128, vrr_stack+44000, vrr_stack+68178, vrr_stack+30648);
 _BUILD_m0n0(Data,vrr_stack+81378, vrr_stack+40656, vrr_stack+70554, vrr_stack+21320, vrr_stack+44000, vrr_stack+24653);
   tmp = vrr_stack + 81378;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+21320, vrr_stack+11678, vrr_stack+11810, vrr_stack+3239, vrr_stack+2174, NULL);
 _BUILD_00o0(Data,vrr_stack+21398, vrr_stack+11744, vrr_stack+11678, vrr_stack+2119, vrr_stack+3239, NULL);
 _BUILD_00o0(Data,vrr_stack+21476, vrr_stack+11810, vrr_stack+13328, vrr_stack+2174, vrr_stack+3393, NULL);
 _BUILD_p0o0(Data,vrr_stack+21554, vrr_stack+21320, vrr_stack+21476, NULL, NULL, vrr_stack+11810);
 _BUILD_p0o0(Data,vrr_stack+21788, vrr_stack+21398, vrr_stack+21320, NULL, NULL, vrr_stack+11678);
 _BUILD_d0o0(Data,vrr_stack+22022, vrr_stack+21788, vrr_stack+21554, vrr_stack+21398, vrr_stack+21320, vrr_stack+11876);
 _BUILD_00o0(Data,vrr_stack+11876, vrr_stack+12668, vrr_stack+11744, vrr_stack+990, vrr_stack+2119, NULL);
 _BUILD_p0o0(Data,vrr_stack+22490, vrr_stack+11876, vrr_stack+21398, NULL, NULL, vrr_stack+11744);
 _BUILD_d0o0(Data,vrr_stack+22724, vrr_stack+22490, vrr_stack+21788, vrr_stack+11876, vrr_stack+21398, vrr_stack+12074);
 _BUILD_00o0(Data,vrr_stack+11954, vrr_stack+13328, vrr_stack+1045, vrr_stack+3393, vrr_stack+1305, NULL);
 _BUILD_p0o0(Data,vrr_stack+12032, vrr_stack+21476, vrr_stack+11954, NULL, NULL, vrr_stack+13328);
 _BUILD_d0o0(Data,vrr_stack+23192, vrr_stack+21554, vrr_stack+12032, vrr_stack+21320, vrr_stack+21476, vrr_stack+13394);
 _BUILD_f0o0(Data,vrr_stack+23660, vrr_stack+22022, vrr_stack+23192, vrr_stack+21788, vrr_stack+21554, vrr_stack+2384);
 _BUILD_f0o0(Data,vrr_stack+13658, vrr_stack+22724, vrr_stack+22022, vrr_stack+22490, vrr_stack+21788, vrr_stack+12272);
 _BUILD_g0o0(Data,vrr_stack+14438, vrr_stack+13658, vrr_stack+23660, vrr_stack+22724, vrr_stack+22022, vrr_stack+33123);
 _BUILD_00o0(Data,vrr_stack+13394, vrr_stack+13592, vrr_stack+12668, vrr_stack+3573, vrr_stack+990, NULL);
 _BUILD_p0o0(Data,vrr_stack+12266, vrr_stack+13394, vrr_stack+11876, NULL, NULL, vrr_stack+12668);
 _BUILD_d0o0(Data,vrr_stack+30098, vrr_stack+12266, vrr_stack+22490, vrr_stack+13394, vrr_stack+11876, vrr_stack+12734);
 _BUILD_f0o0(Data,vrr_stack+30566, vrr_stack+30098, vrr_stack+22724, vrr_stack+12266, vrr_stack+22490, vrr_stack+12932);
 _BUILD_g0o0(Data,vrr_stack+31346, vrr_stack+30566, vrr_stack+13658, vrr_stack+30098, vrr_stack+22724, vrr_stack+33783);
 _BUILD_00o0(Data,vrr_stack+12734, vrr_stack+1045, vrr_stack+3628, vrr_stack+1305, vrr_stack+1540, NULL);
 _BUILD_p0o0(Data,vrr_stack+12812, vrr_stack+11954, vrr_stack+12734, NULL, NULL, vrr_stack+1045);
 _BUILD_d0o0(Data,vrr_stack+32516, vrr_stack+12032, vrr_stack+12812, vrr_stack+21476, vrr_stack+11954, vrr_stack+20066);
 _BUILD_f0o0(Data,vrr_stack+32984, vrr_stack+23192, vrr_stack+32516, vrr_stack+21554, vrr_stack+12032, vrr_stack+20264);
 _BUILD_g0o0(Data,vrr_stack+48968, vrr_stack+23660, vrr_stack+32984, vrr_stack+22022, vrr_stack+23192, vrr_stack+15638);
 _BUILD_h0o0(Data,vrr_stack+1650, vrr_stack+14438, vrr_stack+48968, vrr_stack+13658, vrr_stack+23660, vrr_stack+16298);
 _BUILD_h0o0(Data,vrr_stack+15608, vrr_stack+31346, vrr_stack+14438, vrr_stack+30566, vrr_stack+13658, vrr_stack+34443);
 _BUILD_i0o0(Data,vrr_stack+85008, vrr_stack+15608, vrr_stack+1650, vrr_stack+31346, vrr_stack+14438, vrr_stack+5168);
 _BUILD_00o0(Data,vrr_stack+20066, vrr_stack+38940, vrr_stack+13592, vrr_stack+1485, vrr_stack+3573, NULL);
 _BUILD_p0o0(Data,vrr_stack+20144, vrr_stack+20066, vrr_stack+13394, NULL, NULL, vrr_stack+13592);
 _BUILD_d0o0(Data,vrr_stack+33764, vrr_stack+20144, vrr_stack+12266, vrr_stack+20066, vrr_stack+13394, vrr_stack+19868);
 _BUILD_f0o0(Data,vrr_stack+34232, vrr_stack+33764, vrr_stack+30098, vrr_stack+20144, vrr_stack+12266, vrr_stack+8433);
 _BUILD_g0o0(Data,vrr_stack+3892, vrr_stack+34232, vrr_stack+30566, vrr_stack+33764, vrr_stack+30098, vrr_stack+35433);
 _BUILD_h0o0(Data,vrr_stack+87192, vrr_stack+3892, vrr_stack+31346, vrr_stack+34232, vrr_stack+30566, vrr_stack+36093);
 _BUILD_i0o0(Data,vrr_stack+88830, vrr_stack+87192, vrr_stack+15608, vrr_stack+3892, vrr_stack+31346, vrr_stack+6554);
 _BUILD_00o0(Data,vrr_stack+19868, vrr_stack+3628, vrr_stack+46658, vrr_stack+1540, vrr_stack+106, NULL);
 _BUILD_p0o0(Data,vrr_stack+20378, vrr_stack+12734, vrr_stack+19868, NULL, NULL, vrr_stack+3628);
 _BUILD_d0o0(Data,vrr_stack+35012, vrr_stack+12812, vrr_stack+20378, vrr_stack+11954, vrr_stack+12734, vrr_stack+3694);
 _BUILD_f0o0(Data,vrr_stack+35480, vrr_stack+32516, vrr_stack+35012, vrr_stack+12032, vrr_stack+12812, vrr_stack+40260);
 _BUILD_g0o0(Data,vrr_stack+5062, vrr_stack+32984, vrr_stack+35480, vrr_stack+23192, vrr_stack+32516, vrr_stack+20660);
 _BUILD_h0o0(Data,vrr_stack+6232, vrr_stack+48968, vrr_stack+5062, vrr_stack+23660, vrr_stack+32984, vrr_stack+63954);
 _BUILD_i0o0(Data,vrr_stack+91014, vrr_stack+1650, vrr_stack+6232, vrr_stack+14438, vrr_stack+48968, vrr_stack+64944);
 _BUILD_k0o0(Data,vrr_stack+93198, vrr_stack+85008, vrr_stack+91014, vrr_stack+15608, vrr_stack+1650, vrr_stack+66330);
 _BUILD_k0o0(Data,vrr_stack+63954, vrr_stack+88830, vrr_stack+85008, vrr_stack+87192, vrr_stack+15608, vrr_stack+60720);
 _BUILD_l0o0(Data,vrr_stack+96006, vrr_stack+63954, vrr_stack+93198, vrr_stack+88830, vrr_stack+85008, vrr_stack+68178);
 _BUILD_00o0(Data,vrr_stack+60720, vrr_stack+46376, vrr_stack+38940, vrr_stack+1595, vrr_stack+1485, NULL);
 _BUILD_p0o0(Data,vrr_stack+60798, vrr_stack+60720, vrr_stack+20066, NULL, NULL, vrr_stack+38940);
 _BUILD_d0o0(Data,vrr_stack+61032, vrr_stack+60798, vrr_stack+20144, vrr_stack+60720, vrr_stack+20066, vrr_stack+39006);
 _BUILD_f0o0(Data,vrr_stack+61500, vrr_stack+61032, vrr_stack+33764, vrr_stack+60798, vrr_stack+20144, vrr_stack+39204);
 _BUILD_g0o0(Data,vrr_stack+66762, vrr_stack+61500, vrr_stack+34232, vrr_stack+61032, vrr_stack+33764, vrr_stack+39600);
 _BUILD_h0o0(Data,vrr_stack+39006, vrr_stack+66762, vrr_stack+3892, vrr_stack+61500, vrr_stack+34232, vrr_stack+9478);
   tmp = vrr_stack + 39006;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0o0(Data,vrr_stack+67932, vrr_stack+39006, vrr_stack+87192, vrr_stack+66762, vrr_stack+3892, vrr_stack+62568);
   tmp = vrr_stack + 67932;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0o0(Data,vrr_stack+60798, vrr_stack+67932, vrr_stack+88830, vrr_stack+39006, vrr_stack+87192, vrr_stack+37083);
   tmp = vrr_stack + 60798;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0o0(Data,vrr_stack+7870, vrr_stack+60798, vrr_stack+63954, vrr_stack+67932, vrr_stack+88830, vrr_stack+44000);
   tmp = vrr_stack + 7870;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+39006, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+39009, vrr_stack+0, vrr_stack+39006, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+39015, vrr_stack+46442, vrr_stack+39009, vrr_stack+50655, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+39025, vrr_stack+46448, vrr_stack+39015, vrr_stack+50658, vrr_stack+46442, NULL);
 _BUILD_00h0(Data,vrr_stack+39040, vrr_stack+46458, vrr_stack+39025, vrr_stack+51, vrr_stack+46448, NULL);
 _BUILD_00i0(Data,vrr_stack+39061, vrr_stack+46473, vrr_stack+39040, vrr_stack+50664, vrr_stack+46458, NULL);
 _BUILD_00k0(Data,vrr_stack+39089, vrr_stack+46494, vrr_stack+39061, vrr_stack+50679, vrr_stack+46473, NULL);
 _BUILD_00l0(Data,vrr_stack+52150, vrr_stack+46522, vrr_stack+39089, vrr_stack+50700, vrr_stack+46494, NULL);
 _BUILD_00m0(Data,vrr_stack+39125, vrr_stack+46558, vrr_stack+52150, vrr_stack+50728, vrr_stack+46522, NULL);
 _BUILD_00n0(Data,vrr_stack+39180, vrr_stack+46603, vrr_stack+39125, vrr_stack+61, vrr_stack+46558, NULL);
 _BUILD_00o0(Data,vrr_stack+39246, vrr_stack+46658, vrr_stack+39180, vrr_stack+106, vrr_stack+46603, NULL);
 _BUILD_p0o0(Data,vrr_stack+39324, vrr_stack+19868, vrr_stack+39246, NULL, NULL, vrr_stack+46658);
 _BUILD_d0o0(Data,vrr_stack+39558, vrr_stack+20378, vrr_stack+39324, vrr_stack+12734, vrr_stack+19868, vrr_stack+46724);
 _BUILD_f0o0(Data,vrr_stack+66762, vrr_stack+35012, vrr_stack+39558, vrr_stack+12812, vrr_stack+20378, vrr_stack+46922);
 _BUILD_g0o0(Data,vrr_stack+67542, vrr_stack+35480, vrr_stack+66762, vrr_stack+32516, vrr_stack+35012, vrr_stack+47318);
 _BUILD_h0o0(Data,vrr_stack+68712, vrr_stack+5062, vrr_stack+67542, vrr_stack+32984, vrr_stack+35480, vrr_stack+47978);
 _BUILD_i0o0(Data,vrr_stack+46724, vrr_stack+6232, vrr_stack+68712, vrr_stack+48968, vrr_stack+5062, vrr_stack+50764);
 _BUILD_k0o0(Data,vrr_stack+99516, vrr_stack+91014, vrr_stack+46724, vrr_stack+1650, vrr_stack+6232, vrr_stack+73524);
 _BUILD_l0o0(Data,vrr_stack+102324, vrr_stack+93198, vrr_stack+99516, vrr_stack+85008, vrr_stack+91014, vrr_stack+75372);
 _BUILD_m0o0(Data,vrr_stack+105834, vrr_stack+96006, vrr_stack+102324, vrr_stack+63954, vrr_stack+93198, vrr_stack+27128);
 _BUILD_m0o0(Data,vrr_stack+110124, vrr_stack+7870, vrr_stack+96006, vrr_stack+60798, vrr_stack+63954, vrr_stack+70554);
   tmp = vrr_stack + 110124;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+60798, vrr_stack+21320, vrr_stack+21476, vrr_stack+11678, vrr_stack+11810, NULL);
 _BUILD_00q0(Data,vrr_stack+60889, vrr_stack+21398, vrr_stack+21320, vrr_stack+11744, vrr_stack+11678, NULL);
 _BUILD_00q0(Data,vrr_stack+60980, vrr_stack+21476, vrr_stack+11954, vrr_stack+11810, vrr_stack+13328, NULL);
 _BUILD_p0q0(Data,vrr_stack+61071, vrr_stack+60798, vrr_stack+60980, NULL, NULL, vrr_stack+21476);
 _BUILD_p0q0(Data,vrr_stack+61344, vrr_stack+60889, vrr_stack+60798, NULL, NULL, vrr_stack+21320);
 _BUILD_d0q0(Data,vrr_stack+61617, vrr_stack+61344, vrr_stack+61071, vrr_stack+60889, vrr_stack+60798, vrr_stack+21554);
 _BUILD_00q0(Data,vrr_stack+21476, vrr_stack+11876, vrr_stack+21398, vrr_stack+12668, vrr_stack+11744, NULL);
 _BUILD_p0q0(Data,vrr_stack+62163, vrr_stack+21476, vrr_stack+60889, NULL, NULL, vrr_stack+21398);
 _BUILD_d0q0(Data,vrr_stack+62436, vrr_stack+62163, vrr_stack+61344, vrr_stack+21476, vrr_stack+60889, vrr_stack+21788);
 _BUILD_00q0(Data,vrr_stack+60889, vrr_stack+11954, vrr_stack+12734, vrr_stack+13328, vrr_stack+1045, NULL);
 _BUILD_p0q0(Data,vrr_stack+21567, vrr_stack+60980, vrr_stack+60889, NULL, NULL, vrr_stack+11954);
 _BUILD_d0q0(Data,vrr_stack+62982, vrr_stack+61071, vrr_stack+21567, vrr_stack+60798, vrr_stack+60980, vrr_stack+12032);
 _BUILD_f0q0(Data,vrr_stack+27128, vrr_stack+61617, vrr_stack+62982, vrr_stack+61344, vrr_stack+61071, vrr_stack+23192);
 _BUILD_f0q0(Data,vrr_stack+28038, vrr_stack+62436, vrr_stack+61617, vrr_stack+62163, vrr_stack+61344, vrr_stack+22022);
 _BUILD_g0q0(Data,vrr_stack+73524, vrr_stack+28038, vrr_stack+27128, vrr_stack+62436, vrr_stack+61617, vrr_stack+23660);
 _BUILD_00q0(Data,vrr_stack+60798, vrr_stack+13394, vrr_stack+11876, vrr_stack+13592, vrr_stack+12668, NULL);
 _BUILD_p0q0(Data,vrr_stack+61344, vrr_stack+60798, vrr_stack+21476, NULL, NULL, vrr_stack+11876);
 _BUILD_d0q0(Data,vrr_stack+23192, vrr_stack+61344, vrr_stack+62163, vrr_stack+60798, vrr_stack+21476, vrr_stack+22490);
 _BUILD_f0q0(Data,vrr_stack+23738, vrr_stack+23192, vrr_stack+62436, vrr_stack+61344, vrr_stack+62163, vrr_stack+22724);
 _BUILD_g0q0(Data,vrr_stack+74889, vrr_stack+23738, vrr_stack+28038, vrr_stack+23192, vrr_stack+62436, vrr_stack+13658);
 _BUILD_00q0(Data,vrr_stack+13658, vrr_stack+12734, vrr_stack+19868, vrr_stack+1045, vrr_stack+3628, NULL);
 _BUILD_p0q0(Data,vrr_stack+13749, vrr_stack+60889, vrr_stack+13658, NULL, NULL, vrr_stack+12734);
 _BUILD_d0q0(Data,vrr_stack+62163, vrr_stack+21567, vrr_stack+13749, vrr_stack+60980, vrr_stack+60889, vrr_stack+12812);
 _BUILD_f0q0(Data,vrr_stack+21840, vrr_stack+62982, vrr_stack+62163, vrr_stack+61071, vrr_stack+21567, vrr_stack+32516);
 _BUILD_g0q0(Data,vrr_stack+76254, vrr_stack+27128, vrr_stack+21840, vrr_stack+61617, vrr_stack+62982, vrr_stack+32984);
 _BUILD_h0q0(Data,vrr_stack+36260, vrr_stack+73524, vrr_stack+76254, vrr_stack+28038, vrr_stack+27128, vrr_stack+48968);
 _BUILD_h0q0(Data,vrr_stack+48908, vrr_stack+74889, vrr_stack+73524, vrr_stack+23738, vrr_stack+28038, vrr_stack+14438);
 _BUILD_i0q0(Data,vrr_stack+43626, vrr_stack+48908, vrr_stack+36260, vrr_stack+74889, vrr_stack+73524, vrr_stack+1650);
 _BUILD_00q0(Data,vrr_stack+28038, vrr_stack+20066, vrr_stack+13394, vrr_stack+38940, vrr_stack+13592, NULL);
 _BUILD_p0q0(Data,vrr_stack+62709, vrr_stack+28038, vrr_stack+60798, NULL, NULL, vrr_stack+13394);
 _BUILD_d0q0(Data,vrr_stack+61617, vrr_stack+62709, vrr_stack+61344, vrr_stack+28038, vrr_stack+60798, vrr_stack+12266);
 _BUILD_f0q0(Data,vrr_stack+28129, vrr_stack+61617, vrr_stack+23192, vrr_stack+62709, vrr_stack+61344, vrr_stack+30098);
 _BUILD_g0q0(Data,vrr_stack+29039, vrr_stack+28129, vrr_stack+23738, vrr_stack+61617, vrr_stack+23192, vrr_stack+30566);
 _BUILD_h0q0(Data,vrr_stack+3, vrr_stack+29039, vrr_stack+74889, vrr_stack+28129, vrr_stack+23738, vrr_stack+31346);
 _BUILD_i0q0(Data,vrr_stack+30404, vrr_stack+3, vrr_stack+48908, vrr_stack+29039, vrr_stack+74889, vrr_stack+15608);
 _BUILD_00q0(Data,vrr_stack+60798, vrr_stack+19868, vrr_stack+39246, vrr_stack+3628, vrr_stack+46658, NULL);
 _BUILD_p0q0(Data,vrr_stack+74889, vrr_stack+13658, vrr_stack+60798, NULL, NULL, vrr_stack+19868);
 _BUILD_d0q0(Data,vrr_stack+75162, vrr_stack+13749, vrr_stack+74889, vrr_stack+60889, vrr_stack+13658, vrr_stack+20378);
 _BUILD_f0q0(Data,vrr_stack+20378, vrr_stack+62163, vrr_stack+75162, vrr_stack+21567, vrr_stack+13749, vrr_stack+35012);
 _BUILD_g0q0(Data,vrr_stack+14022, vrr_stack+21840, vrr_stack+20378, vrr_stack+62982, vrr_stack+62163, vrr_stack+35480);
 _BUILD_h0q0(Data,vrr_stack+15387, vrr_stack+76254, vrr_stack+14022, vrr_stack+27128, vrr_stack+21840, vrr_stack+5062);
 _BUILD_i0q0(Data,vrr_stack+114414, vrr_stack+36260, vrr_stack+15387, vrr_stack+73524, vrr_stack+76254, vrr_stack+6232);
 _BUILD_k0q0(Data,vrr_stack+116962, vrr_stack+43626, vrr_stack+114414, vrr_stack+48908, vrr_stack+36260, vrr_stack+91014);
 _BUILD_k0q0(Data,vrr_stack+120238, vrr_stack+30404, vrr_stack+43626, vrr_stack+3, vrr_stack+48908, vrr_stack+85008);
 _BUILD_l0q0(Data,vrr_stack+123514, vrr_stack+120238, vrr_stack+116962, vrr_stack+30404, vrr_stack+43626, vrr_stack+93198);
 _BUILD_00q0(Data,vrr_stack+85008, vrr_stack+60720, vrr_stack+20066, vrr_stack+46376, vrr_stack+38940, NULL);
 _BUILD_p0q0(Data,vrr_stack+85099, vrr_stack+85008, vrr_stack+28038, NULL, NULL, vrr_stack+20066);
 _BUILD_d0q0(Data,vrr_stack+75708, vrr_stack+85099, vrr_stack+62709, vrr_stack+85008, vrr_stack+28038, vrr_stack+20144);
 _BUILD_f0q0(Data,vrr_stack+85372, vrr_stack+75708, vrr_stack+61617, vrr_stack+85099, vrr_stack+62709, vrr_stack+33764);
 _BUILD_g0q0(Data,vrr_stack+73524, vrr_stack+85372, vrr_stack+28129, vrr_stack+75708, vrr_stack+61617, vrr_stack+34232);
 _BUILD_h0q0(Data,vrr_stack+48908, vrr_stack+73524, vrr_stack+29039, vrr_stack+85372, vrr_stack+28129, vrr_stack+3892);
   tmp = vrr_stack + 48908;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0q0(Data,vrr_stack+91014, vrr_stack+48908, vrr_stack+3, vrr_stack+73524, vrr_stack+29039, vrr_stack+87192);
   tmp = vrr_stack + 91014;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0q0(Data,vrr_stack+27128, vrr_stack+91014, vrr_stack+30404, vrr_stack+48908, vrr_stack+3, vrr_stack+88830);
   tmp = vrr_stack + 27128;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0q0(Data,vrr_stack+3, vrr_stack+27128, vrr_stack+120238, vrr_stack+91014, vrr_stack+30404, vrr_stack+63954);
   tmp = vrr_stack + 3;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+30404, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+30407, vrr_stack+39006, vrr_stack+30404, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+30413, vrr_stack+39009, vrr_stack+30407, vrr_stack+0, vrr_stack+39006, NULL);
 _BUILD_00g0(Data,vrr_stack+30423, vrr_stack+39015, vrr_stack+30413, vrr_stack+46442, vrr_stack+39009, NULL);
 _BUILD_00h0(Data,vrr_stack+30438, vrr_stack+39025, vrr_stack+30423, vrr_stack+46448, vrr_stack+39015, NULL);
 _BUILD_00i0(Data,vrr_stack+30404, vrr_stack+39040, vrr_stack+30438, vrr_stack+46458, vrr_stack+39025, NULL);
 _BUILD_00k0(Data,vrr_stack+30432, vrr_stack+39061, vrr_stack+30404, vrr_stack+46473, vrr_stack+39040, NULL);
 _BUILD_00l0(Data,vrr_stack+30468, vrr_stack+39089, vrr_stack+30432, vrr_stack+46494, vrr_stack+39061, NULL);
 _BUILD_00m0(Data,vrr_stack+30404, vrr_stack+52150, vrr_stack+30468, vrr_stack+46522, vrr_stack+39089, NULL);
 _BUILD_00n0(Data,vrr_stack+30459, vrr_stack+39125, vrr_stack+30404, vrr_stack+46558, vrr_stack+52150, NULL);
 _BUILD_00o0(Data,vrr_stack+60720, vrr_stack+39180, vrr_stack+30459, vrr_stack+46603, vrr_stack+39125, NULL);
 _BUILD_00q0(Data,vrr_stack+30404, vrr_stack+39246, vrr_stack+60720, vrr_stack+46658, vrr_stack+39180, NULL);
 _BUILD_p0q0(Data,vrr_stack+30495, vrr_stack+60798, vrr_stack+30404, NULL, NULL, vrr_stack+39246);
 _BUILD_d0q0(Data,vrr_stack+75708, vrr_stack+74889, vrr_stack+30495, vrr_stack+13658, vrr_stack+60798, vrr_stack+39324);
 _BUILD_f0q0(Data,vrr_stack+30404, vrr_stack+75162, vrr_stack+75708, vrr_stack+13749, vrr_stack+74889, vrr_stack+39558);
 _BUILD_g0q0(Data,vrr_stack+31314, vrr_stack+20378, vrr_stack+30404, vrr_stack+62163, vrr_stack+75162, vrr_stack+66762);
 _BUILD_h0q0(Data,vrr_stack+32679, vrr_stack+14022, vrr_stack+31314, vrr_stack+21840, vrr_stack+20378, vrr_stack+67542);
 _BUILD_i0q0(Data,vrr_stack+60720, vrr_stack+15387, vrr_stack+32679, vrr_stack+76254, vrr_stack+14022, vrr_stack+68712);
 _BUILD_k0q0(Data,vrr_stack+30404, vrr_stack+114414, vrr_stack+60720, vrr_stack+36260, vrr_stack+15387, vrr_stack+46724);
 _BUILD_l0q0(Data,vrr_stack+60720, vrr_stack+116962, vrr_stack+30404, vrr_stack+43626, vrr_stack+114414, vrr_stack+99516);
 _BUILD_m0q0(Data,vrr_stack+43626, vrr_stack+123514, vrr_stack+60720, vrr_stack+120238, vrr_stack+116962, vrr_stack+102324);
 _BUILD_m0q0(Data,vrr_stack+60720, vrr_stack+3, vrr_stack+123514, vrr_stack+27128, vrr_stack+120238, vrr_stack+96006);
   tmp = vrr_stack + 60720;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0m0(Data,vrr_stack+27128, vrr_stack+57695, vrr_stack+54670, vrr_stack+52195, vrr_stack+24653, vrr_stack+17393);
   tmp = vrr_stack + 27128;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0n0(Data,vrr_stack+30758, vrr_stack+81378, vrr_stack+77748, vrr_stack+40656, vrr_stack+70554, vrr_stack+54670);
   tmp = vrr_stack + 30758;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0o0(Data,vrr_stack+81378, vrr_stack+110124, vrr_stack+105834, vrr_stack+7870, vrr_stack+96006, vrr_stack+77748);
   tmp = vrr_stack + 81378;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0q0(Data,vrr_stack+110124, vrr_stack+60720, vrr_stack+43626, vrr_stack+3, vrr_stack+123514, vrr_stack+105834);
   tmp = vrr_stack + 110124;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];

}

