/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (id|kf) integrals */

void vrr_order_idkf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+12, vrr_stack+3, vrr_stack+9, NULL, NULL, Data->F+8);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+3, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+21, vrr_stack+12, vrr_stack+6, vrr_stack+3, vrr_stack+0);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+3, vrr_stack+9, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+6, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+6, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+6);
 _BUILD_00p0(Data,vrr_stack+102, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+105, vrr_stack+9, vrr_stack+102, Data->F+8, Data->F+9, NULL);
 _BUILD_p0d0(Data,vrr_stack+111, vrr_stack+48, vrr_stack+105, NULL, NULL, vrr_stack+9);
 _BUILD_d0d0(Data,vrr_stack+129, vrr_stack+60, vrr_stack+111, vrr_stack+54, vrr_stack+48, vrr_stack+12);
 _BUILD_d0d0(Data,vrr_stack+165, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+201, vrr_stack+165, vrr_stack+129, vrr_stack+84, vrr_stack+60, vrr_stack+30);
 _BUILD_00f0(Data,vrr_stack+12, vrr_stack+54, vrr_stack+48, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00f0(Data,vrr_stack+22, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00f0(Data,vrr_stack+32, vrr_stack+48, vrr_stack+105, vrr_stack+3, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+261, vrr_stack+12, vrr_stack+32, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+291, vrr_stack+22, vrr_stack+12, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+321, vrr_stack+291, vrr_stack+261, vrr_stack+22, vrr_stack+12, vrr_stack+60);
 _BUILD_00p0(Data,vrr_stack+60, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+60, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+63, vrr_stack+3, vrr_stack+78, vrr_stack+60, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+381, vrr_stack+63, vrr_stack+22, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+411, vrr_stack+381, vrr_stack+291, vrr_stack+63, vrr_stack+22, vrr_stack+84);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+42, vrr_stack+102, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+105, vrr_stack+42, vrr_stack+9, vrr_stack+102, NULL);
 _BUILD_p0f0(Data,vrr_stack+471, vrr_stack+32, vrr_stack+84, NULL, NULL, vrr_stack+105);
 _BUILD_d0f0(Data,vrr_stack+501, vrr_stack+261, vrr_stack+471, vrr_stack+12, vrr_stack+32, vrr_stack+111);
 _BUILD_f0f0(Data,vrr_stack+561, vrr_stack+321, vrr_stack+501, vrr_stack+291, vrr_stack+261, vrr_stack+129);
 _BUILD_f0f0(Data,vrr_stack+661, vrr_stack+411, vrr_stack+321, vrr_stack+381, vrr_stack+291, vrr_stack+165);
 _BUILD_g0f0(Data,vrr_stack+761, vrr_stack+661, vrr_stack+561, vrr_stack+411, vrr_stack+321, vrr_stack+201);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+12, vrr_stack+32, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+126, vrr_stack+22, vrr_stack+12, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+141, vrr_stack+126, vrr_stack+111, NULL, NULL, vrr_stack+12);
 _BUILD_00g0(Data,vrr_stack+186, vrr_stack+63, vrr_stack+22, vrr_stack+3, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+201, vrr_stack+186, vrr_stack+126, NULL, NULL, vrr_stack+22);
 _BUILD_00g0(Data,vrr_stack+246, vrr_stack+32, vrr_stack+84, vrr_stack+48, vrr_stack+105, NULL);
 _BUILD_p0g0(Data,vrr_stack+911, vrr_stack+111, vrr_stack+246, NULL, NULL, vrr_stack+32);
 _BUILD_d0g0(Data,vrr_stack+956, vrr_stack+141, vrr_stack+911, vrr_stack+126, vrr_stack+111, vrr_stack+261);
 _BUILD_d0g0(Data,vrr_stack+1046, vrr_stack+201, vrr_stack+141, vrr_stack+186, vrr_stack+126, vrr_stack+291);
 _BUILD_f0g0(Data,vrr_stack+1136, vrr_stack+1046, vrr_stack+956, vrr_stack+201, vrr_stack+141, vrr_stack+321);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+261, vrr_stack+9, vrr_stack+60, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+267, vrr_stack+261, vrr_stack+3, vrr_stack+9, vrr_stack+60, NULL);
 _BUILD_00g0(Data,vrr_stack+48, vrr_stack+267, vrr_stack+63, vrr_stack+261, vrr_stack+3, NULL);
 _BUILD_p0g0(Data,vrr_stack+277, vrr_stack+48, vrr_stack+186, NULL, NULL, vrr_stack+63);
 _BUILD_d0g0(Data,vrr_stack+1286, vrr_stack+277, vrr_stack+201, vrr_stack+48, vrr_stack+186, vrr_stack+381);
 _BUILD_f0g0(Data,vrr_stack+1376, vrr_stack+1286, vrr_stack+1046, vrr_stack+277, vrr_stack+201, vrr_stack+411);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+322, vrr_stack+0, vrr_stack+3, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+328, vrr_stack+42, vrr_stack+322, vrr_stack+102, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+338, vrr_stack+84, vrr_stack+328, vrr_stack+105, vrr_stack+42, NULL);
 _BUILD_p0g0(Data,vrr_stack+353, vrr_stack+246, vrr_stack+338, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+1526, vrr_stack+911, vrr_stack+353, vrr_stack+111, vrr_stack+246, vrr_stack+471);
 _BUILD_f0g0(Data,vrr_stack+1616, vrr_stack+956, vrr_stack+1526, vrr_stack+141, vrr_stack+911, vrr_stack+501);
 _BUILD_g0g0(Data,vrr_stack+1766, vrr_stack+1136, vrr_stack+1616, vrr_stack+1046, vrr_stack+956, vrr_stack+561);
 _BUILD_g0g0(Data,vrr_stack+398, vrr_stack+1376, vrr_stack+1136, vrr_stack+1286, vrr_stack+1046, vrr_stack+661);
 _BUILD_h0g0(Data,vrr_stack+1991, vrr_stack+398, vrr_stack+1766, vrr_stack+1376, vrr_stack+1136, vrr_stack+761);
 _BUILD_00h0(Data,vrr_stack+623, vrr_stack+126, vrr_stack+111, vrr_stack+22, vrr_stack+12, NULL);
 _BUILD_00h0(Data,vrr_stack+644, vrr_stack+186, vrr_stack+126, vrr_stack+63, vrr_stack+22, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+111, vrr_stack+246, vrr_stack+12, vrr_stack+32, NULL);
 _BUILD_p0h0(Data,vrr_stack+686, vrr_stack+623, vrr_stack+665, NULL, NULL, vrr_stack+111);
 _BUILD_p0h0(Data,vrr_stack+749, vrr_stack+644, vrr_stack+623, NULL, NULL, vrr_stack+126);
 _BUILD_d0h0(Data,vrr_stack+2306, vrr_stack+749, vrr_stack+686, vrr_stack+644, vrr_stack+623, vrr_stack+141);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+48, vrr_stack+186, vrr_stack+267, vrr_stack+63, NULL);
 _BUILD_p0h0(Data,vrr_stack+812, vrr_stack+141, vrr_stack+644, NULL, NULL, vrr_stack+186);
 _BUILD_d0h0(Data,vrr_stack+2432, vrr_stack+812, vrr_stack+749, vrr_stack+141, vrr_stack+644, vrr_stack+201);
 _BUILD_00h0(Data,vrr_stack+63, vrr_stack+246, vrr_stack+338, vrr_stack+32, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+2558, vrr_stack+665, vrr_stack+63, NULL, NULL, vrr_stack+246);
 _BUILD_d0h0(Data,vrr_stack+2621, vrr_stack+686, vrr_stack+2558, vrr_stack+623, vrr_stack+665, vrr_stack+911);
 _BUILD_f0h0(Data,vrr_stack+2747, vrr_stack+2306, vrr_stack+2621, vrr_stack+749, vrr_stack+686, vrr_stack+956);
 _BUILD_f0h0(Data,vrr_stack+2957, vrr_stack+2432, vrr_stack+2306, vrr_stack+812, vrr_stack+749, vrr_stack+1046);
 _BUILD_g0h0(Data,vrr_stack+3167, vrr_stack+2957, vrr_stack+2747, vrr_stack+2432, vrr_stack+2306, vrr_stack+1136);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+6, vrr_stack+9, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+201, vrr_stack+261, vrr_stack+6, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+9, vrr_stack+207, vrr_stack+267, vrr_stack+201, vrr_stack+261, NULL);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+9, vrr_stack+48, vrr_stack+207, vrr_stack+267, NULL);
 _BUILD_p0h0(Data,vrr_stack+875, vrr_stack+217, vrr_stack+141, NULL, NULL, vrr_stack+48);
 _BUILD_d0h0(Data,vrr_stack+938, vrr_stack+875, vrr_stack+812, vrr_stack+217, vrr_stack+141, vrr_stack+277);
 _BUILD_f0h0(Data,vrr_stack+1064, vrr_stack+938, vrr_stack+2432, vrr_stack+875, vrr_stack+812, vrr_stack+1286);
 _BUILD_g0h0(Data,vrr_stack+3482, vrr_stack+1064, vrr_stack+2957, vrr_stack+938, vrr_stack+2432, vrr_stack+1376);
 _BUILD_00p0(Data,vrr_stack+261, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+264, vrr_stack+3, vrr_stack+261, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+270, vrr_stack+322, vrr_stack+264, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+280, vrr_stack+328, vrr_stack+270, vrr_stack+42, vrr_stack+322, NULL);
 _BUILD_00h0(Data,vrr_stack+295, vrr_stack+338, vrr_stack+280, vrr_stack+84, vrr_stack+328, NULL);
 _BUILD_p0h0(Data,vrr_stack+1274, vrr_stack+63, vrr_stack+295, NULL, NULL, vrr_stack+338);
 _BUILD_d0h0(Data,vrr_stack+1337, vrr_stack+2558, vrr_stack+1274, vrr_stack+665, vrr_stack+63, vrr_stack+353);
 _BUILD_f0h0(Data,vrr_stack+3797, vrr_stack+2621, vrr_stack+1337, vrr_stack+686, vrr_stack+2558, vrr_stack+1526);
 _BUILD_g0h0(Data,vrr_stack+4007, vrr_stack+2747, vrr_stack+3797, vrr_stack+2306, vrr_stack+2621, vrr_stack+1616);
 _BUILD_h0h0(Data,vrr_stack+4322, vrr_stack+3167, vrr_stack+4007, vrr_stack+2957, vrr_stack+2747, vrr_stack+1766);
 _BUILD_h0h0(Data,vrr_stack+1463, vrr_stack+3482, vrr_stack+3167, vrr_stack+1064, vrr_stack+2957, vrr_stack+398);
 _BUILD_i0h0(Data,vrr_stack+4763, vrr_stack+1463, vrr_stack+4322, vrr_stack+3482, vrr_stack+3167, vrr_stack+1991);
 _BUILD_00i0(Data,vrr_stack+353, vrr_stack+623, vrr_stack+665, vrr_stack+126, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+381, vrr_stack+644, vrr_stack+623, vrr_stack+186, vrr_stack+126, NULL);
 _BUILD_p0i0(Data,vrr_stack+409, vrr_stack+381, vrr_stack+353, NULL, NULL, vrr_stack+623);
 _BUILD_00i0(Data,vrr_stack+493, vrr_stack+141, vrr_stack+644, vrr_stack+48, vrr_stack+186, NULL);
 _BUILD_p0i0(Data,vrr_stack+521, vrr_stack+493, vrr_stack+381, NULL, NULL, vrr_stack+644);
 _BUILD_00i0(Data,vrr_stack+162, vrr_stack+665, vrr_stack+63, vrr_stack+111, vrr_stack+246, NULL);
 _BUILD_p0i0(Data,vrr_stack+1904, vrr_stack+353, vrr_stack+162, NULL, NULL, vrr_stack+665);
 _BUILD_d0i0(Data,vrr_stack+1988, vrr_stack+409, vrr_stack+1904, vrr_stack+381, vrr_stack+353, vrr_stack+686);
 _BUILD_d0i0(Data,vrr_stack+5351, vrr_stack+521, vrr_stack+409, vrr_stack+493, vrr_stack+381, vrr_stack+749);
 _BUILD_f0i0(Data,vrr_stack+5519, vrr_stack+5351, vrr_stack+1988, vrr_stack+521, vrr_stack+409, vrr_stack+2306);
 _BUILD_00i0(Data,vrr_stack+686, vrr_stack+217, vrr_stack+141, vrr_stack+9, vrr_stack+48, NULL);
 _BUILD_p0i0(Data,vrr_stack+714, vrr_stack+686, vrr_stack+493, NULL, NULL, vrr_stack+141);
 _BUILD_d0i0(Data,vrr_stack+2156, vrr_stack+714, vrr_stack+521, vrr_stack+686, vrr_stack+493, vrr_stack+812);
 _BUILD_f0i0(Data,vrr_stack+5799, vrr_stack+2156, vrr_stack+5351, vrr_stack+714, vrr_stack+521, vrr_stack+2432);
 _BUILD_00i0(Data,vrr_stack+798, vrr_stack+63, vrr_stack+295, vrr_stack+246, vrr_stack+338, NULL);
 _BUILD_p0i0(Data,vrr_stack+2324, vrr_stack+162, vrr_stack+798, NULL, NULL, vrr_stack+63);
 _BUILD_d0i0(Data,vrr_stack+6079, vrr_stack+1904, vrr_stack+2324, vrr_stack+353, vrr_stack+162, vrr_stack+2558);
 _BUILD_f0i0(Data,vrr_stack+6247, vrr_stack+1988, vrr_stack+6079, vrr_stack+409, vrr_stack+1904, vrr_stack+2621);
 _BUILD_g0i0(Data,vrr_stack+6527, vrr_stack+5519, vrr_stack+6247, vrr_stack+5351, vrr_stack+1988, vrr_stack+2747);
 _BUILD_g0i0(Data,vrr_stack+2408, vrr_stack+5799, vrr_stack+5519, vrr_stack+2156, vrr_stack+5351, vrr_stack+2957);
 _BUILD_h0i0(Data,vrr_stack+6947, vrr_stack+2408, vrr_stack+6527, vrr_stack+5799, vrr_stack+5519, vrr_stack+3167);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+316, vrr_stack+0, vrr_stack+6, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+826, vrr_stack+316, vrr_stack+201, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+836, vrr_stack+826, vrr_stack+207, vrr_stack+316, vrr_stack+201, NULL);
 _BUILD_00h0(Data,vrr_stack+851, vrr_stack+836, vrr_stack+9, vrr_stack+826, vrr_stack+207, NULL);
 _BUILD_00i0(Data,vrr_stack+84, vrr_stack+851, vrr_stack+217, vrr_stack+836, vrr_stack+9, NULL);
 _BUILD_p0i0(Data,vrr_stack+2828, vrr_stack+84, vrr_stack+686, NULL, NULL, vrr_stack+217);
 _BUILD_d0i0(Data,vrr_stack+2912, vrr_stack+2828, vrr_stack+714, vrr_stack+84, vrr_stack+686, vrr_stack+875);
 _BUILD_f0i0(Data,vrr_stack+3080, vrr_stack+2912, vrr_stack+2156, vrr_stack+2828, vrr_stack+714, vrr_stack+938);
 _BUILD_g0i0(Data,vrr_stack+7535, vrr_stack+3080, vrr_stack+5799, vrr_stack+2912, vrr_stack+2156, vrr_stack+1064);
 _BUILD_h0i0(Data,vrr_stack+7955, vrr_stack+7535, vrr_stack+2408, vrr_stack+3080, vrr_stack+5799, vrr_stack+3482);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+261, vrr_stack+6, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+15, vrr_stack+264, vrr_stack+9, vrr_stack+3, vrr_stack+261, NULL);
 _BUILD_00g0(Data,vrr_stack+25, vrr_stack+270, vrr_stack+15, vrr_stack+322, vrr_stack+264, NULL);
 _BUILD_00h0(Data,vrr_stack+40, vrr_stack+280, vrr_stack+25, vrr_stack+328, vrr_stack+270, NULL);
 _BUILD_00i0(Data,vrr_stack+872, vrr_stack+295, vrr_stack+40, vrr_stack+338, vrr_stack+280, NULL);
 _BUILD_p0i0(Data,vrr_stack+900, vrr_stack+798, vrr_stack+872, NULL, NULL, vrr_stack+295);
 _BUILD_d0i0(Data,vrr_stack+984, vrr_stack+2324, vrr_stack+900, vrr_stack+162, vrr_stack+798, vrr_stack+1274);
 _BUILD_f0i0(Data,vrr_stack+3360, vrr_stack+6079, vrr_stack+984, vrr_stack+1904, vrr_stack+2324, vrr_stack+1337);
 _BUILD_g0i0(Data,vrr_stack+8543, vrr_stack+6247, vrr_stack+3360, vrr_stack+1988, vrr_stack+6079, vrr_stack+3797);
 _BUILD_h0i0(Data,vrr_stack+8963, vrr_stack+6527, vrr_stack+8543, vrr_stack+5519, vrr_stack+6247, vrr_stack+4007);
 _BUILD_i0i0(Data,vrr_stack+9551, vrr_stack+6947, vrr_stack+8963, vrr_stack+2408, vrr_stack+6527, vrr_stack+4322);
 _BUILD_i0i0(Data,vrr_stack+3640, vrr_stack+7955, vrr_stack+6947, vrr_stack+7535, vrr_stack+2408, vrr_stack+1463);
 _BUILD_k0i0(Data,vrr_stack+10335, vrr_stack+3640, vrr_stack+9551, vrr_stack+7955, vrr_stack+6947, vrr_stack+4763);
 _BUILD_00k0(Data,vrr_stack+1152, vrr_stack+381, vrr_stack+353, vrr_stack+644, vrr_stack+623, NULL);
 _BUILD_00k0(Data,vrr_stack+1188, vrr_stack+493, vrr_stack+381, vrr_stack+141, vrr_stack+644, NULL);
 _BUILD_00k0(Data,vrr_stack+1224, vrr_stack+353, vrr_stack+162, vrr_stack+623, vrr_stack+665, NULL);
 _BUILD_p0k0(Data,vrr_stack+1260, vrr_stack+1152, vrr_stack+1224, NULL, NULL, vrr_stack+353);
 _BUILD_p0k0(Data,vrr_stack+1368, vrr_stack+1188, vrr_stack+1152, NULL, NULL, vrr_stack+381);
 _BUILD_d0k0(Data,vrr_stack+1476, vrr_stack+1368, vrr_stack+1260, vrr_stack+1188, vrr_stack+1152, vrr_stack+409);
 _BUILD_00k0(Data,vrr_stack+409, vrr_stack+686, vrr_stack+493, vrr_stack+217, vrr_stack+141, NULL);
 _BUILD_p0k0(Data,vrr_stack+1692, vrr_stack+409, vrr_stack+1188, NULL, NULL, vrr_stack+493);
 _BUILD_d0k0(Data,vrr_stack+4424, vrr_stack+1692, vrr_stack+1368, vrr_stack+409, vrr_stack+1188, vrr_stack+521);
 _BUILD_00k0(Data,vrr_stack+521, vrr_stack+162, vrr_stack+798, vrr_stack+665, vrr_stack+63, NULL);
 _BUILD_p0k0(Data,vrr_stack+557, vrr_stack+1224, vrr_stack+521, NULL, NULL, vrr_stack+162);
 _BUILD_d0k0(Data,vrr_stack+4640, vrr_stack+1260, vrr_stack+557, vrr_stack+1152, vrr_stack+1224, vrr_stack+1904);
 _BUILD_f0k0(Data,vrr_stack+4856, vrr_stack+1476, vrr_stack+4640, vrr_stack+1368, vrr_stack+1260, vrr_stack+1988);
 _BUILD_f0k0(Data,vrr_stack+11343, vrr_stack+4424, vrr_stack+1476, vrr_stack+1692, vrr_stack+1368, vrr_stack+5351);
 _BUILD_g0k0(Data,vrr_stack+11703, vrr_stack+11343, vrr_stack+4856, vrr_stack+4424, vrr_stack+1476, vrr_stack+5519);
 _BUILD_00k0(Data,vrr_stack+445, vrr_stack+84, vrr_stack+686, vrr_stack+851, vrr_stack+217, NULL);
 _BUILD_p0k0(Data,vrr_stack+1800, vrr_stack+445, vrr_stack+409, NULL, NULL, vrr_stack+686);
 _BUILD_d0k0(Data,vrr_stack+1908, vrr_stack+1800, vrr_stack+1692, vrr_stack+445, vrr_stack+409, vrr_stack+714);
 _BUILD_f0k0(Data,vrr_stack+5216, vrr_stack+1908, vrr_stack+4424, vrr_stack+1800, vrr_stack+1692, vrr_stack+2156);
 _BUILD_g0k0(Data,vrr_stack+12243, vrr_stack+5216, vrr_stack+11343, vrr_stack+1908, vrr_stack+4424, vrr_stack+5799);
 _BUILD_00k0(Data,vrr_stack+714, vrr_stack+798, vrr_stack+872, vrr_stack+63, vrr_stack+295, NULL);
 _BUILD_p0k0(Data,vrr_stack+2124, vrr_stack+521, vrr_stack+714, NULL, NULL, vrr_stack+798);
 _BUILD_d0k0(Data,vrr_stack+5576, vrr_stack+557, vrr_stack+2124, vrr_stack+1224, vrr_stack+521, vrr_stack+2324);
 _BUILD_f0k0(Data,vrr_stack+12783, vrr_stack+4640, vrr_stack+5576, vrr_stack+1260, vrr_stack+557, vrr_stack+6079);
 _BUILD_g0k0(Data,vrr_stack+13143, vrr_stack+4856, vrr_stack+12783, vrr_stack+1476, vrr_stack+4640, vrr_stack+6247);
 _BUILD_h0k0(Data,vrr_stack+13683, vrr_stack+11703, vrr_stack+13143, vrr_stack+11343, vrr_stack+4856, vrr_stack+6527);
 _BUILD_h0k0(Data,vrr_stack+5792, vrr_stack+12243, vrr_stack+11703, vrr_stack+5216, vrr_stack+11343, vrr_stack+2408);
 _BUILD_i0k0(Data,vrr_stack+14439, vrr_stack+5792, vrr_stack+13683, vrr_stack+12243, vrr_stack+11703, vrr_stack+6947);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+750, vrr_stack+3, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+756, vrr_stack+750, vrr_stack+316, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+766, vrr_stack+756, vrr_stack+826, vrr_stack+750, vrr_stack+316, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+766, vrr_stack+836, vrr_stack+756, vrr_stack+826, NULL);
 _BUILD_00i0(Data,vrr_stack+316, vrr_stack+665, vrr_stack+851, vrr_stack+766, vrr_stack+836, NULL);
 _BUILD_00k0(Data,vrr_stack+750, vrr_stack+316, vrr_stack+84, vrr_stack+665, vrr_stack+851, NULL);
 _BUILD_p0k0(Data,vrr_stack+2232, vrr_stack+750, vrr_stack+445, NULL, NULL, vrr_stack+84);
 _BUILD_d0k0(Data,vrr_stack+2340, vrr_stack+2232, vrr_stack+1800, vrr_stack+750, vrr_stack+445, vrr_stack+2828);
 _BUILD_f0k0(Data,vrr_stack+6548, vrr_stack+2340, vrr_stack+1908, vrr_stack+2232, vrr_stack+1800, vrr_stack+2912);
 _BUILD_g0k0(Data,vrr_stack+6908, vrr_stack+6548, vrr_stack+5216, vrr_stack+2340, vrr_stack+1908, vrr_stack+3080);
 _BUILD_h0k0(Data,vrr_stack+2232, vrr_stack+6908, vrr_stack+12243, vrr_stack+6548, vrr_stack+5216, vrr_stack+7535);
 _BUILD_i0k0(Data,vrr_stack+15447, vrr_stack+2232, vrr_stack+5792, vrr_stack+6908, vrr_stack+12243, vrr_stack+7955);
   tmp = vrr_stack + 15447;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6548, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+6, vrr_stack+6548, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+6551, vrr_stack+9, vrr_stack+0, vrr_stack+261, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+6561, vrr_stack+15, vrr_stack+6551, vrr_stack+264, vrr_stack+9, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+25, vrr_stack+6561, vrr_stack+270, vrr_stack+15, NULL);
 _BUILD_00i0(Data,vrr_stack+6576, vrr_stack+40, vrr_stack+665, vrr_stack+280, vrr_stack+25, NULL);
 _BUILD_00k0(Data,vrr_stack+6604, vrr_stack+872, vrr_stack+6576, vrr_stack+295, vrr_stack+40, NULL);
 _BUILD_p0k0(Data,vrr_stack+6640, vrr_stack+714, vrr_stack+6604, NULL, NULL, vrr_stack+872);
 _BUILD_d0k0(Data,vrr_stack+6748, vrr_stack+2124, vrr_stack+6640, vrr_stack+521, vrr_stack+714, vrr_stack+900);
 _BUILD_f0k0(Data,vrr_stack+6964, vrr_stack+5576, vrr_stack+6748, vrr_stack+557, vrr_stack+2124, vrr_stack+984);
 _BUILD_g0k0(Data,vrr_stack+7324, vrr_stack+12783, vrr_stack+6964, vrr_stack+4640, vrr_stack+5576, vrr_stack+3360);
 _BUILD_h0k0(Data,vrr_stack+16455, vrr_stack+13143, vrr_stack+7324, vrr_stack+4856, vrr_stack+12783, vrr_stack+8543);
 _BUILD_i0k0(Data,vrr_stack+7864, vrr_stack+13683, vrr_stack+16455, vrr_stack+11703, vrr_stack+13143, vrr_stack+8963);
 _BUILD_k0k0(Data,vrr_stack+17211, vrr_stack+14439, vrr_stack+7864, vrr_stack+5792, vrr_stack+13683, vrr_stack+9551);
 _BUILD_k0k0(Data,vrr_stack+8872, vrr_stack+15447, vrr_stack+14439, vrr_stack+2232, vrr_stack+5792, vrr_stack+3640);
   tmp = vrr_stack + 8872;
   target_ptr = Libint->vrr_classes[7][7];
   for(i=0;i<1296;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+2232, vrr_stack+1152, vrr_stack+1224, vrr_stack+381, vrr_stack+353, NULL);
 _BUILD_00l0(Data,vrr_stack+2277, vrr_stack+1188, vrr_stack+1152, vrr_stack+493, vrr_stack+381, NULL);
 _BUILD_00l0(Data,vrr_stack+2322, vrr_stack+1224, vrr_stack+521, vrr_stack+353, vrr_stack+162, NULL);
 _BUILD_p0l0(Data,vrr_stack+2367, vrr_stack+2232, vrr_stack+2322, NULL, NULL, vrr_stack+1224);
 _BUILD_p0l0(Data,vrr_stack+2502, vrr_stack+2277, vrr_stack+2232, NULL, NULL, vrr_stack+1152);
 _BUILD_d0l0(Data,vrr_stack+2637, vrr_stack+2502, vrr_stack+2367, vrr_stack+2277, vrr_stack+2232, vrr_stack+1260);
 _BUILD_00l0(Data,vrr_stack+1260, vrr_stack+409, vrr_stack+1188, vrr_stack+686, vrr_stack+493, NULL);
 _BUILD_p0l0(Data,vrr_stack+2907, vrr_stack+1260, vrr_stack+2277, NULL, NULL, vrr_stack+1188);
 _BUILD_d0l0(Data,vrr_stack+3042, vrr_stack+2907, vrr_stack+2502, vrr_stack+1260, vrr_stack+2277, vrr_stack+1368);
 _BUILD_00l0(Data,vrr_stack+1305, vrr_stack+521, vrr_stack+714, vrr_stack+162, vrr_stack+798, NULL);
 _BUILD_p0l0(Data,vrr_stack+3312, vrr_stack+2322, vrr_stack+1305, NULL, NULL, vrr_stack+521);
 _BUILD_d0l0(Data,vrr_stack+3447, vrr_stack+2367, vrr_stack+3312, vrr_stack+2232, vrr_stack+2322, vrr_stack+557);
 _BUILD_f0l0(Data,vrr_stack+3717, vrr_stack+2637, vrr_stack+3447, vrr_stack+2502, vrr_stack+2367, vrr_stack+4640);
 _BUILD_f0l0(Data,vrr_stack+18507, vrr_stack+3042, vrr_stack+2637, vrr_stack+2907, vrr_stack+2502, vrr_stack+1476);
 _BUILD_g0l0(Data,vrr_stack+18957, vrr_stack+18507, vrr_stack+3717, vrr_stack+3042, vrr_stack+2637, vrr_stack+4856);
 _BUILD_00l0(Data,vrr_stack+4640, vrr_stack+445, vrr_stack+409, vrr_stack+84, vrr_stack+686, NULL);
 _BUILD_p0l0(Data,vrr_stack+4685, vrr_stack+4640, vrr_stack+1260, NULL, NULL, vrr_stack+409);
 _BUILD_d0l0(Data,vrr_stack+4820, vrr_stack+4685, vrr_stack+2907, vrr_stack+4640, vrr_stack+1260, vrr_stack+1692);
 _BUILD_f0l0(Data,vrr_stack+1350, vrr_stack+4820, vrr_stack+3042, vrr_stack+4685, vrr_stack+2907, vrr_stack+4424);
 _BUILD_g0l0(Data,vrr_stack+19632, vrr_stack+1350, vrr_stack+18507, vrr_stack+4820, vrr_stack+3042, vrr_stack+11343);
 _BUILD_00l0(Data,vrr_stack+11343, vrr_stack+714, vrr_stack+6604, vrr_stack+798, vrr_stack+872, NULL);
 _BUILD_p0l0(Data,vrr_stack+11388, vrr_stack+1305, vrr_stack+11343, NULL, NULL, vrr_stack+714);
 _BUILD_d0l0(Data,vrr_stack+4167, vrr_stack+3312, vrr_stack+11388, vrr_stack+2322, vrr_stack+1305, vrr_stack+2124);
 _BUILD_f0l0(Data,vrr_stack+20307, vrr_stack+3447, vrr_stack+4167, vrr_stack+2367, vrr_stack+3312, vrr_stack+5576);
 _BUILD_g0l0(Data,vrr_stack+20757, vrr_stack+3717, vrr_stack+20307, vrr_stack+2637, vrr_stack+3447, vrr_stack+12783);
 _BUILD_h0l0(Data,vrr_stack+21432, vrr_stack+18957, vrr_stack+20757, vrr_stack+18507, vrr_stack+3717, vrr_stack+13143);
 _BUILD_h0l0(Data,vrr_stack+22377, vrr_stack+19632, vrr_stack+18957, vrr_stack+1350, vrr_stack+18507, vrr_stack+11703);
 _BUILD_i0l0(Data,vrr_stack+23322, vrr_stack+22377, vrr_stack+21432, vrr_stack+19632, vrr_stack+18957, vrr_stack+13683);
 _BUILD_00l0(Data,vrr_stack+12783, vrr_stack+750, vrr_stack+445, vrr_stack+316, vrr_stack+84, NULL);
 _BUILD_p0l0(Data,vrr_stack+12828, vrr_stack+12783, vrr_stack+4640, NULL, NULL, vrr_stack+445);
 _BUILD_d0l0(Data,vrr_stack+12963, vrr_stack+12828, vrr_stack+4685, vrr_stack+12783, vrr_stack+4640, vrr_stack+1800);
 _BUILD_f0l0(Data,vrr_stack+13233, vrr_stack+12963, vrr_stack+4820, vrr_stack+12828, vrr_stack+4685, vrr_stack+1908);
 _BUILD_g0l0(Data,vrr_stack+13683, vrr_stack+13233, vrr_stack+1350, vrr_stack+12963, vrr_stack+4820, vrr_stack+5216);
 _BUILD_h0l0(Data,vrr_stack+24582, vrr_stack+13683, vrr_stack+19632, vrr_stack+13233, vrr_stack+1350, vrr_stack+12243);
 _BUILD_i0l0(Data,vrr_stack+11523, vrr_stack+24582, vrr_stack+22377, vrr_stack+13683, vrr_stack+19632, vrr_stack+5792);
   tmp = vrr_stack + 11523;
   target_ptr = Libint->vrr_classes[6][8];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+12828, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12831, vrr_stack+6548, vrr_stack+12828, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+12837, vrr_stack+0, vrr_stack+12831, vrr_stack+6, vrr_stack+6548, NULL);
 _BUILD_00g0(Data,vrr_stack+12847, vrr_stack+6551, vrr_stack+12837, vrr_stack+9, vrr_stack+0, NULL);
 _BUILD_00h0(Data,vrr_stack+12862, vrr_stack+6561, vrr_stack+12847, vrr_stack+15, vrr_stack+6551, NULL);
 _BUILD_00i0(Data,vrr_stack+686, vrr_stack+665, vrr_stack+12862, vrr_stack+25, vrr_stack+6561, NULL);
 _BUILD_00k0(Data,vrr_stack+12883, vrr_stack+6576, vrr_stack+686, vrr_stack+40, vrr_stack+665, NULL);
 _BUILD_00l0(Data,vrr_stack+6, vrr_stack+6604, vrr_stack+12883, vrr_stack+872, vrr_stack+6576, NULL);
 _BUILD_p0l0(Data,vrr_stack+51, vrr_stack+11343, vrr_stack+6, NULL, NULL, vrr_stack+6604);
 _BUILD_d0l0(Data,vrr_stack+12919, vrr_stack+11388, vrr_stack+51, vrr_stack+1305, vrr_stack+11343, vrr_stack+6640);
 _BUILD_f0l0(Data,vrr_stack+13189, vrr_stack+4167, vrr_stack+12919, vrr_stack+3312, vrr_stack+11388, vrr_stack+6748);
 _BUILD_g0l0(Data,vrr_stack+13639, vrr_stack+20307, vrr_stack+13189, vrr_stack+3447, vrr_stack+4167, vrr_stack+6964);
 _BUILD_h0l0(Data,vrr_stack+5090, vrr_stack+20757, vrr_stack+13639, vrr_stack+3717, vrr_stack+20307, vrr_stack+7324);
 _BUILD_i0l0(Data,vrr_stack+25527, vrr_stack+21432, vrr_stack+5090, vrr_stack+18957, vrr_stack+20757, vrr_stack+16455);
 _BUILD_k0l0(Data,vrr_stack+26787, vrr_stack+23322, vrr_stack+25527, vrr_stack+22377, vrr_stack+21432, vrr_stack+7864);
 _BUILD_k0l0(Data,vrr_stack+6640, vrr_stack+11523, vrr_stack+23322, vrr_stack+24582, vrr_stack+22377, vrr_stack+14439);
   tmp = vrr_stack + 6640;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+24582, vrr_stack+2232, vrr_stack+2322, vrr_stack+1152, vrr_stack+1224, NULL);
 _BUILD_00m0(Data,vrr_stack+24637, vrr_stack+2277, vrr_stack+2232, vrr_stack+1188, vrr_stack+1152, NULL);
 _BUILD_00m0(Data,vrr_stack+24692, vrr_stack+2322, vrr_stack+1305, vrr_stack+1224, vrr_stack+521, NULL);
 _BUILD_p0m0(Data,vrr_stack+24747, vrr_stack+24582, vrr_stack+24692, NULL, NULL, vrr_stack+2322);
 _BUILD_p0m0(Data,vrr_stack+24912, vrr_stack+24637, vrr_stack+24582, NULL, NULL, vrr_stack+2232);
 _BUILD_d0m0(Data,vrr_stack+25077, vrr_stack+24912, vrr_stack+24747, vrr_stack+24637, vrr_stack+24582, vrr_stack+2367);
 _BUILD_00m0(Data,vrr_stack+2367, vrr_stack+1260, vrr_stack+2277, vrr_stack+409, vrr_stack+1188, NULL);
 _BUILD_p0m0(Data,vrr_stack+16455, vrr_stack+2367, vrr_stack+24637, NULL, NULL, vrr_stack+2277);
 _BUILD_d0m0(Data,vrr_stack+16620, vrr_stack+16455, vrr_stack+24912, vrr_stack+2367, vrr_stack+24637, vrr_stack+2502);
 _BUILD_00m0(Data,vrr_stack+2422, vrr_stack+1305, vrr_stack+11343, vrr_stack+521, vrr_stack+714, NULL);
 _BUILD_p0m0(Data,vrr_stack+16950, vrr_stack+24692, vrr_stack+2422, NULL, NULL, vrr_stack+1305);
 _BUILD_d0m0(Data,vrr_stack+8260, vrr_stack+24747, vrr_stack+16950, vrr_stack+24582, vrr_stack+24692, vrr_stack+3312);
 _BUILD_f0m0(Data,vrr_stack+28407, vrr_stack+25077, vrr_stack+8260, vrr_stack+24912, vrr_stack+24747, vrr_stack+3447);
 _BUILD_f0m0(Data,vrr_stack+28957, vrr_stack+16620, vrr_stack+25077, vrr_stack+16455, vrr_stack+24912, vrr_stack+2637);
 _BUILD_g0m0(Data,vrr_stack+29507, vrr_stack+28957, vrr_stack+28407, vrr_stack+16620, vrr_stack+25077, vrr_stack+3717);
 _BUILD_00m0(Data,vrr_stack+3312, vrr_stack+4640, vrr_stack+1260, vrr_stack+445, vrr_stack+409, NULL);
 _BUILD_p0m0(Data,vrr_stack+3367, vrr_stack+3312, vrr_stack+2367, NULL, NULL, vrr_stack+1260);
 _BUILD_d0m0(Data,vrr_stack+3532, vrr_stack+3367, vrr_stack+16455, vrr_stack+3312, vrr_stack+2367, vrr_stack+2907);
 _BUILD_f0m0(Data,vrr_stack+2477, vrr_stack+3532, vrr_stack+16620, vrr_stack+3367, vrr_stack+16455, vrr_stack+3042);
 _BUILD_g0m0(Data,vrr_stack+30332, vrr_stack+2477, vrr_stack+28957, vrr_stack+3532, vrr_stack+16620, vrr_stack+18507);
 _BUILD_00m0(Data,vrr_stack+18507, vrr_stack+11343, vrr_stack+6, vrr_stack+714, vrr_stack+6604, NULL);
 _BUILD_p0m0(Data,vrr_stack+18562, vrr_stack+2422, vrr_stack+18507, NULL, NULL, vrr_stack+11343);
 _BUILD_d0m0(Data,vrr_stack+1800, vrr_stack+16950, vrr_stack+18562, vrr_stack+24692, vrr_stack+2422, vrr_stack+11388);
 _BUILD_f0m0(Data,vrr_stack+31157, vrr_stack+8260, vrr_stack+1800, vrr_stack+24747, vrr_stack+16950, vrr_stack+4167);
 _BUILD_g0m0(Data,vrr_stack+31707, vrr_stack+28407, vrr_stack+31157, vrr_stack+25077, vrr_stack+8260, vrr_stack+20307);
 _BUILD_h0m0(Data,vrr_stack+32532, vrr_stack+29507, vrr_stack+31707, vrr_stack+28957, vrr_stack+28407, vrr_stack+20757);
 _BUILD_h0m0(Data,vrr_stack+33687, vrr_stack+30332, vrr_stack+29507, vrr_stack+2477, vrr_stack+28957, vrr_stack+18957);
 _BUILD_i0m0(Data,vrr_stack+34842, vrr_stack+33687, vrr_stack+32532, vrr_stack+30332, vrr_stack+29507, vrr_stack+21432);
 _BUILD_00m0(Data,vrr_stack+20307, vrr_stack+12783, vrr_stack+4640, vrr_stack+750, vrr_stack+445, NULL);
 _BUILD_p0m0(Data,vrr_stack+20362, vrr_stack+20307, vrr_stack+3312, NULL, NULL, vrr_stack+4640);
 _BUILD_d0m0(Data,vrr_stack+20527, vrr_stack+20362, vrr_stack+3367, vrr_stack+20307, vrr_stack+3312, vrr_stack+4685);
 _BUILD_f0m0(Data,vrr_stack+20857, vrr_stack+20527, vrr_stack+3532, vrr_stack+20362, vrr_stack+3367, vrr_stack+4820);
 _BUILD_g0m0(Data,vrr_stack+21407, vrr_stack+20857, vrr_stack+2477, vrr_stack+20527, vrr_stack+3532, vrr_stack+1350);
 _BUILD_h0m0(Data,vrr_stack+36382, vrr_stack+21407, vrr_stack+30332, vrr_stack+20857, vrr_stack+2477, vrr_stack+19632);
 _BUILD_i0m0(Data,vrr_stack+18727, vrr_stack+36382, vrr_stack+33687, vrr_stack+21407, vrr_stack+30332, vrr_stack+22377);
   tmp = vrr_stack + 18727;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+1350, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1353, vrr_stack+12828, vrr_stack+1350, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+1359, vrr_stack+12831, vrr_stack+1353, vrr_stack+6548, vrr_stack+12828, NULL);
 _BUILD_00g0(Data,vrr_stack+1369, vrr_stack+12837, vrr_stack+1359, vrr_stack+0, vrr_stack+12831, NULL);
 _BUILD_00h0(Data,vrr_stack+1384, vrr_stack+12847, vrr_stack+1369, vrr_stack+6551, vrr_stack+12837, NULL);
 _BUILD_00i0(Data,vrr_stack+1405, vrr_stack+12862, vrr_stack+1384, vrr_stack+6561, vrr_stack+12847, NULL);
 _BUILD_00k0(Data,vrr_stack+1433, vrr_stack+686, vrr_stack+1405, vrr_stack+665, vrr_stack+12862, NULL);
 _BUILD_00l0(Data,vrr_stack+1469, vrr_stack+12883, vrr_stack+1433, vrr_stack+6576, vrr_stack+686, NULL);
 _BUILD_00m0(Data,vrr_stack+1514, vrr_stack+6, vrr_stack+1469, vrr_stack+6604, vrr_stack+12883, NULL);
 _BUILD_p0m0(Data,vrr_stack+1569, vrr_stack+18507, vrr_stack+1514, NULL, NULL, vrr_stack+6);
 _BUILD_d0m0(Data,vrr_stack+20362, vrr_stack+18562, vrr_stack+1569, vrr_stack+2422, vrr_stack+18507, vrr_stack+51);
 _BUILD_f0m0(Data,vrr_stack+51, vrr_stack+1800, vrr_stack+20362, vrr_stack+16950, vrr_stack+18562, vrr_stack+12919);
 _BUILD_g0m0(Data,vrr_stack+20692, vrr_stack+31157, vrr_stack+51, vrr_stack+8260, vrr_stack+1800, vrr_stack+13189);
 _BUILD_h0m0(Data,vrr_stack+21517, vrr_stack+31707, vrr_stack+20692, vrr_stack+28407, vrr_stack+31157, vrr_stack+13639);
 _BUILD_i0m0(Data,vrr_stack+37537, vrr_stack+32532, vrr_stack+21517, vrr_stack+29507, vrr_stack+31707, vrr_stack+5090);
 _BUILD_k0m0(Data,vrr_stack+39077, vrr_stack+34842, vrr_stack+37537, vrr_stack+33687, vrr_stack+32532, vrr_stack+25527);
 _BUILD_k0m0(Data,vrr_stack+41057, vrr_stack+18727, vrr_stack+34842, vrr_stack+36382, vrr_stack+33687, vrr_stack+23322);
   tmp = vrr_stack + 41057;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+1734, vrr_stack+24582, vrr_stack+24692, vrr_stack+2232, vrr_stack+2322, NULL);
 _BUILD_00n0(Data,vrr_stack+36382, vrr_stack+24637, vrr_stack+24582, vrr_stack+2277, vrr_stack+2232, NULL);
 _BUILD_00n0(Data,vrr_stack+36448, vrr_stack+24692, vrr_stack+2422, vrr_stack+2322, vrr_stack+1305, NULL);
 _BUILD_p0n0(Data,vrr_stack+36514, vrr_stack+1734, vrr_stack+36448, NULL, NULL, vrr_stack+24692);
 _BUILD_p0n0(Data,vrr_stack+36712, vrr_stack+36382, vrr_stack+1734, NULL, NULL, vrr_stack+24582);
 _BUILD_d0n0(Data,vrr_stack+36910, vrr_stack+36712, vrr_stack+36514, vrr_stack+36382, vrr_stack+1734, vrr_stack+24747);
 _BUILD_00n0(Data,vrr_stack+24692, vrr_stack+2367, vrr_stack+24637, vrr_stack+1260, vrr_stack+2277, NULL);
 _BUILD_p0n0(Data,vrr_stack+37306, vrr_stack+24692, vrr_stack+36382, NULL, NULL, vrr_stack+24637);
 _BUILD_d0n0(Data,vrr_stack+12919, vrr_stack+37306, vrr_stack+36712, vrr_stack+24692, vrr_stack+36382, vrr_stack+24912);
 _BUILD_00n0(Data,vrr_stack+36382, vrr_stack+2422, vrr_stack+18507, vrr_stack+1305, vrr_stack+11343, NULL);
 _BUILD_p0n0(Data,vrr_stack+24758, vrr_stack+36448, vrr_stack+36382, NULL, NULL, vrr_stack+2422);
 _BUILD_d0n0(Data,vrr_stack+13315, vrr_stack+36514, vrr_stack+24758, vrr_stack+1734, vrr_stack+36448, vrr_stack+16950);
 _BUILD_f0n0(Data,vrr_stack+13711, vrr_stack+36910, vrr_stack+13315, vrr_stack+36712, vrr_stack+36514, vrr_stack+8260);
 _BUILD_f0n0(Data,vrr_stack+4685, vrr_stack+12919, vrr_stack+36910, vrr_stack+37306, vrr_stack+36712, vrr_stack+25077);
 _BUILD_g0n0(Data,vrr_stack+24956, vrr_stack+4685, vrr_stack+13711, vrr_stack+12919, vrr_stack+36910, vrr_stack+28407);
 _BUILD_00n0(Data,vrr_stack+1734, vrr_stack+3312, vrr_stack+2367, vrr_stack+4640, vrr_stack+1260, NULL);
 _BUILD_p0n0(Data,vrr_stack+36712, vrr_stack+1734, vrr_stack+24692, NULL, NULL, vrr_stack+2367);
 _BUILD_d0n0(Data,vrr_stack+28407, vrr_stack+36712, vrr_stack+37306, vrr_stack+1734, vrr_stack+24692, vrr_stack+16455);
 _BUILD_f0n0(Data,vrr_stack+25946, vrr_stack+28407, vrr_stack+12919, vrr_stack+36712, vrr_stack+37306, vrr_stack+16620);
 _BUILD_g0n0(Data,vrr_stack+5345, vrr_stack+25946, vrr_stack+4685, vrr_stack+28407, vrr_stack+12919, vrr_stack+28957);
 _BUILD_00n0(Data,vrr_stack+12919, vrr_stack+18507, vrr_stack+1514, vrr_stack+11343, vrr_stack+6, NULL);
 _BUILD_p0n0(Data,vrr_stack+12985, vrr_stack+36382, vrr_stack+12919, NULL, NULL, vrr_stack+18507);
 _BUILD_d0n0(Data,vrr_stack+16455, vrr_stack+24758, vrr_stack+12985, vrr_stack+36448, vrr_stack+36382, vrr_stack+18562);
 _BUILD_f0n0(Data,vrr_stack+28803, vrr_stack+13315, vrr_stack+16455, vrr_stack+36514, vrr_stack+24758, vrr_stack+1800);
 _BUILD_g0n0(Data,vrr_stack+43037, vrr_stack+13711, vrr_stack+28803, vrr_stack+36910, vrr_stack+13315, vrr_stack+31157);
 _BUILD_h0n0(Data,vrr_stack+44027, vrr_stack+24956, vrr_stack+43037, vrr_stack+4685, vrr_stack+13711, vrr_stack+31707);
 _BUILD_h0n0(Data,vrr_stack+45413, vrr_stack+5345, vrr_stack+24956, vrr_stack+25946, vrr_stack+4685, vrr_stack+29507);
 _BUILD_i0n0(Data,vrr_stack+46799, vrr_stack+45413, vrr_stack+44027, vrr_stack+5345, vrr_stack+24956, vrr_stack+32532);
 _BUILD_00n0(Data,vrr_stack+4685, vrr_stack+20307, vrr_stack+3312, vrr_stack+12783, vrr_stack+4640, NULL);
 _BUILD_p0n0(Data,vrr_stack+4751, vrr_stack+4685, vrr_stack+1734, NULL, NULL, vrr_stack+3312);
 _BUILD_d0n0(Data,vrr_stack+4949, vrr_stack+4751, vrr_stack+36712, vrr_stack+4685, vrr_stack+1734, vrr_stack+3367);
 _BUILD_f0n0(Data,vrr_stack+1734, vrr_stack+4949, vrr_stack+28407, vrr_stack+4751, vrr_stack+36712, vrr_stack+3532);
 _BUILD_g0n0(Data,vrr_stack+31157, vrr_stack+1734, vrr_stack+25946, vrr_stack+4949, vrr_stack+28407, vrr_stack+2477);
 _BUILD_h0n0(Data,vrr_stack+2394, vrr_stack+31157, vrr_stack+5345, vrr_stack+1734, vrr_stack+25946, vrr_stack+30332);
 _BUILD_i0n0(Data,vrr_stack+48647, vrr_stack+2394, vrr_stack+45413, vrr_stack+31157, vrr_stack+5345, vrr_stack+33687);
   tmp = vrr_stack + 48647;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+25946, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+1350, vrr_stack+25946, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+25946, vrr_stack+1353, vrr_stack+0, vrr_stack+12828, vrr_stack+1350, NULL);
 _BUILD_00g0(Data,vrr_stack+25956, vrr_stack+1359, vrr_stack+25946, vrr_stack+12831, vrr_stack+1353, NULL);
 _BUILD_00h0(Data,vrr_stack+25971, vrr_stack+1369, vrr_stack+25956, vrr_stack+12837, vrr_stack+1359, NULL);
 _BUILD_00i0(Data,vrr_stack+25992, vrr_stack+1384, vrr_stack+25971, vrr_stack+12847, vrr_stack+1369, NULL);
 _BUILD_00k0(Data,vrr_stack+25946, vrr_stack+1405, vrr_stack+25992, vrr_stack+12862, vrr_stack+1384, NULL);
 _BUILD_00l0(Data,vrr_stack+25982, vrr_stack+1433, vrr_stack+25946, vrr_stack+686, vrr_stack+1405, NULL);
 _BUILD_00m0(Data,vrr_stack+26027, vrr_stack+1469, vrr_stack+25982, vrr_stack+12883, vrr_stack+1433, NULL);
 _BUILD_00n0(Data,vrr_stack+25946, vrr_stack+1514, vrr_stack+26027, vrr_stack+6, vrr_stack+1469, NULL);
 _BUILD_p0n0(Data,vrr_stack+26012, vrr_stack+12919, vrr_stack+25946, NULL, NULL, vrr_stack+1514);
 _BUILD_d0n0(Data,vrr_stack+28407, vrr_stack+12985, vrr_stack+26012, vrr_stack+36382, vrr_stack+12919, vrr_stack+1569);
 _BUILD_f0n0(Data,vrr_stack+36382, vrr_stack+16455, vrr_stack+28407, vrr_stack+24758, vrr_stack+12985, vrr_stack+20362);
 _BUILD_g0n0(Data,vrr_stack+3780, vrr_stack+28803, vrr_stack+36382, vrr_stack+13315, vrr_stack+16455, vrr_stack+51);
 _BUILD_h0n0(Data,vrr_stack+0, vrr_stack+43037, vrr_stack+3780, vrr_stack+13711, vrr_stack+28803, vrr_stack+20692);
 _BUILD_i0n0(Data,vrr_stack+3780, vrr_stack+44027, vrr_stack+0, vrr_stack+24956, vrr_stack+43037, vrr_stack+21517);
 _BUILD_k0n0(Data,vrr_stack+0, vrr_stack+46799, vrr_stack+3780, vrr_stack+45413, vrr_stack+44027, vrr_stack+37537);
 _BUILD_k0n0(Data,vrr_stack+43037, vrr_stack+48647, vrr_stack+46799, vrr_stack+2394, vrr_stack+45413, vrr_stack+34842);
   tmp = vrr_stack + 43037;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0k0(Data,vrr_stack+2376, vrr_stack+8872, vrr_stack+17211, vrr_stack+15447, vrr_stack+14439, vrr_stack+10335);
   tmp = vrr_stack + 2376;
   target_ptr = Libint->vrr_classes[8][7];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0l0(Data,vrr_stack+3996, vrr_stack+6640, vrr_stack+26787, vrr_stack+11523, vrr_stack+23322, vrr_stack+17211);
   tmp = vrr_stack + 3996;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0m0(Data,vrr_stack+6021, vrr_stack+41057, vrr_stack+39077, vrr_stack+18727, vrr_stack+34842, vrr_stack+26787);
   tmp = vrr_stack + 6021;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+8496, vrr_stack+43037, vrr_stack+0, vrr_stack+48647, vrr_stack+46799, vrr_stack+39077);
   tmp = vrr_stack + 8496;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];

}

