/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (p0|nl) integrals */

void vrr_order_p0nl(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+5, Data->F+6, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+31, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+81, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+3, vrr_stack+31, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+50, vrr_stack+34, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+163, vrr_stack+56, vrr_stack+40, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+178, vrr_stack+66, vrr_stack+163, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+199, vrr_stack+96, vrr_stack+178, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+255, vrr_stack+227, vrr_stack+199, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+0, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+84, vrr_stack+15, vrr_stack+81, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+21, vrr_stack+117, vrr_stack+84, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+306, vrr_stack+291, vrr_stack+127, vrr_stack+21, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+327, vrr_stack+306, vrr_stack+142, vrr_stack+291, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+355, vrr_stack+327, vrr_stack+227, vrr_stack+306, vrr_stack+142, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+31, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+34, vrr_stack+90, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+40, vrr_stack+117, vrr_stack+50, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+127, vrr_stack+163, vrr_stack+3, vrr_stack+56, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+391, vrr_stack+178, vrr_stack+127, vrr_stack+66, vrr_stack+163, NULL);
 _BUILD_00k0(Data,vrr_stack+419, vrr_stack+199, vrr_stack+391, vrr_stack+96, vrr_stack+178, NULL);
 _BUILD_00l0(Data,vrr_stack+455, vrr_stack+255, vrr_stack+419, vrr_stack+227, vrr_stack+199, NULL);
 _BUILD_00l0(Data,vrr_stack+500, vrr_stack+355, vrr_stack+255, vrr_stack+327, vrr_stack+227, NULL);
 _BUILD_00m0(Data,vrr_stack+545, vrr_stack+500, vrr_stack+455, vrr_stack+355, vrr_stack+255, NULL);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+227, vrr_stack+0, vrr_stack+18, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+233, vrr_stack+90, vrr_stack+227, vrr_stack+31, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+117, vrr_stack+233, vrr_stack+34, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+3, vrr_stack+148, vrr_stack+40, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+31, vrr_stack+127, vrr_stack+96, vrr_stack+163, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+600, vrr_stack+391, vrr_stack+31, vrr_stack+178, vrr_stack+127, NULL);
 _BUILD_00l0(Data,vrr_stack+636, vrr_stack+419, vrr_stack+600, vrr_stack+199, vrr_stack+391, NULL);
 _BUILD_00m0(Data,vrr_stack+163, vrr_stack+455, vrr_stack+636, vrr_stack+255, vrr_stack+419, NULL);
 _BUILD_00n0(Data,vrr_stack+681, vrr_stack+545, vrr_stack+163, vrr_stack+500, vrr_stack+455, NULL);
 _BUILD_00p0(Data,vrr_stack+218, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+221, vrr_stack+218, vrr_stack+81, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+59, vrr_stack+221, vrr_stack+84, vrr_stack+218, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+69, vrr_stack+59, vrr_stack+21, vrr_stack+221, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+243, vrr_stack+69, vrr_stack+291, vrr_stack+59, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+747, vrr_stack+243, vrr_stack+306, vrr_stack+69, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+264, vrr_stack+747, vrr_stack+327, vrr_stack+243, vrr_stack+306, NULL);
 _BUILD_00l0(Data,vrr_stack+775, vrr_stack+264, vrr_stack+355, vrr_stack+747, vrr_stack+327, NULL);
 _BUILD_00m0(Data,vrr_stack+300, vrr_stack+775, vrr_stack+500, vrr_stack+264, vrr_stack+355, NULL);
 _BUILD_00n0(Data,vrr_stack+820, vrr_stack+300, vrr_stack+545, vrr_stack+775, vrr_stack+500, NULL);
 _BUILD_00p0(Data,vrr_stack+500, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+503, vrr_stack+18, vrr_stack+500, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+227, vrr_stack+503, vrr_stack+0, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+509, vrr_stack+233, vrr_stack+21, vrr_stack+90, vrr_stack+227, NULL);
 _BUILD_00h0(Data,vrr_stack+524, vrr_stack+148, vrr_stack+509, vrr_stack+117, vrr_stack+233, NULL);
 _BUILD_00i0(Data,vrr_stack+355, vrr_stack+96, vrr_stack+524, vrr_stack+3, vrr_stack+148, NULL);
 _BUILD_00k0(Data,vrr_stack+747, vrr_stack+31, vrr_stack+355, vrr_stack+127, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+243, vrr_stack+600, vrr_stack+747, vrr_stack+391, vrr_stack+31, NULL);
 _BUILD_00m0(Data,vrr_stack+886, vrr_stack+636, vrr_stack+243, vrr_stack+419, vrr_stack+600, NULL);
 _BUILD_00n0(Data,vrr_stack+383, vrr_stack+163, vrr_stack+886, vrr_stack+455, vrr_stack+636, NULL);
 _BUILD_00o0(Data,vrr_stack+941, vrr_stack+681, vrr_stack+383, vrr_stack+545, vrr_stack+163, NULL);
 _BUILD_00o0(Data,vrr_stack+1019, vrr_stack+820, vrr_stack+681, vrr_stack+300, vrr_stack+545, NULL);
 _BUILD_00p0(Data,vrr_stack+117, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+120, vrr_stack+500, vrr_stack+117, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+126, vrr_stack+503, vrr_stack+120, vrr_stack+18, vrr_stack+500, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+21, vrr_stack+126, vrr_stack+227, vrr_stack+503, NULL);
 _BUILD_00h0(Data,vrr_stack+449, vrr_stack+509, vrr_stack+0, vrr_stack+233, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+470, vrr_stack+524, vrr_stack+449, vrr_stack+148, vrr_stack+509, NULL);
 _BUILD_00k0(Data,vrr_stack+783, vrr_stack+355, vrr_stack+470, vrr_stack+96, vrr_stack+524, NULL);
 _BUILD_00l0(Data,vrr_stack+288, vrr_stack+747, vrr_stack+783, vrr_stack+31, vrr_stack+355, NULL);
 _BUILD_00m0(Data,vrr_stack+31, vrr_stack+243, vrr_stack+288, vrr_stack+600, vrr_stack+747, NULL);
 _BUILD_00n0(Data,vrr_stack+1097, vrr_stack+886, vrr_stack+31, vrr_stack+636, vrr_stack+243, NULL);
 _BUILD_00o0(Data,vrr_stack+600, vrr_stack+383, vrr_stack+1097, vrr_stack+163, vrr_stack+886, NULL);
 _BUILD_00q0(Data,vrr_stack+136, vrr_stack+941, vrr_stack+600, vrr_stack+681, vrr_stack+383, NULL);
 _BUILD_00q0(Data,vrr_stack+1163, vrr_stack+1019, vrr_stack+941, vrr_stack+820, vrr_stack+681, NULL);
 _BUILD_00p0(Data,vrr_stack+678, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+117, vrr_stack+678, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+86, vrr_stack+120, vrr_stack+15, vrr_stack+500, vrr_stack+117, NULL);
 _BUILD_00g0(Data,vrr_stack+96, vrr_stack+126, vrr_stack+86, vrr_stack+503, vrr_stack+120, NULL);
 _BUILD_00h0(Data,vrr_stack+333, vrr_stack+0, vrr_stack+96, vrr_stack+21, vrr_stack+126, NULL);
 _BUILD_00i0(Data,vrr_stack+1254, vrr_stack+449, vrr_stack+333, vrr_stack+509, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+1282, vrr_stack+470, vrr_stack+1254, vrr_stack+524, vrr_stack+449, NULL);
 _BUILD_00l0(Data,vrr_stack+498, vrr_stack+783, vrr_stack+1282, vrr_stack+355, vrr_stack+470, NULL);
 _BUILD_00m0(Data,vrr_stack+1318, vrr_stack+288, vrr_stack+498, vrr_stack+747, vrr_stack+783, NULL);
 _BUILD_00n0(Data,vrr_stack+1373, vrr_stack+31, vrr_stack+1318, vrr_stack+243, vrr_stack+288, NULL);
 _BUILD_00o0(Data,vrr_stack+1439, vrr_stack+1097, vrr_stack+1373, vrr_stack+886, vrr_stack+31, NULL);
 _BUILD_00q0(Data,vrr_stack+1517, vrr_stack+600, vrr_stack+1439, vrr_stack+383, vrr_stack+1097, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1608, vrr_stack+136, vrr_stack+1517, vrr_stack+941, vrr_stack+600, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1713, vrr_stack+1163, vrr_stack+136, vrr_stack+1019, vrr_stack+941, NULL);
 _BUILD_00p0(Data,vrr_stack+886, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+111, vrr_stack+678, vrr_stack+886, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+111, vrr_stack+117, vrr_stack+678, NULL);
 _BUILD_00g0(Data,vrr_stack+889, vrr_stack+86, vrr_stack+21, vrr_stack+120, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+904, vrr_stack+96, vrr_stack+889, vrr_stack+126, vrr_stack+86, NULL);
 _BUILD_00i0(Data,vrr_stack+747, vrr_stack+333, vrr_stack+904, vrr_stack+0, vrr_stack+96, NULL);
 _BUILD_00k0(Data,vrr_stack+227, vrr_stack+1254, vrr_stack+747, vrr_stack+449, vrr_stack+333, NULL);
 _BUILD_00l0(Data,vrr_stack+354, vrr_stack+1282, vrr_stack+227, vrr_stack+470, vrr_stack+1254, NULL);
 _BUILD_00m0(Data,vrr_stack+399, vrr_stack+498, vrr_stack+354, vrr_stack+783, vrr_stack+1282, NULL);
 _BUILD_00n0(Data,vrr_stack+1818, vrr_stack+1318, vrr_stack+399, vrr_stack+288, vrr_stack+498, NULL);
 _BUILD_00o0(Data,vrr_stack+1884, vrr_stack+1373, vrr_stack+1818, vrr_stack+31, vrr_stack+1318, NULL);
 _BUILD_00q0(Data,vrr_stack+1962, vrr_stack+1439, vrr_stack+1884, vrr_stack+1097, vrr_stack+1373, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2053, vrr_stack+1517, vrr_stack+1962, vrr_stack+600, vrr_stack+1439, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2158, vrr_stack+1608, vrr_stack+2053, vrr_stack+136, vrr_stack+1517, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2278, vrr_stack+1713, vrr_stack+1608, vrr_stack+1163, vrr_stack+136, NULL);
 _BUILD_00p0(Data,vrr_stack+600, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+603, vrr_stack+886, vrr_stack+600, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+609, vrr_stack+111, vrr_stack+603, vrr_stack+678, vrr_stack+886, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+21, vrr_stack+609, vrr_stack+15, vrr_stack+111, NULL);
 _BUILD_00h0(Data,vrr_stack+619, vrr_stack+889, vrr_stack+0, vrr_stack+86, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+640, vrr_stack+904, vrr_stack+619, vrr_stack+96, vrr_stack+889, NULL);
 _BUILD_00k0(Data,vrr_stack+1097, vrr_stack+747, vrr_stack+640, vrr_stack+333, vrr_stack+904, NULL);
 _BUILD_00l0(Data,vrr_stack+775, vrr_stack+227, vrr_stack+1097, vrr_stack+1254, vrr_stack+747, NULL);
 _BUILD_00m0(Data,vrr_stack+31, vrr_stack+354, vrr_stack+775, vrr_stack+1282, vrr_stack+227, NULL);
 _BUILD_00n0(Data,vrr_stack+263, vrr_stack+399, vrr_stack+31, vrr_stack+498, vrr_stack+354, NULL);
 _BUILD_00o0(Data,vrr_stack+454, vrr_stack+1818, vrr_stack+263, vrr_stack+1318, vrr_stack+399, NULL);
 _BUILD_00q0(Data,vrr_stack+1254, vrr_stack+1884, vrr_stack+454, vrr_stack+1373, vrr_stack+1818, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2398, vrr_stack+1962, vrr_stack+1254, vrr_stack+1439, vrr_stack+1884, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1345, vrr_stack+2053, vrr_stack+2398, vrr_stack+1517, vrr_stack+1962, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+1465, vrr_stack+2158, vrr_stack+1345, vrr_stack+1608, vrr_stack+2053, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2503, vrr_stack+2278, vrr_stack+2158, vrr_stack+1713, vrr_stack+1608, NULL);
 _BUILD_00p0(Data,vrr_stack+1601, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+600, vrr_stack+1601, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+668, vrr_stack+603, vrr_stack+15, vrr_stack+886, vrr_stack+600, NULL);
 _BUILD_00g0(Data,vrr_stack+1133, vrr_stack+609, vrr_stack+668, vrr_stack+111, vrr_stack+603, NULL);
 _BUILD_00h0(Data,vrr_stack+86, vrr_stack+0, vrr_stack+1133, vrr_stack+21, vrr_stack+609, NULL);
 _BUILD_00i0(Data,vrr_stack+107, vrr_stack+619, vrr_stack+86, vrr_stack+889, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+2639, vrr_stack+640, vrr_stack+107, vrr_stack+904, vrr_stack+619, NULL);
 _BUILD_00l0(Data,vrr_stack+886, vrr_stack+1097, vrr_stack+2639, vrr_stack+747, vrr_stack+640, NULL);
 _BUILD_00m0(Data,vrr_stack+2675, vrr_stack+775, vrr_stack+886, vrr_stack+227, vrr_stack+1097, NULL);
 _BUILD_00n0(Data,vrr_stack+2730, vrr_stack+31, vrr_stack+2675, vrr_stack+354, vrr_stack+775, NULL);
 _BUILD_00o0(Data,vrr_stack+2796, vrr_stack+263, vrr_stack+2730, vrr_stack+399, vrr_stack+31, NULL);
 _BUILD_00q0(Data,vrr_stack+329, vrr_stack+454, vrr_stack+2796, vrr_stack+1818, vrr_stack+263, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2874, vrr_stack+1254, vrr_stack+329, vrr_stack+1884, vrr_stack+454, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1818, vrr_stack+2398, vrr_stack+2874, vrr_stack+1962, vrr_stack+1254, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2979, vrr_stack+1345, vrr_stack+1818, vrr_stack+2053, vrr_stack+2398, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+1938, vrr_stack+1465, vrr_stack+2979, vrr_stack+2158, vrr_stack+1345, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3115, vrr_stack+2503, vrr_stack+1465, vrr_stack+2278, vrr_stack+2158, NULL);
 _BUILD_00p0(Data,vrr_stack+678, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2091, vrr_stack+1601, vrr_stack+678, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+2091, vrr_stack+600, vrr_stack+1601, NULL);
 _BUILD_00g0(Data,vrr_stack+1148, vrr_stack+668, vrr_stack+21, vrr_stack+603, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+2097, vrr_stack+1133, vrr_stack+1148, vrr_stack+609, vrr_stack+668, NULL);
 _BUILD_00i0(Data,vrr_stack+747, vrr_stack+86, vrr_stack+2097, vrr_stack+0, vrr_stack+1133, NULL);
 _BUILD_00k0(Data,vrr_stack+227, vrr_stack+107, vrr_stack+747, vrr_stack+619, vrr_stack+86, NULL);
 _BUILD_00l0(Data,vrr_stack+3268, vrr_stack+2639, vrr_stack+227, vrr_stack+640, vrr_stack+107, NULL);
 _BUILD_00m0(Data,vrr_stack+600, vrr_stack+886, vrr_stack+3268, vrr_stack+1097, vrr_stack+2639, NULL);
 _BUILD_00n0(Data,vrr_stack+3313, vrr_stack+2675, vrr_stack+600, vrr_stack+775, vrr_stack+886, NULL);
 _BUILD_00o0(Data,vrr_stack+3379, vrr_stack+2730, vrr_stack+3313, vrr_stack+31, vrr_stack+2675, NULL);
 _BUILD_00q0(Data,vrr_stack+3457, vrr_stack+2796, vrr_stack+3379, vrr_stack+263, vrr_stack+2730, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3548, vrr_stack+329, vrr_stack+3457, vrr_stack+454, vrr_stack+2796, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+420, vrr_stack+2874, vrr_stack+3548, vrr_stack+1254, vrr_stack+329, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+3653, vrr_stack+1818, vrr_stack+420, vrr_stack+2398, vrr_stack+2874, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3789, vrr_stack+2979, vrr_stack+3653, vrr_stack+1345, vrr_stack+1818, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1254, vrr_stack+1938, vrr_stack+3789, vrr_stack+1465, vrr_stack+2979, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+3942, vrr_stack+3115, vrr_stack+1938, vrr_stack+2503, vrr_stack+1465, NULL);
 _BUILD_00p0(Data,vrr_stack+2398, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2401, vrr_stack+678, vrr_stack+2398, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+931, vrr_stack+2091, vrr_stack+2401, vrr_stack+1601, vrr_stack+678, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+21, vrr_stack+931, vrr_stack+15, vrr_stack+2091, NULL);
 _BUILD_00h0(Data,vrr_stack+2398, vrr_stack+1148, vrr_stack+0, vrr_stack+668, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+0, vrr_stack+2097, vrr_stack+2398, vrr_stack+1133, vrr_stack+1148, NULL);
 _BUILD_00k0(Data,vrr_stack+2398, vrr_stack+747, vrr_stack+0, vrr_stack+86, vrr_stack+2097, NULL);
 _BUILD_00l0(Data,vrr_stack+775, vrr_stack+227, vrr_stack+2398, vrr_stack+107, vrr_stack+747, NULL);
 _BUILD_00m0(Data,vrr_stack+2398, vrr_stack+3268, vrr_stack+775, vrr_stack+2639, vrr_stack+227, NULL);
 _BUILD_00n0(Data,vrr_stack+1097, vrr_stack+600, vrr_stack+2398, vrr_stack+886, vrr_stack+3268, NULL);
 _BUILD_00o0(Data,vrr_stack+2398, vrr_stack+3313, vrr_stack+1097, vrr_stack+2675, vrr_stack+600, NULL);
 _BUILD_00q0(Data,vrr_stack+2639, vrr_stack+3379, vrr_stack+2398, vrr_stack+2730, vrr_stack+3313, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2398, vrr_stack+3457, vrr_stack+2639, vrr_stack+2796, vrr_stack+3379, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2639, vrr_stack+3548, vrr_stack+2398, vrr_stack+329, vrr_stack+3457, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+420, vrr_stack+2639, vrr_stack+2874, vrr_stack+3548, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2639, vrr_stack+3653, vrr_stack+0, vrr_stack+1818, vrr_stack+420, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2792, vrr_stack+3789, vrr_stack+2639, vrr_stack+2979, vrr_stack+3653, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+3268, vrr_stack+1254, vrr_stack+2792, vrr_stack+1938, vrr_stack+3789, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+2639, vrr_stack+3942, vrr_stack+1254, vrr_stack+3115, vrr_stack+1938, NULL);
 _BUILD_p0n0(Data,vrr_stack+2829, vrr_stack+820, vrr_stack+681, NULL, NULL, vrr_stack+545);
   tmp = vrr_stack + 2829;
   target_ptr = Libint->vrr_classes[1][10];
   for(i=0;i<198;i++)
     target_ptr[i] += tmp[i];
 _BUILD_p0o0(Data,vrr_stack+3458, vrr_stack+1019, vrr_stack+941, NULL, NULL, vrr_stack+681);
   tmp = vrr_stack + 3458;
   target_ptr = Libint->vrr_classes[1][11];
   for(i=0;i<234;i++)
     target_ptr[i] += tmp[i];
 _BUILD_p0q0(Data,vrr_stack+227, vrr_stack+1163, vrr_stack+136, NULL, NULL, vrr_stack+941);
   tmp = vrr_stack + 227;
   target_ptr = Libint->vrr_classes[1][12];
   for(i=0;i<273;i++)
     target_ptr[i] += tmp[i];
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+500, vrr_stack+1713, vrr_stack+1608, NULL, NULL, vrr_stack+136);
   tmp = vrr_stack + 500;
   target_ptr = Libint->vrr_classes[1][13];
   for(i=0;i<315;i++)
     target_ptr[i] += tmp[i];
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+815, vrr_stack+2278, vrr_stack+2158, NULL, NULL, vrr_stack+1608);
   tmp = vrr_stack + 815;
   target_ptr = Libint->vrr_classes[1][14];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+4113, vrr_stack+2503, vrr_stack+1465, NULL, NULL, vrr_stack+2158);
   tmp = vrr_stack + 4113;
   target_ptr = Libint->vrr_classes[1][15];
   for(i=0;i<408;i++)
     target_ptr[i] += tmp[i];
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2091, vrr_stack+3115, vrr_stack+1938, NULL, NULL, vrr_stack+1465);
   tmp = vrr_stack + 2091;
   target_ptr = Libint->vrr_classes[1][16];
   for(i=0;i<459;i++)
     target_ptr[i] += tmp[i];
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1425, vrr_stack+3942, vrr_stack+1254, NULL, NULL, vrr_stack+1938);
   tmp = vrr_stack + 1425;
   target_ptr = Libint->vrr_classes[1][17];
   for(i=0;i<513;i++)
     target_ptr[i] += tmp[i];
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+4521, vrr_stack+2639, vrr_stack+3268, NULL, NULL, vrr_stack+1254);
   tmp = vrr_stack + 4521;
   target_ptr = Libint->vrr_classes[1][18];
   for(i=0;i<570;i++)
     target_ptr[i] += tmp[i];

}

