/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_00hd(Libr12_t *, prim_data *);

  /* Computes (00|hd) integrals for linear R12-methods */

void hrr_grt_order_00hd(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[1][5] = int_stack + 0;
 Libr12->t2vrr_classes[0][5] = int_stack + 63;
 Libr12->gvrr_classes[1][6] = int_stack + 84;
 Libr12->t2vrr_classes[0][6] = int_stack + 168;
 Libr12->t2vrr_classes[0][7] = int_stack + 196;
 Libr12->t1vrr_classes[0][5] = int_stack + 232;
 Libr12->t1vrr_classes[0][6] = int_stack + 253;
 Libr12->t1vrr_classes[0][7] = int_stack + 281;
 Libr12->rvrr_classes[0][5] = int_stack + 317;
 Libr12->rvrr_classes[0][6] = int_stack + 338;
 Libr12->rvrr_classes[0][7] = int_stack + 366;
 Libr12->gvrr_classes[0][5] = int_stack + 402;
 Libr12->gvrr_classes[0][6] = int_stack + 423;
 Libr12->gvrr_classes[0][7] = int_stack + 451;
 memset(int_stack,0,487*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 487;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_00hd(Libr12, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+487, int_stack+423, int_stack+402, 1);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+550, int_stack+84, int_stack+0, 3);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+739, int_stack+451, int_stack+423, 1);
 /*--- compute (00|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+823, int_stack+168, int_stack+63, int_stack+423, int_stack+0, int_stack+402, 0, 0);
 /*--- compute (00|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+196, int_stack+168, int_stack+451, int_stack+84, int_stack+423, 0, 0);
 /*--- compute (00|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+84, int_stack+253, int_stack+232, 1);
 /*--- compute (00|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+147, int_stack+281, int_stack+253, 1);
 /*--- compute (00||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+231, int_stack+338, int_stack+317, 1);
 /*--- compute (00||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+402, int_stack+366, int_stack+338, 1);
 /*--- compute (00|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+886, int_stack+0, int_stack+823, int_stack+739, int_stack+550, int_stack+487, 0, 0);
     Libr12->te_ptr[3] = int_stack + 886;
 /*--- compute (00|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+550, int_stack+147, int_stack+84, 1);
     Libr12->te_ptr[2] = int_stack + 550;
 /*--- compute (00||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+0, int_stack+402, int_stack+231, 1);
     Libr12->te_ptr[1] = int_stack + 0;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+126, int_stack+739, int_stack+487, 1);
     Libr12->te_ptr[0] = int_stack + 126;

}
