/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_h0hp(Libr12_t *, prim_data *);

  /* Computes (h0|hp) integrals for linear R12-methods */

void hrr_grt_order_h0hp(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[6][5] = int_stack + 0;
 Libr12->t2vrr_classes[5][5] = int_stack + 588;
 Libr12->t2vrr_classes[5][6] = int_stack + 1029;
 Libr12->t1vrr_classes[5][5] = int_stack + 1617;
 Libr12->t1vrr_classes[5][6] = int_stack + 2058;
 Libr12->rvrr_classes[5][5] = int_stack + 2646;
 Libr12->rvrr_classes[5][6] = int_stack + 3087;
 Libr12->gvrr_classes[5][5] = int_stack + 3675;
 Libr12->gvrr_classes[5][6] = int_stack + 4116;
 memset(int_stack,0,4704*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 4704;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_h0hp(Libr12, Data);
   Data++;
 }

 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4704, int_stack+1029, int_stack+588, int_stack+4116, int_stack+0, int_stack+3675, 5, 0);
     Libr12->te_ptr[3] = int_stack + 4704;
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+2058, int_stack+1617, 21);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1323, int_stack+3087, int_stack+2646, 21);
     Libr12->te_ptr[1] = int_stack + 1323;
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+6027, int_stack+4116, int_stack+3675, 21);
     Libr12->te_ptr[0] = int_stack + 6027;

}
