/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (0s||is) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_00i0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE oneo2n;
  REALTYPE twoo2n;
  REALTYPE threeo2n;
  REALTYPE fouro2n;
  REALTYPE fiveo2n;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  oneo2n = 1.0*Data->oo2n;
  twoo2n = 2.0*Data->oo2n;
  threeo2n = 3.0*Data->oo2n;
  fouro2n = 4.0*Data->oo2n;
  fiveo2n = 5.0*Data->oo2n;
  U20 = Data->U[2][0];
  U21 = Data->U[2][1];
  U22 = Data->U[2][2];
  U10 = Data->U[2][0]*Data->oo2z + Data->U[3][0]*Data->oo2n;
  U11 = Data->U[2][1]*Data->oo2z + Data->U[3][1]*Data->oo2n;
  U12 = Data->U[2][2]*Data->oo2z + Data->U[3][2]*Data->oo2n;

*(vp++) = U20*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (fiveo2n)*I1[0] - (fiveo4zn)*I4[0];
*(vp++) = U20*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (fouro2n)*I1[1] - (fouro4zn)*I4[1];
*(vp++) = U20*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (fouro2n)*I1[2] - (fouro4zn)*I4[2];
*(vp++) = U20*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (threeo2n)*I1[3] - (threeo4zn)*I4[3];
*(vp++) = U20*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (threeo2n)*I1[4] - (threeo4zn)*I4[4];
*(vp++) = U20*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (threeo2n)*I1[5] - (threeo4zn)*I4[5];
*(vp++) = U20*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (twoo2n)*I1[6] - (twoo4zn)*I4[6];
*(vp++) = U20*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (twoo2n)*I1[7] - (twoo4zn)*I4[7];
*(vp++) = U20*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (twoo2n)*I1[8] - (twoo4zn)*I4[8];
*(vp++) = U20*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (twoo2n)*I1[9] - (twoo4zn)*I4[9];
*(vp++) = U20*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (oneo2n)*I1[10] - (oneo4zn)*I4[10];
*(vp++) = U20*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (oneo2n)*I1[11] - (oneo4zn)*I4[11];
*(vp++) = U20*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (oneo2n)*I1[12] - (oneo4zn)*I4[12];
*(vp++) = U20*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (oneo2n)*I1[13] - (oneo4zn)*I4[13];
*(vp++) = U20*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (oneo2n)*I1[14] - (oneo4zn)*I4[14];
*(vp++) = U20*I0[15] - U10*I3[15] + loo2p*I2[15];
*(vp++) = U20*I0[16] - U10*I3[16] + loo2p*I2[16];
*(vp++) = U20*I0[17] - U10*I3[17] + loo2p*I2[17];
*(vp++) = U20*I0[18] - U10*I3[18] + loo2p*I2[18];
*(vp++) = U20*I0[19] - U10*I3[19] + loo2p*I2[19];
*(vp++) = U20*I0[20] - U10*I3[20] + loo2p*I2[20];
*(vp++) = U21*I0[15] - U11*I3[15] + loo2p*I2[21]
        + (fiveo2n)*I1[10] - (fiveo4zn)*I4[10];
*(vp++) = U21*I0[16] - U11*I3[16] + loo2p*I2[22]
        + (fouro2n)*I1[11] - (fouro4zn)*I4[11];
*(vp++) = U21*I0[17] - U11*I3[17] + loo2p*I2[23]
        + (threeo2n)*I1[12] - (threeo4zn)*I4[12];
*(vp++) = U21*I0[18] - U11*I3[18] + loo2p*I2[24]
        + (twoo2n)*I1[13] - (twoo4zn)*I4[13];
*(vp++) = U21*I0[19] - U11*I3[19] + loo2p*I2[25]
        + (oneo2n)*I1[14] - (oneo4zn)*I4[14];
*(vp++) = U21*I0[20] - U11*I3[20] + loo2p*I2[26];
*(vp++) = U22*I0[20] - U12*I3[20] + loo2p*I2[27]
        + (fiveo2n)*I1[14] - (fiveo4zn)*I4[14];

}
