/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (fs||hs) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_f0h0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (twoo2z)*I1[0] - (twoo4zn)*I4[0] - (fiveo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (twoo2z)*I1[1] - (twoo4zn)*I4[1] - (fouro4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (twoo2z)*I1[2] - (twoo4zn)*I4[2] - (fouro4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (twoo2z)*I1[3] - (twoo4zn)*I4[3] - (threeo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (twoo2z)*I1[4] - (twoo4zn)*I4[4] - (threeo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (twoo2z)*I1[5] - (twoo4zn)*I4[5] - (threeo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (twoo2z)*I1[6] - (twoo4zn)*I4[6] - (twoo4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (twoo2z)*I1[7] - (twoo4zn)*I4[7] - (twoo4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (twoo2z)*I1[8] - (twoo4zn)*I4[8] - (twoo4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (twoo2z)*I1[9] - (twoo4zn)*I4[9] - (twoo4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (twoo2z)*I1[10] - (twoo4zn)*I4[10] - (oneo4zn)*I5[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (twoo2z)*I1[11] - (twoo4zn)*I4[11] - (oneo4zn)*I5[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (twoo2z)*I1[12] - (twoo4zn)*I4[12] - (oneo4zn)*I5[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (twoo2z)*I1[13] - (twoo4zn)*I4[13] - (oneo4zn)*I5[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (twoo2z)*I1[14] - (twoo4zn)*I4[14] - (oneo4zn)*I5[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (twoo2z)*I1[15] - (twoo4zn)*I4[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (twoo2z)*I1[16] - (twoo4zn)*I4[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (twoo2z)*I1[17] - (twoo4zn)*I4[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (twoo2z)*I1[18] - (twoo4zn)*I4[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (twoo2z)*I1[19] - (twoo4zn)*I4[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (twoo2z)*I1[20] - (twoo4zn)*I4[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (oneo2z)*I1[21] - (oneo4zn)*I4[21] - (fiveo4zn)*I5[15];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (oneo2z)*I1[22] - (oneo4zn)*I4[22] - (fouro4zn)*I5[16];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (oneo2z)*I1[23] - (oneo4zn)*I4[23] - (fouro4zn)*I5[17];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (oneo2z)*I1[24] - (oneo4zn)*I4[24] - (threeo4zn)*I5[18];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (oneo2z)*I1[25] - (oneo4zn)*I4[25] - (threeo4zn)*I5[19];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (oneo2z)*I1[26] - (oneo4zn)*I4[26] - (threeo4zn)*I5[20];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (oneo2z)*I1[27] - (oneo4zn)*I4[27] - (twoo4zn)*I5[21];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (oneo2z)*I1[28] - (oneo4zn)*I4[28] - (twoo4zn)*I5[22];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (oneo2z)*I1[29] - (oneo4zn)*I4[29] - (twoo4zn)*I5[23];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (oneo2z)*I1[30] - (oneo4zn)*I4[30] - (twoo4zn)*I5[24];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (oneo2z)*I1[31] - (oneo4zn)*I4[31] - (oneo4zn)*I5[25];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (oneo2z)*I1[32] - (oneo4zn)*I4[32] - (oneo4zn)*I5[26];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (oneo2z)*I1[33] - (oneo4zn)*I4[33] - (oneo4zn)*I5[27];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (oneo2z)*I1[34] - (oneo4zn)*I4[34] - (oneo4zn)*I5[28];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (oneo2z)*I1[35] - (oneo4zn)*I4[35] - (oneo4zn)*I5[29];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (oneo2z)*I1[36] - (oneo4zn)*I4[36];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (oneo2z)*I1[37] - (oneo4zn)*I4[37];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (oneo2z)*I1[38] - (oneo4zn)*I4[38];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (oneo2z)*I1[39] - (oneo4zn)*I4[39];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (oneo2z)*I1[40] - (oneo4zn)*I4[40];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (oneo2z)*I1[41] - (oneo4zn)*I4[41];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (oneo2z)*I1[42] - (oneo4zn)*I4[42] - (fiveo4zn)*I5[30];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (oneo2z)*I1[43] - (oneo4zn)*I4[43] - (fouro4zn)*I5[31];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (oneo2z)*I1[44] - (oneo4zn)*I4[44] - (fouro4zn)*I5[32];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (oneo2z)*I1[45] - (oneo4zn)*I4[45] - (threeo4zn)*I5[33];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (oneo2z)*I1[46] - (oneo4zn)*I4[46] - (threeo4zn)*I5[34];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (oneo2z)*I1[47] - (oneo4zn)*I4[47] - (threeo4zn)*I5[35];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (oneo2z)*I1[48] - (oneo4zn)*I4[48] - (twoo4zn)*I5[36];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (oneo2z)*I1[49] - (oneo4zn)*I4[49] - (twoo4zn)*I5[37];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (oneo2z)*I1[50] - (oneo4zn)*I4[50] - (twoo4zn)*I5[38];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (oneo2z)*I1[51] - (oneo4zn)*I4[51] - (twoo4zn)*I5[39];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (oneo2z)*I1[52] - (oneo4zn)*I4[52] - (oneo4zn)*I5[40];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (oneo2z)*I1[53] - (oneo4zn)*I4[53] - (oneo4zn)*I5[41];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (oneo2z)*I1[54] - (oneo4zn)*I4[54] - (oneo4zn)*I5[42];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (oneo2z)*I1[55] - (oneo4zn)*I4[55] - (oneo4zn)*I5[43];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (oneo2z)*I1[56] - (oneo4zn)*I4[56] - (oneo4zn)*I5[44];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (oneo2z)*I1[57] - (oneo4zn)*I4[57];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (oneo2z)*I1[58] - (oneo4zn)*I4[58];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (oneo2z)*I1[59] - (oneo4zn)*I4[59];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (oneo2z)*I1[60] - (oneo4zn)*I4[60];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (oneo2z)*I1[61] - (oneo4zn)*I4[61];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (oneo2z)*I1[62] - (oneo4zn)*I4[62];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63] - (fiveo4zn)*I5[45];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64] - (fouro4zn)*I5[46];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65] - (fouro4zn)*I5[47];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66] - (threeo4zn)*I5[48];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67] - (threeo4zn)*I5[49];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68] - (threeo4zn)*I5[50];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69] - (twoo4zn)*I5[51];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70] - (twoo4zn)*I5[52];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71] - (twoo4zn)*I5[53];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72] - (twoo4zn)*I5[54];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73] - (oneo4zn)*I5[55];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74] - (oneo4zn)*I5[56];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75] - (oneo4zn)*I5[57];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76] - (oneo4zn)*I5[58];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77] - (oneo4zn)*I5[59];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84] - (fiveo4zn)*I5[60];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85] - (fouro4zn)*I5[61];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86] - (fouro4zn)*I5[62];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87] - (threeo4zn)*I5[63];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88] - (threeo4zn)*I5[64];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89] - (threeo4zn)*I5[65];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90] - (twoo4zn)*I5[66];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91] - (twoo4zn)*I5[67];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92] - (twoo4zn)*I5[68];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93] - (twoo4zn)*I5[69];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94] - (oneo4zn)*I5[70];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95] - (oneo4zn)*I5[71];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96] - (oneo4zn)*I5[72];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97] - (oneo4zn)*I5[73];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98] - (oneo4zn)*I5[74];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105] - (fiveo4zn)*I5[75];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106] - (fouro4zn)*I5[76];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107] - (fouro4zn)*I5[77];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108] - (threeo4zn)*I5[78];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109] - (threeo4zn)*I5[79];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110] - (threeo4zn)*I5[80];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111] - (twoo4zn)*I5[81];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112] - (twoo4zn)*I5[82];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113] - (twoo4zn)*I5[83];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114] - (twoo4zn)*I5[84];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115] - (oneo4zn)*I5[85];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116] - (oneo4zn)*I5[86];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117] - (oneo4zn)*I5[87];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118] - (oneo4zn)*I5[88];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119] - (oneo4zn)*I5[89];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125];
*(vp++) = U01*I0[63] - U11*I3[63] + loo2p*I2[126]
        + (twoo2z)*I1[21] - (twoo4zn)*I4[21];
*(vp++) = U01*I0[64] - U11*I3[64] + loo2p*I2[127]
        + (twoo2z)*I1[22] - (twoo4zn)*I4[22] - (oneo4zn)*I5[45];
*(vp++) = U01*I0[65] - U11*I3[65] + loo2p*I2[128]
        + (twoo2z)*I1[23] - (twoo4zn)*I4[23];
*(vp++) = U01*I0[66] - U11*I3[66] + loo2p*I2[129]
        + (twoo2z)*I1[24] - (twoo4zn)*I4[24] - (twoo4zn)*I5[46];
*(vp++) = U01*I0[67] - U11*I3[67] + loo2p*I2[130]
        + (twoo2z)*I1[25] - (twoo4zn)*I4[25] - (oneo4zn)*I5[47];
*(vp++) = U01*I0[68] - U11*I3[68] + loo2p*I2[131]
        + (twoo2z)*I1[26] - (twoo4zn)*I4[26];
*(vp++) = U01*I0[69] - U11*I3[69] + loo2p*I2[132]
        + (twoo2z)*I1[27] - (twoo4zn)*I4[27] - (threeo4zn)*I5[48];
*(vp++) = U01*I0[70] - U11*I3[70] + loo2p*I2[133]
        + (twoo2z)*I1[28] - (twoo4zn)*I4[28] - (twoo4zn)*I5[49];
*(vp++) = U01*I0[71] - U11*I3[71] + loo2p*I2[134]
        + (twoo2z)*I1[29] - (twoo4zn)*I4[29] - (oneo4zn)*I5[50];
*(vp++) = U01*I0[72] - U11*I3[72] + loo2p*I2[135]
        + (twoo2z)*I1[30] - (twoo4zn)*I4[30];
*(vp++) = U01*I0[73] - U11*I3[73] + loo2p*I2[136]
        + (twoo2z)*I1[31] - (twoo4zn)*I4[31] - (fouro4zn)*I5[51];
*(vp++) = U01*I0[74] - U11*I3[74] + loo2p*I2[137]
        + (twoo2z)*I1[32] - (twoo4zn)*I4[32] - (threeo4zn)*I5[52];
*(vp++) = U01*I0[75] - U11*I3[75] + loo2p*I2[138]
        + (twoo2z)*I1[33] - (twoo4zn)*I4[33] - (twoo4zn)*I5[53];
*(vp++) = U01*I0[76] - U11*I3[76] + loo2p*I2[139]
        + (twoo2z)*I1[34] - (twoo4zn)*I4[34] - (oneo4zn)*I5[54];
*(vp++) = U01*I0[77] - U11*I3[77] + loo2p*I2[140]
        + (twoo2z)*I1[35] - (twoo4zn)*I4[35];
*(vp++) = U01*I0[78] - U11*I3[78] + loo2p*I2[141]
        + (twoo2z)*I1[36] - (twoo4zn)*I4[36] - (fiveo4zn)*I5[55];
*(vp++) = U01*I0[79] - U11*I3[79] + loo2p*I2[142]
        + (twoo2z)*I1[37] - (twoo4zn)*I4[37] - (fouro4zn)*I5[56];
*(vp++) = U01*I0[80] - U11*I3[80] + loo2p*I2[143]
        + (twoo2z)*I1[38] - (twoo4zn)*I4[38] - (threeo4zn)*I5[57];
*(vp++) = U01*I0[81] - U11*I3[81] + loo2p*I2[144]
        + (twoo2z)*I1[39] - (twoo4zn)*I4[39] - (twoo4zn)*I5[58];
*(vp++) = U01*I0[82] - U11*I3[82] + loo2p*I2[145]
        + (twoo2z)*I1[40] - (twoo4zn)*I4[40] - (oneo4zn)*I5[59];
*(vp++) = U01*I0[83] - U11*I3[83] + loo2p*I2[146]
        + (twoo2z)*I1[41] - (twoo4zn)*I4[41];
*(vp++) = U01*I0[84] - U11*I3[84] + loo2p*I2[147]
        + (oneo2z)*I1[42] - (oneo4zn)*I4[42];
*(vp++) = U01*I0[85] - U11*I3[85] + loo2p*I2[148]
        + (oneo2z)*I1[43] - (oneo4zn)*I4[43] - (oneo4zn)*I5[60];
*(vp++) = U01*I0[86] - U11*I3[86] + loo2p*I2[149]
        + (oneo2z)*I1[44] - (oneo4zn)*I4[44];
*(vp++) = U01*I0[87] - U11*I3[87] + loo2p*I2[150]
        + (oneo2z)*I1[45] - (oneo4zn)*I4[45] - (twoo4zn)*I5[61];
*(vp++) = U01*I0[88] - U11*I3[88] + loo2p*I2[151]
        + (oneo2z)*I1[46] - (oneo4zn)*I4[46] - (oneo4zn)*I5[62];
*(vp++) = U01*I0[89] - U11*I3[89] + loo2p*I2[152]
        + (oneo2z)*I1[47] - (oneo4zn)*I4[47];
*(vp++) = U01*I0[90] - U11*I3[90] + loo2p*I2[153]
        + (oneo2z)*I1[48] - (oneo4zn)*I4[48] - (threeo4zn)*I5[63];
*(vp++) = U01*I0[91] - U11*I3[91] + loo2p*I2[154]
        + (oneo2z)*I1[49] - (oneo4zn)*I4[49] - (twoo4zn)*I5[64];
*(vp++) = U01*I0[92] - U11*I3[92] + loo2p*I2[155]
        + (oneo2z)*I1[50] - (oneo4zn)*I4[50] - (oneo4zn)*I5[65];
*(vp++) = U01*I0[93] - U11*I3[93] + loo2p*I2[156]
        + (oneo2z)*I1[51] - (oneo4zn)*I4[51];
*(vp++) = U01*I0[94] - U11*I3[94] + loo2p*I2[157]
        + (oneo2z)*I1[52] - (oneo4zn)*I4[52] - (fouro4zn)*I5[66];
*(vp++) = U01*I0[95] - U11*I3[95] + loo2p*I2[158]
        + (oneo2z)*I1[53] - (oneo4zn)*I4[53] - (threeo4zn)*I5[67];
*(vp++) = U01*I0[96] - U11*I3[96] + loo2p*I2[159]
        + (oneo2z)*I1[54] - (oneo4zn)*I4[54] - (twoo4zn)*I5[68];
*(vp++) = U01*I0[97] - U11*I3[97] + loo2p*I2[160]
        + (oneo2z)*I1[55] - (oneo4zn)*I4[55] - (oneo4zn)*I5[69];
*(vp++) = U01*I0[98] - U11*I3[98] + loo2p*I2[161]
        + (oneo2z)*I1[56] - (oneo4zn)*I4[56];
*(vp++) = U01*I0[99] - U11*I3[99] + loo2p*I2[162]
        + (oneo2z)*I1[57] - (oneo4zn)*I4[57] - (fiveo4zn)*I5[70];
*(vp++) = U01*I0[100] - U11*I3[100] + loo2p*I2[163]
        + (oneo2z)*I1[58] - (oneo4zn)*I4[58] - (fouro4zn)*I5[71];
*(vp++) = U01*I0[101] - U11*I3[101] + loo2p*I2[164]
        + (oneo2z)*I1[59] - (oneo4zn)*I4[59] - (threeo4zn)*I5[72];
*(vp++) = U01*I0[102] - U11*I3[102] + loo2p*I2[165]
        + (oneo2z)*I1[60] - (oneo4zn)*I4[60] - (twoo4zn)*I5[73];
*(vp++) = U01*I0[103] - U11*I3[103] + loo2p*I2[166]
        + (oneo2z)*I1[61] - (oneo4zn)*I4[61] - (oneo4zn)*I5[74];
*(vp++) = U01*I0[104] - U11*I3[104] + loo2p*I2[167]
        + (oneo2z)*I1[62] - (oneo4zn)*I4[62];
*(vp++) = U01*I0[105] - U11*I3[105] + loo2p*I2[168];
*(vp++) = U01*I0[106] - U11*I3[106] + loo2p*I2[169] - (oneo4zn)*I5[75];
*(vp++) = U01*I0[107] - U11*I3[107] + loo2p*I2[170];
*(vp++) = U01*I0[108] - U11*I3[108] + loo2p*I2[171] - (twoo4zn)*I5[76];
*(vp++) = U01*I0[109] - U11*I3[109] + loo2p*I2[172] - (oneo4zn)*I5[77];
*(vp++) = U01*I0[110] - U11*I3[110] + loo2p*I2[173];
*(vp++) = U01*I0[111] - U11*I3[111] + loo2p*I2[174] - (threeo4zn)*I5[78];
*(vp++) = U01*I0[112] - U11*I3[112] + loo2p*I2[175] - (twoo4zn)*I5[79];
*(vp++) = U01*I0[113] - U11*I3[113] + loo2p*I2[176] - (oneo4zn)*I5[80];
*(vp++) = U01*I0[114] - U11*I3[114] + loo2p*I2[177];
*(vp++) = U01*I0[115] - U11*I3[115] + loo2p*I2[178] - (fouro4zn)*I5[81];
*(vp++) = U01*I0[116] - U11*I3[116] + loo2p*I2[179] - (threeo4zn)*I5[82];
*(vp++) = U01*I0[117] - U11*I3[117] + loo2p*I2[180] - (twoo4zn)*I5[83];
*(vp++) = U01*I0[118] - U11*I3[118] + loo2p*I2[181] - (oneo4zn)*I5[84];
*(vp++) = U01*I0[119] - U11*I3[119] + loo2p*I2[182];
*(vp++) = U01*I0[120] - U11*I3[120] + loo2p*I2[183] - (fiveo4zn)*I5[85];
*(vp++) = U01*I0[121] - U11*I3[121] + loo2p*I2[184] - (fouro4zn)*I5[86];
*(vp++) = U01*I0[122] - U11*I3[122] + loo2p*I2[185] - (threeo4zn)*I5[87];
*(vp++) = U01*I0[123] - U11*I3[123] + loo2p*I2[186] - (twoo4zn)*I5[88];
*(vp++) = U01*I0[124] - U11*I3[124] + loo2p*I2[187] - (oneo4zn)*I5[89];
*(vp++) = U01*I0[125] - U11*I3[125] + loo2p*I2[188];
*(vp++) = U02*I0[105] - U12*I3[105] + loo2p*I2[189]
        + (twoo2z)*I1[42] - (twoo4zn)*I4[42];
*(vp++) = U02*I0[106] - U12*I3[106] + loo2p*I2[190]
        + (twoo2z)*I1[43] - (twoo4zn)*I4[43];
*(vp++) = U02*I0[107] - U12*I3[107] + loo2p*I2[191]
        + (twoo2z)*I1[44] - (twoo4zn)*I4[44] - (oneo4zn)*I5[75];
*(vp++) = U02*I0[108] - U12*I3[108] + loo2p*I2[192]
        + (twoo2z)*I1[45] - (twoo4zn)*I4[45];
*(vp++) = U02*I0[109] - U12*I3[109] + loo2p*I2[193]
        + (twoo2z)*I1[46] - (twoo4zn)*I4[46] - (oneo4zn)*I5[76];
*(vp++) = U02*I0[110] - U12*I3[110] + loo2p*I2[194]
        + (twoo2z)*I1[47] - (twoo4zn)*I4[47] - (twoo4zn)*I5[77];
*(vp++) = U02*I0[111] - U12*I3[111] + loo2p*I2[195]
        + (twoo2z)*I1[48] - (twoo4zn)*I4[48];
*(vp++) = U02*I0[112] - U12*I3[112] + loo2p*I2[196]
        + (twoo2z)*I1[49] - (twoo4zn)*I4[49] - (oneo4zn)*I5[78];
*(vp++) = U02*I0[113] - U12*I3[113] + loo2p*I2[197]
        + (twoo2z)*I1[50] - (twoo4zn)*I4[50] - (twoo4zn)*I5[79];
*(vp++) = U02*I0[114] - U12*I3[114] + loo2p*I2[198]
        + (twoo2z)*I1[51] - (twoo4zn)*I4[51] - (threeo4zn)*I5[80];
*(vp++) = U02*I0[115] - U12*I3[115] + loo2p*I2[199]
        + (twoo2z)*I1[52] - (twoo4zn)*I4[52];
*(vp++) = U02*I0[116] - U12*I3[116] + loo2p*I2[200]
        + (twoo2z)*I1[53] - (twoo4zn)*I4[53] - (oneo4zn)*I5[81];
*(vp++) = U02*I0[117] - U12*I3[117] + loo2p*I2[201]
        + (twoo2z)*I1[54] - (twoo4zn)*I4[54] - (twoo4zn)*I5[82];
*(vp++) = U02*I0[118] - U12*I3[118] + loo2p*I2[202]
        + (twoo2z)*I1[55] - (twoo4zn)*I4[55] - (threeo4zn)*I5[83];
*(vp++) = U02*I0[119] - U12*I3[119] + loo2p*I2[203]
        + (twoo2z)*I1[56] - (twoo4zn)*I4[56] - (fouro4zn)*I5[84];
*(vp++) = U02*I0[120] - U12*I3[120] + loo2p*I2[204]
        + (twoo2z)*I1[57] - (twoo4zn)*I4[57];
*(vp++) = U02*I0[121] - U12*I3[121] + loo2p*I2[205]
        + (twoo2z)*I1[58] - (twoo4zn)*I4[58] - (oneo4zn)*I5[85];
*(vp++) = U02*I0[122] - U12*I3[122] + loo2p*I2[206]
        + (twoo2z)*I1[59] - (twoo4zn)*I4[59] - (twoo4zn)*I5[86];
*(vp++) = U02*I0[123] - U12*I3[123] + loo2p*I2[207]
        + (twoo2z)*I1[60] - (twoo4zn)*I4[60] - (threeo4zn)*I5[87];
*(vp++) = U02*I0[124] - U12*I3[124] + loo2p*I2[208]
        + (twoo2z)*I1[61] - (twoo4zn)*I4[61] - (fouro4zn)*I5[88];
*(vp++) = U02*I0[125] - U12*I3[125] + loo2p*I2[209]
        + (twoo2z)*I1[62] - (twoo4zn)*I4[62] - (fiveo4zn)*I5[89];

}
