/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (hs||ls) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_r_build_h0l0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE eighto4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  eighto4zn = 8.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (fouro2z)*I1[0] - (fouro4zn)*I4[0] - (eighto4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (fouro2z)*I1[1] - (fouro4zn)*I4[1] - (seveno4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (fouro2z)*I1[2] - (fouro4zn)*I4[2] - (seveno4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (fouro2z)*I1[3] - (fouro4zn)*I4[3] - (sixo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (fouro2z)*I1[4] - (fouro4zn)*I4[4] - (sixo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (fouro2z)*I1[5] - (fouro4zn)*I4[5] - (sixo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (fouro2z)*I1[6] - (fouro4zn)*I4[6] - (fiveo4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (fouro2z)*I1[7] - (fouro4zn)*I4[7] - (fiveo4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (fouro2z)*I1[8] - (fouro4zn)*I4[8] - (fiveo4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (fouro2z)*I1[9] - (fouro4zn)*I4[9] - (fiveo4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (fouro2z)*I1[10] - (fouro4zn)*I4[10] - (fouro4zn)*I5[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (fouro2z)*I1[11] - (fouro4zn)*I4[11] - (fouro4zn)*I5[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (fouro2z)*I1[12] - (fouro4zn)*I4[12] - (fouro4zn)*I5[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (fouro2z)*I1[13] - (fouro4zn)*I4[13] - (fouro4zn)*I5[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (fouro2z)*I1[14] - (fouro4zn)*I4[14] - (fouro4zn)*I5[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (fouro2z)*I1[15] - (fouro4zn)*I4[15] - (threeo4zn)*I5[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (fouro2z)*I1[16] - (fouro4zn)*I4[16] - (threeo4zn)*I5[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (fouro2z)*I1[17] - (fouro4zn)*I4[17] - (threeo4zn)*I5[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (fouro2z)*I1[18] - (fouro4zn)*I4[18] - (threeo4zn)*I5[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (fouro2z)*I1[19] - (fouro4zn)*I4[19] - (threeo4zn)*I5[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (fouro2z)*I1[20] - (fouro4zn)*I4[20] - (threeo4zn)*I5[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (fouro2z)*I1[21] - (fouro4zn)*I4[21] - (twoo4zn)*I5[21];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (fouro2z)*I1[22] - (fouro4zn)*I4[22] - (twoo4zn)*I5[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (fouro2z)*I1[23] - (fouro4zn)*I4[23] - (twoo4zn)*I5[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (fouro2z)*I1[24] - (fouro4zn)*I4[24] - (twoo4zn)*I5[24];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (fouro2z)*I1[25] - (fouro4zn)*I4[25] - (twoo4zn)*I5[25];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (fouro2z)*I1[26] - (fouro4zn)*I4[26] - (twoo4zn)*I5[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (fouro2z)*I1[27] - (fouro4zn)*I4[27] - (twoo4zn)*I5[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (fouro2z)*I1[28] - (fouro4zn)*I4[28] - (oneo4zn)*I5[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (fouro2z)*I1[29] - (fouro4zn)*I4[29] - (oneo4zn)*I5[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (fouro2z)*I1[30] - (fouro4zn)*I4[30] - (oneo4zn)*I5[30];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (fouro2z)*I1[31] - (fouro4zn)*I4[31] - (oneo4zn)*I5[31];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (fouro2z)*I1[32] - (fouro4zn)*I4[32] - (oneo4zn)*I5[32];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (fouro2z)*I1[33] - (fouro4zn)*I4[33] - (oneo4zn)*I5[33];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (fouro2z)*I1[34] - (fouro4zn)*I4[34] - (oneo4zn)*I5[34];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (fouro2z)*I1[35] - (fouro4zn)*I4[35] - (oneo4zn)*I5[35];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (fouro2z)*I1[36] - (fouro4zn)*I4[36];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (fouro2z)*I1[37] - (fouro4zn)*I4[37];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (fouro2z)*I1[38] - (fouro4zn)*I4[38];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (fouro2z)*I1[39] - (fouro4zn)*I4[39];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (fouro2z)*I1[40] - (fouro4zn)*I4[40];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (fouro2z)*I1[41] - (fouro4zn)*I4[41];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (fouro2z)*I1[42] - (fouro4zn)*I4[42];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (fouro2z)*I1[43] - (fouro4zn)*I4[43];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (fouro2z)*I1[44] - (fouro4zn)*I4[44];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (threeo2z)*I1[45] - (threeo4zn)*I4[45] - (eighto4zn)*I5[36];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (threeo2z)*I1[46] - (threeo4zn)*I4[46] - (seveno4zn)*I5[37];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (threeo2z)*I1[47] - (threeo4zn)*I4[47] - (seveno4zn)*I5[38];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (threeo2z)*I1[48] - (threeo4zn)*I4[48] - (sixo4zn)*I5[39];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (threeo2z)*I1[49] - (threeo4zn)*I4[49] - (sixo4zn)*I5[40];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (threeo2z)*I1[50] - (threeo4zn)*I4[50] - (sixo4zn)*I5[41];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (threeo2z)*I1[51] - (threeo4zn)*I4[51] - (fiveo4zn)*I5[42];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (threeo2z)*I1[52] - (threeo4zn)*I4[52] - (fiveo4zn)*I5[43];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (threeo2z)*I1[53] - (threeo4zn)*I4[53] - (fiveo4zn)*I5[44];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (threeo2z)*I1[54] - (threeo4zn)*I4[54] - (fiveo4zn)*I5[45];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (threeo2z)*I1[55] - (threeo4zn)*I4[55] - (fouro4zn)*I5[46];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (threeo2z)*I1[56] - (threeo4zn)*I4[56] - (fouro4zn)*I5[47];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (threeo2z)*I1[57] - (threeo4zn)*I4[57] - (fouro4zn)*I5[48];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (threeo2z)*I1[58] - (threeo4zn)*I4[58] - (fouro4zn)*I5[49];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (threeo2z)*I1[59] - (threeo4zn)*I4[59] - (fouro4zn)*I5[50];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (threeo2z)*I1[60] - (threeo4zn)*I4[60] - (threeo4zn)*I5[51];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (threeo2z)*I1[61] - (threeo4zn)*I4[61] - (threeo4zn)*I5[52];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (threeo2z)*I1[62] - (threeo4zn)*I4[62] - (threeo4zn)*I5[53];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (threeo2z)*I1[63] - (threeo4zn)*I4[63] - (threeo4zn)*I5[54];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (threeo2z)*I1[64] - (threeo4zn)*I4[64] - (threeo4zn)*I5[55];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (threeo2z)*I1[65] - (threeo4zn)*I4[65] - (threeo4zn)*I5[56];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (threeo2z)*I1[66] - (threeo4zn)*I4[66] - (twoo4zn)*I5[57];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (threeo2z)*I1[67] - (threeo4zn)*I4[67] - (twoo4zn)*I5[58];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (threeo2z)*I1[68] - (threeo4zn)*I4[68] - (twoo4zn)*I5[59];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (threeo2z)*I1[69] - (threeo4zn)*I4[69] - (twoo4zn)*I5[60];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (threeo2z)*I1[70] - (threeo4zn)*I4[70] - (twoo4zn)*I5[61];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (threeo2z)*I1[71] - (threeo4zn)*I4[71] - (twoo4zn)*I5[62];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (threeo2z)*I1[72] - (threeo4zn)*I4[72] - (twoo4zn)*I5[63];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (threeo2z)*I1[73] - (threeo4zn)*I4[73] - (oneo4zn)*I5[64];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (threeo2z)*I1[74] - (threeo4zn)*I4[74] - (oneo4zn)*I5[65];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (threeo2z)*I1[75] - (threeo4zn)*I4[75] - (oneo4zn)*I5[66];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (threeo2z)*I1[76] - (threeo4zn)*I4[76] - (oneo4zn)*I5[67];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (threeo2z)*I1[77] - (threeo4zn)*I4[77] - (oneo4zn)*I5[68];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (threeo2z)*I1[78] - (threeo4zn)*I4[78] - (oneo4zn)*I5[69];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (threeo2z)*I1[79] - (threeo4zn)*I4[79] - (oneo4zn)*I5[70];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (threeo2z)*I1[80] - (threeo4zn)*I4[80] - (oneo4zn)*I5[71];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (threeo2z)*I1[81] - (threeo4zn)*I4[81];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (threeo2z)*I1[82] - (threeo4zn)*I4[82];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (threeo2z)*I1[83] - (threeo4zn)*I4[83];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (threeo2z)*I1[84] - (threeo4zn)*I4[84];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (threeo2z)*I1[85] - (threeo4zn)*I4[85];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (threeo2z)*I1[86] - (threeo4zn)*I4[86];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (threeo2z)*I1[87] - (threeo4zn)*I4[87];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (threeo2z)*I1[88] - (threeo4zn)*I4[88];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (threeo2z)*I1[89] - (threeo4zn)*I4[89];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (threeo2z)*I1[90] - (threeo4zn)*I4[90] - (eighto4zn)*I5[72];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (threeo2z)*I1[91] - (threeo4zn)*I4[91] - (seveno4zn)*I5[73];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (threeo2z)*I1[92] - (threeo4zn)*I4[92] - (seveno4zn)*I5[74];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (threeo2z)*I1[93] - (threeo4zn)*I4[93] - (sixo4zn)*I5[75];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (threeo2z)*I1[94] - (threeo4zn)*I4[94] - (sixo4zn)*I5[76];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (threeo2z)*I1[95] - (threeo4zn)*I4[95] - (sixo4zn)*I5[77];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (threeo2z)*I1[96] - (threeo4zn)*I4[96] - (fiveo4zn)*I5[78];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (threeo2z)*I1[97] - (threeo4zn)*I4[97] - (fiveo4zn)*I5[79];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (threeo2z)*I1[98] - (threeo4zn)*I4[98] - (fiveo4zn)*I5[80];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (threeo2z)*I1[99] - (threeo4zn)*I4[99] - (fiveo4zn)*I5[81];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (threeo2z)*I1[100] - (threeo4zn)*I4[100] - (fouro4zn)*I5[82];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (threeo2z)*I1[101] - (threeo4zn)*I4[101] - (fouro4zn)*I5[83];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (threeo2z)*I1[102] - (threeo4zn)*I4[102] - (fouro4zn)*I5[84];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (threeo2z)*I1[103] - (threeo4zn)*I4[103] - (fouro4zn)*I5[85];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (threeo2z)*I1[104] - (threeo4zn)*I4[104] - (fouro4zn)*I5[86];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (threeo2z)*I1[105] - (threeo4zn)*I4[105] - (threeo4zn)*I5[87];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (threeo2z)*I1[106] - (threeo4zn)*I4[106] - (threeo4zn)*I5[88];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (threeo2z)*I1[107] - (threeo4zn)*I4[107] - (threeo4zn)*I5[89];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (threeo2z)*I1[108] - (threeo4zn)*I4[108] - (threeo4zn)*I5[90];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (threeo2z)*I1[109] - (threeo4zn)*I4[109] - (threeo4zn)*I5[91];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (threeo2z)*I1[110] - (threeo4zn)*I4[110] - (threeo4zn)*I5[92];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (threeo2z)*I1[111] - (threeo4zn)*I4[111] - (twoo4zn)*I5[93];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (threeo2z)*I1[112] - (threeo4zn)*I4[112] - (twoo4zn)*I5[94];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (threeo2z)*I1[113] - (threeo4zn)*I4[113] - (twoo4zn)*I5[95];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (threeo2z)*I1[114] - (threeo4zn)*I4[114] - (twoo4zn)*I5[96];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (threeo2z)*I1[115] - (threeo4zn)*I4[115] - (twoo4zn)*I5[97];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (threeo2z)*I1[116] - (threeo4zn)*I4[116] - (twoo4zn)*I5[98];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (threeo2z)*I1[117] - (threeo4zn)*I4[117] - (twoo4zn)*I5[99];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (threeo2z)*I1[118] - (threeo4zn)*I4[118] - (oneo4zn)*I5[100];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (threeo2z)*I1[119] - (threeo4zn)*I4[119] - (oneo4zn)*I5[101];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (threeo2z)*I1[120] - (threeo4zn)*I4[120] - (oneo4zn)*I5[102];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (threeo2z)*I1[121] - (threeo4zn)*I4[121] - (oneo4zn)*I5[103];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (threeo2z)*I1[122] - (threeo4zn)*I4[122] - (oneo4zn)*I5[104];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (threeo2z)*I1[123] - (threeo4zn)*I4[123] - (oneo4zn)*I5[105];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (threeo2z)*I1[124] - (threeo4zn)*I4[124] - (oneo4zn)*I5[106];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (threeo2z)*I1[125] - (threeo4zn)*I4[125] - (oneo4zn)*I5[107];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126]
        + (threeo2z)*I1[126] - (threeo4zn)*I4[126];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127]
        + (threeo2z)*I1[127] - (threeo4zn)*I4[127];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128]
        + (threeo2z)*I1[128] - (threeo4zn)*I4[128];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129]
        + (threeo2z)*I1[129] - (threeo4zn)*I4[129];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130]
        + (threeo2z)*I1[130] - (threeo4zn)*I4[130];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131]
        + (threeo2z)*I1[131] - (threeo4zn)*I4[131];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132]
        + (threeo2z)*I1[132] - (threeo4zn)*I4[132];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133]
        + (threeo2z)*I1[133] - (threeo4zn)*I4[133];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134]
        + (threeo2z)*I1[134] - (threeo4zn)*I4[134];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135]
        + (twoo2z)*I1[135] - (twoo4zn)*I4[135] - (eighto4zn)*I5[108];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136]
        + (twoo2z)*I1[136] - (twoo4zn)*I4[136] - (seveno4zn)*I5[109];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137]
        + (twoo2z)*I1[137] - (twoo4zn)*I4[137] - (seveno4zn)*I5[110];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138]
        + (twoo2z)*I1[138] - (twoo4zn)*I4[138] - (sixo4zn)*I5[111];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139]
        + (twoo2z)*I1[139] - (twoo4zn)*I4[139] - (sixo4zn)*I5[112];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140]
        + (twoo2z)*I1[140] - (twoo4zn)*I4[140] - (sixo4zn)*I5[113];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141]
        + (twoo2z)*I1[141] - (twoo4zn)*I4[141] - (fiveo4zn)*I5[114];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142]
        + (twoo2z)*I1[142] - (twoo4zn)*I4[142] - (fiveo4zn)*I5[115];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143]
        + (twoo2z)*I1[143] - (twoo4zn)*I4[143] - (fiveo4zn)*I5[116];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144]
        + (twoo2z)*I1[144] - (twoo4zn)*I4[144] - (fiveo4zn)*I5[117];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145]
        + (twoo2z)*I1[145] - (twoo4zn)*I4[145] - (fouro4zn)*I5[118];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146]
        + (twoo2z)*I1[146] - (twoo4zn)*I4[146] - (fouro4zn)*I5[119];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147]
        + (twoo2z)*I1[147] - (twoo4zn)*I4[147] - (fouro4zn)*I5[120];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148]
        + (twoo2z)*I1[148] - (twoo4zn)*I4[148] - (fouro4zn)*I5[121];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149]
        + (twoo2z)*I1[149] - (twoo4zn)*I4[149] - (fouro4zn)*I5[122];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150]
        + (twoo2z)*I1[150] - (twoo4zn)*I4[150] - (threeo4zn)*I5[123];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151]
        + (twoo2z)*I1[151] - (twoo4zn)*I4[151] - (threeo4zn)*I5[124];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152]
        + (twoo2z)*I1[152] - (twoo4zn)*I4[152] - (threeo4zn)*I5[125];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153]
        + (twoo2z)*I1[153] - (twoo4zn)*I4[153] - (threeo4zn)*I5[126];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154]
        + (twoo2z)*I1[154] - (twoo4zn)*I4[154] - (threeo4zn)*I5[127];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155]
        + (twoo2z)*I1[155] - (twoo4zn)*I4[155] - (threeo4zn)*I5[128];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156]
        + (twoo2z)*I1[156] - (twoo4zn)*I4[156] - (twoo4zn)*I5[129];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157]
        + (twoo2z)*I1[157] - (twoo4zn)*I4[157] - (twoo4zn)*I5[130];
*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158]
        + (twoo2z)*I1[158] - (twoo4zn)*I4[158] - (twoo4zn)*I5[131];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159]
        + (twoo2z)*I1[159] - (twoo4zn)*I4[159] - (twoo4zn)*I5[132];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160]
        + (twoo2z)*I1[160] - (twoo4zn)*I4[160] - (twoo4zn)*I5[133];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161]
        + (twoo2z)*I1[161] - (twoo4zn)*I4[161] - (twoo4zn)*I5[134];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162]
        + (twoo2z)*I1[162] - (twoo4zn)*I4[162] - (twoo4zn)*I5[135];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163]
        + (twoo2z)*I1[163] - (twoo4zn)*I4[163] - (oneo4zn)*I5[136];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164]
        + (twoo2z)*I1[164] - (twoo4zn)*I4[164] - (oneo4zn)*I5[137];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165]
        + (twoo2z)*I1[165] - (twoo4zn)*I4[165] - (oneo4zn)*I5[138];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166]
        + (twoo2z)*I1[166] - (twoo4zn)*I4[166] - (oneo4zn)*I5[139];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167]
        + (twoo2z)*I1[167] - (twoo4zn)*I4[167] - (oneo4zn)*I5[140];
*(vp++) = U00*I0[168] - U10*I3[168] + loo2p*I2[168]
        + (twoo2z)*I1[168] - (twoo4zn)*I4[168] - (oneo4zn)*I5[141];
*(vp++) = U00*I0[169] - U10*I3[169] + loo2p*I2[169]
        + (twoo2z)*I1[169] - (twoo4zn)*I4[169] - (oneo4zn)*I5[142];
*(vp++) = U00*I0[170] - U10*I3[170] + loo2p*I2[170]
        + (twoo2z)*I1[170] - (twoo4zn)*I4[170] - (oneo4zn)*I5[143];
*(vp++) = U00*I0[171] - U10*I3[171] + loo2p*I2[171]
        + (twoo2z)*I1[171] - (twoo4zn)*I4[171];
*(vp++) = U00*I0[172] - U10*I3[172] + loo2p*I2[172]
        + (twoo2z)*I1[172] - (twoo4zn)*I4[172];
*(vp++) = U00*I0[173] - U10*I3[173] + loo2p*I2[173]
        + (twoo2z)*I1[173] - (twoo4zn)*I4[173];
*(vp++) = U00*I0[174] - U10*I3[174] + loo2p*I2[174]
        + (twoo2z)*I1[174] - (twoo4zn)*I4[174];
*(vp++) = U00*I0[175] - U10*I3[175] + loo2p*I2[175]
        + (twoo2z)*I1[175] - (twoo4zn)*I4[175];
*(vp++) = U00*I0[176] - U10*I3[176] + loo2p*I2[176]
        + (twoo2z)*I1[176] - (twoo4zn)*I4[176];
*(vp++) = U00*I0[177] - U10*I3[177] + loo2p*I2[177]
        + (twoo2z)*I1[177] - (twoo4zn)*I4[177];
*(vp++) = U00*I0[178] - U10*I3[178] + loo2p*I2[178]
        + (twoo2z)*I1[178] - (twoo4zn)*I4[178];
*(vp++) = U00*I0[179] - U10*I3[179] + loo2p*I2[179]
        + (twoo2z)*I1[179] - (twoo4zn)*I4[179];
*(vp++) = U00*I0[180] - U10*I3[180] + loo2p*I2[180]
        + (twoo2z)*I1[180] - (twoo4zn)*I4[180] - (eighto4zn)*I5[144];
*(vp++) = U00*I0[181] - U10*I3[181] + loo2p*I2[181]
        + (twoo2z)*I1[181] - (twoo4zn)*I4[181] - (seveno4zn)*I5[145];
*(vp++) = U00*I0[182] - U10*I3[182] + loo2p*I2[182]
        + (twoo2z)*I1[182] - (twoo4zn)*I4[182] - (seveno4zn)*I5[146];
*(vp++) = U00*I0[183] - U10*I3[183] + loo2p*I2[183]
        + (twoo2z)*I1[183] - (twoo4zn)*I4[183] - (sixo4zn)*I5[147];
*(vp++) = U00*I0[184] - U10*I3[184] + loo2p*I2[184]
        + (twoo2z)*I1[184] - (twoo4zn)*I4[184] - (sixo4zn)*I5[148];
*(vp++) = U00*I0[185] - U10*I3[185] + loo2p*I2[185]
        + (twoo2z)*I1[185] - (twoo4zn)*I4[185] - (sixo4zn)*I5[149];
*(vp++) = U00*I0[186] - U10*I3[186] + loo2p*I2[186]
        + (twoo2z)*I1[186] - (twoo4zn)*I4[186] - (fiveo4zn)*I5[150];
*(vp++) = U00*I0[187] - U10*I3[187] + loo2p*I2[187]
        + (twoo2z)*I1[187] - (twoo4zn)*I4[187] - (fiveo4zn)*I5[151];
*(vp++) = U00*I0[188] - U10*I3[188] + loo2p*I2[188]
        + (twoo2z)*I1[188] - (twoo4zn)*I4[188] - (fiveo4zn)*I5[152];
*(vp++) = U00*I0[189] - U10*I3[189] + loo2p*I2[189]
        + (twoo2z)*I1[189] - (twoo4zn)*I4[189] - (fiveo4zn)*I5[153];
*(vp++) = U00*I0[190] - U10*I3[190] + loo2p*I2[190]
        + (twoo2z)*I1[190] - (twoo4zn)*I4[190] - (fouro4zn)*I5[154];
*(vp++) = U00*I0[191] - U10*I3[191] + loo2p*I2[191]
        + (twoo2z)*I1[191] - (twoo4zn)*I4[191] - (fouro4zn)*I5[155];
*(vp++) = U00*I0[192] - U10*I3[192] + loo2p*I2[192]
        + (twoo2z)*I1[192] - (twoo4zn)*I4[192] - (fouro4zn)*I5[156];
*(vp++) = U00*I0[193] - U10*I3[193] + loo2p*I2[193]
        + (twoo2z)*I1[193] - (twoo4zn)*I4[193] - (fouro4zn)*I5[157];
*(vp++) = U00*I0[194] - U10*I3[194] + loo2p*I2[194]
        + (twoo2z)*I1[194] - (twoo4zn)*I4[194] - (fouro4zn)*I5[158];
*(vp++) = U00*I0[195] - U10*I3[195] + loo2p*I2[195]
        + (twoo2z)*I1[195] - (twoo4zn)*I4[195] - (threeo4zn)*I5[159];
*(vp++) = U00*I0[196] - U10*I3[196] + loo2p*I2[196]
        + (twoo2z)*I1[196] - (twoo4zn)*I4[196] - (threeo4zn)*I5[160];
*(vp++) = U00*I0[197] - U10*I3[197] + loo2p*I2[197]
        + (twoo2z)*I1[197] - (twoo4zn)*I4[197] - (threeo4zn)*I5[161];
*(vp++) = U00*I0[198] - U10*I3[198] + loo2p*I2[198]
        + (twoo2z)*I1[198] - (twoo4zn)*I4[198] - (threeo4zn)*I5[162];
*(vp++) = U00*I0[199] - U10*I3[199] + loo2p*I2[199]
        + (twoo2z)*I1[199] - (twoo4zn)*I4[199] - (threeo4zn)*I5[163];
*(vp++) = U00*I0[200] - U10*I3[200] + loo2p*I2[200]
        + (twoo2z)*I1[200] - (twoo4zn)*I4[200] - (threeo4zn)*I5[164];
*(vp++) = U00*I0[201] - U10*I3[201] + loo2p*I2[201]
        + (twoo2z)*I1[201] - (twoo4zn)*I4[201] - (twoo4zn)*I5[165];
*(vp++) = U00*I0[202] - U10*I3[202] + loo2p*I2[202]
        + (twoo2z)*I1[202] - (twoo4zn)*I4[202] - (twoo4zn)*I5[166];
*(vp++) = U00*I0[203] - U10*I3[203] + loo2p*I2[203]
        + (twoo2z)*I1[203] - (twoo4zn)*I4[203] - (twoo4zn)*I5[167];
*(vp++) = U00*I0[204] - U10*I3[204] + loo2p*I2[204]
        + (twoo2z)*I1[204] - (twoo4zn)*I4[204] - (twoo4zn)*I5[168];
*(vp++) = U00*I0[205] - U10*I3[205] + loo2p*I2[205]
        + (twoo2z)*I1[205] - (twoo4zn)*I4[205] - (twoo4zn)*I5[169];
*(vp++) = U00*I0[206] - U10*I3[206] + loo2p*I2[206]
        + (twoo2z)*I1[206] - (twoo4zn)*I4[206] - (twoo4zn)*I5[170];
*(vp++) = U00*I0[207] - U10*I3[207] + loo2p*I2[207]
        + (twoo2z)*I1[207] - (twoo4zn)*I4[207] - (twoo4zn)*I5[171];
*(vp++) = U00*I0[208] - U10*I3[208] + loo2p*I2[208]
        + (twoo2z)*I1[208] - (twoo4zn)*I4[208] - (oneo4zn)*I5[172];
*(vp++) = U00*I0[209] - U10*I3[209] + loo2p*I2[209]
        + (twoo2z)*I1[209] - (twoo4zn)*I4[209] - (oneo4zn)*I5[173];
*(vp++) = U00*I0[210] - U10*I3[210] + loo2p*I2[210]
        + (twoo2z)*I1[210] - (twoo4zn)*I4[210] - (oneo4zn)*I5[174];
*(vp++) = U00*I0[211] - U10*I3[211] + loo2p*I2[211]
        + (twoo2z)*I1[211] - (twoo4zn)*I4[211] - (oneo4zn)*I5[175];
*(vp++) = U00*I0[212] - U10*I3[212] + loo2p*I2[212]
        + (twoo2z)*I1[212] - (twoo4zn)*I4[212] - (oneo4zn)*I5[176];
*(vp++) = U00*I0[213] - U10*I3[213] + loo2p*I2[213]
        + (twoo2z)*I1[213] - (twoo4zn)*I4[213] - (oneo4zn)*I5[177];
*(vp++) = U00*I0[214] - U10*I3[214] + loo2p*I2[214]
        + (twoo2z)*I1[214] - (twoo4zn)*I4[214] - (oneo4zn)*I5[178];
*(vp++) = U00*I0[215] - U10*I3[215] + loo2p*I2[215]
        + (twoo2z)*I1[215] - (twoo4zn)*I4[215] - (oneo4zn)*I5[179];
*(vp++) = U00*I0[216] - U10*I3[216] + loo2p*I2[216]
        + (twoo2z)*I1[216] - (twoo4zn)*I4[216];
*(vp++) = U00*I0[217] - U10*I3[217] + loo2p*I2[217]
        + (twoo2z)*I1[217] - (twoo4zn)*I4[217];
*(vp++) = U00*I0[218] - U10*I3[218] + loo2p*I2[218]
        + (twoo2z)*I1[218] - (twoo4zn)*I4[218];
*(vp++) = U00*I0[219] - U10*I3[219] + loo2p*I2[219]
        + (twoo2z)*I1[219] - (twoo4zn)*I4[219];
*(vp++) = U00*I0[220] - U10*I3[220] + loo2p*I2[220]
        + (twoo2z)*I1[220] - (twoo4zn)*I4[220];
*(vp++) = U00*I0[221] - U10*I3[221] + loo2p*I2[221]
        + (twoo2z)*I1[221] - (twoo4zn)*I4[221];
*(vp++) = U00*I0[222] - U10*I3[222] + loo2p*I2[222]
        + (twoo2z)*I1[222] - (twoo4zn)*I4[222];
*(vp++) = U00*I0[223] - U10*I3[223] + loo2p*I2[223]
        + (twoo2z)*I1[223] - (twoo4zn)*I4[223];
*(vp++) = U00*I0[224] - U10*I3[224] + loo2p*I2[224]
        + (twoo2z)*I1[224] - (twoo4zn)*I4[224];
*(vp++) = U00*I0[225] - U10*I3[225] + loo2p*I2[225]
        + (twoo2z)*I1[225] - (twoo4zn)*I4[225] - (eighto4zn)*I5[180];
*(vp++) = U00*I0[226] - U10*I3[226] + loo2p*I2[226]
        + (twoo2z)*I1[226] - (twoo4zn)*I4[226] - (seveno4zn)*I5[181];
*(vp++) = U00*I0[227] - U10*I3[227] + loo2p*I2[227]
        + (twoo2z)*I1[227] - (twoo4zn)*I4[227] - (seveno4zn)*I5[182];
*(vp++) = U00*I0[228] - U10*I3[228] + loo2p*I2[228]
        + (twoo2z)*I1[228] - (twoo4zn)*I4[228] - (sixo4zn)*I5[183];
*(vp++) = U00*I0[229] - U10*I3[229] + loo2p*I2[229]
        + (twoo2z)*I1[229] - (twoo4zn)*I4[229] - (sixo4zn)*I5[184];
*(vp++) = U00*I0[230] - U10*I3[230] + loo2p*I2[230]
        + (twoo2z)*I1[230] - (twoo4zn)*I4[230] - (sixo4zn)*I5[185];
*(vp++) = U00*I0[231] - U10*I3[231] + loo2p*I2[231]
        + (twoo2z)*I1[231] - (twoo4zn)*I4[231] - (fiveo4zn)*I5[186];
*(vp++) = U00*I0[232] - U10*I3[232] + loo2p*I2[232]
        + (twoo2z)*I1[232] - (twoo4zn)*I4[232] - (fiveo4zn)*I5[187];
*(vp++) = U00*I0[233] - U10*I3[233] + loo2p*I2[233]
        + (twoo2z)*I1[233] - (twoo4zn)*I4[233] - (fiveo4zn)*I5[188];
*(vp++) = U00*I0[234] - U10*I3[234] + loo2p*I2[234]
        + (twoo2z)*I1[234] - (twoo4zn)*I4[234] - (fiveo4zn)*I5[189];
*(vp++) = U00*I0[235] - U10*I3[235] + loo2p*I2[235]
        + (twoo2z)*I1[235] - (twoo4zn)*I4[235] - (fouro4zn)*I5[190];
*(vp++) = U00*I0[236] - U10*I3[236] + loo2p*I2[236]
        + (twoo2z)*I1[236] - (twoo4zn)*I4[236] - (fouro4zn)*I5[191];
return vp;
}

REALTYPE *_r_build_h0l0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE eighto4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  eighto4zn = 8.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[237] - U10*I3[237] + loo2p*I2[237]
        + (twoo2z)*I1[237] - (twoo4zn)*I4[237] - (fouro4zn)*I5[192];
*(vp++) = U00*I0[238] - U10*I3[238] + loo2p*I2[238]
        + (twoo2z)*I1[238] - (twoo4zn)*I4[238] - (fouro4zn)*I5[193];
*(vp++) = U00*I0[239] - U10*I3[239] + loo2p*I2[239]
        + (twoo2z)*I1[239] - (twoo4zn)*I4[239] - (fouro4zn)*I5[194];
*(vp++) = U00*I0[240] - U10*I3[240] + loo2p*I2[240]
        + (twoo2z)*I1[240] - (twoo4zn)*I4[240] - (threeo4zn)*I5[195];
*(vp++) = U00*I0[241] - U10*I3[241] + loo2p*I2[241]
        + (twoo2z)*I1[241] - (twoo4zn)*I4[241] - (threeo4zn)*I5[196];
*(vp++) = U00*I0[242] - U10*I3[242] + loo2p*I2[242]
        + (twoo2z)*I1[242] - (twoo4zn)*I4[242] - (threeo4zn)*I5[197];
*(vp++) = U00*I0[243] - U10*I3[243] + loo2p*I2[243]
        + (twoo2z)*I1[243] - (twoo4zn)*I4[243] - (threeo4zn)*I5[198];
*(vp++) = U00*I0[244] - U10*I3[244] + loo2p*I2[244]
        + (twoo2z)*I1[244] - (twoo4zn)*I4[244] - (threeo4zn)*I5[199];
*(vp++) = U00*I0[245] - U10*I3[245] + loo2p*I2[245]
        + (twoo2z)*I1[245] - (twoo4zn)*I4[245] - (threeo4zn)*I5[200];
*(vp++) = U00*I0[246] - U10*I3[246] + loo2p*I2[246]
        + (twoo2z)*I1[246] - (twoo4zn)*I4[246] - (twoo4zn)*I5[201];
*(vp++) = U00*I0[247] - U10*I3[247] + loo2p*I2[247]
        + (twoo2z)*I1[247] - (twoo4zn)*I4[247] - (twoo4zn)*I5[202];
*(vp++) = U00*I0[248] - U10*I3[248] + loo2p*I2[248]
        + (twoo2z)*I1[248] - (twoo4zn)*I4[248] - (twoo4zn)*I5[203];
*(vp++) = U00*I0[249] - U10*I3[249] + loo2p*I2[249]
        + (twoo2z)*I1[249] - (twoo4zn)*I4[249] - (twoo4zn)*I5[204];
*(vp++) = U00*I0[250] - U10*I3[250] + loo2p*I2[250]
        + (twoo2z)*I1[250] - (twoo4zn)*I4[250] - (twoo4zn)*I5[205];
*(vp++) = U00*I0[251] - U10*I3[251] + loo2p*I2[251]
        + (twoo2z)*I1[251] - (twoo4zn)*I4[251] - (twoo4zn)*I5[206];
*(vp++) = U00*I0[252] - U10*I3[252] + loo2p*I2[252]
        + (twoo2z)*I1[252] - (twoo4zn)*I4[252] - (twoo4zn)*I5[207];
*(vp++) = U00*I0[253] - U10*I3[253] + loo2p*I2[253]
        + (twoo2z)*I1[253] - (twoo4zn)*I4[253] - (oneo4zn)*I5[208];
*(vp++) = U00*I0[254] - U10*I3[254] + loo2p*I2[254]
        + (twoo2z)*I1[254] - (twoo4zn)*I4[254] - (oneo4zn)*I5[209];
*(vp++) = U00*I0[255] - U10*I3[255] + loo2p*I2[255]
        + (twoo2z)*I1[255] - (twoo4zn)*I4[255] - (oneo4zn)*I5[210];
*(vp++) = U00*I0[256] - U10*I3[256] + loo2p*I2[256]
        + (twoo2z)*I1[256] - (twoo4zn)*I4[256] - (oneo4zn)*I5[211];
*(vp++) = U00*I0[257] - U10*I3[257] + loo2p*I2[257]
        + (twoo2z)*I1[257] - (twoo4zn)*I4[257] - (oneo4zn)*I5[212];
*(vp++) = U00*I0[258] - U10*I3[258] + loo2p*I2[258]
        + (twoo2z)*I1[258] - (twoo4zn)*I4[258] - (oneo4zn)*I5[213];
*(vp++) = U00*I0[259] - U10*I3[259] + loo2p*I2[259]
        + (twoo2z)*I1[259] - (twoo4zn)*I4[259] - (oneo4zn)*I5[214];
*(vp++) = U00*I0[260] - U10*I3[260] + loo2p*I2[260]
        + (twoo2z)*I1[260] - (twoo4zn)*I4[260] - (oneo4zn)*I5[215];
*(vp++) = U00*I0[261] - U10*I3[261] + loo2p*I2[261]
        + (twoo2z)*I1[261] - (twoo4zn)*I4[261];
*(vp++) = U00*I0[262] - U10*I3[262] + loo2p*I2[262]
        + (twoo2z)*I1[262] - (twoo4zn)*I4[262];
*(vp++) = U00*I0[263] - U10*I3[263] + loo2p*I2[263]
        + (twoo2z)*I1[263] - (twoo4zn)*I4[263];
*(vp++) = U00*I0[264] - U10*I3[264] + loo2p*I2[264]
        + (twoo2z)*I1[264] - (twoo4zn)*I4[264];
*(vp++) = U00*I0[265] - U10*I3[265] + loo2p*I2[265]
        + (twoo2z)*I1[265] - (twoo4zn)*I4[265];
*(vp++) = U00*I0[266] - U10*I3[266] + loo2p*I2[266]
        + (twoo2z)*I1[266] - (twoo4zn)*I4[266];
*(vp++) = U00*I0[267] - U10*I3[267] + loo2p*I2[267]
        + (twoo2z)*I1[267] - (twoo4zn)*I4[267];
*(vp++) = U00*I0[268] - U10*I3[268] + loo2p*I2[268]
        + (twoo2z)*I1[268] - (twoo4zn)*I4[268];
*(vp++) = U00*I0[269] - U10*I3[269] + loo2p*I2[269]
        + (twoo2z)*I1[269] - (twoo4zn)*I4[269];
*(vp++) = U00*I0[270] - U10*I3[270] + loo2p*I2[270]
        + (oneo2z)*I1[270] - (oneo4zn)*I4[270] - (eighto4zn)*I5[216];
*(vp++) = U00*I0[271] - U10*I3[271] + loo2p*I2[271]
        + (oneo2z)*I1[271] - (oneo4zn)*I4[271] - (seveno4zn)*I5[217];
*(vp++) = U00*I0[272] - U10*I3[272] + loo2p*I2[272]
        + (oneo2z)*I1[272] - (oneo4zn)*I4[272] - (seveno4zn)*I5[218];
*(vp++) = U00*I0[273] - U10*I3[273] + loo2p*I2[273]
        + (oneo2z)*I1[273] - (oneo4zn)*I4[273] - (sixo4zn)*I5[219];
*(vp++) = U00*I0[274] - U10*I3[274] + loo2p*I2[274]
        + (oneo2z)*I1[274] - (oneo4zn)*I4[274] - (sixo4zn)*I5[220];
*(vp++) = U00*I0[275] - U10*I3[275] + loo2p*I2[275]
        + (oneo2z)*I1[275] - (oneo4zn)*I4[275] - (sixo4zn)*I5[221];
*(vp++) = U00*I0[276] - U10*I3[276] + loo2p*I2[276]
        + (oneo2z)*I1[276] - (oneo4zn)*I4[276] - (fiveo4zn)*I5[222];
*(vp++) = U00*I0[277] - U10*I3[277] + loo2p*I2[277]
        + (oneo2z)*I1[277] - (oneo4zn)*I4[277] - (fiveo4zn)*I5[223];
*(vp++) = U00*I0[278] - U10*I3[278] + loo2p*I2[278]
        + (oneo2z)*I1[278] - (oneo4zn)*I4[278] - (fiveo4zn)*I5[224];
*(vp++) = U00*I0[279] - U10*I3[279] + loo2p*I2[279]
        + (oneo2z)*I1[279] - (oneo4zn)*I4[279] - (fiveo4zn)*I5[225];
*(vp++) = U00*I0[280] - U10*I3[280] + loo2p*I2[280]
        + (oneo2z)*I1[280] - (oneo4zn)*I4[280] - (fouro4zn)*I5[226];
*(vp++) = U00*I0[281] - U10*I3[281] + loo2p*I2[281]
        + (oneo2z)*I1[281] - (oneo4zn)*I4[281] - (fouro4zn)*I5[227];
*(vp++) = U00*I0[282] - U10*I3[282] + loo2p*I2[282]
        + (oneo2z)*I1[282] - (oneo4zn)*I4[282] - (fouro4zn)*I5[228];
*(vp++) = U00*I0[283] - U10*I3[283] + loo2p*I2[283]
        + (oneo2z)*I1[283] - (oneo4zn)*I4[283] - (fouro4zn)*I5[229];
*(vp++) = U00*I0[284] - U10*I3[284] + loo2p*I2[284]
        + (oneo2z)*I1[284] - (oneo4zn)*I4[284] - (fouro4zn)*I5[230];
*(vp++) = U00*I0[285] - U10*I3[285] + loo2p*I2[285]
        + (oneo2z)*I1[285] - (oneo4zn)*I4[285] - (threeo4zn)*I5[231];
*(vp++) = U00*I0[286] - U10*I3[286] + loo2p*I2[286]
        + (oneo2z)*I1[286] - (oneo4zn)*I4[286] - (threeo4zn)*I5[232];
*(vp++) = U00*I0[287] - U10*I3[287] + loo2p*I2[287]
        + (oneo2z)*I1[287] - (oneo4zn)*I4[287] - (threeo4zn)*I5[233];
*(vp++) = U00*I0[288] - U10*I3[288] + loo2p*I2[288]
        + (oneo2z)*I1[288] - (oneo4zn)*I4[288] - (threeo4zn)*I5[234];
*(vp++) = U00*I0[289] - U10*I3[289] + loo2p*I2[289]
        + (oneo2z)*I1[289] - (oneo4zn)*I4[289] - (threeo4zn)*I5[235];
*(vp++) = U00*I0[290] - U10*I3[290] + loo2p*I2[290]
        + (oneo2z)*I1[290] - (oneo4zn)*I4[290] - (threeo4zn)*I5[236];
*(vp++) = U00*I0[291] - U10*I3[291] + loo2p*I2[291]
        + (oneo2z)*I1[291] - (oneo4zn)*I4[291] - (twoo4zn)*I5[237];
*(vp++) = U00*I0[292] - U10*I3[292] + loo2p*I2[292]
        + (oneo2z)*I1[292] - (oneo4zn)*I4[292] - (twoo4zn)*I5[238];
*(vp++) = U00*I0[293] - U10*I3[293] + loo2p*I2[293]
        + (oneo2z)*I1[293] - (oneo4zn)*I4[293] - (twoo4zn)*I5[239];
*(vp++) = U00*I0[294] - U10*I3[294] + loo2p*I2[294]
        + (oneo2z)*I1[294] - (oneo4zn)*I4[294] - (twoo4zn)*I5[240];
*(vp++) = U00*I0[295] - U10*I3[295] + loo2p*I2[295]
        + (oneo2z)*I1[295] - (oneo4zn)*I4[295] - (twoo4zn)*I5[241];
*(vp++) = U00*I0[296] - U10*I3[296] + loo2p*I2[296]
        + (oneo2z)*I1[296] - (oneo4zn)*I4[296] - (twoo4zn)*I5[242];
*(vp++) = U00*I0[297] - U10*I3[297] + loo2p*I2[297]
        + (oneo2z)*I1[297] - (oneo4zn)*I4[297] - (twoo4zn)*I5[243];
*(vp++) = U00*I0[298] - U10*I3[298] + loo2p*I2[298]
        + (oneo2z)*I1[298] - (oneo4zn)*I4[298] - (oneo4zn)*I5[244];
*(vp++) = U00*I0[299] - U10*I3[299] + loo2p*I2[299]
        + (oneo2z)*I1[299] - (oneo4zn)*I4[299] - (oneo4zn)*I5[245];
*(vp++) = U00*I0[300] - U10*I3[300] + loo2p*I2[300]
        + (oneo2z)*I1[300] - (oneo4zn)*I4[300] - (oneo4zn)*I5[246];
*(vp++) = U00*I0[301] - U10*I3[301] + loo2p*I2[301]
        + (oneo2z)*I1[301] - (oneo4zn)*I4[301] - (oneo4zn)*I5[247];
*(vp++) = U00*I0[302] - U10*I3[302] + loo2p*I2[302]
        + (oneo2z)*I1[302] - (oneo4zn)*I4[302] - (oneo4zn)*I5[248];
*(vp++) = U00*I0[303] - U10*I3[303] + loo2p*I2[303]
        + (oneo2z)*I1[303] - (oneo4zn)*I4[303] - (oneo4zn)*I5[249];
*(vp++) = U00*I0[304] - U10*I3[304] + loo2p*I2[304]
        + (oneo2z)*I1[304] - (oneo4zn)*I4[304] - (oneo4zn)*I5[250];
*(vp++) = U00*I0[305] - U10*I3[305] + loo2p*I2[305]
        + (oneo2z)*I1[305] - (oneo4zn)*I4[305] - (oneo4zn)*I5[251];
*(vp++) = U00*I0[306] - U10*I3[306] + loo2p*I2[306]
        + (oneo2z)*I1[306] - (oneo4zn)*I4[306];
*(vp++) = U00*I0[307] - U10*I3[307] + loo2p*I2[307]
        + (oneo2z)*I1[307] - (oneo4zn)*I4[307];
*(vp++) = U00*I0[308] - U10*I3[308] + loo2p*I2[308]
        + (oneo2z)*I1[308] - (oneo4zn)*I4[308];
*(vp++) = U00*I0[309] - U10*I3[309] + loo2p*I2[309]
        + (oneo2z)*I1[309] - (oneo4zn)*I4[309];
*(vp++) = U00*I0[310] - U10*I3[310] + loo2p*I2[310]
        + (oneo2z)*I1[310] - (oneo4zn)*I4[310];
*(vp++) = U00*I0[311] - U10*I3[311] + loo2p*I2[311]
        + (oneo2z)*I1[311] - (oneo4zn)*I4[311];
*(vp++) = U00*I0[312] - U10*I3[312] + loo2p*I2[312]
        + (oneo2z)*I1[312] - (oneo4zn)*I4[312];
*(vp++) = U00*I0[313] - U10*I3[313] + loo2p*I2[313]
        + (oneo2z)*I1[313] - (oneo4zn)*I4[313];
*(vp++) = U00*I0[314] - U10*I3[314] + loo2p*I2[314]
        + (oneo2z)*I1[314] - (oneo4zn)*I4[314];
*(vp++) = U00*I0[315] - U10*I3[315] + loo2p*I2[315]
        + (oneo2z)*I1[315] - (oneo4zn)*I4[315] - (eighto4zn)*I5[252];
*(vp++) = U00*I0[316] - U10*I3[316] + loo2p*I2[316]
        + (oneo2z)*I1[316] - (oneo4zn)*I4[316] - (seveno4zn)*I5[253];
*(vp++) = U00*I0[317] - U10*I3[317] + loo2p*I2[317]
        + (oneo2z)*I1[317] - (oneo4zn)*I4[317] - (seveno4zn)*I5[254];
*(vp++) = U00*I0[318] - U10*I3[318] + loo2p*I2[318]
        + (oneo2z)*I1[318] - (oneo4zn)*I4[318] - (sixo4zn)*I5[255];
*(vp++) = U00*I0[319] - U10*I3[319] + loo2p*I2[319]
        + (oneo2z)*I1[319] - (oneo4zn)*I4[319] - (sixo4zn)*I5[256];
*(vp++) = U00*I0[320] - U10*I3[320] + loo2p*I2[320]
        + (oneo2z)*I1[320] - (oneo4zn)*I4[320] - (sixo4zn)*I5[257];
*(vp++) = U00*I0[321] - U10*I3[321] + loo2p*I2[321]
        + (oneo2z)*I1[321] - (oneo4zn)*I4[321] - (fiveo4zn)*I5[258];
*(vp++) = U00*I0[322] - U10*I3[322] + loo2p*I2[322]
        + (oneo2z)*I1[322] - (oneo4zn)*I4[322] - (fiveo4zn)*I5[259];
*(vp++) = U00*I0[323] - U10*I3[323] + loo2p*I2[323]
        + (oneo2z)*I1[323] - (oneo4zn)*I4[323] - (fiveo4zn)*I5[260];
*(vp++) = U00*I0[324] - U10*I3[324] + loo2p*I2[324]
        + (oneo2z)*I1[324] - (oneo4zn)*I4[324] - (fiveo4zn)*I5[261];
*(vp++) = U00*I0[325] - U10*I3[325] + loo2p*I2[325]
        + (oneo2z)*I1[325] - (oneo4zn)*I4[325] - (fouro4zn)*I5[262];
*(vp++) = U00*I0[326] - U10*I3[326] + loo2p*I2[326]
        + (oneo2z)*I1[326] - (oneo4zn)*I4[326] - (fouro4zn)*I5[263];
*(vp++) = U00*I0[327] - U10*I3[327] + loo2p*I2[327]
        + (oneo2z)*I1[327] - (oneo4zn)*I4[327] - (fouro4zn)*I5[264];
*(vp++) = U00*I0[328] - U10*I3[328] + loo2p*I2[328]
        + (oneo2z)*I1[328] - (oneo4zn)*I4[328] - (fouro4zn)*I5[265];
*(vp++) = U00*I0[329] - U10*I3[329] + loo2p*I2[329]
        + (oneo2z)*I1[329] - (oneo4zn)*I4[329] - (fouro4zn)*I5[266];
*(vp++) = U00*I0[330] - U10*I3[330] + loo2p*I2[330]
        + (oneo2z)*I1[330] - (oneo4zn)*I4[330] - (threeo4zn)*I5[267];
*(vp++) = U00*I0[331] - U10*I3[331] + loo2p*I2[331]
        + (oneo2z)*I1[331] - (oneo4zn)*I4[331] - (threeo4zn)*I5[268];
*(vp++) = U00*I0[332] - U10*I3[332] + loo2p*I2[332]
        + (oneo2z)*I1[332] - (oneo4zn)*I4[332] - (threeo4zn)*I5[269];
*(vp++) = U00*I0[333] - U10*I3[333] + loo2p*I2[333]
        + (oneo2z)*I1[333] - (oneo4zn)*I4[333] - (threeo4zn)*I5[270];
*(vp++) = U00*I0[334] - U10*I3[334] + loo2p*I2[334]
        + (oneo2z)*I1[334] - (oneo4zn)*I4[334] - (threeo4zn)*I5[271];
*(vp++) = U00*I0[335] - U10*I3[335] + loo2p*I2[335]
        + (oneo2z)*I1[335] - (oneo4zn)*I4[335] - (threeo4zn)*I5[272];
*(vp++) = U00*I0[336] - U10*I3[336] + loo2p*I2[336]
        + (oneo2z)*I1[336] - (oneo4zn)*I4[336] - (twoo4zn)*I5[273];
*(vp++) = U00*I0[337] - U10*I3[337] + loo2p*I2[337]
        + (oneo2z)*I1[337] - (oneo4zn)*I4[337] - (twoo4zn)*I5[274];
*(vp++) = U00*I0[338] - U10*I3[338] + loo2p*I2[338]
        + (oneo2z)*I1[338] - (oneo4zn)*I4[338] - (twoo4zn)*I5[275];
*(vp++) = U00*I0[339] - U10*I3[339] + loo2p*I2[339]
        + (oneo2z)*I1[339] - (oneo4zn)*I4[339] - (twoo4zn)*I5[276];
*(vp++) = U00*I0[340] - U10*I3[340] + loo2p*I2[340]
        + (oneo2z)*I1[340] - (oneo4zn)*I4[340] - (twoo4zn)*I5[277];
*(vp++) = U00*I0[341] - U10*I3[341] + loo2p*I2[341]
        + (oneo2z)*I1[341] - (oneo4zn)*I4[341] - (twoo4zn)*I5[278];
*(vp++) = U00*I0[342] - U10*I3[342] + loo2p*I2[342]
        + (oneo2z)*I1[342] - (oneo4zn)*I4[342] - (twoo4zn)*I5[279];
*(vp++) = U00*I0[343] - U10*I3[343] + loo2p*I2[343]
        + (oneo2z)*I1[343] - (oneo4zn)*I4[343] - (oneo4zn)*I5[280];
*(vp++) = U00*I0[344] - U10*I3[344] + loo2p*I2[344]
        + (oneo2z)*I1[344] - (oneo4zn)*I4[344] - (oneo4zn)*I5[281];
*(vp++) = U00*I0[345] - U10*I3[345] + loo2p*I2[345]
        + (oneo2z)*I1[345] - (oneo4zn)*I4[345] - (oneo4zn)*I5[282];
*(vp++) = U00*I0[346] - U10*I3[346] + loo2p*I2[346]
        + (oneo2z)*I1[346] - (oneo4zn)*I4[346] - (oneo4zn)*I5[283];
*(vp++) = U00*I0[347] - U10*I3[347] + loo2p*I2[347]
        + (oneo2z)*I1[347] - (oneo4zn)*I4[347] - (oneo4zn)*I5[284];
*(vp++) = U00*I0[348] - U10*I3[348] + loo2p*I2[348]
        + (oneo2z)*I1[348] - (oneo4zn)*I4[348] - (oneo4zn)*I5[285];
*(vp++) = U00*I0[349] - U10*I3[349] + loo2p*I2[349]
        + (oneo2z)*I1[349] - (oneo4zn)*I4[349] - (oneo4zn)*I5[286];
*(vp++) = U00*I0[350] - U10*I3[350] + loo2p*I2[350]
        + (oneo2z)*I1[350] - (oneo4zn)*I4[350] - (oneo4zn)*I5[287];
*(vp++) = U00*I0[351] - U10*I3[351] + loo2p*I2[351]
        + (oneo2z)*I1[351] - (oneo4zn)*I4[351];
*(vp++) = U00*I0[352] - U10*I3[352] + loo2p*I2[352]
        + (oneo2z)*I1[352] - (oneo4zn)*I4[352];
*(vp++) = U00*I0[353] - U10*I3[353] + loo2p*I2[353]
        + (oneo2z)*I1[353] - (oneo4zn)*I4[353];
*(vp++) = U00*I0[354] - U10*I3[354] + loo2p*I2[354]
        + (oneo2z)*I1[354] - (oneo4zn)*I4[354];
*(vp++) = U00*I0[355] - U10*I3[355] + loo2p*I2[355]
        + (oneo2z)*I1[355] - (oneo4zn)*I4[355];
*(vp++) = U00*I0[356] - U10*I3[356] + loo2p*I2[356]
        + (oneo2z)*I1[356] - (oneo4zn)*I4[356];
*(vp++) = U00*I0[357] - U10*I3[357] + loo2p*I2[357]
        + (oneo2z)*I1[357] - (oneo4zn)*I4[357];
*(vp++) = U00*I0[358] - U10*I3[358] + loo2p*I2[358]
        + (oneo2z)*I1[358] - (oneo4zn)*I4[358];
*(vp++) = U00*I0[359] - U10*I3[359] + loo2p*I2[359]
        + (oneo2z)*I1[359] - (oneo4zn)*I4[359];
*(vp++) = U00*I0[360] - U10*I3[360] + loo2p*I2[360]
        + (oneo2z)*I1[360] - (oneo4zn)*I4[360] - (eighto4zn)*I5[288];
*(vp++) = U00*I0[361] - U10*I3[361] + loo2p*I2[361]
        + (oneo2z)*I1[361] - (oneo4zn)*I4[361] - (seveno4zn)*I5[289];
*(vp++) = U00*I0[362] - U10*I3[362] + loo2p*I2[362]
        + (oneo2z)*I1[362] - (oneo4zn)*I4[362] - (seveno4zn)*I5[290];
*(vp++) = U00*I0[363] - U10*I3[363] + loo2p*I2[363]
        + (oneo2z)*I1[363] - (oneo4zn)*I4[363] - (sixo4zn)*I5[291];
*(vp++) = U00*I0[364] - U10*I3[364] + loo2p*I2[364]
        + (oneo2z)*I1[364] - (oneo4zn)*I4[364] - (sixo4zn)*I5[292];
*(vp++) = U00*I0[365] - U10*I3[365] + loo2p*I2[365]
        + (oneo2z)*I1[365] - (oneo4zn)*I4[365] - (sixo4zn)*I5[293];
*(vp++) = U00*I0[366] - U10*I3[366] + loo2p*I2[366]
        + (oneo2z)*I1[366] - (oneo4zn)*I4[366] - (fiveo4zn)*I5[294];
*(vp++) = U00*I0[367] - U10*I3[367] + loo2p*I2[367]
        + (oneo2z)*I1[367] - (oneo4zn)*I4[367] - (fiveo4zn)*I5[295];
*(vp++) = U00*I0[368] - U10*I3[368] + loo2p*I2[368]
        + (oneo2z)*I1[368] - (oneo4zn)*I4[368] - (fiveo4zn)*I5[296];
*(vp++) = U00*I0[369] - U10*I3[369] + loo2p*I2[369]
        + (oneo2z)*I1[369] - (oneo4zn)*I4[369] - (fiveo4zn)*I5[297];
*(vp++) = U00*I0[370] - U10*I3[370] + loo2p*I2[370]
        + (oneo2z)*I1[370] - (oneo4zn)*I4[370] - (fouro4zn)*I5[298];
*(vp++) = U00*I0[371] - U10*I3[371] + loo2p*I2[371]
        + (oneo2z)*I1[371] - (oneo4zn)*I4[371] - (fouro4zn)*I5[299];
*(vp++) = U00*I0[372] - U10*I3[372] + loo2p*I2[372]
        + (oneo2z)*I1[372] - (oneo4zn)*I4[372] - (fouro4zn)*I5[300];
*(vp++) = U00*I0[373] - U10*I3[373] + loo2p*I2[373]
        + (oneo2z)*I1[373] - (oneo4zn)*I4[373] - (fouro4zn)*I5[301];
*(vp++) = U00*I0[374] - U10*I3[374] + loo2p*I2[374]
        + (oneo2z)*I1[374] - (oneo4zn)*I4[374] - (fouro4zn)*I5[302];
*(vp++) = U00*I0[375] - U10*I3[375] + loo2p*I2[375]
        + (oneo2z)*I1[375] - (oneo4zn)*I4[375] - (threeo4zn)*I5[303];
*(vp++) = U00*I0[376] - U10*I3[376] + loo2p*I2[376]
        + (oneo2z)*I1[376] - (oneo4zn)*I4[376] - (threeo4zn)*I5[304];
*(vp++) = U00*I0[377] - U10*I3[377] + loo2p*I2[377]
        + (oneo2z)*I1[377] - (oneo4zn)*I4[377] - (threeo4zn)*I5[305];
*(vp++) = U00*I0[378] - U10*I3[378] + loo2p*I2[378]
        + (oneo2z)*I1[378] - (oneo4zn)*I4[378] - (threeo4zn)*I5[306];
*(vp++) = U00*I0[379] - U10*I3[379] + loo2p*I2[379]
        + (oneo2z)*I1[379] - (oneo4zn)*I4[379] - (threeo4zn)*I5[307];
*(vp++) = U00*I0[380] - U10*I3[380] + loo2p*I2[380]
        + (oneo2z)*I1[380] - (oneo4zn)*I4[380] - (threeo4zn)*I5[308];
*(vp++) = U00*I0[381] - U10*I3[381] + loo2p*I2[381]
        + (oneo2z)*I1[381] - (oneo4zn)*I4[381] - (twoo4zn)*I5[309];
*(vp++) = U00*I0[382] - U10*I3[382] + loo2p*I2[382]
        + (oneo2z)*I1[382] - (oneo4zn)*I4[382] - (twoo4zn)*I5[310];
*(vp++) = U00*I0[383] - U10*I3[383] + loo2p*I2[383]
        + (oneo2z)*I1[383] - (oneo4zn)*I4[383] - (twoo4zn)*I5[311];
*(vp++) = U00*I0[384] - U10*I3[384] + loo2p*I2[384]
        + (oneo2z)*I1[384] - (oneo4zn)*I4[384] - (twoo4zn)*I5[312];
*(vp++) = U00*I0[385] - U10*I3[385] + loo2p*I2[385]
        + (oneo2z)*I1[385] - (oneo4zn)*I4[385] - (twoo4zn)*I5[313];
*(vp++) = U00*I0[386] - U10*I3[386] + loo2p*I2[386]
        + (oneo2z)*I1[386] - (oneo4zn)*I4[386] - (twoo4zn)*I5[314];
*(vp++) = U00*I0[387] - U10*I3[387] + loo2p*I2[387]
        + (oneo2z)*I1[387] - (oneo4zn)*I4[387] - (twoo4zn)*I5[315];
*(vp++) = U00*I0[388] - U10*I3[388] + loo2p*I2[388]
        + (oneo2z)*I1[388] - (oneo4zn)*I4[388] - (oneo4zn)*I5[316];
*(vp++) = U00*I0[389] - U10*I3[389] + loo2p*I2[389]
        + (oneo2z)*I1[389] - (oneo4zn)*I4[389] - (oneo4zn)*I5[317];
*(vp++) = U00*I0[390] - U10*I3[390] + loo2p*I2[390]
        + (oneo2z)*I1[390] - (oneo4zn)*I4[390] - (oneo4zn)*I5[318];
*(vp++) = U00*I0[391] - U10*I3[391] + loo2p*I2[391]
        + (oneo2z)*I1[391] - (oneo4zn)*I4[391] - (oneo4zn)*I5[319];
*(vp++) = U00*I0[392] - U10*I3[392] + loo2p*I2[392]
        + (oneo2z)*I1[392] - (oneo4zn)*I4[392] - (oneo4zn)*I5[320];
*(vp++) = U00*I0[393] - U10*I3[393] + loo2p*I2[393]
        + (oneo2z)*I1[393] - (oneo4zn)*I4[393] - (oneo4zn)*I5[321];
*(vp++) = U00*I0[394] - U10*I3[394] + loo2p*I2[394]
        + (oneo2z)*I1[394] - (oneo4zn)*I4[394] - (oneo4zn)*I5[322];
*(vp++) = U00*I0[395] - U10*I3[395] + loo2p*I2[395]
        + (oneo2z)*I1[395] - (oneo4zn)*I4[395] - (oneo4zn)*I5[323];
*(vp++) = U00*I0[396] - U10*I3[396] + loo2p*I2[396]
        + (oneo2z)*I1[396] - (oneo4zn)*I4[396];
*(vp++) = U00*I0[397] - U10*I3[397] + loo2p*I2[397]
        + (oneo2z)*I1[397] - (oneo4zn)*I4[397];
*(vp++) = U00*I0[398] - U10*I3[398] + loo2p*I2[398]
        + (oneo2z)*I1[398] - (oneo4zn)*I4[398];
*(vp++) = U00*I0[399] - U10*I3[399] + loo2p*I2[399]
        + (oneo2z)*I1[399] - (oneo4zn)*I4[399];
*(vp++) = U00*I0[400] - U10*I3[400] + loo2p*I2[400]
        + (oneo2z)*I1[400] - (oneo4zn)*I4[400];
*(vp++) = U00*I0[401] - U10*I3[401] + loo2p*I2[401]
        + (oneo2z)*I1[401] - (oneo4zn)*I4[401];
*(vp++) = U00*I0[402] - U10*I3[402] + loo2p*I2[402]
        + (oneo2z)*I1[402] - (oneo4zn)*I4[402];
*(vp++) = U00*I0[403] - U10*I3[403] + loo2p*I2[403]
        + (oneo2z)*I1[403] - (oneo4zn)*I4[403];
*(vp++) = U00*I0[404] - U10*I3[404] + loo2p*I2[404]
        + (oneo2z)*I1[404] - (oneo4zn)*I4[404];
*(vp++) = U00*I0[405] - U10*I3[405] + loo2p*I2[405]
        + (oneo2z)*I1[405] - (oneo4zn)*I4[405] - (eighto4zn)*I5[324];
*(vp++) = U00*I0[406] - U10*I3[406] + loo2p*I2[406]
        + (oneo2z)*I1[406] - (oneo4zn)*I4[406] - (seveno4zn)*I5[325];
*(vp++) = U00*I0[407] - U10*I3[407] + loo2p*I2[407]
        + (oneo2z)*I1[407] - (oneo4zn)*I4[407] - (seveno4zn)*I5[326];
*(vp++) = U00*I0[408] - U10*I3[408] + loo2p*I2[408]
        + (oneo2z)*I1[408] - (oneo4zn)*I4[408] - (sixo4zn)*I5[327];
*(vp++) = U00*I0[409] - U10*I3[409] + loo2p*I2[409]
        + (oneo2z)*I1[409] - (oneo4zn)*I4[409] - (sixo4zn)*I5[328];
*(vp++) = U00*I0[410] - U10*I3[410] + loo2p*I2[410]
        + (oneo2z)*I1[410] - (oneo4zn)*I4[410] - (sixo4zn)*I5[329];
*(vp++) = U00*I0[411] - U10*I3[411] + loo2p*I2[411]
        + (oneo2z)*I1[411] - (oneo4zn)*I4[411] - (fiveo4zn)*I5[330];
*(vp++) = U00*I0[412] - U10*I3[412] + loo2p*I2[412]
        + (oneo2z)*I1[412] - (oneo4zn)*I4[412] - (fiveo4zn)*I5[331];
*(vp++) = U00*I0[413] - U10*I3[413] + loo2p*I2[413]
        + (oneo2z)*I1[413] - (oneo4zn)*I4[413] - (fiveo4zn)*I5[332];
*(vp++) = U00*I0[414] - U10*I3[414] + loo2p*I2[414]
        + (oneo2z)*I1[414] - (oneo4zn)*I4[414] - (fiveo4zn)*I5[333];
*(vp++) = U00*I0[415] - U10*I3[415] + loo2p*I2[415]
        + (oneo2z)*I1[415] - (oneo4zn)*I4[415] - (fouro4zn)*I5[334];
*(vp++) = U00*I0[416] - U10*I3[416] + loo2p*I2[416]
        + (oneo2z)*I1[416] - (oneo4zn)*I4[416] - (fouro4zn)*I5[335];
*(vp++) = U00*I0[417] - U10*I3[417] + loo2p*I2[417]
        + (oneo2z)*I1[417] - (oneo4zn)*I4[417] - (fouro4zn)*I5[336];
*(vp++) = U00*I0[418] - U10*I3[418] + loo2p*I2[418]
        + (oneo2z)*I1[418] - (oneo4zn)*I4[418] - (fouro4zn)*I5[337];
*(vp++) = U00*I0[419] - U10*I3[419] + loo2p*I2[419]
        + (oneo2z)*I1[419] - (oneo4zn)*I4[419] - (fouro4zn)*I5[338];
*(vp++) = U00*I0[420] - U10*I3[420] + loo2p*I2[420]
        + (oneo2z)*I1[420] - (oneo4zn)*I4[420] - (threeo4zn)*I5[339];
*(vp++) = U00*I0[421] - U10*I3[421] + loo2p*I2[421]
        + (oneo2z)*I1[421] - (oneo4zn)*I4[421] - (threeo4zn)*I5[340];
*(vp++) = U00*I0[422] - U10*I3[422] + loo2p*I2[422]
        + (oneo2z)*I1[422] - (oneo4zn)*I4[422] - (threeo4zn)*I5[341];
*(vp++) = U00*I0[423] - U10*I3[423] + loo2p*I2[423]
        + (oneo2z)*I1[423] - (oneo4zn)*I4[423] - (threeo4zn)*I5[342];
*(vp++) = U00*I0[424] - U10*I3[424] + loo2p*I2[424]
        + (oneo2z)*I1[424] - (oneo4zn)*I4[424] - (threeo4zn)*I5[343];
*(vp++) = U00*I0[425] - U10*I3[425] + loo2p*I2[425]
        + (oneo2z)*I1[425] - (oneo4zn)*I4[425] - (threeo4zn)*I5[344];
*(vp++) = U00*I0[426] - U10*I3[426] + loo2p*I2[426]
        + (oneo2z)*I1[426] - (oneo4zn)*I4[426] - (twoo4zn)*I5[345];
*(vp++) = U00*I0[427] - U10*I3[427] + loo2p*I2[427]
        + (oneo2z)*I1[427] - (oneo4zn)*I4[427] - (twoo4zn)*I5[346];
*(vp++) = U00*I0[428] - U10*I3[428] + loo2p*I2[428]
        + (oneo2z)*I1[428] - (oneo4zn)*I4[428] - (twoo4zn)*I5[347];
*(vp++) = U00*I0[429] - U10*I3[429] + loo2p*I2[429]
        + (oneo2z)*I1[429] - (oneo4zn)*I4[429] - (twoo4zn)*I5[348];
*(vp++) = U00*I0[430] - U10*I3[430] + loo2p*I2[430]
        + (oneo2z)*I1[430] - (oneo4zn)*I4[430] - (twoo4zn)*I5[349];
*(vp++) = U00*I0[431] - U10*I3[431] + loo2p*I2[431]
        + (oneo2z)*I1[431] - (oneo4zn)*I4[431] - (twoo4zn)*I5[350];
*(vp++) = U00*I0[432] - U10*I3[432] + loo2p*I2[432]
        + (oneo2z)*I1[432] - (oneo4zn)*I4[432] - (twoo4zn)*I5[351];
*(vp++) = U00*I0[433] - U10*I3[433] + loo2p*I2[433]
        + (oneo2z)*I1[433] - (oneo4zn)*I4[433] - (oneo4zn)*I5[352];
*(vp++) = U00*I0[434] - U10*I3[434] + loo2p*I2[434]
        + (oneo2z)*I1[434] - (oneo4zn)*I4[434] - (oneo4zn)*I5[353];
*(vp++) = U00*I0[435] - U10*I3[435] + loo2p*I2[435]
        + (oneo2z)*I1[435] - (oneo4zn)*I4[435] - (oneo4zn)*I5[354];
*(vp++) = U00*I0[436] - U10*I3[436] + loo2p*I2[436]
        + (oneo2z)*I1[436] - (oneo4zn)*I4[436] - (oneo4zn)*I5[355];
*(vp++) = U00*I0[437] - U10*I3[437] + loo2p*I2[437]
        + (oneo2z)*I1[437] - (oneo4zn)*I4[437] - (oneo4zn)*I5[356];
*(vp++) = U00*I0[438] - U10*I3[438] + loo2p*I2[438]
        + (oneo2z)*I1[438] - (oneo4zn)*I4[438] - (oneo4zn)*I5[357];
*(vp++) = U00*I0[439] - U10*I3[439] + loo2p*I2[439]
        + (oneo2z)*I1[439] - (oneo4zn)*I4[439] - (oneo4zn)*I5[358];
*(vp++) = U00*I0[440] - U10*I3[440] + loo2p*I2[440]
        + (oneo2z)*I1[440] - (oneo4zn)*I4[440] - (oneo4zn)*I5[359];
*(vp++) = U00*I0[441] - U10*I3[441] + loo2p*I2[441]
        + (oneo2z)*I1[441] - (oneo4zn)*I4[441];
*(vp++) = U00*I0[442] - U10*I3[442] + loo2p*I2[442]
        + (oneo2z)*I1[442] - (oneo4zn)*I4[442];
*(vp++) = U00*I0[443] - U10*I3[443] + loo2p*I2[443]
        + (oneo2z)*I1[443] - (oneo4zn)*I4[443];
*(vp++) = U00*I0[444] - U10*I3[444] + loo2p*I2[444]
        + (oneo2z)*I1[444] - (oneo4zn)*I4[444];
*(vp++) = U00*I0[445] - U10*I3[445] + loo2p*I2[445]
        + (oneo2z)*I1[445] - (oneo4zn)*I4[445];
*(vp++) = U00*I0[446] - U10*I3[446] + loo2p*I2[446]
        + (oneo2z)*I1[446] - (oneo4zn)*I4[446];
*(vp++) = U00*I0[447] - U10*I3[447] + loo2p*I2[447]
        + (oneo2z)*I1[447] - (oneo4zn)*I4[447];
*(vp++) = U00*I0[448] - U10*I3[448] + loo2p*I2[448]
        + (oneo2z)*I1[448] - (oneo4zn)*I4[448];
*(vp++) = U00*I0[449] - U10*I3[449] + loo2p*I2[449]
        + (oneo2z)*I1[449] - (oneo4zn)*I4[449];
*(vp++) = U00*I0[450] - U10*I3[450] + loo2p*I2[450] - (eighto4zn)*I5[360];
*(vp++) = U00*I0[451] - U10*I3[451] + loo2p*I2[451] - (seveno4zn)*I5[361];
*(vp++) = U00*I0[452] - U10*I3[452] + loo2p*I2[452] - (seveno4zn)*I5[362];
*(vp++) = U00*I0[453] - U10*I3[453] + loo2p*I2[453] - (sixo4zn)*I5[363];
*(vp++) = U00*I0[454] - U10*I3[454] + loo2p*I2[454] - (sixo4zn)*I5[364];
*(vp++) = U00*I0[455] - U10*I3[455] + loo2p*I2[455] - (sixo4zn)*I5[365];
*(vp++) = U00*I0[456] - U10*I3[456] + loo2p*I2[456] - (fiveo4zn)*I5[366];
*(vp++) = U00*I0[457] - U10*I3[457] + loo2p*I2[457] - (fiveo4zn)*I5[367];
*(vp++) = U00*I0[458] - U10*I3[458] + loo2p*I2[458] - (fiveo4zn)*I5[368];
*(vp++) = U00*I0[459] - U10*I3[459] + loo2p*I2[459] - (fiveo4zn)*I5[369];
*(vp++) = U00*I0[460] - U10*I3[460] + loo2p*I2[460] - (fouro4zn)*I5[370];
*(vp++) = U00*I0[461] - U10*I3[461] + loo2p*I2[461] - (fouro4zn)*I5[371];
*(vp++) = U00*I0[462] - U10*I3[462] + loo2p*I2[462] - (fouro4zn)*I5[372];
*(vp++) = U00*I0[463] - U10*I3[463] + loo2p*I2[463] - (fouro4zn)*I5[373];
*(vp++) = U00*I0[464] - U10*I3[464] + loo2p*I2[464] - (fouro4zn)*I5[374];
*(vp++) = U00*I0[465] - U10*I3[465] + loo2p*I2[465] - (threeo4zn)*I5[375];
*(vp++) = U00*I0[466] - U10*I3[466] + loo2p*I2[466] - (threeo4zn)*I5[376];
*(vp++) = U00*I0[467] - U10*I3[467] + loo2p*I2[467] - (threeo4zn)*I5[377];
*(vp++) = U00*I0[468] - U10*I3[468] + loo2p*I2[468] - (threeo4zn)*I5[378];
*(vp++) = U00*I0[469] - U10*I3[469] + loo2p*I2[469] - (threeo4zn)*I5[379];
*(vp++) = U00*I0[470] - U10*I3[470] + loo2p*I2[470] - (threeo4zn)*I5[380];
*(vp++) = U00*I0[471] - U10*I3[471] + loo2p*I2[471] - (twoo4zn)*I5[381];
*(vp++) = U00*I0[472] - U10*I3[472] + loo2p*I2[472] - (twoo4zn)*I5[382];
*(vp++) = U00*I0[473] - U10*I3[473] + loo2p*I2[473] - (twoo4zn)*I5[383];
return vp;
}

REALTYPE *_r_build_h0l0_2(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE eighto4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  eighto4zn = 8.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[474] - U10*I3[474] + loo2p*I2[474] - (twoo4zn)*I5[384];
*(vp++) = U00*I0[475] - U10*I3[475] + loo2p*I2[475] - (twoo4zn)*I5[385];
*(vp++) = U00*I0[476] - U10*I3[476] + loo2p*I2[476] - (twoo4zn)*I5[386];
*(vp++) = U00*I0[477] - U10*I3[477] + loo2p*I2[477] - (twoo4zn)*I5[387];
*(vp++) = U00*I0[478] - U10*I3[478] + loo2p*I2[478] - (oneo4zn)*I5[388];
*(vp++) = U00*I0[479] - U10*I3[479] + loo2p*I2[479] - (oneo4zn)*I5[389];
*(vp++) = U00*I0[480] - U10*I3[480] + loo2p*I2[480] - (oneo4zn)*I5[390];
*(vp++) = U00*I0[481] - U10*I3[481] + loo2p*I2[481] - (oneo4zn)*I5[391];
*(vp++) = U00*I0[482] - U10*I3[482] + loo2p*I2[482] - (oneo4zn)*I5[392];
*(vp++) = U00*I0[483] - U10*I3[483] + loo2p*I2[483] - (oneo4zn)*I5[393];
*(vp++) = U00*I0[484] - U10*I3[484] + loo2p*I2[484] - (oneo4zn)*I5[394];
*(vp++) = U00*I0[485] - U10*I3[485] + loo2p*I2[485] - (oneo4zn)*I5[395];
*(vp++) = U00*I0[486] - U10*I3[486] + loo2p*I2[486];
*(vp++) = U00*I0[487] - U10*I3[487] + loo2p*I2[487];
*(vp++) = U00*I0[488] - U10*I3[488] + loo2p*I2[488];
*(vp++) = U00*I0[489] - U10*I3[489] + loo2p*I2[489];
*(vp++) = U00*I0[490] - U10*I3[490] + loo2p*I2[490];
*(vp++) = U00*I0[491] - U10*I3[491] + loo2p*I2[491];
*(vp++) = U00*I0[492] - U10*I3[492] + loo2p*I2[492];
*(vp++) = U00*I0[493] - U10*I3[493] + loo2p*I2[493];
*(vp++) = U00*I0[494] - U10*I3[494] + loo2p*I2[494];
*(vp++) = U00*I0[495] - U10*I3[495] + loo2p*I2[495] - (eighto4zn)*I5[396];
*(vp++) = U00*I0[496] - U10*I3[496] + loo2p*I2[496] - (seveno4zn)*I5[397];
*(vp++) = U00*I0[497] - U10*I3[497] + loo2p*I2[497] - (seveno4zn)*I5[398];
*(vp++) = U00*I0[498] - U10*I3[498] + loo2p*I2[498] - (sixo4zn)*I5[399];
*(vp++) = U00*I0[499] - U10*I3[499] + loo2p*I2[499] - (sixo4zn)*I5[400];
*(vp++) = U00*I0[500] - U10*I3[500] + loo2p*I2[500] - (sixo4zn)*I5[401];
*(vp++) = U00*I0[501] - U10*I3[501] + loo2p*I2[501] - (fiveo4zn)*I5[402];
*(vp++) = U00*I0[502] - U10*I3[502] + loo2p*I2[502] - (fiveo4zn)*I5[403];
*(vp++) = U00*I0[503] - U10*I3[503] + loo2p*I2[503] - (fiveo4zn)*I5[404];
*(vp++) = U00*I0[504] - U10*I3[504] + loo2p*I2[504] - (fiveo4zn)*I5[405];
*(vp++) = U00*I0[505] - U10*I3[505] + loo2p*I2[505] - (fouro4zn)*I5[406];
*(vp++) = U00*I0[506] - U10*I3[506] + loo2p*I2[506] - (fouro4zn)*I5[407];
*(vp++) = U00*I0[507] - U10*I3[507] + loo2p*I2[507] - (fouro4zn)*I5[408];
*(vp++) = U00*I0[508] - U10*I3[508] + loo2p*I2[508] - (fouro4zn)*I5[409];
*(vp++) = U00*I0[509] - U10*I3[509] + loo2p*I2[509] - (fouro4zn)*I5[410];
*(vp++) = U00*I0[510] - U10*I3[510] + loo2p*I2[510] - (threeo4zn)*I5[411];
*(vp++) = U00*I0[511] - U10*I3[511] + loo2p*I2[511] - (threeo4zn)*I5[412];
*(vp++) = U00*I0[512] - U10*I3[512] + loo2p*I2[512] - (threeo4zn)*I5[413];
*(vp++) = U00*I0[513] - U10*I3[513] + loo2p*I2[513] - (threeo4zn)*I5[414];
*(vp++) = U00*I0[514] - U10*I3[514] + loo2p*I2[514] - (threeo4zn)*I5[415];
*(vp++) = U00*I0[515] - U10*I3[515] + loo2p*I2[515] - (threeo4zn)*I5[416];
*(vp++) = U00*I0[516] - U10*I3[516] + loo2p*I2[516] - (twoo4zn)*I5[417];
*(vp++) = U00*I0[517] - U10*I3[517] + loo2p*I2[517] - (twoo4zn)*I5[418];
*(vp++) = U00*I0[518] - U10*I3[518] + loo2p*I2[518] - (twoo4zn)*I5[419];
*(vp++) = U00*I0[519] - U10*I3[519] + loo2p*I2[519] - (twoo4zn)*I5[420];
*(vp++) = U00*I0[520] - U10*I3[520] + loo2p*I2[520] - (twoo4zn)*I5[421];
*(vp++) = U00*I0[521] - U10*I3[521] + loo2p*I2[521] - (twoo4zn)*I5[422];
*(vp++) = U00*I0[522] - U10*I3[522] + loo2p*I2[522] - (twoo4zn)*I5[423];
*(vp++) = U00*I0[523] - U10*I3[523] + loo2p*I2[523] - (oneo4zn)*I5[424];
*(vp++) = U00*I0[524] - U10*I3[524] + loo2p*I2[524] - (oneo4zn)*I5[425];
*(vp++) = U00*I0[525] - U10*I3[525] + loo2p*I2[525] - (oneo4zn)*I5[426];
*(vp++) = U00*I0[526] - U10*I3[526] + loo2p*I2[526] - (oneo4zn)*I5[427];
*(vp++) = U00*I0[527] - U10*I3[527] + loo2p*I2[527] - (oneo4zn)*I5[428];
*(vp++) = U00*I0[528] - U10*I3[528] + loo2p*I2[528] - (oneo4zn)*I5[429];
*(vp++) = U00*I0[529] - U10*I3[529] + loo2p*I2[529] - (oneo4zn)*I5[430];
*(vp++) = U00*I0[530] - U10*I3[530] + loo2p*I2[530] - (oneo4zn)*I5[431];
*(vp++) = U00*I0[531] - U10*I3[531] + loo2p*I2[531];
*(vp++) = U00*I0[532] - U10*I3[532] + loo2p*I2[532];
*(vp++) = U00*I0[533] - U10*I3[533] + loo2p*I2[533];
*(vp++) = U00*I0[534] - U10*I3[534] + loo2p*I2[534];
*(vp++) = U00*I0[535] - U10*I3[535] + loo2p*I2[535];
*(vp++) = U00*I0[536] - U10*I3[536] + loo2p*I2[536];
*(vp++) = U00*I0[537] - U10*I3[537] + loo2p*I2[537];
*(vp++) = U00*I0[538] - U10*I3[538] + loo2p*I2[538];
*(vp++) = U00*I0[539] - U10*I3[539] + loo2p*I2[539];
*(vp++) = U00*I0[540] - U10*I3[540] + loo2p*I2[540] - (eighto4zn)*I5[432];
*(vp++) = U00*I0[541] - U10*I3[541] + loo2p*I2[541] - (seveno4zn)*I5[433];
*(vp++) = U00*I0[542] - U10*I3[542] + loo2p*I2[542] - (seveno4zn)*I5[434];
*(vp++) = U00*I0[543] - U10*I3[543] + loo2p*I2[543] - (sixo4zn)*I5[435];
*(vp++) = U00*I0[544] - U10*I3[544] + loo2p*I2[544] - (sixo4zn)*I5[436];
*(vp++) = U00*I0[545] - U10*I3[545] + loo2p*I2[545] - (sixo4zn)*I5[437];
*(vp++) = U00*I0[546] - U10*I3[546] + loo2p*I2[546] - (fiveo4zn)*I5[438];
*(vp++) = U00*I0[547] - U10*I3[547] + loo2p*I2[547] - (fiveo4zn)*I5[439];
*(vp++) = U00*I0[548] - U10*I3[548] + loo2p*I2[548] - (fiveo4zn)*I5[440];
*(vp++) = U00*I0[549] - U10*I3[549] + loo2p*I2[549] - (fiveo4zn)*I5[441];
*(vp++) = U00*I0[550] - U10*I3[550] + loo2p*I2[550] - (fouro4zn)*I5[442];
*(vp++) = U00*I0[551] - U10*I3[551] + loo2p*I2[551] - (fouro4zn)*I5[443];
*(vp++) = U00*I0[552] - U10*I3[552] + loo2p*I2[552] - (fouro4zn)*I5[444];
*(vp++) = U00*I0[553] - U10*I3[553] + loo2p*I2[553] - (fouro4zn)*I5[445];
*(vp++) = U00*I0[554] - U10*I3[554] + loo2p*I2[554] - (fouro4zn)*I5[446];
*(vp++) = U00*I0[555] - U10*I3[555] + loo2p*I2[555] - (threeo4zn)*I5[447];
*(vp++) = U00*I0[556] - U10*I3[556] + loo2p*I2[556] - (threeo4zn)*I5[448];
*(vp++) = U00*I0[557] - U10*I3[557] + loo2p*I2[557] - (threeo4zn)*I5[449];
*(vp++) = U00*I0[558] - U10*I3[558] + loo2p*I2[558] - (threeo4zn)*I5[450];
*(vp++) = U00*I0[559] - U10*I3[559] + loo2p*I2[559] - (threeo4zn)*I5[451];
*(vp++) = U00*I0[560] - U10*I3[560] + loo2p*I2[560] - (threeo4zn)*I5[452];
*(vp++) = U00*I0[561] - U10*I3[561] + loo2p*I2[561] - (twoo4zn)*I5[453];
*(vp++) = U00*I0[562] - U10*I3[562] + loo2p*I2[562] - (twoo4zn)*I5[454];
*(vp++) = U00*I0[563] - U10*I3[563] + loo2p*I2[563] - (twoo4zn)*I5[455];
*(vp++) = U00*I0[564] - U10*I3[564] + loo2p*I2[564] - (twoo4zn)*I5[456];
*(vp++) = U00*I0[565] - U10*I3[565] + loo2p*I2[565] - (twoo4zn)*I5[457];
*(vp++) = U00*I0[566] - U10*I3[566] + loo2p*I2[566] - (twoo4zn)*I5[458];
*(vp++) = U00*I0[567] - U10*I3[567] + loo2p*I2[567] - (twoo4zn)*I5[459];
*(vp++) = U00*I0[568] - U10*I3[568] + loo2p*I2[568] - (oneo4zn)*I5[460];
*(vp++) = U00*I0[569] - U10*I3[569] + loo2p*I2[569] - (oneo4zn)*I5[461];
*(vp++) = U00*I0[570] - U10*I3[570] + loo2p*I2[570] - (oneo4zn)*I5[462];
*(vp++) = U00*I0[571] - U10*I3[571] + loo2p*I2[571] - (oneo4zn)*I5[463];
*(vp++) = U00*I0[572] - U10*I3[572] + loo2p*I2[572] - (oneo4zn)*I5[464];
*(vp++) = U00*I0[573] - U10*I3[573] + loo2p*I2[573] - (oneo4zn)*I5[465];
*(vp++) = U00*I0[574] - U10*I3[574] + loo2p*I2[574] - (oneo4zn)*I5[466];
*(vp++) = U00*I0[575] - U10*I3[575] + loo2p*I2[575] - (oneo4zn)*I5[467];
*(vp++) = U00*I0[576] - U10*I3[576] + loo2p*I2[576];
*(vp++) = U00*I0[577] - U10*I3[577] + loo2p*I2[577];
*(vp++) = U00*I0[578] - U10*I3[578] + loo2p*I2[578];
*(vp++) = U00*I0[579] - U10*I3[579] + loo2p*I2[579];
*(vp++) = U00*I0[580] - U10*I3[580] + loo2p*I2[580];
*(vp++) = U00*I0[581] - U10*I3[581] + loo2p*I2[581];
*(vp++) = U00*I0[582] - U10*I3[582] + loo2p*I2[582];
*(vp++) = U00*I0[583] - U10*I3[583] + loo2p*I2[583];
*(vp++) = U00*I0[584] - U10*I3[584] + loo2p*I2[584];
*(vp++) = U00*I0[585] - U10*I3[585] + loo2p*I2[585] - (eighto4zn)*I5[468];
*(vp++) = U00*I0[586] - U10*I3[586] + loo2p*I2[586] - (seveno4zn)*I5[469];
*(vp++) = U00*I0[587] - U10*I3[587] + loo2p*I2[587] - (seveno4zn)*I5[470];
*(vp++) = U00*I0[588] - U10*I3[588] + loo2p*I2[588] - (sixo4zn)*I5[471];
*(vp++) = U00*I0[589] - U10*I3[589] + loo2p*I2[589] - (sixo4zn)*I5[472];
*(vp++) = U00*I0[590] - U10*I3[590] + loo2p*I2[590] - (sixo4zn)*I5[473];
*(vp++) = U00*I0[591] - U10*I3[591] + loo2p*I2[591] - (fiveo4zn)*I5[474];
*(vp++) = U00*I0[592] - U10*I3[592] + loo2p*I2[592] - (fiveo4zn)*I5[475];
*(vp++) = U00*I0[593] - U10*I3[593] + loo2p*I2[593] - (fiveo4zn)*I5[476];
*(vp++) = U00*I0[594] - U10*I3[594] + loo2p*I2[594] - (fiveo4zn)*I5[477];
*(vp++) = U00*I0[595] - U10*I3[595] + loo2p*I2[595] - (fouro4zn)*I5[478];
*(vp++) = U00*I0[596] - U10*I3[596] + loo2p*I2[596] - (fouro4zn)*I5[479];
*(vp++) = U00*I0[597] - U10*I3[597] + loo2p*I2[597] - (fouro4zn)*I5[480];
*(vp++) = U00*I0[598] - U10*I3[598] + loo2p*I2[598] - (fouro4zn)*I5[481];
*(vp++) = U00*I0[599] - U10*I3[599] + loo2p*I2[599] - (fouro4zn)*I5[482];
*(vp++) = U00*I0[600] - U10*I3[600] + loo2p*I2[600] - (threeo4zn)*I5[483];
*(vp++) = U00*I0[601] - U10*I3[601] + loo2p*I2[601] - (threeo4zn)*I5[484];
*(vp++) = U00*I0[602] - U10*I3[602] + loo2p*I2[602] - (threeo4zn)*I5[485];
*(vp++) = U00*I0[603] - U10*I3[603] + loo2p*I2[603] - (threeo4zn)*I5[486];
*(vp++) = U00*I0[604] - U10*I3[604] + loo2p*I2[604] - (threeo4zn)*I5[487];
*(vp++) = U00*I0[605] - U10*I3[605] + loo2p*I2[605] - (threeo4zn)*I5[488];
*(vp++) = U00*I0[606] - U10*I3[606] + loo2p*I2[606] - (twoo4zn)*I5[489];
*(vp++) = U00*I0[607] - U10*I3[607] + loo2p*I2[607] - (twoo4zn)*I5[490];
*(vp++) = U00*I0[608] - U10*I3[608] + loo2p*I2[608] - (twoo4zn)*I5[491];
*(vp++) = U00*I0[609] - U10*I3[609] + loo2p*I2[609] - (twoo4zn)*I5[492];
*(vp++) = U00*I0[610] - U10*I3[610] + loo2p*I2[610] - (twoo4zn)*I5[493];
*(vp++) = U00*I0[611] - U10*I3[611] + loo2p*I2[611] - (twoo4zn)*I5[494];
*(vp++) = U00*I0[612] - U10*I3[612] + loo2p*I2[612] - (twoo4zn)*I5[495];
*(vp++) = U00*I0[613] - U10*I3[613] + loo2p*I2[613] - (oneo4zn)*I5[496];
*(vp++) = U00*I0[614] - U10*I3[614] + loo2p*I2[614] - (oneo4zn)*I5[497];
*(vp++) = U00*I0[615] - U10*I3[615] + loo2p*I2[615] - (oneo4zn)*I5[498];
*(vp++) = U00*I0[616] - U10*I3[616] + loo2p*I2[616] - (oneo4zn)*I5[499];
*(vp++) = U00*I0[617] - U10*I3[617] + loo2p*I2[617] - (oneo4zn)*I5[500];
*(vp++) = U00*I0[618] - U10*I3[618] + loo2p*I2[618] - (oneo4zn)*I5[501];
*(vp++) = U00*I0[619] - U10*I3[619] + loo2p*I2[619] - (oneo4zn)*I5[502];
*(vp++) = U00*I0[620] - U10*I3[620] + loo2p*I2[620] - (oneo4zn)*I5[503];
*(vp++) = U00*I0[621] - U10*I3[621] + loo2p*I2[621];
*(vp++) = U00*I0[622] - U10*I3[622] + loo2p*I2[622];
*(vp++) = U00*I0[623] - U10*I3[623] + loo2p*I2[623];
*(vp++) = U00*I0[624] - U10*I3[624] + loo2p*I2[624];
*(vp++) = U00*I0[625] - U10*I3[625] + loo2p*I2[625];
*(vp++) = U00*I0[626] - U10*I3[626] + loo2p*I2[626];
*(vp++) = U00*I0[627] - U10*I3[627] + loo2p*I2[627];
*(vp++) = U00*I0[628] - U10*I3[628] + loo2p*I2[628];
*(vp++) = U00*I0[629] - U10*I3[629] + loo2p*I2[629];
*(vp++) = U00*I0[630] - U10*I3[630] + loo2p*I2[630] - (eighto4zn)*I5[504];
*(vp++) = U00*I0[631] - U10*I3[631] + loo2p*I2[631] - (seveno4zn)*I5[505];
*(vp++) = U00*I0[632] - U10*I3[632] + loo2p*I2[632] - (seveno4zn)*I5[506];
*(vp++) = U00*I0[633] - U10*I3[633] + loo2p*I2[633] - (sixo4zn)*I5[507];
*(vp++) = U00*I0[634] - U10*I3[634] + loo2p*I2[634] - (sixo4zn)*I5[508];
*(vp++) = U00*I0[635] - U10*I3[635] + loo2p*I2[635] - (sixo4zn)*I5[509];
*(vp++) = U00*I0[636] - U10*I3[636] + loo2p*I2[636] - (fiveo4zn)*I5[510];
*(vp++) = U00*I0[637] - U10*I3[637] + loo2p*I2[637] - (fiveo4zn)*I5[511];
*(vp++) = U00*I0[638] - U10*I3[638] + loo2p*I2[638] - (fiveo4zn)*I5[512];
*(vp++) = U00*I0[639] - U10*I3[639] + loo2p*I2[639] - (fiveo4zn)*I5[513];
*(vp++) = U00*I0[640] - U10*I3[640] + loo2p*I2[640] - (fouro4zn)*I5[514];
*(vp++) = U00*I0[641] - U10*I3[641] + loo2p*I2[641] - (fouro4zn)*I5[515];
*(vp++) = U00*I0[642] - U10*I3[642] + loo2p*I2[642] - (fouro4zn)*I5[516];
*(vp++) = U00*I0[643] - U10*I3[643] + loo2p*I2[643] - (fouro4zn)*I5[517];
*(vp++) = U00*I0[644] - U10*I3[644] + loo2p*I2[644] - (fouro4zn)*I5[518];
*(vp++) = U00*I0[645] - U10*I3[645] + loo2p*I2[645] - (threeo4zn)*I5[519];
*(vp++) = U00*I0[646] - U10*I3[646] + loo2p*I2[646] - (threeo4zn)*I5[520];
*(vp++) = U00*I0[647] - U10*I3[647] + loo2p*I2[647] - (threeo4zn)*I5[521];
*(vp++) = U00*I0[648] - U10*I3[648] + loo2p*I2[648] - (threeo4zn)*I5[522];
*(vp++) = U00*I0[649] - U10*I3[649] + loo2p*I2[649] - (threeo4zn)*I5[523];
*(vp++) = U00*I0[650] - U10*I3[650] + loo2p*I2[650] - (threeo4zn)*I5[524];
*(vp++) = U00*I0[651] - U10*I3[651] + loo2p*I2[651] - (twoo4zn)*I5[525];
*(vp++) = U00*I0[652] - U10*I3[652] + loo2p*I2[652] - (twoo4zn)*I5[526];
*(vp++) = U00*I0[653] - U10*I3[653] + loo2p*I2[653] - (twoo4zn)*I5[527];
*(vp++) = U00*I0[654] - U10*I3[654] + loo2p*I2[654] - (twoo4zn)*I5[528];
*(vp++) = U00*I0[655] - U10*I3[655] + loo2p*I2[655] - (twoo4zn)*I5[529];
*(vp++) = U00*I0[656] - U10*I3[656] + loo2p*I2[656] - (twoo4zn)*I5[530];
*(vp++) = U00*I0[657] - U10*I3[657] + loo2p*I2[657] - (twoo4zn)*I5[531];
*(vp++) = U00*I0[658] - U10*I3[658] + loo2p*I2[658] - (oneo4zn)*I5[532];
*(vp++) = U00*I0[659] - U10*I3[659] + loo2p*I2[659] - (oneo4zn)*I5[533];
*(vp++) = U00*I0[660] - U10*I3[660] + loo2p*I2[660] - (oneo4zn)*I5[534];
*(vp++) = U00*I0[661] - U10*I3[661] + loo2p*I2[661] - (oneo4zn)*I5[535];
*(vp++) = U00*I0[662] - U10*I3[662] + loo2p*I2[662] - (oneo4zn)*I5[536];
*(vp++) = U00*I0[663] - U10*I3[663] + loo2p*I2[663] - (oneo4zn)*I5[537];
*(vp++) = U00*I0[664] - U10*I3[664] + loo2p*I2[664] - (oneo4zn)*I5[538];
*(vp++) = U00*I0[665] - U10*I3[665] + loo2p*I2[665] - (oneo4zn)*I5[539];
*(vp++) = U00*I0[666] - U10*I3[666] + loo2p*I2[666];
*(vp++) = U00*I0[667] - U10*I3[667] + loo2p*I2[667];
*(vp++) = U00*I0[668] - U10*I3[668] + loo2p*I2[668];
*(vp++) = U00*I0[669] - U10*I3[669] + loo2p*I2[669];
*(vp++) = U00*I0[670] - U10*I3[670] + loo2p*I2[670];
*(vp++) = U00*I0[671] - U10*I3[671] + loo2p*I2[671];
*(vp++) = U00*I0[672] - U10*I3[672] + loo2p*I2[672];
*(vp++) = U00*I0[673] - U10*I3[673] + loo2p*I2[673];
*(vp++) = U00*I0[674] - U10*I3[674] + loo2p*I2[674];
*(vp++) = U01*I0[450] - U11*I3[450] + loo2p*I2[675]
        + (fouro2z)*I1[270] - (fouro4zn)*I4[270];
*(vp++) = U01*I0[451] - U11*I3[451] + loo2p*I2[676]
        + (fouro2z)*I1[271] - (fouro4zn)*I4[271] - (oneo4zn)*I5[360];
*(vp++) = U01*I0[452] - U11*I3[452] + loo2p*I2[677]
        + (fouro2z)*I1[272] - (fouro4zn)*I4[272];
*(vp++) = U01*I0[453] - U11*I3[453] + loo2p*I2[678]
        + (fouro2z)*I1[273] - (fouro4zn)*I4[273] - (twoo4zn)*I5[361];
*(vp++) = U01*I0[454] - U11*I3[454] + loo2p*I2[679]
        + (fouro2z)*I1[274] - (fouro4zn)*I4[274] - (oneo4zn)*I5[362];
*(vp++) = U01*I0[455] - U11*I3[455] + loo2p*I2[680]
        + (fouro2z)*I1[275] - (fouro4zn)*I4[275];
*(vp++) = U01*I0[456] - U11*I3[456] + loo2p*I2[681]
        + (fouro2z)*I1[276] - (fouro4zn)*I4[276] - (threeo4zn)*I5[363];
*(vp++) = U01*I0[457] - U11*I3[457] + loo2p*I2[682]
        + (fouro2z)*I1[277] - (fouro4zn)*I4[277] - (twoo4zn)*I5[364];
*(vp++) = U01*I0[458] - U11*I3[458] + loo2p*I2[683]
        + (fouro2z)*I1[278] - (fouro4zn)*I4[278] - (oneo4zn)*I5[365];
*(vp++) = U01*I0[459] - U11*I3[459] + loo2p*I2[684]
        + (fouro2z)*I1[279] - (fouro4zn)*I4[279];
*(vp++) = U01*I0[460] - U11*I3[460] + loo2p*I2[685]
        + (fouro2z)*I1[280] - (fouro4zn)*I4[280] - (fouro4zn)*I5[366];
*(vp++) = U01*I0[461] - U11*I3[461] + loo2p*I2[686]
        + (fouro2z)*I1[281] - (fouro4zn)*I4[281] - (threeo4zn)*I5[367];
*(vp++) = U01*I0[462] - U11*I3[462] + loo2p*I2[687]
        + (fouro2z)*I1[282] - (fouro4zn)*I4[282] - (twoo4zn)*I5[368];
*(vp++) = U01*I0[463] - U11*I3[463] + loo2p*I2[688]
        + (fouro2z)*I1[283] - (fouro4zn)*I4[283] - (oneo4zn)*I5[369];
*(vp++) = U01*I0[464] - U11*I3[464] + loo2p*I2[689]
        + (fouro2z)*I1[284] - (fouro4zn)*I4[284];
*(vp++) = U01*I0[465] - U11*I3[465] + loo2p*I2[690]
        + (fouro2z)*I1[285] - (fouro4zn)*I4[285] - (fiveo4zn)*I5[370];
*(vp++) = U01*I0[466] - U11*I3[466] + loo2p*I2[691]
        + (fouro2z)*I1[286] - (fouro4zn)*I4[286] - (fouro4zn)*I5[371];
*(vp++) = U01*I0[467] - U11*I3[467] + loo2p*I2[692]
        + (fouro2z)*I1[287] - (fouro4zn)*I4[287] - (threeo4zn)*I5[372];
*(vp++) = U01*I0[468] - U11*I3[468] + loo2p*I2[693]
        + (fouro2z)*I1[288] - (fouro4zn)*I4[288] - (twoo4zn)*I5[373];
*(vp++) = U01*I0[469] - U11*I3[469] + loo2p*I2[694]
        + (fouro2z)*I1[289] - (fouro4zn)*I4[289] - (oneo4zn)*I5[374];
*(vp++) = U01*I0[470] - U11*I3[470] + loo2p*I2[695]
        + (fouro2z)*I1[290] - (fouro4zn)*I4[290];
*(vp++) = U01*I0[471] - U11*I3[471] + loo2p*I2[696]
        + (fouro2z)*I1[291] - (fouro4zn)*I4[291] - (sixo4zn)*I5[375];
*(vp++) = U01*I0[472] - U11*I3[472] + loo2p*I2[697]
        + (fouro2z)*I1[292] - (fouro4zn)*I4[292] - (fiveo4zn)*I5[376];
*(vp++) = U01*I0[473] - U11*I3[473] + loo2p*I2[698]
        + (fouro2z)*I1[293] - (fouro4zn)*I4[293] - (fouro4zn)*I5[377];
*(vp++) = U01*I0[474] - U11*I3[474] + loo2p*I2[699]
        + (fouro2z)*I1[294] - (fouro4zn)*I4[294] - (threeo4zn)*I5[378];
*(vp++) = U01*I0[475] - U11*I3[475] + loo2p*I2[700]
        + (fouro2z)*I1[295] - (fouro4zn)*I4[295] - (twoo4zn)*I5[379];
*(vp++) = U01*I0[476] - U11*I3[476] + loo2p*I2[701]
        + (fouro2z)*I1[296] - (fouro4zn)*I4[296] - (oneo4zn)*I5[380];
*(vp++) = U01*I0[477] - U11*I3[477] + loo2p*I2[702]
        + (fouro2z)*I1[297] - (fouro4zn)*I4[297];
*(vp++) = U01*I0[478] - U11*I3[478] + loo2p*I2[703]
        + (fouro2z)*I1[298] - (fouro4zn)*I4[298] - (seveno4zn)*I5[381];
*(vp++) = U01*I0[479] - U11*I3[479] + loo2p*I2[704]
        + (fouro2z)*I1[299] - (fouro4zn)*I4[299] - (sixo4zn)*I5[382];
*(vp++) = U01*I0[480] - U11*I3[480] + loo2p*I2[705]
        + (fouro2z)*I1[300] - (fouro4zn)*I4[300] - (fiveo4zn)*I5[383];
*(vp++) = U01*I0[481] - U11*I3[481] + loo2p*I2[706]
        + (fouro2z)*I1[301] - (fouro4zn)*I4[301] - (fouro4zn)*I5[384];
*(vp++) = U01*I0[482] - U11*I3[482] + loo2p*I2[707]
        + (fouro2z)*I1[302] - (fouro4zn)*I4[302] - (threeo4zn)*I5[385];
*(vp++) = U01*I0[483] - U11*I3[483] + loo2p*I2[708]
        + (fouro2z)*I1[303] - (fouro4zn)*I4[303] - (twoo4zn)*I5[386];
*(vp++) = U01*I0[484] - U11*I3[484] + loo2p*I2[709]
        + (fouro2z)*I1[304] - (fouro4zn)*I4[304] - (oneo4zn)*I5[387];
*(vp++) = U01*I0[485] - U11*I3[485] + loo2p*I2[710]
        + (fouro2z)*I1[305] - (fouro4zn)*I4[305];
return vp;
}

REALTYPE *_r_build_h0l0_3(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE eighto4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  eighto4zn = 8.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U01*I0[486] - U11*I3[486] + loo2p*I2[711]
        + (fouro2z)*I1[306] - (fouro4zn)*I4[306] - (eighto4zn)*I5[388];
*(vp++) = U01*I0[487] - U11*I3[487] + loo2p*I2[712]
        + (fouro2z)*I1[307] - (fouro4zn)*I4[307] - (seveno4zn)*I5[389];
*(vp++) = U01*I0[488] - U11*I3[488] + loo2p*I2[713]
        + (fouro2z)*I1[308] - (fouro4zn)*I4[308] - (sixo4zn)*I5[390];
*(vp++) = U01*I0[489] - U11*I3[489] + loo2p*I2[714]
        + (fouro2z)*I1[309] - (fouro4zn)*I4[309] - (fiveo4zn)*I5[391];
*(vp++) = U01*I0[490] - U11*I3[490] + loo2p*I2[715]
        + (fouro2z)*I1[310] - (fouro4zn)*I4[310] - (fouro4zn)*I5[392];
*(vp++) = U01*I0[491] - U11*I3[491] + loo2p*I2[716]
        + (fouro2z)*I1[311] - (fouro4zn)*I4[311] - (threeo4zn)*I5[393];
*(vp++) = U01*I0[492] - U11*I3[492] + loo2p*I2[717]
        + (fouro2z)*I1[312] - (fouro4zn)*I4[312] - (twoo4zn)*I5[394];
*(vp++) = U01*I0[493] - U11*I3[493] + loo2p*I2[718]
        + (fouro2z)*I1[313] - (fouro4zn)*I4[313] - (oneo4zn)*I5[395];
*(vp++) = U01*I0[494] - U11*I3[494] + loo2p*I2[719]
        + (fouro2z)*I1[314] - (fouro4zn)*I4[314];
*(vp++) = U01*I0[495] - U11*I3[495] + loo2p*I2[720]
        + (threeo2z)*I1[315] - (threeo4zn)*I4[315];
*(vp++) = U01*I0[496] - U11*I3[496] + loo2p*I2[721]
        + (threeo2z)*I1[316] - (threeo4zn)*I4[316] - (oneo4zn)*I5[396];
*(vp++) = U01*I0[497] - U11*I3[497] + loo2p*I2[722]
        + (threeo2z)*I1[317] - (threeo4zn)*I4[317];
*(vp++) = U01*I0[498] - U11*I3[498] + loo2p*I2[723]
        + (threeo2z)*I1[318] - (threeo4zn)*I4[318] - (twoo4zn)*I5[397];
*(vp++) = U01*I0[499] - U11*I3[499] + loo2p*I2[724]
        + (threeo2z)*I1[319] - (threeo4zn)*I4[319] - (oneo4zn)*I5[398];
*(vp++) = U01*I0[500] - U11*I3[500] + loo2p*I2[725]
        + (threeo2z)*I1[320] - (threeo4zn)*I4[320];
*(vp++) = U01*I0[501] - U11*I3[501] + loo2p*I2[726]
        + (threeo2z)*I1[321] - (threeo4zn)*I4[321] - (threeo4zn)*I5[399];
*(vp++) = U01*I0[502] - U11*I3[502] + loo2p*I2[727]
        + (threeo2z)*I1[322] - (threeo4zn)*I4[322] - (twoo4zn)*I5[400];
*(vp++) = U01*I0[503] - U11*I3[503] + loo2p*I2[728]
        + (threeo2z)*I1[323] - (threeo4zn)*I4[323] - (oneo4zn)*I5[401];
*(vp++) = U01*I0[504] - U11*I3[504] + loo2p*I2[729]
        + (threeo2z)*I1[324] - (threeo4zn)*I4[324];
*(vp++) = U01*I0[505] - U11*I3[505] + loo2p*I2[730]
        + (threeo2z)*I1[325] - (threeo4zn)*I4[325] - (fouro4zn)*I5[402];
*(vp++) = U01*I0[506] - U11*I3[506] + loo2p*I2[731]
        + (threeo2z)*I1[326] - (threeo4zn)*I4[326] - (threeo4zn)*I5[403];
*(vp++) = U01*I0[507] - U11*I3[507] + loo2p*I2[732]
        + (threeo2z)*I1[327] - (threeo4zn)*I4[327] - (twoo4zn)*I5[404];
*(vp++) = U01*I0[508] - U11*I3[508] + loo2p*I2[733]
        + (threeo2z)*I1[328] - (threeo4zn)*I4[328] - (oneo4zn)*I5[405];
*(vp++) = U01*I0[509] - U11*I3[509] + loo2p*I2[734]
        + (threeo2z)*I1[329] - (threeo4zn)*I4[329];
*(vp++) = U01*I0[510] - U11*I3[510] + loo2p*I2[735]
        + (threeo2z)*I1[330] - (threeo4zn)*I4[330] - (fiveo4zn)*I5[406];
*(vp++) = U01*I0[511] - U11*I3[511] + loo2p*I2[736]
        + (threeo2z)*I1[331] - (threeo4zn)*I4[331] - (fouro4zn)*I5[407];
*(vp++) = U01*I0[512] - U11*I3[512] + loo2p*I2[737]
        + (threeo2z)*I1[332] - (threeo4zn)*I4[332] - (threeo4zn)*I5[408];
*(vp++) = U01*I0[513] - U11*I3[513] + loo2p*I2[738]
        + (threeo2z)*I1[333] - (threeo4zn)*I4[333] - (twoo4zn)*I5[409];
*(vp++) = U01*I0[514] - U11*I3[514] + loo2p*I2[739]
        + (threeo2z)*I1[334] - (threeo4zn)*I4[334] - (oneo4zn)*I5[410];
*(vp++) = U01*I0[515] - U11*I3[515] + loo2p*I2[740]
        + (threeo2z)*I1[335] - (threeo4zn)*I4[335];
*(vp++) = U01*I0[516] - U11*I3[516] + loo2p*I2[741]
        + (threeo2z)*I1[336] - (threeo4zn)*I4[336] - (sixo4zn)*I5[411];
*(vp++) = U01*I0[517] - U11*I3[517] + loo2p*I2[742]
        + (threeo2z)*I1[337] - (threeo4zn)*I4[337] - (fiveo4zn)*I5[412];
*(vp++) = U01*I0[518] - U11*I3[518] + loo2p*I2[743]
        + (threeo2z)*I1[338] - (threeo4zn)*I4[338] - (fouro4zn)*I5[413];
*(vp++) = U01*I0[519] - U11*I3[519] + loo2p*I2[744]
        + (threeo2z)*I1[339] - (threeo4zn)*I4[339] - (threeo4zn)*I5[414];
*(vp++) = U01*I0[520] - U11*I3[520] + loo2p*I2[745]
        + (threeo2z)*I1[340] - (threeo4zn)*I4[340] - (twoo4zn)*I5[415];
*(vp++) = U01*I0[521] - U11*I3[521] + loo2p*I2[746]
        + (threeo2z)*I1[341] - (threeo4zn)*I4[341] - (oneo4zn)*I5[416];
*(vp++) = U01*I0[522] - U11*I3[522] + loo2p*I2[747]
        + (threeo2z)*I1[342] - (threeo4zn)*I4[342];
*(vp++) = U01*I0[523] - U11*I3[523] + loo2p*I2[748]
        + (threeo2z)*I1[343] - (threeo4zn)*I4[343] - (seveno4zn)*I5[417];
*(vp++) = U01*I0[524] - U11*I3[524] + loo2p*I2[749]
        + (threeo2z)*I1[344] - (threeo4zn)*I4[344] - (sixo4zn)*I5[418];
*(vp++) = U01*I0[525] - U11*I3[525] + loo2p*I2[750]
        + (threeo2z)*I1[345] - (threeo4zn)*I4[345] - (fiveo4zn)*I5[419];
*(vp++) = U01*I0[526] - U11*I3[526] + loo2p*I2[751]
        + (threeo2z)*I1[346] - (threeo4zn)*I4[346] - (fouro4zn)*I5[420];
*(vp++) = U01*I0[527] - U11*I3[527] + loo2p*I2[752]
        + (threeo2z)*I1[347] - (threeo4zn)*I4[347] - (threeo4zn)*I5[421];
*(vp++) = U01*I0[528] - U11*I3[528] + loo2p*I2[753]
        + (threeo2z)*I1[348] - (threeo4zn)*I4[348] - (twoo4zn)*I5[422];
*(vp++) = U01*I0[529] - U11*I3[529] + loo2p*I2[754]
        + (threeo2z)*I1[349] - (threeo4zn)*I4[349] - (oneo4zn)*I5[423];
*(vp++) = U01*I0[530] - U11*I3[530] + loo2p*I2[755]
        + (threeo2z)*I1[350] - (threeo4zn)*I4[350];
*(vp++) = U01*I0[531] - U11*I3[531] + loo2p*I2[756]
        + (threeo2z)*I1[351] - (threeo4zn)*I4[351] - (eighto4zn)*I5[424];
*(vp++) = U01*I0[532] - U11*I3[532] + loo2p*I2[757]
        + (threeo2z)*I1[352] - (threeo4zn)*I4[352] - (seveno4zn)*I5[425];
*(vp++) = U01*I0[533] - U11*I3[533] + loo2p*I2[758]
        + (threeo2z)*I1[353] - (threeo4zn)*I4[353] - (sixo4zn)*I5[426];
*(vp++) = U01*I0[534] - U11*I3[534] + loo2p*I2[759]
        + (threeo2z)*I1[354] - (threeo4zn)*I4[354] - (fiveo4zn)*I5[427];
*(vp++) = U01*I0[535] - U11*I3[535] + loo2p*I2[760]
        + (threeo2z)*I1[355] - (threeo4zn)*I4[355] - (fouro4zn)*I5[428];
*(vp++) = U01*I0[536] - U11*I3[536] + loo2p*I2[761]
        + (threeo2z)*I1[356] - (threeo4zn)*I4[356] - (threeo4zn)*I5[429];
*(vp++) = U01*I0[537] - U11*I3[537] + loo2p*I2[762]
        + (threeo2z)*I1[357] - (threeo4zn)*I4[357] - (twoo4zn)*I5[430];
*(vp++) = U01*I0[538] - U11*I3[538] + loo2p*I2[763]
        + (threeo2z)*I1[358] - (threeo4zn)*I4[358] - (oneo4zn)*I5[431];
*(vp++) = U01*I0[539] - U11*I3[539] + loo2p*I2[764]
        + (threeo2z)*I1[359] - (threeo4zn)*I4[359];
*(vp++) = U01*I0[540] - U11*I3[540] + loo2p*I2[765]
        + (twoo2z)*I1[360] - (twoo4zn)*I4[360];
*(vp++) = U01*I0[541] - U11*I3[541] + loo2p*I2[766]
        + (twoo2z)*I1[361] - (twoo4zn)*I4[361] - (oneo4zn)*I5[432];
*(vp++) = U01*I0[542] - U11*I3[542] + loo2p*I2[767]
        + (twoo2z)*I1[362] - (twoo4zn)*I4[362];
*(vp++) = U01*I0[543] - U11*I3[543] + loo2p*I2[768]
        + (twoo2z)*I1[363] - (twoo4zn)*I4[363] - (twoo4zn)*I5[433];
*(vp++) = U01*I0[544] - U11*I3[544] + loo2p*I2[769]
        + (twoo2z)*I1[364] - (twoo4zn)*I4[364] - (oneo4zn)*I5[434];
*(vp++) = U01*I0[545] - U11*I3[545] + loo2p*I2[770]
        + (twoo2z)*I1[365] - (twoo4zn)*I4[365];
*(vp++) = U01*I0[546] - U11*I3[546] + loo2p*I2[771]
        + (twoo2z)*I1[366] - (twoo4zn)*I4[366] - (threeo4zn)*I5[435];
*(vp++) = U01*I0[547] - U11*I3[547] + loo2p*I2[772]
        + (twoo2z)*I1[367] - (twoo4zn)*I4[367] - (twoo4zn)*I5[436];
*(vp++) = U01*I0[548] - U11*I3[548] + loo2p*I2[773]
        + (twoo2z)*I1[368] - (twoo4zn)*I4[368] - (oneo4zn)*I5[437];
*(vp++) = U01*I0[549] - U11*I3[549] + loo2p*I2[774]
        + (twoo2z)*I1[369] - (twoo4zn)*I4[369];
*(vp++) = U01*I0[550] - U11*I3[550] + loo2p*I2[775]
        + (twoo2z)*I1[370] - (twoo4zn)*I4[370] - (fouro4zn)*I5[438];
*(vp++) = U01*I0[551] - U11*I3[551] + loo2p*I2[776]
        + (twoo2z)*I1[371] - (twoo4zn)*I4[371] - (threeo4zn)*I5[439];
*(vp++) = U01*I0[552] - U11*I3[552] + loo2p*I2[777]
        + (twoo2z)*I1[372] - (twoo4zn)*I4[372] - (twoo4zn)*I5[440];
*(vp++) = U01*I0[553] - U11*I3[553] + loo2p*I2[778]
        + (twoo2z)*I1[373] - (twoo4zn)*I4[373] - (oneo4zn)*I5[441];
*(vp++) = U01*I0[554] - U11*I3[554] + loo2p*I2[779]
        + (twoo2z)*I1[374] - (twoo4zn)*I4[374];
*(vp++) = U01*I0[555] - U11*I3[555] + loo2p*I2[780]
        + (twoo2z)*I1[375] - (twoo4zn)*I4[375] - (fiveo4zn)*I5[442];
*(vp++) = U01*I0[556] - U11*I3[556] + loo2p*I2[781]
        + (twoo2z)*I1[376] - (twoo4zn)*I4[376] - (fouro4zn)*I5[443];
*(vp++) = U01*I0[557] - U11*I3[557] + loo2p*I2[782]
        + (twoo2z)*I1[377] - (twoo4zn)*I4[377] - (threeo4zn)*I5[444];
*(vp++) = U01*I0[558] - U11*I3[558] + loo2p*I2[783]
        + (twoo2z)*I1[378] - (twoo4zn)*I4[378] - (twoo4zn)*I5[445];
*(vp++) = U01*I0[559] - U11*I3[559] + loo2p*I2[784]
        + (twoo2z)*I1[379] - (twoo4zn)*I4[379] - (oneo4zn)*I5[446];
*(vp++) = U01*I0[560] - U11*I3[560] + loo2p*I2[785]
        + (twoo2z)*I1[380] - (twoo4zn)*I4[380];
*(vp++) = U01*I0[561] - U11*I3[561] + loo2p*I2[786]
        + (twoo2z)*I1[381] - (twoo4zn)*I4[381] - (sixo4zn)*I5[447];
*(vp++) = U01*I0[562] - U11*I3[562] + loo2p*I2[787]
        + (twoo2z)*I1[382] - (twoo4zn)*I4[382] - (fiveo4zn)*I5[448];
*(vp++) = U01*I0[563] - U11*I3[563] + loo2p*I2[788]
        + (twoo2z)*I1[383] - (twoo4zn)*I4[383] - (fouro4zn)*I5[449];
*(vp++) = U01*I0[564] - U11*I3[564] + loo2p*I2[789]
        + (twoo2z)*I1[384] - (twoo4zn)*I4[384] - (threeo4zn)*I5[450];
*(vp++) = U01*I0[565] - U11*I3[565] + loo2p*I2[790]
        + (twoo2z)*I1[385] - (twoo4zn)*I4[385] - (twoo4zn)*I5[451];
*(vp++) = U01*I0[566] - U11*I3[566] + loo2p*I2[791]
        + (twoo2z)*I1[386] - (twoo4zn)*I4[386] - (oneo4zn)*I5[452];
*(vp++) = U01*I0[567] - U11*I3[567] + loo2p*I2[792]
        + (twoo2z)*I1[387] - (twoo4zn)*I4[387];
*(vp++) = U01*I0[568] - U11*I3[568] + loo2p*I2[793]
        + (twoo2z)*I1[388] - (twoo4zn)*I4[388] - (seveno4zn)*I5[453];
*(vp++) = U01*I0[569] - U11*I3[569] + loo2p*I2[794]
        + (twoo2z)*I1[389] - (twoo4zn)*I4[389] - (sixo4zn)*I5[454];
*(vp++) = U01*I0[570] - U11*I3[570] + loo2p*I2[795]
        + (twoo2z)*I1[390] - (twoo4zn)*I4[390] - (fiveo4zn)*I5[455];
*(vp++) = U01*I0[571] - U11*I3[571] + loo2p*I2[796]
        + (twoo2z)*I1[391] - (twoo4zn)*I4[391] - (fouro4zn)*I5[456];
*(vp++) = U01*I0[572] - U11*I3[572] + loo2p*I2[797]
        + (twoo2z)*I1[392] - (twoo4zn)*I4[392] - (threeo4zn)*I5[457];
*(vp++) = U01*I0[573] - U11*I3[573] + loo2p*I2[798]
        + (twoo2z)*I1[393] - (twoo4zn)*I4[393] - (twoo4zn)*I5[458];
*(vp++) = U01*I0[574] - U11*I3[574] + loo2p*I2[799]
        + (twoo2z)*I1[394] - (twoo4zn)*I4[394] - (oneo4zn)*I5[459];
*(vp++) = U01*I0[575] - U11*I3[575] + loo2p*I2[800]
        + (twoo2z)*I1[395] - (twoo4zn)*I4[395];
*(vp++) = U01*I0[576] - U11*I3[576] + loo2p*I2[801]
        + (twoo2z)*I1[396] - (twoo4zn)*I4[396] - (eighto4zn)*I5[460];
*(vp++) = U01*I0[577] - U11*I3[577] + loo2p*I2[802]
        + (twoo2z)*I1[397] - (twoo4zn)*I4[397] - (seveno4zn)*I5[461];
*(vp++) = U01*I0[578] - U11*I3[578] + loo2p*I2[803]
        + (twoo2z)*I1[398] - (twoo4zn)*I4[398] - (sixo4zn)*I5[462];
*(vp++) = U01*I0[579] - U11*I3[579] + loo2p*I2[804]
        + (twoo2z)*I1[399] - (twoo4zn)*I4[399] - (fiveo4zn)*I5[463];
*(vp++) = U01*I0[580] - U11*I3[580] + loo2p*I2[805]
        + (twoo2z)*I1[400] - (twoo4zn)*I4[400] - (fouro4zn)*I5[464];
*(vp++) = U01*I0[581] - U11*I3[581] + loo2p*I2[806]
        + (twoo2z)*I1[401] - (twoo4zn)*I4[401] - (threeo4zn)*I5[465];
*(vp++) = U01*I0[582] - U11*I3[582] + loo2p*I2[807]
        + (twoo2z)*I1[402] - (twoo4zn)*I4[402] - (twoo4zn)*I5[466];
*(vp++) = U01*I0[583] - U11*I3[583] + loo2p*I2[808]
        + (twoo2z)*I1[403] - (twoo4zn)*I4[403] - (oneo4zn)*I5[467];
*(vp++) = U01*I0[584] - U11*I3[584] + loo2p*I2[809]
        + (twoo2z)*I1[404] - (twoo4zn)*I4[404];
*(vp++) = U01*I0[585] - U11*I3[585] + loo2p*I2[810]
        + (oneo2z)*I1[405] - (oneo4zn)*I4[405];
*(vp++) = U01*I0[586] - U11*I3[586] + loo2p*I2[811]
        + (oneo2z)*I1[406] - (oneo4zn)*I4[406] - (oneo4zn)*I5[468];
*(vp++) = U01*I0[587] - U11*I3[587] + loo2p*I2[812]
        + (oneo2z)*I1[407] - (oneo4zn)*I4[407];
*(vp++) = U01*I0[588] - U11*I3[588] + loo2p*I2[813]
        + (oneo2z)*I1[408] - (oneo4zn)*I4[408] - (twoo4zn)*I5[469];
*(vp++) = U01*I0[589] - U11*I3[589] + loo2p*I2[814]
        + (oneo2z)*I1[409] - (oneo4zn)*I4[409] - (oneo4zn)*I5[470];
*(vp++) = U01*I0[590] - U11*I3[590] + loo2p*I2[815]
        + (oneo2z)*I1[410] - (oneo4zn)*I4[410];
*(vp++) = U01*I0[591] - U11*I3[591] + loo2p*I2[816]
        + (oneo2z)*I1[411] - (oneo4zn)*I4[411] - (threeo4zn)*I5[471];
*(vp++) = U01*I0[592] - U11*I3[592] + loo2p*I2[817]
        + (oneo2z)*I1[412] - (oneo4zn)*I4[412] - (twoo4zn)*I5[472];
*(vp++) = U01*I0[593] - U11*I3[593] + loo2p*I2[818]
        + (oneo2z)*I1[413] - (oneo4zn)*I4[413] - (oneo4zn)*I5[473];
*(vp++) = U01*I0[594] - U11*I3[594] + loo2p*I2[819]
        + (oneo2z)*I1[414] - (oneo4zn)*I4[414];
*(vp++) = U01*I0[595] - U11*I3[595] + loo2p*I2[820]
        + (oneo2z)*I1[415] - (oneo4zn)*I4[415] - (fouro4zn)*I5[474];
*(vp++) = U01*I0[596] - U11*I3[596] + loo2p*I2[821]
        + (oneo2z)*I1[416] - (oneo4zn)*I4[416] - (threeo4zn)*I5[475];
*(vp++) = U01*I0[597] - U11*I3[597] + loo2p*I2[822]
        + (oneo2z)*I1[417] - (oneo4zn)*I4[417] - (twoo4zn)*I5[476];
*(vp++) = U01*I0[598] - U11*I3[598] + loo2p*I2[823]
        + (oneo2z)*I1[418] - (oneo4zn)*I4[418] - (oneo4zn)*I5[477];
*(vp++) = U01*I0[599] - U11*I3[599] + loo2p*I2[824]
        + (oneo2z)*I1[419] - (oneo4zn)*I4[419];
*(vp++) = U01*I0[600] - U11*I3[600] + loo2p*I2[825]
        + (oneo2z)*I1[420] - (oneo4zn)*I4[420] - (fiveo4zn)*I5[478];
*(vp++) = U01*I0[601] - U11*I3[601] + loo2p*I2[826]
        + (oneo2z)*I1[421] - (oneo4zn)*I4[421] - (fouro4zn)*I5[479];
*(vp++) = U01*I0[602] - U11*I3[602] + loo2p*I2[827]
        + (oneo2z)*I1[422] - (oneo4zn)*I4[422] - (threeo4zn)*I5[480];
*(vp++) = U01*I0[603] - U11*I3[603] + loo2p*I2[828]
        + (oneo2z)*I1[423] - (oneo4zn)*I4[423] - (twoo4zn)*I5[481];
*(vp++) = U01*I0[604] - U11*I3[604] + loo2p*I2[829]
        + (oneo2z)*I1[424] - (oneo4zn)*I4[424] - (oneo4zn)*I5[482];
*(vp++) = U01*I0[605] - U11*I3[605] + loo2p*I2[830]
        + (oneo2z)*I1[425] - (oneo4zn)*I4[425];
*(vp++) = U01*I0[606] - U11*I3[606] + loo2p*I2[831]
        + (oneo2z)*I1[426] - (oneo4zn)*I4[426] - (sixo4zn)*I5[483];
*(vp++) = U01*I0[607] - U11*I3[607] + loo2p*I2[832]
        + (oneo2z)*I1[427] - (oneo4zn)*I4[427] - (fiveo4zn)*I5[484];
*(vp++) = U01*I0[608] - U11*I3[608] + loo2p*I2[833]
        + (oneo2z)*I1[428] - (oneo4zn)*I4[428] - (fouro4zn)*I5[485];
*(vp++) = U01*I0[609] - U11*I3[609] + loo2p*I2[834]
        + (oneo2z)*I1[429] - (oneo4zn)*I4[429] - (threeo4zn)*I5[486];
*(vp++) = U01*I0[610] - U11*I3[610] + loo2p*I2[835]
        + (oneo2z)*I1[430] - (oneo4zn)*I4[430] - (twoo4zn)*I5[487];
*(vp++) = U01*I0[611] - U11*I3[611] + loo2p*I2[836]
        + (oneo2z)*I1[431] - (oneo4zn)*I4[431] - (oneo4zn)*I5[488];
*(vp++) = U01*I0[612] - U11*I3[612] + loo2p*I2[837]
        + (oneo2z)*I1[432] - (oneo4zn)*I4[432];
*(vp++) = U01*I0[613] - U11*I3[613] + loo2p*I2[838]
        + (oneo2z)*I1[433] - (oneo4zn)*I4[433] - (seveno4zn)*I5[489];
*(vp++) = U01*I0[614] - U11*I3[614] + loo2p*I2[839]
        + (oneo2z)*I1[434] - (oneo4zn)*I4[434] - (sixo4zn)*I5[490];
*(vp++) = U01*I0[615] - U11*I3[615] + loo2p*I2[840]
        + (oneo2z)*I1[435] - (oneo4zn)*I4[435] - (fiveo4zn)*I5[491];
*(vp++) = U01*I0[616] - U11*I3[616] + loo2p*I2[841]
        + (oneo2z)*I1[436] - (oneo4zn)*I4[436] - (fouro4zn)*I5[492];
*(vp++) = U01*I0[617] - U11*I3[617] + loo2p*I2[842]
        + (oneo2z)*I1[437] - (oneo4zn)*I4[437] - (threeo4zn)*I5[493];
*(vp++) = U01*I0[618] - U11*I3[618] + loo2p*I2[843]
        + (oneo2z)*I1[438] - (oneo4zn)*I4[438] - (twoo4zn)*I5[494];
*(vp++) = U01*I0[619] - U11*I3[619] + loo2p*I2[844]
        + (oneo2z)*I1[439] - (oneo4zn)*I4[439] - (oneo4zn)*I5[495];
*(vp++) = U01*I0[620] - U11*I3[620] + loo2p*I2[845]
        + (oneo2z)*I1[440] - (oneo4zn)*I4[440];
*(vp++) = U01*I0[621] - U11*I3[621] + loo2p*I2[846]
        + (oneo2z)*I1[441] - (oneo4zn)*I4[441] - (eighto4zn)*I5[496];
*(vp++) = U01*I0[622] - U11*I3[622] + loo2p*I2[847]
        + (oneo2z)*I1[442] - (oneo4zn)*I4[442] - (seveno4zn)*I5[497];
*(vp++) = U01*I0[623] - U11*I3[623] + loo2p*I2[848]
        + (oneo2z)*I1[443] - (oneo4zn)*I4[443] - (sixo4zn)*I5[498];
*(vp++) = U01*I0[624] - U11*I3[624] + loo2p*I2[849]
        + (oneo2z)*I1[444] - (oneo4zn)*I4[444] - (fiveo4zn)*I5[499];
*(vp++) = U01*I0[625] - U11*I3[625] + loo2p*I2[850]
        + (oneo2z)*I1[445] - (oneo4zn)*I4[445] - (fouro4zn)*I5[500];
*(vp++) = U01*I0[626] - U11*I3[626] + loo2p*I2[851]
        + (oneo2z)*I1[446] - (oneo4zn)*I4[446] - (threeo4zn)*I5[501];
*(vp++) = U01*I0[627] - U11*I3[627] + loo2p*I2[852]
        + (oneo2z)*I1[447] - (oneo4zn)*I4[447] - (twoo4zn)*I5[502];
*(vp++) = U01*I0[628] - U11*I3[628] + loo2p*I2[853]
        + (oneo2z)*I1[448] - (oneo4zn)*I4[448] - (oneo4zn)*I5[503];
*(vp++) = U01*I0[629] - U11*I3[629] + loo2p*I2[854]
        + (oneo2z)*I1[449] - (oneo4zn)*I4[449];
*(vp++) = U01*I0[630] - U11*I3[630] + loo2p*I2[855];
*(vp++) = U01*I0[631] - U11*I3[631] + loo2p*I2[856] - (oneo4zn)*I5[504];
*(vp++) = U01*I0[632] - U11*I3[632] + loo2p*I2[857];
*(vp++) = U01*I0[633] - U11*I3[633] + loo2p*I2[858] - (twoo4zn)*I5[505];
*(vp++) = U01*I0[634] - U11*I3[634] + loo2p*I2[859] - (oneo4zn)*I5[506];
*(vp++) = U01*I0[635] - U11*I3[635] + loo2p*I2[860];
*(vp++) = U01*I0[636] - U11*I3[636] + loo2p*I2[861] - (threeo4zn)*I5[507];
*(vp++) = U01*I0[637] - U11*I3[637] + loo2p*I2[862] - (twoo4zn)*I5[508];
*(vp++) = U01*I0[638] - U11*I3[638] + loo2p*I2[863] - (oneo4zn)*I5[509];
*(vp++) = U01*I0[639] - U11*I3[639] + loo2p*I2[864];
*(vp++) = U01*I0[640] - U11*I3[640] + loo2p*I2[865] - (fouro4zn)*I5[510];
*(vp++) = U01*I0[641] - U11*I3[641] + loo2p*I2[866] - (threeo4zn)*I5[511];
*(vp++) = U01*I0[642] - U11*I3[642] + loo2p*I2[867] - (twoo4zn)*I5[512];
*(vp++) = U01*I0[643] - U11*I3[643] + loo2p*I2[868] - (oneo4zn)*I5[513];
*(vp++) = U01*I0[644] - U11*I3[644] + loo2p*I2[869];
*(vp++) = U01*I0[645] - U11*I3[645] + loo2p*I2[870] - (fiveo4zn)*I5[514];
*(vp++) = U01*I0[646] - U11*I3[646] + loo2p*I2[871] - (fouro4zn)*I5[515];
*(vp++) = U01*I0[647] - U11*I3[647] + loo2p*I2[872] - (threeo4zn)*I5[516];
*(vp++) = U01*I0[648] - U11*I3[648] + loo2p*I2[873] - (twoo4zn)*I5[517];
*(vp++) = U01*I0[649] - U11*I3[649] + loo2p*I2[874] - (oneo4zn)*I5[518];
*(vp++) = U01*I0[650] - U11*I3[650] + loo2p*I2[875];
*(vp++) = U01*I0[651] - U11*I3[651] + loo2p*I2[876] - (sixo4zn)*I5[519];
*(vp++) = U01*I0[652] - U11*I3[652] + loo2p*I2[877] - (fiveo4zn)*I5[520];
*(vp++) = U01*I0[653] - U11*I3[653] + loo2p*I2[878] - (fouro4zn)*I5[521];
*(vp++) = U01*I0[654] - U11*I3[654] + loo2p*I2[879] - (threeo4zn)*I5[522];
*(vp++) = U01*I0[655] - U11*I3[655] + loo2p*I2[880] - (twoo4zn)*I5[523];
*(vp++) = U01*I0[656] - U11*I3[656] + loo2p*I2[881] - (oneo4zn)*I5[524];
*(vp++) = U01*I0[657] - U11*I3[657] + loo2p*I2[882];
*(vp++) = U01*I0[658] - U11*I3[658] + loo2p*I2[883] - (seveno4zn)*I5[525];
*(vp++) = U01*I0[659] - U11*I3[659] + loo2p*I2[884] - (sixo4zn)*I5[526];
*(vp++) = U01*I0[660] - U11*I3[660] + loo2p*I2[885] - (fiveo4zn)*I5[527];
*(vp++) = U01*I0[661] - U11*I3[661] + loo2p*I2[886] - (fouro4zn)*I5[528];
*(vp++) = U01*I0[662] - U11*I3[662] + loo2p*I2[887] - (threeo4zn)*I5[529];
*(vp++) = U01*I0[663] - U11*I3[663] + loo2p*I2[888] - (twoo4zn)*I5[530];
*(vp++) = U01*I0[664] - U11*I3[664] + loo2p*I2[889] - (oneo4zn)*I5[531];
*(vp++) = U01*I0[665] - U11*I3[665] + loo2p*I2[890];
*(vp++) = U01*I0[666] - U11*I3[666] + loo2p*I2[891] - (eighto4zn)*I5[532];
*(vp++) = U01*I0[667] - U11*I3[667] + loo2p*I2[892] - (seveno4zn)*I5[533];
*(vp++) = U01*I0[668] - U11*I3[668] + loo2p*I2[893] - (sixo4zn)*I5[534];
*(vp++) = U01*I0[669] - U11*I3[669] + loo2p*I2[894] - (fiveo4zn)*I5[535];
*(vp++) = U01*I0[670] - U11*I3[670] + loo2p*I2[895] - (fouro4zn)*I5[536];
*(vp++) = U01*I0[671] - U11*I3[671] + loo2p*I2[896] - (threeo4zn)*I5[537];
*(vp++) = U01*I0[672] - U11*I3[672] + loo2p*I2[897] - (twoo4zn)*I5[538];
*(vp++) = U01*I0[673] - U11*I3[673] + loo2p*I2[898] - (oneo4zn)*I5[539];
*(vp++) = U01*I0[674] - U11*I3[674] + loo2p*I2[899];
*(vp++) = U02*I0[630] - U12*I3[630] + loo2p*I2[900]
        + (fouro2z)*I1[405] - (fouro4zn)*I4[405];
*(vp++) = U02*I0[631] - U12*I3[631] + loo2p*I2[901]
        + (fouro2z)*I1[406] - (fouro4zn)*I4[406];
*(vp++) = U02*I0[632] - U12*I3[632] + loo2p*I2[902]
        + (fouro2z)*I1[407] - (fouro4zn)*I4[407] - (oneo4zn)*I5[504];
*(vp++) = U02*I0[633] - U12*I3[633] + loo2p*I2[903]
        + (fouro2z)*I1[408] - (fouro4zn)*I4[408];
*(vp++) = U02*I0[634] - U12*I3[634] + loo2p*I2[904]
        + (fouro2z)*I1[409] - (fouro4zn)*I4[409] - (oneo4zn)*I5[505];
*(vp++) = U02*I0[635] - U12*I3[635] + loo2p*I2[905]
        + (fouro2z)*I1[410] - (fouro4zn)*I4[410] - (twoo4zn)*I5[506];
*(vp++) = U02*I0[636] - U12*I3[636] + loo2p*I2[906]
        + (fouro2z)*I1[411] - (fouro4zn)*I4[411];
*(vp++) = U02*I0[637] - U12*I3[637] + loo2p*I2[907]
        + (fouro2z)*I1[412] - (fouro4zn)*I4[412] - (oneo4zn)*I5[507];
*(vp++) = U02*I0[638] - U12*I3[638] + loo2p*I2[908]
        + (fouro2z)*I1[413] - (fouro4zn)*I4[413] - (twoo4zn)*I5[508];
*(vp++) = U02*I0[639] - U12*I3[639] + loo2p*I2[909]
        + (fouro2z)*I1[414] - (fouro4zn)*I4[414] - (threeo4zn)*I5[509];
*(vp++) = U02*I0[640] - U12*I3[640] + loo2p*I2[910]
        + (fouro2z)*I1[415] - (fouro4zn)*I4[415];
*(vp++) = U02*I0[641] - U12*I3[641] + loo2p*I2[911]
        + (fouro2z)*I1[416] - (fouro4zn)*I4[416] - (oneo4zn)*I5[510];
*(vp++) = U02*I0[642] - U12*I3[642] + loo2p*I2[912]
        + (fouro2z)*I1[417] - (fouro4zn)*I4[417] - (twoo4zn)*I5[511];
*(vp++) = U02*I0[643] - U12*I3[643] + loo2p*I2[913]
        + (fouro2z)*I1[418] - (fouro4zn)*I4[418] - (threeo4zn)*I5[512];
*(vp++) = U02*I0[644] - U12*I3[644] + loo2p*I2[914]
        + (fouro2z)*I1[419] - (fouro4zn)*I4[419] - (fouro4zn)*I5[513];
*(vp++) = U02*I0[645] - U12*I3[645] + loo2p*I2[915]
        + (fouro2z)*I1[420] - (fouro4zn)*I4[420];
*(vp++) = U02*I0[646] - U12*I3[646] + loo2p*I2[916]
        + (fouro2z)*I1[421] - (fouro4zn)*I4[421] - (oneo4zn)*I5[514];
*(vp++) = U02*I0[647] - U12*I3[647] + loo2p*I2[917]
        + (fouro2z)*I1[422] - (fouro4zn)*I4[422] - (twoo4zn)*I5[515];
*(vp++) = U02*I0[648] - U12*I3[648] + loo2p*I2[918]
        + (fouro2z)*I1[423] - (fouro4zn)*I4[423] - (threeo4zn)*I5[516];
*(vp++) = U02*I0[649] - U12*I3[649] + loo2p*I2[919]
        + (fouro2z)*I1[424] - (fouro4zn)*I4[424] - (fouro4zn)*I5[517];
*(vp++) = U02*I0[650] - U12*I3[650] + loo2p*I2[920]
        + (fouro2z)*I1[425] - (fouro4zn)*I4[425] - (fiveo4zn)*I5[518];
*(vp++) = U02*I0[651] - U12*I3[651] + loo2p*I2[921]
        + (fouro2z)*I1[426] - (fouro4zn)*I4[426];
*(vp++) = U02*I0[652] - U12*I3[652] + loo2p*I2[922]
        + (fouro2z)*I1[427] - (fouro4zn)*I4[427] - (oneo4zn)*I5[519];
*(vp++) = U02*I0[653] - U12*I3[653] + loo2p*I2[923]
        + (fouro2z)*I1[428] - (fouro4zn)*I4[428] - (twoo4zn)*I5[520];
*(vp++) = U02*I0[654] - U12*I3[654] + loo2p*I2[924]
        + (fouro2z)*I1[429] - (fouro4zn)*I4[429] - (threeo4zn)*I5[521];
*(vp++) = U02*I0[655] - U12*I3[655] + loo2p*I2[925]
        + (fouro2z)*I1[430] - (fouro4zn)*I4[430] - (fouro4zn)*I5[522];
*(vp++) = U02*I0[656] - U12*I3[656] + loo2p*I2[926]
        + (fouro2z)*I1[431] - (fouro4zn)*I4[431] - (fiveo4zn)*I5[523];
*(vp++) = U02*I0[657] - U12*I3[657] + loo2p*I2[927]
        + (fouro2z)*I1[432] - (fouro4zn)*I4[432] - (sixo4zn)*I5[524];
*(vp++) = U02*I0[658] - U12*I3[658] + loo2p*I2[928]
        + (fouro2z)*I1[433] - (fouro4zn)*I4[433];
*(vp++) = U02*I0[659] - U12*I3[659] + loo2p*I2[929]
        + (fouro2z)*I1[434] - (fouro4zn)*I4[434] - (oneo4zn)*I5[525];
*(vp++) = U02*I0[660] - U12*I3[660] + loo2p*I2[930]
        + (fouro2z)*I1[435] - (fouro4zn)*I4[435] - (twoo4zn)*I5[526];
*(vp++) = U02*I0[661] - U12*I3[661] + loo2p*I2[931]
        + (fouro2z)*I1[436] - (fouro4zn)*I4[436] - (threeo4zn)*I5[527];
*(vp++) = U02*I0[662] - U12*I3[662] + loo2p*I2[932]
        + (fouro2z)*I1[437] - (fouro4zn)*I4[437] - (fouro4zn)*I5[528];
*(vp++) = U02*I0[663] - U12*I3[663] + loo2p*I2[933]
        + (fouro2z)*I1[438] - (fouro4zn)*I4[438] - (fiveo4zn)*I5[529];
*(vp++) = U02*I0[664] - U12*I3[664] + loo2p*I2[934]
        + (fouro2z)*I1[439] - (fouro4zn)*I4[439] - (sixo4zn)*I5[530];
*(vp++) = U02*I0[665] - U12*I3[665] + loo2p*I2[935]
        + (fouro2z)*I1[440] - (fouro4zn)*I4[440] - (seveno4zn)*I5[531];
*(vp++) = U02*I0[666] - U12*I3[666] + loo2p*I2[936]
        + (fouro2z)*I1[441] - (fouro4zn)*I4[441];
*(vp++) = U02*I0[667] - U12*I3[667] + loo2p*I2[937]
        + (fouro2z)*I1[442] - (fouro4zn)*I4[442] - (oneo4zn)*I5[532];
*(vp++) = U02*I0[668] - U12*I3[668] + loo2p*I2[938]
        + (fouro2z)*I1[443] - (fouro4zn)*I4[443] - (twoo4zn)*I5[533];
*(vp++) = U02*I0[669] - U12*I3[669] + loo2p*I2[939]
        + (fouro2z)*I1[444] - (fouro4zn)*I4[444] - (threeo4zn)*I5[534];
*(vp++) = U02*I0[670] - U12*I3[670] + loo2p*I2[940]
        + (fouro2z)*I1[445] - (fouro4zn)*I4[445] - (fouro4zn)*I5[535];
*(vp++) = U02*I0[671] - U12*I3[671] + loo2p*I2[941]
        + (fouro2z)*I1[446] - (fouro4zn)*I4[446] - (fiveo4zn)*I5[536];
*(vp++) = U02*I0[672] - U12*I3[672] + loo2p*I2[942]
        + (fouro2z)*I1[447] - (fouro4zn)*I4[447] - (sixo4zn)*I5[537];
*(vp++) = U02*I0[673] - U12*I3[673] + loo2p*I2[943]
        + (fouro2z)*I1[448] - (fouro4zn)*I4[448] - (seveno4zn)*I5[538];
*(vp++) = U02*I0[674] - U12*I3[674] + loo2p*I2[944]
        + (fouro2z)*I1[449] - (fouro4zn)*I4[449] - (eighto4zn)*I5[539];
return vp;
}
