/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ds|[r12,T1]|ls) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t1_build_d0l0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 3.000000))*Data->oo2z;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[45] - I2[1])
          - U12*(I1[90] - I2[2])
          + (twozboz)*(I3[0] - AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[46] - I2[3])
          - U12*(I1[91] - I2[4])
          + (twozboz)*(I3[1] - AC0*I4[1]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[47] - I2[4])
          - U12*(I1[92] - I2[5])
          + (twozboz)*(I3[2] - AC0*I4[2]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[48] - I2[6])
          - U12*(I1[93] - I2[7])
          + (twozboz)*(I3[3] - AC0*I4[3]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[49] - I2[7])
          - U12*(I1[94] - I2[8])
          + (twozboz)*(I3[4] - AC0*I4[4]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[50] - I2[8])
          - U12*(I1[95] - I2[9])
          + (twozboz)*(I3[5] - AC0*I4[5]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[6])
          - U11*(I1[51] - I2[10])
          - U12*(I1[96] - I2[11])
          + (twozboz)*(I3[6] - AC0*I4[6]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[7])
          - U11*(I1[52] - I2[11])
          - U12*(I1[97] - I2[12])
          + (twozboz)*(I3[7] - AC0*I4[7]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[8])
          - U11*(I1[53] - I2[12])
          - U12*(I1[98] - I2[13])
          + (twozboz)*(I3[8] - AC0*I4[8]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[9])
          - U11*(I1[54] - I2[13])
          - U12*(I1[99] - I2[14])
          + (twozboz)*(I3[9] - AC0*I4[9]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[10])
          - U11*(I1[55] - I2[15])
          - U12*(I1[100] - I2[16])
          + (twozboz)*(I3[10] - AC0*I4[10]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[11])
          - U11*(I1[56] - I2[16])
          - U12*(I1[101] - I2[17])
          + (twozboz)*(I3[11] - AC0*I4[11]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[12])
          - U11*(I1[57] - I2[17])
          - U12*(I1[102] - I2[18])
          + (twozboz)*(I3[12] - AC0*I4[12]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[13])
          - U11*(I1[58] - I2[18])
          - U12*(I1[103] - I2[19])
          + (twozboz)*(I3[13] - AC0*I4[13]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[14])
          - U11*(I1[59] - I2[19])
          - U12*(I1[104] - I2[20])
          + (twozboz)*(I3[14] - AC0*I4[14]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[15])
          - U11*(I1[60] - I2[21])
          - U12*(I1[105] - I2[22])
          + (twozboz)*(I3[15] - AC0*I4[15]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[16])
          - U11*(I1[61] - I2[22])
          - U12*(I1[106] - I2[23])
          + (twozboz)*(I3[16] - AC0*I4[16]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[17])
          - U11*(I1[62] - I2[23])
          - U12*(I1[107] - I2[24])
          + (twozboz)*(I3[17] - AC0*I4[17]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[18])
          - U11*(I1[63] - I2[24])
          - U12*(I1[108] - I2[25])
          + (twozboz)*(I3[18] - AC0*I4[18]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[19])
          - U11*(I1[64] - I2[25])
          - U12*(I1[109] - I2[26])
          + (twozboz)*(I3[19] - AC0*I4[19]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[20])
          - U11*(I1[65] - I2[26])
          - U12*(I1[110] - I2[27])
          + (twozboz)*(I3[20] - AC0*I4[20]);
*(vp++) = U0*I0[21]
          - U10*(I1[21] - I2[21])
          - U11*(I1[66] - I2[28])
          - U12*(I1[111] - I2[29])
          + (twozboz)*(I3[21] - AC0*I4[21]);
*(vp++) = U0*I0[22]
          - U10*(I1[22] - I2[22])
          - U11*(I1[67] - I2[29])
          - U12*(I1[112] - I2[30])
          + (twozboz)*(I3[22] - AC0*I4[22]);
*(vp++) = U0*I0[23]
          - U10*(I1[23] - I2[23])
          - U11*(I1[68] - I2[30])
          - U12*(I1[113] - I2[31])
          + (twozboz)*(I3[23] - AC0*I4[23]);
*(vp++) = U0*I0[24]
          - U10*(I1[24] - I2[24])
          - U11*(I1[69] - I2[31])
          - U12*(I1[114] - I2[32])
          + (twozboz)*(I3[24] - AC0*I4[24]);
*(vp++) = U0*I0[25]
          - U10*(I1[25] - I2[25])
          - U11*(I1[70] - I2[32])
          - U12*(I1[115] - I2[33])
          + (twozboz)*(I3[25] - AC0*I4[25]);
*(vp++) = U0*I0[26]
          - U10*(I1[26] - I2[26])
          - U11*(I1[71] - I2[33])
          - U12*(I1[116] - I2[34])
          + (twozboz)*(I3[26] - AC0*I4[26]);
*(vp++) = U0*I0[27]
          - U10*(I1[27] - I2[27])
          - U11*(I1[72] - I2[34])
          - U12*(I1[117] - I2[35])
          + (twozboz)*(I3[27] - AC0*I4[27]);
*(vp++) = U0*I0[28]
          - U10*(I1[28] - I2[28])
          - U11*(I1[73] - I2[36])
          - U12*(I1[118] - I2[37])
          + (twozboz)*(I3[28] - AC0*I4[28]);
*(vp++) = U0*I0[29]
          - U10*(I1[29] - I2[29])
          - U11*(I1[74] - I2[37])
          - U12*(I1[119] - I2[38])
          + (twozboz)*(I3[29] - AC0*I4[29]);
*(vp++) = U0*I0[30]
          - U10*(I1[30] - I2[30])
          - U11*(I1[75] - I2[38])
          - U12*(I1[120] - I2[39])
          + (twozboz)*(I3[30] - AC0*I4[30]);
*(vp++) = U0*I0[31]
          - U10*(I1[31] - I2[31])
          - U11*(I1[76] - I2[39])
          - U12*(I1[121] - I2[40])
          + (twozboz)*(I3[31] - AC0*I4[31]);
*(vp++) = U0*I0[32]
          - U10*(I1[32] - I2[32])
          - U11*(I1[77] - I2[40])
          - U12*(I1[122] - I2[41])
          + (twozboz)*(I3[32] - AC0*I4[32]);
*(vp++) = U0*I0[33]
          - U10*(I1[33] - I2[33])
          - U11*(I1[78] - I2[41])
          - U12*(I1[123] - I2[42])
          + (twozboz)*(I3[33] - AC0*I4[33]);
*(vp++) = U0*I0[34]
          - U10*(I1[34] - I2[34])
          - U11*(I1[79] - I2[42])
          - U12*(I1[124] - I2[43])
          + (twozboz)*(I3[34] - AC0*I4[34]);
*(vp++) = U0*I0[35]
          - U10*(I1[35] - I2[35])
          - U11*(I1[80] - I2[43])
          - U12*(I1[125] - I2[44])
          + (twozboz)*(I3[35] - AC0*I4[35]);
*(vp++) = U0*I0[36]
          - U10*(I1[36] - I2[36])
          - U11*(I1[81] - I2[45])
          - U12*(I1[126] - I2[46])
          + (twozboz)*(I3[36] - AC0*I4[36]);
*(vp++) = U0*I0[37]
          - U10*(I1[37] - I2[37])
          - U11*(I1[82] - I2[46])
          - U12*(I1[127] - I2[47])
          + (twozboz)*(I3[37] - AC0*I4[37]);
*(vp++) = U0*I0[38]
          - U10*(I1[38] - I2[38])
          - U11*(I1[83] - I2[47])
          - U12*(I1[128] - I2[48])
          + (twozboz)*(I3[38] - AC0*I4[38]);
*(vp++) = U0*I0[39]
          - U10*(I1[39] - I2[39])
          - U11*(I1[84] - I2[48])
          - U12*(I1[129] - I2[49])
          + (twozboz)*(I3[39] - AC0*I4[39]);
*(vp++) = U0*I0[40]
          - U10*(I1[40] - I2[40])
          - U11*(I1[85] - I2[49])
          - U12*(I1[130] - I2[50])
          + (twozboz)*(I3[40] - AC0*I4[40]);
*(vp++) = U0*I0[41]
          - U10*(I1[41] - I2[41])
          - U11*(I1[86] - I2[50])
          - U12*(I1[131] - I2[51])
          + (twozboz)*(I3[41] - AC0*I4[41]);
*(vp++) = U0*I0[42]
          - U10*(I1[42] - I2[42])
          - U11*(I1[87] - I2[51])
          - U12*(I1[132] - I2[52])
          + (twozboz)*(I3[42] - AC0*I4[42]);
*(vp++) = U0*I0[43]
          - U10*(I1[43] - I2[43])
          - U11*(I1[88] - I2[52])
          - U12*(I1[133] - I2[53])
          + (twozboz)*(I3[43] - AC0*I4[43]);
*(vp++) = U0*I0[44]
          - U10*(I1[44] - I2[44])
          - U11*(I1[89] - I2[53])
          - U12*(I1[134] - I2[54])
          + (twozboz)*(I3[44] - AC0*I4[44]);
*(vp++) = U0*I0[45]
          - U10*(I1[45] - I2[55])
          - U11*(I1[135] - I2[56])
          - U12*(I1[180] - I2[57])
          + (onezboz)*(I3[55] - AC0*I4[45])
          + (onezboz)*(I3[1] - AC1*I4[0]);
*(vp++) = U0*I0[46]
          - U10*(I1[46] - I2[56])
          - U11*(I1[136] - I2[58])
          - U12*(I1[181] - I2[59])
          + (onezboz)*(I3[56] - AC0*I4[46])
          + (onezboz)*(I3[3] - AC1*I4[1]);
*(vp++) = U0*I0[47]
          - U10*(I1[47] - I2[57])
          - U11*(I1[137] - I2[59])
          - U12*(I1[182] - I2[60])
          + (onezboz)*(I3[57] - AC0*I4[47])
          + (onezboz)*(I3[4] - AC1*I4[2]);
*(vp++) = U0*I0[48]
          - U10*(I1[48] - I2[58])
          - U11*(I1[138] - I2[61])
          - U12*(I1[183] - I2[62])
          + (onezboz)*(I3[58] - AC0*I4[48])
          + (onezboz)*(I3[6] - AC1*I4[3]);
*(vp++) = U0*I0[49]
          - U10*(I1[49] - I2[59])
          - U11*(I1[139] - I2[62])
          - U12*(I1[184] - I2[63])
          + (onezboz)*(I3[59] - AC0*I4[49])
          + (onezboz)*(I3[7] - AC1*I4[4]);
*(vp++) = U0*I0[50]
          - U10*(I1[50] - I2[60])
          - U11*(I1[140] - I2[63])
          - U12*(I1[185] - I2[64])
          + (onezboz)*(I3[60] - AC0*I4[50])
          + (onezboz)*(I3[8] - AC1*I4[5]);
*(vp++) = U0*I0[51]
          - U10*(I1[51] - I2[61])
          - U11*(I1[141] - I2[65])
          - U12*(I1[186] - I2[66])
          + (onezboz)*(I3[61] - AC0*I4[51])
          + (onezboz)*(I3[10] - AC1*I4[6]);
*(vp++) = U0*I0[52]
          - U10*(I1[52] - I2[62])
          - U11*(I1[142] - I2[66])
          - U12*(I1[187] - I2[67])
          + (onezboz)*(I3[62] - AC0*I4[52])
          + (onezboz)*(I3[11] - AC1*I4[7]);
*(vp++) = U0*I0[53]
          - U10*(I1[53] - I2[63])
          - U11*(I1[143] - I2[67])
          - U12*(I1[188] - I2[68])
          + (onezboz)*(I3[63] - AC0*I4[53])
          + (onezboz)*(I3[12] - AC1*I4[8]);
*(vp++) = U0*I0[54]
          - U10*(I1[54] - I2[64])
          - U11*(I1[144] - I2[68])
          - U12*(I1[189] - I2[69])
          + (onezboz)*(I3[64] - AC0*I4[54])
          + (onezboz)*(I3[13] - AC1*I4[9]);
*(vp++) = U0*I0[55]
          - U10*(I1[55] - I2[65])
          - U11*(I1[145] - I2[70])
          - U12*(I1[190] - I2[71])
          + (onezboz)*(I3[65] - AC0*I4[55])
          + (onezboz)*(I3[15] - AC1*I4[10]);
*(vp++) = U0*I0[56]
          - U10*(I1[56] - I2[66])
          - U11*(I1[146] - I2[71])
          - U12*(I1[191] - I2[72])
          + (onezboz)*(I3[66] - AC0*I4[56])
          + (onezboz)*(I3[16] - AC1*I4[11]);
*(vp++) = U0*I0[57]
          - U10*(I1[57] - I2[67])
          - U11*(I1[147] - I2[72])
          - U12*(I1[192] - I2[73])
          + (onezboz)*(I3[67] - AC0*I4[57])
          + (onezboz)*(I3[17] - AC1*I4[12]);
*(vp++) = U0*I0[58]
          - U10*(I1[58] - I2[68])
          - U11*(I1[148] - I2[73])
          - U12*(I1[193] - I2[74])
          + (onezboz)*(I3[68] - AC0*I4[58])
          + (onezboz)*(I3[18] - AC1*I4[13]);
*(vp++) = U0*I0[59]
          - U10*(I1[59] - I2[69])
          - U11*(I1[149] - I2[74])
          - U12*(I1[194] - I2[75])
          + (onezboz)*(I3[69] - AC0*I4[59])
          + (onezboz)*(I3[19] - AC1*I4[14]);
*(vp++) = U0*I0[60]
          - U10*(I1[60] - I2[70])
          - U11*(I1[150] - I2[76])
          - U12*(I1[195] - I2[77])
          + (onezboz)*(I3[70] - AC0*I4[60])
          + (onezboz)*(I3[21] - AC1*I4[15]);
*(vp++) = U0*I0[61]
          - U10*(I1[61] - I2[71])
          - U11*(I1[151] - I2[77])
          - U12*(I1[196] - I2[78])
          + (onezboz)*(I3[71] - AC0*I4[61])
          + (onezboz)*(I3[22] - AC1*I4[16]);
*(vp++) = U0*I0[62]
          - U10*(I1[62] - I2[72])
          - U11*(I1[152] - I2[78])
          - U12*(I1[197] - I2[79])
          + (onezboz)*(I3[72] - AC0*I4[62])
          + (onezboz)*(I3[23] - AC1*I4[17]);
*(vp++) = U0*I0[63]
          - U10*(I1[63] - I2[73])
          - U11*(I1[153] - I2[79])
          - U12*(I1[198] - I2[80])
          + (onezboz)*(I3[73] - AC0*I4[63])
          + (onezboz)*(I3[24] - AC1*I4[18]);
*(vp++) = U0*I0[64]
          - U10*(I1[64] - I2[74])
          - U11*(I1[154] - I2[80])
          - U12*(I1[199] - I2[81])
          + (onezboz)*(I3[74] - AC0*I4[64])
          + (onezboz)*(I3[25] - AC1*I4[19]);
*(vp++) = U0*I0[65]
          - U10*(I1[65] - I2[75])
          - U11*(I1[155] - I2[81])
          - U12*(I1[200] - I2[82])
          + (onezboz)*(I3[75] - AC0*I4[65])
          + (onezboz)*(I3[26] - AC1*I4[20]);
*(vp++) = U0*I0[66]
          - U10*(I1[66] - I2[76])
          - U11*(I1[156] - I2[83])
          - U12*(I1[201] - I2[84])
          + (onezboz)*(I3[76] - AC0*I4[66])
          + (onezboz)*(I3[28] - AC1*I4[21]);
*(vp++) = U0*I0[67]
          - U10*(I1[67] - I2[77])
          - U11*(I1[157] - I2[84])
          - U12*(I1[202] - I2[85])
          + (onezboz)*(I3[77] - AC0*I4[67])
          + (onezboz)*(I3[29] - AC1*I4[22]);
*(vp++) = U0*I0[68]
          - U10*(I1[68] - I2[78])
          - U11*(I1[158] - I2[85])
          - U12*(I1[203] - I2[86])
          + (onezboz)*(I3[78] - AC0*I4[68])
          + (onezboz)*(I3[30] - AC1*I4[23]);
*(vp++) = U0*I0[69]
          - U10*(I1[69] - I2[79])
          - U11*(I1[159] - I2[86])
          - U12*(I1[204] - I2[87])
          + (onezboz)*(I3[79] - AC0*I4[69])
          + (onezboz)*(I3[31] - AC1*I4[24]);
*(vp++) = U0*I0[70]
          - U10*(I1[70] - I2[80])
          - U11*(I1[160] - I2[87])
          - U12*(I1[205] - I2[88])
          + (onezboz)*(I3[80] - AC0*I4[70])
          + (onezboz)*(I3[32] - AC1*I4[25]);
*(vp++) = U0*I0[71]
          - U10*(I1[71] - I2[81])
          - U11*(I1[161] - I2[88])
          - U12*(I1[206] - I2[89])
          + (onezboz)*(I3[81] - AC0*I4[71])
          + (onezboz)*(I3[33] - AC1*I4[26]);
*(vp++) = U0*I0[72]
          - U10*(I1[72] - I2[82])
          - U11*(I1[162] - I2[89])
          - U12*(I1[207] - I2[90])
          + (onezboz)*(I3[82] - AC0*I4[72])
          + (onezboz)*(I3[34] - AC1*I4[27]);
*(vp++) = U0*I0[73]
          - U10*(I1[73] - I2[83])
          - U11*(I1[163] - I2[91])
          - U12*(I1[208] - I2[92])
          + (onezboz)*(I3[83] - AC0*I4[73])
          + (onezboz)*(I3[36] - AC1*I4[28]);
*(vp++) = U0*I0[74]
          - U10*(I1[74] - I2[84])
          - U11*(I1[164] - I2[92])
          - U12*(I1[209] - I2[93])
          + (onezboz)*(I3[84] - AC0*I4[74])
          + (onezboz)*(I3[37] - AC1*I4[29]);
*(vp++) = U0*I0[75]
          - U10*(I1[75] - I2[85])
          - U11*(I1[165] - I2[93])
          - U12*(I1[210] - I2[94])
          + (onezboz)*(I3[85] - AC0*I4[75])
          + (onezboz)*(I3[38] - AC1*I4[30]);
*(vp++) = U0*I0[76]
          - U10*(I1[76] - I2[86])
          - U11*(I1[166] - I2[94])
          - U12*(I1[211] - I2[95])
          + (onezboz)*(I3[86] - AC0*I4[76])
          + (onezboz)*(I3[39] - AC1*I4[31]);
*(vp++) = U0*I0[77]
          - U10*(I1[77] - I2[87])
          - U11*(I1[167] - I2[95])
          - U12*(I1[212] - I2[96])
          + (onezboz)*(I3[87] - AC0*I4[77])
          + (onezboz)*(I3[40] - AC1*I4[32]);
*(vp++) = U0*I0[78]
          - U10*(I1[78] - I2[88])
          - U11*(I1[168] - I2[96])
          - U12*(I1[213] - I2[97])
          + (onezboz)*(I3[88] - AC0*I4[78])
          + (onezboz)*(I3[41] - AC1*I4[33]);
*(vp++) = U0*I0[79]
          - U10*(I1[79] - I2[89])
          - U11*(I1[169] - I2[97])
          - U12*(I1[214] - I2[98])
          + (onezboz)*(I3[89] - AC0*I4[79])
          + (onezboz)*(I3[42] - AC1*I4[34]);
*(vp++) = U0*I0[80]
          - U10*(I1[80] - I2[90])
          - U11*(I1[170] - I2[98])
          - U12*(I1[215] - I2[99])
          + (onezboz)*(I3[90] - AC0*I4[80])
          + (onezboz)*(I3[43] - AC1*I4[35]);
*(vp++) = U0*I0[81]
          - U10*(I1[81] - I2[91])
          - U11*(I1[171] - I2[100])
          - U12*(I1[216] - I2[101])
          + (onezboz)*(I3[91] - AC0*I4[81])
          + (onezboz)*(I3[45] - AC1*I4[36]);
*(vp++) = U0*I0[82]
          - U10*(I1[82] - I2[92])
          - U11*(I1[172] - I2[101])
          - U12*(I1[217] - I2[102])
          + (onezboz)*(I3[92] - AC0*I4[82])
          + (onezboz)*(I3[46] - AC1*I4[37]);
*(vp++) = U0*I0[83]
          - U10*(I1[83] - I2[93])
          - U11*(I1[173] - I2[102])
          - U12*(I1[218] - I2[103])
          + (onezboz)*(I3[93] - AC0*I4[83])
          + (onezboz)*(I3[47] - AC1*I4[38]);
*(vp++) = U0*I0[84]
          - U10*(I1[84] - I2[94])
          - U11*(I1[174] - I2[103])
          - U12*(I1[219] - I2[104])
          + (onezboz)*(I3[94] - AC0*I4[84])
          + (onezboz)*(I3[48] - AC1*I4[39]);
*(vp++) = U0*I0[85]
          - U10*(I1[85] - I2[95])
          - U11*(I1[175] - I2[104])
          - U12*(I1[220] - I2[105])
          + (onezboz)*(I3[95] - AC0*I4[85])
          + (onezboz)*(I3[49] - AC1*I4[40]);
*(vp++) = U0*I0[86]
          - U10*(I1[86] - I2[96])
          - U11*(I1[176] - I2[105])
          - U12*(I1[221] - I2[106])
          + (onezboz)*(I3[96] - AC0*I4[86])
          + (onezboz)*(I3[50] - AC1*I4[41]);
*(vp++) = U0*I0[87]
          - U10*(I1[87] - I2[97])
          - U11*(I1[177] - I2[106])
          - U12*(I1[222] - I2[107])
          + (onezboz)*(I3[97] - AC0*I4[87])
          + (onezboz)*(I3[51] - AC1*I4[42]);
*(vp++) = U0*I0[88]
          - U10*(I1[88] - I2[98])
          - U11*(I1[178] - I2[107])
          - U12*(I1[223] - I2[108])
          + (onezboz)*(I3[98] - AC0*I4[88])
          + (onezboz)*(I3[52] - AC1*I4[43]);
*(vp++) = U0*I0[89]
          - U10*(I1[89] - I2[99])
          - U11*(I1[179] - I2[108])
          - U12*(I1[224] - I2[109])
          + (onezboz)*(I3[99] - AC0*I4[89])
          + (onezboz)*(I3[53] - AC1*I4[44]);
*(vp++) = U0*I0[90]
          - U10*(I1[90] - I2[110])
          - U11*(I1[180] - I2[111])
          - U12*(I1[225] - I2[112])
          + (onezboz)*(I3[110] - AC0*I4[90])
          + (onezboz)*(I3[2] - AC2*I4[0]);
*(vp++) = U0*I0[91]
          - U10*(I1[91] - I2[111])
          - U11*(I1[181] - I2[113])
          - U12*(I1[226] - I2[114])
          + (onezboz)*(I3[111] - AC0*I4[91])
          + (onezboz)*(I3[4] - AC2*I4[1]);
*(vp++) = U0*I0[92]
          - U10*(I1[92] - I2[112])
          - U11*(I1[182] - I2[114])
          - U12*(I1[227] - I2[115])
          + (onezboz)*(I3[112] - AC0*I4[92])
          + (onezboz)*(I3[5] - AC2*I4[2]);
*(vp++) = U0*I0[93]
          - U10*(I1[93] - I2[113])
          - U11*(I1[183] - I2[116])
          - U12*(I1[228] - I2[117])
          + (onezboz)*(I3[113] - AC0*I4[93])
          + (onezboz)*(I3[7] - AC2*I4[3]);
*(vp++) = U0*I0[94]
          - U10*(I1[94] - I2[114])
          - U11*(I1[184] - I2[117])
          - U12*(I1[229] - I2[118])
          + (onezboz)*(I3[114] - AC0*I4[94])
          + (onezboz)*(I3[8] - AC2*I4[4]);
*(vp++) = U0*I0[95]
          - U10*(I1[95] - I2[115])
          - U11*(I1[185] - I2[118])
          - U12*(I1[230] - I2[119])
          + (onezboz)*(I3[115] - AC0*I4[95])
          + (onezboz)*(I3[9] - AC2*I4[5]);
*(vp++) = U0*I0[96]
          - U10*(I1[96] - I2[116])
          - U11*(I1[186] - I2[120])
          - U12*(I1[231] - I2[121])
          + (onezboz)*(I3[116] - AC0*I4[96])
          + (onezboz)*(I3[11] - AC2*I4[6]);
*(vp++) = U0*I0[97]
          - U10*(I1[97] - I2[117])
          - U11*(I1[187] - I2[121])
          - U12*(I1[232] - I2[122])
          + (onezboz)*(I3[117] - AC0*I4[97])
          + (onezboz)*(I3[12] - AC2*I4[7]);
*(vp++) = U0*I0[98]
          - U10*(I1[98] - I2[118])
          - U11*(I1[188] - I2[122])
          - U12*(I1[233] - I2[123])
          + (onezboz)*(I3[118] - AC0*I4[98])
          + (onezboz)*(I3[13] - AC2*I4[8]);
*(vp++) = U0*I0[99]
          - U10*(I1[99] - I2[119])
          - U11*(I1[189] - I2[123])
          - U12*(I1[234] - I2[124])
          + (onezboz)*(I3[119] - AC0*I4[99])
          + (onezboz)*(I3[14] - AC2*I4[9]);
*(vp++) = U0*I0[100]
          - U10*(I1[100] - I2[120])
          - U11*(I1[190] - I2[125])
          - U12*(I1[235] - I2[126])
          + (onezboz)*(I3[120] - AC0*I4[100])
          + (onezboz)*(I3[16] - AC2*I4[10]);
*(vp++) = U0*I0[101]
          - U10*(I1[101] - I2[121])
          - U11*(I1[191] - I2[126])
          - U12*(I1[236] - I2[127])
          + (onezboz)*(I3[121] - AC0*I4[101])
          + (onezboz)*(I3[17] - AC2*I4[11]);
*(vp++) = U0*I0[102]
          - U10*(I1[102] - I2[122])
          - U11*(I1[192] - I2[127])
          - U12*(I1[237] - I2[128])
          + (onezboz)*(I3[122] - AC0*I4[102])
          + (onezboz)*(I3[18] - AC2*I4[12]);
*(vp++) = U0*I0[103]
          - U10*(I1[103] - I2[123])
          - U11*(I1[193] - I2[128])
          - U12*(I1[238] - I2[129])
          + (onezboz)*(I3[123] - AC0*I4[103])
          + (onezboz)*(I3[19] - AC2*I4[13]);
*(vp++) = U0*I0[104]
          - U10*(I1[104] - I2[124])
          - U11*(I1[194] - I2[129])
          - U12*(I1[239] - I2[130])
          + (onezboz)*(I3[124] - AC0*I4[104])
          + (onezboz)*(I3[20] - AC2*I4[14]);
*(vp++) = U0*I0[105]
          - U10*(I1[105] - I2[125])
          - U11*(I1[195] - I2[131])
          - U12*(I1[240] - I2[132])
          + (onezboz)*(I3[125] - AC0*I4[105])
          + (onezboz)*(I3[22] - AC2*I4[15]);
*(vp++) = U0*I0[106]
          - U10*(I1[106] - I2[126])
          - U11*(I1[196] - I2[132])
          - U12*(I1[241] - I2[133])
          + (onezboz)*(I3[126] - AC0*I4[106])
          + (onezboz)*(I3[23] - AC2*I4[16]);
*(vp++) = U0*I0[107]
          - U10*(I1[107] - I2[127])
          - U11*(I1[197] - I2[133])
          - U12*(I1[242] - I2[134])
          + (onezboz)*(I3[127] - AC0*I4[107])
          + (onezboz)*(I3[24] - AC2*I4[17]);
*(vp++) = U0*I0[108]
          - U10*(I1[108] - I2[128])
          - U11*(I1[198] - I2[134])
          - U12*(I1[243] - I2[135])
          + (onezboz)*(I3[128] - AC0*I4[108])
          + (onezboz)*(I3[25] - AC2*I4[18]);
*(vp++) = U0*I0[109]
          - U10*(I1[109] - I2[129])
          - U11*(I1[199] - I2[135])
          - U12*(I1[244] - I2[136])
          + (onezboz)*(I3[129] - AC0*I4[109])
          + (onezboz)*(I3[26] - AC2*I4[19]);
*(vp++) = U0*I0[110]
          - U10*(I1[110] - I2[130])
          - U11*(I1[200] - I2[136])
          - U12*(I1[245] - I2[137])
          + (onezboz)*(I3[130] - AC0*I4[110])
          + (onezboz)*(I3[27] - AC2*I4[20]);
*(vp++) = U0*I0[111]
          - U10*(I1[111] - I2[131])
          - U11*(I1[201] - I2[138])
          - U12*(I1[246] - I2[139])
          + (onezboz)*(I3[131] - AC0*I4[111])
          + (onezboz)*(I3[29] - AC2*I4[21]);
*(vp++) = U0*I0[112]
          - U10*(I1[112] - I2[132])
          - U11*(I1[202] - I2[139])
          - U12*(I1[247] - I2[140])
          + (onezboz)*(I3[132] - AC0*I4[112])
          + (onezboz)*(I3[30] - AC2*I4[22]);
*(vp++) = U0*I0[113]
          - U10*(I1[113] - I2[133])
          - U11*(I1[203] - I2[140])
          - U12*(I1[248] - I2[141])
          + (onezboz)*(I3[133] - AC0*I4[113])
          + (onezboz)*(I3[31] - AC2*I4[23]);
*(vp++) = U0*I0[114]
          - U10*(I1[114] - I2[134])
          - U11*(I1[204] - I2[141])
          - U12*(I1[249] - I2[142])
          + (onezboz)*(I3[134] - AC0*I4[114])
          + (onezboz)*(I3[32] - AC2*I4[24]);
*(vp++) = U0*I0[115]
          - U10*(I1[115] - I2[135])
          - U11*(I1[205] - I2[142])
          - U12*(I1[250] - I2[143])
          + (onezboz)*(I3[135] - AC0*I4[115])
          + (onezboz)*(I3[33] - AC2*I4[25]);
*(vp++) = U0*I0[116]
          - U10*(I1[116] - I2[136])
          - U11*(I1[206] - I2[143])
          - U12*(I1[251] - I2[144])
          + (onezboz)*(I3[136] - AC0*I4[116])
          + (onezboz)*(I3[34] - AC2*I4[26]);
*(vp++) = U0*I0[117]
          - U10*(I1[117] - I2[137])
          - U11*(I1[207] - I2[144])
          - U12*(I1[252] - I2[145])
          + (onezboz)*(I3[137] - AC0*I4[117])
          + (onezboz)*(I3[35] - AC2*I4[27]);
*(vp++) = U0*I0[118]
          - U10*(I1[118] - I2[138])
          - U11*(I1[208] - I2[146])
          - U12*(I1[253] - I2[147])
          + (onezboz)*(I3[138] - AC0*I4[118])
          + (onezboz)*(I3[37] - AC2*I4[28]);
*(vp++) = U0*I0[119]
          - U10*(I1[119] - I2[139])
          - U11*(I1[209] - I2[147])
          - U12*(I1[254] - I2[148])
          + (onezboz)*(I3[139] - AC0*I4[119])
          + (onezboz)*(I3[38] - AC2*I4[29]);
*(vp++) = U0*I0[120]
          - U10*(I1[120] - I2[140])
          - U11*(I1[210] - I2[148])
          - U12*(I1[255] - I2[149])
          + (onezboz)*(I3[140] - AC0*I4[120])
          + (onezboz)*(I3[39] - AC2*I4[30]);
*(vp++) = U0*I0[121]
          - U10*(I1[121] - I2[141])
          - U11*(I1[211] - I2[149])
          - U12*(I1[256] - I2[150])
          + (onezboz)*(I3[141] - AC0*I4[121])
          + (onezboz)*(I3[40] - AC2*I4[31]);
*(vp++) = U0*I0[122]
          - U10*(I1[122] - I2[142])
          - U11*(I1[212] - I2[150])
          - U12*(I1[257] - I2[151])
          + (onezboz)*(I3[142] - AC0*I4[122])
          + (onezboz)*(I3[41] - AC2*I4[32]);
*(vp++) = U0*I0[123]
          - U10*(I1[123] - I2[143])
          - U11*(I1[213] - I2[151])
          - U12*(I1[258] - I2[152])
          + (onezboz)*(I3[143] - AC0*I4[123])
          + (onezboz)*(I3[42] - AC2*I4[33]);
*(vp++) = U0*I0[124]
          - U10*(I1[124] - I2[144])
          - U11*(I1[214] - I2[152])
          - U12*(I1[259] - I2[153])
          + (onezboz)*(I3[144] - AC0*I4[124])
          + (onezboz)*(I3[43] - AC2*I4[34]);
*(vp++) = U0*I0[125]
          - U10*(I1[125] - I2[145])
          - U11*(I1[215] - I2[153])
          - U12*(I1[260] - I2[154])
          + (onezboz)*(I3[145] - AC0*I4[125])
          + (onezboz)*(I3[44] - AC2*I4[35]);
*(vp++) = U0*I0[126]
          - U10*(I1[126] - I2[146])
          - U11*(I1[216] - I2[155])
          - U12*(I1[261] - I2[156])
          + (onezboz)*(I3[146] - AC0*I4[126])
          + (onezboz)*(I3[46] - AC2*I4[36]);
*(vp++) = U0*I0[127]
          - U10*(I1[127] - I2[147])
          - U11*(I1[217] - I2[156])
          - U12*(I1[262] - I2[157])
          + (onezboz)*(I3[147] - AC0*I4[127])
          + (onezboz)*(I3[47] - AC2*I4[37]);
*(vp++) = U0*I0[128]
          - U10*(I1[128] - I2[148])
          - U11*(I1[218] - I2[157])
          - U12*(I1[263] - I2[158])
          + (onezboz)*(I3[148] - AC0*I4[128])
          + (onezboz)*(I3[48] - AC2*I4[38]);
*(vp++) = U0*I0[129]
          - U10*(I1[129] - I2[149])
          - U11*(I1[219] - I2[158])
          - U12*(I1[264] - I2[159])
          + (onezboz)*(I3[149] - AC0*I4[129])
          + (onezboz)*(I3[49] - AC2*I4[39]);
*(vp++) = U0*I0[130]
          - U10*(I1[130] - I2[150])
          - U11*(I1[220] - I2[159])
          - U12*(I1[265] - I2[160])
          + (onezboz)*(I3[150] - AC0*I4[130])
          + (onezboz)*(I3[50] - AC2*I4[40]);
*(vp++) = U0*I0[131]
          - U10*(I1[131] - I2[151])
          - U11*(I1[221] - I2[160])
          - U12*(I1[266] - I2[161])
          + (onezboz)*(I3[151] - AC0*I4[131])
          + (onezboz)*(I3[51] - AC2*I4[41]);
*(vp++) = U0*I0[132]
          - U10*(I1[132] - I2[152])
          - U11*(I1[222] - I2[161])
          - U12*(I1[267] - I2[162])
          + (onezboz)*(I3[152] - AC0*I4[132])
          + (onezboz)*(I3[52] - AC2*I4[42]);
*(vp++) = U0*I0[133]
          - U10*(I1[133] - I2[153])
          - U11*(I1[223] - I2[162])
          - U12*(I1[268] - I2[163])
          + (onezboz)*(I3[153] - AC0*I4[133])
          + (onezboz)*(I3[53] - AC2*I4[43]);
*(vp++) = U0*I0[134]
          - U10*(I1[134] - I2[154])
          - U11*(I1[224] - I2[163])
          - U12*(I1[269] - I2[164])
          + (onezboz)*(I3[154] - AC0*I4[134])
          + (onezboz)*(I3[54] - AC2*I4[44]);
*(vp++) = U0*I0[135]
          - U10*(I1[135] - I2[165])
          - U11*(I1[270] - I2[166])
          - U12*(I1[315] - I2[167])
          + (twozboz)*(I3[56] - AC1*I4[45]);
*(vp++) = U0*I0[136]
          - U10*(I1[136] - I2[166])
          - U11*(I1[271] - I2[168])
          - U12*(I1[316] - I2[169])
          + (twozboz)*(I3[58] - AC1*I4[46]);
*(vp++) = U0*I0[137]
          - U10*(I1[137] - I2[167])
          - U11*(I1[272] - I2[169])
          - U12*(I1[317] - I2[170])
          + (twozboz)*(I3[59] - AC1*I4[47]);
*(vp++) = U0*I0[138]
          - U10*(I1[138] - I2[168])
          - U11*(I1[273] - I2[171])
          - U12*(I1[318] - I2[172])
          + (twozboz)*(I3[61] - AC1*I4[48]);
*(vp++) = U0*I0[139]
          - U10*(I1[139] - I2[169])
          - U11*(I1[274] - I2[172])
          - U12*(I1[319] - I2[173])
          + (twozboz)*(I3[62] - AC1*I4[49]);
*(vp++) = U0*I0[140]
          - U10*(I1[140] - I2[170])
          - U11*(I1[275] - I2[173])
          - U12*(I1[320] - I2[174])
          + (twozboz)*(I3[63] - AC1*I4[50]);
*(vp++) = U0*I0[141]
          - U10*(I1[141] - I2[171])
          - U11*(I1[276] - I2[175])
          - U12*(I1[321] - I2[176])
          + (twozboz)*(I3[65] - AC1*I4[51]);
*(vp++) = U0*I0[142]
          - U10*(I1[142] - I2[172])
          - U11*(I1[277] - I2[176])
          - U12*(I1[322] - I2[177])
          + (twozboz)*(I3[66] - AC1*I4[52]);
*(vp++) = U0*I0[143]
          - U10*(I1[143] - I2[173])
          - U11*(I1[278] - I2[177])
          - U12*(I1[323] - I2[178])
          + (twozboz)*(I3[67] - AC1*I4[53]);
*(vp++) = U0*I0[144]
          - U10*(I1[144] - I2[174])
          - U11*(I1[279] - I2[178])
          - U12*(I1[324] - I2[179])
          + (twozboz)*(I3[68] - AC1*I4[54]);
*(vp++) = U0*I0[145]
          - U10*(I1[145] - I2[175])
          - U11*(I1[280] - I2[180])
          - U12*(I1[325] - I2[181])
          + (twozboz)*(I3[70] - AC1*I4[55]);
*(vp++) = U0*I0[146]
          - U10*(I1[146] - I2[176])
          - U11*(I1[281] - I2[181])
          - U12*(I1[326] - I2[182])
          + (twozboz)*(I3[71] - AC1*I4[56]);
*(vp++) = U0*I0[147]
          - U10*(I1[147] - I2[177])
          - U11*(I1[282] - I2[182])
          - U12*(I1[327] - I2[183])
          + (twozboz)*(I3[72] - AC1*I4[57]);
*(vp++) = U0*I0[148]
          - U10*(I1[148] - I2[178])
          - U11*(I1[283] - I2[183])
          - U12*(I1[328] - I2[184])
          + (twozboz)*(I3[73] - AC1*I4[58]);
*(vp++) = U0*I0[149]
          - U10*(I1[149] - I2[179])
          - U11*(I1[284] - I2[184])
          - U12*(I1[329] - I2[185])
          + (twozboz)*(I3[74] - AC1*I4[59]);
*(vp++) = U0*I0[150]
          - U10*(I1[150] - I2[180])
          - U11*(I1[285] - I2[186])
          - U12*(I1[330] - I2[187])
          + (twozboz)*(I3[76] - AC1*I4[60]);
*(vp++) = U0*I0[151]
          - U10*(I1[151] - I2[181])
          - U11*(I1[286] - I2[187])
          - U12*(I1[331] - I2[188])
          + (twozboz)*(I3[77] - AC1*I4[61]);
*(vp++) = U0*I0[152]
          - U10*(I1[152] - I2[182])
          - U11*(I1[287] - I2[188])
          - U12*(I1[332] - I2[189])
          + (twozboz)*(I3[78] - AC1*I4[62]);
*(vp++) = U0*I0[153]
          - U10*(I1[153] - I2[183])
          - U11*(I1[288] - I2[189])
          - U12*(I1[333] - I2[190])
          + (twozboz)*(I3[79] - AC1*I4[63]);
*(vp++) = U0*I0[154]
          - U10*(I1[154] - I2[184])
          - U11*(I1[289] - I2[190])
          - U12*(I1[334] - I2[191])
          + (twozboz)*(I3[80] - AC1*I4[64]);
*(vp++) = U0*I0[155]
          - U10*(I1[155] - I2[185])
          - U11*(I1[290] - I2[191])
          - U12*(I1[335] - I2[192])
          + (twozboz)*(I3[81] - AC1*I4[65]);
*(vp++) = U0*I0[156]
          - U10*(I1[156] - I2[186])
          - U11*(I1[291] - I2[193])
          - U12*(I1[336] - I2[194])
          + (twozboz)*(I3[83] - AC1*I4[66]);
*(vp++) = U0*I0[157]
          - U10*(I1[157] - I2[187])
          - U11*(I1[292] - I2[194])
          - U12*(I1[337] - I2[195])
          + (twozboz)*(I3[84] - AC1*I4[67]);
*(vp++) = U0*I0[158]
          - U10*(I1[158] - I2[188])
          - U11*(I1[293] - I2[195])
          - U12*(I1[338] - I2[196])
          + (twozboz)*(I3[85] - AC1*I4[68]);
*(vp++) = U0*I0[159]
          - U10*(I1[159] - I2[189])
          - U11*(I1[294] - I2[196])
          - U12*(I1[339] - I2[197])
          + (twozboz)*(I3[86] - AC1*I4[69]);
*(vp++) = U0*I0[160]
          - U10*(I1[160] - I2[190])
          - U11*(I1[295] - I2[197])
          - U12*(I1[340] - I2[198])
          + (twozboz)*(I3[87] - AC1*I4[70]);
*(vp++) = U0*I0[161]
          - U10*(I1[161] - I2[191])
          - U11*(I1[296] - I2[198])
          - U12*(I1[341] - I2[199])
          + (twozboz)*(I3[88] - AC1*I4[71]);
*(vp++) = U0*I0[162]
          - U10*(I1[162] - I2[192])
          - U11*(I1[297] - I2[199])
          - U12*(I1[342] - I2[200])
          + (twozboz)*(I3[89] - AC1*I4[72]);
*(vp++) = U0*I0[163]
          - U10*(I1[163] - I2[193])
          - U11*(I1[298] - I2[201])
          - U12*(I1[343] - I2[202])
          + (twozboz)*(I3[91] - AC1*I4[73]);
*(vp++) = U0*I0[164]
          - U10*(I1[164] - I2[194])
          - U11*(I1[299] - I2[202])
          - U12*(I1[344] - I2[203])
          + (twozboz)*(I3[92] - AC1*I4[74]);
*(vp++) = U0*I0[165]
          - U10*(I1[165] - I2[195])
          - U11*(I1[300] - I2[203])
          - U12*(I1[345] - I2[204])
          + (twozboz)*(I3[93] - AC1*I4[75]);
*(vp++) = U0*I0[166]
          - U10*(I1[166] - I2[196])
          - U11*(I1[301] - I2[204])
          - U12*(I1[346] - I2[205])
          + (twozboz)*(I3[94] - AC1*I4[76]);
*(vp++) = U0*I0[167]
          - U10*(I1[167] - I2[197])
          - U11*(I1[302] - I2[205])
          - U12*(I1[347] - I2[206])
          + (twozboz)*(I3[95] - AC1*I4[77]);
*(vp++) = U0*I0[168]
          - U10*(I1[168] - I2[198])
          - U11*(I1[303] - I2[206])
          - U12*(I1[348] - I2[207])
          + (twozboz)*(I3[96] - AC1*I4[78]);
*(vp++) = U0*I0[169]
          - U10*(I1[169] - I2[199])
          - U11*(I1[304] - I2[207])
          - U12*(I1[349] - I2[208])
          + (twozboz)*(I3[97] - AC1*I4[79]);
*(vp++) = U0*I0[170]
          - U10*(I1[170] - I2[200])
          - U11*(I1[305] - I2[208])
          - U12*(I1[350] - I2[209])
          + (twozboz)*(I3[98] - AC1*I4[80]);
*(vp++) = U0*I0[171]
          - U10*(I1[171] - I2[201])
          - U11*(I1[306] - I2[210])
          - U12*(I1[351] - I2[211])
          + (twozboz)*(I3[100] - AC1*I4[81]);
*(vp++) = U0*I0[172]
          - U10*(I1[172] - I2[202])
          - U11*(I1[307] - I2[211])
          - U12*(I1[352] - I2[212])
          + (twozboz)*(I3[101] - AC1*I4[82]);
*(vp++) = U0*I0[173]
          - U10*(I1[173] - I2[203])
          - U11*(I1[308] - I2[212])
          - U12*(I1[353] - I2[213])
          + (twozboz)*(I3[102] - AC1*I4[83]);
*(vp++) = U0*I0[174]
          - U10*(I1[174] - I2[204])
          - U11*(I1[309] - I2[213])
          - U12*(I1[354] - I2[214])
          + (twozboz)*(I3[103] - AC1*I4[84]);
*(vp++) = U0*I0[175]
          - U10*(I1[175] - I2[205])
          - U11*(I1[310] - I2[214])
          - U12*(I1[355] - I2[215])
          + (twozboz)*(I3[104] - AC1*I4[85]);
*(vp++) = U0*I0[176]
          - U10*(I1[176] - I2[206])
          - U11*(I1[311] - I2[215])
          - U12*(I1[356] - I2[216])
          + (twozboz)*(I3[105] - AC1*I4[86]);
*(vp++) = U0*I0[177]
          - U10*(I1[177] - I2[207])
          - U11*(I1[312] - I2[216])
          - U12*(I1[357] - I2[217])
          + (twozboz)*(I3[106] - AC1*I4[87]);
*(vp++) = U0*I0[178]
          - U10*(I1[178] - I2[208])
          - U11*(I1[313] - I2[217])
          - U12*(I1[358] - I2[218])
          + (twozboz)*(I3[107] - AC1*I4[88]);
*(vp++) = U0*I0[179]
          - U10*(I1[179] - I2[209])
          - U11*(I1[314] - I2[218])
          - U12*(I1[359] - I2[219])
          + (twozboz)*(I3[108] - AC1*I4[89]);
*(vp++) = U0*I0[180]
          - U10*(I1[180] - I2[220])
          - U11*(I1[315] - I2[221])
          - U12*(I1[360] - I2[222])
          + (onezboz)*(I3[111] - AC1*I4[90])
          + (onezboz)*(I3[57] - AC2*I4[45]);
*(vp++) = U0*I0[181]
          - U10*(I1[181] - I2[221])
          - U11*(I1[316] - I2[223])
          - U12*(I1[361] - I2[224])
          + (onezboz)*(I3[113] - AC1*I4[91])
          + (onezboz)*(I3[59] - AC2*I4[46]);
*(vp++) = U0*I0[182]
          - U10*(I1[182] - I2[222])
          - U11*(I1[317] - I2[224])
          - U12*(I1[362] - I2[225])
          + (onezboz)*(I3[114] - AC1*I4[92])
          + (onezboz)*(I3[60] - AC2*I4[47]);
*(vp++) = U0*I0[183]
          - U10*(I1[183] - I2[223])
          - U11*(I1[318] - I2[226])
          - U12*(I1[363] - I2[227])
          + (onezboz)*(I3[116] - AC1*I4[93])
          + (onezboz)*(I3[62] - AC2*I4[48]);
*(vp++) = U0*I0[184]
          - U10*(I1[184] - I2[224])
          - U11*(I1[319] - I2[227])
          - U12*(I1[364] - I2[228])
          + (onezboz)*(I3[117] - AC1*I4[94])
          + (onezboz)*(I3[63] - AC2*I4[49]);
*(vp++) = U0*I0[185]
          - U10*(I1[185] - I2[225])
          - U11*(I1[320] - I2[228])
          - U12*(I1[365] - I2[229])
          + (onezboz)*(I3[118] - AC1*I4[95])
          + (onezboz)*(I3[64] - AC2*I4[50]);
*(vp++) = U0*I0[186]
          - U10*(I1[186] - I2[226])
          - U11*(I1[321] - I2[230])
          - U12*(I1[366] - I2[231])
          + (onezboz)*(I3[120] - AC1*I4[96])
          + (onezboz)*(I3[66] - AC2*I4[51]);
*(vp++) = U0*I0[187]
          - U10*(I1[187] - I2[227])
          - U11*(I1[322] - I2[231])
          - U12*(I1[367] - I2[232])
          + (onezboz)*(I3[121] - AC1*I4[97])
          + (onezboz)*(I3[67] - AC2*I4[52]);
*(vp++) = U0*I0[188]
          - U10*(I1[188] - I2[228])
          - U11*(I1[323] - I2[232])
          - U12*(I1[368] - I2[233])
          + (onezboz)*(I3[122] - AC1*I4[98])
          + (onezboz)*(I3[68] - AC2*I4[53]);
*(vp++) = U0*I0[189]
          - U10*(I1[189] - I2[229])
          - U11*(I1[324] - I2[233])
          - U12*(I1[369] - I2[234])
          + (onezboz)*(I3[123] - AC1*I4[99])
          + (onezboz)*(I3[69] - AC2*I4[54]);
*(vp++) = U0*I0[190]
          - U10*(I1[190] - I2[230])
          - U11*(I1[325] - I2[235])
          - U12*(I1[370] - I2[236])
          + (onezboz)*(I3[125] - AC1*I4[100])
          + (onezboz)*(I3[71] - AC2*I4[55]);
*(vp++) = U0*I0[191]
          - U10*(I1[191] - I2[231])
          - U11*(I1[326] - I2[236])
          - U12*(I1[371] - I2[237])
          + (onezboz)*(I3[126] - AC1*I4[101])
          + (onezboz)*(I3[72] - AC2*I4[56]);
*(vp++) = U0*I0[192]
          - U10*(I1[192] - I2[232])
          - U11*(I1[327] - I2[237])
          - U12*(I1[372] - I2[238])
          + (onezboz)*(I3[127] - AC1*I4[102])
          + (onezboz)*(I3[73] - AC2*I4[57]);
*(vp++) = U0*I0[193]
          - U10*(I1[193] - I2[233])
          - U11*(I1[328] - I2[238])
          - U12*(I1[373] - I2[239])
          + (onezboz)*(I3[128] - AC1*I4[103])
          + (onezboz)*(I3[74] - AC2*I4[58]);
*(vp++) = U0*I0[194]
          - U10*(I1[194] - I2[234])
          - U11*(I1[329] - I2[239])
          - U12*(I1[374] - I2[240])
          + (onezboz)*(I3[129] - AC1*I4[104])
          + (onezboz)*(I3[75] - AC2*I4[59]);
*(vp++) = U0*I0[195]
          - U10*(I1[195] - I2[235])
          - U11*(I1[330] - I2[241])
          - U12*(I1[375] - I2[242])
          + (onezboz)*(I3[131] - AC1*I4[105])
          + (onezboz)*(I3[77] - AC2*I4[60]);
*(vp++) = U0*I0[196]
          - U10*(I1[196] - I2[236])
          - U11*(I1[331] - I2[242])
          - U12*(I1[376] - I2[243])
          + (onezboz)*(I3[132] - AC1*I4[106])
          + (onezboz)*(I3[78] - AC2*I4[61]);
*(vp++) = U0*I0[197]
          - U10*(I1[197] - I2[237])
          - U11*(I1[332] - I2[243])
          - U12*(I1[377] - I2[244])
          + (onezboz)*(I3[133] - AC1*I4[107])
          + (onezboz)*(I3[79] - AC2*I4[62]);
*(vp++) = U0*I0[198]
          - U10*(I1[198] - I2[238])
          - U11*(I1[333] - I2[244])
          - U12*(I1[378] - I2[245])
          + (onezboz)*(I3[134] - AC1*I4[108])
          + (onezboz)*(I3[80] - AC2*I4[63]);
*(vp++) = U0*I0[199]
          - U10*(I1[199] - I2[239])
          - U11*(I1[334] - I2[245])
          - U12*(I1[379] - I2[246])
          + (onezboz)*(I3[135] - AC1*I4[109])
          + (onezboz)*(I3[81] - AC2*I4[64]);
*(vp++) = U0*I0[200]
          - U10*(I1[200] - I2[240])
          - U11*(I1[335] - I2[246])
          - U12*(I1[380] - I2[247])
          + (onezboz)*(I3[136] - AC1*I4[110])
          + (onezboz)*(I3[82] - AC2*I4[65]);
*(vp++) = U0*I0[201]
          - U10*(I1[201] - I2[241])
          - U11*(I1[336] - I2[248])
          - U12*(I1[381] - I2[249])
          + (onezboz)*(I3[138] - AC1*I4[111])
          + (onezboz)*(I3[84] - AC2*I4[66]);
*(vp++) = U0*I0[202]
          - U10*(I1[202] - I2[242])
          - U11*(I1[337] - I2[249])
          - U12*(I1[382] - I2[250])
          + (onezboz)*(I3[139] - AC1*I4[112])
          + (onezboz)*(I3[85] - AC2*I4[67]);
*(vp++) = U0*I0[203]
          - U10*(I1[203] - I2[243])
          - U11*(I1[338] - I2[250])
          - U12*(I1[383] - I2[251])
          + (onezboz)*(I3[140] - AC1*I4[113])
          + (onezboz)*(I3[86] - AC2*I4[68]);
*(vp++) = U0*I0[204]
          - U10*(I1[204] - I2[244])
          - U11*(I1[339] - I2[251])
          - U12*(I1[384] - I2[252])
          + (onezboz)*(I3[141] - AC1*I4[114])
          + (onezboz)*(I3[87] - AC2*I4[69]);
*(vp++) = U0*I0[205]
          - U10*(I1[205] - I2[245])
          - U11*(I1[340] - I2[252])
          - U12*(I1[385] - I2[253])
          + (onezboz)*(I3[142] - AC1*I4[115])
          + (onezboz)*(I3[88] - AC2*I4[70]);
*(vp++) = U0*I0[206]
          - U10*(I1[206] - I2[246])
          - U11*(I1[341] - I2[253])
          - U12*(I1[386] - I2[254])
          + (onezboz)*(I3[143] - AC1*I4[116])
          + (onezboz)*(I3[89] - AC2*I4[71]);
*(vp++) = U0*I0[207]
          - U10*(I1[207] - I2[247])
          - U11*(I1[342] - I2[254])
          - U12*(I1[387] - I2[255])
          + (onezboz)*(I3[144] - AC1*I4[117])
          + (onezboz)*(I3[90] - AC2*I4[72]);
*(vp++) = U0*I0[208]
          - U10*(I1[208] - I2[248])
          - U11*(I1[343] - I2[256])
          - U12*(I1[388] - I2[257])
          + (onezboz)*(I3[146] - AC1*I4[118])
          + (onezboz)*(I3[92] - AC2*I4[73]);
*(vp++) = U0*I0[209]
          - U10*(I1[209] - I2[249])
          - U11*(I1[344] - I2[257])
          - U12*(I1[389] - I2[258])
          + (onezboz)*(I3[147] - AC1*I4[119])
          + (onezboz)*(I3[93] - AC2*I4[74]);
*(vp++) = U0*I0[210]
          - U10*(I1[210] - I2[250])
          - U11*(I1[345] - I2[258])
          - U12*(I1[390] - I2[259])
          + (onezboz)*(I3[148] - AC1*I4[120])
          + (onezboz)*(I3[94] - AC2*I4[75]);
*(vp++) = U0*I0[211]
          - U10*(I1[211] - I2[251])
          - U11*(I1[346] - I2[259])
          - U12*(I1[391] - I2[260])
          + (onezboz)*(I3[149] - AC1*I4[121])
          + (onezboz)*(I3[95] - AC2*I4[76]);
*(vp++) = U0*I0[212]
          - U10*(I1[212] - I2[252])
          - U11*(I1[347] - I2[260])
          - U12*(I1[392] - I2[261])
          + (onezboz)*(I3[150] - AC1*I4[122])
          + (onezboz)*(I3[96] - AC2*I4[77]);
*(vp++) = U0*I0[213]
          - U10*(I1[213] - I2[253])
          - U11*(I1[348] - I2[261])
          - U12*(I1[393] - I2[262])
          + (onezboz)*(I3[151] - AC1*I4[123])
          + (onezboz)*(I3[97] - AC2*I4[78]);
*(vp++) = U0*I0[214]
          - U10*(I1[214] - I2[254])
          - U11*(I1[349] - I2[262])
          - U12*(I1[394] - I2[263])
          + (onezboz)*(I3[152] - AC1*I4[124])
          + (onezboz)*(I3[98] - AC2*I4[79]);
*(vp++) = U0*I0[215]
          - U10*(I1[215] - I2[255])
          - U11*(I1[350] - I2[263])
          - U12*(I1[395] - I2[264])
          + (onezboz)*(I3[153] - AC1*I4[125])
          + (onezboz)*(I3[99] - AC2*I4[80]);
*(vp++) = U0*I0[216]
          - U10*(I1[216] - I2[256])
          - U11*(I1[351] - I2[265])
          - U12*(I1[396] - I2[266])
          + (onezboz)*(I3[155] - AC1*I4[126])
          + (onezboz)*(I3[101] - AC2*I4[81]);
*(vp++) = U0*I0[217]
          - U10*(I1[217] - I2[257])
          - U11*(I1[352] - I2[266])
          - U12*(I1[397] - I2[267])
          + (onezboz)*(I3[156] - AC1*I4[127])
          + (onezboz)*(I3[102] - AC2*I4[82]);
*(vp++) = U0*I0[218]
          - U10*(I1[218] - I2[258])
          - U11*(I1[353] - I2[267])
          - U12*(I1[398] - I2[268])
          + (onezboz)*(I3[157] - AC1*I4[128])
          + (onezboz)*(I3[103] - AC2*I4[83]);
*(vp++) = U0*I0[219]
          - U10*(I1[219] - I2[259])
          - U11*(I1[354] - I2[268])
          - U12*(I1[399] - I2[269])
          + (onezboz)*(I3[158] - AC1*I4[129])
          + (onezboz)*(I3[104] - AC2*I4[84]);
*(vp++) = U0*I0[220]
          - U10*(I1[220] - I2[260])
          - U11*(I1[355] - I2[269])
          - U12*(I1[400] - I2[270])
          + (onezboz)*(I3[159] - AC1*I4[130])
          + (onezboz)*(I3[105] - AC2*I4[85]);
*(vp++) = U0*I0[221]
          - U10*(I1[221] - I2[261])
          - U11*(I1[356] - I2[270])
          - U12*(I1[401] - I2[271])
          + (onezboz)*(I3[160] - AC1*I4[131])
          + (onezboz)*(I3[106] - AC2*I4[86]);
*(vp++) = U0*I0[222]
          - U10*(I1[222] - I2[262])
          - U11*(I1[357] - I2[271])
          - U12*(I1[402] - I2[272])
          + (onezboz)*(I3[161] - AC1*I4[132])
          + (onezboz)*(I3[107] - AC2*I4[87]);
*(vp++) = U0*I0[223]
          - U10*(I1[223] - I2[263])
          - U11*(I1[358] - I2[272])
          - U12*(I1[403] - I2[273])
          + (onezboz)*(I3[162] - AC1*I4[133])
          + (onezboz)*(I3[108] - AC2*I4[88]);
*(vp++) = U0*I0[224]
          - U10*(I1[224] - I2[264])
          - U11*(I1[359] - I2[273])
          - U12*(I1[404] - I2[274])
          + (onezboz)*(I3[163] - AC1*I4[134])
          + (onezboz)*(I3[109] - AC2*I4[89]);
*(vp++) = U0*I0[225]
          - U10*(I1[225] - I2[275])
          - U11*(I1[360] - I2[276])
          - U12*(I1[405] - I2[277])
          + (twozboz)*(I3[112] - AC2*I4[90]);
*(vp++) = U0*I0[226]
          - U10*(I1[226] - I2[276])
          - U11*(I1[361] - I2[278])
          - U12*(I1[406] - I2[279])
          + (twozboz)*(I3[114] - AC2*I4[91]);
*(vp++) = U0*I0[227]
          - U10*(I1[227] - I2[277])
          - U11*(I1[362] - I2[279])
          - U12*(I1[407] - I2[280])
          + (twozboz)*(I3[115] - AC2*I4[92]);
*(vp++) = U0*I0[228]
          - U10*(I1[228] - I2[278])
          - U11*(I1[363] - I2[281])
          - U12*(I1[408] - I2[282])
          + (twozboz)*(I3[117] - AC2*I4[93]);
*(vp++) = U0*I0[229]
          - U10*(I1[229] - I2[279])
          - U11*(I1[364] - I2[282])
          - U12*(I1[409] - I2[283])
          + (twozboz)*(I3[118] - AC2*I4[94]);
*(vp++) = U0*I0[230]
          - U10*(I1[230] - I2[280])
          - U11*(I1[365] - I2[283])
          - U12*(I1[410] - I2[284])
          + (twozboz)*(I3[119] - AC2*I4[95]);
*(vp++) = U0*I0[231]
          - U10*(I1[231] - I2[281])
          - U11*(I1[366] - I2[285])
          - U12*(I1[411] - I2[286])
          + (twozboz)*(I3[121] - AC2*I4[96]);
*(vp++) = U0*I0[232]
          - U10*(I1[232] - I2[282])
          - U11*(I1[367] - I2[286])
          - U12*(I1[412] - I2[287])
          + (twozboz)*(I3[122] - AC2*I4[97]);
*(vp++) = U0*I0[233]
          - U10*(I1[233] - I2[283])
          - U11*(I1[368] - I2[287])
          - U12*(I1[413] - I2[288])
          + (twozboz)*(I3[123] - AC2*I4[98]);
*(vp++) = U0*I0[234]
          - U10*(I1[234] - I2[284])
          - U11*(I1[369] - I2[288])
          - U12*(I1[414] - I2[289])
          + (twozboz)*(I3[124] - AC2*I4[99]);
*(vp++) = U0*I0[235]
          - U10*(I1[235] - I2[285])
          - U11*(I1[370] - I2[290])
          - U12*(I1[415] - I2[291])
          + (twozboz)*(I3[126] - AC2*I4[100]);
*(vp++) = U0*I0[236]
          - U10*(I1[236] - I2[286])
          - U11*(I1[371] - I2[291])
          - U12*(I1[416] - I2[292])
          + (twozboz)*(I3[127] - AC2*I4[101]);
*(vp++) = U0*I0[237]
          - U10*(I1[237] - I2[287])
          - U11*(I1[372] - I2[292])
          - U12*(I1[417] - I2[293])
          + (twozboz)*(I3[128] - AC2*I4[102]);
*(vp++) = U0*I0[238]
          - U10*(I1[238] - I2[288])
          - U11*(I1[373] - I2[293])
          - U12*(I1[418] - I2[294])
          + (twozboz)*(I3[129] - AC2*I4[103]);
*(vp++) = U0*I0[239]
          - U10*(I1[239] - I2[289])
          - U11*(I1[374] - I2[294])
          - U12*(I1[419] - I2[295])
          + (twozboz)*(I3[130] - AC2*I4[104]);
*(vp++) = U0*I0[240]
          - U10*(I1[240] - I2[290])
          - U11*(I1[375] - I2[296])
          - U12*(I1[420] - I2[297])
          + (twozboz)*(I3[132] - AC2*I4[105]);
*(vp++) = U0*I0[241]
          - U10*(I1[241] - I2[291])
          - U11*(I1[376] - I2[297])
          - U12*(I1[421] - I2[298])
          + (twozboz)*(I3[133] - AC2*I4[106]);
*(vp++) = U0*I0[242]
          - U10*(I1[242] - I2[292])
          - U11*(I1[377] - I2[298])
          - U12*(I1[422] - I2[299])
          + (twozboz)*(I3[134] - AC2*I4[107]);
*(vp++) = U0*I0[243]
          - U10*(I1[243] - I2[293])
          - U11*(I1[378] - I2[299])
          - U12*(I1[423] - I2[300])
          + (twozboz)*(I3[135] - AC2*I4[108]);
*(vp++) = U0*I0[244]
          - U10*(I1[244] - I2[294])
          - U11*(I1[379] - I2[300])
          - U12*(I1[424] - I2[301])
          + (twozboz)*(I3[136] - AC2*I4[109]);
*(vp++) = U0*I0[245]
          - U10*(I1[245] - I2[295])
          - U11*(I1[380] - I2[301])
          - U12*(I1[425] - I2[302])
          + (twozboz)*(I3[137] - AC2*I4[110]);
*(vp++) = U0*I0[246]
          - U10*(I1[246] - I2[296])
          - U11*(I1[381] - I2[303])
          - U12*(I1[426] - I2[304])
          + (twozboz)*(I3[139] - AC2*I4[111]);
*(vp++) = U0*I0[247]
          - U10*(I1[247] - I2[297])
          - U11*(I1[382] - I2[304])
          - U12*(I1[427] - I2[305])
          + (twozboz)*(I3[140] - AC2*I4[112]);
*(vp++) = U0*I0[248]
          - U10*(I1[248] - I2[298])
          - U11*(I1[383] - I2[305])
          - U12*(I1[428] - I2[306])
          + (twozboz)*(I3[141] - AC2*I4[113]);
*(vp++) = U0*I0[249]
          - U10*(I1[249] - I2[299])
          - U11*(I1[384] - I2[306])
          - U12*(I1[429] - I2[307])
          + (twozboz)*(I3[142] - AC2*I4[114]);
*(vp++) = U0*I0[250]
          - U10*(I1[250] - I2[300])
          - U11*(I1[385] - I2[307])
          - U12*(I1[430] - I2[308])
          + (twozboz)*(I3[143] - AC2*I4[115]);
*(vp++) = U0*I0[251]
          - U10*(I1[251] - I2[301])
          - U11*(I1[386] - I2[308])
          - U12*(I1[431] - I2[309])
          + (twozboz)*(I3[144] - AC2*I4[116]);
*(vp++) = U0*I0[252]
          - U10*(I1[252] - I2[302])
          - U11*(I1[387] - I2[309])
          - U12*(I1[432] - I2[310])
          + (twozboz)*(I3[145] - AC2*I4[117]);
*(vp++) = U0*I0[253]
          - U10*(I1[253] - I2[303])
          - U11*(I1[388] - I2[311])
          - U12*(I1[433] - I2[312])
          + (twozboz)*(I3[147] - AC2*I4[118]);
*(vp++) = U0*I0[254]
          - U10*(I1[254] - I2[304])
          - U11*(I1[389] - I2[312])
          - U12*(I1[434] - I2[313])
          + (twozboz)*(I3[148] - AC2*I4[119]);
*(vp++) = U0*I0[255]
          - U10*(I1[255] - I2[305])
          - U11*(I1[390] - I2[313])
          - U12*(I1[435] - I2[314])
          + (twozboz)*(I3[149] - AC2*I4[120]);
*(vp++) = U0*I0[256]
          - U10*(I1[256] - I2[306])
          - U11*(I1[391] - I2[314])
          - U12*(I1[436] - I2[315])
          + (twozboz)*(I3[150] - AC2*I4[121]);
*(vp++) = U0*I0[257]
          - U10*(I1[257] - I2[307])
          - U11*(I1[392] - I2[315])
          - U12*(I1[437] - I2[316])
          + (twozboz)*(I3[151] - AC2*I4[122]);
*(vp++) = U0*I0[258]
          - U10*(I1[258] - I2[308])
          - U11*(I1[393] - I2[316])
          - U12*(I1[438] - I2[317])
          + (twozboz)*(I3[152] - AC2*I4[123]);
*(vp++) = U0*I0[259]
          - U10*(I1[259] - I2[309])
          - U11*(I1[394] - I2[317])
          - U12*(I1[439] - I2[318])
          + (twozboz)*(I3[153] - AC2*I4[124]);
*(vp++) = U0*I0[260]
          - U10*(I1[260] - I2[310])
          - U11*(I1[395] - I2[318])
          - U12*(I1[440] - I2[319])
          + (twozboz)*(I3[154] - AC2*I4[125]);
*(vp++) = U0*I0[261]
          - U10*(I1[261] - I2[311])
          - U11*(I1[396] - I2[320])
          - U12*(I1[441] - I2[321])
          + (twozboz)*(I3[156] - AC2*I4[126]);
*(vp++) = U0*I0[262]
          - U10*(I1[262] - I2[312])
          - U11*(I1[397] - I2[321])
          - U12*(I1[442] - I2[322])
          + (twozboz)*(I3[157] - AC2*I4[127]);
*(vp++) = U0*I0[263]
          - U10*(I1[263] - I2[313])
          - U11*(I1[398] - I2[322])
          - U12*(I1[443] - I2[323])
          + (twozboz)*(I3[158] - AC2*I4[128]);
*(vp++) = U0*I0[264]
          - U10*(I1[264] - I2[314])
          - U11*(I1[399] - I2[323])
          - U12*(I1[444] - I2[324])
          + (twozboz)*(I3[159] - AC2*I4[129]);
*(vp++) = U0*I0[265]
          - U10*(I1[265] - I2[315])
          - U11*(I1[400] - I2[324])
          - U12*(I1[445] - I2[325])
          + (twozboz)*(I3[160] - AC2*I4[130]);
*(vp++) = U0*I0[266]
          - U10*(I1[266] - I2[316])
          - U11*(I1[401] - I2[325])
          - U12*(I1[446] - I2[326])
          + (twozboz)*(I3[161] - AC2*I4[131]);
*(vp++) = U0*I0[267]
          - U10*(I1[267] - I2[317])
          - U11*(I1[402] - I2[326])
          - U12*(I1[447] - I2[327])
          + (twozboz)*(I3[162] - AC2*I4[132]);
*(vp++) = U0*I0[268]
          - U10*(I1[268] - I2[318])
          - U11*(I1[403] - I2[327])
          - U12*(I1[448] - I2[328])
          + (twozboz)*(I3[163] - AC2*I4[133]);
*(vp++) = U0*I0[269]
          - U10*(I1[269] - I2[319])
          - U11*(I1[404] - I2[328])
          - U12*(I1[449] - I2[329])
          + (twozboz)*(I3[164] - AC2*I4[134]);

}
