/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (0s|[r12,T2]|hs) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t2_build_00h0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezdon;
  REALTYPE twozdon;
  REALTYPE threezdon;
  REALTYPE fourzdon;
  REALTYPE fivezdon;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezdon = 1.0*(Data->twozeta_d*Data->oo2n);
  twozdon = 2.0*(Data->twozeta_d*Data->oo2n);
  threezdon = 3.0*(Data->twozeta_d*Data->oo2n);
  fourzdon = 4.0*(Data->twozeta_d*Data->oo2n);
  fivezdon = 5.0*(Data->twozeta_d*Data->oo2n);
  U10 = ShellData->CD[0]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U11 = ShellData->CD[1]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U12 = ShellData->CD[2]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U0  = (Data->twozeta_c - Data->twozeta_d*(Data->twozeta_c*ShellData->CDdotCA + 6.000000))*Data->oo2n;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[1] - I2[21])
          - U12*(I1[2] - I2[42])
          + (fivezdon)*(I3[0] + AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[3] - I2[22])
          - U12*(I1[4] - I2[43])
          + (fourzdon)*(I3[1] + AC0*I4[1])
          + (onezdon)*(I3[15] + AC1*I4[0]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[4] - I2[23])
          - U12*(I1[5] - I2[44])
          + (fourzdon)*(I3[2] + AC0*I4[2])
          + (onezdon)*(I3[30] + AC2*I4[0]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[6] - I2[24])
          - U12*(I1[7] - I2[45])
          + (threezdon)*(I3[3] + AC0*I4[3])
          + (twozdon)*(I3[16] + AC1*I4[1]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[7] - I2[25])
          - U12*(I1[8] - I2[46])
          + (threezdon)*(I3[4] + AC0*I4[4])
          + (onezdon)*(I3[17] + AC1*I4[2])
          + (onezdon)*(I3[31] + AC2*I4[1]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[8] - I2[26])
          - U12*(I1[9] - I2[47])
          + (threezdon)*(I3[5] + AC0*I4[5])
          + (twozdon)*(I3[32] + AC2*I4[2]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[6])
          - U11*(I1[10] - I2[27])
          - U12*(I1[11] - I2[48])
          + (twozdon)*(I3[6] + AC0*I4[6])
          + (threezdon)*(I3[18] + AC1*I4[3]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[7])
          - U11*(I1[11] - I2[28])
          - U12*(I1[12] - I2[49])
          + (twozdon)*(I3[7] + AC0*I4[7])
          + (twozdon)*(I3[19] + AC1*I4[4])
          + (onezdon)*(I3[33] + AC2*I4[3]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[8])
          - U11*(I1[12] - I2[29])
          - U12*(I1[13] - I2[50])
          + (twozdon)*(I3[8] + AC0*I4[8])
          + (onezdon)*(I3[20] + AC1*I4[5])
          + (twozdon)*(I3[34] + AC2*I4[4]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[9])
          - U11*(I1[13] - I2[30])
          - U12*(I1[14] - I2[51])
          + (twozdon)*(I3[9] + AC0*I4[9])
          + (threezdon)*(I3[35] + AC2*I4[5]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[10])
          - U11*(I1[15] - I2[31])
          - U12*(I1[16] - I2[52])
          + (onezdon)*(I3[10] + AC0*I4[10])
          + (fourzdon)*(I3[21] + AC1*I4[6]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[11])
          - U11*(I1[16] - I2[32])
          - U12*(I1[17] - I2[53])
          + (onezdon)*(I3[11] + AC0*I4[11])
          + (threezdon)*(I3[22] + AC1*I4[7])
          + (onezdon)*(I3[36] + AC2*I4[6]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[12])
          - U11*(I1[17] - I2[33])
          - U12*(I1[18] - I2[54])
          + (onezdon)*(I3[12] + AC0*I4[12])
          + (twozdon)*(I3[23] + AC1*I4[8])
          + (twozdon)*(I3[37] + AC2*I4[7]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[13])
          - U11*(I1[18] - I2[34])
          - U12*(I1[19] - I2[55])
          + (onezdon)*(I3[13] + AC0*I4[13])
          + (onezdon)*(I3[24] + AC1*I4[9])
          + (threezdon)*(I3[38] + AC2*I4[8]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[14])
          - U11*(I1[19] - I2[35])
          - U12*(I1[20] - I2[56])
          + (onezdon)*(I3[14] + AC0*I4[14])
          + (fourzdon)*(I3[39] + AC2*I4[9]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[15])
          - U11*(I1[21] - I2[36])
          - U12*(I1[22] - I2[57])
          + (fivezdon)*(I3[25] + AC1*I4[10]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[16])
          - U11*(I1[22] - I2[37])
          - U12*(I1[23] - I2[58])
          + (fourzdon)*(I3[26] + AC1*I4[11])
          + (onezdon)*(I3[40] + AC2*I4[10]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[17])
          - U11*(I1[23] - I2[38])
          - U12*(I1[24] - I2[59])
          + (threezdon)*(I3[27] + AC1*I4[12])
          + (twozdon)*(I3[41] + AC2*I4[11]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[18])
          - U11*(I1[24] - I2[39])
          - U12*(I1[25] - I2[60])
          + (twozdon)*(I3[28] + AC1*I4[13])
          + (threezdon)*(I3[42] + AC2*I4[12]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[19])
          - U11*(I1[25] - I2[40])
          - U12*(I1[26] - I2[61])
          + (onezdon)*(I3[29] + AC1*I4[14])
          + (fourzdon)*(I3[43] + AC2*I4[13]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[20])
          - U11*(I1[26] - I2[41])
          - U12*(I1[27] - I2[62])
          + (fivezdon)*(I3[44] + AC2*I4[14]);

}
